PART THREE:  Appendix 2
SUPPLEMENTAL INFORMATION
FOR SOLVING PROBLEMS
(Also contained in the disk file "32SUPPLE.MAN".)
 
 
(Last revision:  November 1993)
 
 
 
CONTENTS OF APPENDIX 2
 
    1.   PROBLEM SOLVING STARTS HERE. . . . .3-2.227
         1.1  Problems with Software Installation3-2.227
         1.2  Problems with Loading JAWS Software3-2.227
         1.3  Problems Installing an Internal Speech
              Synthesizer . . . . . . . . . .3-2.227
         1.4  Problems Installing an External Speech
              Synthesizer . . . . . . . . . .3-2.228
         1.5  Problems with Toshiba Laptop PC's3-2.228
         1.6  Problems with Application Software
              Compatibility . . . . . . . . .3-2.228
         1.7  Problems with Synthesizer Behavior3-2.229
    2.   PREPARING TO INSTALL JAWS. . . . . .3-2.229
         2.1  Hardware Installation . . . . .3-2.229
         2.2  Protecting the Hardware . . . .3-2.230
         2.3  Starting the PC . . . . . . . .3-2.230
    3.   DETAILED DESCRIPTION OF JAWS
         INSTALLATION . . . . . . . . . . . .3-2.230
    4.   JAWS WILL NOT SPEAK. . . . . . . . .3-2.235
         4.1  JAWS Logo and Copyright Screen Do
              Not Appear. . . . . . . . . . .3-2.236
         4.2  JAWS Logo Appears, but the Synthesizer
              Does Not Speak. . . . . . . . .3-2.237
         4.3  JAWS Logo Appears and the Computer
              Locks-Up. . . . . . . . . . . .3-2.238
         4.4  Nothing Seems to Work!. . . . .3-2.238
    5.   PROBLEMS WITH USING DIFFERENT PC's .3-2.239
    6.   PROBLEM DETERMINING SCREEN COLOR . .3-2.240
    7.   PROBLEM WITH SOME TEXT NOT BEING
         SPOKEN . . . . . . . . . . . . . . .3-2.242
1.  PROBLEM SOLVING STARTS HERE
 
    If you are reading this appendix, then it is most likely
because
you have encountered a problem with the installation or operation
of
JAWS or your speech synthesizer.  If you already believe you know
the
cause of your problem, then this chapter will direct you to the
information you need.  If you are not sure what might be causing
your
problem, and if you haven't done so already, then please read the
first
three chapters in PART ONE of this manual.  If you have already
read
these introductory chapters, then the information presented here,
and
in the recommended chapters, should help solve your problems.
 
 
1.1 Problems with Software Installation
 
    See Sections 2 and 3 in this chapter, and
    PART ONE, Chapter 2
         ("12INSTAL.MAN" for JAWS installation)
 
 
1.2 Problems with Loading JAWS Software
 
    See Sections 2 and 3 in this chapter, and
    PART ONE:  Chapter 2
         ("12INSTAL.MAN" for JAWS installation)
    PART TWO:  Chapter 8
         ("28CONFIG.MAN" for configuration files)
    PART THREE:  Appendix 4
         (disk file "34COMAND.MAN" for command line switches)
 
 
1.3 Problems Installing an Internal Speech Synthesizer
 
    PART FIVE:  Installation Reference 1
         (disk file "51INTERN.MAN" for internal synthesizers)
    PART FIVE:  Installation Reference 3
         (disk file "53SYNTH.MAN" for synthesizer information)
 
 
1.4 Problems Installing an External Speech Synthesizer
 
    PART FIVE:  Installation Reference 2
         (disk file "52EXTERN.MAN" for external synthesizers)
    PART FIVE:  Installation Reference 3
         (disk file "53SYNTH.MAN" for synthesizer information)
 
 
1.5 Problems with Toshiba Laptop PC's
 
    PART FIVE:  Installation Reference 4
         (disk file "54TOSH.MAN")
 
 
1.6 Problems with Application Software Compatibility
 
    PART FOUR:  Application 1
         (disk file "41WP.MAN" for WordPerfect)
    PART FOUR:  Application 2
         (disk file "42LOTUS.MAN" for Lotus 1-2-3)
    PART TWO:  Chapter 8
         ("28CONFIG.MAN" for configuration files)
    PART TWO:  Chapter 6
         ("26SMART.MAN" for smart screens)
    PART TWO:  Chapter 7
         ("27MACRO1.MAN" for creating macros)
    PART THREE:  Appendix 4
         (disk file "34COMAND.MAN" for command line switches)
 
 
1.7 Problems with Synthesizer Behavior
 
    PART TWO:  Chapter 3
         ("23VOICE.MAN" for adjusting synthesizer speech)
    PART THREE:  Appendix 4
         (disk file "34COMAND.MAN" for command line switches)
    PART FIVE:  Installation Reference 3
         (disk file "53SYNTH.MAN" for synthesizer information)
 
 
2.  PREPARING TO INSTALL JAWS
 
2.1 Hardware Installation
 
    We begin with the assumption that you have an IBM or 100%
IBM compatible PC that is functioning normally and is using DOS
version 3.0 or higher.  We also assume that you have a speech
synthesizer that has been connected to your PC or has been
installed
within your PC.  If you have not installed your speech synthesizer,
then
you do not need to do so before you use the installation program. 
Information about installing your synthesizer should have been
provided
by the synthesizer's manufacturer.  You may wish to use the
installation
references we have provided in PART FIVE of this manual to assist
with
synthesizer installation.  If you are installing a synthesizer in
a Toshiba
laptop computer, then you should also review the installation
reference
in PART FIVE that discusses Toshiba computers.  The installation
reference on speech synthesizers and related equipment also
contained
in PART FIVE addresses the set up and use of specific speech
synthesizers, and describes other computer related equipment
(including
alternative keyboards) that can be helpful to persons with multiple
disabilities.
 
2.2 Protecting the Hardware
 
    Be sure the PC, the screen (monitor), external speech
synthesizer,
printer, and anything else that is connected to your PC are plugged
into
a surge protector designed to protect against electrical spikes. 
The
surge protector should be plugged into a grounded electrical
outlet.  A
surge protector is not required, but it is strongly recommended as
a wise
investment for protecting your PC from unexpected voltage increases
that could destroy the PC and anything attached to it.
 
2.3 Starting the PC
 
    Turn on the surge protector, the PC, the PC screen, and the
speech synthesizer (if the synthesizer is an external synthesizer). 
Let
the PC boot (start) normally.
 
 
3.  DETAILED DESCRIPTION OF JAWS INSTALLATION
 
    The following steps will summarize the process that is followed
by the JAWS installation program.
 
a.  Begin software installation by typing A:INSTALL  or
    B:INSTALL (then press ENTER.  All information that is
    displayed during the installation process will be spoken by
your
    synthesizer if you are currently using a screen reading
program. 
 
b.  The first screen that appears will remind users that JAWS is
    copyrighted software.  Installation is to be done in accordance
    with the limitation of the software license that was accepted
    when you opened the sealed envelope containing the JAWS
    distribution disks.  
 
c.  The installation process can be stopped at any time by pressing
    ESCAPE followed by ENTER.  Pressing any other key will tell
    the installation program to move on to the next step.  
 
d.  Steps that should be taken when updating an older JAWS version
    may be displayed at this point.  If you are installing JAWS for
the
    first time, then this screen will not appear.  If an older
version of
    JAWS is being updated, then follow the instructions.
 
e.  When you are asked about the type of keyboard you are using,
    you can use the UP ARROW and DOWN ARROW to highlight the
    appropriate type of keyboard and press ENTER.
 
f.  When you are asked to indicate the disk drive you will use for
    storing the JAWS files, you will need to select a disk drive
letter. 
    We recommend installing the JAWS files on a hard disk drive (if
    you have one), but they can be installed on a floppy disk if
this is
    required.  Use the UP ARROW and DOWN ARROW to highlight
    the drive letter and press ENTER to make your selection.
 
g.  When you are asked to indicate the actual subdirectory where
the
    JAWS files are to be stored, you will either need to accept the
    subdirectory name that is offered or type in a different
    subdirectory name.  Experience has proven that many potential
    problems can be avoided if the files are installed to the
default
    subdirectory "\JAWS".  Press ENTER to accept the use of
    the default /JAWS subdirectory.  If you need to use a different
    sub directory then you can use the DELETE, BACKSPACE,
    LEFT ARROW, and RIGHT ARROW to edit the subdirectory
    name.  Press ENTER when done.
 
h.  If you are updating your JAWS software then you may receive
    specific instructions related to your situation.  If you have
deleted
    all of your old JAWS files, then you will get a message that
states
    that the installation program can not find your JAWS.JNF file. 
    If your JAWS subdirectory still contains your JAWS 2.2 files,
    then the installation program will present information about
    converting your voice and environment configuration files to
    JAWS 2.3 format.  Configuration files from JAWS versions that
    precede version 2.2 cannot be converted.  Follow the
instructions
    that are presented and press ENTER to move on to the next
    installation step.
 
i.  When you are asked to identify the speech synthesizer you will
be
    using, you will need to select the name of your synthesizer
from
    a list of synthesizers.  Use the UP and DOWN ARROWS to
    highlight the name of your synthesizer.  Additional
synthesizers
    will appear on the screen as you use the DOWN ARROW. 
    Selecting the proper synthesizer name will insure that the
    installation program installs the software files that will
optimize
    the performance of your synthesizer.  Once your synthesizer has
    been highlighted, press ENTER to make your selection.  
 
j.  If you selected a serial synthesizer in the previous step, then
you
    will be asked to identify the serial port that will be used by
    JAWS to communicate with your synthesizer.  Use the UP and
    DOWN ARROWS to highlight the port.  Most people will use
    COM1 if it is available.  Press ENTER to select the correct
port.
 
k.  When you are asked about installing the disk version of the
    JAWS Users Manual and Configuration Files, you will need to
    identify the items you wish to install.  We recommend that you
    install the JAWS Manual and all of the configuration files,
unless
    you are installing onto a floppy drive, or you have very
limited
    hard disk drive storage space.  Configuration files are used by
    JAWS to fine tune the operation of JAWS when you use specific
    application software programs.  Press ENTER to install all
items
    on the list.  If you do not wish to install all the items, then
follow
    the instructions on the screen for making a partial selection.
 
l.  If the selections you made in the previous step included
    WordPerfect configurations, then you are asked to identify the
    version of WordPerfect you will be using.  If you indicated
that
    you wanted all of the configuration files to be installed, then
    WordPerfect was automatically selected.  This choice insures
that
    your configuration files will match your WordPerfect version. 

 
m.  When a summary of all the selections you have made is
    displayed, you will need to determine that everything is
correct. 
    Press ENTER if all selections are correct.  Press ESCAPE and
    ENTER to exit the program if the information is not correct. 
If
    you exit the program then you will need to run the installation
    program again to enter the correct selections.
 
n. If you are asked about modifying your AUTOEXEC.BAT file, then 
    you will need to give permission before modifications will be
    completed.  When you allow the installation program to modify
    this file, then you enable JAWS to automatically be loaded when
    you turn on your PC.  You also may allow certain other
    instructions for your speech synthesizer to be created.  Select
    "yes" or "no" and press ENTER.  
 
o.  If you are using an internal speech synthesizer, then you may
be
    asked whether the installation program can modify your
    CONFIG.SYS file.  Programs called Software Drivers are
    required for some internal synthesizers, and are used by JAWS
    to communicate with the synthesizer.  These special software
    programs are loaded by the CONFIG.SYS file when you turn on
    your PC.  You are asked whether you would like the installation
    program to modify your CONFIG.SYS file to add instructions for
    loading the appropriate programs.  If you do not let the
    installation program make the necessary changes, then you will
    need to modify your CONFIG.SYS file with a text editor before
    JAWS can communicate with your synthesizer and make it speak.
    
         If you have been instructed to copy additional files to
your
    hard disk, then you can copy these "software drivers" after the
    installation program has completed its work.  Failure to
install
    the required software drivers may prevent your synthesizer from
    speaking.
 
p.  When you are told that the installation program is ready to
begin
    copying files, then press ENTER to begin the process.  If you
are
    updating or installing a demo copy of JAWS, then you will
receive
    a warning notice if the installation program cannot find your
    "JAWS.JNF" file.  This file is your personal identification
file.  If
    a copy of this file is not in the directory to which files will
be
    installed, then the JAWS software will not be a fully
functional
    program.
 
q.  After some files have been copied, you will hear a beep and
    instructions about inserting the next installation disk will be
    displayed on the screen.  Insert the next JAWS distribution
    diskette and press ENTER.  Repeat this process with each of
your
    JAWS disks until all disks have been used.  You will hear a
beep
    and be prompted each time a disk needs to be changed.  You will
    also hear a beep after the last distribution disk has been
used. 
    At this point, you should place the first disk back in the disk
    drive and press ENTER.  
 
r. Once all of the files have been copied, you will receive one or
    more informational messages.  If you will need to load software
    drivers, then you will be reminded of this fact one last time. 
You
    will be told that JAWS will load automatically, if you allowed
the
    installation program to modify your AUTOEXEC.BAT and
    CONFIG.SYS files.  Additionally you will be told that you can
    type "JAWS" at a DOS prompt to load JAWS.
 
u.  You have now completed the JAWS installation process.  Press
    ENTER to exit the program and return to DOS.
 
    When you next boot your PC, or when you type "JAWS" at a DOS
prompt, then JAWS will be loaded and your synthesizer should speak
introductory information about the JAWS version number and identify
the name of the registered user and his/her registration number.
 
 
4.  JAWS WILL NOT SPEAK
 
    Chapter 2 in PART ONE of this manual described the use of the
JAWS installation program which automatically installs JAWS so that
it will work with your PC and synthesizer.  This section is
designed to
identify and solve problems that could not be foreseen by the
installation
program.  If, after you read through this section, you still have
problems
with JAWS or your speech synthesizer, then please read through the
other chapters that were mentioned at the beginning of this
chapter.
 
    A large variety of factors can interfere with the proper
loading of
JAWS software, and interfere with communication between JAWS, a
speech synthesizer, and your computer.  This section describes the
first
steps that should be followed to determine the source of your
problems
and to identify possible solutions.
 
4.1 JAWS Logo and Copyright Screen Do Not Appear
 
    If the JAWS logo and copyright notice does not appear on the
screen when "JAWS" is typed at the DOS prompt and ENTER is
pressed, then JAWS was not loaded.  
 
 
    There could be a problem with the DOS PATH command, the
location of the JAWS files, the JAWS.BAT file, or other setup
related
problems.  You may wish to run the installation program again to
correct any accidental mistakes you might have made when making
setup selections.  
 
    If you loaded JAWS on a hard disk drive (C drive, for example),
then you may wish to try entering the following commands.  These
commands will help you determine if the JAWS files had been copied
to
the proper location.
 
a.  Type c:  (or the letter of the disk drive where you installed
JAWS,
    and press ENTER.)
 
b.  Type cd\ (Press ENTER.)
 
c.  Type cd\JAWS (or the name of the directory where you installed
    JAWS and press ENTER.)
 
d.  Type JAWS (Press ENTER.)
 
    If you enter the above commands, and your computer responds to
either of the last two commands with the message, "BAD COMMAND
or FILE NAME", then you should definitely run the installation
program
a second time.  If the last command (d.) causes the JAWS logo to
appear
on the screen, but you still do not hear speech, then keep on
reading.
 
4.2 JAWS Logo Appears, but the Synthesizer Does Not Speak
 
    If the JAWS logo appears and your speech synthesizer does not
say anything, then this means JAWS software was loaded and your
problem is somewhere else.  If this is your situation, then you
should
check the following points to see if they are preventing speech
output:
 
a.  If you have an external synthesizer, make sure it is plugged
into
    a surge protector or an electrical outlet.  If you are using a
surge
    protector, then be sure it is plugged in.  Be sure the
synthesizer
    and surge protector are both turned on.  Be sure the proper
    computer cable has been used, and be sure the cable ends are
    firmly connected to the synthesizer and the computer.
 
b.  If you indicated that COM1 was to be used for your external
    synthesizer when you used the installation program, then be
sure
    the cable is connected to COM1.  You may wish to read
    Installation Reference 2 in PART FIVE for additional
information
    on installing external synthesizers.  You also should refer to
the
    user's manual that came with your synthesizer.  Installation
    Reference 3 in PART FIVE of this manual also contains notes
    about specific synthesizers that may help you with installation
    related questions.
 
c.  If you have an internal synthesizer, check to be sure the
external
    speaker is connected and the synthesizer has been installed
    correctly.  If you were instructed to install a software driver
    during the installation process, then be sure this has been
done. 
    If you did not let the installation program modify your
    CONFIG.SYS file, then be sure there is a command in the
    CONFIG.SYS file that will load the device driver for your
    synthesizer.  You may wish to review the information presented
    in Installation Reference 1 of PART FIVE to learn more about
    installing internal synthesizers.  The manual that came with
your
    synthesizer will also be helpful for questions about proper
    synthesizer installation.  Installation Reference 3 in PART
FIVE
    also contains notes regarding specific synthesizers, and this
    information may help you with your installation related
    questions.
 
d.  If either the external or internal synthesizer has a dial for
    controlling volume, then be sure that it is turned to a mid
range
    position.
 
4.3 JAWS Logo Appears and the Computer Locks-Up
 
    If you think that your computer locks-up (freezes) and does not
respond to the pressing of keys whenever the JAWS logo appears on
the
screen, then you can perform the following simple test at a DOS
prompt.
 
    Type DIR  (Press ENTER.)
 
    If nothing happens, then the computer is locked up.  This could
be caused by a variety of software or hardware conflicts.  You may
wish
to read the section in Installation Reference 3 of PART FIVE that
pertains to your synthesizer.  The user's manual for your
synthesizer
should also have information about this type of situation.
 
4.4 Nothing Seems to Work!
 
5.  PROBLEMS WITH USING DIFFERENT PC's
 
    Perhaps you have a computer at work and one at home, and both
are using JAWS.  You may have noticed some differences in
performance and behavior.  Why is this?
 
    There are many things that can vary from one computer to
another:  Model, BIOS type, processor type, processor speed, amount
of
memory, video type color/monochrome, EGA/VGA, type and size of disk
drives, keyboard, number of serial and parallel ports, number and
type
of expansion cards or boards, modems, DOS version,
extended/expanded
memory, version of application program, etc.  Each of these factors
can
affect the way the PC, speech synthesizer, and  JAWS performs.  In
a
given instance, it is usually impossible to immediately identify
the cause
of performance differences without a thorough investigation.  As a
result, something similar to detective work is needed to
investigate the
situation.  You must identify the differences and eliminate things
that
are not problems and target the factors that could be the cause of
your
problem.
 
a.  You may have different speech synthesizers, with different
    features and capabilities.  A specific JAWS program has been
    prepared for each synthesizer, which is designed to use
    synthesizer features and to compensate for synthesizer
    deficiencies.  For example, when an Accent synthesizer is used,
    JAWS keeps the cursor closely synchronized with the words that
    are being spoken, so that the cursor can be placed on the last
    word spoken when speech stops.  The Echo PC does not have the
    ability to work closely with JAWS in this way, and the voice
will
    often lag far behind the visible data and the cursor's
movement.
 
b.  You may have obtained the computers and your copies of JAWS
    at different times.  The JAWS program may have different
    features because they are different versions of the program or
    have different release dates.  We are always making
    improvements to JAWS, so your two copies may be different.  If
    you are using the same type of synthesizer on both of your
PC's,
    then you can simply copy the most recent JAWS files and put
    them on the second PC.  If the synthesizers are different, then
    you will need to install the JAWS program again using the most
    recent set of installation disks. 
 
c.  You may have different sets of macros in the JAWS macro file,
    different definitions in the dictionary file, and different
settings
    in the frame file, voice file or environment file.  If a key on
one
    computer performs differently than the same key on the other
    computer, then you are likely using different sets of macros.
If so,
    just copy the "*.JMF" file from one PC to the other and this
    should fix things.
 
d.  There may be differences in the computers or their keyboards. 
    One computer may have a 101-key keyboard and a 486 processor
    while the other may be a 8086 laptop with a distinctly
different
    Toshiba keyboard layout.  You may be able to alleviate some of
    the differences by using the JAWS Macro Manager to reposition
    the JAWS keys.  A little experimentation or trial-and-error
will
    help out here.
 
 
6.  PROBLEM DETERMINING SCREEN COLOR
 
    JAWS can usually sense whether the PC is using a color or
monochrome video card when it is being loaded.  If JAWS thinks the
PC
is a color system, then it will load the color menus, which display
the
names of true colors in the JAWS enhancements menu.  For example,
choices like "red" or "magenta" are displayed when JAWS believes
the
PC is a color system.  When JAWS determines that the PC is a
monochrome system, then it will display the monochrome attributes
such as "reverse" or "intense".
 
    If you want to check on how JAWS interprets your system, then
activate the JAWS Menu System, press E for Enhance, press F for
find,
and then read the choices.  You could also press the Say Screen
Enhancement macro key INSERT + 5, and JAWS will speak the
color/monochrome attribute at the active cursor.  If JAWS says
something like "blue on cyan" or "black on white", then JAWS
considers
the PC to be a color system.  If JAWS says "normal" or "blinking",
then
it is monochrome.
 
    It is important to know that the display of colors are
influenced
by the type of monitor being used.  What looks to be "yellow" to a
sighted person is not necessarily labeled as yellow by the PC and
JAWS. 
Many monochrome monitors, for example, display "white" as green or
amber.
 
    Some computers function as if they are color systems, but
actually
display information on the screen in shades of monochrome.  The
AT&T
6300 and the IBM PS2 model 30 fall into this situation.  They use
a
color video card, a monochrome monitor, and display colors in
shades of
gray.  JAWS will speak the names of the colors that are used within
the
PC even though the screen only displays shades of gray.  This is
not
usually confusing to a blind PC user, but it may confuse sighted PC
users.  Most JAWS users will never have to know if the PC is color
or
monochrome, because JAWS normally makes the correct setup decision.
 
    If you need to force JAWS to work in a color or monochrome
mode, then you can do so by using a command line parameter.  The
command line parameter for color is "/C", and the parameter for
monochrome is "/M".  Additional information on command line
parameters is presented in the disk file for Appendix 4. 
Additional
information regarding screen colors and macros is presented in the
chapter on the JAWS macro manager contained in PART TWO of this
manual.  This parameter is typed on the same DOS command line with
the name of the JAWS program file as is shown below.
 
    [JAWS program name] [/C]
 
 
7.  PROBLEM WITH SOME TEXT NOT BEING SPOKEN
 
    Sometimes JAWS will skip over characters, words and even lines
of text when the PC and JAWS are not working closely together. 
This
undesirable situation can be resolved by activating Singles Mode. 
Press
INSERT + 7 (on the numbers row) to toggle Singles Mode on and off. 
 
    The skipping of text can be caused by situations such as when
the
PC Cursor is active and you press the Say Next Word key.  In this
situation, JAWS tells the application program to move the cursor,
then
JAWS reads the word at the new cursor position.  If the application
program is slow in moving the cursor, then JAWS tries to read the
new
word before the cursor stops moving. This means that JAWS will read
the word the cursor had been on instead of the next word.  In this
case,
this is simply a matter of the application being slower than JAWS. 
This
is most noticeable when the cursor "wraps" around from the end of
one
line to the beginning of the next line.  Turning on Singles mode
will fix
this and related problems.
 
    When Singles Mode is on, then JAWS moves the cursor by single
key strokes to get to the next word.  In this way JAWS knows when
to
read the word and how to break up the speaking of text that is
connected by hyphens, slashes, and decimal points.  You will notice
that
the PC beeps when you press an arrow key and the cursor does not or
cannot move to the correct new position.  This beep lets you know
that
something strange has happened.  This occurs in a word processing
program when the cursor skips over a page break or a hidden control
code or when the cursor cannot move any further up or down in the
document.
 
    Another situation that can cause words to not be spoken
involves
words that scroll off the  left or right side of the screen.  If
you use the
Say All function and you find that words at the end of lines are
not
spoken, then this problem is related to the margins you are using. 
JAWS can only speak the words that are visible on the screen. 
Thus,
if you have more than 80 characters on a line of text, some of them
will
scroll off the screen.  This can happen at either end of the line. 
JAWS
can read all the words in your document if you set your margins so
that
all of the text will be visible on the screen.  The user's manual
for your
word processing program will explain how this is done.
 

