' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'   DUNGEON MAPPING PROGRAM                         14 JUL 1999  
'                                           Update: 27 JAN 2012  
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

CHDIR "..\DD"

TYPE ADV
   ANAME AS STRING * 78
   NUMBER AS INTEGER
END TYPE

TYPE DESC
  TEXT AS STRING * 255
END TYPE

TYPE ROOM
  RNAME AS STRING * 79: d1 AS INTEGER: d2 AS INTEGER: D3 AS INTEGER
  D4 AS INTEGER: D5 AS INTEGER: D6 AS INTEGER: D7 AS INTEGER: D8 AS INTEGER
  D9 AS INTEGER: D10 AS INTEGER: LIGHT AS INTEGER
END TYPE
DIM ADV AS ADV, DS AS DESC, RM AS ROOM

ON ERROR GOTO ErHndlr

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

GOSUB Init: DIM DIR$(10), r$(nr), r%(nr, 11): GOSUB Init1

'Ŀ
'                      Menu O' Choices                          
'
Menu:
CLS : COLOR 3: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(23); "EAMON DELUXE INSTA-MAP  V1.0";
PRINT SPACE$(23); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT : PRINT "Mapping: "; : COLOR 14: PRINT advname$: PRINT : COLOR 3
PRINT " 1.  Full Map (Name/Description/Exits)": PRINT
PRINT " 2.  Short Map (Room Name & Exit Numbers)": PRINT
PRINT " 3.  Turn Printer "; MID$("OffOn", ABS(PT = 0) * 3 + 1, 3)
PRINT : PRINT " 4.  Quit": PRINT
LINE INPUT "          Enter 1-5 :"; a$: m% = VAL(a$): tb = 0
IF m% < 1 OR m% > 4 THEN GOTO Menu
ON m% GOTO Full, Short, Toggle, Quit

Toggle:
PT = ABS(PT = 0): GOTO Menu
Quit:
CLOSE : CHDIR "..": CHDIR "DD": RUN "DDMENU"

'Ŀ
'                        The big guy                            
'
Full:
CLS : L = 0: a$ = "A map of: " + advname$: GOSUB Lp0: GOSUB LP1
FOR a = 1 TO nr
   a$ = "     Room #" + RTRIM$(LTRIM$(STR$(a))) + ": " + r$(a)
   GOSUB Lp0: GOSUB LP1
   GET #1, a + adj1, DS
   a$ = RTRIM$(DS.TEXT): GOSUB Lp0
   FOR m = 1 TO nd STEP 4
      A1$ = DIR$(m) + LTRIM$(STR$(r%(a, m)))
      A2$ = DIR$(m + 1) + LTRIM$(STR$(r%(a, m + 1)))
      IF (nd = 10 AND m = 9) OR (nd = 6 AND m = 5) THEN
        A3$ = "": A4$ = "": GOTO FULL1
      END IF
      A3$ = DIR$(m + 2) + LTRIM$(STR$(r%(a, m + 2)))
      A4$ = DIR$(m + 3) + LTRIM$(STR$(r%(a, m + 3)))
FULL1:
      a$ = A1$ + LEFT$(SP$, 20 - LEN(A1$)) + A2$ + LEFT$(SP$, 20 - LEN(A2$))
      a$ = a$ + A3$ + LEFT$(SP$, 20 - LEN(A3$)) + A4$
      GOSUB Lp0
   NEXT
   GOSUB LP1
NEXT
L = 99: GOSUB LP6: GOTO Menu

'Ŀ
'                       The lil' guy                            
'
Short:
CLS : L = 0: xtra = 20 * ABS(nd = 6): tb = 1
a$ = "A map of: " + advname$: GOSUB Lp0: GOSUB LP1
tb$ = "Room name:" + LEFT$(SP$, 19 + xtra)
FOR a = 1 TO nd: tb$ = tb$ + DIR$(a): NEXT
a$ = tb$: GOSUB Lp0: a$ = LN$: GOSUB Lp0
'
FOR a = 1 TO nr
   n$ = r$(a): IF LCASE$(LEFT$(n$, 8)) = "you are " THEN n$ = MID$(n$, 9)
   IF LEN(n$) > 24 + xtra THEN n$ = LEFT$(n$, 24 + xtra)
   IF a > 9 AND a < 1000 THEN a$ = " " + LTRIM$(STR$(a)) + "- "
   IF a < 10 THEN a$ = "  " + LTRIM$(STR$(a)) + "- "
   IF a > 999 THEN a$ = LTRIM$(STR$(a)) + "- "
   n$ = a$ + n$: IF LEN(n$) > 28 + xtra THEN n$ = LEFT$(n$, 28 + xtra)
   n$ = n$ + LEFT$(S2$, (29 + xtra) - LEN(n$)): r$ = ""
   FOR m = 1 TO nd
      r$ = r$ + LTRIM$(STR$(r%(a, m)))
      FOR x = LEN(LTRIM$(STR$(r%(a, m)))) TO 4: r$ = r$ + " ": NEXT
   NEXT
   a$ = n$ + r$: GOSUB Lp0
NEXT
L = 99: GOSUB LP6: GOTO Menu

'Ŀ
'                  Line pause routines                          
'
Lp0:
IF LEN(a$) <= 79 THEN
  IF PT = 0 THEN PRINT a$:  GOTO LP2
  LPRINT a$: GOTO LP2
END IF
FOR K = 79 TO 1 STEP -1
   IF MID$(a$, K, 1) = " " THEN
     IF PT = 0 THEN PRINT LEFT$(a$, K - 1)
     IF PT = 1 THEN LPRINT LEFT$(a$, K - 1)
     a$ = LTRIM$(RIGHT$(a$, LEN(a$) - K)): GOSUB LP2: K = 1
   END IF
NEXT: GOTO Lp0

LP1:
IF PT = 0 THEN PRINT
IF PT = 1 THEN LPRINT

LP2:
L = L + 1

LP6:
IF L < 22 OR PT = 1 THEN RETURN
PRINT "[Hit any key...]"
DO
LOOP UNTIL INKEY$ > ""
PRINT : CLS : L = 0: IF tb = 1 THEN a$ = tb$: GOSUB Lp0: a$ = LN$: GOTO Lp0
RETURN

'Ŀ
'            Load design names, select adventure                
'
Init:
OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE

IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1"
  OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, a, a, a, a, d1$: CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2"
  OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, a, a, a, a, d2$: CLOSE
  CHDIR "..": CHDIR "DD"
END IF

CHDIR "..": OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90: GET #2, 1, ADV
numadv = ADV.NUMBER: numadv1 = numadv
DIM an$(numadv + 2), anum(numadv + 2)

FOR a = 2 TO numadv + 1
   GET #2, a, ADV: an$(a - 1) = RTRIM$(ADV.ANAME$)
NEXT: CLOSE

CHDIR "DD"
IF d1 = 1 THEN numadv = numadv + 1: an$(numadv) = d1$ + "  (Design 1)"
IF d2 = 1 THEN numadv = numadv + 1: an$(numadv) = d2$ + "  (Design 2)"

'
'               Change to proper directory
'              ----------------------------
Start:
CLS : PRINT "Select adventure to map.": PRINT : L = 2
FOR a = 1 TO numadv
   a$ = "": IF a < 10 THEN a$ = " "
   a$ = a$ + LTRIM$(RTRIM$(STR$(a))) + ": " + an$(a): PRINT a$: L = L + 1
   IF L >= 20 THEN
      PRINT "Hit any key to continue..."; : a$ = INKEY$
      DO
      LOOP UNTIL INKEY$ <> ""
      L = 0
   END IF
NEXT
PRINT : LINE INPUT "Enter the number of your choice:"; a$
a = INT(VAL(a$)): IF a < 1 OR a > numadv THEN GOTO Start
a$ = LTRIM$(RTRIM$(STR$(a))): ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
IF a = numadv1 + 1 THEN ad$ = "DGN-1"
IF a = numadv1 + 2 OR (a = numadv1 + 1 AND d1 = 0) THEN ad$ = "DGN-2"

CHDIR "..": CHDIR ad$: OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, nr, na, ne, nm, advname$, nd, ver, dungeons
IF dungeons > 1 THEN
  DIM dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF
CLOSE

'Ŀ
'                   Select from multiples                       
'
Start1:
IF dungeons > 1 THEN
  CLS : PRINT "Select adventure to list:": PRINT
  FOR a = 1 TO dungeons: PRINT " "; RTRIM$(STR$(a)); ". "; dn$(a): NEXT
  PRINT : PRINT "Enter 1-"; LTRIM$(RTRIM$(STR$(dungeons)));
  LINE INPUT ": "; a$: a = INT(VAL(a$))
  IF a < 1 OR a > dungeons THEN GOTO Start1
  nr = dn%(a, 1): na = dn%(a, 2): ne = dn%(a, 3): nm = dn%(a, 4)
  nd = dn%(a, 9): adj1 = dn%(a, 5) - 1: adj2 = dn%(a, 6) - 1
  adj3 = dn%(a, 7) - 1: adj4 = dn%(a, 8) - 1: advname$ = dn$(a)
END IF
'
RETURN
'Ŀ
'           Initialize variables, load room data                
'
Init1:
FOR a = 1 TO 10: READ DIR$(a): NEXT
SP$ = SPACE$(40): S2$ = STRING$(40, "."): LN$ = STRING$(40, "-")
LN$ = LN$ + LEFT$(LN$, 39)

OPEN "ROOMS.DAT" FOR RANDOM AS #1 LEN = 101
FOR r = 1 TO nr
   GET #1, r + adj1, RM: r$(r) = RTRIM$(RM.RNAME)
   r%(r, 1) = RM.d1: r%(r, 2) = RM.d2: r%(r, 3) = RM.D3: r%(r, 4) = RM.D4
   r%(r, 5) = RM.D5: r%(r, 6) = RM.D6: r%(r, 7) = RM.D7: r%(r, 8) = RM.D8
   r%(r, 9) = RM.D9: r%(r, 10) = RM.D10: r%(r, 11) = RM.LIGHT
NEXT: CLOSE

OPEN "ROOMS.DSC" FOR RANDOM AS #1 LEN = 255
RETURN

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 68 THEN PRINT "(Printer unavailable)";
IF ERR = 62 THEN PRINT "(Input past end of file)";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : PRINT "Program terminated.": RESUME ErHndlr1
ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

DATA "N:   ","S:   ","E:   ","W:   ","U:   ","D:   ","NE:  ","NW:  "
DATA "SE:  ","SW:  "

