' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'       HANG PERSON BY BERT KERSEY / BEAGLE BROS SOFTWARE        
'                                                                
' QBASIC Adaption by Frank Black           Revision: 15 NOV 2012 
'                                            Update: 20 NOV 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

' QBASIC Adaption by Frank Black - 15 NOV 2012
ON ERROR GOTO ErrHandler

'       Default words, 'word used' flags
DIM SHARED HPwp$(150), HPwp(150)
'       'Character (A-Z) tried' flags, 'letters guessed' flags (per round)
DIM SHARED HPlp(26), HPwp1(28)
'       'Wrong guess' counter, Sound FX on/off (0/1) toggle, screen columns
'       "woz$" holds a the ANSI character used for Apple II LORES emulation
DIM SHARED HPwg%, HPsfx%, HPsc%, woz$, q$

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE
HPwg% = 0: HPsfx% = 0: HPsc% = 80: woz$ = CHR$(219): q$ = CHR$(34)
FOR x = 1 TO 150: READ HPwp$(x): NEXT

RANDOMIZE TIMER

' Ye Olde Beagle Classic Start Screen
'-------------------------------------
HPMain:
CLS : IF s%(4) <> 1 THEN WIDTH HPsc%
COLOR 15: LOCATE 5: PRINT "H A N G "; : GOSUB Noisy
PRINT " P E R S O N !": PRINT "- - - -  - - - - - - -": COLOR 7
PRINT "By Bert Kersey & Frank Black"
PRINT : GOSUB Noisy: PRINT "HIT <"; : COLOR 2: PRINT "ENTER"; : COLOR 7
PRINT "> ONLY ": PRINT "  TO PLAY AGAINST": PRINT "  THE COMPUTER, OR..."
PRINT : PRINT : GOSUB Noisy: GOSUB HPD
LOCATE 12: PRINT "TYPE YOUR SECRET WORD(S): ______________"
PRINT "  THEN HIT <ENTER>.": PRINT : GOSUB Noisy
LOCATE 19: PRINT "TYPE LETTERS + SPACES ONLY, 14 MAXIMUM.": GOSUB Noisy
' Disable sound & column switching for VI Mode (for global hardware support)
IF s%(4) <> 1 THEN
  PRINT " S <ENTER> TURNS SOUND ";
  IF HPsfx% = 1 THEN PRINT "ON.":  ELSE PRINT "OFF."
  PRINT " W <ENTER> SWITCHES TO ";
  IF HPsc% = 80 THEN PRINT "40"; :  ELSE PRINT "80";
  PRINT " COLUMN SCREEN."
END IF
PRINT " Q <ENTER> QUITS THE GAME."

' Clear key buffer, get user input, UCASE$ it for easy sorting
LOCATE 12, 27: w$ = INKEY$: w$ = ""
LINE INPUT ""; w$: w$ = LTRIM$(RTRIM$(UCASE$(w$)))

' Special commands [short I/O bus]
IF w$ = "S" AND s%(4) <> 1 THEN HPsfx% = 1 + (HPsfx% = 1): GOTO HPMain
IF w$ = "W" AND s%(4) <> 1 THEN HPsc% = 40 * (2 + (HPsc% = 80)): GOTO HPMain
IF w$ = "Q" THEN CLS : PRINT "(BORT = SPOT)": LOCATE 24: GOSUB HPD: RUN "DDMENU"
IF LEN(w$) = 0 THEN GOSUB GetNum  ' Let the 'puter pick a word

' Weed out dipshit input and try again if needed...
FOR x = 1 TO LEN(w$)
   HPwg% = ASC(MID$(w$, x, 1))
   IF (HPwg% < 65 OR HPwg% > 90) AND HPwg% <> 32 THEN GOTO HPMain
NEXT
IF LEN(w$) > 14 THEN GOTO HPMain

'  START THE GAME!
' -----------------
CLS : GOSUB HPG0: LOCATE 21, 1: PRINT "SECRET WORD:": PRINT
PRINT "TYPE A LETTER."; : HPwg% = 0

' Clear 'letter used' and 'secret word' flags
FOR x = 1 TO 26: HPlp(x) = 0: NEXT: FOR x = 1 TO 28: HPwp1(x) = 0: NEXT
' Zonk out extra characters
FOR x = 1 TO LEN(w$)
   LOCATE 22, 12 + 2 * x: a$ = MID$(w$, x, 1)
   IF a$ = " " OR a$ = "'" OR a$ = "-" THEN HPwp1(x) = 1
   IF HPwp1(x) = 0 THEN PRINT "-"; : GOSUB Noisy
NEXT

'  Redundant checks and input loop
' ---------------------------------
HPKeyLoop:
f = 0: FOR x = 1 TO LEN(w$): f = f + ABS(HPwp1(x) <> 0): NEXT

' Winner! Winner! Chicken dinner!
IF f >= LEN(w$) THEN
  GOSUB HPCL
  FOR x = 1 TO LEN(w$)
     HPwg% = 11 + x * 2
     LOCATE 22, HPwg%: PRINT MID$(w$, x, 1); " "; : LOCATE 23, HPwg%
     IF ASC(MID$(w$, x, 1)) > 64 AND ASC(MID$(w$, x, 1)) < 90 THEN PRINT "-";
  NEXT
  LOCATE 24, 1: COLOR 2: w$ = "   YOU GOT IT!  "
  FOR x = 1 TO LEN(w$)
     PRINT MID$(w$, x, 1); : IF x / 2 <> INT(x / 2) THEN GOSUB Noisy
  NEXT
  GOTO HPAK
END IF

' Get keypress, ignoring dipshit (invalid) input
HPKeyLoop1:
a$ = INKEY$: a$ = ""
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
a$ = UCASE$(a$): x = ASC(a$)
IF x < 65 OR x > 90 THEN GOTO HPKeyLoop1
LOCATE 21, 1: PRINT SPACE$(12);
IF HPlp(x - 64) = 1 THEN GOSUB Noisy1: GOTO HPKeyLoop1

f = 0: HPlp(x - 64) = 1
FOR x = 1 TO LEN(w$)
   IF a$ = UCASE$(MID$(w$, x, 1)) THEN
     LOCATE 21, (2 * x) - 7 + 19: PRINT a$; : HPwp1(x) = 1: f = f + 1
   END IF
NEXT

' Correct letters
IF f > 0 THEN
  LOCATE 21, 1: IF f < 2 THEN PRINT "ONE "; :  ELSE PRINT LTRIM$(STR$(f));
  PRINT q$; a$; q$; : IF f > 1 THEN PRINT "'S!";
  PRINT "->"; : GOSUB Noisy: GOTO HPKeyLoop
END IF

' Ding, dong! You're wrong!
LOCATE 23, 1: PRINT "WRONG GUESSES:": HPwg% = HPwg% + 1
LOCATE 23, 14 + HPwg% * 2: COLOR 15: PRINT a$; "  "; : COLOR 7: GOSUB Noisy2
LOCATE 21, 1: PRINT "NO "; q$; a$; q$; "..."
IF HPwg% > 5 THEN
  GOSUB HPG6: GOSUB HPCL: LOCATE 24, 1: PRINT "YOU LOSE! IT WAS ";
  COLOR 2: PRINT w$; : COLOR 7: PRINT "!"; : GOSUB Noisy1: GOTO HPAK
END IF

ON HPwg% GOSUB HPG1, HPG2, HPG3, HPG4, HPG5
GOTO HPKeyLoop

'  End of round
' --------------
HPAK:
LOCATE 21, 1: COLOR 7: PRINT "<HIT THE "; : COLOR 14: PRINT q$; "ANY"; q$;
COLOR 7: PRINT " KEY>"; : LOCATE 22, 2: w$ = INKEY$: w$ = ""
DO
  w$ = INKEY$
LOOP UNTIL w$ <> ""
s = 0: GOTO HPMain

' Clear "Text" screen rows
' -------------------------
HPCL:
FOR x = 21 TO 24
   LOCATE x, 1: PRINT STRING$(40, " "); : LOCATE x, 1
NEXT
RETURN

'      "GRAPHICS"
'     ------------

' GALLOWS
HPG0:
IF s%(4) = 1 THEN RETURN
COLOR 8: LOCATE 1, 25: PRINT STRING$(7, woz$);
FOR x = 1 TO 20: LOCATE x, 32: PRINT woz$; : NEXT
LOCATE 19, 19: PRINT STRING$(13, woz$); : LOCATE 20, 19: PRINT woz$;
LOCATE 2, 29: PRINT woz$; : LOCATE 3, 30: PRINT woz$;
LOCATE 4, 31: PRINT woz$; : LOCATE 5, 32: PRINT woz$;
COLOR 7: RETURN

' ROPE
HPG1:
IF s%(4) = 1 THEN RETURN
COLOR 15: LOCATE 2, 25: PRINT woz$; : LOCATE 3, 24: PRINT STRING$(3, woz$)
LOCATE 4, 24: PRINT woz$; : LOCATE 4, 26: PRINT woz$; : LOCATE 5, 24
PRINT woz$; : LOCATE 5, 26: PRINT woz$; : LOCATE 6, 24
PRINT STRING$(3, woz$): COLOR 7: RETURN

' HEAD
HPG2:
IF s%(4) = 1 THEN RETURN
COLOR 12
FOR x = 3 TO 5
   LOCATE x, 23 + ABS(x = 3 OR x = 5)
   PRINT STRING$(3 + 2 * ABS(x > 3 AND x < 5), woz$);
NEXT
LOCATE 7, 25: PRINT woz$;
COLOR 0: LOCATE 4, 24: PRINT woz$; : LOCATE 4, 26: PRINT woz$;
COLOR 7: RETURN

'BODY
HPG3:
IF s%(4) = 1 THEN RETURN
COLOR 6
LOCATE 7, 23: PRINT STRING$(2, woz$); : LOCATE 7, 26: PRINT STRING$(2, woz$);
FOR x = 8 TO 12
   LOCATE x, 23: PRINT STRING$(5, woz$);
NEXT
COLOR 5: LOCATE 9, 25: PRINT woz$; : LOCATE 11, 25: PRINT woz$;
COLOR 7: RETURN

'ARMS
HPG4:
IF s%(4) = 1 THEN RETURN
COLOR 6
FOR x = 8 TO 11
   IF x < 10 THEN LOCATE x, 22: PRINT woz$; : LOCATE x, 28: PRINT woz$;
   IF x > 8 THEN LOCATE x, 21: PRINT woz$; : LOCATE x, 29: PRINT woz$;
NEXT
COLOR 12
FOR x = 12 TO 13
   LOCATE x, 21: PRINT woz$; : LOCATE x, 29: PRINT woz$;
NEXT
LOCATE 13, 20: PRINT woz$; : LOCATE 13, 30: PRINT woz$;
COLOR 7: RETURN

' BELT & LEGS
HPG5:
IF s%(4) = 1 THEN RETURN
COLOR 1: LOCATE 12, 23: PRINT STRING$(5, woz$); : COLOR 6
FOR x = 13 TO 15
   LOCATE x, 23: PRINT STRING$(2, woz$);
   LOCATE x, 26: PRINT STRING$(2, woz$);
NEXT
COLOR 2: LOCATE 24, 1: PRINT " ONE MORE MISS, AND YOU'RE HUNG! ";
COLOR 7: RETURN

' BOOTS
HPG6:
IF s%(4) = 1 THEN RETURN
COLOR 1
LOCATE 16, 23: PRINT STRING$(2, woz$);
LOCATE 16, 26: PRINT STRING$(2, woz$);
LOCATE 17, 21: PRINT STRING$(2, woz$); : LOCATE 17, 24: PRINT woz$;
LOCATE 17, 28: PRINT STRING$(2, woz$); : LOCATE 17, 26: PRINT woz$;
COLOR 7: RETURN

'   PC Speaker Awesomesauce!
'  --------------------------
' Random circus music
Noisy:
IF s%(4) <> 1 AND HPsfx% = 0 THEN
  SOUND 150 + (INT(RND * 200) + 50), 1: GOSUB HPD
END IF
RETURN
' Belching sound
Noisy1:
IF s%(4) <> 1 AND HPsfx% = 0 THEN SOUND 50, 6
RETURN
' Groaning sound
Noisy2:
IF s%(4) <> 1 AND HPsfx% = 0 THEN SOUND 100, 2: GOSUB HPD
RETURN

' Attempt to use sane FX speeds
HPD:
IF s%(4) <> 1 AND INT(RND * 100) + 1 < 51 THEN
  FOR x# = 1 TO dly#: NEXT
END IF
RETURN

'    Make computer select random word from default set
' (Check to see if ALL words have been used, reset if needed)
GetNum:
f = 0
FOR x = 1 TO 150
   IF HPwp(x) = 0 THEN f = 1
NEXT
IF f = 0 THEN FOR x = 1 TO 150: HPwp(x) = 0: NEXT

' Grab a random word from the word pile...
GetNum1:
x = INT(RND * 150) + 1: IF HPwp(x) <> 0 THEN GOTO GetNum1
HPwp(x) = 1: w$ = HPwp$(x): RETURN

'        ------------
'         Error trap
'        ------------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; STR$(ERR); ")": PRINT
k$ = "try and continue": IF ERR > 51 THEN k$ = "exit to Main Menu"
PRINT SPACE$(20); "Hit any key to "; k$; "...": k$ = INKEY$
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : l = 0: COLOR 7: RESUME NEXT

DATA HAPPY NEW YEAR,ONE TWO THREE,PIE CRUST,SLOT MACHINE,HAM AND CHEESE
DATA SCHOOL ZONE,DONALD DUCK,FOOTBALL,MEOW,MINNEAPOLIS
DATA UNITED STATES,DICTIONARY,GREEN JELLO,APPLE COMPUTER,RC COLA RULES
DATA E T PHONE HOME,ABRA CADABRA,FOOTBALL,QUICK DRAW,BEAGLE PUPPIES
DATA CROAKING FROGS,LUGGAGE,FURNITURE,HAWAIIAN SURF,ZEBRA STRIPES
DATA HOT DOG BUNS,NOSE JOB,PRIVATE EYE,LIGHT MY FIRE,SWEAT SHIRT
DATA KITCHEN SINK,JUMBO JET,TELEVISION SET,TRAIN,KARATE EXPERT,SCREAMING KIDS
DATA QUACKING DUCKS,CITY LIMITS,SYMBOL,POLICEMAN
DATA BELLY BUTTON,ROLLAWAY BED,JACK AND JILL,HAUNTED HOUSE,HANDKERCHIEF
DATA CINCINNATI,TIGHTROPE,JIGGLING,FREEWAY DRIVER,FOXY LADY
DATA WONDER WOMAN,FOX TERRIER,BIG FAT PIG,ONION SOUP,EGGS OVER EASY
DATA GOOD GRAVY,MISTLETOE,TAXICAB DRIVER,RED RIDINGHOOD,STAR WARS
DATA ROLLING STONE,LAZY DAY,WALK THE PLANK,TAKE A CHANCE,SLAPSTICK,ROAST BEEF
DATA FRANKENSTEIN,ONE MAN BAND,DOWNTOWN,CHICKEN SOUP
DATA MOW THE LAWN,UMBRELLA,HIT A HOME RUN,GREASED PIG,BACON FAT,OATMEAL
DATA YELLOW RIBBON,MICROWAVE OVEN,FROZEN CUSTARD,POPSCICLE
DATA TEN SPEED BIKE,RADIO,POPULATION,STEREO,LUMBERJACK,FORTUNE COOKIE
DATA BULLETIN BOARD,COWS GO MOO,WASHINGTON,YES SIR
DATA GUNNY SACK,WATER FOUNTAIN,ORANGE PUMPKIN,SLIME,KEYBOARD,SOAPY WATER
DATA JUICY PICKLES,HALF AN OUNCE,ORANGE JUICE,GOOD MOOD,RHYTHM,FLOPPY DISK
DATA MEXICO,LIZARD,NOOSE,NEEDLE NOSE,KEYBOARD,SPLASH,ZOOLOGY,CRUNCH
DATA CASSETTE,BOOKLET,PERFORATE,SHOWCASE,SPRAY,TOKYO,DECEMBER,LOLLIPOP,TURKEY
DATA CAT TAIL,REAL ESTATE,COLLAPSE,SHOTGUN,FLEA POWDER,CRYBABY,OKLAHOMA
DATA ALASKA,CIVIC,UNQUESTIONABLY,LIQUOR,QUAKER,JUMPY
DATA SWEAT SHIRT,FROWN,COLLAR,KNOBS,STOVE,SIGNATURE,SIX PACK,BEER KEG
DATA BUSY BODY,STRIPES,CALENDAR,PENCIL,COMMERCIAL,DITCH,SCOOPER,ARKANSAS
DATA QUICKSAND,ROCKET SHIP

