' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                                                                
'  EAMON DELUXE ON-LINE HINT FILE EDITOR            16 JUL 1999  
'                                           Update: 27 JAN 2012  
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
CHDIR "..\DD"

'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

ON ERROR GOTO ErHndlr

TYPE DESC
   text AS STRING * 255
END TYPE

TYPE ADV
   ANAME AS STRING * 78: NUMBER AS INTEGER
END TYPE
DIM ds AS DESC, ADV AS ADV

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

'
' Load design names
'
OPEN "DGNDIR.DAT" FOR INPUT AS #1
INPUT #1, d1, d2
CLOSE
IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1": OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d1$: CLOSE : CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2": OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d2$: CLOSE : CHDIR "..": CHDIR "DD"
END IF
'
' Load adventure names
'
CHDIR "..": OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90: GET #2, 1, ADV
numadv = ADV.NUMBER: numadv1 = numadv
DIM an$(numadv + 2), anum(numadv + 2)

FOR a = 2 TO numadv + 1
   GET #2, a, ADV: an$(a - 1) = RTRIM$(ADV.ANAME$)
NEXT

CLOSE : CHDIR "DD"
IF d1 = 1 THEN numadv = numadv + 1: an$(numadv) = d1$ + "  (Design 1)"
IF d2 = 1 THEN numadv = numadv + 1: an$(numadv) = d2$ + "  (Design 2)"
'
' Change to proper directory
'
Start:
CLS : L = 2: PRINT "Select adventure to edit.": PRINT
FOR a = 1 TO numadv
   PRINT LTRIM$(RTRIM$(STR$(a))); ": "; an$(a)
   L = L + 1
   IF L = 20 THEN
      PRINT "Hit any key to continue...";
      DO
      LOOP UNTIL INKEY$ <> ""
      CLS : L = 0
   END IF
NEXT
PRINT
LINE INPUT "Enter the number of your choice:"; a$: a = INT(VAL(a$))
IF a < 1 OR a > numadv THEN GOTO Start
a$ = LTRIM$(RTRIM$(STR$(a))): ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
IF a = numadv1 + 1 THEN ad$ = "DGN-1"
IF a = numadv1 + 2 OR (a = numadv1 + 1 AND d1 = 0) THEN ad$ = "DGN-2"
CHDIR "..": CHDIR ad$

'Ŀ
'                    Load hint names & info                     
'
OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, a, a, a, a, ANAME$: CLOSE
OPEN "HINTDIR.DAT" FOR INPUT AS #1
  INPUT #1, nh
  DIM h$(500), h%(500, 2)
  IF nh > 0 THEN
    FOR r = 1 TO nh
       LINE INPUT #1, h$(r): INPUT #1, h%(r, 1), h%(r, 2)
    NEXT
  END IF
CLOSE
nr = h%(nh, 1) + h%(nh, 2) - 1: IF nr < 1 THEN nr = 0
OPEN "HINTS.DSC" FOR RANDOM AS #1 LEN = 255
clr = 6: columns = 80: od$(1) = "Screen": od$(2) = "Printer"
od$(3) = "ASCII text file": ez = 1: od = 1: GOTO ChangeDevice1

'Ŀ
'                         Main Menu                             
'
Menu:
CLS : COLOR 3: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(18); "EAMON DELUXE ON-LINE HELP EDITOR  v2.0";
PRINT SPACE$(18); CHR$(179): PRINT CHR$(179); SPACE$(14);
PRINT "Another fine product of Frank Black Productions"; SPACE$(13); CHR$(179)
PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT SPC(10); "Editing: "; : COLOR 2: PRINT ANAME$: COLOR 3
PRINT "Number of entries:"; : COLOR 2: PRINT nh; : COLOR 3
IF nh = 500 THEN PRINT " (Maximum amount)"
PRINT : PRINT
PRINT "   1. Add an entry.": PRINT "   2. Edit an entry."
PRINT "   3. List entries.": PRINT "   4. List entry names."
PRINT "   5. Insert an entry.": PRINT "   6. Delete an entry."
PRINT "   7. Change output device. "; : COLOR 2
PRINT "(Currently: "; od$(od); ")": COLOR 3
PRINT "   8. Quit.": PRINT : PRINT " Enter your choice.  (1-6): ";
GOSUB GetKey: k = INT(VAL(k$)): IF k < 1 OR k > 8 THEN GOTO Menu
IF nh < 1 AND k > 1 AND k < 7 THEN GOTO Menu
IF (k = 1 OR k = 5) AND nh = 500 THEN BEEP: GOTO Menu
CLS : COLOR 6
ON k GOTO Add, Edit, HList, HListNames, EnIns, EnDel, ChangeDevice, Quit

Quit:
CLOSE : OPEN "HINTDIR.DAT" FOR OUTPUT AS #1: PRINT #1, nh
FOR r = 1 TO nh: PRINT #1, h$(r): PRINT #1, h%(r, 1), h%(r, 2): NEXT
CLOSE : CHDIR "..": CHDIR "DD": RUN "DDMENU"

'Ŀ
'                    Add a new record                           
'
Add:
PRINT "Enter name, question, etc. of hint:"
i$ = "": nh = nh + 1: tl = 70: GOSUB TextInput
h$(nh) = i$: h%(nh, 1) = nr + 1: p = 1: PRINT : PRINT "Enter hint.": PRINT

Add1:
IF p = 51 THEN GOTO Add3
CLS : PRINT "Paragraph #"; LTRIM$(STR$(p)): PRINT
i$ = "": tl = 255: GOSUB TextInput
ds.text = i$: rec = h%(nh, 1) + p - 1: PUT #1, rec, ds
PRINT "Another paragraph?  (Y/N): "; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO Add3
p = p + 1: GOTO Add1

Add3:
h%(nh, 2) = p: nr = nr + p: GOTO Menu

'Ŀ
'                    Edit an old record                         
'
Edit:
CLS : PRINT "Enter # of hint to edit (1-"; LTRIM$(RTRIM$(STR$(nh)));
LINE INPUT "): "; a$: xh = INT(VAL(a$))
IF xh < 1 OR xh > nh THEN GOTO Menu

PRINT "Enter question of hint:"
i$ = h$(xh): tl = 70: GOSUB TextInput: h$(xh) = i$: p = 1

Edit1:
IF p <= h%(xh, 2) THEN
  GET #1, h%(xh, 1) + p - 1, ds: i$ = RTRIM$(ds.text)
END IF
IF p > h%(xh, 2) THEN
  PRINT "Another paragraph?  (Y/N): "; : GOSUB GetKey
  IF k$ <> "Y" THEN GOTO Edit2
  i$ = "": h%(xh, 2) = h%(xh, 2) + 1
  '
  '      Move data ahead 1 record if inserting
  '     ---------------------------------------
  IF xh < nh THEN
    FOR x = h%(nh, 1) + h%(nh, 2) - 1 TO h%(xh + 1, 1) STEP -1
       GET #1, x, ds: PUT #1, x + 1, ds
    NEXT
    FOR x = xh + 1 TO nh: h%(x, 1) = h%(x, 1) + 1: NEXT
  END IF
END IF

CLS
PRINT "Entering paragraph #"; LTRIM$(STR$(p)); " of "; LTRIM$(STR$(h%(xh, 2)))
tl = 255: GOSUB TextInput: ds.text = i$: PUT #1, h%(xh, 1) + p - 1, ds
p = p + 1: GOTO Edit1

Edit2:
GOTO Menu

'Ŀ
'                   List complete hints                         
'
HList:
GOSUB PickParms: CLS : L = 0: IF od = 3 THEN GOSUB PickFN

FOR r = be TO en
   a$ = h1$: GOSUB Disp
   a$ = LEFT$(LTRIM$(RTRIM$(STR$(r))) + ": " + h$(r), 78)
   a = INT((78 - LEN(a$)) / 2): x = a + ABS(a <> (78 - LEN(a$)) / 2)
   a$ = h3$ + SPACE$(a) + a$ + SPACE$(x) + h3$: GOSUB Disp
   a$ = h2$: GOSUB Disp: a$ = "": GOSUB Disp
   FOR k = h%(r, 1) TO h%(r, 1) + h%(r, 2) - 1
      GET #1, k, ds: a1$ = RTRIM$(ds.text)
HList1:
      IF LEN(a1$) < 81 THEN a$ = a1$: GOSUB Disp: GOTO HList2
      FOR x = 80 TO 1 STEP -1
         IF MID$(a1$, x, 1) = " " THEN
           a$ = LEFT$(a1$, x - 1): a1$ = MID$(a1$, x + 1)
           GOSUB Disp: GOTO HList1
         END IF
      NEXT
      a$ = ">>> STRING ERROR <<<": GOSUB Disp
HList2:
   a$ = "": GOSUB Disp
   NEXT
   IF od = 1 AND L > 1 THEN L = 99: GOSUB Disp
   CLS : L = 0
NEXT
CLOSE #2: GOTO Menu

'Ŀ
'                    List hint names only                       
'
HListNames:
CLS : L = 0: IF od = 3 THEN GOSUB PickFN
FOR r = 1 TO nh: a$ = RTRIM$(STR$(r)) + ": " + h$(r): GOSUB Disp: NEXT
L = 99: a$ = "": GOSUB Disp: CLOSE #2: GOTO Menu

'Ŀ
'                       Insert entries                          
'
EnIns:
LINE INPUT "Insert after which hint?  (0 to exit):"; a$: be = INT(VAL(a$))
IF a$ = "0" THEN GOTO Menu
IF be < 1 OR be > nh - 1 THEN
  PRINT "Only 1 -"; nh - 1; " are valid!": PRINT : GOTO EnIns
END IF
CLS : PRINT "     Insert between--": PRINT h$(be)
PRINT "     And--": PRINT h$(be + 1): PRINT
PRINT "Correct?  (Y/N): "; : GOSUB GetKey: IF k$ <> "Y" THEN GOTO EnIns

'      Move data ahead 1 record
FOR x = h%(nh, 1) + h%(nh, 2) - 1 TO h%(be + 1, 1) STEP -1
   GET #1, x, ds: PUT #1, x + 1, ds
NEXT
FOR x = nh + 1 TO be + 1 STEP -1
   h%(x, 1) = h%(x - 1, 1) + 1: h%(x, 2) = h%(x - 1, 2): h$(x) = h$(x - 1)
NEXT
'      Create blank new record
ds.text = "Blank": h$(be + 1) = "Blank"
h%(be + 1, 1) = h%(be, 1) + h%(be, 2): h%(be + 1, 2) = 1
nh = nh + 1: PUT #1, h%(be + 1, 1), ds

CLS : PRINT "Blank entry inserted as #"; LTRIM$(STR$(be + 1))
PRINT : PRINT "Use option 2 (Edit an entry) to modify.": PRINT
PRINT "Hit any key..."; : GOSUB GetKey: GOTO Menu

'Ŀ
'                        Delete entries                         
'
EnDel:
LINE INPUT "Delete which hint?  (0 to exit):"; a$: be = INT(VAL(a$))
IF a$ = "0" THEN GOTO Menu
IF be < 1 OR be > nh THEN
  PRINT "Only 1 -"; nh; " are valid!": PRINT : GOTO EnDel
END IF
CLS : COLOR 14: PRINT "     You are about to delete:"
PRINT h$(be): PRINT : BEEP: COLOR 3
PRINT "Proceed?  (Y/N): "; : GOSUB GetKey: IF k$ <> "Y" THEN GOTO Menu

IF be = nh THEN nh = nh - 1: GOTO Menu

'      Move data back 1 record
z = h%(be, 2)
FOR x = h%(be, 1) TO h%(nh, 1) + h%(nh, 2) - 1
   GET #1, x + z, ds: PUT #1, x, ds
NEXT
FOR x = be + 1 TO nh
   h%(x - 1, 1) = h%(x, 1) - z: h%(x - 1, 2) = h%(x, 2): h$(x - 1) = h$(x)
NEXT
nh = nh - 1: GOTO Menu

'Ŀ
'                    Change output device                       
'
ChangeDevice:
PRINT "Enter device to print to:": PRINT
PRINT "   1.  Screen": PRINT "   2.  Printer (LPT1)"
PRINT "   3.  An ASCII (TXT) file": PRINT
PRINT " Enter 1-3: "; : GOSUB GetKey: od = INT(VAL(k$))
IF od < 1 OR od > 3 THEN CLS : GOTO ChangeDevice

ChangeDevice1:
h1$ = CHR$(218) + STRING$(78, 196) + CHR$(191)
h2$ = CHR$(192) + STRING$(78, 196) + CHR$(217): h3$ = CHR$(179)
IF od = 2 THEN h1$ = STRING$(80, "-"): h2$ = h1$: h3$ = " "
GOTO Menu

'Ŀ
' Subs: Pick list #s, pick file name, display a$, line-pause, get keypress 
'
PickParms:
CLS
LINE INPUT "Beginning with? (Default = 1):"; a$
be = INT(VAL(a$)): IF a$ = "" THEN be = 1
IF be < 1 OR be > nh THEN GOTO PickParms
PRINT "Ending with? (Default ="; STR$(nh); : LINE INPUT "):"; a$
en = INT(VAL(a$)): IF a$ = "" THEN en = nh
IF en < be OR en > nh THEN GOTO PickParms
RETURN

PickFN:
CLS : LINE INPUT "Enter name of file to write/append to:"; a$: PRINT
f$ = UCASE$(LEFT$(a$, 8) + ".TXT")
PRINT "Write/append to "; f$; "?  (Y/N): "; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO PickFN
OPEN f$ FOR APPEND AS #2: RETURN

Disp:
IF od = 1 THEN PRINT a$
IF od = 2 THEN LPRINT a$
IF od = 3 THEN PRINT #2, a$
GOTO Lp6

Lp6:
L = L + 1: IF od > 1 OR L < 21 THEN RETURN
PRINT "Hit any key..."; : GOSUB GetKey: L = 0: CLS : RETURN

GetKey:
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = INKEY$
  LOOP UNTIL k$ <> ""
  k$ = UCASE$(k$): PRINT k$: RETURN
END IF
' Standard Routine
BS = POS(0): CC# = 0
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
k$ = INKEY$
LOOP UNTIL k$ <> ""
k$ = UCASE$(k$): PRINT k$: RETURN

'**************************************************************************
'*                   Eamon Deluxe text editor v2.2                        *
'*                        by Frank Black 1999                             *
'*                                                                        *
'*   Variables to set before calling:                                     *
'*                                                                        *
'*       TL -- The desired length of the text string                      *
'*       i$ -- The text string to edit; Can be null ("") for new strings  *
'*  columns -- The # of columns to display in  (default=80)               *
'*      clr -- The current text color (default=7)                         *
'* TextHelp -- If anything but -1, valid key info is displayed            *
'*                (Help isn't displayed for strings < 20 in length)       *
'*                                                                        *
'*   Other variables used and/or changed by this subroutine:              *
'*                                                                        *
'*         sl -- String Length                                            *
'*          i -- Current location in i$                                   *
'*  TextHelp1 -- Used to preserve TextHelp setting on strings < 20        *
'*  col & row -- Present column and row on screen                         *
'* csr1, csr2 -- Row & column loc. when called (csr2 always reverts to 1) *
'*   a, a$, x -- Generic variables for procedures                         *
'**************************************************************************
TextInput:
IF columns = 0 THEN columns = 80
IF clr = 0 THEN clr = 7
TextHelp1 = TextHelp: IF tl < 20 THEN TextHelp1 = -1

csr1 = CSRLIN: csr2 = 1: PRINT
sl = LEN(i$): IF sl = 0 THEN i$ = " ": sl = 1
row = csr1: col = csr2: i = 1

LOCATE csr1, csr2: PRINT i$ + STRING$(tl - sl, 196)
IF TextHelp1 <> -1 THEN
  PRINT : PRINT "<Enter> Accepts all text left of cursor";
  IF columns < 80 THEN PRINT
  PRINT "        <Tab> Inserts a space": PRINT "  <Esc> Accepts ALL text"
  PRINT "<F1> Toggle extended text (under cursor)"
  PRINT "<F2> Toggle extended text (entire text)"
END IF

TextInput1:
LOCATE csr1, csr2: PRINT i$ + STRING$(tl - sl, 196)
'
TextInputLoop:
IF col > columns THEN col = 1: row = row + 1
IF col < 1 THEN col = columns: row = row - 1
IF row < csr1 THEN row = csr1: col = 1
IF i$ = "" THEN i$ = " ": sl = 1: i = 1
a2$ = MID$(i$, i, 1)
LOCATE row, col: COLOR 0, clr: PRINT a2$; :  COLOR clr, 0
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
LOCATE row, col: PRINT a2$; : LOCATE row, col
'
'    Sort key presses
'
a = ASC(RIGHT$(a$, 1))
IF LEN(a$) > 1 THEN
'
'   Left and Right arrows
'
  IF a = 75 THEN
    IF i = 1 THEN GOTO ErrorRtn
    IF RIGHT$(i$, 1) = " " THEN
      i$ = LEFT$(i$, sl - 1): sl = sl - 1: PRINT CHR$(196)
    END IF
    col = col - 1: i = i - 1
    GOTO TextInputLoop
  END IF
  IF a = 77 THEN
    IF i = tl THEN GOTO ErrorRtn
    IF i = sl THEN i$ = i$ + " ": sl = sl + 1
    i = i + 1: col = col + 1
    GOTO TextInputLoop
  END IF
'
'   Up and Down arrows
'
  IF a = 72 THEN
    IF row = csr1 THEN GOTO ErrorRtn
    i$ = RTRIM$(i$): sl = LEN(i$): row = row - 1: i = i - columns
    IF i > sl THEN col = col - (i - sl): i = sl
    GOTO TextInput1
  END IF
  IF a = 80 THEN
    IF row = INT(sl / columns) + csr1 THEN GOTO ErrorRtn
    IF i + columns > sl THEN GOTO ErrorRtn
    row = row + 1: i = i + columns
    GOTO TextInput1
  END IF
'
'  <Home> & <End>
'
  IF a = 71 THEN
    IF i = 1 THEN GOTO ErrorRtn
    i$ = RTRIM$(i$): sl = LEN(i$)
    i = 1: row = csr1: col = csr2: GOTO TextInput1
  END IF
  IF a = 79 THEN
    IF i = tl THEN GOTO ErrorRtn
    x = INT(sl / columns): row = csr1 + x: col = sl - x * columns
    i = sl: GOTO TextInputLoop
  END IF
'
'   Delete
'
   IF a = 83 THEN
     IF i = sl GOTO ErrorRtn
     i$ = MID$(i$, 1, i - 1) + MID$(i$, i + 1)
     sl = sl - 1
     GOTO TextInput1
   END IF
'
'  F1 and F2  (Toggles for extened/regular ASCII mode)
'
  IF a = 59 THEN
    x = 127: IF ASC(MID$(i$, i, 1)) > 127 THEN x = -x
    i$ = LEFT$(i$, i - 1) + CHR$(ASC(MID$(i$, i, 1)) + x) + MID$(i$, i + 1)
    GOTO TextInputLoop
  END IF
  IF a = 60 THEN
    a$ = ""
    FOR a = 1 TO sl
       x = 127: IF ASC(MID$(i$, a, 1)) > 127 THEN x = -x
       a$ = a$ + CHR$(ASC(MID$(i$, a, 1)) + x)
    NEXT
    i$ = a$: GOTO TextInput1
  END IF
  GOTO ErrorRtn
END IF
'
'   Backspace
'
IF a = 8 THEN
  IF i = 1 GOTO ErrorRtn
  i$ = MID$(i$, 1, i - 2) + MID$(i$, i)
  i = i - 1: sl = sl - 1: col = col - 1
  GOTO TextInput1
END IF
'
'    TAB key (insert space)
'
IF a = 9 THEN
  IF i = tl OR i = sl OR sl = tl THEN GOTO ErrorRtn
  IF i = 1 THEN i$ = " " + i$
  IF i > 1 THEN i$ = MID$(i$, 1, i - 1) + " " + MID$(i$, i)
  sl = sl + 1: LOCATE csr1, csr2: PRINT i$;
  GOTO TextInputLoop
END IF
'
'  <ENTER> accepts text from beginning to cursor)
'    <ESC> accepts all text)
'
IF a = 13 THEN
  i$ = LEFT$(i$, i - 1 * ABS(i < tl))
  GOTO TextInputDone
END IF
IF a = 27 THEN GOTO TextInputDone
'
'  Add valid characters to string
'
IF a < 32 THEN GOTO ErrorRtn
IF i = tl THEN
  i$ = MID$(i$, 1, i - 1) + a$: PRINT a$; : GOTO TextInputLoop
END IF
IF i < sl THEN
  IF i = 1 THEN i$ = a$ + MID$(i$, 2)
  IF i > 1 THEN i$ = MID$(i$, 1, i - 1) + a$ + MID$(i$, i + 1)
END IF
IF i = sl THEN
  i$ = LEFT$(i$, sl - 1) + a$ + " ": sl = sl + 1
END IF
i = i + 1: col = col + 1: PRINT a$; : GOTO TextInputLoop
'
'     Invalide keys/move
'
ErrorRtn:
SOUND 800, .5: GOTO TextInputLoop
'
'     Display string
'
TextInputDone:
a$ = "": IF TextHelp1 <> -1 THEN a$ = STRING$(425, 32)
LOCATE csr1, csr2: PRINT STRING$(tl, 32) + a$
i$ = RTRIM$(i$): LOCATE csr1, csr2: PRINT i$: PRINT
RETURN

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 68 THEN PRINT "(Printer unavailable)";
IF ERR = 62 THEN PRINT "(Input past end of file)";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : IF ez = 0 THEN PRINT "Program terminated.": RESUME ErHndlr1
PRINT "Hit any key..."; : GOSUB GetKey: CLOSE #2: RESUME Menu

ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

