' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                                                                
'  DUNGEON LIST PROGRAM                             15 MAY 1999  
'                                           Update: 27 JAN 2012  
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

CHDIR "..\DD"

TYPE ADV
   ANAME AS STRING * 78
   NUMBER AS INTEGER
END TYPE
DIM ADV AS ADV

ON ERROR GOTO ErHndlr

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

'
' Load design names
'
OPEN "DGNDIR.DAT" FOR INPUT AS #1
INPUT #1, d1, d2
CLOSE
IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d1$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d2$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
'
' Load adventure names
'
CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
GET #2, 1, ADV
numadv = ADV.NUMBER: numadv1 = numadv
DIM an$(numadv + 2), anum(numadv + 2)

FOR a = 2 TO numadv + 1
   GET #2, a, ADV
   an$(a - 1) = LTRIM$(RTRIM$(ADV.ANAME$))
NEXT
CLOSE : CHDIR "DD"
IF d1 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d1$ + "  (Design 1)"
END IF
IF d2 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d2$ + "  (Design 2)"
END IF
'
' Change to proper directory
'
Start:
CLS : l = 0
PRINT "Select adventure to list."
FOR a = 1 TO numadv
   a$ = LTRIM$(RTRIM$(STR$(a))) + ": " + an$(a)
   PRINT a$
   l = l + 1
   IF l = 20 THEN
      PRINT "Hit any key to continue...";
      DO
      LOOP UNTIL INKEY$ <> ""
      l = 0
   END IF
NEXT
PRINT
LINE INPUT "Enter the number of your choice:"; a$
a = INT(VAL(a$))
IF a < 1 OR a > numadv THEN GOTO Start
a$ = LTRIM$(RTRIM$(STR$(a)))
ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
IF a = numadv1 + 1 THEN ad$ = "DGN-1"
IF a = numadv1 + 2 OR (a = numadv1 + 1 AND d1 = 0) THEN ad$ = "DGN-2"
CHDIR "..": CHDIR ad$

'----------------------------------------------------------------------------
CLS : COLOR 12
TYPE DESC
  TEXT AS STRING * 255
END TYPE
DIM D AS DESC

TYPE ROOM
  RNAME AS STRING * 79: d1 AS INTEGER: d2 AS INTEGER: D3 AS INTEGER
  D4 AS INTEGER: D5 AS INTEGER: D6 AS INTEGER: D7 AS INTEGER: D8 AS INTEGER
  D9 AS INTEGER: D10 AS INTEGER: Light AS INTEGER
END TYPE
DIM rm AS ROOM

TYPE ARTIFACT
  ANAME AS STRING * 35: AD1 AS INTEGER: AD2 AS INTEGER: AD3 AS INTEGER:
  AD4 AS INTEGER: AD5 AS INTEGER: AD6 AS INTEGER: AD7 AS INTEGER:
  AD8 AS INTEGER
END TYPE
DIM art AS ARTIFACT

TYPE MONSTER
  MNAME AS STRING * 35: MD1 AS INTEGER: MD2 AS INTEGER: MD3 AS INTEGER:
  MD4 AS INTEGER: MD5 AS INTEGER: MD6 AS INTEGER: MD7 AS INTEGER:
  MD8 AS INTEGER: MD9 AS INTEGER: MD10 AS INTEGER: MD11 AS INTEGER
  MD12 AS INTEGER: MD13 AS INTEGER
END TYPE
DIM mon AS MONSTER
'---------------------------------------------------------------------------
'  Set up variable table
'
OPEN "NAME.DAT  " FOR INPUT AS #1
INPUT #1, nr, na, ne, nm, advname$, nd, ver, dungeons
IF dungeons > 1 THEN
  DIM dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a)
     FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF
CLOSE

OPEN "HINTDIR.DAT" FOR INPUT AS #1
INPUT #1, nh
DIM h$(nh), h%(nh, 2)
FOR r = 1 TO nh
   INPUT #1, h$(r), h%(r, 1), h%(r, 2)
NEXT: CLOSE
'
' Select from multiples
'
Start1:
IF dungeons > 1 THEN
  CLS : PRINT "Select adventure to list:": PRINT
  FOR a = 1 TO dungeons
     PRINT " "; RTRIM$(STR$(a)); ". "; dn$(a)
  NEXT
  PRINT : PRINT "Enter 1-"; LTRIM$(RTRIM$(STR$(dungeons)));
  LINE INPUT ": "; a$: a = INT(VAL(a$))
  IF a < 1 OR a > dungeons THEN GOTO Start1
  nr = dn%(a, 1): na = dn%(a, 2): ne = dn%(a, 3): nm = dn%(a, 4)
  nd = dn%(a, 9): adj1 = dn%(a, 5) - 1: adj2 = dn%(a, 6) - 1
  adj3 = dn%(a, 7) - 1: adj4 = dn%(a, 8) - 1: advname$ = dn$(a)
END IF

Start2:
DIM a$(na), a%(na, 8), m$(nm), m%(nm, 13), r$(nr), r%(nr, 11), dir$(10)
DIM w$(5), ar$(7), ct$(6)
mf = 13: READ af
DIM mf$(mf), ty$(af), f$(af, 8)
GOSUB Init: DS = 1

OPEN "ROOMS.DSC" FOR RANDOM AS #10 LEN = 255
OPEN "ARTIFACT.DSC" FOR RANDOM AS #11 LEN = 255
OPEN "MONSTERS.DSC" FOR RANDOM AS #12 LEN = 255
OPEN "EFFECT.DSC" FOR RANDOM AS #13 LEN = 255

OPEN "HINTS.DSC" FOR RANDOM AS #2 LEN = 255

'---------------------------------------------------------------------------
' Menu
'
Menu:
CLS : l = 0: PRINT SPC(24); "Eamon Deluxe Dungeon List": PRINT
COLOR 2
PRINT SPC((80 - LEN(advname$)) / 2); advname$: PRINT
COLOR 12
PRINT "    Select Action Desired:"
PRINT
PRINT SPC(10); "1. List Rooms"
PRINT SPC(10); "2. List Artifacts"
PRINT SPC(10); "3. List Effects"
PRINT SPC(10); "4. List Monsters"
PRINT SPC(10); "5. List Help/Hint File"
PRINT SPC(10); "6. Toggle Descriptions (Now ";
PRINT MID$("offon", DS * 3 + 1, 3); ")"
PRINT SPC(10); "7. Toggle Printer (Now ";
PRINT MID$("offon", pt * 3 + 1, 3); ")"
PRINT SPC(10); "8. List a New Dungeon"
PRINT SPC(10); "9. Quit"
PRINT
LINE INPUT "    Enter the no. of your choice (1-8):"; a$
CLS : l = 0: ch = INT(VAL(a$))
IF ch < 1 OR ch > 9 THEN GOTO Menu
ON ch GOTO Rooms, Artifacts, Effects, Monsters, Hints, DS, pt, New, Quit
'---------------------------------------------------------------------------
'  List Rooms
'
Rooms:
a1 = nr: GOSUB Pick: CLS : l = 0
a$ = advname$: GOSUB Center
FOR r = be TO en
   CLS
   a$ = "Room #" + LTRIM$(RTRIM$(STR$(r))) + ": " + r$(r): GOSUB Lp0
   GOSUB Lp1
   IF DS = 1 THEN
     GET #10, r + adj1, D
     a$ = RTRIM$(D.TEXT): GOSUB Lp0: GOSUB Lp1
   END IF
   FOR dir = 1 TO nd
      x = r%(r, dir): a$ = "   " + dir$(dir) + ": "
      a$ = a$ + LEFT$("  ", ABS(x >= 0) + ABS(ABS(x) < 10))
      a$ = a$ + LTRIM$(STR$(x)) + "     "
      IF LEN(STR$(x)) < 4 THEN a$ = a$ + " "
      IF x = -999 THEN a$ = a$ + "[Exit]"
      IF x > 1000 AND na >= x - 1000 THEN a$ = a$ + "[" + a$(x - 1000) + "]"
      IF x > 0 AND x <= nr THEN a$ = a$ + "[" + r$(x) + "]"
   GOSUB Lp0
   NEXT
   a$ = "Light:" + STR$(r%(r, 11)): GOSUB Lp0: GOSUB Lp1
   IF pt = 0 THEN
     l = 999: GOSUB Lp6
   END IF
NEXT
l = 999: IF pt = 1 THEN GOSUB Lp6
CLS : GOTO Menu
'---------------------------------------------------------------------------
'  List artifacts
'
Artifacts:
a1 = na: GOSUB Pick: CLS : l = 0
a$ = advname$: GOSUB Center
FOR r = be TO en
  CLS : l = 0
  a$ = "Artifact #" + LTRIM$(RTRIM$(STR$(r))) + ": " + a$(r): GOSUB Lp0
  GOSUB Lp1
  IF DS = 1 THEN
    GET #11, r + adj2, D
    a$ = RTRIM$(D.TEXT): GOSUB Lp0: GOSUB Lp1
  END IF
  a$ = "  Value" + LEFT$(pr$, 15) + LTRIM$(STR$(a%(r, 1))): GOSUB Lp0
  a$ = "  Type" + LEFT$(pr$, 16) + LTRIM$(STR$(a%(r, 2)))
  b = LEN(LTRIM$(STR$(a%(r, 2))))
  a$ = a$ + LEFT$("     ", 5 - ABS(b > 1) - ABS(b > 2) - ABS(b > 3)) + "["
  IF a%(r, 2) < 0 OR a%(r, 2) > af THEN a$ = a$ + "Unknown]"
  IF a%(r, 2) > -1 AND a%(r, 2) <= af THEN a$ = a$ + ty$(a%(r, 2)) + "]"
  GOSUB Lp0
  a$ = "  Weight" + LEFT$(pr$, 14) + LTRIM$(STR$(a%(r, 3)))
  IF a%(r, 3) = -999 THEN a$ = a$ + "  [Unmovable]"
  GOSUB Lp0
  a$ = "  Room" + LEFT$(pr$, 16) + LTRIM$(STR$(a%(r, 4)))
  b = LEN(LTRIM$(STR$(a%(r, 4))))
  a$ = a$ + LEFT$("     ", 5 - ABS(b > 1) - ABS(b > 2) - ABS(b > 3) - ABS(b > 4))
  x = a%(r, 4)
  IF x > 0 AND x <= nr THEN a$ = a$ + "[" + r$(x) + "]"
  IF x < 0 AND x >= -nm - 1 THEN a$ = a$ + "[Carried by " + m$(ABS(x + 1)) + "]"
  IF x > 2000 AND x <= nr + 2000 THEN a$ = a$ + "[Embedded in room " + LTRIM$(STR$(x - 2000)) + "]"
  IF x > 1000 AND x <= na + 1000 THEN a$ = a$ + "[Inside " + a$(x - 1000) + "]"
  IF x = -999 THEN a$ = a$ + "[Worn by " + m$(0) + "]"
  IF x < -1000 AND x >= -nm - 1000 THEN a$ = a$ + "[Worn by " + m$(ABS(x) - 1000) + "]"
  GOSUB Lp0
  FOR a = 5 TO 8
     x = a%(r, 2)
     IF x < 0 OR x > af THEN
       a$ = "  Field #" + STR$(a) + ":" + LEFT$(pr$, 12) + STR$(a%(r, a))
       GOTO Art1
     END IF
     m = a%(r, a)
     a$ = "  " + f$(x, a) + LEFT$(pr$, 20 - LEN(f$(x, a))) + LTRIM$(STR$(m))
     b = LEN(LTRIM$(STR$(m)))
     IF (x = 2 OR x = 3) AND a = 5 THEN
       b = b + 1: a$ = a$ + "%"
     END IF
     a$ = a$ + LEFT$("     ", 5 - ABS(b > 1) - ABS(b > 2) - ABS(b > 3))
     IF (x = 2 OR x = 3) AND a = 6 THEN a$ = a$ + "[" + w$(m) + "]"
     IF (x = 10 AND (a = 5 OR a = 7)) OR (x = 12 AND a = 5) THEN
       IF m > 0 AND m <= nm THEN a$ = a$ + "[" + m$(m) + "]"
     END IF
     IF (x = 4 AND a = 5) OR (x = 8 AND a = 6) OR (x = 10 AND a = 6) THEN
       IF m > 0 AND m <= na THEN a$ = a$ + "[" + a$(m) + "]"
     END IF
     IF x = 4 AND a = 6 AND m > 1000 THEN a$ = a$ + "[Strength of " + LTRIM$(RTRIM$(STR$(m - 1000))) + "]"
     IF x = 8 AND a = 5 AND m > 0 AND m <= nr THEN a$ = a$ + "[" + r$(m) + "]"
     IF x = 8 AND a = 7 THEN
       IF m = 0 THEN a$ = a$ + "[Open]"
       IF m = 1 THEN a$ = a$ + "[Closed]"
       IF m > 100 THEN a$ = a$ + "[Strength of " + LTRIM$(RTRIM$(STR$(m - 100))) + "]"
     END IF
     IF x <> 11 THEN GOTO Art1
     IF a = 5 AND m > -1 AND m < 8 THEN a$ = a$ + "[" + ar$(m) + "]"
     IF a = 5 AND m > 7 THEN a$ = a$ + "[Magic/Exotic]"
     IF a = 6 AND a%(r, 5) = 0 AND m > -1 AND m < 6 THEN
       a$ = a$ + "[" + ct$(m) + "]"
     END IF
Art1:
     GOSUB Lp0
  NEXT
  IF pt = 0 THEN
    l = 999: GOSUB Lp6
  END IF
NEXT
l = 999: IF pt = 1 THEN GOSUB Lp6
CLS : GOTO Menu
'---------------------------------------------------------------------------
'  List Effects
'
Effects:
a1 = ne: GOSUB Pick: CLS : l = 0
a$ = advname$: GOSUB Center
FOR r = be TO en
   a$ = "Effect #" + LTRIM$(STR$(r)): GOSUB Lp0
   GET #13, r + adj3, D
   a$ = RTRIM$(D.TEXT): GOSUB Lp0: GOSUB Lp1
NEXT
l = 999: GOSUB Lp6: CLS : GOTO Menu
'---------------------------------------------------------------------------
'  List monsters
'
Monsters:
a1 = nm: GOSUB Pick: CLS : l = 0
a$ = advname$: GOSUB Center
FOR r = be TO en
  CLS : l = 0
  a$ = "Monster #" + LTRIM$(RTRIM$(STR$(r))) + ": "
  IF m%(r, 3) > 1 THEN a$ = a$ + LTRIM$(STR$(m%(r, 3))) + " "
  a$ = a$ + m$(r): IF m%(r, 3) > 1 THEN a$ = a$ + "s"
  GOSUB Lp0: GOSUB Lp1
  IF DS = 1 THEN
    GET #12, r + adj4, D
    a$ = RTRIM$(D.TEXT): GOSUB Lp0: GOSUB Lp1
  END IF
  FOR m = 1 TO mf
     IF m = 3 THEN GOTO Monsters1
     x = m%(r, m)
     a$ = " " + mf$(m) + LEFT$(pr$, 20 - LEN(mf$(m))) + LTRIM$(STR$(x))
     b = LEN(LTRIM$(STR$(x)))
     IF m = 4 THEN a$ = a$ + "%"
     a$ = a$ + LEFT$("      ", 6 - ABS(b > 1) - ABS(b > 2) - ABS(b > 3))
     IF m = 6 THEN
       IF x = 1 THEN a$ = a$ + "['ATTACKS' only]"
       IF x = 0 THEN a$ = a$ + "[Normal]"
       IF x = -2 THEN a$ = a$ + "[Doesn't fight]"
       IF x = -1 THEN a$ = a$ + "[Will use wep. or nat. weapons]"
     END IF
     IF m = 11 AND x > 99 THEN a$ = a$ + "[" + LTRIM$(STR$(x - 100)) + "%]"
     IF m = 11 AND x > 0 AND x < 4 THEN a$ = a$ + "[" + fr$(x) + "]"
     IF m = 5 AND x > 0 AND x <= nr THEN a$ = a$ + "[" + r$(x) + "]"
     IF m = 8 AND x = 0 THEN a$ = a$ + "[Natural Weapons]"
     IF m = 8 AND x < 0 THEN a$ = a$ + "[Weaponless]"
     IF m = 8 AND x > 0 AND x <= na THEN a$ = a$ + "[" + a$(x) + "]"
     GOSUB Lp0
Monsters1:
  NEXT
  GOSUB Lp1
  IF pt = 0 THEN
    l = 999: GOSUB Lp6
  END IF
NEXT
l = 999: IF pt = 1 THEN GOSUB Lp6
CLS : GOTO Menu

'---------------------------------------------------------------------------
'  List hints
'
Hints:
a1 = nh: GOSUB Pick: CLS : l = 0
a$ = advname$: GOSUB Center
FOR r = be TO en
   a$ = "Hint #" + LTRIM$(STR$(r)) + ": " + h$(r): GOSUB Lp0: GOSUB Lp1
   a = h%(r, 1) + h%(r, 2) - 1
   FOR m = h%(r, 1) TO a
      GET #2, m, D: a$ = RTRIM$(D.TEXT): GOSUB Lp0: GOSUB Lp1
   NEXT
   GOSUB Lp1
NEXT
l = 999: GOSUB Lp6: CLS : GOTO Menu
'---------------------------------------------------------------------------
' Toggle Descriptions
'
DS:
IF DS = 0 THEN
  DS = 1: GOTO Menu
END IF
DS = 0: GOTO Menu
'---------------------------------------------------------------------------
' Toggle Descriptions
'
pt:
IF pt = 0 THEN
  pt = 1: GOTO Menu
END IF
pt = 0: GOTO Menu
'---------------------------------------------------------------------------
' New dungeon
'
New:
LINE INPUT "Select a new dungeon? (Y/N):"; a$
a$ = LCASE$(LEFT$(LTRIM$(RTRIM$(a$)), 1))
IF a$ <> "y" THEN GOTO Menu
CHDIR ".."
CHDIR "DD"
RUN
'---------------------------------------------------------------------------
' Exit Program
'
Quit:
CHDIR ".."
CHDIR "DD"
RUN "DDMENU"

'---------------------------------------------------------------------------
' Subroutines
'
Center:
IF pt = 0 THEN
  PRINT SPC((80 - LEN(a$)) / 2); a$: PRINT : l = l + 2
END IF
IF pt = 1 THEN
  LPRINT SPC((80 - LEN(a$)) / 2); a$: LPRINT : l = l + 2
END IF
RETURN
'
Lp0:
IF LEN(a$) <= 79 THEN
  IF pt = 0 THEN PRINT a$:  GOTO Lp2
  LPRINT a$: GOTO Lp2
END IF
FOR k = 79 TO 1 STEP -1
   IF MID$(a$, k, 1) = " " THEN
     IF pt = 0 THEN
       PRINT LEFT$(a$, k - 1): a$ = LTRIM$(RIGHT$(a$, LEN(a$) - k))
     END IF
     IF pt = 1 THEN
       LPRINT LEFT$(a$, k - 1): a$ = LTRIM$(RIGHT$(a$, LEN(a$) - k))
     END IF
     GOSUB Lp2: k = 1
   END IF
NEXT: GOTO Lp0
'
Lp1:
IF pt = 0 THEN PRINT
IF pt = 1 THEN LPRINT
'
Lp2:
l = l + 1: GOTO Lp5
'
Lp4:
IF pt = 0 THEN PRINT
IF pt = 1 THEN LPRINT
l = l + 2
'
Lp5:
x = 20: IF pt = 1 THEN x = 55
IF l < x THEN RETURN
'
Lp6:
l = 0
IF pt = 1 THEN RETURN
PRINT "HIT ANY KEY..."; : z$ = ""
DO
z$ = INKEY$
LOOP UNTIL z$ > ""
IF ASC(z$) = 27 THEN r = en
PRINT : CLS : RETURN
'
Pick:
PRINT : PRINT "Enter 1-"; LTRIM$(RTRIM$(STR$(a1)));
PRINT ", ENTER accepts number in parenthesis.": PRINT
LINE INPUT "Beginning with # (1):"; be$
IF be$ = "" THEN
  be$ = "1": LOCATE CSRLIN - 1, 24: PRINT "(No. 1)"
END IF
PRINT : PRINT "Ending with # ("; LTRIM$(RTRIM$(STR$(a1)));
LINE INPUT "):"; en$
IF en$ = "" THEN
  en$ = LTRIM$(RTRIM$(STR$(a1))): LOCATE CSRLIN - 1, 24: PRINT "(No. "; en$; ")"
END IF
be = INT(VAL(be$)): en = INT(VAL(en$))
IF be > a1 OR be < 1 THEN be = 1
IF en > a1 OR en < be THEN en = a1
RETURN
'---------------------------------------------------------------------------
'  Input data from files
'
Init:
OPEN "ROOMS.DAT" FOR RANDOM AS #1 LEN = 101
OPEN "ARTIFACT.DAT" FOR RANDOM AS #2 LEN = 51
OPEN "MONSTERS.DAT" FOR RANDOM AS #3 LEN = 61
'
'   Rooms
'
FOR r = 1 TO nr
   GET #1, r + adj1, rm
   r$(r) = RTRIM$(rm.RNAME)
   r%(r, 1) = rm.d1: r%(r, 2) = rm.d2: r%(r, 3) = rm.D3: r%(r, 4) = rm.D4
   r%(r, 5) = rm.D5: r%(r, 6) = rm.D6: r%(r, 7) = rm.D7: r%(r, 8) = rm.D8
   r%(r, 9) = rm.D9: r%(r, 10) = rm.D10: r%(r, 11) = rm.Light
NEXT
'
'   Artifacts
'
FOR a = 1 TO na
   GET #2, a + adj2, art
   a$(a) = RTRIM$(art.ANAME): a%(a, 1) = art.AD1: a%(a, 2) = art.AD2
   a%(a, 3) = art.AD3: a%(a, 4) = art.AD4: a%(a, 5) = art.AD5
   a%(a, 6) = art.AD6: a%(a, 7) = art.AD7: a%(a, 8) = art.AD8
NEXT
'
'   Monsters
'
FOR m = 1 TO nm
   GET #3, m + adj4, mon
   m$(m) = RTRIM$(mon.MNAME): m%(m, 1) = mon.MD1: m%(m, 2) = mon.MD2
   m%(m, 3) = mon.MD3: m%(m, 4) = mon.MD4: m%(m, 5) = mon.MD5
   m%(m, 6) = mon.MD6: m%(m, 7) = mon.MD7: m%(m, 8) = mon.MD8
   m%(m, 9) = mon.MD9: m%(m, 10) = mon.MD10: m%(m, 11) = mon.MD11
   m%(m, 12) = mon.MD12: m%(m, 13) = mon.MD13
NEXT
CLOSE
'---------------------------------------------------------------------------
' Read Artifact types and fields
'
FOR a = 0 TO af
   READ ty$(a)
   FOR a2 = 5 TO 8
      READ f$(a, a2)
   NEXT
NEXT
FOR a = 0 TO af
   f$(a, 1) = "Value"
   f$(a, 2) = "Type"
   f$(a, 3) = "Weight"
   f$(a, 4) = "Room"
NEXT
'
' Monster fields
'
FOR m = 1 TO mf: READ mf$(m): NEXT
'
' Direction names
'
FOR a = 1 TO 10: READ dir$(a): NEXT
'
' Weapon types
'
FOR a = 1 TO 5: READ w$(a): NEXT
'
' Armor & Clothing
'
READ ar$(0), ar$(1)
FOR a = 2 TO 6 STEP 2
   READ ar$(a)
   ar$(a + 1) = ar$(a) + " & Shield"
NEXT
FOR a = 0 TO 6
   READ ct$(a)
NEXT
'
m$(0) = "The Adventurer"
pr$ = "...................."
fr$(1) = "Enemy": fr$(2) = "Neutral": fr$(3) = "Friend"
RETURN

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 68 THEN PRINT "(Printer unavailable)";
IF ERR = 62 THEN PRINT "(Input past end of file)";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : PRINT "Program terminated.": RESUME ErHndlr1
ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

'
' ARTIFACT DATA
'
DATA 16
DATA Gold,User #5,User #6,User #7,User #8
DATA Treasure,User #5,User #6,User #7,User #8
DATA Weapon,Odds,Type,Dice,Sides
DATA Magic Weapon,Odds,Type,Dice,Sides
DATA Container,Key#,Open/Closed,# of Items Inside,# of Items Can Hold
DATA Light,Counter,User #6,User #7,User #8
DATA Drinkable,Heal Amount,# of Uses,Open/Closed,User #8
DATA Readable,1st Effect,# of Effects,Open/Closed,User #8
DATA Door/Gate,Room Beyond,Key#,Open/Closed,Hidden
DATA Food,Heal Amount,# of Uses,Open/Closed,User #8
DATA Bound Monster,Monster#,Key #,Guard#,User #8
DATA Wearable,Armor Class,Type,User #7,User #8
DATA Disguised Monster,Monster #,# of First Effect,# of Effects,User #8
DATA Dead body,GET status,User #6,User #7,User #8
DATA USER TYPE#1,User #5,User #6,User #7,User #8
DATA USER TYPE#2,User #5,User #6,User #7,User #8
DATA USER TYPE#3,User #5,User #6,User #7,User #8
'
' Monster Data
'
DATA Hardiness,Agility,# Members in Group,Courage,Room
DATA Combat Code,Armor,Weapon #,Weapon Dice,Weapon Sides
DATA Friendliness,USER #1,USER #2
'
' Direction names
'
DATA "North    ","South    ","East     ","West     ","Up       ","Down     "
DATA Northeast,Northwest,Southeast,Southwest
'
' Weapon types
'
DATA Axe,Bow,Club,Spear,Sword
'
' Armor & Clothing
'
DATA Clothes,Shield,Leather,Chain,Plate
DATA Clothing,Overclothes,Shoes,Gloves,Headwear,Jewelry,Undergarments

