' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                 MULTI-ADVENTURE INTRO PROGRAM                  
'                                                                
' The Jim Jacobson Adventures Deluxe       Revision: 13 JUN 2012 
'  by Jim Jacobson and Frank Black           Update: 16 JUN 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB PastBlast2 ()
ON ERROR GOTO ErrHandler

DIM SHARED Adventure$, author$, q$, SEX, friend$
DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: SEX AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM SHARED z AS RECORD

TYPE VISITORS
   pname AS STRING * 40: psex AS STRING * 3: v0 AS INTEGER: v1 AS INTEGER
   v2 AS INTEGER: v3 AS INTEGER: v4 AS INTEGER: v5 AS INTEGER: v6 AS INTEGER
   v7 AS INTEGER: v8 AS INTEGER: v9 AS INTEGER: v10 AS INTEGER: v11 AS INTEGER
   v12 AS INTEGER: v13 AS INTEGER: v14 AS INTEGER: v15 AS INTEGER
   v16 AS INTEGER: v17 AS INTEGER: v18 AS INTEGER: v19 AS INTEGER
   v20 AS INTEGER: v21 AS INTEGER: v22 AS INTEGER: v23 AS INTEGER
   v24 AS INTEGER: v25 AS INTEGER: v26 AS INTEGER
END TYPE
DIM SHARED vz AS VISITORS
SCREEN 0: WIDTH 80: CLS

' Check for new installs/missing visitors file, restore if needed
ON ERROR GOTO VisitorFileIOError
s%(4) = 1: OPEN "VISITORS.DAT" FOR INPUT AS #1
VisitorFileIOError1:
ON ERROR GOTO ErrHandler
CLOSE
IF ProgErr1 = 1 THEN
  PRINT "Restoring visitor records file from default backup......";
  OPEN "VISIT-BK.DAT" FOR RANDOM AS #1 LEN = 97
  OPEN "VISITORS.DAT" FOR RANDOM AS #2 LEN = 97
  FOR x = 1 TO 3: GET #1, x, vz: PUT #2, x, vz: NEXT
  CLOSE : COLOR 15: PRINT "DONE!": PRINT : COLOR 7: ProgErr1 = 0
  GOSUB KeyWait2: CLS
END IF

' Load system settings
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE
RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), adv, adv1, adv2, ANAME$, dungeons
adv2 = a
OPEN "NAME.DAT" FOR INPUT AS #1
    INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
    IF dungeons > 1 THEN
      DIM SHARED dn$(dungeons), dn%(dungeons, 9)
      FOR a = 1 TO dungeons
	 LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
      NEXT
    END IF
CLOSE

' Load multi-adventure names
'----------------------------
FOR a = 1 TO adv2: READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a): NEXT

' Init choices for EDXMenuM
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27) '(Enter, Space, Escape)
'  Load useful character data
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): SEX = z.SEX: q$ = CHR$(34)

' Load captive's name for Abductor's Quarters
OPEN "CAPTIVE.DAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
friend$ = LTRIM$(RTRIM$(z.CNAME$))

author1$ = "Converted and expanded by Frank Black": author$ = author1$
Adventure1$ = "The Jim Jacobson Adventures Deluxe Edition": Adventure$ = Adventure1$
SCREEN 0: WIDTH 80: CLS : GOSUB Title

OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
IF ASC(MID$(name$, 1)) = 0 THEN
  COLOR 15: PRINT "WARNING! This adventure has a corrupt file. Repairing the ";
  PRINT "file and returning to": PRINT "Main System Menu...": GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, -1
      FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF
IF a = -1 THEN
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
      a = -2: PRINT #1, a: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE
  COLOR 2: LOCATE 6: a$ = "This is Official Eamon Deluxe Adventure #3"
  GOSUB Center: LOCATE 20: GOSUB KeyWait: GOSUB Intro: GOTO Menu
END IF
IF a = -2 THEN GOTO Menu
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; Adventure$; "!": PRINT
PRINT "Do you want to read the intro story again? (Y/N):"; : GOSUB KeyWait3
IF k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Cave, Zyphur, Tomb, Abductor, Trezore
GOTO IntroDone

'                 [Formerly] Blast from the past intro
'                --------------------------------------
Intro:
GOSUB Header:  LOCATE 6: COLOR 2
PRINT "  After Donald Brown created Classic Eamon, his friend, Jim Jacobson, stepped"
PRINT "  into the shoes of what was to become the first Eamon author. Over thirty"
PRINT "  years have passed since he wrote "; q$; "The Cave of the Mind"; q$; " and new Eamon"
PRINT "  Adventures continue to be written and played to this day. While somewhat"
PRINT "  small and simple by later standards, I found all of Jim's adventures to be"
PRINT "  very well written and fun with a certain style to them that is"
PRINT "  distinguishably his own."
PRINT
PRINT "  When converting them to Eamon Deluxe, I decided it would be fun to expand"
PRINT "  them and add new characters, items, and puzzles while still keeping in"
PRINT "  place all of the things he had written and integrating them into a sort of"
PRINT "  hybrid adventure set as a tribute to a great Classic Eamon author who is"
PRINT "  one of my personal favorites."
LOCATE 20: GOSUB KeyWait
GOSUB Header: LOCATE 7: COLOR 2
PRINT "  It should be noted that the plot lines of the first four adventures connect"
PRINT "  slightly and they should be played in sequential order for full enjoyment."
PRINT "  You will meet characters who will reappear in later adventures and remember"
PRINT "  how you treated them previously."
PRINT
PRINT "  "; q$; "The Quest for Trezore"; q$; " is a little different and doesn't "; q$; "remember"; q$
PRINT "  anything."
LOCATE 20: GOSUB KeyWait
GOSUB Header: LOCATE 7: COLOR 2
PRINT "  Playing them again for the Eamon Deluxe 5.0 upgrade reminded me how fun it"
PRINT "  was when I first converted and co-authored them and I hope that the"
PRINT "  adventurers who wander through here have just as much fun because that is"
PRINT "  what Eamon has always been about. Well, that and pillaging..."
PRINT : PRINT : COLOR 15: LOCATE CSRLIN, 58
PRINT "Cheers,": COLOR 7: LOCATE CSRLIN, 55: PRINT "-Frank Black"
LOCATE CSRLIN, 55: PRINT "January, 2012"
LOCATE 20: GOTO KeyWait

Menu:
author$ = author1$: Adventure$ = Adventure1$: GOSUB Title: COLOR 2
FOR a = 1 TO 3
   PRINT a$(a); : LOCATE CSRLIN, 40: IF a < 3 THEN PRINT a$(a + 3)
NEXT
COLOR 7: PRINT : PRINT
k = 10: c1 = 4
CALL EDXMenuM(k, c1, 1, 7, 3, 0)
IF k > 7 OR c1 = 3 THEN CHDIR "..": RUN "EAMONDX"
IF k = 7 THEN GOSUB Intro: GOTO Menu
IF k = 6 THEN RUN "VISITORS"
IF k = 4 THEN adv = 0: GOTO Reviews

' Past Blast and VI Mode safety catch for said blast
IF k = 5 THEN
  GOSUB Header: LOCATE 7: COLOR 10
  PRINT "  In older versions of Eamon Deluxe, the Donald Brown, Jim Jacobson and John"
  PRINT "  Nelson adventure collections opened with a 40-Column text splash screen."
  PRINT "  These screens each recreated one of the three commonly used boot screens"
  PRINT "  from the Classic Eamon era, and were included for nostalgic amusement only."
  PRINT "  The splash screen effects have been removed and viewing them made optional"
  PRINT "  with the upgrade to Eamon Deluxe 5.0."
  LOCATE 21: GOSUB KeyWait
  IF s%(4) = 1 THEN
    PRINT "VI Mode note: This routine switches to a 40 column text screen which was"
    PRINT "occasionally reported to cause hardware and/or software problems in the past."
    PRINT "Hit "; q$; "X"; q$; " if you wish to try and run it anyway: ";
    GOSUB KeyWait3: IF k$ <> "X" THEN GOTO Menu
  END IF
  CALL PastBlast2: GOTO Menu
END IF

GOSUB Pick
ON k GOTO Stories, IntroDone0, Reviews

Stories:
GOSUB Title
ON adv GOSUB Cave, Zyphur, Tomb, Abductor, Trezore
GOTO Menu

Reviews:
IF adv > 0 THEN
  COLOR 3: GOSUB Title1: PRINT : COLOR 2
  PRINT "Reviews have been written for both the Eamon Deluxe version of this adventure"
  PRINT "and the classic title from the original Apple II Eamon gaming system upon which"
  PRINT "it was based. Please select the version of the adventure that you wish to read"
  PRINT "the review for.": PRINT : PRINT
  c = 12: c1 = 4
  CALL EDXMenuM(c, c1, 9, 10, 3, 0)
  IF c1 = 3 THEN GOTO Menu
  IF c = 2 THEN GOTO DustyReviews
END IF
author$ = "reviewed by Luke Hewitt": Adventure$ = Adventure$ + " Deluxe Edition"
IF adv = 0 THEN Adventure$ = Adventure1$
a$ = "": IF adv < 9 THEN a$ = "0"
a1$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv)))
a$ = "": IF adv + 1 < 9 THEN a$ = "0"
a2$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv + 1)))
OPEN "EDX003RV.TXT" FOR INPUT AS #1
  DO
    LINE INPUT #1, a$
  LOOP UNTIL a$ = a1$
  COLOR 2: GOSUB Title1: COLOR 7
  DO
    LINE INPUT #1, a$
    IF a$ = "<paws>" THEN
      PRINT : COLOR 2: GOSUB KeyWait2: COLOR 2: GOSUB Title1: COLOR 7
      LOCATE CSRLIN - 1: a$ = ""
    END IF
    IF a$ <> a2$ THEN PRINT a$
  LOOP UNTIL a$ = a2$
  CLOSE : GOTO Menu
DustyReviews:
GOSUB Title
ON adv GOSUB Cave1, Zyphur1, Tomb1, Abductor1, Trezore1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Cave, Zyphur, Tomb, Abductor, Trezore
IntroDone:
a$ = "(Waking up the monsters...)"
PRINT a$: FOR x# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'                           The Cave of the Mind
'                          ----------------------
Cave:
CLS : LOCATE 10: COLOR 7
a$ = "The Cave of the Mind, original air date: January, 1980."
GOSUB Center: COLOR 8: LOCATE 23: GOSUB KeyWait2: CLS : LOCATE 7
COLOR 6: PRINT SPACE$(22); "Rebroadcast in colour: March, 1999.": : LOCATE 11
COLOR 4: PRINT SPACE$(22); "(Colourization by Eamon Deluxe 3.2)"
LOCATE 23: COLOR 8: GOSUB KeyWait2: CLS : LOCATE 7
COLOR 2: PRINT SPACE$(17); "Digitally remastered with ";
COLOR 15: PRINT "Eamon Deluxe 5.0": LOCATE 11
COLOR 10: PRINT SPACE$(21); "Satellite transmission: June, 2012"
LOCATE 23: COLOR 8: GOSUB KeyWait2: LOCATE 7: COLOR 2
'
PRINT "As you were leaving the Main Hall one evening, you encountered a short little"
PRINT "man who beckoned you to see what he was holding. It turned out to be a grail"
PRINT "which contained a bubbling green liquid."
PRINT
PRINT "In a strange low voice he said, "; : COLOR 10
PRINT q$; "Most adventures are for normal adventurers,"
PRINT "but you are special. Drink this and you will be transported to the most"
PRINT "challenging adventure you could imagine. DANGER! TREASURE! GLORY! Do you dare"
PRINT "try and conquer...The Cave of the Mind!?! Ha-ha-ha-ha!"; q$
LOCATE 20: GOSUB KeyWait: LOCATE 7: COLOR 2
PRINT "With a sly wink, he then hands you the grail. You study it for a moment, then"
PRINT "glance back at the little man...But he has vanished!"
PRINT
PRINT "Never being weak on courage, you raise the grail to your lips and quaff the"
PRINT "potion..."
LOCATE 20: GOSUB KeyWait: LOCATE 7: COLOR 2
PRINT "...And instantly wish you hadn't! Ackkk! The stuff tastes like green cough"
PRINT "syrup! Blechh! It isn't mixing well with the Double Dragon Blombs that you had"
PRINT "with dinner either!"
PRINT
PRINT "What a fool you were for believing that little wretch. "; q$; "Special Adventurer"; q$
PRINT "indeed! If you ever get your hands on... Wait, what's this? What's happening?"
LOCATE 20: GOSUB KeyWait: LOCATE 7: COLOR 2
IF s%(4) = 1 THEN
  COLOR 7: PRINT "[VI Mode note: A series of randomly colored text characters flood the screen"
  PRINT "here, attempting to add a psychedelic feeling as the intro text is ended.]"
  LOCATE 20: GOTO KeyWait
END IF
IF s%(4) <> 1 THEN
  FOR a = 1 TO 10
     FOR x = 1 TO 15
	COLOR 0, x: FOR xa = 1 TO 13: PRINT "x+x+x+"; : NEXT: COLOR 0, 0: PRINT
     NEXT
     COLOR 3, 0
   NEXT
END IF
LOCATE 20: GOTO KeyWait
Cave1:
s$ = "June 1995": GOSUB Review1: COLOR 7: PRINT
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 15-30 min."
PRINT "Reviewer Rating: 3.0    Average Rating: 3.2/7"
PRINT : COLOR 2
PRINT "Comment: This is definitely a beginner-level Eamon. It has much of the flavor"
PRINT "of the original Beginners Cave, with a little humor and simple map and such. "
PRINT "It is pretty small, with 31 rooms."
PRINT
PRINT "Strictly for beginners and Hack'n'Slash fans. The difficulty will ring in "
PRINT "at about (4) for beginners, and much lower for experienced characters with "
PRINT "good weapons."
LOCATE 20: GOTO KeyWait


'                     The Zyphur Riverventure
'                    -------------------------
Zyphur:
GOSUB Title: LOCATE 6: COLOR 15
PRINT "Greetings, "; name$; "!": COLOR 2
PRINT
PRINT "You have just been selected for a very large and important task. Three months"
PRINT "ago a very important scientist, Professor Axom, disappeared. It was recently"
PRINT "discovered that he was kidnapped by an evil villain known as the Black Warrior."
PRINT
PRINT "The Black Warrior is keeping the Professor in his stronghold, which is rumored"
PRINT "to be located in a series of caves somewhere off of the dangerous Zyphur River."
PRINT "The Black Warrior is forcing the Professor to use his knowledge to make weapons"
PRINT "of destruction which he will use to try and overthrow the Free Adventurer's"
PRINT "Guild."
LOCATE 20: GOSUB KeyWait: LOCATE 7: COLOR 2
PRINT "Aside from being morally bound to this task, the SPS (Society for the"
PRINT "Preservation of Scientists) will pay you a reward of 2,000 gold pieces and"
PRINT "provide you with a boat for your quest."
PRINT
PRINT "You must explore the dangerous river, find the Black Warrior's lair, free"
PRINT "Professor Axom and make it back to the Main Hall alive. Piece of cake, right?"
LOCATE 20: GOTO KeyWait
Zyphur1:
s$ = "June 1995": GOSUB Review1: COLOR 7: PRINT
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 20-60 min."
PRINT "Reviewer Rating: 5.0    Average Rating: 5.7/7"
PRINT : COLOR 2
PRINT "Comment: This adventure is a very good example of an early Eamon. The large and"
PRINT "somewhat complex map is well laid out, with competent room descriptions and it"
PRINT "has a boat that is interesting and unusual. "
PRINT
PRINT "Apart from the above, it's rather low in content by modern standards, with few"
PRINT "monsters and artifacts. But it's a clean quest and a relaxing play. If you"
PRINT "keep a careful map, you'll find the difficulty is certainly no more than (5)."
LOCATE 20: GOTO KeyWait


'                      The Devil's Tomb
'                     ------------------
Tomb:
GOSUB Title: LOCATE 6: COLOR 15
a$ = "NOW YOU'VE DONE IT!": GOSUB Center: COLOR 2
PRINT
PRINT "While lounging about at the Main Hall one day, you noticed an old book sitting"
PRINT "on the bar, apparently forgotten by someone."
PRINT
PRINT "You opened it curiously and started to read a tale describing a very dangerous"
PRINT "and challenging dungeon...In Hades! As soon as you began to grow interested, a"
PRINT "booming voice appeared from nowhere:"
LOCATE 20: GOSUB KeyWait: LOCATE 10: COLOR 14
PRINT "SO, YOU CONSIDER YOURSELF AN ADVENTURER? WANT A CHALLENGE? TRY MY DUNGEON!"
LOCATE 20: GOSUB KeyWait: LOCATE 7: COLOR 2
PRINT "The voice began to chuckle fiendishly and a hole appeared beneath you. You"
PRINT "found yourself falling down a dark narrow shaft!"
PRINT
PRINT "When you hit the bottom, you realized that you were locked in dungeon cell."
PRINT "Somewhere in the distance a voice says, "; : COLOR 14: PRINT q$; "GOOD LUCK, SUCKER!"; q$
LOCATE 20: GOTO KeyWait
Tomb1:
s$ = "August 1984": GOSUB Review2: LOCATE 7: COLOR 7
PRINT "Reviewed by Bob Davis"
PRINT
PRINT "Average Rating: 5.0/7": COLOR 2
PRINT
PRINT "Comment: Getting out of this one is the mission. Along the way you'll find"
PRINT "gambling with the devil, a few demons and gargoyles, and the magical book of"
PRINT "Trezore! One hint: The power spell can be very useful."
LOCATE 20: GOTO KeyWait


'                    The Abductor's Quarters
'                   -------------------------
Abductor:
GOSUB Title: COLOR 15: PRINT : PRINT name$; ", you are needed!": COLOR 2
PRINT
a$ = "A friend of yours, " + friend$ + ", is in trouble. After trying to retrieve some of"
a$ = a$ + " the many valuable treasures in a nearby dungeon, your friend mysteriously"
a$ = a$ + " disappeared.": GOSUB Lp0
PRINT
PRINT "After careful research, you discover that the dungeon your friend went to"
PRINT "is controlled by a renegade adventurer known only as the Abductor. You must"
PRINT "find your friend before the Abductor gets nasty and heads start to roll!"
PRINT : COLOR 10
PRINT "Good luck!"
LOCATE 20: GOTO KeyWait
Abductor1:
s$ = "August 1984": GOSUB Review2: COLOR 7: LOCATE 7
PRINT "Reviewed by Bob Davis"
PRINT
PRINT "Average Rating: 4.7/3": COLOR 2
PRINT
PRINT "Comment: A friend of yours (who is a fellow adventurer, of course) has been"
PRINT "captured and is being held in a nearby network of caverns. You must enter these"
PRINT "caverns and rescue your friend before the Abductor executes him/her."
LOCATE 20: GOTO KeyWait


'                     The Quest for Trezore
'                   -------------------------
Trezore:
GOSUB Title: : PRINT : COLOR 15
a$ = "YOU ARE ABOUT TO FACE YOUR MOST TRYING TASK! ": GOSUB Center: COLOR 2
PRINT
PRINT "A powerful and evil wizard has captured several friends of yours. You cannot"
PRINT "fight this wizard, but another wizard could. You must therefore set off to find"
PRINT "Trezore, the powerful and great wizard whose spells have helped (or is it"
PRINT "plagued?) you before."
PRINT
PRINT "However, Trezore does not like just anyone to barge in on him, nor does he"
PRINT "perform favors for complete strangers. He has set up a test to find out if"
PRINT "adventurers like yourself are worthy of his attention."
PRINT
PRINT "You will undertake many tasks, but this is probably the most difficult. Good"
PRINT "luck to you."
LOCATE 21: GOTO KeyWait
Trezore1:
s$ = "August 1984": GOSUB Review2: COLOR 7: LOCATE 7
PRINT "Reviewed by Bob Davis"
PRINT
PRINT "Average Rating: 6.2/4": COLOR 2
PRINT
PRINT "Comment: You are searching for the wizard, Trezore, and come across a bronze"
PRINT "door with three small holes in it. You know it must be opened somehow. The"
PRINT "search for the key(s) is tough and dangerous, as you will encounter varied and"
PRINT "pugnacious beasts & beings."
LOCATE 20: GOTO KeyWait


'                  EAG Review Header
'                 -------------------
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter. The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe. The review is for the old Apple II version."
Review1a:
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it. e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
GOTO KeyWait
'                  NEUC Review Header
'                 --------------------
Review2:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the "; : COLOR 7
PRINT "National Eamon User's Club": COLOR 3
PRINT "newsletter which preceded the Eamon Adventurer's Guild. The ratings are from"
PRINT "the EAG. The NEUC supported the Apple II version of Eamon and not Eamon Deluxe."
PRINT "The review is for the old Apple II version.": GOTO Review1a


'                  Select adventure
'                 ------------------
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv): RETURN

KeyWait:
COLOR 3
KeyWait1:
PRINT : PRINT
KeyWait2:
PRINT "Press any key to continue...";
KeyWait3:
k$ = INKEY$: BS = POS(0): CC# = 0
DO
   IF s%(4) <> 1 THEN
     CC# = CC# + 1
     IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, BS
     IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
     IF CC# = CC3# THEN : PRINT "\": LOCATE CSRLIN - 1, BS: CC# = 0
   END IF
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

Title:
COLOR 3
Title1:
CLS : a$ = Adventure$: GOSUB Center: a$ = author$:
GOSUB Center: PRINT STRING$(80, 196): PRINT : RETURN

Center:
PRINT SPACE$(INT((80 - LEN(a$)) / 2)); a$: RETURN

' Print a$ without wrap-around
Lp0:
xm = 0: a$ = LTRIM$(a$)
IF LEN(a$) <= 79 THEN PRINT a$: RETURN
FOR k = 79 TO 1 STEP -1
   IF MID$(a$, k, 1) = " " THEN
     PRINT LEFT$(a$, k - 1): a$ = RIGHT$(a$, LEN(a$) - k): k = 1: xm = 1
   END IF
NEXT: IF xm = 1 THEN GOTO Lp0

'              AD Menu Header 5.0
'             --------------------
Header:
mc1 = 1: mc2 = 15: mc3 = 7: COLOR 7: CLS
IF s%(4) = 1 THEN RETURN
COLOR mc1, 0: PRINT " "; STRING$(76, ""); ""
'PRINT " "; SPACE$(76); ""
PRINT " "; SPACE$(20); : COLOR mc2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR mc1: PRINT SPACE$(20); "": PRINT " "; SPACE$(24); : COLOR mc2
PRINT "The Jim Jacobson Adventures"; : COLOR mc1: PRINT SPACE$(25); ""
PRINT " "; STRING$(76, ""); "": PRINT : COLOR 7: RETURN

' Set flag when visitors file is not in directory
VisitorFileIOError:
ProgErr1 = 1: RESUME VisitorFileIOError1

'                       -----------
'                        Error Pit
'                       -----------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; STR$(ERR); ")": PRINT
k$ = "try and continue": IF ERR > 51 THEN k$ = "exit to Main Menu"
PRINT SPACE$(20); "Hit any key to "; k$; "...": k$ = INKEY$: k$ = ""
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : L = 0: COLOR 7: RESUME NEXT

AdventureData:
DATA 5
DATA The Cave of the Mind,"Red Varnum, Jim Jacobson, & Frank Black",CAVEMIND
DATA The Zypur Riverventure,"Jim Jacobson & Frank Black",ZYPHUR
DATA The Devil's Tomb,"Jim Jacobson & Frank Black",TOMB
DATA The Abductor's Quarters,"Jim Jacobson & Frank Black",ABDUCTOR
DATA The Quest for Trezore,"Jim Jacobson & Frank Black",TREZORE

EDXMenuStrings:
DATA 10
DATA "  Preview Adventure Intros          "
DATA "  START PLAYING AN ADVENTURE        "
DATA "  Read Adventure Reviews            "
DATA "  Read Review for This Collection   "
DATA "  View a Blast from the Past        "
DATA "  View Visitor Records              "
DATA "  Read Notes About This Collection  "
DATA "  Return to Eamon Deluxe Menu    "
DATA "  Review of the Eamon Deluxe Version   "
DATA "  Review of the Classic Eamon Version  "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
' (Updated for VI Mode support 06 JAN 2012)
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

' VI Mode numeric menu
GetMAdvCVI:
IF s%(4) = 1 THEN
  CLS : L = 2: PRINT "Please select an adventure:"
  FOR c = 1 TO dungeons
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + dn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to Exit):";
  LINE INPUT ""; a$: c = INT(VAL(a$))
  IF c < 0 OR c > dungeons THEN CLS : GOTO GetMAdvCVI
  'IF c = 0 THEN RUN 0
  a$ = dn$(c): EXIT SUB
END IF


' Standard Menu
'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(13) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>                     <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
' (Updated with alt. numeric menu for VI Mode support 06 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:
'    s%() - Eamon DX system settings (s%(4) = 1 is VI Mode Flag)
'   em$() - An array which holds all available choices. em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'

' VI Mode numeric menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  L = 2
  FOR x = be TO en
     x$ = LTRIM$(STR$(x - be + 1)) + ": " + LTRIM$(RTRIM$(em$(x)))
     IF x < 100 THEN x$ = " " + x$: IF x < 10 THEN x$ = " " + x$
     PRINT x$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       CLS : L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to exit):";
  LINE INPUT ""; k$: c = INT(VAL(k$)): c1 = c + (be - 1)
  IF c = 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB PastBlast2
' VI Mode support added 15 JUN 2012
x1 = 2: x2 = 0: x3 = 0: x4 = 2: IF s%(4) = 1 THEN x1 = 7: x3 = 15: x4 = 0
'  Take me back...
CLS : WIDTH 40: COLOR x1, x2
PRINT "  THE WONDERFUL WORLD OF EAMON DELUXE"
PRINT STRING$(40, "-"): PRINT SPACE$(13) + "BY FRANK BLACK": LOCATE 6
PRINT SPACE$(14) + "ADVENTURE #3": PRINT : COLOR x3, x4
PRINT STRING$(40, "*") + "*" + SPACE$(38) + "*";
PRINT "*" + SPACE$(6) + "THE JIM JACOBSON ADVENTURES" + SPACE$(5) + "*";
PRINT "*"; SPACE$(38); "*"; : PRINT STRING$(40, "*"): COLOR x1, x2: PRINT
PRINT SPACE$(12) + "BY JIM JACOBSON": PRINT : PRINT
PRINT "TO GO ON THESE ADVENTURES YOU MUST FIRST"
PRINT SPACE$(5) + "MAKE SURE YOUR SPEAR IS SHARP": PRINT : PRINT
PRINT " NON COMMERCIAL DISTRIBUTION ENCOURAGED": PRINT : PRINT
PRINT "] "; : FOR x# = 1 TO dly# * 10: NEXT
'
PRINT "Press any key to continue...";
k$ = INKEY$: BS = POS(0): CC# = 0
DO
   IF s%(4) <> 1 THEN
     CC# = CC# + 1
     IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
     IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
     IF CC# = CC3# THEN : PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   END IF
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""
CLS : WIDTH 80: COLOR 3
END SUB

