' THE MARVELOUS WORLD OF EAMON DELUXE v3.2 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                 MULTI-ADVENTURE INTRO PROGRAM                  
'                                                                
' The Frank Black Adventures               Revision: 21 MAY 2001 
'                                            Update: 01 FEB 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB IntroPic ()

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

'    Variables to load & hold picture data
DIM SHARED pic%(1 TO 3460)
TYPE pictype
   s AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR X = 1 TO 10: INPUT #1, s%(X): NEXT
CLOSE

OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): sex = z.sex: q$ = CHR$(34): l$ = STRING$(80, 196)

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), adv, adv1, adv2
adv2 = a
FOR a = 1 TO adv2: READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a): NEXT

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR X = 1 TO em0: READ em$(X): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)

DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT: CLOSE
END IF

OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "by Frank Black": adventure1$ = "The Frank Black Adventures Deluxe"
author$ = author1$: Adventure$ = adventure1$

'     Make sure graphic mode is available
ON ERROR GOTO ScreenError
IF s%(4) <> 1 THEN SCREEN 7

Start:
ON ERROR GOTO 0
SCREEN 0: WIDTH 80: COLOR 3: GOSUB Title

IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file. File is being restored and you are being"
  PRINT "returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5: PRINT #1, "(none)": NEXT: CLOSE
  GOSUB Offend  '<----  Adventure in Interzone settings
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; Adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Interzone, Fiends, Heart, Edgar
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
IF ScreenErr = 0 AND s%(4) <> 1 THEN CALL IntroPic
GOSUB Title: a$ = "This is Official Eamon Deluxe Adventure #7": COLOR 2
PRINT : GOSUB Center: COLOR 3: LOCATE 22: GOSUB KeyWait

Menu:
author$ = author1$: Adventure$ = adventure1$: GOSUB Title
COLOR 2
PRINT a$(1); : LOCATE CSRLIN, 40: PRINT a$(3)
PRINT a$(2); : LOCATE CSRLIN, 40: PRINT a$(4)
PRINT : COLOR 3: k = 10: c1 = 4
CALL EDXMenuM(k, c1, 1, 5, 3, 0)
IF k < 1 OR k > 5 THEN GOTO Menu
IF k = 4 THEN RUN "GDEDIT"
IF k = 5 THEN CHDIR "..": RUN "EAMONDX"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Interzone, Fiends, Heart, Edgar
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Interzone1, Fiends1, Heart1, Edgar1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Interzone, Fiends, Heart, Edgar
IntroDone:
PRINT "(Waking up the monsters...)": FOR X# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'                     Adventure in Interzone
'                     ----------------------
Interzone:
PRINT "It all started with a dragon.  Hokas Tokas, the resident wizard of the Main"
PRINT "Hall, received news of a distant land which was being terrorized by a dragon."
PRINT "What really caught his interest was the large bounty offered by the king."
PRINT
PRINT "     He set out almost immediately to destroy this creature and claim the small"
PRINT "fortune.  Months passed and still no word came from him.  After nearly a year,"
PRINT "the burly Irishman sadly erased Hokas' name from his book and he was pronounced"
PRINT "dead."
PRINT
PRINT "     Several adventurers were sent to clear Hokas' room of its belongings.  You"
PRINT "happened to be among that group.  Unfortunately, somebody brought along a barrel"
PRINT "of Grog & Gello's famous wine and you ended up drinking way too much."
PRINT : PRINT : GOSUB KeyWait
PRINT "     Well, you were feeling pretty good despite of everything when you happened"
PRINT "to come across a plain wooden chest with an inscription reading, "; q$; "KEEP OUT!"
PRINT "(THIS MEANS YOU!)"; q$
PRINT
PRINT "     SMASH!!  You ripped it open and found an assortment of strange bottles."
PRINT q$; "Hmm...  Looks like imported beer."; q$; " you decided.  And, yes, you drank them all."
PRINT "Well, they tasted pretty darned good as a matter-of-fact and you left that"
PRINT "night feeling just great."
PRINT
PRINT "     When you finally awoke then next day, you noticed that you were growing a"
PRINT "little red tail!  You quickly concealed it, but it kept getting longer each day."
PRINT "By the next week, you had a full-length tail along with a set of horns and"
PRINT "hoofed feet to match.  You became the laughing stock of the Main Hall."
PRINT : PRINT : GOSUB KeyWait
PRINT "     You found a decent witch doctor who restored your form (after sending you"
PRINT "on a series of awful quests for the stupidest objects) and you returned to the"
PRINT "Main Hall much more humble than you were before."
PRINT
PRINT "     To add insult to injury, you discovered that Hokas had returned while you"
PRINT "were away.  He was upset and grumbling that, "; q$; "A damn volcano had erupted beneath"
PRINT "the dragon before he had gotten there."; q$
PRINT
PRINT "     Your friends told you that when Hokas had discovered what you had done with"
PRINT "his best potions, he was furious!  After he heard what had happened to you, he"
PRINT "had started laughing hysterically."
PRINT : PRINT : GOSUB KeyWait
PRINT "     When you returned, you sheepishly avoided him for days.  Finally he"
PRINT "cornered you and informed you that, in his initial anger, he had placed a curse"
PRINT "on you and he wasn't sure what had become of it.  You found out later that night"
PRINT "when your body began fading away.  You begged him to lift the curse but he only"
PRINT "shrugged and said, "; q$; "You dug your grave, now lie in it!"; q$
PRINT
PRINT "     "; q$; "But what will happen to me?"; q$; " you implored of him, "; q$; "Am I drifting to"
PRINT "another plane of existence?"; q$
PRINT
PRINT "     "; q$; "I can't remember where it was I was going to send you when I placed the"
PRINT "curse,"; q$; " Hokas replied, "; q$; "Just that it was a place where escape was impossible and"
PRINT "you would learn a lesson.  Perhaps a permanent one!"; q$
PRINT
PRINT "     You never heard his reply, however, because your mind suddenly filled with"
PRINT "whispering voices and a dark cloud enveloped you..."
PRINT : PRINT : GOSUB KeyWait
PRINT "Author's notes:": PRINT
PRINT "Adventure in Interzone was the first Eamon adventure that I ever wrote.  I"
PRINT "originally wrote it in 1994 for the Apple II Eamon.  When I converted it to"
PRINT "Eamon Deluxe, I threw in a few new features and options.  For those of you who"
PRINT "might have played my original version, the map is the same as it was before and"
PRINT "the puzzles still have the same solutions.  However, one new puzzle has been"
PRINT "thrown in and most of the old puzzles now have multiple solutions.  Other"
PRINT "changes will become evident during play."
PRINT
PRINT "To those of you who wish to dissect the base dungeon program, I have included"
PRINT "a routine which will print out a list of all the special variables to a printer."
PRINT "on LPT1."
PRINT
PRINT "Do you wish to do this"; : GOSUB GetKey
IF k$ = "y" THEN GOSUB VarPrint
PRINT : PRINT : GOTO KeyWait
'        ----------------------
'         Don't offend anybody
'        ----------------------
Offend:
PRINT "Before we begin...": PRINT
PRINT "An associate of mine in the Eamon business once told me that a couple of the"
PRINT "monsters in Interzone which I had included as mere satire might actually be"
PRINT "offensive to some people."
PRINT
PRINT "It is not my intention to offend anybody so I have included some alternatives"
PRINT "in the Eamon Deluxe version.  Please answer the following 'yes' or 'no'"
PRINT "questions and the game will be set to your preferences."
PRINT
GOSUB KeyWait
PRINT "Would you be offended if...": PRINT
PRINT "I made fun of politicians and/or world leaders"; : GOSUB GetKey
IF k$ = "y" THEN of%(1) = 1
PRINT "I made fun of Amway salesmen"; : GOSUB GetKey
IF k$ = "y" THEN of%(2) = 1
PRINT "I made fun of people who copy protect floppy disks"; : GOSUB GetKey
IF k$ = "y" THEN of%(3) = 1
PRINT "I made fun of people who write TV sitcoms and commercials"; : GOSUB GetKey
IF k$ = "y" THEN of%(4) = 1
PRINT "You had to drink alcohol to complete the game"; : GOSUB GetKey
IF k$ = "y" THEN of%(5) = 1
PRINT "Saving settings...": FOR X# = 1 TO dly# * 2: NEXT
OPEN "OFFEND.DAT" FOR OUTPUT AS #2: CLOSE : KILL "OFFEND.DAT"
OPEN "OFFEND.DAT" FOR OUTPUT AS #2
FOR X = 1 TO 5: PRINT #2, of%(X): NEXT
CLOSE : RETURN
'
'     Subroutine which prints out Interzone variable list
'    -----------------------------------------------------
VarPrint:
ON ERROR GOTO VPError
LPRINT "Adventure in Interzone variables:"
LPRINT
LPRINT "d%(1)......Program Control Room counter"
LPRINT "d%(2)......Customs Official requests weapons flag"
LPRINT "d%(3)......Drunks in tavern flag & counter"
LPRINT "d%(4)......Waitress flag & counter"
LPRINT "d%(5)......A.J. talks in store room flag"
LPRINT "d%(6)......Eaten by grue counter"
LPRINT "d%(7)......A.J. talks after you get drunk flag"
LPRINT "d%(8)......Pointer to monster # of thugs (41 or 49)"
LPRINT "d%(9)......Get busted for A.J.'s death flag & counter"
LPRINT "d%(10).....Thugs appear flag & counter (appear at 80, attack at 82)"
LPRINT "d%(11-19)..Pointers to rooms with signs in them"
LPRINT "d%(21-29)..Pointers to effect # of sign (corresponds to 11-19)"
LPRINT "d%(30).....Elven king rewards you flag"
LPRINT "d%(31).....Got drunk? flag (set to 1 if you select 'no alcohol')"
LPRINT "d%(32).....Pay Bob for pawned items flag"
LPRINT "d%(33).....A.J. talks in cafe flag"
LPRINT "d%(34).....A.J. talks in tavern flag"
LPRINT "d%(35).....A.J. suggests Power spell on streets of Freeland flag"
LPRINT "d%(36).....You should Heal A.J. flag (reset on moves to a new room)"
LPRINT "d%(37).....A.J.'s random comments counter (he speaks at 8 and its reset)"
LPRINT "d%(38).....A.J.'s random comments, # of comment (in 40-50) to print"
LPRINT "d%(39).....A.J. talks in hotel room flag"
LPRINT "d%(40-50)..A.J.'s random comments effects # pointers  "
LPRINT "d%(51).....A.J. suggests Power spell in Benway's room"
LPRINT "d%(52).....Bribe tunnel guard flag"
LPRINT
LPRINT "Monster User field #14: Follow codes (1=never follows, 0 is normal)"
LPRINT "Monster User field #15: Effect # of monster's death text (if any)"
LPRINT
LPRINT "om$ & ow$(x): Names of player and weapons/armor before Land of the Dead"
LPRINT "gold1: Players gold before they got drunk (value of idol)"
LPRINT "loan: Amount owed by player at end of game if they needed a loan at the start"
'
PRINT "Done!"
VarPrint1:
ON ERROR GOTO 0
RETURN
'
VPError:
CLS : PRINT "Print error.  Printing canceled."
RESUME VarPrint1:
Interzone1:
s$ = "June 1994": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 1-2 hr.": PRINT "Reviewer Rating: 8.0"
PRINT
PRINT "Comment:  Let me lead this off by saying that the above rating may well be on"
PRINT "the low side.  I downrated it for some details that didn't hit me just right; if"
PRINT "these same details catch your fancy, you are liable to rate it a good bit higher"
PRINT "than I did."
PRINT
PRINT "Frank has crafted one of the most sophisticated Eamons ever done.  The player"
PRINT "interface is virtually flawless, with careful attention to every detail."
PRINT
PRINT "Though the map is only 54 rooms, there are 90-odd Effects, and the play is"
PRINT "jammed with special events and plot developments.  Frank has provided against"
PRINT "all kinds of ways that you might find to go astray; as I read through the"
PRINT : PRINT : GOSUB KeyWait
PRINT "Effects after completing play, I was amazed to see some of the things he had"
PRINT "planned for.  In short, here is an Eamon in which the author worked hard to make"
PRINT "as perfect as he could, and it shows."
PRINT
PRINT "The play is a Puzzler's delight.  The puzzles are subtle and require careful"
PRINT "reading and thought, often being presented as plot developments that require"
PRINT "interaction with other characters to solve.  Though there is very little combat"
PRINT "for the Hack'n'Slasher in most of the map, there is a ton of combat to wade"
PRINT "through at one point."
PRINT
PRINT "You are liable to get killed out several times before you solve the first major"
PRINT "puzzle, which is to survive an assault by a gang of thugs.  Let's just say that"
PRINT "you will need some help.  Spell ability gets a workout in several places.  And"
PRINT "don't forget the fine art of bribery!"
PRINT
PRINT "I peg the overall difficulty at (8), due mainly to a couple of potentially"
PRINT "deadly puzzles.  But even if you're not a puzzler, don't miss this one."
PRINT : PRINT : GOTO KeyWait

'                         Fiends of Eamon
'                         ---------------
Fiends:
a$ = "The end of Eamon is near and it's all your fault!": COLOR 2
GOSUB Center: COLOR 3: PRINT
PRINT "Several years ago, you found yourself hurled into a strange land.  You were"
PRINT "informed by the denizens of that land they could send you back if you did them a"
PRINT "service.  (See The Donald Brown Adventures -- Assault on the Clone Master.)"
PRINT
PRINT "     The service that they charged you with was the assassination of their"
PRINT "dreaded enemy, the Clone Master.  And so you barged into his lab, slew his"
PRINT "guards, and destroyed his equipment, ending his reign of terror.  Or so you"
PRINT "thought."
PRINT : PRINT : GOSUB KeyWait
PRINT "     It seems that, when the Clone Master discovered his fortress had been"
PRINT "breached, he created a clone of himself and sent it out to meet you.  He himself"
PRINT "went into hiding."
PRINT
PRINT "     When you were returned home through a dimensional fault line, the Clone"
PRINT "Master followed you.  Seeking revenge, he quickly set up a new lab and continued"
PRINT "his experiments in the land of Eamon!  He has recently engaged the services of"
PRINT "the infamous Doctor Benway of Interzone and rebuilt his evil cloning machine,"
PRINT "the Clonatorium."
PRINT
PRINT "     Soon his Clonatorium will be perfected and he has threatened to unleash his"
PRINT "wrath upon us with an unstoppable army of clones!  The Free Adventurer's Guild"
PRINT "has talked it over and decided that, since you were the reason he came here, you"
PRINT "must be the one to stop him."
PRINT : PRINT : GOSUB KeyWait
PRINT "     His lab is nestled within the caves of a lonely island.  A constant vicious"
PRINT "storm surrounds the island making travel there very difficult."
PRINT
a$ = "                   ...And so your quest begins...                  "
FOR a = 1 TO LEN(a$)
   PRINT MID$(a$, a, 1);
   FOR X# = 1 TO dly# / 4: NEXT
NEXT
PRINT : PRINT : GOSUB KeyWait
PRINT "You sailed for several days before you reached the island.  Caught up in the"
PRINT "violent storms, your ship crashed upon the rocky shore.  Thrashing and gasping,"
PRINT "you managed to find the shelter of a cave entrance...The entrance to the Clone"
PRINT "Master's lair!"
PRINT : PRINT : GOTO KeyWait
Fiends1:
s$ = "March 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT : PRINT "Playing Time: 1-2 hours": PRINT "Reviewer Rating: 8.0"
PRINT
PRINT "Comment: This Eamon is extremely well-crafted.  While there is little that you"
PRINT "can point to that says, "; q$; "this is special"; q$; ", it is all special in little ways that"
PRINT "add much to the gaming experience."
PRINT
PRINT "Frank had fun using bad guys from other Eamons, and you'll enjoy seeing the"
PRINT "familiar faces.  He also adds individual touches to many of them that keeps your"
PRINT "interest up.  It's very funny!"
PRINT
PRINT "This is primarily a Hack'n'Slasher's Eamon, with tons of combat, but there are"
PRINT "so many variations and clever touches during combat that even a combat-hater"
PRINT "like myself had a good time."
PRINT : PRINT : GOSUB KeyWait
PRINT "There are a few secret passages to be discovered, and you must figure out how to"
PRINT "enable the teleport machines, but these puzzles aren't bad.  I give it an"
PRINT "overall (6) for difficulty."
PRINT : PRINT : GOTO KeyWait

'                           Heart of Gold
'                           -------------
Heart:
PRINT "Several years ago, a stranger named Ford Prefect appeared at the Main Hall.  He"
PRINT "employed himself as an actor and you became friends with him.  He seemed like a"
PRINT "good chap--if a bit odd.  He was known to be found staring at the sky for long"
PRINT "periods of time, claiming to be looking for "; q$; "flying saucers"; q$; "."
PRINT
PRINT "     This was always taken as a joke and he would laugh with everyone at it,"
PRINT "then order a round of double dragon blombs."
PRINT
PRINT "     Then one day an enormous green shape appeared in the sky.  A voice boomed"
PRINT "out of it, saying that the planet Eamon was in the way of a new 'hyperspace"
PRINT "bypass' and would promptly be destroyed.  Panic broke out and a mob of brave"
PRINT "adventurers ran out to challenge the green monstrosity."
PRINT : PRINT : GOSUB KeyWait
PRINT "     Ford suddenly pulled you aside.  "; q$; "Another ship has appeared!"; q$; " he said"
PRINT "excitedly, "; q$; "I'm trying to hitch a ride--But don't worry, I'll bring you with"
PRINT "me."; q$; "  You, of course, have absolutely no idea what he's talking about and"
PRINT "figure he's just having a nervous breakdown."
PRINT
PRINT "     "; q$; "I've succeeded!"; q$; " he suddenly yells with joy, "; q$; "Prepare to be"
PRINT "teleported..."; q$
PRINT
PRINT "     You feel a gut-wrenching sensation and pass out.  Somewhere off in the"
PRINT "distance, you are aware of the world of Eamon being completely destroyed!"
PRINT : PRINT : GOSUB KeyWait
PRINT "Author's note:": PRINT
PRINT "The Hitchhiker's Guide to the Galaxy artifact works with routines that are"
PRINT "identical to the help/hints routine.  I have included the Guide Editor for"
PRINT "anybody who wants to list the Guide entries or use these routines in their own"
PRINT "adventures."
PRINT : PRINT : GOTO KeyWait
Heart1:
s$ = "June 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 2-3 hours and up"
PRINT "Reviewer Rating: 6.5"
PRINT
PRINT "Comment: If you don't recognize the above, this Eamon is based on Douglas Adams'"
PRINT q$; "Hitchhiker's Guide to the Galaxy"; q$; " books.  Frank set out to purposely write a"
PRINT "very difficult Eamon that is very much like an Infocom game.  In other words, it"
PRINT "has no combat and a series of small puzzles that must be done precisely in order"
PRINT "and on a tight timeline."
PRINT
PRINT "Because the puzzles must be done in order and on time, there are many, many ways"
PRINT "to get killed out, and you will almost certainly start over at least a dozen"
PRINT "times before winning through to the end.  In fact, the only thing that makes it"
PRINT "solvable with only a dozen or so restarts is the detailed hints available via"
PRINT "the HINTS command.  Without this command, the adventure would be nearly"
PRINT "unsolvable for the vast majority of players.  Even when using HINTS, the"
PRINT "difficulty falls near (8)."
PRINT : PRINT : GOSUB KeyWait
PRINT "This Eamon only has about 15 rooms, making maps unnecessary, but takes a couple"
PRINT "of hours to play even if you cheat and use the hints, which should give you a"
PRINT "good idea of the number and difficulty of puzzles."
PRINT
PRINT "This is a technical masterpiece, which is only what we have come to expect from"
PRINT "Frank.  It gets its lukewarm rating for two reasons: because I got tired of"
PRINT "starting over, and because I felt somewhat deflated because I had to use the"
PRINT "hints at every turn to lower the difficulty to something I could handle."
PRINT
PRINT "One hint: don't SAVE too often. It's better to have to repeat a dozen or two"
PRINT "actions than to discover that you have saved an unwinnable game."
PRINT
PRINT "Highly recommended for serious puzzle junkies, who may wish to try to solve it"
PRINT "without use of the hints."
PRINT : PRINT : GOTO KeyWait

'                       Edgar's Adventures
'                       ------------------
Edgar:
IF s%(4) = 1 THEN GOTO Edgar0
CLS : a2$ = "": FOR a = 1 TO 79: a2$ = a2$ + " ": NEXT
a$ = a2$: GOSUB Center1
a$ = LEFT$(a2$, 30) + "EDGAR'S ADVENTURES" + LEFT$(a2$, 31): GOSUB Center1
a$ = a2$: GOSUB Center1: PRINT : PRINT
PRINT
FOR a = 2 TO 29
  LOCATE CSRLIN, a - 1
  PRINT " ";
  LOCATE CSRLIN, a
  PRINT "+ B   r n   l c   +    ";
  LOCATE CSRLIN, 53 - a
  SOUND 37, 1
  PRINT "   y  F a k B a k      ";
NEXT
LOCATE CSRLIN, 27
PRINT "  + By Frank Black +     "
PRINT : PRINT : GOSUB KeyWait
Edgar0:
GOSUB Title
PRINT "You are about to play a few days in the life of Edgar E. Blevins.  One night, as"
PRINT "Edgar was walking home from his job at a local 7-11, he was suddenly surrounded"
PRINT "by a strange blue light and a thick green steam.  When it all cleared, Edgar was"
PRINT "gone!"
PRINT
PRINT "     Edgar wakes up and finds himself aboard an alien spaceship.  He also sees"
PRINT "that several aliens with blue skin are preparing to dissect him!"
PRINT : PRINT : GOSUB KeyWait
PRINT "     Your initial goal in Edgar's Adventures will be to defeat the aliens and"
PRINT "escape the spaceship.  What happens after that, you'll have to find out for"
PRINT "yourself."
PRINT : PRINT : GOTO KeyWait
Edgar1:
s$ = "January 2001": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Reviewer Rating: 9.0"
PRINT
PRINT "Frank is undoubtedly one of the top three programmers to ever write an Eamon"
PRINT "adventure. This Eamon is extremely well crafted, with a flawless, sophisticated"
PRINT "user interface and quite an ongoing plot line. Edgar did indeed have some"
PRINT "interesting adventures!"
PRINT
PRINT "I did not need to bother with a map or even much in the way of notes. But it was"
PRINT "a very interesting, mildly challenging play from start to end. I give it a (7)"
PRINT "for difficulty."
PRINT
PRINT "Edgar is a real treat to play. Be sure to check it out!"
PRINT : PRINT : GOTO KeyWait

'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version."
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN
'
'        Get a 'y' or 'n' keypress
'       ---------------------------
GetKey:
xcheck = 1
PRINT "? (Y/N): ";
GetKey1:
f = 1: GOSUB KeyWait1: IF k$ <> "y" AND k$ <> "n" THEN GOTO GetKey1
PRINT UCASE$(k$): PRINT : xcheck = 0: RETURN
'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$: BS = POS(0): CC# = 0
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = LCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: GOTO Title
END IF
' Standard rtn
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = LCASE$(INKEY$)
LOOP UNTIL k$ <> ""
IF f = 1 THEN f = 0: RETURN
'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = Adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN

' Center a string on 80-column screen
'
Center:
PRINT SPC((79 - LEN(a$)) / 2); a$: RETURN


' Fancy-schmancy string printing
'
Center1:
COLOR 0, 2
FOR a = 1 TO LEN(a$)
   PRINT MID$(a$, a, 1);
   'IF MID$(a$, a, 1) = " " AND a / 2 = INT(a / 2) THEN SOUND 37, 1
   'IF MID$(a$, a, 1) <> " " THEN SOUND 37, 1
   FOR X# = 1 TO dly# / 10: NEXT
NEXT
COLOR 3, 0: PRINT : RETURN

' Can't initialize graphics screen
ScreenError:
SCREEN 0: WIDTH 80: CLS : ScreenErr = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the intro picture for this adventure, because it requires"
PRINT "an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME Start

'
' Adventure data
'
AdventureData:
DATA 4
DATA Adventure in Interzone,Frank Black,INTRZONE
DATA Fiends of Eamon,Frank Black,FIENDS
DATA The Heart of Gold,Frank Black,HEART
DATA Edgar's Adventures,Frank Black,EDGAR

EDXMenuStrings:
DATA 5
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Run the Hitchhiker's Guide Editor "
DATA " 5. Quit "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
' (Updated for VI Mode support 06 JAN 2012)
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

' VI Mode numeric menu
GetMAdvCVI:
IF s%(4) = 1 THEN
  CLS : l = 2: PRINT "Please select an adventure:"
  FOR c = 1 TO dungeons
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + dn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: l = l + 1
     IF l = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; a$
  c = INT(VAL(a$))
  IF c < 0 OR c > dungeons THEN CLS : GOTO GetMAdvCVI
  IF c = 0 THEN CLOSE : RUN
  a$ = dn$(c): EXIT SUB
END IF

' Standard Menu
'            Load adventure names
REDIM advn$(dungeons)
FOR X = 1 TO dungeons
   advn$(X) = LEFT$(LTRIM$(RTRIM$(dn$(X))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
X = ABS(c > be + 20): v = 3 + (c - be) - 21 * X: h = 2 + 39 * X
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): X = 52 - ABS(k > 9)
    LOCATE 25, X: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, X
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR X = be TO en
   LOCATE v, h: PRINT advn$(X); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
' (Updated with VI Mode alternate numeric menu: 09 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
' VI Mode Numeric Menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  l = 0
  FOR X = be TO en
     PRINT em$(X): l = l + 1
     IF l = 22 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; k$
  c = INT(VAL(k$)):  c1 = c + (be - 1)
  IF c = 0 THEN c = be: c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR X = be TO en: LOCATE v, h: PRINT em$(X); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB IntroPic
'    Intro picture loader and uncompressor
'   ---------------------------------------
SCREEN 7
OPEN "EDX7-NEW.PIC" FOR RANDOM AS #1 LEN = 6920
    GET #1, 1, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 0), pic%, PSET: a$ = ""
    GET #1, 2, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 0), pic%, PSET: a$ = ""
    GET #1, 3, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 96), pic%, PSET: a$ = ""
    GET #1, 4, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 96), pic%, PSET
CLOSE

'  Resume text mode and exit
'
LOCATE 23, 5: PRINT "(Hit any key to continue)";
a$ = INKEY$:
DO
LOOP UNTIL INKEY$ <> ""
SCREEN 0: WIDTH 80: CLS : COLOR 3
END SUB

