' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                MULTI-ADVENTURE INTRO PROGRAM 5.0               
'         DUMMY (SPACE HOLDER) ADVENTURE INTRO PROGRAM           
'                                                                
' The Sam Ruby Adventures                  Revision: 12 JUN 2012 
' Eamon Deluxe conversion by Frank Black     Update: 12 JUN 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB Pic.Loader (a$)

DIM SHARED adventure$, author$, q$, sex
ON ERROR GOTO ErrHandler

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM SHARED Z AS RECORD

'    Variables to load & hold picture data
DIM SHARED Pic%(1 TO 3460)
TYPE pictype
   ps AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

' Load system settings
DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

' Remove highlighted text in VI Mode
x1 = 0: x2 = 2: IF s%(4) = 1 THEN x1 = 2: x2 = 0

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), adv, adv1, adv2, ANAME$, dungeons
adv2 = a
OPEN "NAME.DAT" FOR INPUT AS #1
    INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
    IF dungeons > 1 THEN
      DIM SHARED dn$(dungeons), dn%(dungeons, 9)
      FOR a = 1 TO dungeons
	 LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
      NEXT
    END IF
CLOSE

' Load multi-adventure names
'----------------------------
FOR a = 1 TO adv2: READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a): NEXT

' Init choices for EDXMenuM
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27) '(Enter, Space, Escape)
'  Load useful character data
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, Z: CLOSE
name$ = LTRIM$(RTRIM$(Z.CNAME$)): sex = Z.sex: q$ = CHR$(34)
author1$ = "Converted to Eamon Deluxe by Frank Black": author$ = author1$
Adventure1$ = "The Sam Ruby Adventures": adventure$ = Adventure1$

' See if graphic mode is available
'----------------------------------
ON ERROR GOTO ScreenError: IF s%(4) <> 1 THEN SCREEN 7
SkreenTest:
ON ERROR GOTO 0: SCREEN 0: WIDTH 80: CLS : GOSUB Title

OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
IF ASC(MID$(name$, 1)) = 0 THEN
  COLOR 15: PRINT "WARNING! This adventure has a corrupt file. Repairing the ";
  PRINT "file and returning to": PRINT "Main System Menu...": GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, -1
      FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF
IF a = -1 THEN
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
      a = -2: PRINT #1, a: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE
  COLOR 2: LOCATE 6: a$ = "This is Official Eamon Deluxe Adventure #9"
  GOSUB Center: LOCATE 20: GOSUB KeyWait: GOSUB Intro: GOTO Menu
END IF
IF a = -2 THEN GOTO Menu
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to read the intro story again? (Y/N):"; : GOSUB KeyWait3
IF k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Redemption, Banana, Talon, Moria, Forest, RingDoom, IronPrison, VOD
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Header: LOCATE 8: COLOR 2
PRINT "  Welcome to an unfinished copy of this adventure collection!": PRINT
PRINT "  Although the menu lists several adventures, only the first eight have been"
PRINT "  converted to Eamon Deluxe at this time."
LOCATE 20: GOSUB KeyWait
GOSUB Header: LOCATE 8: COLOR 2
PRINT "  Visit "; : COLOR 15: PRINT "www.EamonAG.org/pages/eamondx.htm"; : COLOR 2
PRINT " for the latest Eamon Deluxe updates.": PRINT : PRINT : PRINT
PRINT "  For information regarding the conversion status of these adventures or any"
PRINT "  other questions, comments, etc., please email:"; : COLOR 15
PRINT " eamondeluxe@gmail.com"
LOCATE 20: GOTO KeyWait


Menu:
author$ = author1$: adventure$ = Adventure1$: GOSUB Title
FOR a = 1 TO 9
   IF a < 9 THEN COLOR 2
   PRINT a$(a); : COLOR 8: LOCATE CSRLIN, 40: PRINT a$(a + 3)
NEXT
COLOR 7: PRINT
k = 15: c1 = 4
CALL EDXMenuM(k, c1, 1, 5, 3, 0)
IF k > 5 OR c1 = 3 THEN CHDIR "..": RUN "EAMONDX"
IF k = 5 THEN GOSUB Intro: GOTO Menu
IF k = 4 THEN adv = 0: GOTO Reviews

GOSUB Pick
ON k GOTO Stories, IntroDone0, Reviews

Stories:
GOSUB Title
ON adv GOSUB Redemption, Banana, Talon, Moria, Forest, RingDoom, IronPrison, VOD
GOTO Menu

Reviews:
IF adv > 0 THEN  ' AND adv <> 1
  COLOR 3: GOSUB Title1: PRINT : COLOR 2
  PRINT "Reviews have been written for both the Eamon Deluxe version of this adventure"
  PRINT "and the classic title from the original Apple II Eamon gaming system upon which"
  PRINT "it was based. Please select the version of the adventure that you wish to read"
  PRINT "the review for.": PRINT : PRINT
  c = 12: c1 = 4
  CALL EDXMenuM(c, c1, 7, 8, 3, 0)
  IF c1 = 3 THEN GOTO Menu
  IF c = 2 THEN GOTO DustyReviews
END IF
author$ = author$: adventure$ = adventure$
'IF adv <> 2 THEN adventure$ = adventure$ + " Deluxe Edition"
IF adv = 0 THEN author$ = author1$: adventure$ = Adventure1$
a$ = "": IF adv < 10 THEN a$ = "0"
a1$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv)))
a$ = "": IF adv + 1 < 10 THEN a$ = "0"
a2$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv + 1)))
OPEN "EDX009RV.TXT" FOR INPUT AS #1
  DO
    LINE INPUT #1, a$
  LOOP UNTIL a$ = a1$
  COLOR 2: GOSUB Title1: COLOR 3
  DO
    LINE INPUT #1, a$
    IF a$ = "<paws>" THEN
      PRINT : COLOR 2: GOSUB KeyWait2: COLOR 2: GOSUB Title1: COLOR 3
      LOCATE CSRLIN - 1: a$ = ""
    END IF
    IF a$ <> a2$ THEN PRINT a$
  LOOP UNTIL a$ = a2$
  CLOSE : GOTO Menu
DustyReviews:
GOSUB Title
ON adv GOSUB Redemption1, Banana1, Talon1, Moria1, Forest1, RingDoom1, IronPrison1, VOD1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Redemption, Banana, Talon, Moria, Forest, RingDoom, IronPrison, VOD
IntroDone:
a$ = "(Waking up the monsters...)"
PRINT a$: FOR x# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$


'                            Redemption
'                            ----------
Redemption:
IF SkreenTest = 0 AND s%(4) <> 1 THEN CALL Pic.Loader("REDMPTN")
GOSUB Title: LOCATE 7: COLOR 2
PRINT "    You see now that it had been a really boneheaded idea in the first place."
PRINT
PRINT "    The Slavers are nowhere in sight. It seems you've finally given them the"
PRINT "slip. That's the good news. The bad news is, you have no idea where you are,"
PRINT "and although you could probably find your way back the way you came, the Slavers"
PRINT "would get you. If you had your armour, weapons, your warhorse.....but you've"
PRINT "got nothing. And even if you could manage to get past the Slavers, whether by"
PRINT "stealth or force, you'd probably be executed by the King's soldiers the minute"
PRINT "you got home. You've been in the Slavers' hands for some time, but not long"
PRINT "enough to expect that the King has by now forgiven you."
PRINT
PRINT "    And why should he? It really was a boneheaded idea."
LOCATE 20: GOSUB KeyWait
'
z0$ = " R E D E M P T I O N ": z1$ = "137": z2$ = "1993": GOSUB SoftDisk
IF k$ = "S" THEN RETURN
'
GOSUB Title: COLOR 15: PRINT : PRINT SPACE$(33); "AUTHOR'S NOTES"
PRINT : COLOR 2
PRINT "   This adventure can be mapped using a grid system, provided that you map the"
PRINT "wilderness separately from the towns. The map is so simple, however, that you"
PRINT "should consider mapping optional."
PRINT
PRINT "   This is not as challenging an adventure as someone might expect of me, but it";
PRINT "does require that you pay attention to what people say to you. There is no"
PRINT "single "; q$; "right"; q$; " way to complete the adventure, although you will of course have"
PRINT "to do some things before others. Feel free to pursue whatever element of the"
PRINT "plot interests you at a particular time."
LOCATE 20: GOSUB KeyWait
COLOR 2
PRINT "Some notes on commands:": PRINT
PRINT "GIVE - to give money just enter a number (the amount you wish to give)."
PRINT
PRINT "LOOK summons the full room description. If directions are listed in the short"
PRINT "description, then those are the only directions you can go from there."
PRINT
PRINT "EXAMINE recalls an artifact's description. It also identifies artifacts that"
PRINT "are 'embedded' in the room description which you might normally ignore."
PRINT
PRINT "     There is one embedded artifact. It isn't a trivial item, so"
PRINT "     don't worry about examining every little thing. There is also"
PRINT "     an item that appears normally, but must be examined."
PRINT
PRINT "HEAL - the chance of success decreases the more times you use it. Eventually"
PRINT "your power will give out and you'll have to find other sources of healing."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   One more hint: there is a "; q$; "secret"; q$; " exit in one room that is only mentioned"
PRINT "in one of the monster descriptions -- so don't ignore them!"
COLOR 15: PRINT : PRINT : PRINT SPC(55); "Enjoy the adventure!": PRINT
COLOR 7: PRINT SPC(61); "- Sam Ruby": PRINT SPC(58); "San Francisco, CA"
PRINT SPC(65); "1993"
LOCATE 20: GOSUB KeyWait
'
LOCATE 12: COLOR 2
LINE INPUT "Enter the name you wish to use for your character: "; a$
a$ = LTRIM$(RTRIM$(LEFT$(a$, 30))): IF a$ = "" THEN a$ = "Tom Zuchinni"
OPEN "REDMPTN.DAT" FOR OUTPUT AS #1: PRINT #1, a$: CLOSE
'
GOSUB Title: COLOR 2
PRINT "   It all started when you returned to your home kingdom after a prolonged"
PRINT "period of adventuring. In your absence, a humongous dragon named Argon had"
PRINT "taken up residence near the steamy crater of Mount Collapso. A particularly"
PRINT "greedy and gluttonous dragon, Argon had nearly decimated the kingdom through his"
PRINT "destructive marauding. There was hardly a horse, pig, sheep, goat, or cow left"
PRINT "in the nation. Argon had also amassed quite a hoard of treasure at the expense"
PRINT "of your countrymen."
PRINT
PRINT "   The King's warriors and wizards were soundly trounced in one battle after"
PRINT "another. Argon, a dragon of few words, cryptically informed them in the midst"
PRINT "of one skirmish that he was fated to die while asleep, not in combat. This was"
PRINT "confirmed by an independent prophesizing firm commissioned by the King."
PRINT "Naturally the Royal Guard attempted to infiltrate Argon's lair and dispatch him"
PRINT "while he was napping. Unfortunately, what Argon lacked in eloquence he more"
PRINT "than made up for in wariness; the King's men always found his cave blocked off"
PRINT "by a large, immovable boulder."
LOCATE 20: GOSUB KeyWait
LOCATE 10: COLOR 2
PRINT "   Enter you and your hair-brained scheme."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   Recalling an ancient legend about the downfall of a certain city, and hoping"
PRINT "to take advantage of Argon's love of treasure, you advised the King to build a"
PRINT "giant, golden statue of a cow (Argon's favorite appetizer), adorned with all"
PRINT "kinds of precious stones. Hidden in the statue would be a secret compartment"
PRINT "in which you would hide. Wheel it outside the city, you told the King, and"
PRINT "Argon will take it back to his cavern, thinking it some pathetic (but shiny)"
PRINT "form of tribute or appeasement. Then, while the dragon slept, you would leap"
PRINT "out and kill him with your awesome weaponry."
PRINT
PRINT "   The King, with whom you held considerable favor, accepted your advice and did"
PRINT "as you suggested. It pained him to take such a drastically expensive course of"
PRINT "action, but he trusted you, and after all, he'd get the statue back once the"
PRINT "dragon was dead."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   But on the night in which the plan was put into motion, you had been partying"
PRINT "with some friends from out of town. You showed up at the gates with your"
PRINT "scabbard, but not your sword! In the darkness, none of the engineers noticed."
PRINT "They simply tucked you into your compartment, where you promptly passed out."
PRINT
PRINT "   Early the next morning Argon came calling, and sure enough, he was immensely"
PRINT "amused and pleased with the Golden Cow. Just as you had anticipated, he took it"
PRINT "back to his cave (stopping along the way to munch on a caravan's horses) and"
PRINT "sealed himself inside."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   By this time you had discovered your mistake, so you got out of the statue"
PRINT "and prepared to escape when Argon next left his lair. You were successful in"
PRINT "doing so, but you forgot to close the trap door to the secret compartment behind"
PRINT "you. When Argon returned, he figured out what had been tried, and in a fit of"
PRINT "rage he took the statue, flew high above the royal city, and with unerring"
PRINT "precision dropped it on the palace. Adding insult to injury, he retrieved the"
PRINT "statue and deposited it in the sulfurous lake in the crater of Mount Collapso."
PRINT
PRINT "   Needless to say, the King was furious. Here he was in the middle of the"
PRINT "greatest national emergency since the Ale Revolt of 1093, and you had convinced"
PRINT "him to melt down half his treasury to build that stupid...thing which now lay"
PRINT "at the bottom of a bubbling, volcanic cesspool! Plus he was catching hell from"
PRINT "the Queen for losing her favorite diamond necklace!": PRINT
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   In a quick show trial you were convicted of Treasonous Negligence of the"
PRINT "Highest Degree. Since you woefully lacked the moolah needed to repay the King,"
PRINT "you were turned over to the Slavers, who would see that you spent the rest of"
PRINT "your natural life underground in the Western Mines. The King even set his"
PRINT "Clerics about the task of committing your supernatural life to this fate as"
PRINT "well."
PRINT
PRINT "   Since your escape, you have been wandering east through a wide valley of"
PRINT "plains. Over the last three days you have passed by several farms. Now you see"
PRINT "the gate to a small village surrounded by a wooden, lightly fortified wall."
PRINT "You take a breath, step through the gate, and pray that somewhere in this new"
PRINT "land you may find the means to your redemption."
LOCATE 20: GOTO KeyWait
Redemption1:
s$ = "June 1993": GOSUB Review1: PRINT : COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "New Commands: ENTER, BUY, SELL, TALK, ASK"
PRINT "Playing Time: 2-3 hours"
PRINT "Reviewer Rating: 9.5"
PRINT : COLOR 2
PRINT "Comment: As the adventure opens, you have escaped from the Slavers. After"
PRINT "running for three days, you arrive penniless at the gates of a small village in"
PRINT "another kingdom. You quickly discover that they have a dragon problem as well."
PRINT "Dragons have fabulous treasure hoards; if you kill this one you will have the"
PRINT "means to repay the king. Can this be the means to your redemption?"
PRINT
PRINT "Sam tailored this adventure for newcomers to Eamon, taking special effort to"
PRINT "make it wonderfully forgiving and easy to play without compromising the depth"
PRINT "of the puzzles or encounters."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "This adventure hinges on the new TALK and ASK commands. Most of the play"
PRINT "revolves around interacting with many of the characters, finding out what they"
PRINT "know, learning how to approach people in power, earning money, gaining secret"
PRINT "knowledge, obtaining your equipment and maps. It all is deeply interlocked in"
PRINT "the ways that Sam does so well."
PRINT
PRINT "This is in my opinion the finest single-dungeon Eamon that Sam has ever done,"
PRINT "and in many ways could be argued to be his best work of any size. I found it to"
PRINT "be an immensely good play. Hack 'n'slashers may be disappointed, but anyone who"
PRINT "enjoys complex Eamon scenarios will not want to miss this one!"
PRINT
PRINT "I give it a (7) for difficulty."
LOCATE 20: GOTO KeyWait


'                             Banana Republic
'                             ---------------
Banana:
GOSUB Title: LOCATE 7: COLOR 2
PRINT "   You regretted it the moment you did it."
PRINT
PRINT "   Searching for the treasure of King Wrichdood in a vast cave system, you were"
PRINT "surprised by an evil conjuror and his warriors who were similarly engaged."
PRINT "Well, neither party being disposed towards sharing, a battle ensued, in which"
PRINT "you managed to break both of your swords and lose your shield to a conjured Fire"
PRINT "Giant. Faced with your imminent demise, you pulled out a little talisman that"
PRINT "you picked up years ago but never needed (and certainly never wanted) to use."
PRINT
PRINT "But now it was your only hope. You held it out in front of you, spoke the magic"
PRINT "word, and cast a POWER spell for good luck..."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   The talisman exploded in a burst of magical energy, ripping a momentary hole"
PRINT "in the space/time continuum. And into this rift you went..."
PRINT
PRINT "   Suddenly you were falling. You prepared for the inevitable thud but all you"
PRINT "got was a SQUISH! You landed in...what? Bananas? BANANAS! Recovering your"
PRINT "wits, you looked around, finding yourself in a field of very strange looking"
PRINT "banana trees. You tried to cast a Heal spell but your magic seems to fail here."
PRINT
PRINT "   The next thing you heard was an alarm being raised. The next thing you saw"
PRINT "were the soldiers..."
LOCATE 20: GOSUB KeyWait
'
z0$ = "  Banana Republic  ": z1$ = "152": z2$ = "1994": GOSUB SoftDisk
IF k$ = "S" THEN RETURN
'
GOSUB Title: LOCATE 7: COLOR 15: PRINT "AUTHOR'S NOTES": COLOR 2: PRINT
PRINT "   "; q$; "Banana Republic"; q$; " is a sequel to "; q$; "Redemption"; q$; ". Those familiar with the first"
PRINT "game will understand the command system already and will perhaps be amused by"
PRINT "structural similarities and themes, but it is not necessary to have completed"
PRINT "the first adventure to succeed in this one, since the plot is completely"
PRINT "different."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "Some notes on commands:"
PRINT
PRINT "GIVE has two meanings in this game. It normally implies giving something away"
PRINT "to someone. But it can also be used to show someone something, to have him "
PRINT "examine, identify, or comment on it. The object will be returned to you."
PRINT
PRINT "The SEARCH command finds hidden treasure and objects not readily seen. But"
PRINT "don't waste  your time searching everywhere -- only where objects might be "
PRINT "intentionally hidden or hidden because of darkness, clutter, etc."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "All objects with writing on them can be READ. Some you can also USE."
PRINT
PRINT "LOOK recalls the long description of an area. EXAMINE recalls the long"
PRINT "description of objects and subjects. In one instance it will reveal new"
PRINT "information about an object previously not in full view."
COLOR 15: PRINT : PRINT : PRINT SPC(55); "Enjoy the adventure!"
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   You've been in a prison cell for several days now. The only thing anyone"
PRINT "will tell you is that you are under arrest for Trespassing -- and "; q$; "Destroying"
PRINT "Magic Bananas."; q$; "  They've got to be kidding!"
PRINT
PRINT "   But apparently they think you are some sort of spy or saboteur. They don't"
PRINT "believe your story any more than you believe this stuff about magic bananas."
PRINT
PRINT "   You keep saying "; q$; "Take me to your leader,"; q$; " and eventually they do."
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "   "; q$; "You are in the Banana Republic of Centraland. I am President Dole. I have"
PRINT "decided to take the risk of believing that you may be telling the truth about"
PRINT "yourself."
PRINT
PRINT "   "; q$; "If indeed you are, you are probably concerned with returning to your own"
PRINT "time and place. We can provide you with the means to do so. But our resources"
PRINT "are most precious and you will have to earn our help."
PRINT
PRINT "   "; q$; "The Banana Republic is facing its darkest hour. Once we were the most"
PRINT "powerful and important nation on this continent, and we enjoyed mutually"
PRINT "beneficial relationships with our neighbors. However, in the last five years"
PRINT "these nations have been swept by ethnic nationalism and have turned into"
PRINT "military dictatorships. Now they wish to conquer our Republic and divide it"
PRINT "amongst themselves."; q$
LOCATE 20: GOSUB KeyWait: COLOR 2
PRINT "   "; q$; "Our stores of magic bananas have, until now, kept the balance of power in"
PRINT "our favor. But our enemies have started their own biological weapons programs."
PRINT "We have developed a new crop of extremely powerful bananas that could turn the"
PRINT "tide and save the Republic. Unfortunately, the four sets of genetic prototypes"
PRINT "(which look like seeds) have been stolen by the four powers that oppose us."; q$
PRINT
PRINT "   You can see what President Dole is leading up to. He wants you to try to"
PRINT "recover the seeds. And you realize that you don't have much choice."
PRINT
PRINT "   "; q$; "If I make your world safe for democracy and banana splits, how will you get"
PRINT "me back to my own world?"; q$; " you ask."
PRINT
PRINT "   "; q$; "In our orchards there is an ancient tree that bears but a single ripened"
PRINT "Time/Space Displacement banana every decade. This banana we will give to you if"
PRINT "you accomplish your mission. Once consumed, it will correct your"
PRINT "spacio-temporal displacement."; q$
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "   "; q$; "Right,"; q$; " you say, "; q$; "I'm on the job. For starters, I'll need some string, a"
PRINT "Holocaust Cloak, a wheelbarrow, and--"; q$
PRINT
PRINT "   "; q$; "I have not completely dismissed the possibility that you are an agent of our"
PRINT "enemies. You shall have to find, or earn, such things. Yet I shall provide you"
PRINT "with a little help..."; q$
LOCATE 20: GOTO KeyWait
Banana1:
s$ = "December 1994": GOSUB Review1: COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "New Commands: ENTER, BUY, SELL, TALK, SEARCH"
PRINT "Special Features: 10 directions"
PRINT "Playing Time: 2-3 hours"
PRINT "Reviewer Rating: 9.0                        Average Rating: 8.0/2"
PRINT : COLOR 2
PRINT "Comment: This Eamon is a sequel to Sam's very excellent "; q$; "Redemption"; q$; ". Though it"
PRINT "only has 49 Rooms, it encompasses an astonishing range of interesting stuff to"
PRINT "keep you entertained for the hours you will be playing. You start out with a"
PRINT "sword, some fragmentation bananas and a sling to throw them with. From there,"
PRINT "you are on your own (as usual!)."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT q$; "Banana Republic"; q$; " is quite a bit simpler than "; q$; "Redemption"; q$; ", and is perhaps the"
PRINT "simplest top-quality Eamon that Sam has ever done. Once again, you must use the"
PRINT "TALK command to discover things you need to know. From there, you must solve a"
PRINT "succession of small puzzles and battle quite a few imposing enemies before you"
PRINT "finally recover all of the seeds. It is not as deeply interlocked as many of"
PRINT "Sam's top Eamons, and a careful selection among the many special-purpose bananas"
PRINT "will be very helpful in dispatching the bad guys. It is fairly forgiving as"
PRINT "long as you make good use of the SAVE command. Between the smallish,"
PRINT "symmetrical map and the logical layout, I found it easy to play with no paper"
PRINT "map and few notes."
PRINT
PRINT "Like all of Sam's best stuff, this is not an Eamon to be missed. I found the"
PRINT "play to be much fun and very relaxing, and highly recommend it to puzzlers and"
PRINT "hack'n'slashers alike. I give it a (7) for difficulty."
LOCATE 20: GOTO KeyWait


'                           The Curse of Talon
'                           ------------------
Talon:
GOSUB Title: LOCATE 7: COLOR 2
PRINT "     A messenger from the New Kingdom was coming to see you."
PRINT
PRINT "     It was there that you found yourself two years ago, when fortune and "
PRINT "foolishness sent you into exile, and it was there that you found redemption. In"
PRINT "tracking down and destroying a vicious Green Dragon, you saved the kingdom and"
PRINT "your honor. What news might there be from that faraway land?"
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "     "; q$; "My lord,"; q$; " the messenger says, "; q$; "I was commanded to bring this message to"
PRINT "you with the greatest of speed. It comes from His Highness the Crown Prince."
PRINT "Will you hear me?"; q$
PRINT
PRINT "     The Crown Prince? "; q$; "Speak,"; q$; " you say."
PRINT
PRINT "     "; q$; "Thank you, M'Lord. Thus says His Highness: 'Once before, Great Warrior,"
PRINT "you brought salvation to a land besieged by a terrible force from without. Now"
PRINT "a greater peril faces us, and this time the cause of our imminent destruction is"
PRINT "our own past. In the name of my father and the people of the New Kingdom, I beg"
PRINT "you to come to our aid once again...or all may be lost!'"; q$
LOCATE 20: GOSUB KeyWait
'
z0$ = " The Curse of Talon ": z1$ = "156": z2$ = "1995": GOSUB SoftDisk
IF k$ = "S" THEN RETURN
'
GOSUB Title: LOCATE 7: COLOR 15: PRINT SPACE$(33); "AUTHOR'S NOTES": COLOR 2
PRINT : PRINT "Some notes on commands:"
PRINT
PRINT "Most commands involve a verb and an object or subject ("; q$; "ATTACK MEAN DOG"; q$; "). You"
PRINT "can abbreviate most verbs, objects, and subjects down to two or three letters"
PRINT "("; q$; "A ME"; q$; " or "; q$; "A DOG"; q$; ") but NOT MAGIC WORDS!"
PRINT
PRINT "Hold down the ENTER key to repeat a command."
PRINT
PRINT "You can get a list of commands during the game by entering ?. Most commands are"
PRINT "easy to figure out. You can move in four horizontal directions (N/S/E/W) plus"
PRINT "Up and Down. In battle you must FLEE to exit an area."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "LOOK recalls an area's long description. EXAMINE does the same for artifacts"
PRINT "and people/monsters. It can also be used to get more information on objects"
PRINT "that are only mentioned in the room description and are not fully described"
PRINT "because they do not have any obvious significance. Examination by other party"
PRINT "members may uncover facts not discoverable by yourself. Try to keep your"
PRINT "friends alive!"
PRINT
PRINT "The new command CAST is used to ask your friends to cast spells they may know."
PRINT "Sometimes they will cast spells on their own. Once again, try to keep your"
PRINT "friends alive -- you may not be able to win the game without them."
PRINT
PRINT "SAY can be used to pronounce magic words. LIGHT can be used to try to burn or"
PRINT "melt something."
LOCATE 20: GOSUB KeyWait: COLOR 2
PRINT "Some advice:"
PRINT
PRINT "Conserve healing objects by not using them on minor wounds. Don't be quick to"
PRINT "use up potions. You will need them if your cleric is busy or incapacitated, and"
PRINT "for emergencies in battle."
PRINT
PRINT "Save the game often. 1) When the party survives a tough fight. 2) Before you do"
PRINT "anything that might hurt you or not work. 3) After completing a significant"
PRINT "segment of the game, such as a puzzle, or a level."
PRINT
PRINT "The COMMUNE spell is not really supposed to be used. Using it because you're"
PRINT "too lazy to solve a puzzle is cheating!"
PRINT
PRINT "All your companions are important. Keep them alive. Later in the game, death"
PRINT "can be overcome, but at a great cost of clerical power."
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "     One week later you arrive at Kingscourt, the capital of the New Kingdom. A"
PRINT "contingent of guards escort you to the palace. Your presence causes quite a"
PRINT "stir, which is not surprising given your heroic status."
PRINT
PRINT "     The Prince, clad entirely in purple, greets you in the throne room."
PRINT
PRINT "     "; q$; "Perhaps you were expecting to see my father The King,"; q$; " he says. "; q$; "Alas, he"
PRINT "has fallen deathly ill, as have countless others. Many have already died, and"
PRINT "all of us will eventually succumb if the Curse is not lifted."; q$
PRINT
PRINT "     A curse?"
PRINT
PRINT "     What curse?"
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "     "; q$; "The New Kingdom was only founded three hundred years ago. Before then,"
PRINT "our people lived on the other side of the Great Mountains. The center of the"
PRINT "Old Kingdom was a castle located in the forest. The castle was home to the"
PRINT "Cyrak Princes, a family which produced a long line of rulers. Many were mighty"
PRINT "warriors, clerics, and mages. But in the time of Talon Cyrak, the last of the"
PRINT "Cyrakian line, dark and evil powers had seduced many members of the aristocracy"
PRINT "and their vassals."
PRINT
PRINT "     "; q$; "Talon could not bear to see his great family, proud people, and mighty"
PRINT "kingdom fall under the Cloak of Darkness, but he realized that the tide was"
PRINT "against him. Many thought that he would lead his remaining, fanatical followers"
PRINT "into overt war against the treasonous elements, even though he was likely to"
PRINT "lose. But Talon made no such move, and died mysteriously."; q$
LOCATE 20: GOSUB KeyWait: COLOR 2
PRINT "     "; q$; "His vassals dutifully buried him and then disappeared. Actually they"
PRINT "migrated to this land, and founded the New Kingdom. Meanwhile, back in the"
PRINT "forest, an inexplicable plague swept out from the castle. No medicine could"
PRINT "stop it, for it was not a plague, but a curse -- a curse invoked by Talon"
PRINT "himself, who sacrificed his life to make it so powerful. The curse decimated"
PRINT "the aristocracy, then the populace. The forces of evil eventually took control"
PRINT "of the territory, but Talon had achieved his goal -- the powers, secrets, and"
PRINT "strength of the Cyrakian Kingdom would not be handed over to the Dark Lords."
PRINT
PRINT "     "; q$; "For three hundred years, the New Kingdom flourished. But recently the"
PRINT "Dark Lords finally crossed the Great Mountains and attempted to subdue us. We"
PRINT "were victorious, but it was a terrible war, and we were not able to move back"
PRINT "over the mountains and reclaim the old kingdom. Yet we were satisfied that we"
PRINT "held a defensive advantage and were freed from any immediate threat of a new"
PRINT "invasion."; q$
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "     "; q$; "Unfortunately, we now believe that the Curse of Talon has been passed on"
PRINT "to us by the hordes of Orcs and other things that we fought in the war. You"
PRINT "see, these creatures lived for three hundred years in the cursed remains of the"
PRINT "Old Kingdom. Although they themselves were not affected by the curse, they"
PRINT "became embued with it, and passed it on to us -- the lost descendents of the"
PRINT "Cyraks -- when we met in the wars. Now, it is only a matter of time before we"
PRINT "are all wiped out."
PRINT
PRINT "     "; q$; "Our only hope lies in an ancient legend. It is said that Talon hoped that"
PRINT "the Faithful would one day grow strong enough to retake the forest. He"
PRINT "enchanted a rod that would remove the curse from the afflicted, and hid it"
PRINT "somewhere in the castle. We must recover this artifact at all costs."; q$
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "     "; q$; "But as I said, we lack the strength to launch an attack over the"
PRINT "mountains. Our only chance is to send in a small team that can make its way to"
PRINT "the castle by stealth, find the rod, and bring it back. Because of the skills"
PRINT "you displayed in your heroic efforts here before, we thought that you would be"
PRINT "the best person to lead the team."
PRINT
PRINT "     Well, the game would be over pretty quick if you refused so, needless to"
PRINT "say, you agree to lead the team on this dangerous adventure."
PRINT
PRINT "     "; q$; "All the major centers of the New Kingdom will aid you in this. To add"
PRINT "fighting strength to your party, the Lord of Ironcastle himself, Sir Blackstone,"
PRINT "will accompany you. He may also be able to help overcome obstacles that require"
PRINT "great physical strength."; q$
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "     "; q$; "From Shrine City, the High Priest of the Temple of Light shall march with"
PRINT "you. He is a mighty cleric who can cast the spells known as HEAL and COMMUNE,"
PRINT "the latter of which can sometimes access the knowledge of the Gods to solve"
PRINT "dilemmas. He does not like to cast this spell, however, so try to solve problems"
PRINT "yourself. The High Priest is also a powerful enemy of the Undead, whom you"
PRINT "might encounter. Against them he has special defenses."
PRINT
PRINT "     "; q$; "From Kingscourt, you shall have the aid of Tolkien the Scribe. You will"
PRINT "have to take great care to defend him in dangerous situations, but in that"
PRINT "ancient castle, you may need someone with the knowledge of old languages,"
PRINT "science, magic, and alchemy."; q$
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "     "; q$; "The province of Agroville is sending a young squire to help carry your"
PRINT "provisions and equipment. These are being paid for by Tradetown. The squire"
PRINT "can also help defend the party and can carry whatever treasure you may wish to"
PRINT "recover. Although this mission is of great importance to us, we know that as an"
PRINT "adventurer, you will be interested in collecting valuables, and it is the least"
PRINT "we can offer in terms of compensation for your assistance."
PRINT
PRINT "     "; q$; "Legend has it that the rod will NOT be easily found. Many puzzles will"
PRINT "have to be solved, and other items obtained and used -- this to test you and"
PRINT "insure that only the deserving would be able to lift the curse. You will face"
PRINT "many challenges left by Talon as well as many perils left by the Dark Lords."
PRINT "Search thoroughly and fight bravely!"; q$
LOCATE 20: GOSUB KeyWait
LOCATE 10: COLOR 2
PRINT "     Soon you leave Kingscourt and embark on the difficult journey over the"
PRINT "mountains. Eventually your escorts leave you, and the party descends into the"
PRINT "dark forest on the other side.....enemy territory."
LOCATE 20: GOTO KeyWait
Talon1:
s$ = "September 1995": GOSUB Review1: COLOR 7
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "New Command: CAST"
PRINT "Playing Time: 3-6 hours"
PRINT "Reviewer Rating: 9.0                        Average Rating: 9.0/2"
PRINT : COLOR 2
PRINT "Comments: To shorten Sam's usual long and convoluted intro, you and a small band"
PRINT "of worthies are tasked to recover the long-lost Rod of Talon, needed to nullify"
PRINT "a curse that is laying waste to the countryside. Your companions will include a"
PRINT "Cleric, versed in the healing arts and in spell casting, a Scholar, steeped in"
PRINT "knowledge and lore, a Fighter of no small strength, and a Squire to serve as"
PRINT "helper."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "This Eamon is good. I mean, really good. Each of your companions has special"
PRINT "abilities that you will need to fulfill the quest. There are many dozens of"
PRINT "specials so that every new area you explore is an entirely new experience, and"
PRINT "you never know what a new artifact or monster might invoke."
PRINT
PRINT "By the halfway point, I had tentatively decided to give this Eamon a (10)"
PRINT "rating, something which I thought I would never do, but the new and special"
PRINT "stuff is that good. In the end, I dropped it to a (9) for two reasons: first,"
PRINT "the squire is a young kid who tends to make silly, even stupid comments during"
PRINT "combat; the comments quickly wore thin, and some are anachronistic."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "Second and much more importantly, Sam loaded the end game with combat. Once I"
PRINT "had acquired the Rod, it took me over an hour to win my way through about 30"
PRINT "previously-explored rooms back to the entrance. I found myself playing the same"
PRINT "two or three battles over and over and over as I waited for the random results"
PRINT "of combat to let me and my companions survive the battle intact. Frankly, I was"
PRINT "quite bored long before I finally completed the game. Thus, my (10) fell to "
PRINT "a (9), and I give it a difficulty of (9) as well."
PRINT
PRINT "But don't let the above griping put you off. This is an incredible Eamon that"
PRINT "should not be missed by anyone who appreciates the Best that Eamon has to offer!"
LOCATE 20: GOTO KeyWait

'                           The Mines of Moria
'                           ------------------
Moria:
GOSUB Title: LOCATE 7: COLOR 2
PRINT "It is a bad time for the free people. The forces of the dark lord, Sauron, are"
PRINT "swarming over the world. Armies of orcs, trolls, and evil men and beasts are"
PRINT "strengthening the shadow that will soon envelop the earth."
PRINT
PRINT "For the moment, the land of the west (which you are on) is protected by the"
PRINT "Misty Mountains, which Sauron is not yet ready to cross. But you, the Main"
PRINT "Hall, and the free lands and people of the west are not safe! The men of the"
PRINT "south, who have been fighting bravely against the dark lord, cannot hold out for"
PRINT "long against Sauron and his growing power."
PRINT
PRINT "But there is hope. At great risk, a wizard and his ranger companion smuggled"
PRINT "information out of Sauron's fortress which could be of great use to the men in"
PRINT "the south."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "They could not deliver the information right away, so they waited at the Main"
PRINT "Hall. When they finally set out, all paths through the Misty Mountains were"
PRINT "blocked due to winter storms."
PRINT
PRINT "Realizing that Sauron would stop them if they tried to take any normal paths,"
PRINT "the two men decided to take a path that the dark lord would never think of"
PRINT "watching ... because the way is more terrible than his army!"
PRINT
PRINT "The path they chose was......................"
LOCATE 20: GOSUB KeyWait
IF s%(4) <> 1 THEN
  CLS : COLOR 15, 4: FOR c = 1 TO 4: PRINT SPACE$(80); : NEXT
  PRINT SPACE$(38); "THE"; SPACE$(39); : FOR c = 1 TO 4: PRINT SPACE$(80); : NEXT
  PRINT SPACE$(37); "MINES"; SPACE$(38); : FOR c = 1 TO 4: PRINT SPACE$(80); : NEXT
  PRINT SPACE$(39); "OF"; SPACE$(39); : FOR c = 1 TO 4: PRINT SPACE$(80); : NEXT
  PRINT SPACE$(37); "MORIA"; SPACE$(38); : FOR c = 1 TO 4: PRINT SPACE$(80); : NEXT
  COLOR 3, 0
  ' Delay
  c# = 0: a$ = INKEY$
  DO
    c# = c# + 1
    IF INKEY$ <> "" THEN c# = dly# * 10
  LOOP UNTIL c# >= dly# * 10
  GOSUB Title: a$ = INKEY$
END IF
IF s%(4) = 1 THEN
  COLOR 7: PRINT "[VI Mode Note: Displayed here is an all red screen with bright white letters"
  PRINT "that read THE MINES OF MORIA in a vertical order.]"
  GOSUB KeyWait
END IF
LOCATE 8: COLOR 2
PRINT "Built by the dwarves long, long ago, "; q$; "Khazad-Dum"; q$; " (the halls of the dwarves)"
PRINT "became the center of dwarfdom. Skilled dwarvish miners built a kingdom under"
PRINT "the Misty Mountains. The mines produced unmeasurable amounts of gold, silver,"
PRINT "iron, jewels, and most importantly, mithril (the most valuable metal on earth)!"
PRINT
PRINT "But the dwarves dug too deep, and awoke evil things far below the earth. Many"
PRINT "dwarves were slain, and the rest were forced to flee. The doors were shut, and"
PRINT "Khazad-Dum was renamed "; q$; "Moria"; q$; " - the black chasm."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "The wizard and ranger were never heard from again."
PRINT
PRINT "However, the wizard left a copy of the information with the bartender at the"
PRINT "Main Hall, telling him that if he was not heard from to give it to a tough and"
PRINT "trustworthy adventurer to take it to the men of the south."
PRINT
PRINT "(In case you haven't figured it out yet, the bartender is sending you on the"
PRINT "mission!)"
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "You read the letter. It says:"
PRINT
PRINT q$; "If you are reading this, then I have failed. Your mission is perilous and"
PRINT "difficult. You will enter Moria from the west, survive in Moria, and find the"
PRINT "exit, 'East-Gate', on the other side of the mountains."
PRINT
PRINT q$; "Once there, you must deliver this letter to friends."
PRINT : PRINT SPC(57); "- Elbereth."; q$
PRINT
PRINT "The rest of the letter is written in a strange language which you cannot read"
PRINT "and the letter is signed with a strange rune which seems to be a "; q$; "G"; q$; "."
PRINT
PRINT "May the valar be with you!"
LOCATE 20: GOTO KeyWait
Moria1:
s$ = "October 1985": GOSUB Review2: COLOR 7
PRINT "Reviewed by Bob Davis": PRINT
PRINT "Average Rating: 6.5/5": PRINT : COLOR 2
PRINT "Comment: The setting in the intro may sound familiar to you. It is from the"
PRINT "Lord of the Rings. And like the book, the action doesn't stop. The monsters"
PRINT "are mean and plentiful, the way through the mines is treacherous and the clues"
PRINT "are very, very subtle."
PRINT
PRINT "I found a variety of monsters from orcs to trolls and from spiders to dragons."
PRINT "The dungeon kept me interested with gates, cave-ins and chasms. A little humor"
PRINT "is threaded throughout the adventure."
PRINT
PRINT "This is part one of a three part series. Part two is "; q$; "The Forest of Fear"; q$; " and"
PRINT "part three is "; q$; "The Ring of Doom"; q$; ". One need not have to go through the series in"
PRINT "order to play the adventure."
LOCATE 20: GOTO KeyWait


'                            The Forest of Fear
'                            ------------------
Forest:
GOSUB Title: COLOR 2
PRINT "Ages ago, in times few remember, the Dark Lord, Sauron, fashioned rings of power"
PRINT "in the land of Mordor. One he made for himself, the mightiest ring of all,"
PRINT "which ruled the others."
PRINT
PRINT "Three were given to the elves, but being the wisest of the races they were not"
PRINT "tricked by Sauron's fake friendship. Seven were given to the dwarves, and nine"
PRINT "to mortal men."
PRINT
PRINT "These men received great power, but they became slaves to the Dark Lord because"
PRINT "of the rings. The men became immortal, but as time passed they lost their"
PRINT "physical bodies and became shadows, dark and terrible."
PRINT
PRINT "They serve Sauron as his trusted lieutenants and messengers. They are the"
PRINT "Nazgul, the Ringwraiths, the Black Riders...the Nine."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "The chief of the Nazgul, the Witch King of Angmar, has recently re-occupied one"
PRINT "of Sauron's old haunts, the fortress of Dol Guldur (elvish for "; q$; "hill of dark"
PRINT "sorcery"; q$; ")."
PRINT
PRINT "Dol Guldur lies at the head of some foothills in Mirkwood forest. The forest"
PRINT "was once a bright place, but Sauron and his evil poisoned it. The wood-elves of"
PRINT "the north renamed the forest "; q$; "Mirkwood"; q$; " ... the "; q$; "Forest of Great Fear"; q$; "."
PRINT
PRINT "Worst of all, the Black Captain of the Nine has captured and locked away in his"
PRINT "prison a wise and mighty ranger, who is much needed in the fight against the"
PRINT "Dark Lord."
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "Your mission is three-fold: One, to secure southern Mirkwood (where the "
PRINT "trouble is) and drive off or kill all the foul creatures you find there. Two,"
PRINT "to rescue the ranger and bring him out alive. Three (if possible) destroy the"
PRINT "chief of the Nazgul!"
PRINT
PRINT "Beware! There are reports that an orc platoon has been stationed in and around"
PRINT "Dol Guldur. They probably have and are riding wargs--huge, evil wolves. It is"
PRINT "known that spiders make their homes in the trees of southern Mirkwood, and rumor"
PRINT "has it that an ancient evil and even a dragon have joined the Black Captain."
PRINT
PRINT "You may find help. Look to the trees that talk and those that taught them."
PRINT
PRINT "May the Valar be with you!"
LOCATE 20: GOTO KeyWait
Forest1:
s$ = "June 1986": GOSUB Review2: COLOR 7
PRINT "Reviewed by Bob Davis": PRINT
PRINT "Playing time: 3-4 hours"
PRINT "Reviewer Rating: 6                                Average Rating: 5.7/4"
PRINT : COLOR 2
PRINT "Comment: This is a good brute-force adventure and it makes you think about the"
PRINT "survival of others. The characters are interesting and plentiful, the treasure"
PRINT "valuable, but the descriptions were lacking once inside Dol Guldur. Overall,"
PRINT "the play is good. I was continually getting myself in trouble the first time I"
PRINT "played it (mainly by poking my nose into everything that came along) but got"
PRINT "through the adventure on the second try with a little more common sense."
PRINT
PRINT "This adventure is recommended for those times when you want to kill something or"
PRINT "have a strong character who is bored with the usual "; q$; "wimps"; q$; " (normal Hardiness"
PRINT "characters) in most dungeons."
LOCATE 20: GOTO KeyWait


'                             The Ring of Doom
'                             ----------------
RingDoom:
GOSUB Title: COLOR 2
PRINT "Ages ago, in times few remembered, the Dark Lord, Sauron, fashioned rings of"
PRINT "power in his land of Mordor. One he made for himself, and it was the mightiest,"
PRINT "for it could control the others. In all, twenty rings were made. An old poem"
PRINT "tells how Sauron distributed them:"
PRINT : COLOR 7
PRINT SPC(20); "Three rings for elven-kings under the sky,"
PRINT SPC(20); "Seven for dwarf-lords in halls of stone,"
PRINT SPC(20); "Nine for mortal men doomed to die,"
PRINT SPC(20); "One for the Dark Lord on his dark throne"
PRINT SPC(20); "In the land of Mordor where shadows lie"
PRINT SPC(20); "One ring to rule them all,"
PRINT SPC(20); "One ring to find them,"
PRINT SPC(20); "One ring to bring them all,"
PRINT SPC(20); "And in the darkness bind them,"
PRINT SPC(20); "In the land of Mordor where shadows lie"
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "The elves were not tricked by Sauron's false friendship, so they hid their"
PRINT "rings. Sauron has taken back the seven of the dwarves. The nine are used by"
PRINT "the Black Riders, the Nazgul, who are Sauron's powerful servants."
PRINT
PRINT "But the one was lost..."
PRINT
PRINT "Lost, that is, until now. The one has been found, by the "; q$; "good guys"; q$; ","
PRINT "fortunately, for if Sauron recovers it he will be invincible!"
PRINT
PRINT "Being a mighty warrior and hero of the land, you are summoned to a council of"
PRINT "the wise and the leaders of the free peoples. A debate occurs over the"
PRINT "question, "; q$; "What should we do with the ring?"; q$
LOCATE 20: GOSUB KeyWait: COLOR 2
PRINT "The leader of the council, Elrond, says after a long debate, "; q$; "There is only one"
PRINT "way. We must destroy it. Doing that will destroy Sauron. It must be thrown"
PRINT "into the Mountain of Fire, Orodruin (also called the Mountain of Doom)."
PRINT "However, Mount Doom lies in the land of Mordor, where Sauron dwells."
PRINT
PRINT q$; "What?"; q$; " says someone, "; q$; "Take it right under his nose? Nonsense!"; q$
PRINT
PRINT q$; "Perhaps,"; q$; " says Elrond, "; q$; "but it is our only hope."; q$
PRINT
PRINT "You volunteer to be the ring bearer. You must go through a mountain pass called"
PRINT "Cirith Ungol and into Mordor. There you will throw the ring into the fire of"
PRINT "the mountain. You are given some lembas, an elvish waybread, the shards of a"
PRINT "once mighty sword, and a flask of a magical liquid."
PRINT
PRINT "You journey south until you reach the jungle-forest of southern Ithilien."
LOCATE 20: GOTO KeyWait
RingDoom1:
s$ = "March 1994": GOSUB Review1: COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 1-2 hours ": PRINT "Reviewer Rating: 5.0"
PRINT : COLOR 2
PRINT "Comment: This adventure is classic Ruby from his "; q$; "Middle-Earth period"; q$; ". It is"
PRINT "a reasonably accurate rendition of Frodo's portion of The Return of the King,"
PRINT "beginning at the Rangers' hideout and continuing on to the Cracks of Doom."
PRINT
PRINT "This is a very tough adventure, with very dense combat, and often harsh"
PRINT "consequences for wrong decisions. Get it right, or die. Because of the very"
PRINT "intense combat, I give it a (9) for difficulty. Bring your strongest character"
PRINT "and heaviest weapons!"
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "The puzzles are pretty easy, if you have read Tolkein's Lord of the Rings books."
PRINT "If you haven't read them, then some of the necessary actions may be pretty"
PRINT "obscure. If you've read the books, it's a Hack'n'Slasher's delight."
PRINT
PRINT "Here are a few hints to lighten the difficulty: the reforged sword is a 5D5"
PRINT "weapon; if that's a big gun for you, then be sure to watch for the opportunity"
PRINT "to reforge it. You can complete the quest even if you do not have Frodo, Sam,"
PRINT "or Gollum with you. Look for the Rangers at the beginning, they will be"
PRINT "invaluable in combat."
PRINT
PRINT "Sam did a pretty nice overall. It would easily have garnered a higher rating if"
PRINT "not for the high difficulty."
LOCATE 20: GOTO KeyWait

'                       The Iron Prison
'                       ---------------
IronPrison:
GOSUB Title: COLOR 2
PRINT "In the beginning, a group of highly-powered beings came to the world. They were"
PRINT "gods, and they were called the Valar. The most powerful of them was Melkor, but"
PRINT "he envied the others and coveted their powers."
PRINT
PRINT "And then, other races were born. Amongst these were the elves, and they were"
PRINT "wise and skillful. Their greatest smith, Feanor, created three gems (the"
PRINT "Silmarils) which shone with the light of stars. But Melkor lusted for them, and"
PRINT "he took them, and fled to the north. And the light of the world was diminished."
PRINT
PRINT "From that day on, he was called Morgoth, the black enemy. He built a vast"
PRINT "underground complex, and it was named Angband, the "; q$; "Iron Prison"; q$; ". Above"
PRINT "Angband, he raised Thangorodrim, the Mountains of Tyranny."
PRINT
PRINT "From his stronghold, he made war upon all that would not call him king. He set"
PRINT "the Silmarils in an iron crown, and it never leaves his head."
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "Morgoth created foul creatures to fight for him: orcs, cruel mockeries of the"
PRINT "elves; trolls, as tough as the stone from which they came; werewolves, the giant"
PRINT "wolves (his special pets); and the great worms.......dragons."
PRINT
PRINT "Many spirits were seduced by Morgoth, and used their great power to terrorize"
PRINT "and fight Morgoth's enemies. Among these were the balrogs, the demons of flame,"
PRINT "and the vampires."
PRINT
PRINT "Now, the final war is brewing. As the armies prepare for battle, you are"
PRINT "summoned by Manwe, the king of the Valar, for a special mission. You must"
PRINT "infiltrate Angband and retrieve the Silmarils. Of course, this is extremely"
PRINT "dangerous, for Morgoth has a great host of monsters which he commands. And none"
PRINT "who have entered Angband have come out alive."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "You will not be without aid. Manwe is sending his herald to help you, and Este,"
PRINT "the goddess of healing, gives you a healing potion. It can only be used once,"
PRINT "so use it wisely!"
PRINT
PRINT "You travel for days through forests until you come to the edge. In the distance"
PRINT "you see Thangorodrim, and the entrance to Angband. May the Valar give you"
PRINT "strength!"
LOCATE 20: GOTO KeyWait
IronPrison1:
s$ = "September 1992": GOSUB Review1: COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 2-3 hours"
PRINT "Reviewer Rating: 5.0                               Average Rating: 5.0/3"
PRINT : COLOR 2
PRINT "Comment: As we all know, Sam cut his teeth in Eamon by adapting much of J.R.R."
PRINT "Tolkien's Middle Earth saga. This adventure is Sam's adaptation of the Second"
PRINT "Age story of Beren One-Hand, as it was recounted in "; q$; "The Silmarillion"; q$; "."
PRINT "Naturally, much had to be changed to make an adventure out of it, but all of the"
PRINT "primary characters are in place."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "Castle Angband was a very dangerous place that was populated by very powerful"
PRINT "denizens. Sam sought to duplicate the vast danger that was recounted in the"
PRINT "original story. There are four or five friendly monsters and over 80 enemies."
PRINT "Many of the bad guys are demonic and have huge Hardiness numbers."
PRINT
PRINT "Still, it's not an impossible adventure for a very strong character carrying a"
PRINT q$; "tactical nuke"; q$; " class of weapon. I found it to be quite playable with a player"
PRINT "hardiness of 25 and a 4D8 sword. And Sam scattered some healing potions around"
PRINT "the castle."
PRINT
PRINT "This is a savage "; q$; "Hack'n'Slash"; q$; " foray. While there are about five locked doors,"
PRINT "they are all easily opened once you find and dispatch the bad guy who has the"
PRINT "key."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "I gave it a (10) for difficulty when I first played it some years ago. This"
PRINT "high number came from the heavy combat against very strong opponents and a"
PRINT "couple of no-warning death traps. I found the replay for this review to be much"
PRINT "easier, because I had my old map to guide me past the worst of it. This"
PRINT "adventure comes from a period in which Sam strongly believed that a good"
PRINT "adventure should require several replays before you win through."
PRINT
PRINT "One hint: Though I found him to be killable by conventional means, Morgoth can"
PRINT "be easily slain if you use the right command and artifact."
LOCATE 20: GOTO KeyWait


'               The Valley of Death (20th Anniversary Edition)
'               ----------------------------------------------
VOD:
GOSUB Title: COLOR 2
PRINT "You were sitting in the pub one night, enjoying a brew with your good friend,"
PRINT "Melvin of New Alfredtowne, when he started talking about a fantastic deal he had"
PRINT "heard about. You followed him across the street and entered the Mayhem, Inc."
PRINT "building (a favorite supplier for adventurers with a little dough). You asked"
PRINT "him not to keep you in suspense any longer, but he would reveal nothing."
PRINT
PRINT q$; "I'm starting to get impatient,"; q$; " you told your friend. "; q$; "You know I just"
PRINT "recovered from that wound the balrog gave me. I'm not interested in buying any"
PRINT "equipment right now."; q$
PRINT
PRINT q$; "That's not the kind of deal I'm talking about,"; q$; " he said. "; q$; "Look, we're almost"
PRINT "there..."
PRINT
PRINT q$; "Almost where?"; q$; " you asked, but your friend did not hear you."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "You entered a small, well-kept room. An interesting-looking rock, placed within"
PRINT "a small case, caught your eye. Your friend grabbed your shoulder and said,"
PRINT q$; "Look at this."; q$; "  You turned around and saw a large sign."
PRINT : PRINT SPACE$(6); : COLOR x1, x2
PRINT "                          ADVENTURERS!                            "
COLOR 3, 0: PRINT SPACE$(6); : COLOR x1, x2
PRINT "                    THIS IS YOUR BIG CHANCE!                      "
COLOR 3, 0: PRINT : COLOR 2
PRINT q$; "We need two good warriors, not afraid to face danger, to join an organized"
PRINT "expedition to the Valley of Death. Untold riches await. Benefits include:"
PRINT "Five thousand gold pieces, a full share of all treasure recovered and basic"
PRINT "equipment provided for free. Meet at the Green Dragon Inn on the 21st."; q$
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT q$; "Interesting,"; q$; " you said."
PRINT
PRINT q$; "You know this is perfect for us,"; q$; " said your friend. "; q$; "Five thousand, plus"
PRINT "treasure and equipment! How could you pass this up?"; q$
PRINT
PRINT q$; "Very easily,"; q$; " you replied. Your leg still hurt where the flaming whip seared"
PRINT "through your skin. The deal sounded good, but it wasn't the right time."
PRINT q$; "Besides,"; q$; " you argued, "; q$; "I've heard stories about this 'Valley of Death'..."; q$
PRINT
PRINT q$; "What!?! Are you scared, man? For five thousand and who knows how much more,"
PRINT "I'd sing to Sauron himself! Valley of Death...ha!...old wives tales. What do"
PRINT "they know?"; q$
PRINT
PRINT q$; "More than you do, fool!"; q$; " said a voice behind you."
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 2
PRINT "You wheeled around to see an old, one-eyed man. One look at him and you could"
PRINT "sense that something was special about this battle-weary veteran. He speaks to"
PRINT "you:"
PRINT
PRINT q$; "I was once young, energetic, and full of adventure, as you are now. I wanted"
PRINT "to take on the world, thought I could, as you put it, 'Sing to Sauron himself.'"
PRINT "I, too, laughed at the tales of the Valley of Death. How foolish I was!"; q$
PRINT
PRINT "Thoroughly captivated by the old man's words, you begged him to explain."
PRINT
PRINT q$; "You see that rock over there?"; q$; " he asks, pointing to the case you noticed"
PRINT "before. "; q$; "That rock is the only thing ever brought out of the Valley of Death."
PRINT "It is dusty, but if you look carefully you will notice that it is pure gold!"; q$
LOCATE 20: GOSUB KeyWait: COLOR 2
PRINT q$; "How do you know all this?"; q$; " asked your friend."
PRINT
PRINT q$; "How?"; q$; " he replied. "; q$; "I brought it out! I am the only man to ever survive the"
PRINT "Valley of Death!"; q$
PRINT
PRINT "He went on to describe the valley. "; q$; "The River Anduin breaks off and enters a"
PRINT "deep valley made of stone. Once in there, there is no turning back. You must"
PRINT "reach the high pass -- and then the danger triples! If the hunger doesn't get"
PRINT "you, the creatures will...And then there is the big lizards..."; q$
PRINT
PRINT q$; "If it was so bad,"; q$; " your friend asked, "; q$; "how did you escape?"; q$
PRINT
PRINT "The old man's face went blank. His answer left your friend's mouth gaping:"
PRINT
PRINT q$; "I drowned."; q$; " the old man replied."
LOCATE 20: GOSUB KeyWait
LOCATE 6: COLOR 15: PRINT "[Six months later...] ": COLOR 2: PRINT
PRINT "Oh, how you wish your friend had remembered the old man. But, no, damn him and"
PRINT "the old geezer, he went anyway. And now he's gone."
PRINT
PRINT "But you're not giving up. You owe it to him. Who pulled you up all those times"
PRINT "when the ground crumbled below you? Whose bow was unerring when your sword"
PRINT "missed the mark?"
PRINT
PRINT "No, you're not giving up! He could be dead, and you may die searching for him,"
PRINT "but that would never stop a Free Adventurer from trying."
PRINT
PRINT "Do it to it, "; name$; "!"
LOCATE 20: GOTO KeyWait
VOD1:
s$ = "March 1997": GOSUB Review1: COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 2-3 hours": PRINT "Reviewer Rating: N/A"
PRINT : COLOR 2
PRINT "Comment: This is a quite uncharacteristic Sam Ruby Eamon adventure. It is"
PRINT "primarily a "; q$; "kill'n'loot"; q$; " scenario; there are just a couple of gate keys for"
PRINT "puzzles, and they aren't very deeply hidden if you look for them."
PRINT
PRINT "It has nothing at all to do with the Lord of the Rings stories, as all of Sam's"
PRINT "other early Eamons do. The Valley of Death borrows more from King Kong than"
PRINT "anything else, though there are no huge apes to be found. But there are plenty"
PRINT "of dinosaurs, and a village outside a massive wall. The village is just loaded"
PRINT "with people who want to kill you; in fact you'll find that you have to FLEE"
PRINT "several times to get the number of enemies down to something survivable."
LOCATE 20: GOSUB KeyWait
LOCATE 7: COLOR 2
PRINT "Lots of combat, with more than 50 enemies to battle. Hack'n'slashers will love"
PRINT "this one. Just remember to examine likely-looking items in the descriptions to"
PRINT "find out if they are real artifacts, and those keys will show up."
PRINT
PRINT "One hint: that firewood is really dry; it will burn in a place where you"
PRINT "wouldn't expect it to."
PRINT
PRINT "I'm modifying my original ratings slightly, raising my rating to (5) and the"
PRINT "difficulty to (7), because of two "; q$; "gotcha!"; q$; " death traps plus all the bad guys."
LOCATE 20: GOTO KeyWait


'                  Review header
'                 ---------------
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild  ": COLOR 15: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org  ": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter. The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe. The review is for the old Apple II version."
Review1a:
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it. e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
GOTO KeyWait

'                *********************
'                  NEUC Review header
'                *********************
Review2:
GOSUB Title: a$ = "The Eamon Adventurer's Guild  ": COLOR 15: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org  ": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the "; : COLOR 7
PRINT "National Eamon User's Club": COLOR 3
PRINT "newsletter which preceded the Eamon Adventurer's Guild. The ratings are from"
PRINT "the EAG. The NEUC supported the Apple II version of Eamon and not Eamon Deluxe."
PRINT "The review is for the old Apple II version.": GOTO Review1a

'                  Select adventure
'                 ------------------
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv): RETURN


KeyWait:
COLOR 3
KeyWait1:
PRINT : PRINT
KeyWait2:
PRINT "Press any key to continue...";
KeyWait3:
k$ = INKEY$: BS = POS(0): CC# = 0
DO
   IF s%(4) <> 1 THEN
     CC# = CC# + 1
     IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, BS
     IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
     IF CC# = CC3# THEN : PRINT "\": LOCATE CSRLIN - 1, BS: CC# = 0
   END IF
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

Title:
COLOR 3
Title1:
CLS : a$ = adventure$: GOSUB Center: a$ = author$:
GOSUB Center: PRINT STRING$(80, 196): PRINT : RETURN

Center:
PRINT SPC(INT((80 - LEN(a$)) / 2)); a$: RETURN

'  Softdisk adventure logo
SoftDisk:
CLS : LOCATE 4: COLOR x1, x2: PRINT SPACE$(80); : COLOR 15, 0: PRINT : PRINT
PRINT SPC(15); "WELCOME TO THE EAMON DELUXE FANTASY GAMING SYSTEM": PRINT
PRINT : LOCATE CSRLIN, (80 - LEN(z0$)) / 2
COLOR 7, 1: IF s%(4) = 1 THEN COLOR 7, 0
PRINT z0$; : COLOR 2, 0: PRINT : LOCATE 15: COLOR 7
IF z1$ <> "159" THEN
  PRINT SPC(25); "Press "; q$; "S"; q$; " to skip introduction"
  PRINT SPC(25); "Press any other key to continue"
END IF
PRINT : PRINT : COLOR x1, x2: PRINT SPACE$(80); : COLOR 2, 0: PRINT
PRINT "      Originally published on Softdisk #"; z1$; " (c) "; z2$; " Softdisk Publishing"
COLOR x1, x2: PRINT " "; SPC(79); : COLOR 3, 0: PRINT : k$ = ""
DO
  k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""
CLS : RETURN

'              AD Menu Header 5.0
'             --------------------
Header:
mc1 = 1: mc2 = 15: mc3 = 7: COLOR 7: CLS
IF s%(4) = 1 THEN RETURN
COLOR mc1, 0: PRINT " "; STRING$(76, ""); ""
'PRINT " "; SPACE$(76); ""
PRINT " "; SPACE$(20); : COLOR mc2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR mc1: PRINT SPACE$(20); "": PRINT " "; SPACE$(26); : COLOR mc2
PRINT "The Sam Ruby Adventures"; : COLOR mc1: PRINT SPACE$(27); ""
PRINT " "; STRING$(76, ""); "": PRINT : COLOR 7: RETURN

'                       -----------
'                        Error Pit
'                       -----------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; STR$(ERR); ")": PRINT
k$ = "try and continue": IF ERR > 51 THEN k$ = "exit to Main Menu"
PRINT SPACE$(20); "Hit any key to "; k$; "...": k$ = INKEY$: k$ = ""
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : L = 0: COLOR 7: RESUME NEXT

ScreenError:
SCREEN 0: WIDTH 80: CLS : SkreenTest = 1
COLOR s%(4), 2 * ABS(s%(4) = 0): PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the graphic intro screen for "; q$; "[GAME NAME]"; q$; ","
PRINT "because compatible graphics hardware is not available."
GOSUB KeyWait: RESUME SkreenTest

AdventureData:
DATA 18
DATA Redemption,Sam Ruby,REDMPTN
DATA Banana Republic,Sam Ruby,BANANA
DATA The Curse of Talon,Sam Ruby,TALON
DATA The Mines of Moria,Sam Ruby,LRDRINGS
DATA The Forest of Fear,Sam Ruby,LRDRINGS
DATA The Ring of Doom,Sam Ruby,LRDRINGS
DATA The Iron Prison,Sam Ruby,IRONPRIS
DATA The Valley of Death,"Sam Ruby & Frank Black",VOD
DATA The Hunt for the Ring,Sam Ruby,MAINPGM
DATA Quest of Erebor,Sam Ruby,MAINPGM
DATA Return to Moria,Sam Ruby,MAINPGM
DATA Haradwaith,Sam Ruby,MAINPGM
DATA Elemental Apocalypse,Sam Ruby,MAINPGM
DATA Operation Endgame,Sam Ruby,MAINPGM
DATA Animal Farm,Sam Ruby,MAINPGM
DATA Storm Breaker,Sam Ruby,MAINPGM
DATA The Boy and the Bard,Sam Ruby,MAINPGM
DATA Sanctuary,Sam Ruby,MAINPGM

EDXMenuStrings:
DATA 8
DATA "  Preview Adventure Intros          "
DATA "  START PLAYING AN ADVENTURE        "
DATA "  Read Adventure Reviews            "
DATA "  Read Review for This Collection   "
DATA "  Read Notes About This Collection  "
DATA "  Return to Eamon Deluxe Menu    "
DATA "  Review of the Eamon Deluxe Version   "
DATA "  Review of the Classic Eamon Version  "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
' (Updated for VI Mode support 06 JAN 2012)
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

' VI Mode numeric menu
GetMAdvCVI:
IF s%(4) = 1 THEN
  CLS : L = 2: PRINT "Please select an adventure:"
  FOR c = 1 TO dungeons
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + dn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to Exit):";
  LINE INPUT ""; a$: c = INT(VAL(a$))
  IF c < 0 OR c > dungeons THEN CLS : GOTO GetMAdvCVI
  'IF c = 0 THEN RUN 0
  a$ = dn$(c): EXIT SUB
END IF


' Standard Menu
'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(13) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>                     <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
' (Updated with alt. numeric menu for VI Mode support 06 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:
'    s%() - Eamon DX system settings (s%(4) = 1 is VI Mode Flag)
'   em$() - An array which holds all available choices. em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'

' VI Mode numeric menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  L = 2
  FOR x = be TO en
     x$ = LTRIM$(STR$(x - be + 1)) + ": " + LTRIM$(RTRIM$(em$(x)))
     IF x < 100 THEN x$ = " " + x$: IF x < 10 THEN x$ = " " + x$
     PRINT x$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       CLS : L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to exit):";
  LINE INPUT ""; k$: c = INT(VAL(k$)): c1 = c + (be - 1)
  IF c = 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB Pic.Loader (a$)
'    Intro picture loader and uncompressor
'    (Call Sub with a$ = file name of pic)
'   ---------------------------------------
' Exit if in VI Mode
IF s%(4) = 1 THEN CLS : COLOR 7: EXIT SUB
SCREEN 7
OPEN a$ + ".PIC" FOR RANDOM AS #1 LEN = 6920
    GET #1, 1, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 0), Pic%, PSET: a$ = ""
    GET #1, 2, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 0), Pic%, PSET: a$ = ""
    GET #1, 3, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 96), Pic%, PSET: a$ = ""
    GET #1, 4, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 96), Pic%, PSET
CLOSE

'  Pause, resume text mode and exit
'
FOR x# = 1 TO dly# * 10: NEXT
LOCATE 24, 5: PRINT "(Hit any key to continue)"; : a$ = INKEY$
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
SCREEN 0: WIDTH 80: CLS : COLOR 3

END SUB

