' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank Black                        
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'                 MULTI-ADVENTURE INTRO PROGRAM                  
'                                                                
'     The Robert Parker Adventures          Update: 31 JAN 2012  
' Converted to Eamon Deluxe by Frank Black                       
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB Pic.Loader (b$)

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

'    Variables to load & hold picture data
DIM SHARED Pic%(1 TO 3460)
TYPE pictype
   s AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): sex = z.sex: q$ = CHR$(34): l$ = STRING$(80, 196)

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), adv, adv1, adv2
adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)

DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF
CLOSE

OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Converted to Eamon Deluxe by Frank Black"
Adventure1$ = "The Robert Parker Adventures"
author$ = author1$: adventure$ = Adventure1$

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB Keywait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Cheops, Jack, Granite, Anatomy, DirtieTrix, Shippe, AlienI, WizTower, GammaOne, Sewer, Farmer, BodyRev, EncBookworm, Rhyl, RevBook, Dracula, Worm3D, ForbCity, Cat
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Title: a$ = "This is official Eamon Deluxe adventure #11": COLOR 2
PRINT : GOSUB Center: COLOR 3: LOCATE 22: GOSUB KeyWait: COLOR 2
PRINT "While about twelve of Robert Parker's nineteen Eamon adventures really stink and"
PRINT "seemed to have been churned out one-after-the-other, he was at least a very"
PRINT "enthusiastic member of the Eamon community and did end up writing some very good"
PRINT "material toward the end."
PRINT
PRINT q$; "The Creature of Rhyl"; q$; ", "; q$; "The Forbidden City"; q$; ", and his "; q$; "Bookworm"; q$; " trilogy are all"
PRINT "very good adventures and "; q$; "Bookworm 3-D"; q$; " is, in my opinion, one of the best"
PRINT "Eamons ever written."
PRINT
PRINT "All in all, I had a lot of fun converting all of these (well, maybe not "; q$; "The"
PRINT "Body Revisited"; q$; ") to Eamon Deluxe and they are all (again: maybe not "; q$; "The Body"
PRINT "Revisited"; q$; ") worth giving at least one play.  Even the redundant twelve are still"
PRINT "creative.": PRINT SPC(45); "Viva la Eamon! (as Rob once said)"
PRINT SPC(56); "-Frank Black"
COLOR 3: PRINT : PRINT : GOSUB KeyWait

Menu:
author$ = author1$: adventure$ = Adventure1$: GOSUB Title
COLOR 2
FOR a = 1 TO 10
   PRINT a$(a);
   IF a < 10 THEN LOCATE CSRLIN, 40: PRINT a$(a + 10)
NEXT
PRINT : COLOR 3: k = 17: c1 = 6
CALL EDXMenuM(k, c1, 1, 4, 3, 0)
IF k < 1 OR k > 4 THEN GOTO Menu
IF k = 4 THEN CHDIR "..": RUN "EAMONDX"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Cheops, Jack, Granite, Anatomy, DirtieTrix, Shippe, AlienI, WizTower, GammaOne, Sewer, Farmer, BodyRev, EncBookworm, Rhyl, RevBook, Dracula, Worm3D, ForbCity, Cat
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Cheops1, Jack1, Granite1, Anatomy1, DirtieTrix1, Shippe1, AlienI1, WizTower1, GammaOne1, Sewer1, Farmer1, BodyRev1, EncBookworm1, Rhyl1, RevBook1, Dracula1, Worm3D1, ForbCity1, Cat1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Cheops, Jack, Granite, Anatomy, DirtieTrix, Shippe, AlienI, WizTower, GammaOne, Sewer, Farmer, BodyRev, EncBookworm, Rhyl, RevBook, Dracula, Worm3D, ForbCity, Cat
IntroDone:
IF adv = 19 THEN
  PRINT q$; "The Cat House"; q$; " is a very obscene adventure. It consists mainly of interacting"
  PRINT "with various prostitutes within the house and is NOT recommended for children."
  PRINT "Are you 18 or older?"; : GOSUB Keywait1: IF a$ <> "Y" THEN GOTO Menu
  IF ScreenErr = 0 AND s%(1) <> 4 THEN
    CALL Pic.Loader("CATHOUSE.PIC"): FOR x# = 1 TO dly# * 20: NEXT
    SCREEN 0: WIDTH 80: COLOR 3: GOSUB Title
  END IF
END IF
IF adv = 2 THEN
  GOSUB Title
END IF

a$ = "(Waking up the monsters...)"
IF adv = 17 THEN a$ = "(Waking up the, oh, never mind!)"
IF adv = 19 THEN a$ = "Please wait one moment...    (Waking up the whores)"
PRINT : PRINT a$: FOR x# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'                 The Pyramid of Cheops
'                -----------------------
Cheops:
COLOR 7
PRINT q$; "To speak the name of the dead is to make them live again."; q$
PRINT SPC(25); "-Inscription on wall in King Tut's tomb": COLOR 3
PRINT
PRINT "It has been many months since you have left the Main Hall.  You have traveled"
PRINT "far to reach..."
COLOR 2: LOCATE 12, 18: PRINT "The": LOCATE 13, 16: PRINT "Pyramid"
LOCATE 14, 18: PRINT "of": LOCATE 15, 16: PRINT "Cheops": COLOR 14
LOCATE 11, 41: PRINT "*": LOCATE 12, 40: PRINT "***": LOCATE 13, 39
PRINT "*****": LOCATE 14, 38: PRINT "*******": LOCATE 15, 37
PRINT "*********": LOCATE 16, 36: PRINT "***********"
PRINT "  "; STRING$(76, "="): COLOR 3
PRINT : PRINT : GOTO KeyWait
Cheops1:
s$ = "June 1998": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30-60 min.": PRINT "Reviewer Rating: 5.0": PRINT
PRINT "Comment: There's not a lot to see and do here, even though there are 78 rooms to"
PRINT "explore.  This is primarily a "; q$; "mapper's dungeon"; q$; ", and there are a couple of"
PRINT q$; "secret"; q$; " passages that can be found by going in listed directions."
PRINT
PRINT "This is a really easy foray.  The mapping is straightforward and the bad guys"
PRINT "are tuned for Marcos' standard weapons.  Difficulty of (3).  Probably a good"
PRINT "pick for the Young Eamonaut.  My overall rating is for that target group."
PRINT "Advanced campaigners will likely be bored."
PRINT
PRINT "One very minor hint: don't ignore the signs."
PRINT : PRINT : GOTO KeyWait

'               The House that Jack Built
'              ---------------------------
Jack:
COLOR 2: PRINT "You are the fighter that:": PRINT : COLOR 15
PRINT "  Found the infant that cried insistent"
PRINT "  Saved Sammy Jo fair, with the really nice pair-"
PRINT "  Fought skeletons, five, and barely survived-"
PRINT "     And found the treasure beyond measure-"
PRINT "  All in the house that Jack built.": COLOR 2: PRINT
PRINT "And boy, is Jack pissed...": COLOR 14: PRINT : PRINT
PRINT STRING$(80, "="): COLOR 3: LOCATE 23: GOTO KeyWait
Jack1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30-45 min."
PRINT "Reviewer Rating: 3.0    Average Rating: 2.0/2": PRINT
PRINT "Comment: This is a fairly good-sized Eamon that has very little content.  All"
PRINT "you do is wander about a very large house.  The tone is light and the"
PRINT "descriptions mildly silly.  If it had more content I might have given it a"
PRINT "better rating, though I must note that Pat Hurst gave it a (1)."
PRINT
PRINT "You'll enjoy it more if you set yourself to do all the things listed in the"
PRINT "intro.  But as for "; q$; "treasure beyond measure,"; q$; " my take was 320 GP."
PRINT
PRINT "There are a large number of movement-related death traps, but they are mostly"
PRINT "well marked and make sense if you think about it.  Difficulty of (2)."
PRINT : PRINT : GOTO KeyWait

'                   Escape from Granite Hall
'                  --------------------------
Granite:
PRINT q$; "I need a brave volunteer to assist me on personal matters.  I will pay good"
PRINT "gold to the one who volunteers."; q$
PRINT
PRINT "You look around the bar and realize that everyone has seemed to disappear into"
PRINT "the shadows and cracks that are well known in this bar.  You curse yourself for"
PRINT "not doing the same because that means that the grey robed man was talking to"
PRINT "you."
PRINT
PRINT q$; "What is it that needs to be done, sir?"; q$; " you ask, fearing the worst."
PRINT
PRINT q$; "Just this.  You must escape from my place of dwelling; a sort of test of my"
PRINT "security."; q$
PRINT
PRINT q$; "And were do you dwell?"; q$
PRINT : COLOR 14: PRINT q$; "I dwell at Granite Hall!"; q$: COLOR 3
PRINT : PRINT : GOSUB KeyWait
PRINT "You reach for your weapon, but never get it out in time to strike.  You never"
PRINT "saw the BLAST spell that knocked you unconscious, nor the inhuman hands carrying"
PRINT "you to the waiting wagon.  All you think is, "; q$; "This is the feared mage, Ajakstu;"
PRINT "arch-mage to the demons of Hades..."; q$
PRINT
PRINT "If half of what you have heard about Ajakstu is true, you are in deep trouble!"
PRINT : PRINT : GOTO KeyWait
Granite1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 5-45 min."
PRINT "Reviewer Rating: 4.0    Average Rating: 3.5/2"
PRINT
PRINT "Comment: Well maybe you're not in all that much trouble.  This is a mild"
PRINT "Hack'n'Slash romp with a difficulty of (3).  There are several keys and lamps"
PRINT "and stuff, but I never saw any use for any of it.  The exit was cleverly done"
PRINT "and I predict that you will find it only by chance, but that you will not have"
PRINT "difficulty stumbling onto it.  But the overall content is low, diminishing the"
PRINT "rating."
PRINT : PRINT : GOTO KeyWait

'                       Anatomy of the Body
'                      ---------------------
Anatomy:
COLOR 2: PRINT "NOTE:": COLOR 3: PRINT
PRINT "Greetings.  I am Dirtie Trix, the creator of this game.  I have, in this"
PRINT "particular game, kept the design rather simple (human anatomy is not my strong"
PRINT "point!)."
PRINT
PRINT "In keeping with my stylish sense of humor, I have placed randomness into this"
PRINT "game.  You might encounter everything in the groin, the hand, etc."
PRINT
PRINT "I hope you enjoy this game, and the many more that I have turned out."
PRINT
PRINT SPC(47); "-Dirtie Trix"
PRINT : PRINT : GOSUB KeyWait
PRINT "Welcome into the human body!"
PRINT
PRINT "You bravely "; q$; "volunteered"; q$; " to enter a human patient and destroy cancerous"
PRINT "growths, tumors, and bacteria.  To aid you are several white blood cells,"
PRINT "already residing in each of us, and a Zap(tm) gun."
PRINT
PRINT "For your troubles you will be paid 1,000 gold pieces.  Also, you get to keep the"
PRINT "Zap gun."
PRINT
PRINT SPC(40); "Thank you,"
PRINT SPC(36); "Dr. Sickman Fraud"
PRINT : PRINT : GOTO KeyWait
Anatomy1:
s$ = "September 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min. "
PRINT "Reviewer Rating: 3.0            Average Rating: 3.5/2"
PRINT
PRINT "Comment: This adventure was Rob's first attempt at a "; q$; "Fantastic Voyage"; q$; "-type"
PRINT "adventure.  His main purpose was to write an Eamon adventure that would also"
PRINT "help educate the player about human anatomy.  Unfortunately actual anatomy is"
PRINT "almost non-existent, as most of the 'rooms' of the map use terms like"
PRINT q$; "lower-head"; q$; ", "; q$; "mid-arm"; q$; ", and so on.  The monster-like attitudes of the bad guys"
PRINT "was rather unrealistic, also."
PRINT
PRINT "If you want to use Eamon as an anatomy teaching aid, take a close look at "; q$; "The"
PRINT "Body Revisited"; q$; ".  It has a MUCH better and more detailed anatomical map.  I give"
PRINT "this adventure a (2) for difficulty. "
PRINT : PRINT : GOTO KeyWait


'                        Dirtie Trix's Mad Maze
'                       ------------------------
DirtieTrix:
GOSUB Noise1
a$ = q$ + "...Greetings, you fools.  I am the Game Master, Dirtie Trix.  So you thought my"
a# = dly# / 6: GOSUB SlowPrint
a$ = "other games were easy?  Well, it's safe to say you've never gone to my fun"
GOSUB SlowPrint: a$ = "house...": GOSUB SlowPrint: GOSUB Noise1
SLEEP 2: PRINT : GOSUB Noise1
a$ = q$ + "...Up until now you've had it easy..." + q$: GOSUB SlowPrint
GOSUB Noise1: PRINT : PRINT : GOTO KeyWait
DirtieTrix1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 15-45 min."
PRINT "Reviewer Rating: 3.0"
PRINT
PRINT "Comment: This is a straight mapping exercise with no combat.  It's not even much"
PRINT "of a maze, by Eamon standards, with no diabolical twists that I saw, although"
PRINT "the room names tend to be very, very similar."
PRINT
PRINT "The drill here is to wander around until you find the exit.  If there is"
PRINT "anything else, I missed it, although I must admit that I only saw about half of"
PRINT "the 96 rooms before stumbling onto the exit.  Difficulty of (2) for the large"
PRINT "map."
PRINT : PRINT : GOTO KeyWait


'                          Shippe of Fooles
'                         ------------------
Shippe:
PRINT "One day, while taking a break from adventuring, you decided to go to the docks."
PRINT "It is refreshing, watching the ships sail in and out of port; to see the"
PRINT "billowing of the sails; to see the dock-workers loading and unloading the ships."
PRINT
PRINT "While watching the ships, you notice an unusual ship arrive; the "; q$; "S.S. "
PRINT "Darkmist"; q$; ".  You shudder at the sight of it, but you do not know why.  You put it"
PRINT "out of your mind and shift your attention to other activities."
PRINT
PRINT "A little while later, a sinister man slides up beside you and wheezes, "; q$; "Ever"
PRINT "want to sail?"; q$; " between rotted teeth."
PRINT
PRINT "Before you can answer, he hits you over the head with a blackjack!  When you"
PRINT "awaken, you find that you are on the S.S. Darkmist; a slave ship!"
PRINT : PRINT : GOTO KeyWait
Shippe1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 10-20 min."
PRINT "Reviewer Rating: 2.0"
PRINT
PRINT "Comment:  You have been shanghaied and your quest is to find a way off the ship."
PRINT "Other than that, this is a straight combat scenario with no other content"
PRINT "whatsoever.  Nine out of ten enemies you meet will be named PIRATE.  No"
PRINT "companions. Difficulty of (3)."
PRINT
PRINT "The ship seems rather nicely appointed for a 17th-century pirate vessel and"
PRINT "feels more like a small castle than a ship."
PRINT
PRINT "One hint: there is no obvious way off the ship.  Look for something a little"
PRINT "mysterious to find your exit."
PRINT : PRINT : GOTO KeyWait


'                     The Alien Intruder
'                    --------------------
AlienI:
COLOR 0, 3: PRINT " May day, may day, Mission Control.  Do you copy, over? ";
COLOR 3, 0: PRINT : PRINT
PRINT "This is Mission Control, Moon Base.  What seems to be the problem, over?"
PRINT : COLOR 0, 3
PRINT " Ship sensors are picking up at least three large life forms headed this way,   "
PRINT " over."; : COLOR 3, 0: PRINT : PRINT
PRINT "Report full, direction headed and speed, Moon Base.  The Russians reported"
PRINT "escape of top secret experiment, over."
PRINT : PRINT : GOSUB KeyWait
COLOR 0, 3: PRINT SPACE$(80); : COLOR 3, 0: PRINT : PRINT
PRINT "Come in Moon Base, this is Mission Control.": PRINT : COLOR 0, 3
PRINT SPACE$(80); : COLOR 3, 0: PRINT : PRINT : PRINT "Repeat, come in Moon Base, over."
PRINT : COLOR 0, 3: PRINT SPACE$(80); : COLOR 3, 0: PRINT
PRINT : PRINT : GOSUB KeyWait
PRINT "Mission Control, Houston, this is Mission Control, Cape Cod.  Please be advised"
PRINT "that we have lost all contact with Moon Base.  Last report was of a group of at"
PRINT "least three large objects moving toward Moon Base.  Assume all on board dead."
PRINT "Tell the Russians we will have to scrap all further searches for their lost"
PRINT "patrol until we have solved our own problem, over."
PRINT : PRINT : GOSUB KeyWait
PRINT "Roger, Cape Cod.  It looks like we'll have to send in our Specialist for this"
PRINT "job.  Suit 'em up...."
PRINT : PRINT : GOTO KeyWait
AlienI1:
s$ = "September 1995": GOSUB Review1
PRINT "Reviewed by Phil Moore"
PRINT
PRINT "Playing Time: 30-60 min."
PRINT "Reviewer Rating: 2.0         Average Rating: 3.0/2"
PRINT
PRINT "Comment:  If you are expecting some one-eyed, seven-legged creature that trashes"
PRINT "the base, forget it.  I found no such creature in the adventure.  This is a "
PRINT "short hack'n'slash grab-the-loot scenario.  The mapping was rather unique and"
PRINT "could cause problems if you are not paying attention.  I got lost a couple of"
PRINT "times, but was able to recover when I found myself back at the start.  The"
PRINT "monsters are not very original, either.  There are no sudden death traps, or"
PRINT "much of anything else special."
PRINT : PRINT : GOSUB KeyWait
PRINT "I liked the way that the monsters are placed randomly; I played it several"
PRINT "times, and the monsters moved around.  There are a bunch of friendly monsters."
PRINT "You could probably take a weak character and not die because of all the friends."
PRINT "I used a regular character from the Main Hall with no spells and a Main Hall"
PRINT "weapon."
PRINT
PRINT "I rated it low because there is no mission or plot, the monsters were boring and"
PRINT "mundane with repetitive names (ALIEN, ALIEN, ALIEN).  On the other hand, I liked"
PRINT "the way that the monsters showed up differently on each restart, the unique map,"
PRINT "and absence of death traps.  I probably would have rated it higher if the"
PRINT "monsters were more interesting, there had been a bit of plot or quest, and even"
PRINT "one simple locked door puzzle or special effect."
PRINT
PRINT "It is probably a good choice for a beginner or young Eamonaut to play right"
PRINT "after the Beginners Cave."
PRINT : PRINT : GOTO KeyWait


'                       The Wizard's Tower
'                      --------------------
WizTower:
COLOR 7: a$ = "Who dares enter...": GOSUB Center: PRINT : COLOR 0, 7
PRINT SPACE$(31); "The Wizard's Tower!"; SPACE$(30); : COLOR 3, 0: PRINT
PRINT
PRINT "There exists a wizard by the name of Izurath.  He is a cunning and smart wizard,"
PRINT "but very, very evil.  He has sent a letter to the Main Hall stating that he will"
PRINT "open up the doors to his tower to bold and brave (and somewhat stupid)"
PRINT "adventurers as a challenge and to test his skills."
PRINT
PRINT "Several of your fellow adventurers have already set out for this tower.  None"
PRINT "have come back!"
PRINT
COLOR 7: a$ = "Now you seek to beat...": GOSUB Center: PRINT : COLOR 0, 7
PRINT SPACE$(31); "The Wizard's Tower!"; SPACE$(30); : COLOR 3, 0: PRINT
PRINT : PRINT : GOTO KeyWait
WizTower1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30-45 min."
PRINT "Reviewer Rating: 4.0            Average Rating: 4.4/2"
PRINT
PRINT "Comment: This is a straightforward Hack'n'Slash foray.  You can enhance the play"
PRINT "a bit by making it your quest to find and kill Izurath.  This Eamon is more"
PRINT "sophisticated than Rob's earlier ones in that it has several secret passages to"
PRINT "discover."
PRINT
PRINT "Difficulty of (4).  Izurath is a bit more difficult to find than it might at"
PRINT "first appear."
PRINT : PRINT : GOTO KeyWait

GammaOne:
PRINT "You are wandering around the Main Hall one day when you come across an unusual"
PRINT "sign."
PRINT : PRINT : COLOR 9
PRINT SPC(11); ""
PRINT SPC(11); "  Ŀ  "
PRINT SPC(11); "                                                "
PRINT SPC(11); "                     WANTED!                    "
PRINT SPC(11); "                                                "
PRINT SPC(11); "     Brave adventurer to test time machine!     "
PRINT SPC(11); "                                                "
PRINT SPC(11); "         (See Dr. Hoosenfire, room #117)        "
PRINT SPC(11); "                                                "
PRINT SPC(11); "    "
PRINT SPC(11); ""
PRINT : COLOR 3: PRINT : PRINT : GOSUB KeyWait
PRINT "You decide to pay the good doctor a call..."
PRINT
PRINT q$; "Hoo, yes."; q$; " says the doctor, "; q$; "Et is verry simple.  I plan to send you into a"
PRINT "parrarrallell univerze verry much like mine own.  I do not know what you will"
PRINT "find der, but it should be verry interesting!"
PRINT
PRINT "(It would be more interesting, you thought, if the doctor would remove the Nazi"
PRINT "outfit and lose the ridiculous accent.)"
PRINT
PRINT q$; "I will pay you 1,000 gold pieces when you git back, and if you don't, 200 to"
PRINT "your mother!"
PRINT
PRINT q$; "I will send you to a planet call Dirt, er, Earth.  The time is early 21st"
PRINT "century.  Not much is known about this planet, as it was destroyed long ago in a"
PRINT "galaxy far, far away*.                            *[Couldn't resist it. -R.P.]"
PRINT : PRINT : GOSUB KeyWait
PRINT "Author's Note:"
PRINT
PRINT "Gamma 1 takes place in a nuclear-devastated world.  It is based on Gamma World,"
PRINT "a game by TSR, The Game Wizards.  Gamma 1 is based on the game world module,"
PRINT "Legion of Gold (GW1), by Gary Gygax, Luke Gygax and Paul Reiche III."
PRINT
PRINT "I used the Gamma World rule book as well as modules for the game idea.  Catch"
PRINT "you in the Beginner's cave!"
PRINT
PRINT SPC(50); "Viva la' Eamon,"
PRINT SPC(51); "Robert Parker"
PRINT : PRINT : GOTO KeyWait
GammaOne1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Special Features: Sound effect when enemy dies"
PRINT "Playing Time: 30-45 min."
PRINT "Reviewer Rating: 3.0        Average Rating: 3.5/2"
PRINT
PRINT "Comment:  Apparently where you are sent is Earth after a nuclear war.  You find"
PRINT "lots of mutant zombies and a few refugees and friendly guards."
PRINT
PRINT "The entire adventure takes place in some kind of underground bunker, so you have"
PRINT "your standard indoors dungeon-type map to check out.  I found a couple of keys"
PRINT "laying in corridors, and if they did anything they did it transparently.  [Note:"
PRINT "They originaly did open doors transparently, but real doors have been added to"
PRINT "the Eamon Deluxe version.]"
PRINT : PRINT : GOSUB KeyWait
PRINT "Straight Hack'n'Slash fare, with no secret passages and no puzzles.  Difficulty"
PRINT "of (3)."
PRINT : PRINT : GOTO KeyWait

'                      The Eamon Sewer System
'                     ------------------------
Sewer:
PRINT q$; "We need a volunteer to help clean out the Eamon sewer system.  It's clogged"
PRINT "again."; q$
PRINT
PRINT "Everyone looks at the sewer official from the sewage plant.  No one comes"
PRINT "forward to take the job.  And no wonder why:  With the exception of Slasher, who"
PRINT "came back through a toilet pipe when someone plunged too hard, the last 37"
PRINT "helpers never came back."
PRINT
PRINT q$; "I have 2,000 gold pieces for the volunteer."; q$
PRINT
PRINT "What the hell, adventuring is in your blood.  You raise your hand to volunteer."
PRINT
PRINT q$; "Good, a volunteer.  Follow me."; q$; "  says the sewer official.  He leads you to a"
PRINT "set of stairs going down."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "At the foot of the stairs is a small room.  The other volunteer is already"
PRINT "there.  Oh, by the way, you can't leave until your job is done.  You are to"
PRINT "clean out the sewer system of rats, bums, alligators, and -oh, yes- the sewage"
PRINT "monster!"; q$
PRINT
PRINT "He slams the door behind you.  You have no choice but to go down..."
PRINT : PRINT : GOTO KeyWait
Sewer1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 10-15 min."
PRINT "Reviewer Rating: 1.0"
PRINT
PRINT "Comment: To be precise, there are 16 rats, two alligators, two bums, and the"
PRINT "aforementioned sewage monster."
PRINT
PRINT "Thirty-six rooms.  No doors.  No hidden anything.  Straight combat.  But if you"
PRINT "enjoy mapping, the place is a bit of a maze of similar passages and would be a"
PRINT "minor challenge to map completely."
PRINT
PRINT "The monsters aren't tough. Difficulty of (2)."
PRINT : PRINT : GOTO KeyWait

'                      Farmer Brown's Woods
'                     ----------------------
Farmer:
COLOR 14: PRINT "OOO-BOY!!": COLOR 3: PRINT : PRINT
PRINT "You shouldn't have drank so much!  Your head sure does hurt.  But that's not the"
PRINT "problem.  The problem is, you are in Farmer Brown's woods.  And we all know how"
PRINT "much he hates trespassers..."
PRINT
PRINT "(Next time, be a designated driver!)"
PRINT : PRINT : GOTO KeyWait
Farmer1:
s$ = "September 1997": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 10-20 min."
PRINT "Reviewer Rating: 1.0"
PRINT
PRINT "Comment:  Yep, the intro is that you got drunk and woke up on private property."
PRINT "Now your mission is to wander around and kill everything you meet until you find"
PRINT "a key to unlock the gate."
PRINT
PRINT "Well, you don't kill everything.  You randomly make friends and enemies of"
PRINT "sundry deer and squirrels, and it's pretty stupid to be in a battle where you"
PRINT "have one enemy deer and two friendly deer and you have to kill them all to get"
PRINT "the bad one because they all have the same name.  However, you do get to kill"
PRINT "about a dozen hands and a big truckload of dogs, not to mention the good Mr."
PRINT "Brown himself."
PRINT : PRINT : GOSUB KeyWait
PRINT "Wander around a huge compound where every room has a nearly identical"
PRINT "description until you stumble on a key.  Yawn.  Difficulty of (1)."
PRINT : PRINT : GOTO KeyWait

'                      The Body Revisited
'                     --------------------
BodyRev:
PRINT q$; name$; ", we need your help!"; q$
PRINT
PRINT "You look up startled.  You didn't here anyone enter.  Standing before you is"
PRINT "your friend, Doctor Sickman Fraud.  You realize that it must be an emergency if"
PRINT "the doctor comes to you."
PRINT
PRINT q$; "How can I help?"; q$
PRINT
PRINT q$; "A very important person was attacked recently by an assassin.  We thought that"
PRINT "the attacker missed, but he didn't.  In the patient somewhere is a microscopic"
PRINT "pellet, slowly releasing a poison!"
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "We have discovered the kind of poison, and know that it will be released into"
PRINT "his body in 600 to 800 turns.  We need you to go into the body and find the"
PRINT "poison.  We will supply you with a flashlight, zap gun, and lead container to"
PRINT "put the pellet in."
PRINT
PRINT q$; "Oh, and remember when you enter the body, to LIGHT the flashlight!"; q$
PRINT : PRINT : GOTO KeyWait
BodyRev1:
s$ = "December 1989": GOSUB Review1
PRINT "Reviewed by "; q$; "King Gordo"; q$
PRINT
PRINT "Special Features:  Emergency exit"
PRINT "Playing Time:  2-3 hours"
PRINT "Reviewer Rating:  4.0                Average Rating: 5.0/3"
PRINT
PRINT "Comment: Your doctor friend, S. Fraud, enlists your help.  It seems that a VIP"
PRINT "has been shot and has a slow acting poison pellet in his body.  You are shrunk"
PRINT "to microscopic size to run around in his body, banging through organs until you"
PRINT "stumble on the pellet, which you are to put in a lead container, after which you"
PRINT "will be retrieved and returned to normal size.  You enter the body at the left"
PRINT "elbow in the brachial artery.  To the north is the radial artery and south the"
PRINT "left forearm.  Get the picture?  You travel through 192 organs, veins and"
PRINT "arteries, such as: Jugular Vein, Common Carotid Artery, Posterior Tibial Vein,"
PRINT "and my favorite, the Inferior Vena Cava.  If you get tired of looking for the"
PRINT "pellet, just SAY CHICKEN and you are rescued, but be ready for insults.  You can"
PRINT "also exit through the Urethra."
PRINT : GOSUB KeyWait
PRINT "My God, 193 rooms- much ado about nothing.  I gave up trying to map it after"
PRINT "reaching room #85.  There are so many rooms that seem to have no point other"
PRINT "than to round out a very complete internal map of the body.  It is very"
PRINT "difficult to map without getting mixed up because of the difficult anatomical"
PRINT "names and because the body's organs aren't laid out in a very orderly fashion."
PRINT "One of the things I enjoy doing is making good, clean and understandable maps,"
PRINT "but not for this one."
PRINT : PRINT : GOSUB KeyWait
PRINT "The pellet is randomly placed and the quest consists of stumbling about until"
PRINT "you come upon it.  The ending is unsatisfactory because you are not recognized"
PRINT "nor thanked for your enormous effort in killing cancer cells, tapeworms, and"
PRINT "tumors and bringing out the pellet.  The small reward gives little satisfaction."
PRINT "The monsters were very monotonous, being mainly an endless succession of cancer"
PRINT "cells and white blood cells."
PRINT : COLOR 2
PRINT "[Note:  The above was written in error; you ARE thanked for those things, but"
PRINT "you MUST find the pellet and PUT it in the container to get your thanks and"
PRINT "bonus.]": COLOR 3
PRINT : PRINT : GOSUB KeyWait
PRINT "I reluctantly rate this a 4.  I say reluctantly because I know the author must"
PRINT "have spent a lot of time learning the proper names of the parts of the human"
PRINT "body and getting them in the right places.  He set out to write an educational"
PRINT "Eamon adventure that teaches the body and probably deserves more credit for that"
PRINT "alone, but I was turned off as I don't have that kind of interest.  This is a"
PRINT "perfect example of an adventure that has too many rooms that don't go anywhere."
PRINT : PRINT : GOTO KeyWait

'                     Encounter: The Bookworm
'                    -------------------------
EncBookworm:
PRINT SPC(25); "(The story begins...)": PRINT
PRINT "One fine day while relaxing at the bar, Hokas Tokas approaches you."
PRINT
PRINT q$; "We need your help."; q$; " he says.  "; q$; "Will you aid us?"; q$
PRINT
PRINT q$; "Before I answer,"; q$; " you say, "; q$; "might I ask what the problem is?"; q$
PRINT
PRINT q$; "Of course.  If you will follow me."; q$
PRINT
PRINT "You leave the bar following Hokas.  He takes you down a couple side streets and"
PRINT "comes to a stop in front of the Eamon Public Library.  He begins to mount the"
PRINT "steps, so you follow him.  An armed guard standing near the door sees you and"
PRINT "begins to walk toward you."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "He's with me."; q$; " Hokas says to the guard, who then moves out of your way."
PRINT
PRINT "You catch the guard giving you a nervous look."
PRINT
PRINT "Inside the library, you see books thrown about, as if vandals had broken in and"
PRINT "ransacked the place.  Picking up one of the books, you see a three inch hole"
PRINT "through the center of it.  Opening it up, you discover that all of the pages are"
PRINT "now completely blank."
PRINT
PRINT q$; "This is the fifth library to have this happen to it."; q$; " Hokas says.  "; q$; "We have to"
PRINT "stop this madman before more books are destroyed.  Luckily, these books are easy"
PRINT "to replace.  However, if this had been a library of rare manuscripts..."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT "Hokas begins to shiver as though a wicked thought crossed his mind."
PRINT
PRINT q$; "I'll do it."; q$; " you say.  "; q$; "But tell me, who did this?"; q$
PRINT
PRINT q$; "The Bookworm."; q$; " Hokas hisses through clenched teeth."
PRINT : PRINT : GOSUB KeyWait
PRINT SPC(25); "(...Many days later...)"
PRINT
PRINT q$; "I have located where he is holding out, Hokas, and I'm on my way there now."; q$
PRINT
PRINT q$; "I shall never be able to thank you enough if you defeat him.  I have found out"
PRINT "a bit about him for you.  He plays an odd sort of savoir-faire.  His hideout, I"
PRINT "am told, has many 'clues' or 'hints' built into it that you can access if you"
PRINT "SAY HELP in every room.  I do not know any more, so pay close attention to"
PRINT "anything and everything."
PRINT
PRINT SPC(10); q$; "Remember.  A mind is a terrible thing to waste!"; q$
PRINT : PRINT : GOTO KeyWait
EncBookworm1:
s$ = "June 1998": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30-60 min."
PRINT "Reviewer Rating: 6.5            Average Rating: 6.5/4"
PRINT
PRINT "Comment: This is a very decent Eamon, arguably Rob's best work.  It doesn't rate"
PRINT "higher because it is a bit low on content, but the writing and mapping are"
PRINT "excellent, and it has several novel room ideas.  I came very close to revising"
PRINT "my old rating upwards after replaying it for this review."
PRINT
PRINT "Difficulty will run 3-7.  Here's a warning of sorts: the contents of the can"
PRINT "will mess with your character's stats in an amusing way.  If you feel strongly"
PRINT "about that, don't fool with the can.  But if you are using a test character or"
PRINT "don't mind having to "; q$; "repair"; q$; " your character via the character editor, you may"
PRINT "get a chuckle out of it."
PRINT : PRINT : GOTO KeyWait

'
'                     The Creature of Rhyl
'                    ----------------------
Rhyl:
PRINT "The country of Rhyl has been beset nearly every night for many years by a large,"
PRINT "terrible creature that flies out from the mountains near the city of Asereht."
PRINT "The creature soars over farmland, picking up livestock or an occasional"
PRINT "unfortunate farmer and carrying the victim back into the mountains.  After the"
PRINT "creature appears, the early-morning air in Asereht is unusually cold and misty."
PRINT
PRINT "Nearly a year ago the creature broke through the wall of King Namreh's castle"
PRINT "and carried off the King's son, Prince Laechim, along with a large amount of the"
PRINT "royal treasure.  Since that incident, which did not seem like the act of an"
PRINT "unthinking creature interested only in food, King Namreh has suspected that the"
PRINT "creature is somehow under the influence of the mad magician Astylis, who is"
PRINT "believed to reside in the mountains in a vast complex at least two days away on"
PRINT "foot from Asereht."
PRINT : PRINT : GOSUB KeyWait
PRINT "After the creature's raid on the castle, King Namreh ordered his army to search"
PRINT "the mountains and discover Astylis' complex.  The soldiers made two forays into"
PRINT "the mountain wilderness, but each time were harassed and eventually driven back"
PRINT "by goblin raiders.  Since the failure of the second assault, the King has taken"
PRINT "to commissioning small parties of mercenaries and adventurers, sending them into"
PRINT "the mountains with promises of great reward upon the completion of the rescue"
PRINT "mission, and hoping that a small body of searchers will be less likely to"
PRINT "attract the goblins' attention along the way."
PRINT
PRINT "For reasons which the King has never found out, none of these rescue parties has"
PRINT "ever returned to Asereht.  Your party is now attempting to be the first."
PRINT : PRINT : GOSUB KeyWait
PRINT "The trek through the wilderness has been, amazingly enough, uneventful.  No"
PRINT "goblins, and little else of note except for some harmless wildlife.  Some"
PRINT "members of the party are beginning to wonder what did cause all the other"
PRINT "missions to fail if it wasn't the goblins and wilderness.  Finding Astylis'"
PRINT "residence was a simple matter; the skeletons and possessions of some of those"
PRINT "who have gone through before were littered through the mountain passes like a"
PRINT "trail.  And Astylis, if he was inside, was making no attempt to discourage"
PRINT "intruders.  The entry to the complex, as well as the stairway leading to it, is"
PRINT "found to be free of traps and unlocked."
PRINT
PRINT "Your mission, as prescribed by the King, is to go to Astylis' complex (so far,"
PRINT "so good), rescue Prince Laechim plus the royal scepter and the golden crown that"
PRINT "were also taken, and kill the fearsome creature that seems to be under the"
PRINT "wizard's control.  After taking one last look outside--and hoping you will see"
PRINT "it again soon--you turn toward the entrance and step inside."
PRINT : PRINT : GOSUB KeyWait
COLOR 14: PRINT "Author's notes:": COLOR 3: PRINT
PRINT "The Creature of Rhyl is my 14th Eamon adventure.  I have slowed down somewhat"
PRINT "using the new designer.  This has helped me design better games, and to come up"
PRINT "with some ideas."
PRINT
PRINT "With the exception of The Body Revisited and Encounter: The Bookworm, this"
PRINT "adventure has some of my best programing in it.  I also have introduced the"
PRINT "Goblin language to this game.  A full explanation of how to translate it is"
PRINT "available during the game via the HINTS command."
PRINT
PRINT "I would like to thank Nathan Segerlind, Tom Zuchowski and Sam Ruby.  I stole"
PRINT "bits of their stuff and threw it in here."
PRINT : PRINT : GOSUB KeyWait
PRINT "The Creature of Rhyl is based upon a Dungeons and Dragons scenario that was"
PRINT "written by Kevin Knuth and first appeared in the November 1981 issue of Dragon"
PRINT "magazine."
PRINT
PRINT "I have re-edited the map a bit to give a better play, and some artifacts were"
PRINT "added and/or changed to fit better.  With the exception of some rats, goblins"
PRINT "and the dragon, all the monsters were added by me.  The original version of Rhyl"
PRINT "was actually pretty bare of monsters."
PRINT
PRINT "I am a long time player of D&D and that is why I converted this adventure to"
PRINT "Eamon.  I liked it a lot and wanted to play it on my computer.  I realize I"
PRINT "could have easily made some changes here and there and retitled it under a"
PRINT "different name, but I don't work like that.  I'm honest."
PRINT : PRINT SPC(55); "-Robert Parker"
PRINT : PRINT : GOTO KeyWait
Rhyl1:
s$ = "September 1998": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "MAIN PGM Version: 7.0"
PRINT "Extra Commands: ENCAMP, PRAY"
PRINT "Special Features: 10-directions, ASCII picture"
PRINT "Playing Time: 2-3 hours"
PRINT "Reviewer Rating: 7.0"
PRINT
PRINT "Comment: This is a very good Eamon, in many ways the best one Rob ever did.  It"
PRINT "is a mapper's Eamon, with 133 rooms, lots of nifty stuff and a door puzzle to"
PRINT "conquer.  The combat is sparse and not terribly difficult."
PRINT
PRINT "The problem with it is that he didn't write it.  It is a "; q$; "Dungeons and Dragons"; q$
PRINT "scenario.  The D&D people had had a long history of suing first and asking"
PRINT "questions later, so I never gave it the publicity it deserved.  I buried it"
PRINT "through neglect and hoped that people would find it on their own."
PRINT : PRINT : GOSUB KeyWait
PRINT "Several of the puzzles are pretty tough, and there are all those rooms plus"
PRINT "almost 100 artifacts to keep straight.  This is no outing for the young"
PRINT "Eamonaut, or for those looking for a quickie foray.  Difficulty will ring in"
PRINT "between 4-8, depending on how much you use the HINTS command."
PRINT : PRINT : GOTO KeyWait

'
'                    Revenge of the Bookworm
'                   -------------------------
RevBook:
COLOR 2: PRINT "NOTICE!": COLOR 3
PRINT
PRINT "While "; q$; "Revenge of the Bookworm"; q$; " can be played in it's entirety by itself,  I"
PRINT "recommend that you have first played "; q$; "Encounter: the Bookworm"; q$; ".  Some of what"
PRINT "happens in this game makes references to that adventure."
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT "Author's notes/The Bookworm thanks list:": COLOR 3
PRINT
PRINT "The Bookworm wishes to thank the other person who did some of the jokes, Nathan"
PRINT "Segerlind.  It was he who inadvertently gave me Des Moines, Iowa, the statue,"
PRINT "the Robert Parker day, Tom and his tree, the Humanoid Equal Employment Act, and"
PRINT "the plot to "; q$; "Bookworm 3-D"; q$; ", soon to be made."
PRINT
PRINT "Some of the characters who appear in this adventure will be in "; q$; "Bookworm 3-D."; q$
PRINT "Without going into detail, two of the major characters will be killed off in"
PRINT "that adventure."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "Revenge of the Bookworm"; q$; " was supposed to end differently than how it does, but"
PRINT "notes from my esteemed colleague, Nathan, made me alter that ending to fit in"
PRINT "the plot-connector to "; q$; "Bookworm 3-D"; q$; ", and to pull off the joint meeting of our"
PRINT "two favorite baddies, the Bookworm and Mr. R., which would make the most"
PRINT "ultimate adventure ever if we can agree on the plot.  Anyway, if you're reading"
PRINT "this, you're not playing "; q$; "Revenge of the Bookworm"; q$; ", so get going!"
PRINT : PRINT SPC(60); "-Robert Parker"
PRINT : PRINT : GOSUB KeyWait: CLS : WIDTH 40: CLS : COLOR 2
PRINT "****************************************"
PRINT "     The Robert Parker Adventures"
PRINT "****************************************"
PRINT : PRINT "     Eamon Deluxe Adventure #11": PRINT
PRINT "****************************************": PRINT
PRINT "The Eamon Gaming System was developed"
PRINT "   by Don Brown & John Nelson": PRINT
PRINT "Revenge of the Bookworm was": PRINT "       written by Robert Parker"
PRINT : PRINT "To run this adventure, you must boot"
PRINT "from the...  What? How did you escape?": PRINT "No! no! no! no!!!!"
PRINT : PRINT q$; "Tee-hee-hee... I'm back!"; q$: PRINT : COLOR 3
PRINT : GOSUB KeyWait: CLS : WIDTH 80: CLS
GOSUB Title
PRINT q$; "And when you're through cleaning those test tubes, feed the animals."; q$
PRINT
PRINT q$; "Yes Mister Tokas, sir.  I'm almost done with them, sir."; q$; " replied the young lab"
PRINT "assistant."
PRINT
PRINT "He glances at Hokas as he exits, then returns thought to what he is doing."
PRINT
PRINT q$; "Clean this, clean that, feed the animals.  When am I ever going to get the"
PRINT "chance to do something myself?"; q$
PRINT
PRINT "He puts the test tube back on the rack and walks to the other end of the room."
PRINT "He looks at the various animals in cages and aquariums.  One aquarium in"
PRINT "particular catches his eye."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "Why hello there little worm.  What is Hokas using you for?  Checking for poison"
PRINT "apples, perhaps?  Let me remove this top so you can get some fresh air in there."
PRINT "Hokas can be such a mean man to little animals at times.  That brute."; q$
PRINT
PRINT "He unlatches the cover.  A blue light fills the room."
PRINT
COLOR 2: PRINT q$; "No!  No!  Nooooooo!"; q$: COLOR 3
PRINT : PRINT : GOSUB KeyWait
PRINT "You awake with a start.  Sweat pours off of you as if you had been caught in a"
PRINT "rain storm.  Thunder rumbles through a window nearby."
PRINT
PRINT q$; "That's must have been what woke me.  I could have swore I heard a noise,"
PRINT "though, like someone writing a letter."; q$; " you say to yourself."
PRINT : PRINT : GOSUB KeyWait
PRINT "Suddenly, an inner intuition tells you to look at your chest.  There, clinging"
PRINT "to the sweat is a tiny note.  It reads:"
PRINT : COLOR 2
PRINT "     Brave Warrior,"
PRINT
PRINT "     You are the one responsible for my being caged in an aquarium.  I "
PRINT "     shall not be taken alive again.  I could have slaughtered you in "
PRINT "     your sleep, but chose not to.  I want you to know how close to death "
PRINT "     you came.  The next time we meet, I shall kill you!"
PRINT
PRINT "                                                          With love,"
PRINT "                                                         The Bookworm"
COLOR 3: PRINT : PRINT
PRINT "You jump out of bed and throw on your armor and weapons.  With the Bookworm on"
PRINT "the loose, you have no time to take a hot bath.  You leave to find Hokas."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "So that's what happened."; q$; " you say.  You sit in awe and amazement as Hokas tells"
PRINT "you about the crummy help he has been hiring lately due to the Humanoid Equal"
PRINT "Employment directive recently passed.  "; q$; "At least it was only one of those orcs"
PRINT "from Nostrum.  How is that humanoid strike going there anyway?"; q$
PRINT
PRINT q$; "The last I heard, there was rioting.  An adventurer I know by the name of Iron"
PRINT "Mike is in that area, and he lets me know every now and then what's going on."
PRINT "Anyway, back to the Bookworm.  I have no idea where he is this time.  We're"
PRINT "going to have to do a search again, and that takes time."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "No need, Hokas.  He left me a map."; q$; " you reply."
PRINT
PRINT q$; "He what?!?"; q$
PRINT
PRINT q$; "Yeah.  Apparently he wants me to come for him."; q$
PRINT
PRINT q$; "And where is his hideout this time?"; q$
PRINT
PRINT q$; "Des Moines, Iowa."; q$
PRINT
PRINT q$; "My lad,"; q$; " says Hokas, "; q$; "you be damned careful..."; q$
PRINT : PRINT : GOTO KeyWait
RevBook1:
s$ = "June 1990": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Extra Command: PRAY"
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 6.5"
PRINT
PRINT "Comment: This is a pretty funny adventure; not in the guffaw class but it kept"
PRINT "me smiling as I played.  It is done strictly for laughs and any resemblance to a"
PRINT q$; "serious"; q$; " Eamon foray is inconceivable.  Robert did some collaboration with Nate"
PRINT "Segerlind on this, and Nate is a huge believer in humor in Eamon.  It is set in"
PRINT "Des Moines and lots of Eamon authors have cameo appearances in the adventure.  I"
PRINT "had fun figuring out who was who, and if you play much Eamon you should be able"
PRINT "to do so, too.  However, some of the pot-shots at Eamon authors are very close"
PRINT "to being inside jokes, and it is possible that you might be put off if you can't"
PRINT "figure out who is getting slammed."
PRINT : PRINT : GOSUB KeyWait
PRINT "There are few puzzles and they aren't too hard.  The fighting is minor and the"
PRINT "point of the adventure is to joke around and have fun.  Recommended to those who"
PRINT "like funny Eamons and who don't mind silly descriptions."
PRINT : PRINT : GOTO KeyWait

'
'                      Count Dracula's Castle
'                     ------------------------
Dracula:
PRINT "One fine day, after having one too many root beer floats, you lied down to take"
PRINT "a nap.  It was an awful nap, and you had a bad scary dream.  You dreamt you were"
PRINT "trapped in a castle full of bats and vampires!"
PRINT
PRINT "But the really scary part was when you woke up and found that your were really"
PRINT "there..."
PRINT : PRINT : GOTO KeyWait
Dracula1:
s$ = "March 1993": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min. "
PRINT "Reviewer Rating: 2.0"
PRINT
PRINT "Comment:  This is a very simple adventure, with no puzzles or secret stuff.  The"
PRINT "bad guys are easy enough, though there are a lot of them.  I give it a (4) for"
PRINT "difficulty."
PRINT
PRINT "The map is simply laid out.  Just about the only monsters that you see are bats"
PRINT "and vampires, which gets a bit old.  The descriptions were quite simple.  The"
PRINT "adventure does have a "; q$; "quest"; q$; " to fulfill, though it's not spelled out: kill the"
PRINT "Count."
PRINT
PRINT "I suspect that this adventure may be a pretty good pick for young boys, with"
PRINT "tons of combat and absolutely zero mental heavy lifting.  It's actually not that"
PRINT "bad of an adventure; it's just way too simple for my tastes."
PRINT : GOTO KeyWait

'
'                      Bookworm 3-D
'                     --------------
Worm3D:
CLS : WIDTH 40: CLS : COLOR 7
PRINT "...Just when you thought it was safe to"
PRINT "return to adventuring..."
PRINT
PRINT "****************************************"
PRINT
PRINT "     The Robert Parker Adventures"
PRINT "      Eamon Deluxe Adventure #11"
PRINT
PRINT "****************************************"
PRINT
PRINT "The Eamon Gaming System was developed"
PRINT "   by Don Brown & John Nelson"
PRINT
PRINT "Bookworm 3-D was"
PRINT "    written by Robert Parker"
PRINT
PRINT "To run this adventure, you must boot "
PRINT "from the Eamon master diskette."
PRINT
PRINT "To run for your life, you're too late!"
COLOR 3: PRINT : GOSUB KeyWait: CLS : WIDTH 80: GOSUB Title
COLOR 2: PRINT "SPECIAL NOTE:": COLOR 3: PRINT
PRINT "The original version of this adventure was never finished.  Rob Parker spent"
PRINT "several years on it, working in an on-and-off fashion on his Apple II.  Events"
PRINT "then conspired such that Rob no longer had an Apple II and couldn't finish it."
PRINT "Tom Zuchowski, of the Eamon Adventurer's Guild added some code which made it"
PRINT "playable, yet still incomplete, and released it as an official Eamon adventure."
PRINT
PRINT "I have now finished it, adding all the extra events which the database was"
PRINT "pointing out, and debugged the code for the second half (which Tom seemed to"
PRINT "really dislike and refused to do).  You will notice that the second half of the"
PRINT "game takes place on a practically empty space station.  It is obvious that,"
PRINT "given time, Rob would have added a bit more to it.  Still, the adventure is now"
PRINT "completely playable, and you get to see Rob's original ending, which you never"
PRINT "saw in the EAG version and is really very funny."
PRINT : PRINT SPC(60); "-Frank Black": PRINT : GOSUB KeyWait
COLOR 2: PRINT "Author's note:": COLOR 3: PRINT
PRINT "In an unusual mode (for me) I wish to apologize to Donald Brown, whom I so"
PRINT "flagrantly ripped off in this adventure."
PRINT : PRINT : GOSUB KeyWait

COLOR 2: a$ = "THE BOOKWORM:": GOSUB Center: a$ = "THE FINAL CHAPTER"
GOSUB Center: COLOR 3: PRINT : PRINT
a$ = "   Hokas sits in jail.  An orc lies in a hospital bed.  Luke loves Laura, but   "
a$ = a$ + "doesn't want to tell Beth, his wife, who secretly loves Daniel, Laura's son."
a# = dly# / 4: GOSUB SlowPrint
FOR a# = 1 TO dly# * 3: NEXT
PRINT : PRINT
a$ = "              ...wait...": a# = dly# / 2: GOSUB SlowPrint
FOR a# = 1 TO dly# * 5: NEXT
PRINT : PRINT
a$ = "   Scratch that last sentence..  Where was I?  Oh, yes.  The Bookworm "
a$ = a$ + "has once   again disappeared!"
a# = dly# / 7: GOSUB SlowPrint
PRINT : PRINT : GOSUB KeyWait
PRINT "Lately, beginning adventurers have mentioned bizarre happenings at the"
PRINT "Beginner's  Cave.  Could it possibly be him?  There's only one way to find out."
PRINT "You 'borrow' a horse from a nearby farm, and nearly get your butt shot off by a"
PRINT "disgruntled farmer."
PRINT
PRINT q$; "Damned adventurer's!  That's the twelve-thousandth horse you S.O.B.'s have"
PRINT "stolen.  When in the hell are you guys going to start returning....."; q$
PRINT : PRINT
PRINT "     .....and so on."
PRINT : PRINT
PRINT "You approach the Beginner's Cave..."
PRINT : PRINT : GOTO KeyWait
Worm3D1:
s$ = "September 1994": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Extra Command: PASSWORD"
PRINT "Playing Time: 30 min."
PRINT "Reviewer Rating: 7.5"
PRINT
PRINT "Comment: Though Robert Parker had been working on this Eamon for years, it was"
PRINT "not finished before he lost his Apple II.  It can be cleanly divided into two"
PRINT "parts: the first half was a collaboration with Nate Segerlind; it is a send-up"
PRINT "of the "; q$; "Beginners Cave"; q$; " and is hilarious!  The second half is set on a space"
PRINT "station and is much poorer in quality. "
PRINT : PRINT : GOSUB KeyWait
PRINT "I give a difficulty rating of (3).  This adventure is strictly for laughs, with"
PRINT "absurd puzzles and super-lightweight foes."
PRINT
PRINT "One caveat: this is not exactly a "; q$; "G"; q$; "-rated adventure.  It touches on some, uh,"
PRINT "mature themes and uses some language that give it something like a "; q$; "PG-13"; q$
PRINT "rating."
PRINT : PRINT : GOTO KeyWait

'
'                    The Forbidden City
'                   --------------------
ForbCity:
COLOR 2: PRINT "PRELUDE:": COLOR 3: PRINT
PRINT "Silently, he slid the window open.  He cautiously looked inside, and seeing no"
PRINT "one, he entered.  No one, that is, except for a man sleeping in a plush bed."
PRINT "Slowly and silently, he pulled the dagger from its sheath.  Light from the moon"
PRINT "reflected off of the blade; off of the liquid on the blade: "; : COLOR 14
PRINT "POISON!": COLOR 3
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT SPC(39); "I": COLOR 3: PRINT
PRINT "What a night, you think.  You curse yourself for staying at the "; q$; "Golden Dragon"; q$
PRINT "for so long, but Malrik, the bartender, needed some help moving some crates.  At"
PRINT "least you got a couple bottles of wine for your troubles."
PRINT
PRINT q$; "Hold, sir!"; q$
PRINT
PRINT "You spin about, hand going for your weapon by reflex.  "; q$; "Damn!"; q$; " you think.  Of"
PRINT "all the times to get caught in an alley.  You grow nervous as you see nine men"
PRINT "approaching.  You breath a sigh of relief when you recognize them as members of"
PRINT "the town militia.  One of them, obviously their Commander, approaches you.  The"
PRINT "others remain a comfortable distance away."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "I am Lieutenant Gerard.  I do not have time to explain.  Please come with me."; q$
PRINT
PRINT "He grabs your arm and begins to pull you along.  Both bottles of wine fall to"
PRINT "the ground with resounding crashes.  "; q$; "Oh well, they were both probably bad"
PRINT "anyway."; q$; " you think to yourself."
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT SPC(38); "II": COLOR 3: PRINT
PRINT q$; "Please have a seat."; q$
PRINT
PRINT "You look at the large, bull-ish man sitting behind the desk.  He is busily"
PRINT "searching through stacks of paper on his desk.  You sit in the chair in front of"
PRINT "his desk."
PRINT
PRINT q$; "How well did you know the man with one arm?"; q$
PRINT
PRINT q$; "Lieutenant Gerard, this is not about your 'one-armed' man.  So please leave us,"
PRINT "now!"; q$; " bellows the man."
PRINT
PRINT "The Lieutenant does a smart salute, then a 180-degree turn towards the door."
PRINT "You hear him mutter something about going to catch someone."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "Please excuse the Lieutenant.  A few months ago a prisoner in his custody, a"
PRINT "man with one arm, escaped.  It's been driving him crazy ever since.  Now, on to"
PRINT "business.  Please, if you will, follow me..."; q$
PRINT
PRINT "As he rose from his desk he must have hit a button because a panel in the wall"
PRINT "slides back, revealing a darkened corridor.  "; q$; "By the way, my name is Commander"
PRINT "Dirk."; q$
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT SPC(37); "III": COLOR 3: PRINT
PRINT "Commander Dirk leads you to a small room.  In it is a bed in which the King of"
PRINT "the Southern Territory lies.  His skin looks very pale and you hear him wheezing"
PRINT "as he breathes."
PRINT
PRINT q$; "The King has been poisoned,"; q$; " says Commander Dirk, "; q$; "by none other than that"
PRINT "fiend himself, the 'King of Assassins'.  We have tracked him down and we need"
PRINT "you to get him.  We chose you because you are the best there is."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "I'll do it."; q$; " you reply.  "; q$; "No time to get my other equipment, so I'll take what"
PRINT "I have on me.  How long do I have?"; q$
PRINT
PRINT q$; "Not very long.  The King shall die very soon if the antidote is not found."; q$
PRINT
PRINT q$; "Well where is it?"; q$; " you ask."
PRINT
PRINT q$; "In the Forbidden City."; q$; " replies Dirk."
PRINT
PRINT q$; "Uh..."; q$; " you start to say."
PRINT
PRINT q$; "Too late!"; q$; " replies Dirk as you feel the force of a Teleport spell hit you..."
PRINT : PRINT : GOTO KeyWait
ForbCity1:
s$ = "September 1995": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 2-3 hours"
PRINT "Reviewer Rating: 5.0"
PRINT
PRINT "Comment:  This Eamon was written for Softdisk back when they were first"
PRINT "soliciting an Eamon from us.  It had 5 or 6 minor problems, and when Rob learned"
PRINT "that Sam Ruby had submitted "; q$; "Redemption"; q$; ", he gave up in the face of such"
PRINT "overwhelming competition.  While I was waiting for Rob to resubmit this as a"
PRINT "regular Eamon, he got himself a PC and is now permanently out of the Eamon"
PRINT "business.  After checking with Rob, I fixed the problems and released it."
PRINT
PRINT "It has a much better finish than most of Rob's Eamons, with many little touches"
PRINT "and specials that enhance the play.  However, its 90-room map is largely empty."
PRINT "Mapping the seemingly endless tunnels got tiresome enough that I considered a"
PRINT "lower rating, but in the end the Good Stuff won me over.  If the map had been"
PRINT "somewhat smaller, it would likely have gotten a (6) rating."
PRINT : GOSUB KeyWait
PRINT "There are a couple of puzzles that don't make any sense at all to me, but I was"
PRINT "able to solve one by simply guessing from the 4 alternatives.  To solve the"
PRINT "other, make a point of searching out seemingly unimportant junk and toting it"
PRINT "along with you, and it will solve itself."
PRINT
PRINT "The bad guys are heavy enough that you'll want to bring along a magic weapon."
PRINT "A (7) is about right for difficulty, mostly for the puzzles."
PRINT : PRINT : GOTO KeyWait

'       The Cat House
'      ---------------
Cat:
PRINT "The Cat House was made about three months ago by a friend of mine. It looks and"
PRINT "plays like one of my games because I had shown him some of my earlier, "
PRINT "unpublished games. I have edited the Cat House for him, as there were some bugs"
PRINT "present."
PRINT
PRINT "Due to the nature of this game, he wishes not to have his name mentioned at all."
PRINT "This was his only attempt at writing a game. Once he saw how the games come"
PRINT "together, and the programming needed, he became disenchanted with it. He is"
PRINT "more at ease playing then creating. I do pass on to him the adventures when"
PRINT "I get them and when I get the chance."
PRINT SPC(57); "-- Robert Parker"
PRINT : PRINT : GOSUB KeyWait
PRINT "A note from Frank Black:": PRINT : COLOR 2
PRINT q$; "I didn't write it, my anonymous friend did."; q$: COLOR 3
PRINT : PRINT "Ha ha. Sure, Rob, whatever you say...": PRINT
PRINT "After converting all 18 of Robert Parker's previous adventures, I know his style"
PRINT "and method very well. While I can understand him not wanting to take credit for"
PRINT "this, I have to out him on the fact that I am certain that he is indeed the"
PRINT "author of The Cat House.": PRINT : COLOR 2
PRINT "[Still chuckling] "; q$; "My friend wrote it..."; q$: COLOR 3
PRINT : PRINT : GOTO KeyWait
Cat1:
s$ = "September 1998": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT : PRINT "Playing Time: 10 min."
PRINT "Reviewer Rating: 1.0": PRINT
PRINT "Description: Explore Madam Dolly's Cat House.": PRINT
PRINT "Comment: This is a very simple, quite pornographic adventure. All you do is"
PRINT "visit each room of the house, kill the generic customer, then have your way with"
PRINT "the girl in the room. While it's not as gross as "; q$; "House of Ill Repute"; q$; ", it has"
PRINT "even less content.  I give it a difficulty of (1)."
PRINT
PRINT "I have to add that it would get the overall (1) rating even if it wasn't"
PRINT "pornographic, being an awful Eamon from every possible standpoint."
PRINT : PRINT : GOTO KeyWait

'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version."
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN

'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
Keywait1:
k$ = INKEY$: BS = POS(0): CC# = 0
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = UCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: GOTO Title
END IF
' Standard rtn
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN

'
' Center a string on 80-column screen
'
Center:
PRINT SPC((80 - LEN(a$)) / 2); a$: RETURN
'
'         Emulate Apple II SPEED command
'
SlowPrint:
FOR x = 1 TO LEN(a$)
   PRINT MID$(a$, x, 1);
   FOR x1# = 1 TO a#: NEXT
NEXT
PRINT : RETURN
'  Sound FX for "Dirtie Trix's Mad Maze" intro
Noise1:
SOUND 550, .5: SOUND 150, .5: SOUND 550, .5: SOUND 150, .5: SOUND 450, .5
SOUND 550, .5: SOUND 150, .5: SOUND 550, .5: SOUND 150, .5: SOUND 450, .5
RETURN
'
' Adventure data
'
AdventureData:
DATA 19
DATA The Pyramid of Cheops,Robert Parker,MAINPGM
DATA The House that Jack Built,Robert Parker,MAINPGM
DATA Escape from Granite Hall,Robert Parker,MAINPGM
DATA Anatomy of the Body,Robert Parker,MAINPGM
DATA Dirtie Trix's Mad Maze,Robert Parker,MAINPGM
DATA Shippe of Fooles,Robert Parker,MAINPGM
DATA The Alien Intruder,Robert Parker,MAINPGM
DATA The Wizard's Tower,Robert Parker,MAINPGM
DATA Gamma 1,Robert Parker,MAINPGM
DATA The Eamon Sewer System,Robert Parker,MAINPGM
DATA Farmer Brown's Woods,Robert Parker,MAINPGM
DATA The Body Revisited,Robert Parker,BODYREV
DATA "Encounter: The Bookworm",Robert Parker,ENCBOOKW
DATA The Creature of Rhyl,"Robert Parker and Kevin Knuth",RHYL
DATA Revenge of the Bookworm,Robert Parker,REVBOOK
DATA Count Dracula's Castle,Robert Parker,MAINPGM.BAS
DATA "Bookworm 3-D","Robert Parker, Nathan Segerlind, and Frank Black",BOOKW3D
DATA The Forbidden City,Robert Parker,FORBCITY
DATA The Cat House,Anonymous Robert Parker,CATHOUSE.BAS

EDXMenuStrings:
DATA 4
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Quit "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
IF k = 4 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB Pic.Loader (b$)
'    Intro picture loader and uncompressor
'    (Call Sub with a$ = file name of pic)
'   ---------------------------------------
SCREEN 7
OPEN b$ FOR RANDOM AS #1 LEN = 6920
    GET #1, 1, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 0), Pic%, PSET: a$ = ""
    GET #1, 2, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 0), Pic%, PSET: a$ = ""
    GET #1, 3, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 96), Pic%, PSET: a$ = ""
    GET #1, 4, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 96), Pic%, PSET
CLOSE
END SUB

