' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank Black                        
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'                 MULTI-ADVENTURE INTRO PROGRAM                  
'                                                                
' Best of the Classic Adventures           Revision: 18 DEC 2011 
'   Converted to Eamon Deluxe                Update: 31 JAN 2012 
'          by Frank Black                                        
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB Pic.Loader (a$)

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

'  Variables to load & hold picture data
DIM SHARED Pic%(1 TO 3460)
TYPE pictype
   s AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): sex = z.sex: q$ = CHR$(34)

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), adv, adv1, adv2
adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)

DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF
CLOSE


OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Converted to Eamon Deluxe by Frank Black"
Adventure1$ = "Best of the Classic Adventures"
author$ = author1$: Adventure$ = Adventure1$: l$ = STRING$(80, 196)

' Make sure graphic mode is available
ON ERROR GOTO ScreenError
IF s%(4) <> 1 THEN SCREEN 7

Start:
ON ERROR GOTO 0
SCREEN 0: WIDTH 80: COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file. File is being restored and you are being"
  PRINT "returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5: PRINT #1, "(none)": NEXT: CLOSE
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE

'   !!! Only run adventures that have actually been converted
adv = 4 + 8 * ABS((adv = 2))

adv = adv1: Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; Adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Ngurct, Grail, Clouds, Kophinos, NaGog, Canyon, Guild, Search, Tavern, Fugitive, Camp, Doom, Pittfall, Vigil, PegPlace
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Title: LOCATE 6
a$ = "This is official Eamon Deluxe adventure #12": COLOR 2: GOSUB Center
PRINT : PRINT : COLOR 14
PRINT "Note: This is an unfinished copy of this adventure collection."
PRINT : COLOR 3
PRINT "Although the menu lists several adventures, only "; q$; "The Castle Kophinos"; q$; " and"
PRINT q$; "Dungeon of Doom"; q$; " have been converted to Eamon Deluxe at this time."
PRINT : PRINT
PRINT "Visit "; : COLOR 2: PRINT "www.EamonAG.org"; : COLOR 3
PRINT " for the latest release of Eamon Deluxe."
PRINT "Email questions, comments, etc. to "; : COLOR 2
PRINT "eamondeluxe@gmail.com": COLOR 3
COLOR 3: PRINT : PRINT : GOSUB KeyWait

Menu:
author$ = author1$: Adventure$ = Adventure1$: GOSUB Title
FOR a = 1 TO 8
   COLOR 8: IF a = 4 THEN COLOR 2
   PRINT a$(a); : COLOR 8
   IF a + 8 = 12 THEN COLOR 2
   IF a + 8 <= adv2 THEN LOCATE CSRLIN, 40: PRINT a$(a + 8);
   PRINT
NEXT
PRINT : COLOR 3: k = 15: c1 = 4
CALL EDXMenuM(k, c1, 1, 4, 3, 0)
IF k < 1 OR k > 4 THEN GOTO Menu
IF k = 4 THEN CHDIR "..": RUN "EAMONDX"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Ngurct, Grail, Clouds, Kophinos, NaGog, Canyon, Guild, Search, Tavern, Fugitive, Camp, Doom, Pittfall, Vigil, PegPlace
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Ngurct1, Grail1, Clouds1, Kophinos1, NaGog1, Canyon1, Guild1, Search1, Tavern1, Fugitive1, Camp1, Doom1, Pittfall1, Vigil1, PegPlace1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Ngurct, Grail, Clouds, Kophinos, NaGog, Canyon, Guild, Search, Tavern, Fugitive, Camp, Doom, Pittfall, Vigil, PegPlace
IntroDone:

'   !!! Only run adventures that have actually been converted
IF adv <> 4 AND adv <> 12 THEN BEEP: GOTO Menu

PRINT "(Waking up the monsters...)": FOR x# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

Ngurct:
PRINT : PRINT : GOTO KeyWait
Grail:
PRINT : PRINT : GOTO KeyWait
Clouds:
PRINT : PRINT : GOTO KeyWait

'
'                            Castle Kophinos
'                           -----------------
Kophinos:
COLOR 14: a$ = "THE CASTLE KOPHINOS": GOSUB Center: COLOR 3: PRINT
PRINT "    The Castle Kophinos, once one of the most splendid houses in the land, has"
PRINT "fallen upon hard times.  Five years ago, it is said, the wealthy and reclusive"
PRINT "Nikos Kophinos (owner of the castle) made an unheard-of trip to town.        "
PRINT
PRINT "    Furthermore, he was on foot, and was in a state of utter hysteria about "
PRINT q$; "The Devils"; q$; " having taken over his castle.  No one has visited the castle since"
PRINT "(least of all Nikos, who is still "; q$; "resting"; q$; " at an insane asylum)."
PRINT
PRINT "    Naturally, this has hurt the Kophinos family reputation.  Distant relatives"
PRINT "have offered a reward to anyone who can "; q$; "clean out"; q$; " the castle completely.  No"
PRINT "one has collected."
PRINT : PRINT : GOSUB KeyWait
PRINT "    The reward offered by the Kophinos family is more valuable than gold.  They"
PRINT "have commissioned the forging of a magical sword, a sword of awesome power and"
PRINT "breath-taking beauty.  This sword has no name as of yet, as it is to be named by"
PRINT "the adventurer who wins it."
PRINT
PRINT "    But the family is very insistent that the castle be completely cleared of"
PRINT "malevolent beings.  If even one remains, you forfeit the reward."
PRINT : PRINT : GOTO KeyWait
Kophinos1:
s$ = "December 1993": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours"
PRINT "Reviewer Rating: 7.0"
PRINT
PRINT "Comment:  I found this adventure to be a pleasant play; not especially"
PRINT "difficult, yet complex enough to keep my interest.  Right at the beginning, it"
PRINT "gets interesting as you encounter a wizard-merchant who wants to sell you such"
PRINT "things as healing potions, invisibility rings and Holy Hand Grenades."
PRINT
PRINT "One of the more interesting features of this adventure is a couple of"
PRINT "adventurer's journals that offer pointers and warnings about the castle.  While"
PRINT "it did add to the overall interest, the journals gave very little useful aid and"
PRINT "were actually counterproductive in several places."
PRINT : PRINT : GOSUB KeyWait
PRINT "The usual, proper way to play this Eamon is to touch all the bases.  Here's a"
PRINT "couple of tips to save some time.  One of the books gives bad advice, while the"
PRINT "other offers good advice; they're fun to use but you can safely ignore them if"
PRINT "you want to pick up the pace."
PRINT
PRINT "There is one secret passage that can be found when you EXAMINE something.  "
PRINT "Unfortunately, you can't ignore it because one of the bad guys is back there."
PRINT "Look in the bedrooms for this passage."
PRINT
PRINT "There are a couple of death traps.  Be sure to do a save every so often.  I"
PRINT "think I'll put the difficulty at about (5), for the secret passage and the death"
PRINT "traps, though the bad guys aren't all that difficult."
PRINT : PRINT : GOTO KeyWait

NaGog:
PRINT : PRINT : GOTO KeyWait
Canyon:
PRINT : PRINT : GOTO KeyWait
Guild:
PRINT : PRINT : GOTO KeyWait
Search:
PRINT : PRINT : GOTO KeyWait
Tavern:
PRINT : PRINT : GOTO KeyWait
Fugitive:
PRINT : PRINT : GOTO KeyWait
Camp:
PRINT : PRINT : GOTO KeyWait

'
'                        Dungeon of Doom
'                       -----------------
' (Converted Jan, 1997)
Doom:
IF ScreenErr = 0 AND s%(4) <> 1 THEN CALL Pic.Loader("DOOM.PIC")
SCREEN 0: WIDTH 80: CLS : COLOR 3: GOSUB Title
IF s%(4) = 1 THEN
  PRINT : PRINT : COLOR 7
  PRINT "[A hires screen is shown here that says, Dungeon of Doom above a gnarled red"
  PRINT " skull. Below it are the words, "; q$; "Thy death awaits thee..."; q$; "]"
  LOCATE 20: GOSUB KeyWait
END IF
COLOR 2: PRINT "Dear Adventurer:": PRINT
PRINT "You have been chosen by the A.A.A. (Adventurers' Association of America) as"
PRINT "the only one capable of the following task:"
PRINT
PRINT "     You are to enter the dark recesses of the Dungeon of the great dragon,"
PRINT "Shantieka, in search of the BLACK SWORD.  It has been said that Shantieka"
PRINT "herself guards the sword, deep in the dungeon's lower level.  You are to find"
PRINT "it, and then return it to the A.A.A. (by making it out of the dungeon alive.)"
PRINT
PRINT "     If you should make it back with the sword, great wealth and fame shall be"
PRINT "yours.  And now, you are teleported into Shantieka's dungeon.  Good luck."
COLOR 3: PRINT : PRINT : GOTO KeyWait
Doom1:
s$ = "March 1997": GOSUB Review1
PRINT "Reviewed by Adam Myrow"
PRINT
PRINT "Playing Time: 2-4 Hours"
PRINT "Reviewer Rating: 8.0 (Average Rating: 8.0/4)"
PRINT
PRINT "Comment: Here we have a classic "; q$; "kill and loot"; q$; " game with some good puzzles"
PRINT "thrown in for good measure. The first puzzle you encounter is a medium-tough"
PRINT "riddle that when solved, allows you to proceed to the lower level. The dungeon"
PRINT "itself is huge with tons of bends, and intersections."
PRINT
PRINT "The intro isn't kidding about the game being tough! There is loads of combat"
PRINT "with a large variety of monsters. The heal spell is absolutely necessary."
PRINT : PRINT : GOSUB KeyWait
PRINT "The STATUS command is useful in this one as the power spell can mess with your"
PRINT "character stats."
PRINT
PRINT "I'd peg the difficulty around 7. A few hints: pay attention to the advice you"
PRINT "are given just after you get to the second level. Don't read any writing on"
PRINT "the second level as one inscription holds a nasty surprise. It's not a death"
PRINT "trap but it does set you back a bit."
PRINT
PRINT "Overall, I liked this Eamon. My only complaint is that although the puzzles were"
PRINT "good, there weren't enough of them. I'm a big puzzle fan. I would recommend this"
PRINT "game to anybody who likes combat and likes unusual game features."
PRINT : PRINT : GOTO KeyWait

Pittfall:
PRINT : PRINT : GOTO KeyWait
Vigil:
PRINT : PRINT : GOTO KeyWait
PegPlace:
PRINT : PRINT : GOTO KeyWait

'
'             REVIEWS
'
Ngurct1:
PRINT : PRINT : GOTO KeyWait
Grail1:
PRINT : PRINT : GOTO KeyWait
Clouds1:
PRINT : PRINT : GOTO KeyWait
NaGog1:
PRINT : PRINT : GOTO KeyWait
Canyon1:
PRINT : PRINT : GOTO KeyWait
Guild1:
PRINT : PRINT : GOTO KeyWait
Search1:
PRINT : PRINT : GOTO KeyWait
Tavern1:
PRINT : PRINT : GOTO KeyWait
Fugitive1:
PRINT : PRINT : GOTO KeyWait
Camp1:
PRINT : PRINT : GOTO KeyWait



Pittfall1:
PRINT : PRINT : GOTO KeyWait
Vigil1:
PRINT : PRINT : GOTO KeyWait
PegPlace1:
PRINT : PRINT : GOTO KeyWait

'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version."
Review1a:
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait
'                *********************
'                  NEUC Review header
'                *********************
Review2:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the "; : COLOR 7
PRINT "National Eamon User's Club": COLOR 3
PRINT "newsletter which preceded the Eamon Adventurer's Guild.  The ratings are from"
PRINT "the EAG.  The NEUC supported the Apple II version of Eamon and not Eamon Deluxe."
PRINT "The review is for the old Apple II version.": GOTO Review1a

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)

'   !!! Only select adventures that have actually been converted
adv = 4 + 8 * ABS((adv = 2))

Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN

'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$: BS = POS(0): CC# = 0
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = UCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: GOTO Title
END IF
' Standard rtn
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = Adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN

'
' Center a string on 80-column screen
'
Center:
PRINT SPC((80 - LEN(a$)) / 2); a$: RETURN

' Can't initialize graphics screen
ScreenError:
SCREEN 0: WIDTH 80: CLS : ScreenErr = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the intro pics for any adventures that have them,"
PRINT "because they require an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME Start

'
' Adventure data
'
AdventureData:
DATA 15
DATA The Temple of Ngurct,James & Robert Plamondon,NGURCT
DATA Quest for the Holy Grail,Evan Hodson,GRAIL
DATA City in the Clouds,Evan Hodson,CLOUDS
DATA Castle Kophinos,Don Doumakes,KOPHINOS
DATA The Black Castle of NaGog,Doug Burrows,NAGOG
DATA The Deep Canyon,Kenn Blincoe,CANYON
DATA Temple of the Guild,Don Doumakes,GUILD
DATA The Search for Yourself,Don Doumakes,SEARCH
DATA The Prince's Tavern,Bob Davis,TAVERN
DATA The Fugitive,Don Doumakes,FUGITIVE
DATA Camp Eamon,Roger Slemon,CAMP
DATA Dungeon of Doom,Dan Knezek,DOOM
DATA Pittfall,Scott Starkey,PITTFALL
DATA Wrenhold's Secret Vigil,Bob Davis,VIGIL
DATA Peg's Place,Margaret Anderson,PEGPLACE

EDXMenuStrings:
DATA 4
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Quit "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

' VI Mode numeric menu
GetMAdvCVI:
IF s%(4) = 1 THEN
  CLS : l = 2: PRINT "Please select an adventure:"
  FOR c = 1 TO dungeons
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + dn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: l = l + 1
     IF l = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; a$
  c = INT(VAL(a$))
  IF c < 0 OR c > dungeons THEN CLS : GOTO GetMAdvCVI
  IF c = 0 THEN RUN
  a$ = dn$(c): EXIT SUB
END IF

' Standard Menu
'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
' (Updated with VI Mode alternate numeric menu: 09 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
' VI Mode Numeric Menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  l = 0
  FOR x = be TO en
     PRINT em$(x): l = l + 1
     IF l = 22 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; k$
  c = INT(VAL(k$)):  c1 = c + (be - 1)
  IF c = 0 THEN c = be: c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB Pic.Loader (a$)
'    Intro picture loader and uncompressor
'    (Call Sub with a$ = file name of pic)
'   ---------------------------------------
SCREEN 7
OPEN a$ FOR RANDOM AS #1 LEN = 6920
    GET #1, 1, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 0), Pic%, PSET: a$ = ""
    GET #1, 2, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 0), Pic%, PSET: a$ = ""
    GET #1, 3, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 96), Pic%, PSET: a$ = ""
    GET #1, 4, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 96), Pic%, PSET
CLOSE

'  Resume text mode and exit
'
'LOCATE 25, 5: PRINT "(Hit any key to continue)";
FOR x# = 1 TO dly# * 4: NEXT: k$ = INKEY$
FOR x# = 1 TO dly# * 10
   k$ = INKEY$: IF k$ <> "" THEN x# = dly# * 10
NEXT
SCREEN 0: WIDTH 80: CLS : COLOR 3
END SUB

