' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                   by Frank Black Productions                   
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                EDX FULL-SCREEN CHARACTER EDITOR                
'                                                                
' By Blank Frack                      Revision 1: 08 MAR 2003    
'                                     Revision 2: 03 JUL 2012    
'                                         Update: 09 DEC 2012    
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

DECLARE SUB InitData ()
DECLARE SUB EDX.Select.Char (c)
DECLARE SUB DisplayChar (c)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB EamonInput (tl, i$, columns, clr)
DECLARE SUB EditChar (c)
DECLARE SUB EDXpause ()
DECLARE SUB GetKey (k$)

TYPE RECORD
CNAME AS STRING * 40: STATUS AS INTEGER: A1 AS INTEGER: a2 AS INTEGER
A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
WA4 AS INTEGER: WA5 AS INTEGER: AE AS INTEGER: sex AS INTEGER: Gold AS LONG
bank AS LONG: AC AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER: WSIDES4 AS INTEGER
END TYPE
DIM SHARED z AS RECORD

DIM SHARED dly#, cc1#, cc2#, cc3#, numchars
OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, cc1#, cc2#, cc3#: CLOSE
OPEN "NUMPLRS.DAT" FOR INPUT AS #1:  INPUT #1, numchars: CLOSE : m = 50
IF numchars > 50 THEN numchars = 50

DIM SHARED c$(numchars + (50 - numchars), 39), f(39, 9), sex$(1), wp$(5)
DIM SHARED ar$(4), s$(4), stat$(3)
CALL InitData

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
m = 0

Menu:
GOSUB Header: PRINT "Character: "; : COLOR 14
IF m = 0 THEN PRINT "None"
IF m > 0 THEN PRINT c$(m, 1)
PRINT : c = 0: c1 = 10
CALL EDXMenuM(c, c1, 1, 5, 2, 0)
IF c1 = 3 THEN GOTO Menu

IF c = 1 THEN
  CALL EDX.Select.Char(c): IF c < 1 THEN GOTO Menu
  IF VAL(c$(c, 2)) < 3 THEN m = c: GOTO Menu
  CLS : LOCATE 10: COLOR 14
  PRINT "This character is on an adventure right now and can't be modified."
  PRINT : COLOR 2
  PRINT "If you wish, you can remove the character from the adventure.  Any saved games"
  PRINT "you have will be lost.": PRINT : COLOR 3
  PRINT "Do you want to do this? (Y/N):"; : CALL GetKey(c$): PRINT
  IF c$ = "y" THEN
  '      Snatch
    CLS : COLOR 7: PRINT "Searching for character...": PRINT
    f = 0: x = 0: p1$ = "": ProgErr = 0
    ON ERROR GOTO SearchError
   DO
     CLOSE : x = x + 1: c$ = LTRIM$(RTRIM$(STR$(x)))
     IF LEN(c$) < 3 THEN c$ = "0" + c$: IF LEN(c$) < 3 THEN c$ = "0" + c$
     c$ = "..\e" + c$: a$ = c$ + "\NEW-MEAT"
     OPEN a$ FOR INPUT AS #1
     CLOSE #1
     IF ProgErr = 0 THEN
       OPEN a$ FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE #1
       p2$ = LTRIM$(RTRIM$(z.CNAME))
       IF LCASE$(p2$) = LCASE$(c$(c, 1)) THEN p1$ = c$: f = 1
     END IF
     IF ProgErr > 0 AND ProgErr <> 53 THEN f = 2
     ProgErr = 0
   LOOP UNTIL f > 0  ' OR p1$ <> ""
  ON ERROR GOTO 0
    CLOSE #1: ProgErr = 0: c$ = p1$
    IF p1$ = "" THEN
      COLOR 15: PRINT "Error! Couldn't find character, restoring anyway.": PRINT
    END IF
    IF p1$ <> "" THEN
      OPEN c$ + "\GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, -1
      FOR m = 1 TO 5: PRINT #1, "(none)": NEXT: CLOSE #1
      FOR m = 1 TO 5
         a$ = "\GAME" + LTRIM$(RTRIM$(STR$(m))) + ".SAV"
         OPEN c$ + a$ FOR OUTPUT AS #1: PRINT #1, 1: CLOSE #1: KILL c$ + a$
      NEXT
      KILL c$ + "\NEW-MEAT"
    END IF
    PRINT : PRINT "Character has been returned. The Character Editor must now save and exit."
    PRINT "Run the Character Editor again and select character to modify."
    CALL EDXpause: c$(c, 2) = "1": c$ = "y": GOTO SaveCharacters
  END IF
  LOCATE 20: COLOR 3: CALL EDXpause: m = 0: GOTO Menu
END IF

IF c = 2 THEN
  IF m < 1 OR m > numchars THEN SOUND 150, 1: GOTO Menu
  CALL EditChar(m): GOTO Menu
END IF

'
'           Character file Maintenance
'          ----------------------------
IF c = 3 THEN
Menu1:
  GOSUB Header: PRINT "  Character file maintenance:": PRINT
  c = 0: c1 = 10: CALL EDXMenuM(c, c1, 10, 13, 2, 0)
  IF c1 = 3 THEN GOTO Menu
  IF c = 1 THEN
    FOR x = 1 TO numchars
       CLS : COLOR 3: PRINT : PRINT : CALL DisplayChar(x)
       COLOR 2: LOCATE 1: PRINT "Character #"; LTRIM$(RTRIM$(STR$(x))); ":"
       LOCATE 25: CALL EDXpause
    NEXT
    GOTO Menu1
  END IF
  IF c = 2 THEN
    pk = 0
    FOR x = 1 TO numchars
       CLS : COLOR 3: PRINT : PRINT : CALL DisplayChar(x)
       COLOR 2: LOCATE 1: PRINT "Character #"; LTRIM$(RTRIM$(STR$(x))); ":"
       LOCATE 25: PRINT "Keep this character?  (Y/N):"; : CALL GetKey(c$)
       IF c$ = "n" THEN
         IF VAL(c$(x, 2)) = 3 THEN
           CLS : PRINT "Can't delete, character is on an adventure right now."
           PRINT : CALL EDXpause: GOTO DeleteChars
         END IF
         a = numchars
         IF x < a THEN FOR P = 1 TO 39: c$(x, P) = c$(a, P): NEXT
         numchars = numchars - 1: pk = 1
       END IF
DeleteChars:
    NEXT
    IF pk = 1 THEN m = 0
    IF numchars < 1 THEN
      CLS : PRINT "Your roster is empty.  You must now create a new character."
      CALL EDXpause: c = 4: GOTO Create
    END IF
    GOTO Menu1
  END IF
  IF c = 3 THEN
    pk = 0
    FOR x = 1 TO numchars
       IF VAL(c$(x, 2)) = 3 THEN pk = 1
    NEXT
    IF pk = 1 THEN
      CLS : PRINT "You can't do this at this time -- Character(s) on adventure."
      PRINT : CALL EDXpause: GOTO Menu1
    END IF
    CLS : COLOR 14: PRINT "     !!!!!  WARNING !!!!!": COLOR 3: PRINT
    PRINT "You are about to delete EVERY character in your file!": PRINT
    PRINT "Are you sure you want to do this? (Y/N):"; : CALL GetKey(c$)
    IF c$ <> "y" THEN GOTO Menu1
    PRINT "Are you really, really sure? (Y/N):"; : CALL GetKey(c$): PRINT
    IF c$ <> "y" THEN GOTO Menu1
    numchars = 0
    CLOSE : KILL "PLAYERS.DAT": KILL "NUMPLRS.DAT"
    OPEN "NUMPLRS.DAT" FOR OUTPUT AS #1:  PRINT #1, numchars: CLOSE
    OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
    PRINT "Your roster is empty.  You must now create a new character."
    CALL EDXpause: c = 4: GOTO Create
  END IF
  GOTO Menu
END IF
'----------------------------
' Generate a new character
'
Create:
IF c = 4 THEN
  CLS : numchars = numchars + 1: m = numchars
  FOR x = 2 TO 39: c$(m, x) = "0": NEXT
  c$(m, 1) = ""
Create0:
  PRINT "Character name? ";
  CALL EamonInput(40, c$(m, 1), 80, 2): k = 0: PRINT
  IF c$(m, 1) = "" THEN GOTO Create0
  FOR x = 1 TO numchars - 1
     IF LCASE$(c$(x, 1)) = LCASE$(c$(m, 1)) THEN k = 1
  NEXT
  IF k = 1 THEN
    PRINT "You already have a character with that name. "
    CALL EDXpause: GOTO Create0
  END IF
  c$(m, 16) = "0": PRINT "Is this a male character?  (Y/N):";
  CALL GetKey(c$): IF c$ = "n" THEN c$(m, 16) = "1"
Create1:
  CLS : PRINT "Creating: "; c$(m, 1): PRINT
  GOSUB Roll: c$(m, 3) = LTRIM$(RTRIM$(STR$(a)))
  GOSUB Roll: c$(m, 4) = LTRIM$(RTRIM$(STR$(a)))
  GOSUB Roll: c$(m, 5) = LTRIM$(RTRIM$(STR$(a)))
  PRINT "Hardiness: "; c$(m, 3): PRINT "Agility  : "; c$(m, 4)
  PRINT "Charisma : "; c$(m, 5): PRINT
  PRINT " Roll Stats again? (Y/N):"; : CALL GetKey(c$)
  IF c$ = "y" THEN GOTO Create1
  FOR x = 1 TO 4: c$(m, x + 19) = "NONE": c$(m, x + 27) = "3": NEXT
  c$(m, 10) = "5": c$(m, 11) = "-10": c$(m, 12) = "20": c$(m, 13) = "10"
  c$(m, 2) = "1": c$(m, 17) = "200"
  GOTO Menu
END IF
IF c = 5 THEN
  CLS : LOCATE 10: COLOR 3: PRINT "Save changes?  (Y/N):"; : CALL GetKey(c$)
SaveCharacters:
  IF c$ = "y" THEN
    CLOSE ': KILL "PLAYERS.DAT": KILL "NUMPLRS.DAT"
    OPEN "NUMPLRS.DAT" FOR OUTPUT AS #1:  PRINT #1, numchars: CLOSE
    OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
    FOR r = 1 TO numchars
       z.CNAME = c$(r, 1): z.STATUS = VAL(c$(r, 2)): z.A1 = VAL(c$(r, 3))
       z.a2 = VAL(c$(r, 4)): z.A3 = VAL(c$(r, 5))
       z.SP1 = VAL(c$(r, 6)): z.SP2 = VAL(c$(r, 7)): z.SP3 = VAL(c$(r, 8))
       z.SP4 = VAL(c$(r, 9)): z.WA1 = VAL(c$(r, 10)): z.WA2 = VAL(c$(r, 11))
       z.WA3 = VAL(c$(r, 12)): z.WA4 = VAL(c$(r, 13)): z.WA5 = VAL(c$(r, 14))
       z.AE = VAL(c$(r, 15)): z.sex = VAL(c$(r, 16)): z.Gold = VAL(c$(r, 17))
       z.bank = VAL(c$(r, 18)): z.AC = VAL(c$(r, 19))
       z.WN1 = c$(r, 20): z.WN2 = c$(r, 21): z.WN3 = c$(r, 22)
       z.WN4 = c$(r, 23): z.WCOMPLX1 = VAL(c$(r, 24))
       z.WCOMPLX2 = VAL(c$(r, 25)): z.WCOMPLX3 = VAL(c$(r, 26))
       z.WCOMPLX4 = VAL(c$(r, 27)): z.WTYPE1 = VAL(c$(r, 28))
       z.WTYPE2 = VAL(c$(r, 29)): z.WTYPE3 = VAL(c$(r, 30))
       z.WTYPE4 = VAL(c$(r, 31)): z.WDICE1 = VAL(c$(r, 32))
       z.WDICE2 = VAL(c$(r, 33)): z.WDICE3 = VAL(c$(r, 34))
       z.WDICE4 = VAL(c$(r, 35)): z.WSIDES1 = VAL(c$(r, 36))
       z.WSIDES2 = VAL(c$(r, 37)): z.WSIDES3 = VAL(c$(r, 38))
       z.WSIDES4 = VAL(c$(r, 39))
       PUT #1, r, z
    NEXT
  END IF
  CHDIR "..": RUN "EAMONDX"
END IF

Header:
CLS : COLOR 3: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(20); "Eamon Deluxe Character Editor v2.0";
PRINT SPACE$(20); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT : RETURN

Roll:
a = 0: FOR r = 1 TO 3: a = a + INT(RND * 8) + 1: NEXT
IF a < 10 THEN a = 10
RETURN

SearchError:
ProgErr = ERR: RESUME NEXT

DATA Axe,Bow,Club,Spear,Sword
DATA Clothes,Leather,Chain Mail,Plate Mail,Magic/Exotic
DATA blast,heal,speed,power

'  The following data hold definitions for the editor
'     Data format: c$(CHARACTER,x)
'       Where x is: 1 - Vert location on screen
'                   2 - Horiz. loc. on screen
'                   3 - Field to move to when Up Arrow is pressed
'                   4 - Down Arrow
'                   5 - Right Arrow
'                   6 - Left Arrow
'                   7 - Minimum value
'                   8 - Max value
'                   9 - Max string length (for erasing from screen)
'
'Name,status,stats
DATA 3,7,23,3,16,2,0,0,40
DATA 3,69,20,3,1,16,1,2,11
DATA 5,12,1,10,4,5,1,300,3
DATA 5,29,1,10,5,3,1,30,3
DATA 5,47,1,10,3,4,1,24,25
'Spells
DATA 8,51,3,7,10,10,0,500,4
DATA 9,51,6,8,11,11,0,500,4
DATA 10,51,7,9,12,12,0,500,4
DATA 11,51,8,14,13,13,0,500,4
'Wep Ablty
DATA 8,11,3,11,6,6,-50,100,5
DATA 9,11,10,12,7,7,-50,100,5
DATA 10,11,11,13,8,8,-50,100,5
DATA 11,11,12,14,9,9,-50,100,5
DATA 12,11,13,19,17,18,-50,100,5
'AE,sex,gold,bank,AC
DATA 14,56,14,20,19,19,0,65,3
DATA 3,53,20,3,2,1,0,1,6
DATA 12,30,13,19,18,14,0,50000,6
DATA 12,65,13,19,14,17,0,50000,6
DATA 14,10,14,20,15,15,0,15,24
'weapon names
DATA 20,1,19,21,24,36,0,0,20
DATA 21,1,20,22,25,37,0,0,20
DATA 22,1,21,23,26,38,0,0,20
DATA 23,1,22,1,27,39,0,0,20

DATA 20,32,19,25,28,20,-50,100,5
DATA 21,32,24,26,29,21,-50,100,5
DATA 22,32,25,27,30,22,-50,100,5
DATA 23,32,26,1,31,23,-50,100,5

DATA 20,44,19,29,32,24,1,5,5
DATA 21,44,28,30,33,25,1,5,5
DATA 22,44,29,31,34,26,1,5,5
DATA 23,44,30,1,35,27,1,5,5

DATA 20,55,19,33,36,28,1,20,2
DATA 21,55,32,34,37,29,1,20,2
DATA 22,55,33,35,38,30,1,20,2
DATA 23,55,34,1,39,31,1,20,2

DATA 20,66,19,37,20,32,1,20,2
DATA 21,66,36,38,21,33,1,20,2
DATA 22,66,37,39,22,34,1,20,2
DATA 23,66,38,1,23,35,1,20,2

EDXMenuStrings:
DATA 14
DATA " Select a character "," Edit character "," Character file maintenance "
DATA " Create a new character "," Exit character editor "
DATA (reserved),(reserved),(reserved),(reserved)
DATA " List file (display characters) "," List/delete characters "
DATA " Initialize file "," Return to main menu "
DATA (reserved),(reserved),(reserved),(reserved)

SUB DisplayChar (c)
'
' View player data
'

AC = VAL(c$(c, 19))
a = INT(AC / 2): sh = ABS((a < AC / 2))
a = ABS((a < 5)) * a + ABS((a > 4)) * 4
ar$ = ar$(a): IF sh > 0 THEN ar$ = ar$ + " & Shield"

PRINT "Name: "; c$(c, 1); : LOCATE CSRLIN, 48
PRINT "Sex: "; sex$(VAL(c$(c, 16))); : LOCATE CSRLIN, 61
PRINT "Status: "; stat$(VAL(c$(c, 2))): PRINT
PRINT "Hardiness: "; c$(c, 3): LOCATE 5, 20: PRINT "Agility: "; c$(c, 4)
LOCATE 5, 37: PRINT "Charisma: "; c$(c, 5); "    (Charm Mon:";
a = (VAL(c$(c, 5)) - 10) * 2: a$ = LTRIM$(STR$(a)) + "%)"
PRINT MID$("+", ABS((a < 1)) * 1 + 1, 1); a$: PRINT

PRINT "Weapon Abilities:"; : LOCATE 7, 41: PRINT "Spell Abilities:"
PRINT "1. Axe:   "; c$(c, 10); "%": LOCATE 8, 42: PRINT "Blast... "; c$(c, 6); "%"
PRINT "2. Bow:   "; c$(c, 11); "%": LOCATE 9, 42: PRINT "Heal.... "; c$(c, 7); "%"
PRINT "3. Mace:  "; c$(c, 12); "%": LOCATE 10, 42: PRINT "Speed... "; c$(c, 8); "%"
PRINT "4. Spear: "; c$(c, 13); "%": LOCATE 11, 42: PRINT "Power... "; c$(c, 9); "%"
PRINT "5. Sword: "; c$(c, 14); "%": LOCATE 12, 24: PRINT "Gold: "; c$(c, 17);
LOCATE 12, 56: PRINT "In bank: "; c$(c, 18): PRINT

PRINT "Armour:  "; ar$: LOCATE 14, 38
PRINT "Armour Expertise: "; c$(c, 15); "%"
PRINT :  a = VAL(c$(c, 3)) * 10: a$ = LTRIM$(RTRIM$(STR$(a)))
PRINT "Weight Carryable: "; a$; " Gronds  (";
a$ = LTRIM$(RTRIM$(STR$(a * 10)))
PRINT a$; " Dos)": PRINT

PRINT "Weapon Names:             Complexity:      Type:     Dice:      Sides:"
PRINT STRING$(71, "-")
FOR w = 20 TO 23
   c$(c, w) = LTRIM$(RTRIM$(LEFT$(c$(c, w), 20)))
   IF c$(c, w) = "" THEN c$(c, w) = "NONE"
   IF c$(c, w) = "NONE" THEN
     c$(c, w + 4) = "0": c$(c, w + 8) = "0"
     c$(c, w + 12) = "0": c$(c, w + 16) = "0"
   END IF
   a$ = UCASE$(LEFT$(c$(c, w), 1)) + MID$(c$(c, w), 2)
   PRINT a$ + SPACE$(31 - LEN(a$));
   a$ = c$(c, w + 4) + "%": PRINT a$; SPC(12 - LEN(a$));
   a$ = wp$(VAL(c$(c, w + 8))): PRINT a$; SPC(11 - LEN(a$));
   PRINT c$(c, w + 12); SPC(11 - LEN(c$(c, w + 12))); c$(c, w + 16)
NEXT
END SUB

SUB EamonInput (tl, i$, columns, clr)
'
'          Eamon Deluxe text editor v2.2
'         (Modified for Character Editor)
'
TextInput:
IF clr = 0 THEN clr = 7
csr2 = POS(0): PRINT : LOCATE CSRLIN - 1
csr1 = CSRLIN
IF columns = 0 THEN columns = 80
IF csr2 + tl > columns THEN csr2 = 1
sl = LEN(i$): IF sl = 0 THEN i$ = " ": sl = 1
row = csr1: col = csr2: i = 1

COLOR clr, 0: LOCATE csr1, csr2: PRINT i$ + STRING$(tl - sl, 196)

TextInput1:
LOCATE csr1, csr2: PRINT i$ + STRING$(tl - sl, 196)
'
TextInputLoop:
IF col > columns THEN col = 1: row = row + 1
IF col < 1 THEN col = columns: row = row - 1
IF row < csr1 THEN row = csr1: col = 1
IF i$ = "" THEN i$ = " ": sl = 1: i = 1
a2$ = MID$(i$, i, 1)
LOCATE row, col: COLOR 0, clr: PRINT a2$; :  COLOR clr, 0
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
LOCATE row, col: PRINT a2$; : LOCATE row, col
'
'    Sort key presses
'
a = ASC(RIGHT$(a$, 1))
IF LEN(a$) > 1 THEN
'
'   Left and Right arrows
'
  IF a = 75 THEN
    IF i = 1 THEN GOTO ErrorRtn
    IF RIGHT$(i$, 1) = " " THEN
      i$ = LEFT$(i$, sl - 1): sl = sl - 1: PRINT CHR$(196)
    END IF
    col = col - 1: i = i - 1
    GOTO TextInputLoop
  END IF
  IF a = 77 THEN
    IF i = tl THEN GOTO ErrorRtn
    IF i = sl THEN i$ = i$ + " ": sl = sl + 1
    i = i + 1: col = col + 1
    GOTO TextInputLoop
  END IF
'
'   Up and Down arrows
'
  IF a = 72 THEN
    IF row = csr1 THEN GOTO ErrorRtn
    i$ = RTRIM$(i$): sl = LEN(i$): row = row - 1: i = i - columns
    IF i > sl THEN col = col - (i - sl): i = sl
    GOTO TextInput1
  END IF
  IF a = 80 THEN
    IF row = INT(sl / columns) + csr1 THEN GOTO ErrorRtn
    IF i + columns > sl THEN GOTO ErrorRtn
    row = row + 1: i = i + columns
    GOTO TextInput1
  END IF
'
'  <Home> & <End>
'
  IF a = 71 THEN
    IF i = 1 THEN GOTO ErrorRtn
    i$ = RTRIM$(i$): sl = LEN(i$)
    i = 1: row = csr1: col = csr2: GOTO TextInput1
  END IF
  IF a = 79 THEN
    IF i = tl THEN GOTO ErrorRtn
    row = csr1: col = csr2 + sl - 1
    i = sl: GOTO TextInputLoop
  END IF
'
'   Delete
'
   IF a = 83 THEN
     IF i = sl GOTO ErrorRtn
     i$ = MID$(i$, 1, i - 1) + MID$(i$, i + 1)
     sl = sl - 1
     GOTO TextInput1
   END IF
'
'  F1 and F2  (Toggles for extened/regular ASCII mode)
'
  IF a = 59 THEN
    x = 127: IF ASC(MID$(i$, i, 1)) > 127 THEN x = -x
    i$ = LEFT$(i$, i - 1) + CHR$(ASC(MID$(i$, i, 1)) + x) + MID$(i$, i + 1)
    GOTO TextInputLoop
  END IF
  IF a = 60 THEN
    a$ = ""
    FOR a = 1 TO sl
       x = 127: IF ASC(MID$(i$, a, 1)) > 127 THEN x = -x
       a$ = a$ + CHR$(ASC(MID$(i$, a, 1)) + x)
    NEXT
    i$ = a$: GOTO TextInput1
  END IF
  GOTO ErrorRtn
END IF
'
'   Backspace
'
IF a = 8 THEN
  IF i = 1 GOTO ErrorRtn
  i$ = MID$(i$, 1, i - 2) + MID$(i$, i)
  i = i - 1: sl = sl - 1: col = col - 1
  GOTO TextInput1
END IF
'
'    TAB key (insert space)
'
IF a = 9 THEN
  IF i = tl OR i = sl OR sl = tl THEN GOTO ErrorRtn
  IF i = 1 THEN i$ = " " + i$
  IF i > 1 THEN i$ = MID$(i$, 1, i - 1) + " " + MID$(i$, i)
  sl = sl + 1: LOCATE csr1, csr2: PRINT i$;
  GOTO TextInputLoop
END IF
'
'  <ENTER> accepts text from beginning to cursor)
'    <ESC> accepts all text)
'
IF a = 13 THEN
  i$ = LEFT$(i$, i - 1 * ABS(i < tl))
  GOTO TextInputDone
END IF
IF a = 27 THEN GOTO TextInputDone
'
'  Add valid characters to string
'
IF a < 32 THEN GOTO ErrorRtn
IF i = tl THEN
  i$ = MID$(i$, 1, i - 1) + a$: PRINT a$; : GOTO TextInputLoop
END IF
IF i < sl THEN
  IF i = 1 THEN i$ = a$ + MID$(i$, 2)
  IF i > 1 THEN i$ = MID$(i$, 1, i - 1) + a$ + MID$(i$, i + 1)
END IF
IF i = sl THEN
  i$ = LEFT$(i$, sl - 1) + a$ + " ": sl = sl + 1
END IF
i = i + 1: col = col + 1: PRINT a$; : GOTO TextInputLoop
'
'     Invalide keys/move
'
ErrorRtn:
SOUND 800, .5: GOTO TextInputLoop
'
'     Display string
'
TextInputDone:
LOCATE csr1, csr2: PRINT STRING$(tl, 32)
i$ = LTRIM$(RTRIM$(i$)): LOCATE csr1, csr2: PRINT i$: PRINT
END SUB

SUB EditChar (c)
'
'   Edit a character
'
FOR x = 28 TO 31
   IF VAL(c$(c, x)) < 1 OR VAL(c$(c, x)) > 5 THEN c$(c, x) = "1"
NEXT
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "  <Enter/Spacebar=Change a Name>   <Plus/Minus=Change a Value>   <Escape=Done>  "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Tab, Home, or End to select>"; SPACE$(24);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0: LOCATE 3, 1
CALL DisplayChar(c)
L = 1

EditLoop:
LOCATE f(L, 1), f(L, 2): PRINT SPACE$(f(L, 9)); : LOCATE f(L, 1), f(L, 2)
COLOR 0, 3: GOSUB EditDisp: COLOR 3, 0
IF L = 5 THEN
  LOCATE 5, 52: PRINT "(Charm Mon:"; : a = (VAL(c$(c, 5)) - 10) * 2
  a$ = LTRIM$(STR$(a)) + "%)": PRINT MID$("+", ABS((a < 1)) * 1 + 1, 1); a$
END IF
DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN
      CALL DisplayChar(c): min = min - 1: GOTO EditLoop
    END IF
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : a$ = INKEY$
LOOP UNTIL a$ <> ""
a = ASC(RIGHT$(a$, 1))
COLOR 3, 0: LOCATE f(L, 1), f(L, 2): GOSUB EditDisp: LOCATE f(L, 1), f(L, 2)
IF a = 27 THEN EXIT SUB

'
'   Arrow keys, home, end, tab
'
IF LEN(a$) > 1 THEN
  IF a = 72 THEN L = f(L, 3)
  IF a = 80 THEN L = f(L, 4)
  IF a = 77 THEN L = f(L, 5)
  IF a = 75 OR a = 15 THEN L = f(L, 6)
  IF a = 71 THEN L = 1
  IF a = 79 THEN L = 39
  GOTO EditLoop
END IF
IF a = 9 THEN L = f(L, 5): GOTO EditLoop

' Change character name/gold/bank/weapon names
IF a = 13 OR a = 32 THEN
  IF L = 1 THEN CALL EamonInput(40, c$(c, 1), 80, 2): GOTO EditLoop
  IF L = 17 OR L = 18 THEN
    CALL EamonInput(5, c$(c, L), 80, 2): k = VAL(c$(c, L))
    IF k < f(L, 7) THEN k = f(L, 8)
    IF k > f(L, 8) THEN k = f(L, 7)
    c$(c, L) = LTRIM$(RTRIM$(STR$(k))): GOTO EditLoop
  END IF
  IF L > 19 AND L < 24 THEN CALL EamonInput(20, c$(c, L), 80, 2): GOTO EditLoop
  SOUND 250, 1: GOTO EditLoop
END IF

x = INSTR("-_=+", CHR$(a))
IF x = 0 OR L = 1 OR (L > 19 AND L < 24) THEN SOUND 250, 1: GOTO EditLoop
k = VAL(c$(c, L)): IF x < 3 THEN k = k - 1
IF x > 2 THEN k = k + 1
IF k < f(L, 7) THEN k = f(L, 8)
IF k > f(L, 8) THEN k = f(L, 7)
c$(c, L) = LTRIM$(RTRIM$(STR$(k)))
IF L = 3 THEN
  LOCATE 16, 1: PRINT SPACE$(79): LOCATE 16, 1
  PRINT "Weight Carryable: "; LTRIM$(RTRIM$(STR$(k * 10))); " Gronds  (";
  PRINT LTRIM$(RTRIM$(STR$(k * 100))); " Dos)"
END IF
'SOUND 60, .7
GOTO EditLoop


'
'  Display some values as labels (e.g. sex & armor)
'
EditDisp:
IF L = 2 THEN PRINT stat$(VAL(c$(c, 2))): RETURN
IF L = 16 THEN PRINT sex$(VAL(c$(c, 16))): RETURN
IF L = 19 THEN
  AC = VAL(c$(c, 19))
  x = INT(AC / 2): sh = ABS((x <> AC / 2))
  x = ABS((x < 5)) * x + ABS((x > 4)) * 4
  ar$ = ar$(x): IF sh > 0 THEN ar$ = ar$ + " & Shield"
  PRINT ar$: RETURN
END IF
IF L > 27 AND L < 32 THEN PRINT wp$(VAL(c$(c, L))); : RETURN
PRINT c$(c, L);
IF (L > 5 AND L < 15) OR L = 15 OR (L > 23 AND L < 28) THEN PRINT "%"
RETURN
END SUB

SUB EDX.Select.Char (c)
'/// Eamon Deluxe Character Selection
'
keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
be = 1: en = numchars
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

SelectCHRa:
GOSUB SelectCHR0

SelectCHR:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT c$(c, 1);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB SelectCHR0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT c$(c, 1);

'         Set arguments and exit
IF k < 3 THEN
  IF k = 1 THEN c = 0
  VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO SelectCHRa
IF k = 4 AND en < numchars THEN be = be + 42: GOTO SelectCHRa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO SelectCHR

'       Set up screen
SelectCHR0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "   <Enter=Accept>   <Escape=New Character>   <Page Up/Page Down=More Options>   "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
SelectCHR1:
IF be < 1 THEN be = 1
IF be > numchars THEN be = numchars
en = be + 41: IF en > numchars THEN en = numchars
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT c$(x, 1); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  x = RND                               ' Randomize RND seed
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB EDXpause
PRINT "(Hit any key to continue)";
DO
LOOP UNTIL INKEY$ <> ""
PRINT
END SUB

SUB GetKey (k$)
'
' Get a keypress
'
BS = POS(0)
DO
   CC# = CC# + 1
   IF CC# = cc1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = cc2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = cc3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = LCASE$(INKEY$)
LOOP UNTIL k$ = "y" OR k$ = "n"
PRINT k$
END SUB

SUB InitData
'             // Initialize data
'
' (All character data is converted to strings for easier editing)
'
Init:
OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
FOR r = 1 TO numchars
   GET #1, r, z
   c$(r, 1) = LTRIM$(RTRIM$(z.CNAME)): c$(r, 2) = STR$(z.STATUS)
   c$(r, 3) = STR$(z.A1): c$(r, 4) = STR$(z.a2): c$(r, 5) = STR$(z.A3)
   c$(r, 6) = STR$(z.SP1): c$(r, 7) = STR$(z.SP2): c$(r, 8) = STR$(z.SP3)
   c$(r, 9) = STR$(z.SP4): c$(r, 10) = STR$(z.WA1): c$(r, 11) = STR$(z.WA2)
   c$(r, 12) = STR$(z.WA3): c$(r, 13) = STR$(z.WA4): c$(r, 14) = STR$(z.WA5)
   c$(r, 15) = STR$(z.AE): c$(r, 16) = STR$(z.sex): c$(r, 17) = STR$(z.Gold)
   c$(r, 18) = STR$(z.bank): c$(r, 19) = STR$(z.AC)
   c$(r, 20) = RTRIM$(z.WN1): c$(r, 21) = RTRIM$(z.WN2)
   c$(r, 22) = RTRIM$(z.WN3): c$(r, 23) = RTRIM$(z.WN4)
   c$(r, 24) = STR$(z.WCOMPLX1): c$(r, 25) = STR$(z.WCOMPLX2)
   c$(r, 26) = STR$(z.WCOMPLX3): c$(r, 27) = STR$(z.WCOMPLX4)
   c$(r, 28) = STR$(z.WTYPE1): c$(r, 29) = STR$(z.WTYPE2)
   c$(r, 30) = STR$(z.WTYPE3): c$(r, 31) = STR$(z.WTYPE4)
   c$(r, 32) = STR$(z.WDICE1): c$(r, 33) = STR$(z.WDICE2)
   c$(r, 34) = STR$(z.WDICE3): c$(r, 35) = STR$(z.WDICE4)
   c$(r, 36) = STR$(z.WSIDES1): c$(r, 37) = STR$(z.WSIDES2)
   c$(r, 38) = STR$(z.WSIDES3): c$(r, 39) = STR$(z.WSIDES4)
   FOR x = 1 TO 39: c$(r, x) = LTRIM$(RTRIM$(c$(r, x))): NEXT
NEXT
CLOSE #1

sex$(0) = "Male": sex$(1) = "Female"
stat$(1) = "Ok": stat$(2) = "Dead": stat$(3) = "Adventuring"
FOR x = 1 TO 5: READ wp$(x): NEXT
FOR x = 0 TO 4: READ ar$(x): NEXT
FOR x = 1 TO 4: READ s$(x): NEXT
FOR x = 1 TO 39
   FOR a = 1 TO 9: READ f(x, a): NEXT
NEXT
END SUB

