' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                   by Frank Black Productions                   
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'  THE EAMON DELUXE MAIN HALL OF THE GUILD OF FREE ADVENTURERS   
'     by Frank Black                                             
'                                         Update: 13 JAN 2012    
' Inspired by and a tribute to:         (Friday the 13th EEEEK!) 
'  THE EAMON MAIN HALL by Donald Brown                           
'  THE EAMON GRAPHIC MAIN HALL by Rick Volbering                 
'                                                                
'                                          Revision: 30 JAN 2012 
'                                            Update: 11 DEC 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation,Inc., 59 Temple Place-Suite 330, Boston, MA 02111-1307,USA
'

DECLARE SUB Text.Main.Hall ()
DECLARE SUB Initialize ()
DECLARE SUB InitGMH ()
DECLARE SUB Graphic.Main.Hall ()
DECLARE SUB DrawRoom ()
DECLARE SUB HRT ()
DECLARE SUB Moire ()
DECLARE SUB Update ()
DECLARE SUB EDX.Select.Adventure ()
DECLARE SUB KeyWait ()
DECLARE SUB GetKey ()
DECLARE SUB GMH.Look ()
DECLARE SUB DispString ()
DECLARE SUB LPcheck ()
DECLARE SUB GetDirection ()
DECLARE SUB Marcos ()
DECLARE SUB Hokas.Tokas ()
DECLARE SUB Shylock ()
DECLARE SUB Examine.Character ()
DECLARE SUB Casino ()
DECLARE SUB Witch ()
DECLARE SUB Grendel ()
DECLARE SUB Weapon.Training ()
DECLARE SUB Magic.Training ()
DECLARE SUB Armor.Training ()
DECLARE SUB Info.Booth ()

TYPE RECORD
  cname AS STRING * 40: status AS INTEGER: a1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER: WA4 AS INTEGER
  WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG: BANK AS LONG
  ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20: WN3 AS STRING * 20
  WN4 AS STRING * 20: WCOMPLX1 AS INTEGER: WCOMPLX2 AS INTEGER
  WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER: WTYPE1 AS INTEGER
  WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER: WDICE1 AS INTEGER
  WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER: WSIDES1 AS INTEGER
  WSIDES2 AS INTEGER: WSIDES3 AS INTEGER: WSIDES4 AS INTEGER
END TYPE
DIM SHARED c AS RECORD

TYPE adv
  ANAME AS STRING * 78: NUMBER AS INTEGER
END TYPE
DIM SHARED adv AS adv


'         Variables shared by both text and graphic halls
'       ---------------------------------------------------
DIM SHARED sp%(4), wa%(5), wn$(5), wc%(5), wt%(5), wd%(5), ws%(5), s%(10), xc
DIM SHARED AR$(4), GEN$(1), sex$(1), n$, STAT, hd, ag, ch, ae, sex, gold, a
DIM SHARED BANK, ac, q$, sp$(4), rec, numadv, a$, dly#, CC1#, CC2#, cc3#, lp, cp
DIM SHARED HallCode, statue

CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
GET #2, 1, adv
numadv = adv.NUMBER
DIM SHARED AN$(numadv), ANUM(numadv)
FOR a = 2 TO numadv + 1
   GET #2, a, adv
   AN$(a - 1) = RTRIM$(adv.ANAME$): ANUM(a - 1) = adv.NUMBER
NEXT
CLOSE #2: CHDIR "MAIN"

OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, cc3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE
'
'                Graphic Main Hall variables
'              -------------------------------
DIM SHARED map%(3, 9, 22), m%(9, 22, 2), ab$(90), a%(12, 4), a1, a2, l
DIM SHARED ro, textsize, textcolor1, col, row, anm2#, anm1#, ss2#, ss1#, x1
DIM SHARED y1, mv1, mv2, F$, shapes, height%, shapewidth%, size%, mode, info1

CALL Initialize
OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
IF s%(4) = 1 THEN s%(1) = 0: s%(2) = 1: s%(3) = 7

TSwitch:
IF s%(2) = 1 THEN
  cp = 79: lp = 24: CALL Text.Main.Hall: IF HallCode = 2 THEN HallCode = 1
END IF

IF HallCode = 0 THEN
  ' Load appropriate tile set (CGA or EGA/VGA) for Graphic Main Hall
  '------------------------------------------------------------------
  '(EGA/VGA 640x350 resolution was dropped to 320x200 to make it easier)
  IF s%(1) = 9 THEN s%(1) = 7
  IF s%(1) <> 1 AND s%(1) <> 7 THEN GOTO ScreenError1
  F$ = "hall-cga.shp": IF s%(1) > 1 THEN F$ = "hall-ega.shp"
  OPEN F$ FOR INPUT AS #2
      INPUT #2, shapes, height%, shapewidth%, size%, mode
  CLOSE #2
  DIM SHARED tile%(1 TO shapes * size%)
END IF

'         Make sure graphics mode will work
'        ------------------------------------
GSwitch:
ON ERROR GOTO ScreenError
SCREEN mode: ON ERROR GOTO 0
cp = 40: lp = 5: s%(2) = 2: CALL Graphic.Main.Hall
IF HallCode = 1 THEN HallCode = 2
GOTO TSwitch

ScreenError:
RESUME ScreenError1
ScreenError1:
ON ERROR GOTO 0: CLS : PRINT "Error initializing graphics mode."
CALL KeyWait: s%(2) = 1: GOTO TSwitch

DATA Clothes,Leather,Chain Mail,Plate Mail,Magic/Exotic


'
'            Drawing coordinates for HRT routine
'           -------------------------------------
DATA br1d2r1bd2l1r1bu2u2l1,"","","","","",bd2e1u1,"","","","",bd5e1u1,""
DATA bd3f1u1d1l1e1l1d1,"","","","","","","","","","","","",bd5e1u1bu2u1,""
DATA bd1r3bd2l3,"",bd4br1r1bu2e1h1l1bd1c0d3c10,"",bd4br3u2l3d2u3e1r1f1d1
DATA d4r1e1h1e1h1l1,br2l1g1d2f1r1,d4r1e2h2l1
DATA d4r2bu2l2u2r2,r2l2d2r2l2d2,bd1e1r2l2g1d2f1r2u2l1,d4u2r2u2d4,r2l1d4r1l2
DATA bd2d1f1e1u3r1l3,d4u2r1e1u1d1g1f1d1,d4r2,d4u4f2e2d4,d4u4f3d1u4
DATA bd1d2f1r1e1u2h1l1g1,r1f1g1l1d2u4,bd1d2f1r2e1u2h1l2g1bf2f1
DATA d4u2r1f1d1u1h1e1h1l1,br2l1g1f1r1d1g1l1,r1d4u4r1,d3f1r1e1u3
DATA d3f1e1u3,d4e2f2u4,d1f2d1u1h1g1d1u1e2u1,d1f1d2u2e1u1,r3g3d1r3
'
'                    MAIN HALL MAP
'
DATA  19,19,19,19,19,19,19,19,24,20,20,20,24,19,19,19,19,19,19,19,19,19
DATA  19,20,20,20,11,20,20,20,20,20,20,20,20,20,20,20,19,20,20,20,20,19
DATA  19,20,40, 2,12,20,20,20,24,21,22,23,24,20,20,20,19,20,29,30,20,19
DATA  19,20,20,20,13,20,20,20,11,20, 6,20,11,20,20,20,11,20,20,20,20,19
DATA  19,19,19,19,19,20,20,32,12,20, 1,20,12,32,20,20,12,39,20,20,20,19
DATA  19,20,20,20,11,20,20,20,17,16,16,16,18,20,20,20,13,20,20,20,20,19
DATA  19,28,28, 4,12,20,20,20,20,32,32,32,20,20,20,20,19,20,31,31,20,19
DATA  19,28,28,20,13,20,20,20,20,20,20,20,20,20,20,20,19,20,20,20,20,19
DATA  19,19,19,19,19,19,19,19,24,20,20,20,24,19,19,19,19,19,19,19,19,19
'
'                    VILLAGE MAP
'
DATA  25,25,25,25,25,25,25,25,24,20,20,20,24,25,25,25,25,25,25,25,25,25
DATA  25,20,20,20,11,20,20,20,20,20,20,20,20,20,20,20,25,29,30,29,30,25
DATA  25,34,20, 4,12,20,20,20,20,20,20,20,20,20,20,20,25,30,29,30,29,25
DATA  25,34,34,34,13,20,20,20,20,20,49,20,20,20,20,20,11,20,20,20,20,25
DATA  25,25,25,25,25,20,20,20,45,46,48,46,47,20,20,20,12, 5,20,33,20,25
DATA  25,20,20,20,11,20,20,20,20,20,20,20,20,20,20,20,13,20,20,20,20,25
DATA  25,20,20, 3,12,20,20,20,20,20,20,20,20,20,20,20,25,20,20,20,20,25
DATA  25,20,35,20,13,20,20,20,20,20,20,20,20,20,20,20,25,20,20,20,20,25
DATA  25,25,25,25,25,25,25,25,24,20,20,20,24,25,25,25,25,25,25,25,25,25
'
'                    PRACTICE AREA MAP
'
DATA  26,26,26,26,26,26,26,26,24,20,20,20,24,26,26,26,26,26,26,26,26,26
DATA  26,20,20,20,11,20,20,20,20,20,20,20,20,20,20,20,26,31,31,31,31,26
DATA  26,35,20, 2,12,20,20,20,20,20,20,20,20,20,20,20,26,20,20,20,20,26
DATA  26,21,36,23,13,20,20,20,14,16,16,16,15,20,20,20,11,20,20,20,20,26
DATA  26,26,26,26,26,20,20,20,12,20, 1,20,12,20,20,20,12, 7,20,20,20,26
DATA  26,29,30,20,11,20,20,20,17,16,16,16,18,20,20,20,13,20,20,20,20,26
DATA  26,20,20, 8,12,20,20,20,20,20,20,20,20,20,20,20,26,20,20,20,20,26
DATA  26,30,29,20,13,20,20,20,20,20,20,20,20,20,20,20,26,31,31,31,31,26
DATA  26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26
'
'             Animation data  (4 per room)
'      Format is:  Tile #1, Tile #2, Row, Column
'
DATA 2,37,3,4,  38,4,7,4,  39,1,5,18,  27,40,3,3
DATA 38,4,3,4,  41,3,7,4,  42,5,5,18,  50,48,5,11
DATA 2,37,3,4,  44,8,7,4,  43,7,5,18,  39,1,5,11

SUB Armor.Training
'
'                Randomly increase armor expertise
'               ------------------------------------
CLS 2: l = 1
a$ = "A giant steps forward and says, " + q$ + "Me good teacher.  You need "
a$ = a$ + "help with armor skills?  Good, I teach for 1000 gold pieces per "
a$ = a$ + "strike.  Come with me!" + q$
l = 0: CALL DispString: CALL KeyWait
a$ = "He takes you to an open area in the shop and says, " + q$ + "Try and make me miss you!" + q$
CALL DispString: CALL KeyWait

ArmT0:
CLS 2: l = 1: PRINT "Ability: "; RTRIM$(LTRIM$(STR$(ae))); "        ";
PRINT "Gold: "; RTRIM$(LTRIM$(STR$(gold))): PRINT
IF gold < 1000 THEN
  PRINT q$; "You not carry enough gold!"; q$
  CALL KeyWait: GOTO ArmT2
END IF
PRINT "(H)it         (R)est         (S)top": PRINT
PRINT "Enter H, R, or S:"; : CALL GetKey: CLS 2: l = 1

IF a$ = "S" THEN GOTO ArmT2
IF a$ = "R" THEN
  a$ = "CLANK ... PUFF ... CLANK.  " + q$ + "You okay?" + q$
  CALL DispString: CALL KeyWait: GOTO ArmT0
END IF
IF a$ <> "H" THEN GOTO ArmT0

k = INT(RND * 10 + 1): gold = gold - 1000
IF k = 10 THEN a$ = q$ + "Dat was real good!" + q$: ae = ae + 2
IF k > 5 AND k < 10 THEN a$ = q$ + "Good!  You getting it!" + q$: ae = ae + 1
IF k < 6 THEN a$ = q$ + "You need move much faster!  Now get up!" + q$

IF ae > 65 THEN ae = 65
CALL DispString: CALL KeyWait: GOTO ArmT0

ArmT2:
CLS 2: l = 1: PRINT q$; "Me sorry see you go.  Bye now!"; q$
END SUB

SUB Casino
'
'                       SCHMITTY'S CASINO
'                      -------------------
CLS 2: l = 1: a$ = "Schmitty, the owner, says, " + q$ + "Welcome, " + n$ + "!  Perhaps a cocktail before you start?" + q$
CALL DispString: CALL KeyWait
a$ = "Some time later you make your way to the floor of the casino and stop at the roulette wheel..."
CALL DispString: CALL KeyWait
a$ = q$ + "Place your bets!  Place your bets!  Would you like in " + sex$(sex) + "One?" + q$
CALL DispString: CALL KeyWait

Bet1:
a$ = "You have " + LTRIM$(RTRIM$(STR$(gold))) + " gold pieces.  The house limit is 10,000."
CALL DispString: PRINT
LINE INPUT "Your bet? (0 to leave):"; a$: bet = INT(VAL(a$))
CLS 2: l = 1: IF bet < 0 OR bet > gold OR bet > 10000 THEN GOTO Bet1
IF bet = 0 THEN EXIT SUB

PRINT "The wheel is spinning ..."
IF s%(4) <> 1 THEN
  FOR a = 1 TO 4
     FOR z = 50 TO 600 STEP 20: SOUND z, .5: NEXT
     FOR z = 600 TO 50 STEP -20: SOUND z, .5: NEXT
  NEXT
END IF
rl = INT(RND * 100) + 1

IF rl > 80 THEN
  a$ = "You just won double your money!": bet = bet * 2: GOTO Bet2
END IF

IF rl > 55 THEN
  a$ = "You won" + STR$(bet) + " gold pieces!": GOTO Bet2
END IF

a$ = "Sorry, " + n$ + ", you lost.": bet = -bet

Bet2:
CALL DispString: CALL KeyWait: gold = gold + bet: GOTO Bet1
END SUB

SUB DispString
'
'           Print a$ string in 40/80 columns
'     -------------------------------------------
PS:
IF LEN(a$) <= cp THEN PRINT a$: CALL LPcheck: EXIT SUB
FOR k = cp TO 1 STEP -1
   IF MID$(a$, k, 1) = " " THEN
      PRINT LEFT$(a$, k - 1): a$ = RIGHT$(a$, LEN(a$) - k)
      CALL LPcheck: GOTO PS
   END IF
NEXT
END SUB

SUB DrawRoom
'
'                THIS IS A SUB FOR THE GRAPHIC MAIN HALL
'               -----------------------------------------
FOR x1 = 1 TO 9
   FOR y1 = 1 TO 22
      PUT (m%(x1, y1, 2), m%(x1, y1, 1)), tile%(map%(ro, x1, y1)), PSET
   NEXT
NEXT
textcolor1 = 10
IF ro = 1 THEN
  col = 1.5: row = 11: textsize = 2
  LINE (3, 138)-(108, 149), 0, BF: a$ = "MAIN HALL": CALL HRT
  LINE (17, 27)-(46, 33), 0, BF
  textsize = 1: col = 4: row = 5: a$ = "MAGIC": CALL HRT
  LINE (16, 90)-(40, 96), 0, BF: col = 4: row = 14: a$ = "BANK": CALL HRT
  LINE (244, 26)-(285, 34), 0, BF
  col = 42: row = 5: a$ = "WEAPONS": CALL HRT
  LINE (251, 117)-(285, 125), 0, BF
  col = 43: row = 18: a$ = "ARMOUR": CALL HRT
  textcolor1 = 14: IF mode = 1 THEN textcolor1 = 2
  col = 24: row = 14: a$ = "BAR": CALL HRT
END IF
IF ro = 2 THEN
  col = 1.5: row = 11: textsize = 2
  LINE (3, 138)-(88, 149), 0, BF: a$ = "VILLAGE": CALL HRT
  LINE (17, 27)-(53, 33), 0, BF
  textsize = 1: col = 4: row = 5: a$ = "CASINO": CALL HRT
  LINE (16, 90)-(46, 96), 0, BF: col = 4: row = 14: a$ = "WITCH": CALL HRT
  LINE (239, 117)-(290, 125), 0, BF
  col = 41: row = 18: a$ = "GRENDEL'S": CALL HRT
  LINE (244, 124)-(279, 132), 0, BF
  col = 42: row = 19: a$ = "SMITHY": CALL HRT
END IF
IF ro = 3 THEN
  col = 1.5: row = 11: textsize = 2: LINE (3, 138)-(160, 149), 0, BF
  a$ = "PRACTICE AREA": CALL HRT: textsize = 1
  textcolor1 = 14: textcolor1 = 14: IF mode = 1 THEN textcolor1 = 2
  col = 23.5: row = 14: a$ = "INFO": CALL HRT
END IF
END SUB

SUB EDX.Select.Adventure
'
'             This SUB is shared by both Main Halls
'            ---------------------------------------
CLS : l = 0
'          (Update PLAYERS file before proceeding)
CALL Update: PUT #1, rec, c: CLOSE #1

' (Updated for VI Mode support 07 JAN 2012)
'
'            Load adventure names
CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
   GET #2, 1, adv: numadv = adv.NUMBER: numadv1 = numadv
   REDIM advn$(numadv)
   FOR x = 2 TO numadv + 1
      GET #2, x, adv
      advn$(x - 1) = LEFT$(LTRIM$(RTRIM$(adv.ANAME$)), 38)
   NEXT
CLOSE #2
CHDIR "MAIN"
keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

' VI Mode numeric menu
GetAdvCVI:
IF s%(4) = 1 THEN
  CLS : l = 2: PRINT "Please select an adventure:"
  FOR x = 1 TO numadv
     a$ = LTRIM$(RTRIM$(STR$(x))) + ": " + advn$(x)
     IF x < 10 THEN a$ = " " + a$
     IF x < 100 THEN a$ = " " + a$
     PRINT a$: l = l + 1
     IF l = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; a$
  x = INT(VAL(a$))
  IF x < 0 OR x > numadv THEN CLS : GOTO GetAdvCVI
  IF x = 0 THEN RUN
  CLS : v = 1: h = 1: xc = x: k = 2: GOTO SelectADV1
END IF

SelectADVa:
GOSUB SelectADV0

SelectADV:
IF xc < be THEN xc = en
IF xc > en THEN xc = be
x = ABS(xc > be + 20): v = 3 + (xc - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(xc);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB SelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

SelectADVaVI:
LOCATE v, h: COLOR 3, 0: PRINT advn$(xc);

'         Set arguments and exit
SelectADV1:
IF k < 3 THEN
  k$ = LTRIM$(RTRIM$(STR$(xc))): ad$ = LEFT$("E000", 4 - LEN(k$)) + k$
  VIEW PRINT 1 TO 25: CLS
  IF k = 1 THEN xc = 0: ad$ = "": EXIT SUB
  GOTO SelectADV2
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO SelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO SelectADVa
'          Home/end
IF k = 5 THEN xc = be
IF k = 6 THEN xc = en
'         Up/down/left/right
IF k > 8 AND xc < be + 21 AND xc + 21 > en THEN k = k - 2
IF k = 7 THEN xc = xc - 1
IF k = 8 THEN xc = xc + 1
IF k = 9 THEN xc = xc - 21 + 42 * ABS(xc < be + 21)
IF k = 10 THEN xc = xc + 21 - 42 * ABS(xc > be + 21)
GOTO SelectADV

'       Set up screen
SelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
xc = be: RETURN

'                 ---------------------------
'                     START AN ADVENTURE
'                 ---------------------------
SelectADV2:
'     (Make sure directory exists before changing char. status)
CHDIR "..": CHDIR ad$

'     (Make sure other characters aren't in adventure already)
OPEN "GAMEDIR.DAT" FOR INPUT AS #2: INPUT #2, a: CLOSE #2
IF a <> -1 THEN
  OPEN "NEW-MEAT" FOR RANDOM AS #4 LEN = 200: GET #4, 1, c: CLOSE #4
  IF c.status > -1 THEN
    COLOR 14: PRINT : PRINT "You already have a character adventuring there."
    PRINT "(Character: "; RTRIM$(c.cname); ")": PRINT : COLOR s%(3)
    CHDIR "..": CHDIR "MAIN": CALL KeyWait: RUN
  END IF
END IF

'     (Change char. status to "on adventure")
CHDIR "..\MAIN"
CLOSE #1: OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
GET #1, rec, c: c.status = 3: PUT #1, rec, c: CLOSE

' Change to adventure directory, init NEW-MEAT file (hold's char. data, with
'  status changed to record # in PLAYERS.DAT file), and make sure no old
'  saved games exist
CHDIR "..\" + ad$
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: c.status = rec: PUT #1, 1, c
CLOSE : OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, -1
FOR m = 1 TO 5: PRINT #1, "(none)": NEXT: CLOSE
'
' Make sure system settings are current
OPEN "SETTINGS.DAT" FOR OUTPUT AS #1
  PRINT #1, dly#, CC1#, CC2#, cc3#: FOR x = 1 TO 10: WRITE #1, s%(x): NEXT
CLOSE
RUN "INTRO"

END SUB

SUB Examine.Character
'
COLOR s%(3)
FOR a = 1 TO 4
   sp$(a) = LTRIM$(STR$(sp%(a))) + "%"
   IF sp%(a) < 1 THEN sp$(a) = "None"
NEXT
a = INT(ac / 2): SH = ABS((a < ac / 2))
a = ABS((a < 5)) * a + ABS((a > 4)) * 4
AR$ = AR$(a)
IF SH > 0 THEN AR$ = AR$ + " & Shield"
ea = -5 * ABS((AR * 2 <> ac))
IF AR > 0 THEN
   ea = ea - AR * 10: IF AR = 3 THEN ea = ea - 30
END IF

CLS : PRINT "You are the "; sex$(sex); n$: PRINT
PRINT "Hardiness: "; hd: LOCATE 3, 20: PRINT "Agility: "; ag
LOCATE 3, 37: PRINT "Charisma: "; ch; "   (Charm Mon:";
a = (ch - 10) * 2
a$ = LTRIM$(STR$(a)) + "%)"
PRINT MID$("+", ABS((a < 1)) * 1 + 1, 1); a$: PRINT

PRINT "Weapon Abilities:"; : LOCATE 5, 41: PRINT "Spell Abilities:"
PRINT " Axe:  "; LTRIM$(STR$(wa%(1))); "%"
PRINT " Bow:  "; LTRIM$(STR$(wa%(2))); "%"
PRINT " Mace: "; LTRIM$(STR$(wa%(3))); "%"
PRINT " Spear:"; LTRIM$(STR$(wa%(4))); "%"
PRINT " Sword:"; LTRIM$(STR$(wa%(5))); "%"
LOCATE 6, 42: PRINT "Blast..."; sp$(1);
LOCATE 7, 42: PRINT "Heal...."; sp$(2);
LOCATE 8, 42: PRINT "Speed..."; sp$(3);
LOCATE 9, 42: PRINT "Power..."; sp$(4);
LOCATE 10, 24: PRINT "Gold:"; gold
LOCATE 10, 56: PRINT "In bank:"; BANK: PRINT

a$ = RTRIM$(STR$(ae)) + "%"
PRINT "Armor:  "; AR$: LOCATE 12, 34: PRINT "Armour Expertise: "; a$
PRINT : a = hd * 10: a$ = LTRIM$(RTRIM$(STR$(a)))

PRINT "Weight Carryable: "; a$; " Gronds  (";
a$ = LTRIM$(RTRIM$(STR$(a * 10)))
PRINT a$; " Dos)": PRINT

PRINT "Weapon Names:             Complexity:         Damage:   Base Odds to hit:"
FOR a = 1 TO 74: PRINT "-"; : NEXT: PRINT
FOR w = 1 TO 4
   IF wn$(w) = "" OR wn$(w) = "NONE" THEN GOTO WLoop
   IF LEN(wn$(w)) > 30 THEN wn$(w) = LEFT$(wn$(w), 30)
   PRINT wn$(w); SPC(31 - LEN(wn$(w)));
   a$ = LTRIM$(RTRIM$(STR$(wc%(w)))) + "%"
   PRINT a$; SPC(18 - LEN(a$));
   a$ = LTRIM$(RTRIM$(STR$(wd%(w)))) + "D" + LTRIM$(RTRIM$(STR$(ws%(w))))
   PRINT a$; SPC(14 - LEN(a$));
   '
   '          %% COMPUTE ARMOR FACTOR %%
   ar1% = ac / 2: sh1% = ABS(ar1% <> ac / 2): IF ar1% > 3 THEN ar1% = 3
   af% = (-5 * sh1% - ar1% * 10 - (30 * ABS(ar1% = 3)))
   '          %% COMPUTE BASE ODDS TO HIT %%
   x = ag: a = wa%(wt%(w)): sh1% = wc%(w)
   x = x + ((30 - x) * ABS(x > 30)): a = a + ((100 - a) * ABS(a > 100))
   sh1% = sh1% + ((25 - sh1%) * ABS(sh1% > 25))
   odds% = 50 + 2 * (x - ar1%): odds% = odds% + ((af% + ae) * ABS(-af% > ae))
   odds% = odds% + a / 4: odds% = odds% + sh1% / 2
   'IF odds% > 100 THEN odds% = 100
   '
   PRINT LTRIM$(RTRIM$(STR$(odds%))); "%"
WLoop:
NEXT: CALL KeyWait
END SUB

SUB GetDirection
'
'                THIS IS A SUB FOR THE GRAPHIC MAIN HALL
'               -----------------------------------------
IF s%(2) = 1 THEN EXIT SUB
PRINT "Which direction? - "; : k$ = INKEY$: : a = 0
DL:
DO
  a$ = RIGHT$(INKEY$, 1)
LOOP UNTIL a$ <> ""
  k = ASC(a$)
  IF k = 56 OR k = 72 THEN PRINT "North.": a = 1: x1 = x1 - 1
  IF k = 50 OR k = 80 THEN PRINT "South.": a = 1: x1 = x1 + 1
  IF k = 54 OR k = 77 THEN PRINT "East.": a = 1: y1 = y1 + 1
  IF k = 52 OR k = 75 THEN PRINT "West.": a = 1: y1 = y1 - 1
  IF a = 0 THEN GOTO DL
l = 0
END SUB

SUB GetKey
'
' Get a single keypress, randomize RND seed while waiting

'  VI Mode - Skip twirly cursor rtn
IF s%(4) = 1 THEN
   a$ = INKEY$: a$ = ""
  DO
   a$ = UCASE$(INKEY$): xx = RND
  LOOP UNTIL a$ <> ""
  PRINT a$: EXIT SUB
END IF

BS = POS(0): CC = 0: a$ = INKEY$
DO
   CC = CC + 1
   IF CC = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC = cc3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC = 0
   a$ = UCASE$(INKEY$): xx = RND
LOOP UNTIL a$ <> ""
PRINT a$
END SUB

SUB GetNumber
'
'                THIS IS A SUB FOR THE GRAPHIC MAIN HALL
'               -----------------------------------------
PRINT "Enter "; LTRIM$(RTRIM$(STR$(a1)));
PRINT "-"; LTRIM$(RTRIM$(STR$(a1))); ":": k$ = INKEY$
DO
  a = VAL(INKEY$)
LOOP UNTIL a > a1 - 1 AND a < a2 + 1
PRINT a: l = 0
END SUB

SUB GMH.Look
'
'     THIS IS A SUB FOR THE GRAPHIC MAIN HALL'S "LOOK" COMMAND
'    ----------------------------------------------------------
IF s%(2) > 1 THEN CALL GetDirection: a$ = "You see "

IF y1 = 9 OR y1 = 13 THEN
  IF ro = 1 THEN
    IF x1 = 1 THEN a$ = "Exit."
    IF x1 = 3 THEN a$ = "Register here ... OR ELSE!"
    IF x1 = 9 THEN a$ = "This way to village."
  END IF
  IF ro = 2 THEN
    IF x1 = 1 THEN a$ = "This way to Main Hall."
    IF x1 = 9 THEN a$ = "This way to Practice Area."
  END IF
  IF ro = 3 AND x1 = 1 THEN a$ = "This way to village."
  IF a$ <> "You see " THEN a$ = q$ + a$ + q$
END IF

IF y1 = 5 AND (x1 = 2 OR x1 = 3 OR x1 = 4) THEN
  IF ro = 1 THEN a$ = a$ + "Hokas Tokas' School of Magick."
  IF ro = 2 THEN a$ = a$ + "Schmitty's Casino."
END IF

IF y1 = 5 AND (x1 = 6 OR x1 = 7 OR x1 = 8) THEN
  IF ro = 1 THEN a$ = a$ + "the 1st National Bank of McFenny."
  IF ro = 2 THEN a$ = a$ + "a mysterious shop."
END IF

IF y1 = 17 AND (x1 = 4 OR x1 = 5 OR x1 = 6) THEN
  IF ro = 1 THEN a$ = a$ + "Marcos Cavielli's Weapons and Armour Shoppe."
  IF ro = 2 THEN a$ = a$ + "a shop for custom-made and/or used weapons."
END IF

IF ro = 1 THEN
  IF x1 = 3 AND (y1 = 10 OR y1 = 11 OR y1 = 12) THEN
    a$ = a$ + "the Burly Irishman's desk."
  END IF
END IF

IF ro = 2 THEN
  IF x1 = 4 AND y1 = 11 THEN
    a$ = a$ + "a statue.": IF cp < 79 THEN CALL DispString: PRINT
    a$ = "You hear a mysterious voice say, " + q$ + "Throw 20 gold pieces into the fountain "
    a$ = a$ + "and good fortune will be yours!" + q$: CALL DispString: l = lp
    CALL LPcheck: PRINT "Will you do it?  (Y/N):"; : CALL GetKey: l = 1
    F = 0: IF a$ <> "Y" THEN EXIT SUB
    IF gold < 20 THEN PRINT "Your pouch of gold is too light!": EXIT SUB
    FOR z = 1 TO 4
       IF wn$(z) <> "NONE" AND wn$(z) <> "" THEN F = F + 1
    NEXT
    gold = gold - 20
    IF F = 0 OR statue = 1 THEN
      a$ = "The air around the fountain begins to glow briefly but nothing happens..."
      CLS 2: CALL DispString: EXIT SUB
    END IF
Fountain:
    F = INT(RND * 4) + 1: IF wn$(F) = "NONE" OR wn$(F) = "" THEN GOTO Fountain
    a$ = q$ + "For your generosity I will increase the potency of one of your weapons!" + q$
    ws%(F) = ws%(F) + 1: statue = 1: CLS 2: CALL DispString: EXIT SUB
  END IF
  IF x1 = 5 AND y1 > 8 AND y1 < 14 THEN a$ = a$ + "a fountain."
END IF

IF ro = 3 THEN
  IF x1 = 9 AND y1 = 16 AND info1 = 1 THEN
    info1 = 2: CLS 2: l = 1
    IF INT(RND * 100) + 1 > 50 THEN
      PRINT "Nothing here.  Obviously a bad tip.": EXIT SUB
    END IF
    a$ = "You discover a loose block with an old sack hidden behind it.  Inside the sack you find 100 gold coins!"
    gold = gold + 100: CALL DispString: CALL KeyWait: EXIT SUB
  END IF
  IF a$ = "You see " THEN a$ = "Go talk to the man in the center booth."
END IF

IF a$ = "You see " THEN a$ = a$ + "nothing special."
CALL DispString: PRINT : l = 0
END SUB

SUB Graphic.Main.Hall
'***************************************************************************
'*                                                                         *
'*    THE EAMON DELUXE GRAPHIC MAIN HALL v1.0                              *
'*                                                                         *
'*          by Frank Black, 7/99                 Update: 13 JUL 2000       *
'*                                          Last Update: 24 JAN 2012       *
'*    Based upon a program by Rick Volberding                              *
'*                                                                         *
'***************************************************************************

CALL InitGMH


'         Set starting variables, set up screen, etc.
'        ---------------------------------------------
p% = 9 + ABS(ac > 0)
p% = size% * (p% - 1) + 1: x = 1: y = 11: GOSUB Start: CALL DrawRoom
save% = map%(ro, x, y): PUT (m%(x, y, 2), m%(x, y, 1)), tile%(p%), PSET

Main:
'PRINT x, y, x1, y1
x1 = x: y1 = y

DO
  anm1# = anm1# + 1
'                      ANIMATION
  IF anm1# >= anm2# THEN
    anm1# = 0: m = 4 * (ro - 1) + 1
    anm0 = anm0 + 1: IF anm0 = 3 THEN anm0 = 1
    FOR z = m TO m + 3
       PUT (m%(a%(z, 3), a%(z, 4), 2), m%(a%(z, 3), a%(z, 4), 1)), tile%(a%(z, anm0)), PSET
    NEXT
  END IF
  k$ = (RIGHT$(INKEY$, 1))
  ss1# = ss1# + 1
'                   BUILT-IN SCREEN SAVER
  IF ss1# >= ss2# THEN
     ss1# = 0: CALL Moire: IF mode = 1 THEN GOSUB Setup
  END IF
LOOP UNTIL k$ <> ""
k = ASC(k$): ss1# = 0

' Ye Olde Classic Main Hall
IF k = 120 OR k = 88 THEN
  PRINT "Switch to Classic Main Hall? (Y/N):"; : CALL GetKey: l = 1
  IF a$ = "Y" OR a$ = "y" THEN HallCode = 1: s%(2) = 1: EXIT SUB
END IF
'        ------------------------------------------
'         Move (respectively) up, left, right, down
'        ------------------------------------------
IF k = 56 OR k = 72 THEN
  x1 = x - 1: IF x > 1 THEN GOTO Move
  IF ro = 1 THEN
HallExit:
    a$ = "Do you wish to go on an (A)dventure or temporarily (L)eave the universe?"
    CLS 2: l = 1: CALL DispString: PRINT : PRINT "Enter A, L or (N)either: ";
    CALL GetKey: CLS 2: l = 1: IF a$ = "N" THEN GOTO Main
    IF a$ <> "A" AND a$ <> "L" THEN GOTO HallExit
    IF a$ = "A" THEN
      SCREEN 0: WIDTH 80: CALL EDX.Select.Adventure
      GOSUB Setup: GOTO Main
    END IF
    CALL Update: PUT #1, rec, c: CLOSE : CHDIR "..": RUN "EAMONDX"
  END IF
  ro = ro - 1: x = 9: GOTO ChangeRoom
END IF
IF k = 52 OR k = 75 THEN y1 = y - 1: GOTO Move
IF k = 54 OR k = 77 THEN y1 = y + 1: GOTO Move
IF k = 50 OR k = 80 THEN
  x1 = x + 1: IF x < 9 THEN GOTO Move
  IF ro = 3 THEN GOTO MoveErr
  ro = ro + 1: x = 1: GOTO ChangeRoom
END IF

IF k = 47 OR k = 63 THEN
  CLS 2: l = 1
  PRINT "L = Look T = Talk (Arrow Keys=Direction)": PRINT
  PRINT "X = Switch to Classic Main Hall": PRINT
  PRINT "V = View character statistics"
END IF

IF k = 86 OR k = 118 THEN
  SCREEN 0: WIDTH 80: CALL Examine.Character: GOSUB Setup: GOTO Main
END IF

IF k = 76 OR k = 108 THEN PRINT "[LOOK]": CALL GMH.Look: GOTO Main

'               ------------------------
'                THE "TRANSACT" COMMAND
'               ------------------------
IF k = 84 OR k = 116 THEN
  PRINT "[TRANSACT]": CALL GetDirection: l = 0
  IF y1 = 5 AND (x1 = 2 OR x1 = 3 OR x1 = 4) THEN
    IF ro = 1 THEN CALL Hokas.Tokas
    IF ro = 2 THEN CALL Casino
    IF ro = 3 THEN CALL Magic.Training
  END IF
  IF y1 = 5 AND (x1 = 6 OR x1 = 7 OR x1 = 8) THEN
    IF ro = 1 THEN CALL Shylock
    IF ro = 2 THEN CALL Witch
    IF ro = 3 THEN CALL Weapon.Training
  END IF
  IF y1 = 17 AND (x1 = 4 OR x1 = 5 OR x1 = 6) THEN
    IF ro = 1 THEN CALL Marcos
    IF ro = 2 THEN CALL Grendel
    IF ro = 3 THEN CALL Armor.Training
  END IF

  IF x1 = 3 AND (y1 = 10 OR y1 = 11 OR y1 = 12) AND ro = 1 THEN
    a$ = "The Irishman beckons to you and says, " + q$
    a$ = a$ + "Psst.  That potion the barman serves is verra strange.  Be careful!" + q$
    CLS 2: l = 1: CALL DispString
  END IF
 
  IF (x1 = 6 AND (y1 = 10 OR y1 = 11 OR y1 = 12)) OR (ro = 1 AND x1 = 5 AND (y1 = 9 OR y1 = 13)) THEN
  IF ro = 1 THEN
    a$ = "The barman says, " + q$ + "Do you want to buy a magic potion for 300 gold pieces?" + q$
    CLS 2: l = 1: CALL DispString: PRINT "(Y/N):"; : CALL GetKey: CLS 2: l = 1
    IF a$ <> "Y" THEN GOTO Main
    IF gold < 300 THEN
      a$ = q$ + "Sorry, " + sex$(sex) + "Adventurer, but you don't have enough gold!" + q$
      CALL DispString: CALL KeyWait: GOTO Main
    END IF
    gold = gold - 300: a = INT(RND * 4 + 1)
    IF a = 1 THEN
      PRINT "Nothing happens.  You leave grumbling.": CALL KeyWait: GOTO Main
    END IF
    IF a = 2 THEN
      PRINT "Your hardiness increased!": hd = hd + 1: IF hd > 300 THEN hd = 300
      CALL KeyWait: GOTO Main
    END IF
    IF a = 3 THEN
      PRINT "Hmm.  It's just an imported beer.": CALL KeyWait: GOTO Main
    END IF
    PRINT "Your hardiness decreased!": hd = hd - 1: IF hd < 1 THEN hd = 1
    CALL KeyWait: GOTO Main
  END IF
 
  IF ro = 3 THEN CALL Info.Booth: CALL KeyWait: GOTO Main
 
  END IF
  IF ro = 2 AND x1 = 4 AND y1 = 11 THEN
    PRINT : PRINT "Talking to a statue bears no fruit.": PRINT
  END IF
  GOTO Main
END IF


'             ----------------------
'              Move to another room
'             ----------------------
Move:
z = map%(ro, x1, y1)
IF z <> mv1 AND z <> mv2 THEN GOTO MoveErr
PUT (m%(x, y, 2), m%(x, y, 1)), tile%(save%), PSET
x = x1: y = y1: save% = map%(ro, x, y)
PUT (m%(x, y, 2), m%(x, y, 1)), tile%(p%), PSET
'SOUND 50, .5: GOTO Main
GOTO Main

MoveErr:
SOUND 200, .5: GOTO Main

ChangeRoom:
SOUND 50, .5: CALL DrawRoom: anm0 = 0: save% = map%(ro, x, y)
PUT (m%(x, y, 2), m%(x, y, 1)), tile%(p%), PSET
GOTO Main

'         -----------------------------
'          Write info at top of screen
'         -----------------------------
Start:
col = 1: row = 1: textsize = 1: textcolor1 = 10
a$ = "ARROW KEYS=MOVE": CALL HRT
col = 33: row = 1: a$ = "?=COMMAND LIST": CALL HRT
RETURN

Setup:
SCREEN mode: VIEW PRINT 20 TO 25: GOSUB Start: CALL DrawRoom
x1 = x: y1 = y: GOSUB Move
END SUB

SUB Grendel
'
'                        GRENDEL'S SMITHY
'                       ------------------
FOR a = 1 TO 4
   IF wn$(a) = "" THEN wn$(a) = "NONE"
NEXT
CLS 2: w = 0
FOR a = 1 TO 4
   IF wn$(a) = "NONE" THEN w = a: a = 4
NEXT
IF w = 0 THEN
  a$ = "Grendel says, " + q$ + "I'm sorry, but you're going to have to try "
  a$ = a$ + "and sell one of your weapons at the store to the north. You "
  a$ = a$ + "know the law:  No more than four weapons per person!  Come back "
  a$ = a$ + "when you've sold a weapon." + q$
  CALL DispString: CALL KeyWait: EXIT SUB
END IF

PRINT "Grendel says, " + q$ + "Would you care to look at"
PRINT "my stock of used weapons?  (Y/N)"; : CALL GetKey
IF a$ = "N" THEN GOTO Grendel1
CLS 2: l = 1: IF a$ <> "Y" THEN EXIT SUB

'
'                     Used weapons
'                    --------------
nw$ = "SlaymorElfkillStingerScrunchCenturiFalcoorWidowerFlasherSlasherFreedom"
CLS 2: l = 1: PRINT q$; "What type of weapon do you wish?"; q$
GOSUB Grendel4: IF a = 6 THEN GOTO Grendel2

wt%(w) = a: x = (wt%(w) - 1) * 2 + 1: CLS 2: l = 1
a$ = q$ + "I happen to have two in stock right now:" + q$: CALL DispString
PRINT "1. "; MID$(nw$, (x - 1) * 7 + 1, 7); " (2D8  / 12%) ...... 500gp"
PRINT "2. "; MID$(nw$, (x + 1 - 1) * 7 + 1, 7); " (2D16 / 24%) .... 1200gp"
PRINT "Enter 1-2 or (0 to exit): "; : CALL GetKey: a = INSTR("120", a$)
IF a < 1 OR a > 2 THEN GOTO Grendel2
wn$(w) = MID$(nw$, (x + (a - 1) - 1) * 7 + 1, 7)
wd%(w) = 2: ws%(w) = 8 * a: wc%(w) = 12 * a: p = 500 + 700 * (a - 1)
GOSUB Grendel3: IF p = 0 THEN EXIT SUB
gold = gold - p: CLS 2: l = 1: PRINT q$; "Good choice!  A great bargain!"; q$
CALL KeyWait: GOTO Grendel2

'
'                    Custom weapons
'                   ----------------
Grendel1:
CLS 2: l = 1: PRINT q$; "What do you want me to make?"; q$
GOSUB Grendel4: IF a = 6 THEN GOTO Grendel2

wt%(w) = a: CLS 2: l = 1: PRINT q$; "What name should I inscribe on it?"; q$: PRINT
PRINT "Enter weapon name:"; : LINE INPUT ""; wn$(w)
wn$(w) = LTRIM$(RTRIM$(LEFT$(wn$(w), 20)))
IF LEN(wn$(w)) = 0 OR wn$(w) = "NONE" THEN wn$(w) = "special weapon"

CLS 2: PRINT q$; "I do have limits of craftsmanship:"; q$
PRINT "        Odds    Dice   Sides": PRINT "       1%-50%    1-3    1-12 "

CALL KeyWait: PRINT "Enter odds:"; : LINE INPUT ""; a$: wc%(w) = INT(VAL(a$))
IF wc%(w) < 1 THEN wc%(w) = 1
IF wc%(w) > 50 THEN wc%(w) = 50
PRINT "Enter # of dice:"; : LINE INPUT ""; a$: wd%(w) = INT(VAL(a$))
IF wd%(w) < 1 THEN wd%(w) = 1
IF wd%(w) > 3 THEN wd%(w) = 3
PRINT "Enter # of dice sides:"; : LINE INPUT ""; a$: ws%(w) = INT(VAL(a$))
IF ws%(w) < 1 THEN ws%(w) = 1
IF ws%(w) > 12 THEN ws%(w) = 12
p = INT(wc%(w) * wd%(w) * ws%(w) + 500): CLS 2: l = 1
IF p < 100 THEN p = 100

a$ = q$ + "I can make you a " + LTRIM$(RTRIM$(STR$(wd%(w)))) + "D"
a$ = a$ + LTRIM$(RTRIM$(STR$(ws%(w)))) + " "
a$ = a$ + RTRIM$(MID$("axe  bow  mace spearsword", 5 * (wt%(w) - 1) + 1, 5))
a$ = a$ + " with odds of " + LTRIM$(RTRIM$(STR$(wc%(w)))) + "% "
a$ = a$ + "called " + wn$(w) + " for " + LTRIM$(RTRIM$(STR$(p)))
a$ = a$ + " gold pieces.": CALL DispString
PRINT "Proceed?  (Y/N):"; : CALL GetKey: CLS 2: l = 1
IF a$ <> "Y" THEN wn$(w) = "NONE": GOTO Grendel2
GOSUB Grendel3: IF p = 0 THEN EXIT SUB

a$ = "Grendel works on your weapon, often calling in wizards and weapon experts.  Finally he finishes."
CALL DispString: CALL KeyWait
a$ = q$ + "I think you will be satisfied with this." + q$ + " he says modestly."
CALL DispString: CALL KeyWait: gold = gold - p

'                    Exit smithy
'                   -------------
Grendel2:
FOR a = 1 TO 4
   IF LCASE$(wn$(w)) = LCASE$(wn$(a)) AND a <> w THEN
     wn$(w) = wn$(w) + "#": GOTO Grendel2
   END IF
NEXT
CLS 2: l = 0: a$ = q$ + "Goodbye, " + n$ + "!  Come again." + q$: GOSUB d3
EXIT SUB

'                   Smithy subroutines
'                  --------------------
Grendel3:
IF gold < p THEN
  a$ = q$ + "Sorry, but you don't seem to have enough gold to pay for your weapon at this time.  Come back when you have enough." + q$
  CALL DispString: CALL KeyWait: p = 0: wn$(w) = "NONE"
END IF
RETURN

Grendel4:
PRINT "   1.  Axe      4.  Spear": PRINT "   2.  Bow      5.  Sword"
PRINT "   3.  Mace": PRINT : PRINT "Enter 1-5 or (0 to exit): ";
CALL GetKey: a = INSTR("123450", a$): IF a = 0 THEN GOTO Grendel4
RETURN

d3:
CALL DispString: PRINT : CALL LPcheck: RETURN
END SUB

SUB Hokas.Tokas
'
'                  HOKAS TOKAS' SCHOOL OF MAGICK
'                 -------------------------------
CLS 2
a$ = "After a few minutes diligent searching, you find Hokas Tokas, the old Mage.  "
a$ = a$ + "He looks at you and says, " + q$ + "So you want old Hokey to teach you some magic, eh?  "
a$ = a$ + "Well, it'll cost you.  My fees are:" + q$: GOSUB d1
PRINT "   Blast...1000 GP"
PRINT "   Heal.....500 GP"
PRINT "   Speed...4000 GP"
PRINT "   Power....100 GP"
IF s%(2) = 1 THEN PRINT : PRINT q$; "Well, which will it be?"; q$: PRINT

WChoice:
PRINT "Hit a key, B, H, S, P, or (N)one :"; : CALL GetKey: PRINT : l = 1
IF a$ = "N" THEN EXIT SUB
FOR sp = 1 TO 4
   IF a$ = MID$("BHSP", sp, 1) THEN GOTO WChoice2
NEXT: GOTO WChoice

WChoice2:
ON sp GOTO Blast, Heal, Speed, Power

Blast:
p = 1000: GOTO BuySpell
Heal:
p = 500: GOTO BuySpell
Speed:
p = 4000: GOTO BuySpell
Power:
p = 100: GOTO BuySpell

BuySpell:
IF p > gold THEN
   a$ = "When Hokas sees that you don't have enough to pay him, he stalks to the bar, "
   a$ = a$ + "muttering about youngsters who should be turned into frogs."
   GOSUB d1: CALL KeyWait: EXIT SUB
END IF
IF sp%(sp) > 0 THEN
   a$ = "Hokas says, " + q$ + "I ought to take your gold anyway, but haven't you forgotten "
   a$ = a$ + "something?  I already taught you that spell!" + q$: GOSUB d1
   a$ = "Shaking his head sadly, he returns to the bar.": GOSUB d1
   CALL KeyWait: EXIT SUB
END IF

gold = gold - p: sp%(sp) = (RND(1) * 50) + 26
a$ = "Hokas teaches you your spell, takes his fee, and returns to his stool on the "
a$ = a$ + "bar.  As you walk away, you hear him order a Double Dragon Blomb."
GOSUB d1: CALL KeyWait: EXIT SUB

d1:
CALL DispString: PRINT : CALL LPcheck: RETURN
END SUB

SUB HRT
'
'                THIS IS A SUB FOR THE GRAPHIC MAIN HALL
'               -----------------------------------------
'    This routine is only used to write the names of shops, etc.
' For details on the GMH's other HI-RES text, see the DispString SUB.
' This subroutine is similar to the one in the EAMON.BAS program, refer to
' EAMON.BAS for details.
'
HRT:
row1 = INT((26 + ABS(textsize = 1)) / textsize)
DRAW "c" + STR$(textcolor1) + "s" + STR$(textsize * 4)
FOR a = 1 TO LEN(a$)
   k = ASC(MID$(a$, a, 1))
   DRAW "bm" + STR$((col - 1) * (textsize * 6)) + "," + STR$((row - 1) * (textsize * 7))
   DRAW ab$(k): col = col + 1
   IF col > INT(52 / textsize) THEN col = 1: row = row + 1: IF row > row1 THEN row = 1
NEXT
row = row + 1: IF row > row1 THEN row = 1
END SUB

SUB Info.Booth
    bet = 40 - ch: a$ = "The man leans over the counter and says, " + q$
    a$ = a$ + "I give general directions for free and for a small charge of"
    a$ = a$ + STR$(bet) + " gold pieces, I give interesting and useful information." + q$
    CLS 2: l = 1: CALL DispString: CALL KeyWait
    PRINT : PRINT q$; "So what'll it be?"; q$: PRINT
    PRINT "(D)irections or (I)nfo?: "; : CALL GetKey: CLS 2: l = 1
    IF a$ <> "D" AND a$ <> "I" THEN EXIT SUB
    IF a$ = "D" THEN
      a$ = q$ + "The proprietor of the shop to the northwest coaches spell casting.  It's expensive, though." + q$
      CALL DispString: CALL KeyWait
      a$ = q$ + "The weapons training school to the southwest is quite popular.  The owner is an excellent instructor." + q$
      CALL DispString: CALL KeyWait
      a$ = q$ + "The eastern shop belongs to an unusual man.  But he's quite adept at teaching armour skills." + q$
      CALL DispString: EXIT SUB
    END IF
    IF gold < bet THEN
      PRINT : PRINT q$; "You don't have enough gold for my tip!"; q$: EXIT SUB
    END IF
    gold = gold - bet
    IF info1 > 0 THEN a$ = q$ + "Next time you're in the village, you may wish to (L)ook at the statue above the fountain..." + q$
    IF info1 = 0 THEN info1 = 1: a$ = q$ + "If you go to the southeast corner of this area and (L)ook to the south, you may discover wealth!" + q$
    CALL DispString: EXIT SUB
END SUB

SUB InitGMH
'
'                THIS IS A SUB FOR THE GRAPHIC MAIN HALL
'               -----------------------------------------
CLS : RANDOMIZE TIMER
IF HallCode > 0 THEN GOTO HallPass1
'           Init the HI-RES text DRAW strings
FOR a = 33 TO 90: READ ab$(a): NEXT
'           Set animation and screen saver delay times
anm2# = dly# * .75: anm1# = 0: ss2# = dly# * 60: ss1# = 0
'         ----------------------------
'           Load appropriate tile set
'         ----------------------------
OPEN F$ FOR RANDOM AS #2 LEN = size% * 2
FIELD #2, size% * 2 AS x$

z = 0: LOCATE 10: PRINT "Loading shapes ...";
FOR x = 1 TO shapes
   LOCATE CSRLIN, 19: PRINT x; "/"; shapes;
   GET #2, x + 1
   a$ = x$: z1 = 0
   FOR a = 1 TO size% * 2 STEP 2
      z1 = z1 + 1
      tile%(z1 + z) = CVI(MID$(a$, a, 2))
   NEXT
   z = z + size%
NEXT
CLOSE #2: CLS
'----------------------------------------------------------------------------
'  Load map  (Map data is adjusted from actual shape # to starting point in
'  the tile% array for faster display)
'
'  Map format is map%( [room], [column], [# of tile in each column] )
'----------------------------------------------------------------------------
FOR z = 1 TO 3
   LOCATE 10, 5: PRINT "Reading map ..."; z; "/"; 3
   FOR x = 1 TO 9
      FOR y = 1 TO 22: READ a: map%(z, x, y) = size% * (a - 1) + 1: NEXT
   NEXT
NEXT: CLS
'----------------------------------------------------------------------------
'  Generate a look-up table (create a set of arrays that hold the screen
'  coordinates for the starting point of each tile.  This, again, is to
'  enhance the display speed for slower CPUs)
'
'  format: m%( [row], [column], [top-left coordinates to start drawing] )
'----------------------------------------------------------------------------
z = 6: l = 0
FOR x = 1 TO 9
   FOR y = 1 TO 22
      m%(x, y, 1) = z: m%(x, y, 2) = l: l = l + 14
   NEXT
   z = z + 16: l = 0
NEXT
'
' Set up animation tile pointers (these, like the map data, are also
' adjusted for a faster display)
'
FOR x = 1 TO 12
   FOR y = 1 TO 4: READ a%(x, y): NEXT
   a%(x, 1) = size% * (a%(x, 1) - 1) + 1
   a%(x, 2) = size% * (a%(x, 2) - 1) + 1
NEXT
HallPass1:
SCREEN mode: VIEW PRINT 20 TO 25: ro = 1
mv1 = size% * (20 - 1) + 1: mv2 = size% * (32 - 1) + 1
END SUB

SUB Initialize
'
' Initialize general data for both halls
'
OPEN "PLAYER" FOR INPUT AS #1: INPUT #1, rec: CLOSE
OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200: GET #1, rec, c

n$ = RTRIM$(c.cname): STAT = c.status: hd = c.a1: ag = c.a2: ch = c.A3
sp%(1) = c.SP1: sp%(2) = c.SP2: sp%(3) = c.SP3: sp%(4) = c.SP4
wa%(1) = c.WA1: wa%(2) = c.WA2: wa%(3) = c.WA3: wa%(4) = c.WA4: wa%(5) = c.WA5
ae = c.ae: sex = c.sex: gold = c.gold: BANK = c.BANK: ac = c.ac
wn$(1) = RTRIM$(c.WN1): wn$(2) = RTRIM$(c.WN2): wn$(3) = RTRIM$(c.WN3): wn$(4) = RTRIM$(c.WN4)
wc%(1) = c.WCOMPLX1: wc%(2) = c.WCOMPLX2: wc%(3) = c.WCOMPLX3: wc%(4) = c.WCOMPLX4
wt%(1) = c.WTYPE1: wt%(2) = c.WTYPE2: wt%(3) = c.WTYPE3: wt%(4) = c.WTYPE4
wd%(1) = c.WDICE1: wd%(2) = c.WDICE2: wd%(3) = c.WDICE3: wd%(4) = c.WDICE4
ws%(1) = c.WSIDES1: ws%(2) = c.WSIDES2: ws%(3) = c.WSIDES3: ws%(4) = c.WSIDES4

FOR a = 1 TO 4
   IF wn$(a) = "" OR wn$(a) = "none" THEN wn$(a) = "NONE"
NEXT

IF sex < 0 OR sex > 1 THEN sex = 0
FOR a = 0 TO 4: READ AR$(a): NEXT
sex$(0) = "Mighty ": sex$(1) = "Fair ": GEN$(0) = " boy ": GEN$(1) = " girl "
BS$ = CHR$(29): q$ = CHR$(34)
CLOSE

IF s%(3) < 1 OR s%(3) > 15 THEN s%(3) = 7
END SUB

SUB KeyWait
'
'    Display pause message, then fall into GetKey
'
KeyWait:
LOCATE 25: PRINT "Hit any key to continue...";
CALL GetKey: CLS 2: l = 1
END SUB

SUB LPcheck
l = l + 1
IF l < lp THEN EXIT SUB

PRINT "[MORE]"; : k$ = INKEY$
DO
LOOP UNTIL INKEY$ <> ""
CLS 2: l = 0: EXIT SUB
END SUB

SUB Magic.Training
'
'                Randomly increase spell abilities
'               -----------------------------------
CLS 2: l = 1
a$ = q$ + "Ah, so.  Welcome to my shop, oh " + sex$(sex) + "Adventurer.  "
a$ = a$ + "May the blessings of the gods be yours."
CALL DispString: CALL KeyWait
a$ = q$ + "And what mystical prowess do you wish this humble one to impart to one of your magnificence?" + q$
CALL DispString: CALL KeyWait
GOSUB MagT1: IF a = 5 THEN GOTO MagT2

IF sp%(a) = 0 THEN
  a$ = q$ + "You will have to first buy that spell from the mage in the Main Hall!" + q$
  CALL DispString: CALL KeyWait: EXIT SUB
END IF

a$ = q$ + "So you wish to learn how to use your spell more effectively!  "
a$ = a$ + "My fee is 1000 gold pieces for every try." + q$
CALL DispString: CALL KeyWait
a$ = "The mystic teaches you to concentrate while casting spells and says, "
a$ = a$ + q$ + "Now cast your spell while I offer suggestions from nearby." + q$
l = 0: CALL DispString: CALL KeyWait

MagT0:
CLS 2: l = 1: PRINT "Ability: "; RTRIM$(LTRIM$(STR$(sp%(a)))); "        ";
PRINT "Gold: "; RTRIM$(LTRIM$(STR$(gold))): PRINT
IF gold < 1000 THEN
  PRINT q$; "Sorry, but my fee exceeds your assets!"; q$
  CALL KeyWait: EXIT SUB
END IF
PRINT "(C)ast         (R)est         (S)top": PRINT
PRINT "Enter C, R, or S:"; : CALL GetKey: CLS 2: l = 1

IF a$ = "S" THEN GOTO MagT2
IF a$ = "R" THEN
  a$ = "GASP ... MUMBLE ... GASP.  " + q$ + "Breathe deeply!" + q$
  CALL DispString: CALL KeyWait: GOTO MagT0
END IF
IF a$ <> "C" THEN GOTO MagT0

k = INT(RND * 10 + 1): gold = gold - 1000
IF k = 10 THEN
  a$ = q$ + "Perfect cast!  Incredible!" + q$: sp%(a) = sp%(a) + 5
END IF
IF k > 5 AND k < 10 THEN
  a$ = q$ + "Success!  A good cast!" + q$: sp%(a) = sp%(a) + 2
END IF
IF k < 6 THEN a$ = q$ + "Nothing?  Concentrate!" + q$

IF sp%(a) > 500 THEN sp%(a) = 500
CALL DispString: CALL KeyWait: GOTO MagT0

MagT1:
PRINT "   1.  Blast      3.  Speed": PRINT "   2.  Heal       4.  Power"
PRINT : PRINT "Enter 1-4 or (0 to exit): ";
CALL GetKey: a = INSTR("12340", a$): IF a = 0 THEN GOTO MagT1
CLS 2: l = 1: RETURN

MagT2:
CLS 2: l = 1
a$ = q$ + "My ancient ancestors thank you for your excellent patronage!  "
a$ = a$ + "May your magicks be always successful!" + q$
CALL DispString: CALL KeyWait
END SUB

SUB Marcos
'
'                 MARCOS CAVIELLI'S WEAPONS & ARMOR SHOPPE
'               --------------------------------------------
a$ = "As you enter the weapon shop, Marcos Cavielli (the owner) comes from out of "
a$ = a$ + "the back room and says, " + q$ + "Well, as I live and breathe, if it isn't my old pal, "
a$ = a$ + n$ + "!": GOSUB D

Shop1:
a$ = q$ + "So, what do you need?:" + q$: CALL DispString
PRINT " 1. Buy a weapon"
PRINT " 2. Sell a weapon"
PRINT " 3. Get some better Armor?"
PRINT : PRINT "Enter 1-3 or (0 to exit): "; : CALL GetKey: l = 0
CLS 2: a = INT(VAL(a$)): IF a < 0 OR a > 3 THEN GOTO Shop1
IF a = 0 THEN EXIT SUB

FOR m = 1 TO 4
   IF wn$(m) = "" OR wn$(m) = "none" THEN wn$(m) = "NONE"
NEXT
F = 0
FOR m = 1 TO 4
   IF wn$(m) <> "NONE" THEN F = F + 1
NEXT
ON a GOTO BuyWeapon, SellWeapon, BuyArmour
'
'                   Buy a new weapon
'                  ------------------
BuyWeapon:
IF F = 4 THEN
  a$ = "Marcos smiles at you and says, " + q$ + "Thatsa good, but first you must sell me a "
  a$ = a$ + "weapon.  You know the law:  No more than four weapons per person!" + q$
  CALL DispString: CALL KeyWait: EXIT SUB
END IF

a$ = "Marcos smiles at you and says, " + q$ + "Good! I gotta the best.  What kind do you want?" + q$
CALL DispString: PRINT : IF s%(2) > 1 THEN l = lp
CALL LPcheck: GOSUB WepChoice: IF a = 0 THEN EXIT SUB
a$ = "a " + N1$: IF a = 1 THEN a$ = "an " + N1$

a$ = "Marcos says, " + q$ + "Well I just happen to have " + a$ + " in stock of a decent "
a$ = a$ + "quality.  I can let you have it for " + LTRIM$(RTRIM$(STR$(p))) + " gold pieces." + q$
GOSUB D
IF gold < p THEN
   a$ = q$ + "However, I see you can't afford that much.  Come back when you can." + q$
   CALL DispString: CALL KeyWait: EXIT SUB
END IF

WepLoop:
FOR w = 1 TO 4
   IF LCASE$(wn$(w)) = LCASE$(N1$) THEN N1$ = N1$ + "#": GOTO WepLoop
NEXT
FOR w = 1 TO 4
   IF wn$(w) = "NONE" THEN
      wn$(w) = N1$: wt%(w) = TP: wc%(w) = 10: wd%(w) = 1: ws%(w) = SI: w = 4
   END IF
NEXT
gold = gold - p
a$ = "Marcos hands you your new weapon and takes the price from you."
GOSUB D: GOTO LeaveShop
'
'             Player sells a weapon
'            -----------------------
SellWeapon:
IF F = 0 THEN
  a$ = q$ + "You don't have any weapons to sell, " + n$ + "." + q$: GOSUB D
  GOTO LeaveShop
END IF
PRINT q$; "Which weapon do you wanna sell?"; q$: PRINT
IF s%(2) > 1 THEN l = lp: CALL LPcheck
FOR m = 1 TO 4
   IF wn$(m) <> "NONE" THEN
     PRINT " "; LTRIM$(RTRIM$(STR$(m))); ". "; wn$(m)
   END IF
NEXT
PRINT "Enter no. of weapon (0 exits): "; : CALL GetKey: a = INT(VAL(a$))
PRINT : IF a < 1 OR a > 4 THEN EXIT SUB
a$ = wn$(a): IF a$ = "" OR a$ = "none" OR a$ = "NONE" THEN GOTO SellWeapon

Sell1:
IF RIGHT$(a$, 1) = "#" AND LEN(a$) > 1 THEN
  a$ = LEFT$(a$, LEN(a$) - 1): GOTO Sell1
END IF
p = 15: IF wc%(a) > 10 THEN p = p + 25
IF wd%(a) * ws%(a) > 15 THEN p = p + 50
IF wd%(a) * ws%(a) > 25 THEN p = p + 200
IF p > 15 AND p < 200 THEN
  a$ = q$ + "Hey, this is a pretty good weapon!" + q$: GOSUB D
END IF
IF p > 200 THEN
  a$ = q$ + "Very nice, this is a magical weapon." + q$: GOSUB D
END IF
PRINT : CALL LPcheck
a$ = q$ + "Well, I can give you " + LTRIM$(RTRIM$(STR$(p))) + " gold pieces for it." + q$
GOSUB D: PRINT "Do you want to sell? (Y/N): "; : CALL GetKey: PRINT : l = 0
IF UCASE$(a$) <> "Y" THEN CALL KeyWait: EXIT SUB

gold = gold + p
FOR a = a TO 4
   m = a + 1: wn$(a) = wn$(m): wt%(a) = wt%(m): wc%(a) = wc%(m)
   wd%(a) = wd%(m): ws%(a) = ws%(m)
NEXT
a$ = "Marcos gives you your money and takes your weapon.": GOSUB D
wn$(4) = "NONE": GOTO LeaveShop
'
'                  Player buys armor
'                 -------------------
BuyArmour:
a2 = INT(ac / 2): IF ac / 2 <> a2 THEN SH = 1
P1 = a2 * 30 + 10: IF P1 > 100 THEN P1 = 450
IF P1 = 40 THEN P1 = 25
IF P1 = 10 THEN P1 = 0
P2 = INT(P1 / 2)
a$ = "Marcos takes you to the armor section of his shop and shows you suits of "
a$ = a$ + "leather, chain and plate armor.": GOSUB D
a$ = "He says, " + q$ + "I can fit you in any of these pretty cheaply, I need 100 for the "
a$ = a$ + "leather, 250 for the chain, and 500 for the plate." + q$: GOSUB D
IF P1 > 0 THEN
  a$ = q$ + "Also, I can give you a trade in on your old armor of "
  a$ = a$ + LTRIM$(RTRIM$(STR$(P2))) + " gold pieces." + q$: GOSUB D
  IF s%(2) > 1 THEN l = lp: CALL LPcheck
END IF
a$ = q$ + "Well, what will it be?" + q$: CALL DispString
PRINT " 1. Leather....100"
PRINT " 2. Chain......250"
PRINT " 3. Plate......500": PRINT
PRINT "Enter 1-3 (0 exits): "; : CALL GetKey: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > 3 THEN GOTO Armor1
p = 100: IF a > 1 THEN p = p + 150
IF a = 3 THEN p = p * 2
IF gold + P2 < p THEN
  a$ = "Marcos frowns when he sees that you don't have enough to pay for your armor "
  a$ = a$ + "and says, " + q$ + "I don't give credit!" + q$: GOSUB D
  GOTO LeaveShop
END IF
gold = gold + P2: a$ = "gold": IF P2 > 0 THEN a$ = a$ + " and your old armor"
a$ = "Marcos takes your " + a$ + " and helps you into your new armor."
GOSUB D: gold = gold - p: a2 = a
Armor1:
IF SH = 1 THEN GOTO Leave0
a$ = "Marcos smiles and says, " + q$ + "Now how about a shield?  I can let you have one for "
a$ = a$ + "only 50 gold pieces." + q$: GOSUB D
IF gold < 50 THEN
  a$ = q$ + "But, I see that you can't afford that.  Well see me again when you can." + q$
  GOSUB D: GOTO Leave0
END IF
IF s%(2) > 1 THEN l = lp: CALL LPcheck
PRINT "Do you want a shield? (Y/N): "; : CALL GetKey: PRINT
IF UCASE$(a$) <> "Y" THEN GOTO Leave0
gold = gold - 50: SH = 1
a$ = "Marcos takes your gold and gives you a shield.": GOSUB D

Leave0:
ac = a2 * 2 + SH
LeaveShop:
PRINT : l = l + 1
a$ = "Marcos smiles and says, " + q$ + "Come back again soon!" + q$ + " as he shoos you out of his shop."
GOSUB D: CALL KeyWait: EXIT SUB

WepChoice:
PRINT "  Enter weapon of choice:"
PRINT " 1. Axe          4. Spear": PRINT " 2. Bow          5. Sword"
PRINT " 3. Mace"
PRINT "Enter 1-5 (or 0 to exit): "; : CALL GetKey: a = INT(VAL(a$)): PRINT
IF a < 0 OR a > 5 THEN GOTO WepChoice
IF a = 0 THEN RETURN
ON a GOTO Axe, Bow, Mace, Spear, Sword

Axe:
N1$ = "axe": p = 25: TP = 1: SI = 6: RETURN
Bow:
N1$ = "bow": p = 40: TP = 2: SI = 6: RETURN
Mace:
N1$ = "mace": p = 20: TP = 3: SI = 4: RETURN
Spear:
N1$ = "spear": p = 25: TP = 4: SI = 5: RETURN
Sword:
N1$ = "sword": p = 30: TP = 5: SI = 8: RETURN

D:
CALL DispString: PRINT : CALL LPcheck: RETURN
END SUB

SUB Moire
'
'     THIS IS A SUB FOR THE GRAPHIC MAIN HALL'S BUILT-IN SCREEN SAVER
'    -----------------------------------------------------------------
IF BORT = 0 THEN EXIT SUB
IF mode = 1 THEN CLS
'        (Page-flip in EGA/VGA mode to avoid re-drawing screen)
IF mode > 1 THEN PCOPY 0, 1

z = 1: z1 = 2: cx = 319: r = 160: k = 0
MainSS:
GOSUB Moire
IF k = 1 THEN
  IF mode = 1 THEN CLS
  IF mode > 1 THEN PCOPY 1, 0
  EXIT SUB
END IF
GOTO MainSS

'****************************************************************************
'* The following subroutine is BASED on the "Moire" program from a rare and *
'* ancient tome entitled "AppleSoft BASIC Programming Reference Manual"     *
'*             MOIRE is (c) 1981 Apple Computer, Inc.                       *
'*                                                                          *
'* Microsoft BASIC adaption by Frank Black 1999                             *
'****************************************************************************
Moire:
FOR I% = 2 TO 5
  CLS
  a = INT(RND * cx): b = INT(RND * y1)
  FOR z2 = 0 TO cx - 1 STEP I%
     LINE (z2, 0)-(a, b), z: LINE (a, b)-(cx - z2, r), z
     LINE (z2 + 1, 0)-(a, b), z1: LINE (a, b)-(cx - z2 - 1, r), z1
     IF INKEY$ <> "" THEN k = 1: RETURN
  NEXT
  FOR z2 = 0 TO r - 1 STEP I%
     LINE (cx, z2)-(a, b), z: LINE (a, b)-(0, r - z2), z
     LINE (cx, z2 + 1)-(a, b), z1: LINE (a, b)-(0, r - z2 - 1), z1
     IF INKEY$ <> "" THEN k = 1: RETURN
  NEXT
  FOR z2 = 1 TO dly# * 6
     IF INKEY$ <> "" THEN k = 1: RETURN
  NEXT
NEXT
RETURN
END SUB

SUB Shylock
'
'                      1ST NATIONAL BANK OF MCFENNY
'                     ------------------------------
CLS 2
a$ = "You have no trouble spotting Shylock McFenny, the local banker, due to his large "
a$ = a$ + "belly.  You attract his attention, and he comes over to you."
GOSUB d2
a$ = q$ + "Well, " + n$ + " my dear" + GEN$(sex) + "what a pleasure to see you!  "
a$ = a$ + "Do you want to make a deposit or a withdrawal?" + q$: GOSUB d2
a$ = "You have " + LTRIM$(RTRIM$(STR$(gold))) + " GP in hand, "
a$ = a$ + LTRIM$(RTRIM$(STR$(BANK))) + " GP in the bank.": GOSUB d2
BChoice:
PRINT "(Hit "; q$; "D"; q$; " for a Deposit, "; q$; "W"; q$; " for a Withdrawl): ";
CALL GetKey: IF a$ <> "D" AND a$ <> "W" THEN GOTO BChoice
IF a$ = "W" THEN GOTO Withdraw

Deposit:
CLS 2
a$ = "Shylock gets a wide grin on his face and says, " + q$ + "Good for you!  How much do you "
a$ = a$ + "want to deposit?" + q$: GOSUB d2
a$ = "You have " + LTRIM$(RTRIM$(STR$(gold))) + " GP in hand, "
a$ = a$ + LTRIM$(RTRIM$(STR$(BANK))) + " GP in the bank.": GOSUB d2
LINE INPUT "(Enter the amount to deposit.): "; a$: a$ = LTRIM$(RTRIM$(a$))
MN = VAL(a$): CLS 2: l = 1

IF MN < 0 OR MN <> INT(MN) OR LTRIM$(RTRIM$(STR$(MN))) <> a$ THEN
   a$ = "The banker scowls at you and says, " + q$ + "Come, come, you're not making sense!  Try again." + q$
   GOSUB d2: CALL KeyWait: GOTO Deposit
END IF

IF MN > gold THEN
   a$ = "The banker was very pleased when you told him the sum, but when he discovered "
   a$ = a$ + "that you didn't have that much on you, he walked away shouting about fools who "
   a$ = a$ + "try to play tricks on a kindly banker."
   GOSUB d2: CALL KeyWait: EXIT SUB
END IF

gold = gold - MN: BANK = BANK + MN
a$ = "Shylock takes your money, puts it in his bag, listens to it jingle, then thanks "
a$ = a$ + "you and walks away.": GOSUB d2: CALL KeyWait: EXIT SUB

Withdraw:
CLS 2
a$ = "Shylock says, " + q$ + "Well, you have " + LTRIM$(RTRIM$(STR$(BANK)))
a$ = a$ + " gold pieces stored with me.  How many do you want to take back?" + q$
GOSUB d2
a$ = "You have " + LTRIM$(RTRIM$(STR$(gold))) + " GP in hand, "
a$ = a$ + LTRIM$(RTRIM$(STR$(BANK))) + " GP in the bank.": GOSUB d2
LINE INPUT "(Enter the amount to withdraw.): "; a$: a$ = LTRIM$(RTRIM$(a$))
MN = VAL(a$): PRINT : l = 1

IF MN < 0 OR MN <> INT(MN) OR LTRIM$(RTRIM$(STR$(MN))) <> a$ THEN
   a$ = "The banker scowls at you and says, " + q$ + "Come, come, you're not making sense!  Try again." + q$
   GOSUB d2: CALL KeyWait: GOTO Withdraw
END IF

IF MN > BANK THEN
   a$ = "Shylock throws you a terrible glance and says, " + q$ + "That's more than you got!  You "
   a$ = a$ + "know I don't make loans to your kind!" + q$ + "  With that, he loses himself in the "
   a$ = a$ + "crowd. ": GOSUB d2: CALL KeyWait: EXIT SUB
END IF

gold = gold + MN: BANK = BANK - MN: PRINT
a$ = "Shylock hands you your gold and says, " + q$ + "That leaves you with "
a$ = a$ + LTRIM$(RTRIM$(STR$(BANK))) + " gold pieces in my care." + q$
GOSUB d2: a$ = "He shakes your hand and walks away.": GOSUB d2
CALL KeyWait: EXIT SUB

d2:
CALL DispString: PRINT : CALL LPcheck: RETURN
END SUB

SUB Text.Main.Hall
SCREEN 0: WIDTH 80, 25
Menu:
room$ = "Main Hall": ro = 1: GOSUB Header: COLOR 7: PRINT
PRINT "       1. Go on an adventure.": PRINT
PRINT "       2. Visit the Weapons and Armor Shoppe.": PRINT
PRINT "       3. Hire a Wizard to teach you some spells.": PRINT
PRINT "       4. Find the banker to deposit or withdraw some gold.": PRINT
PRINT "       5. Examine your abilities.": PRINT
PRINT "       6. Enter the Village.": PRINT
PRINT "       7. Temporarily leave the universe."
PRINT : COLOR a: GOSUB HallInput
IF a$ = "X" AND s%(4) = 0 THEN
  GOSUB LeaveText: IF a$ = "Y" THEN EXIT SUB
  END
END IF
a = VAL(a$): IF a < 1 OR a > 7 THEN GOTO Menu
ON a GOTO Adventure, Shop, Wizard, BANK, Examine, Village, Quit
'------------------------------
' Play an adventure
'
Adventure:
CALL EDX.Select.Adventure: GOTO Menu
'------------------------------------
' Buy weapons and/or armor
'
Shop:
CLS : LOCATE 5: CALL Marcos: GOTO Menu
'------------------------------
' Learn spells from the Wizard
'
Wizard:
CALL Hokas.Tokas: GOTO Menu
'-----------------------------
'  Banker routines
'
BANK:
CALL Shylock: GOTO Menu
'---------------------------------
' View player data
'
Examine:
CALL Examine.Character: ON ro GOTO Menu, Village, Practice
'---------------------------------
' The Town Square
'
Village:
room$ = "village": ro = 2: x1 = 4: y1 = 11: GOSUB Header: COLOR 3: PRINT
PRINT "       1. Try your luck at the Casino Schmitt.": PRINT
PRINT "       2. Visit the Good Witch's Emporium.": PRINT
PRINT "       3. Browse exotic weapons at Grendel's Smithy.": PRINT
PRINT "       4. Check out the statue in the Village Square.": PRINT
PRINT "       5. Examine your abilities.": PRINT
PRINT "       6. Head north into the Main Hall.": PRINT
PRINT "       7. Wander south into the Practice Area.": PRINT
COLOR a: GOSUB HallInput
IF a$ = "X" AND s%(4) = 0 THEN GOSUB LeaveText: IF a$ = "Y" THEN EXIT SUB
a = VAL(a$): IF a < 1 OR a > 7 THEN GOTO Village
CLS
ON a GOTO Village1, Village1, Village1, Village1, Examine, Menu, Practice
Village1:
IF a = 1 THEN CALL Casino: GOTO Village
IF a = 2 THEN CALL Witch: GOTO Village
IF a = 3 THEN CALL Grendel: GOTO Village
CALL GMH.Look: CALL KeyWait: GOTO Village

'---------------------------------
' Goin' slumming
'
Practice:
room$ = "alleys": ro = 3: x1 = 4: y1 = 11: GOSUB Header: COLOR 12: PRINT
PRINT "       1. Practice your spells with a Licensed Wizard.": PRINT
PRINT "       2. Weapon Wielding 101 with Don Diego.": PRINT
PRINT "       3. Master the art of Wearing Your Clothes Properly.": PRINT
PRINT "       4. Talk to the man in the Info Booth.": PRINT
PRINT "       5. Examine your abilities.": PRINT
PRINT "       6. Enter the Village.": PRINT
PRINT "       7. Temporarily leave the universe."
PRINT : COLOR a: GOSUB HallInput
IF a$ = "X" AND s%(4) = 0 THEN GOSUB LeaveText: IF a$ = "Y" THEN EXIT SUB
a = VAL(a$): IF a < 1 OR a > 7 THEN GOTO Practice
ON a GOTO Practice1, Practice1, Practice1, Practice1, Examine, Village, Quit
Practice1:
IF a = 1 THEN CALL Magic.Training: GOTO Practice
IF a = 2 THEN CALL Weapon.Training: GOTO Practice
IF a = 3 THEN CALL Armor.Training: GOTO Practice
CALL Info.Booth: CALL KeyWait
IF info1 = 1 THEN
  PRINT "You head over there, not knowing what you will find...": PRINT
  x1 = 9: y1 = 16: CALL GMH.Look: CALL KeyWait
END IF
GOTO Practice

'  Update player record and exit to main menu
'  ------------------------------------------
Quit:
CALL Update: PUT #1, rec, c: CLOSE : CHDIR "..": RUN "EAMONDX"

Header:
CLS : a = 1: m = 14: COLOR a
PRINT ""; STRING$(75, ""); "": PRINT ""; SPACE$(20); : COLOR m
PRINT "THE MARVELOUS WORLD OF EAMON DELUXE "; : COLOR a: PRINT SPACE$(19); ""
PRINT ""; SPACE$(75); "": PRINT ""; SPACE$(14); : COLOR m
PRINT "Main Hall of The Guild of Free Adventurers v5.0"; : COLOR a
PRINT SPACE$(14); "": PRINT ""; SPACE$(75); ""
PRINT ""; STRING$(75, ""); "": COLOR s%(3), 0: LOCATE 8: COLOR a
PRINT "As you wander about the "; room$; ", you realize you can do one of seven things:"
RETURN
'
LeaveText:
CLS : PRINT "Switch to Graphic Main Hall? (Y/N):"; : CALL GetKey: l = 1: RETURN
'
HallInput:
IF s%(4) = 1 THEN PRINT " Please enter "; :  ELSE PRINT "Enter ";
PRINT "the number of your choice ";
IF s%(4) = 1 THEN PRINT "(1-7):"; :  ELSE PRINT "(1-7 or X=Graphics):";
COLOR s%(3): CALL GetKey: RETURN
END SUB

SUB Update
'
'          Update player record data and save in PLAYERS.DAT file
'         --------------------------------------------------------
Update:
CLOSE : OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
c.cname = n$: c.a1 = hd: c.a2 = ag: c.A3 = ch
c.SP1 = sp%(1): c.SP2 = sp%(2): c.SP3 = sp%(3): c.SP4 = sp%(4)
c.WA1 = wa%(1): c.WA2 = wa%(2): c.WA3 = wa%(3): c.WA4 = wa%(4): c.WA5 = wa%(5)
c.ae = ae: c.sex = sex: c.gold = gold: c.BANK = BANK: c.ac = ac
c.WN1 = wn$(1): c.WN2 = wn$(2): c.WN3 = wn$(3): c.WN4 = wn$(4)
c.WCOMPLX1 = wc%(1): c.WCOMPLX2 = wc%(2): c.WCOMPLX3 = wc%(3): c.WCOMPLX4 = wc%(4)
c.WTYPE1 = wt%(1): c.WTYPE2 = wt%(2): c.WTYPE3 = wt%(3): c.WTYPE4 = wt%(4)
c.WDICE1 = wd%(1): c.WDICE2 = wd%(2): c.WDICE3 = wd%(3): c.WDICE4 = wd%(4)
c.WSIDES1 = ws%(1): c.WSIDES2 = ws%(2): c.WSIDES3 = ws%(3): c.WSIDES4 = ws%(4)
END SUB

SUB Weapon.Training
'
'                Randomly increase weapon abilities
'               ------------------------------------
CLS 2: l = 1
a$ = "The man behind the counter says, " + q$ + "I'm Don Leif Thor Robin "
a$ = a$ + "Hercules Diego, at your service!  I teach weapons." + q$
CALL DispString: CALL KeyWait
PRINT q$; "Select your weapon of interest:"; q$: GOSUB WepT1
IF a = 6 THEN GOTO WepT2

a$ = q$ + "My fee is 1000 gold pieces per try.  Your current ability is "
a$ = a$ + LTRIM$(RTRIM$(STR$(wa%(a)))) + "%." + q$
CALL DispString: CALL KeyWait
a$ = "Don asks you to enter his shop.  " + q$ + n$ + ", see that "
a$ = a$ + RTRIM$(MID$("dummy target", 6 * ABS(a = 2 OR a = 4) + 1, 6))
a$ = a$ + " over there?  It's all in the wrist...  ATTACK!" + q$
CALL DispString: IF l > 1 THEN CALL KeyWait

WepT0:
CLS 2: l = 1: PRINT "Ability: "; RTRIM$(LTRIM$(STR$(wa%(a)))); "        ";
PRINT "Gold: "; RTRIM$(LTRIM$(STR$(gold))): PRINT
IF gold < 1000 THEN
  PRINT q$; "Sorry, but you have too little gold!"; q$
  CALL KeyWait: EXIT SUB
END IF
PRINT "(A)ttack         (R)est         (S)top": PRINT
PRINT "Enter A, R, or S:"; : CALL GetKey: CLS 2: l = 1

IF a$ = "S" THEN GOTO WepT2
IF a$ = "R" THEN
  a$ = "PUFF  PUFF  PUFF.  " + q$ + "Stamina is important!" + q$
  CALL DispString: CALL KeyWait: GOTO WepT0
END IF
IF a$ <> "A" THEN GOTO WepT0

k = INT(RND * 10 + 1): gold = gold - 1000
IF k = 10 THEN
  a$ = q$ + "A critical hit!  Very good!  Now, continue." + q$
  wa%(a) = wa%(a) + 2
END IF
IF k > 5 AND k < 10 THEN
  a$ = q$ + "A hit!  Good!  Now, continue." + q$: wa%(a) = wa%(a) + 1
END IF
IF k < 6 THEN a$ = q$ + "A miss!  Try harder!  Now, continue." + q$

IF wa%(a) > 200 THEN wa%(a) = 200
CALL DispString: CALL KeyWait: GOTO WepT0

WepT1:
PRINT "   1.  Axe      4.  Spear": PRINT "   2.  Bow      5.  Sword"
PRINT "   3.  Mace": PRINT : PRINT "Enter 1-5 or (0 to exit): ";
CALL GetKey: a = INSTR("123450", a$): IF a = 0 THEN GOTO WepT1
CLS 2: l = 1: RETURN

WepT2:
CLS 2: l = 1: PRINT q$; "Goodbye and good luck!"; q$: EXIT SUB
END SUB

SUB Witch
'
'                       I'LL GET YOU, MY PRETTY!
'                      --------------------------
a$ = "A lovely young woman says, " + q$ + "Good day, " + n$ + ".  Ah, you're surprised that I know your name?"
CLS 2: l = 1: CALL DispString: CALL KeyWait
a$ = "I also know the extent of your hardiness, agility, and charisma.  If you wish, I can magically raise your attributes."
CALL DispString: PRINT
PRINT "Would you like this?  (Y/N):"; : CALL GetKey: IF a$ <> "Y" THEN EXIT SUB

Witch1:
bet = 5000 - ch * 50: CLS 2: l = 1
a$ = "My standard price is 5,000 gold pieces per attribute point.  However, I will charge you only" + STR$(bet) + " GP/point."
CLS 2: l = 1: CALL DispString: CALL KeyWait
IF bet > gold THEN
  a$ = q$ + "Ah, but I see you can't afford my modest fee.  Good faring, " + n$ + q$
  CLS 2: l = 1: CALL DispString: CALL KeyWait: EXIT SUB
END IF

PRINT "HD:"; STR$(hd); "  AG:"; STR$(ag); "  CH:"; STR$(ch)
PRINT "Gold ="; STR$(gold); "   (Price ="; STR$(bet); ")"
PRINT : PRINT "Change which?  H/A/C or N(one): ";
CALL GetKey: F = 0: CLS 2: l = 1: IF a$ = "N" THEN EXIT SUB
FOR z = 1 TO 3
   IF a$ = MID$("HAC", z, 1) THEN F = z
NEXT
IF F = 0 THEN GOTO Witch1

gold = gold - bet
IF INT(RND * 20) + 1 > ch THEN
  a$ = q$ + "Because of your powerful adventurer's aura, my spells will sometimes fail.  "
  a$ = a$ + "Unfortunately, this was one of those times..." + q$
  CALL DispString: EXIT SUB
END IF
IF F = 1 THEN hd = hd + 1
IF F = 2 THEN ag = ag + 1
IF F = 3 THEN ch = ch + 1

a$ = "The witch begins an incantation and you are enveloped by a hazy white cloud.  "
a$ = a$ + q$ + "It is done!" + q$ + "  She exclaims."
CALL DispString: CALL KeyWait: GOTO Witch1
END SUB

