' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                                                                
'                                                                
'              .TXT --> ADVENTURE HINT FILE APPENDER             
'                                                                
'                                           Update: 10 AUG 1999  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

'
'  This program will read a text file called NEWHINTS.TXT and append
'    the data to an Eamon Deluxe adventure's HINTDIR.DAT and HINTS.DSC files
'
'  Data MUST be in the following format:
'
'  [Adventure name that hints represent]
'  # of hints
'  h[hint number]
'  [Hint name]
'  [number of clues]
'  [Clues]
'
'  [and so on...]
'  Note that a carrige return must follow each set of clues
'
'        ------  Example  ------
'
'  Example adventure
'  2
'  h1
'  Hint number 1
'  3
'  Clue 1
'  Clue 2
'  Clue 3
'
'  h2
'  Hint number 2
'  1
'  Clue 1

'CHDIR "c:\eamondx\dd"

CHDir "..":chdir "dd"
'
TYPE ADV
   ANAME AS STRING * 78
   NUMBER AS INTEGER
END TYPE
DIM ADV AS ADV

'---------------------------------------------------------------------------
' Load design names
'
OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE
IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d1$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d2$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
'---------------------------------------------------------------------------
' Load adventure names
'
CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #3 LEN = 90
GET #3, 1, ADV
numadv = ADV.NUMBER: numadv1 = numadv
DIM an$(numadv + 2), anum(numadv + 2)

FOR a = 2 TO numadv + 1
   GET #3, a, ADV
   an$(a - 1) = LTRIM$(RTRIM$(ADV.ANAME$))
NEXT
CLOSE : CHDIR "DD"
IF d1 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d1$ + "  (Design 1)"
END IF
IF d2 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d2$ + "  (Design 2)"
END IF
'---------------------------------------------------------------------------
' Change to proper directory
'
Start:
CLS : L = 0
PRINT "Select adventure to edit."
FOR a = 1 TO numadv
   a$ = LTRIM$(RTRIM$(STR$(a))) + ": " + an$(a)
   PRINT a$
   L = L + 1
   IF L = 20 THEN
      PRINT "Hit any key to continue...";
      DO
      LOOP UNTIL INKEY$ <> ""
      L = 0
   END IF
NEXT
PRINT
LINE INPUT "Enter the number of your choice:"; a$
a = INT(VAL(a$))
IF a < 1 OR a > numadv THEN GOTO Start
a$ = LTRIM$(RTRIM$(STR$(a)))
ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
IF a = numadv1 + 1 THEN ad$ = "DGN-1"
IF a = numadv1 + 2 OR (a = numadv1 + 1 AND d1 = 0) THEN ad$ = "DGN-2"
CHDIR "..": CHDIR ad$
'----------------------------------------------------------------------------
' Initialize variables for random access files
'
TYPE DESC
  text AS STRING * 255
END TYPE
DIM ds AS DESC

OPEN "HINTDIR.DAT" FOR INPUT AS #1
OPEN "HINTS.DSC" FOR RANDOM AS #2 LEN = 255

OPEN "NEWHINTS.TXT" FOR INPUT AS #3
LINE INPUT #3, nn$: INPUT #3, nh2

INPUT #1, nh: DIM h$(nh + nh2), h%(nh + nh2, 2)
FOR r = 1 TO nh: LINE INPUT #1, h$(r): INPUT #1, h%(r, 1), h%(r, 2): NEXT
r2 = h%(nh, 1) + h%(nh, 2)

CLS
PRINT "Testing file structure...": PRINT
COLOR 0, 2: PRINT "  "; nn$; "  ": COLOR 7, 0: PRINT
FOR r = 1 TO nh2
   LOCATE CSRLIN, 1: PRINT "Testing hint #"; r; " /"; nh2;
   LINE INPUT #3, a$
   IF VAL(MID$(a$, 2)) <> r THEN PRINT : BEEP: PRINT "Error": END
   LINE INPUT #3, a$: INPUT #3, z
   FOR a = 1 TO z: LINE INPUT #3, a$: NEXT
   IF r < nh2 THEN INPUT #3, a$
NEXT

PRINT " ....Done!": PRINT : PRINT : CLOSE #3
PRINT "[HIT ANY KEY TO CONTINUE]": k$ = INKEY$
DO
LOOP UNTIL INKEY$ <> ""

OPEN "newhints.txt" FOR INPUT AS #3
LINE INPUT #3, nn$: INPUT #3, nh2

CLS
FOR r = 1 TO nh2
   LOCATE CSRLIN, 1: PRINT "Reading/writing hint #"; r + nh; " /"; nh + nh2;
   LINE INPUT #3, a$
   LINE INPUT #3, h$(r + nh): INPUT #3, z
   h$(r + nh) = LEFT$(LTRIM$(RTRIM$(nn$)) + " -- " + h$(r + nh), 76)
   h%(r + nh, 1) = r2: h%(r + nh, 2) = z
   FOR a = 1 TO z
     LINE INPUT #3, a$: ds.text = a$: PUT #2, r2, ds
     r2 = r2 + 1
   NEXT
   IF r < nh2 THEN INPUT #3, a$
NEXT
CLOSE
PRINT " ....Done!": PRINT : PRINT "Updating Hint Directory";
OPEN "HINTDIR.DAT" FOR OUTPUT AS #1
PRINT #1, nh + nh2
FOR r = 1 TO nh + nh2
   PRINT #1, h$(r): PRINT #1, h%(r, 1), h%(r, 2)
NEXT
PRINT "....Done!"
CLOSE

PRINT : PRINT "[Hit any key to continue...]": k$ = INKEY$
DO
LOOP UNTIL INKEY$ <> ""
CHDIR "..": CHDIR "UTILS": RUN "UMENU"

'
' Copyright (C) 2012  Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'


