' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
' FORCE RESET OF EAMON DELUXE SYSTEM SETTINGS                    
'    AND INSTALLED ADVENTURES ROSTER                             
'                                           Update: 12 JUN 2012  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB paws ()

TYPE adv
   aname AS STRING * 78
   number AS INTEGER
END TYPE
DIM adv AS adv

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10), BORT
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em0 = 2
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)

Menu:
COLOR 15: GOSUB Header
IF BORT = 1 THEN COLOR 14: PRINT SPACE$(66); "(BORT = SPOT)": PRINT
c = 7: c1 = 10: x = em0
CALL EDXMenuM(c, c1, 1, x, 2, 0)
IF BORT = 5 THEN BORT = 1: GOTO Menu
GOSUB Header: IF c < 1 OR c >= em0 OR c1 = 3 THEN RUN "UMENU"

IF c = 1 THEN
  PRINT "Restore Eamon Deluxe default system settings? (Y/N)"; : GOSUB GetKey
  IF k$ <> "Y" THEN GOTO Menu
  OPEN "..\SETTINGS.DAT" FOR OUTPUT AS #1
  WRITE #1, 0, 0, 0, 0, -1, 2, 3: FOR x = 4 TO 10: WRITE #1, 0: NEXT: CLOSE
  PRINT "Defaults restored. Settings will reset next time Eamon Deluxe is started."
  CALL paws: GOTO Menu
END IF

' Warning! This routine permanently modifies installed adventures list!
PRINT "Reset Adventure #1 name to Beginner's Adventures? (Y/N)"; : GOSUB GetKey
PRINT : r = 0: IF k$ = "Y" THEN r = 1
LINE INPUT "Number of installed adventures? (Enter=1):"; ad$: PRINT
IF ad$ = "" THEN ad$ = "1"
a = ABS(INT(VAL(ad$)))
OPEN "..\ADVENTRS" FOR RANDOM AS #1 LEN = 90: GET #1, 1, adv
  an$ = adv.aname: IF r = 1 THEN an$ = "Beginner's Adventures"
  COLOR 15: PRINT a; "installed adventures."
  PRINT : PRINT "#1 is:"; an$: PRINT : PRINT "Proceed with modification?";
  GOSUB GetKey: IF k$ <> "Y" THEN CLOSE : GOTO Menu
  adv.aname = "Eamon Deluxe v5.0": adv.number = a: PUT #1, 1, adv
  adv.aname = an$: adv.number = 1: PUT #1, 2, adv
CLOSE

ResetDone:
CLS : COLOR 14
PRINT "Eamon Deluxe ADVENTRS file reset.": PRINT
PRINT : PRINT "Hit any key to continue..."; : CALL paws: GOTO Menu

Header:
CLS : PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(16); "EAMON DELUXE v5.0 DUNGEON DESIGN UTILITIES";
PRINT SPACE$(16); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT : RETURN

' Get a Y/N kepress
'
GetKey:
k$ = ""
DO
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ = "Y" OR k$ = "N"
PRINT k$: RETURN

EDXMenuStrings:
DATA 4
DATA "  Restore Eamon Deluxe Default Settings  "
DATA "  Quit  "
DATA "  Reset Adventure List  "
DATA "  Quit  "

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Updated with VI Mode alternate numeric menu: 12 JAN 2012
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1

' VI Mode numeric menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  L = 2
  FOR x = be TO en
     x$ = LTRIM$(STR$(x - be + 1)) + ": " + LTRIM$(RTRIM$(em$(x)))
     IF x < 100 THEN x$ = " " + x$: IF x < 10 THEN x$ = " " + x$
     PRINT x$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       CLS : L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to exit):";
  LINE INPUT ""; k$: c = INT(VAL(k$)): c1 = c + (be - 1)
  IF c = 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, 0
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, 0: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF
IF k = 98 AND BORT = 0 THEN BORT = 2: SOUND 250, .5
IF k = 111 AND BORT = 2 THEN BORT = 3: SOUND 350, .5
IF k = 114 AND BORT = 3 THEN BORT = 4: SOUND 450, .5
IF k = 116 AND BORT = 4 THEN
  ' IT'S A BORT! (BORT STILL = SPOT)
  BORT = 5: c1 = 1: SOUND 550, .5: em0 = 3: em$(2) = em$(3): em$(3) = em$(4)
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB paws
PRINT : PRINT "[Hit any key to continue]"; : k$ = INKEY$: k$ = ""
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
END SUB

