PART ONE:  Chapter 2
INSTALLATION
(Also contained in the disk file "12INSTAL.MAN".)
 
 
Last revision:  November 1993.
 
 
 
CONTENTS OF CHAPTER 2
 
    1.   INTRODUCTION . . . . . . . . . . . . 1-2.13
    2.   QUICK INSTALLATION DESCRIPTION . . . 1-2.13
    3.   LOADING AND USING JAWS . . . . . . . 1-2.14
         3.1  Command to Load JAWS. . . . . . 1-2.15
         3.2  Installation Problems . . . . . 1-2.15
1.  INTRODUCTION
 
    This chapter describes the process used by the installation
program to install JAWS.  To help us be clear as we describe the
installation process, we will define the meaning of two words that
are
frequently used.  A complete explanation of other special words
that will
be used in this manual is contained in Appendix 1.  Please refer to
this
appendix whenever we use computer related terms with which you are
unfamiliar, or if you become confused by the way we use print
styles to
express the proper form of a computer command.
 
"Type"
    The word "type" means to use the alphabet and number keys to
    create text on the screen that exactly matches the words and
    symbols that follow the word "type".  It is not necessary to
type
    the letters and words as capital letters even though they may
be
    shown as all capital letters.
 
"Press"
    The word "press" indicates that you should push down the key
    that appears immediately after the word "press".  For example,
    the expression "Press ENTER" means to press the ENTER key. 
    The expression "Press ALT + RIGHT ARROW" means to hold
    down the ALT key and press the RIGHT ARROW key.
 
 
2.  QUICK INSTALLATION DESCRIPTION
 
    The installation process is managed by an automatic
installation
program that asks you a series of questions about your speech
synthesizer and computer.  Once it obtains the information it
needs,
then it will install your software.  It is not always necessary to
install
your speech synthesizer before using the installation program.  We,
however, do recommend that you install the synthesizer first, if it
is a
DECtalk PC or any other synthesizer that requires modification to
the
AUTOEXEC.BAT or CONFIG.SYS files.
 
a.  Open the sealed
    envelope that contains the JAWS distribution diskettes, and
place
    the first JAWS distribution disk labeled "1" into your A-drive
or
    B-drive.
 
b.  Type A:INSTALL or B:INSTALL
         Press ENTER.
 
         The installation process can be stopped at any time by
    pressing ESCAPE followed by ENTER.  Pressing any other key
    will usually tell the installation program to move on to the
next
    step.  If you are already using a screen reading program and
    speech synthesizer when you start the installation process,
then 
    information that is displayed on the screen during the
installation
    process will be spoken.
 
c.  At this point, you will be asked to select various installation
    options.  If you are installing a new copy of JAWS, then you
also
    will be asked to complete a short registration process.  All of
    these steps are explained as they occur.  The PC will beep each
    time you need to insert the next JAWS distribution disk.  When
    all disks have been used, then you will need to insert the
first
    diskette back into the disk drive to complete the process.  If
you
    need additional information about a step in the installation
    process, then the detailed installation information contained
in
    Appendix 2 should help resolve your questions.  If  you do not
    need additional information during installation, and everything
    works smoothly, then you do not need to read Appendix 2.
 
 
3.  LOADING AND USING JAWS
 
    You have now completed the installation process.  If you have
not
exited the installation program, then please do so now by pressing
ESCAPE and ENTER.  If you were instructed to copy a software driver
to your hard disk, then this should be done at this point.  If
changes
were made to either your AUTOEXEC.BAT or CONFIG.SYS files during
installation, then you must reboot your computer before these
changes
will take effect.
 
    If you have not installed your speech synthesizer, then you
should
install it before you load JAWS.  Please follow the instructions
provided
with your synthesizer for correct synthesizer installation.  The
Installation Reference disk files "51INTERN.MAN", "52EXTERN.MAN",
and "53SYNTH.MAN" also contain basic information about installing
most synthesizers.  These reference chapters are available in disk
files
and are not part of this printed volume.  Section 6, at the end of
this
chapter, describes the organization of the JAWS manual and explains
how to use chapters that are only available on computer disk.
 
3.1 Command to Load JAWS
    
    To load JAWS, you should type the word "JAWS" at a DOS
prompt and press ENTER.  When JAWS loads, you should hear the
speech synthesizer speak an introductory message, and the JAWS logo
and copyright message should be displayed on the computer screen.
 
    If the installation was successful and you heard words being
spoken, then you are ready to learn about using JAWS.  Don't worry
if
you did not understand the words that were spoken.  There are
several
adjustments which may be needed to make the speech intelligible. 
At
this point, our goal is simply to have the JAWS software ready for
use
and to have the speech synthesizer installed properly. Chapter 3 in
PART ONE of this manual will explain the details about how to begin
using JAWS.
 
3.2 Installation Problems
 
    If JAWS does not speak after you reboot your computer and you
type "JAWS" and press ENTER at a DOS prompt, then you will have to
investigate the causes of the problem.  If you have a new speech
synthesizer, then you may wish to recheck the tightness of
synthesizer
connections including external speaker or headphone connections,
and
be sure the volume level is set to a mid range loudness setting. 
Appendix 2 discusses other common problems that could prevent JAWS
and your speech synthesizer from speaking.
