PART FOUR:  Application 2
LOTUS 1-2-3
(Only contained in the disk file "42LOTUS.MAN".)
 
 
(Last revision:  1992.)
 
 
 
CONTENTS FOR APPLICATION 2
 
    1.   SUMMARY OF LOTUS MACROS
    2.   EXPLANATION OF MACROS
         2.1  Sheet Cursor On
         2.2  Read Current Function
         2.3  Read Cell
         2.4  Read Menu
         2.5  Up, Down, Left, AND Right ARROWS
         2.6  Read Status
         2.7  Read Cell Coordinates
         2.8  Read Data
         2.9  Position
         2.10 Read Help Line
         2.11 Read Column Title
         2.12 Read Row Title
    3.   MENUS AND CURSORS
    4.   MODIFYING JAWS MACRO KEYS
    5.   USER FLAGS
1.  SUMMARY OF LOTUS MACROS
 
INSERT + PLUS = Sheet Cursor On.
 
INSERT + Z or speech pad 5 (SHIFT + END on Toshiba) = Read
Current Function.
 
INSERT + C = Read Cell.
 
INSERT + F = Read Menu.
 
INSERT + S = Read Status.
 
INSERT + A = Read Cell Coordinates.
 
INSERT + D = Read Data.
 
PERIOD or DELETE = Position.
 
INSERT + DOWN ARROW = Read Help Line.
 
INSERT + T = Read Column Title.
 
INSERT + R = Read Row Title.
 
 
ARROW KEYS = See explanation of macros below.
 
 
2.  EXPLANATION OF MACROS
 
2.1 Sheet Cursor On (INSERT + PLUS)
 
    When this is on the arrow keys perform a spreadsheet function,
i.e.  moving the cell pointer, or choice, in the menu.  The new choice is
spoken.  Turning on the JAWS Cursor or the PC Cursor automatically
turns off the Sheet Cursor.  
 
    Now you have three cursors.  Use the Sheet Cursor to move and
speak the spreadsheet; use the JAWS Cursor if you need to read freely
around the screen; and use the PC Cursor for things like editing, where
the application program actually uses the PC Cursor the way it should.
 
2.2 Read Current Function (INSERT + Z or speech pad 5, or Toshiba
    SHIFT + END)
 
    This will read the current spreadsheet function if the Sheet
Cursor is on.  If not, it will read the character at the cursor, just like
regular JAWS.  The INSERT + Z will read the current spreadsheet
function.  This would be the highlighted menu choice if menus are
displayed, or the prompt on line 2 when it is displayed, or the value in
the current cell when the spreadsheet is "ready".  JAWS automatically
decides which to read.  See "Read Cell" or "Read Menu" for more
information.
 
2.3 Read Cell (INSERT + C)
 
    Reads the value of the highlighted cell in the spreadsheet, the
information that appears in the spreadsheet area, not on line 1.  speech pad
5 also reads this when Sheet Cursor is on.
 
2.4 Read Menu (INSERT + F)
 
    Reads the highlighted choice in the menu if menus are displayed. 
Will also read the prompt or edit field on line 2 if one exists.  speech pad
5 also does this if the Sheet Cursor is on.
 
2.5 Up, Down, Left, AND Right ARROWS
 
    When the Sheet Cursor is on, the arrow keys will perform
spreadsheet functions, like moving the highlighted cell in the
spreadsheet or the highlighted choice in the menu.  The new choice will
be spoken.  Sometimes, the arrow keys will not perform as you might
expect.  For example, if you are in the Menu mode, THEN the UP
ARROW and DOWN ARROW do nothing.  If you are at the top or left
side of the spreadsheet, the UP ARROW and LEFT ARROW will do
nothing.  If you are not in the Ready mode or the Menu mode, then you
probably have a prompt or edit field on line 2 and the performance of
the arrow keys will depend on the situation; i.e.  the application will do
different things at different times.  If you are not sure what to do, just
try something.  During Edit mode, the PC Cursor should be turned on,
then the LEFT ARROW and RIGHT ARROW will read the edit data.
 
2.6 Read Status (INSERT + S)
 
    Reads the status information at the top right corner of the screen. 
It says things like "ready" when the spreadsheet is ready, "menus" when
menus are displayed on line 2 and 3, "point" when you need to enter cell
coordinates or positions, "files" when you are retrieving or saving files,
etc.  Use INSERT + S to read this status information when you are not
sure what the spreadsheet is doing.
 
2.7 Read Cell Coordinates (INSERT + A)
 
    Reads the row and column of the current cell, e.g.  "A1" or "K9".
The letter is the column, the number is the row.
  
2.8 Read Data (INSERT + D)
 
    Reads the cell data displayed on line 1.  This would be the
formula used to calculate the cell value, or a label, or numeric data, or
whatever you enter for the cell.  This key reads the data and places the
JAWS Cursor at the beginning of the data.
 
2.9 Position (PERIOD or DELETE)
 
    This reads the position of the cursor.  If the Sheet Cursor is on,
it will read the cell coordinates, "A5", "Z29", etc.  If the JAWS or PC
Cursor is on, it will read the row and column numbers.
 
2.10Read Help Line (INSERT + DOWN ARROW)
 
    When the Sheet Cursor is on, this key will read the Menu Help
information displayed on line 3 when the spreadsheet menus are
displayed.  If the JAWS menus are up or displayed, it will also read the
JAWS menus help line.  This is very useful for learning more about the
highlighted menu choice.
 
2.11Read Column Title (INSERT + T)
 
    This reads the title of the spreadsheet column of the highlighted
cell.  At least, it is supposed to.  Actually, it just reads the word on line
5 of the screen directly above the highlighted cell:  It looks straight up
from the highlighted cell and reads whatever is on line 5.  You can use
your spreadsheet commands to lock the labels or titles for the column
in this position so this key will actually read the title.  If your titles are
displayed somewhere else, you can modify this macro key to read the
appropriate place on the screen.  This is just a macro that finds the
highlighted cell, then performs a Goto function to move to line 5, while
staying in the same column.
 
2.12Read Row Title (INSERT + R)
 
    This is designed to read the title of the row that the highlighted
cell is in.  Actually, it reads the second word from the left in the row the
highlighted cell is in.  Use your spreadsheet commands to lock the row
titles in this position, so this key will actually read the desired
information.  This is just a macro that finds the highlighted cell, then
moves to the left side of the screen, then does a Next Word and speaks
whatever information is there.
 
 
3.  MENUS AND CURSORS
 
    When you invoke the spreadsheet menus with the / (slash), you
will notice that it reads the highlighted menu choice (be sure Sheet
Cursor is on).  Then as you use the left or right arrow keys, or press the
letter of the choice you want, it will read the new highlighted choice. 
Use the enter key to select a choice; JAWS will speak the new menu. 
Use the ESCAPE to exit a menu; JAWS will speak the new menu.  If
the highlighted choice should disappear, such as when entering a file
name, JAWS will automatically read the prompt on line 2.  Whenever
entering or editing data, such as file names or cell coordinates, turn on
the PC Cursor for better control and to avoid reading line 2.
 
    JAWS monitors menu changes in frame 2, which is lines 2 and 3. 
Anytime something there changes it performs a macro, insert-F, which
searches for the highlighted menu choice.  If there is no highlight, it
reads line 2.  The monitoring causes JAWS to speak when you press a
letter key to make a menu selection, or the enter or escape keys.
 
    JAWS also monitors 1-2-3's status by monitoring frame 70, which
is the area in the top right corner where the status or mode appears. 
Each time this area changes the Read Status macro is performed to read
frame 70.
 
 
4.  MODIFYING JAWS MACRO KEYS
 
    If you do not like the way we have laid out our keys, you can
move them.  Use the duplicate and erase functions in the JAWS macro
menu to reassign macro keys. 
 
    Remember to save your new keyboard layout for future use with
the Config files menu.
 
 
5.  USER FLAGS
 
    The Sheet Cursor key turns on User Flag 1 if it is not already on. 
The JAWS Cursor and PC Cursor keys turn off User Flag 1, if it is not
already off.  Then other keys or functions, like the arrow keys, can check
the user flag and decide what to do.  For example, the DOWN ARROW
checks the user flag.  If it is on, it performs a DOWN ARROW, then
jumps to the Read Current Function macro, which then decides what
part of the spreadsheet to speak.  If the user flag is not on, the DOWN
ARROW performs normally.  It does a Say Next Line, which moves the
active cursor (JAWS or PC) down a line and speaks the new line.
 
