PART FIVE:
Installation Reference 1
INTERNAL SYNTHESIZERS
(Only contained in the disk file "51INTERN.MAN".)
 
 
(Last revision:  November 1993.)
 
 
 
CONTENTS OF INSTALLATION REFERENCE 1
 
    1.   INTRODUCTION
    2.   OPENING THE COMPUTER CASE
    3.   INSTALLING THE SYNTHESIZER
    4.   TESTING YOUR INSTALLATION
1.  INTRODUCTION
 
    It is quite easy to install an internal speech synthesizer, even if
you have never opened the back of your computer before.  These
instructions will help you with most PC's.  The PS/2 computers with
micro channel architecture will be different but similar.  The Toshiba
and other laptop PC's are very different.
 
 
2.  OPENING THE COMPUTER CASE
 
a.  Turn off your computer and unplug the power cord.  
 
b.  If your monitor is resting on the top of your computer, take it off,
    and unplug your keyboard.
 
c   Touch the metal of the computer's case with both of your hands
    to discharge any static electricity that may be on your body.
 
d.  Unscrew the screws that hold the top of the case onto the
    computer.  The screws may be in the back; perhaps one at each
    corner and in the middle at the top.  They could also be on the
    sides, at each of the lower corners.  The information that came
    with your computer should contain information about doing this
    step if you run into a problem.
 
e.  Slide the case off of the computer.  It may slide forward, then up. 
    It may slide straight up, or it may slide backwards.  Refer to your
    owner's manual if there is a problem.
 
    You will see your hard disk, various cables, and possibly one or
    more expansion cards (also called boards) resting in their slots.  
 
 
                      WARNING!
 
    Always turn the power OFF before you insert or
    remove components from your PC.  Leaving the
    power on will damage your system.
 
 
3.  INSTALLING THE SYNTHESIZER
 
a.  Find an empty slot.  Most synthesizers will work in an 8-bit or
    16-bit slot.  The Accent PC, Sounding Board, Prose 4000, and
    Symphonix will work in either an 8-bit or 16-bit slot.  Sixteen-bit
    slots have two "feet" or places to plug in the board.  These are
    raised ridges in the bottom (or side) of the case, with a groove
    into which the board is inserted.
 
b.  Remove the slot cover from the back of the PC and save the
    screw.  Slot covers are metal brackets that are about 5 inches
    long with a one half inch long tab on top through which the screw
    is inserted.  These covers keep dust out of the computer. 
    Examine the slot in the bottom of the computer and examine the
    placement of the other boards.  Your synthesizer will have to fit
    into one of these slots in a similar manner.
 
c.  Carefully take the synthesizer card out of its wrapping.  Avoid
    touching the chips and the series of pins on the bottom of the
    card.  Your goal is to plug the card into the groove (slot) in the
    PC.  With some PC's, you may have to slide the synthesizer
    through the back slot of the PC before you can set it into the slot. 
    Closely examine the alignment of the card and the slot as you set
    the card into the slot.  You may wish to touch the synthesizer and
    the edges of the slot to confirm that the board is properly lined
    up.  You may have to firmly press down on the card to make it
    slide all the way down into the slot.  You may have to give the
    card a final push to firmly seat the board.
 
d.    The back of the synthesizer now fills the open space that had
    been filled by the slot cover.  Take the screw that you removed
    from the slot cover and insert it into the synthesizer retaining
    bracket.  You will use the same hole in the case that was
    originally used to hold the slot cover.  Tighten the screw firmly.
 
 
4.  TESTING YOUR INSTALLATION
 
a.  Before putting the computer back together, test your installation. 
    Connect a speaker, or pair of headphones to the synthesizer if it
    does not have a built-in speaker.  Be sure you are using the
    correct size and type of plug.  Some synthesizers have a 1/8-inch
    mini jack (Accent, Sounding Board, Symphonix), some have an
    RCA jack (Prose), and other synthesizers may use different jacks. 
 
c.  Plug the computer in and turn on the power.  DO NOT TOUCH
    ANYTHING INSIDE THE COMPUTER WHILE THE
    ELECTRICAL POWER IS ON!  Listen for a pop or click,
    electronic noise, or speech.  Any of these sounds will indicate that
    the synthesizer is connected to the computer.  If you do not hear
    anything, then it is advisable to re-check your installation to be
    sure that the board is properly seated into the slot. 
 
d.  Once you have heard some type of sound from the synthesizer,
    then turn your computer off and replace the cover.
 
e.  Reconnect the monitor and keyboard, and then turn the PC on to
    make sure it is working properly with the synthesizer installed. 
    If you get an error message on the screen as the PC boots, then
    read it carefully.  Sometimes the error message disappears, and
    sometimes it gives you information that will help you solve a
    hardware installation problem.  If the computer had been working
    correctly prior to the installation of the synthesizer, and now it is
    not, then this is an indication of a hardware conflict.  See the
    section on hardware conflicts in Appendix D for suggestions on
    what to do.  Appendix E may also contain information about your
    synthesizer that will help resolve a hardware conflict.
 
         The internal Accent synthesizers will usually not cause
    problems.  They do not require an IRQ (Interrupt Request Line). 
    However, the Prose, Sounding Board, Symphonix, and other
    internal synthesizers, require their own IRQ, which may conflict
    with other hardware that you are using.
 
