PART SIX:  Update 1
ABOUT JAWS 2.0
(Only contained in the disk file "61JAWS20.MAN".)
 
 
 
 
 
 
JAWS 2.0 VERSUS JAWS 1
 
JAWS 2 is a new and improved version of the original JAWS, which we
will refer to as JAWS 1.   We will summarize the changes and new
features here for experienced JAWS1 users.
 
JAWS2 uses less than 95k bytes of memory versus J1's 125k.
 
Position key tells which cursor is on, JAWS or PC.
 
JAWS Cursor voice:  you can adjust the rate, volume, pitch, and tone to
sound different when the JAWS Cursor is on.   Use the "JAWS Cursor
voice" in the Voice menu to make the changes.
 
Home Row mode on/off is ALT + SPACE BAR, which has been changed
from SHIFT + SPACE BAR. 
 
Read Line X, followed by a letter or digits, will read the line
corresponding to the letter or number.   Press CONTROL + SPACE BAR
for this function.
 
The JAWS Menu System is slightly different:  You can use next/prior
word or next/prior character (right/left arrows) to read through the
menus;  Pressing a letter will move to and speak the new menu choice; 
"Z", PAGE UP, and ESCAPE will exit all the way out of the menu
system, ALT + ESCAPE no longer works;  DOWN ARROW and ENTER
will select the current menu choice and read the new menu choice (and
not the help line as DOWN ARROW did previously).
 
Configuration files:   There are now 5 independent configuration-type
files, for more power and flexibility.   Macros, frames, environment,
voice and dictionary are now saved or loaded separately from the config
files menu.   The "All" choice saves/loads them all.   Refer to the
training tapes or manual for more details.
 
Macros:   The macros are all new.   The macro editor loads from disk
when needed, all the keys are "macros" and can be moved around
anywhere on the keyboard and/or edited.   Decision-making capability
(if-then-else statements), 120 keys/functions per macro, unlimited
macros per file/configuration, user-definable macro labels and more.  
Listen to the Macros training tape for more info.
 
Frame monitoring:   JAWS1 would speak the contents of a frame that
was being monitored.   JAWS2 will perform a macro when it senses a
change in a frame being monitored.   The macros are user-definable, so
JAWS2 will perform many functions automatically, almost anything you
can do from the keyboard can be done with an Auto-Macro.
 
Dictionary:   JAWS2 has done away with the dictionary editor (add or
erase) functions that JAWS1 had.   You can load and use a dictionary
file, but you must create it or edit it in the text editor of your choice.  
JAWS2 can use JAWS1 dictionary files with one minor difference:  to
represent a graphics or extended character enter a backslash followed
by 3 digits.   The digits are the decimal value of the character.   For
example, use the following rule to speak the "up arrow" graphic
character:  
 
.\024.up arrow.
 
Remember that the first character is the delimiter, which is also used
to separate the first part from the second part and to terminate the rule.
 
Search string:   When entering a graphic character to search for use the
same syntax as explained above for the dictionary, a backslash followed
by 3 digits.
