PART SIX:  Update 2
ABOUT JAWS VERSION 2.2
(Only contained in the disk file "62JAWS22.MAN".)
 
 
(Last Revision, April 1992.)
 
 
 
SMART SCREEN
 
    Smart Screen is designed to handle pull-down menus, pop-up
windows, color bars, and other pieces of information that appear on the
computer screen.  Smart Screen is a set of features that work together
to enhance your computer access.  For an overview of these functions
look at the Smart Screen menu:  Invoke the menus, then press F for
frames, and press T for smarT.  There you will find "Smart Screen",
"Smart Level", "Color Bar", "Smart Focus", and "Smart Options".  
 
    The Smart Screen on/off toggle turns "Smart Speaking" on or off. 
Invoke the menus with CONTROL + / (hold down the control key and
hit the / key) press F for Frames, T for smarT, S for Screen, then F for
ofF, or N for oN, or T for Toggle.  To quickly toggle Smart Screen on or
off without the menus you can use the JAWS macro key INSERT + S
(hold down the INSERT key and press S).
 
    When Smart Screen is on JAWS is constantly watching the screen
for any changes.  When a change is sensed, JAWS evaluates the new
data and determines what and how much to speak.  The new data will
be spoken automatically, as soon as the change occurs.  To repeat the
speaking press the Smart Screen Repeat macro key, INSERT + R.
 
COLOR BAR
 
    JAWS automatically senses when to track a color bar or when to
track the cursor.  This is dependent on the application program, it is not
fool-proof, and it can be over-ridden.  Just use the Color Bar on/off/auto
function, either through the smarT menu or the INSERT + C key, if the
automatic function is not working for you.  The INSERT + C macro
toggles or cycles from "on" to "off" to "auto".  If it is set to "Auto" JAWS
will try to decide which to track, color bar or cursor.  If you set it to "on"
then it will track the color bar, when set to "off" it will track the cursor.
 
    When using the color bar function Smart Screen should be on.  If
you hear two things being read in response to an arrow key, or a beep
indicating a cursor-movement error, you may need to turn off the cursor
by manually turning on the color bar.
 
SMART FOCUS
 
    If a lot of changes occur scattered around the screen you can turn
on "Smart Focus" and read just the changed areas with the JAWS
Cursor.  When Smart Focus is on the JAWS Cursor is limited to just the
areas of the screen that changed and were spoken by Smart Speak. 
This is an excellent way to review in detail the changes on the screen. 
When Smart Focus is off the JAWS Cursor can read anywhere, like
usual.  If Smart Focus is on the JAWS Cursor key will say "JAWS Focus
on", otherwise it will say "JAWS cursor on".
 
    When Smart Focus is on the JAWS Cursor is limited to just the
area that changed, the part of the screen read by Smart Speak.  The UP
ARROW and DOWN ARROW will take you to the previous or next block
of data that changed, not necessarily up or down a line.  PAGE UP or
PAGE DOWN will take you to the top or bottom, first or last, changed
block.  HOME and END will move the JAWS Cursor to the left edge of
the frame (block) or to the right edge.  Previous or Next Character/Word
will read left or right within the frame.  A beep tells you that you have
reached the boundary of the frame or changed area.
 
SMART LEVEL
 
    This sets the level or importance of the changed data, to give the
user control over what and how much is spoken.  You can control the
Speaking Level from the Smart Screen Menu:  invoke the menus, F for
Frames, T for smarT, L for Level.  When selected, the possible choices
are 1 through 8 and Auto.  The default value is 2.  increase or decrease
with the right or left arrow, press Enter to select.  Ore press the number
you want, or the letter "A".  Press Escape, Page Up, or "Z" to exit the
menus.
 
    The Smart Level number sets the minimum level that the new
data must have in order to get spoken.  Naturally you do not want to
hear all the changes on the screen, only the important ones.  The higher
the level the more the importance and the less that is spoken.  Use
trial-and-error to test which level works best for you and your
application program.
 
    The Auto selection will always speak something.  This is useful
when you are using a new program and do not know what is happening
on the screen.  The Auto level will speak all of the highest level changes
found.  For example:  If 5 changes occur on the screen and Smart Screen
assigns a level 3 to 4 of those changes and a level 1 to the remaining
change, then Smart Screen will only speak the changes with the highest
level, which is 4.
 
    JAWS looks at each piece of data and assigns it an importance
level.  The user determines the minimum level of importance for each
piece to get spoken, by entering the appropriate number, from "1"
through "8" or "A".  
 
    The Smart Level can also be input with a macro key, INSERT +
E.  think of "Enter Level".  This macro will prompt you to enter the
level, and it speaks the current level.  Type a new number if you want
to change it, or press ENTER to keep the current value.
 
SMART SPEAK
 
    Smart Speak is the name of the function that actually does the
speaking when Smart Screen is on.  Smart Speak is a function that
should be connected to a monitored frame, so that it will speak
automatically when new data appears on the screen.  See the INSERT-R
macro in the JAWS.JMF file for an example.  The function Smart
Screen Toggle is a flag that can be checked by an "if" statement in the
macro.  If the flag is true this macro calls Smart Speak, which is the
routine that does all the work.  The JAWS.JMF file has frame 0
monitored to the INSERT + R macro, which checks to see if Smart
Toggle is on and then speaks the changes to the screen.  Remember this
key by thinking "R" for Read or Repeat, since it can also be used to
repeat the Smart Screen reading.
 
    If you want to update your own macro files with these new
features use the Auto-Macros menu choice or the Frame Monitor menu
choice to set up an auto macro.  It will prompt you to enter the number
of the frame to monitor, then press the macro key to be performed, then
enter a delay factor, a digit from 0 to 30.  The higher the delay factor
the slower the response to changes on the screen.
 
SMART OPTIONS
 
    These are special options or parameters designed to fine tune the
Smart Speaking, the way JAWS determines the importance of the
changes that occur on the screen.  You access them through the Smart
menu:  Invoke the JAWS Menu System, press F for frames, T for
smarT, O for Options.  Here is a run down of the options:  
 
Left/Right
    This option will "promote" a change to a higher speaking level
when it detects a different attribute on either the left or the right of the
change.  This is good for horizontal menu bars.
 
 Up/Down
    This option will promote a change when it detects a different
attribute above or below the change.  This is ideal for vertical color bar
menus.
 
Attribute
    This option will promote all changes that have the same attribute
as the one set by the INSERT + D and SPACE BAR combination, the
"Define Smart Attribute" function.  Use this if you need to for tracking
Color Bars or for speaking specific colors or attributes on the screen. 
The default is off.  It must be on for JAWS to track the Defined Smart
Attribute or color.  More about this below.
 
Single
    When this option is on, it will prohibit the speaking of changes
that consist of just one character.  This is good for clocks that are
regularly updated on the screen or for status lines that show the current
cursor position.
 
Combine
    This option, when "on", will combine changes that physically
touch on the screen.  Use this option when menu options have certain
letters in a different attribute (sometimes called the "selection
character)".  This prevents a menu option from being broken up while
it is being spoken.  Let's say there is a pull down menu with a "File"
option.  The "F" in "File" is of a different color to indicate that it can be
activated by a certain key combination, such as ALT + F.  In some
programs, when the color bar lands on this option, it may retain the
foreground color and only change the background color.  Many of the
Norton Utility programs act this way.  If this is the case, then the "F"
in "File will be considered a different change than the "ile" in File. 
JAWS will speak a "F" and then "ile".  The result is garbled speech.  By
using the Combine option, you can tell Smart Screen to look ahead when
it's going to speak a change, and if the changes are next to each other,
then to speak the changes as one long string.  This eliminates the above
problem.  
 
Data Only
    This option, when set, promotes the changes of data only to the
highest level.  JAWS bases most of its decision making for importance
on the color (attribute) of the changes.  Sometimes, data will appear
that is of the same attribute as the data that it is overwriting.  So you
are working with a pull down menu and you have your Speaking Level
set to "4", and something pops up on the screen that is of the same color
that it appeared over.  JAWS will speak that data if you have the Data
Only Option set to "on".
 
Screen Echo
    When this is off Smart Screen and Frame Monitoring/Auto
Macros will not function along with DOS screen echo.  When this is on
JAWS will perform Smart Screen reading and frame monitoring/auto
macros simultaneously, which may result in speaking the same data
twice.  For example, while in DOS or some other program that uses the
BIOS to put data on the screen, JAWS automatically speaks all the data
and we do not need Smart Screen.  Other programs that do not use the
BIOS, and that write directly to the screen memory, need Smart Screen
to speak the data.  However, some programs, like ProcommPlus, use a
combination of BIOs and direct writes.  For those programs you want to
have the Smart Option Screen Echo turned on, to get the best of both
worlds.
 
DEFINE SMART ATTRIBUTE
 
    If you press the space bar in response to the prompt from the
INSERT + D macro you will set a specific color or attribute to track. 
Here we are telling JAWS "forget what you think is important, this is
the one I want".  JAWS will grab the attribute at the current cursor
position and use that to give a high level of importance to any data with
the same color.  This is very useful for tracking a specific color in a data
base, where many changes are taking place, or a complex menu like
WordPerfect 5.1, or a spell-checker.
 
    This "Smart Attribute" has a level of "8", if you want only this
data spoken also set your Smart Level to "8".  If Smart Level is set
lower than 8 it will speak the specific color and other data that has a
level greater than or equal to the Smart Level.
 
 
AUTOLOAD
 
    This feature causes JAWS to automatically load the proper
configuration files for your application program.  When you run or
launch a new application program JAWS makes note of the name it
uses, e.g.  "WP" for WordPerfect, "123" for Lotus 123.  Then JAWS looks
in the JAWS subdirectory (or whatever subdirectory JAWS was
launched from) and loads all configuration files with a matching name,
e.g.  "WP.JMF" and "WP.JFF" in the case of WordPerfect.
 
    If it cannot find any matching configuration files it will load up
the default files, named "JAWS" followed by the appropriate extension. 
JAWS configuration files have the extensions ".JMF" for JAWS Macro
File, ".JFF" for JAWS Frame File, ".JEF" for JAWS Environment File,
".JVF" for JAWS Voice File, or ".JDF" for JAWS Dictionary File.
 
    For example, if you had a dictionary file loaded by default
(JAWS.JDF), and you went into WordPerfect, it will retain the rules in
JAWS.JDF unless there was a WP.JDF file.  JAWS will remember what
program you are in, if you shell-out to DOS it will attempt to load up a
default set of files, those with the name "JAWS".  When you EXIT from
DOS back to the application, JAWS will reload the WP files.  You can
stack up to sixteen levels deep.  
 
    If JAWS cannot find a configuration file set to use, it will load up
the default JAWS set.  It will remember the application file name. 
When you go to save your settings, such as voices, or additional macros,
JAWS will pop up the name of the application for the configuration file
name.  All you have to do is hit Enter, thus creating a new configuration
file with the correct name, which will get loaded the next time you
launch this application.
 
    Note that for autoload to work the config files must have a
matching name.  Therefore the naming convention we used on previous
versions of JAWS will not work!  For example, the "WPJ51.JMF" file for
WordPerfect 5.1 will not be recognized by autoload.  It must be renamed
to "WP.JMF".
 
    The Autoload feature will default to "ON" and will not be saved
or restored in a configuration file, it must be turned on or off by the user
from the keyboard or in a macro.  However, for you power users that
want total control over your software you can use the "/O" command line
parameter so JAWS will boot up with autoload "off".  You must turn it
on manually, by pressing the INSERT + A macro or by using the
"Autoload" choice in the Config Files menu.  Also, remember that if you
use the J_LOAD.EXE program to load your configuration files as we
have done in previous versions of JAWS it will turn autoload "off" and
leave it off.  You must turn it on manually, by pressing the INSERT +
A macro or using the autoload choice in the Config Files menu.
 
 
EXPANDABLE MACRO BUFFER and DICTIONARY BUFFER
 
    If you are adding to our macro files, or creating your own, and you
have run out of room, then you will be glad to know that now you can
expand (or contract) the macro buffer.  The default size is 4k, 4 kilo
bytes or four thousand characters.  It can be expanded up to 8k or down
to 2k.  To do so, use the "/B=X" command line parameter, where "X" is
the size of the macro buffer in K (1024 bytes).  The "B" stands for
Buffer.  For example, to expand the macro buffer to 8k add "/B=8" to the
command line following the command to launch JAWS.  Examples are
shown below.  It can be used along with the other command line
parameters, and the order in which they appear on the command line
is not important.
 
    To vary the sized of the dictionary buffer, use the "/D=x"
command line parameter to set the size of the dictionary buffer, where
"X" is the size of the dictionary buffer in k (1024 bytes).  The maximum
is 16.  Before, JAWS would default to 2k of memory for the dictionary. 
You can now disable the dictionary feature altogether by specifying
"/D=0".  When this is done, you will not be able to load a dictionary until
you remove JAWS from memory and specify a buffer large enough for
your dictionary files.  If you try to load a dictionary file that is too large
for the buffer, it will give you an error message.  Of course, the bigger
the buffer, the more memory JAWS will take up.  If you do not use
Dictionaries, then use "/D=0" which will not reserve any memory.
 
    Automatic dictionary on after loading:  Now, when you load a
dictionary file from Config Files/Load/Dictionary menu or by Autoload
or J_LOAD , it will automatically turn on the dictionary feature.  No
need to manually turn it on, as before.
 
 
NEW COMMAND LINE PARAMETERS
 
    Here are examples of the new command line parameters:  If you
have an Accent SA use the following:
 
    J_ACNTSA /B=8 /D=4
 
For the Audapter use:
 
    J_AUDAPT /B=6 /d=1
 
 
NUMBER LOCK ON
 
    The "NUMOFF.COM" file is no longer needed.  JAWS will
automatically turn off NUM LOCK when it is loaded.
 
FRAME MONITORING OR AUTO MACROS
 
    Frame Monitoring now uses the "/F=X" command line parameter,
where "X" is "1" through "19".  The lower the number, the faster the
screen is checked for changes.  The trade off being that the higher the
number, the quicker the application goes, but JAWS will be slower to
respond to screen changes.  Try different values, the default is "5".
 
 
HARDWARE CURSOR AND BIOS CURSOR
 
    By default, JAWS will track the hardware cursor instead of the
BIOS cursor.  Some problems are caused by dealing directly with the
video hardware, the hardware cursor.  If you are having difficulties with
cursor tracking, try using the /H switch, which turns on the BIOS
Cursor Tracking.  We know that BIOS starts with "B", but we already
used "B" for the macro buffer.
 
WATCHDOG
 
    A watchdog interrupt handler is now available for users who lose
keyboard control when running some Terminal Emulation packages
and/or memory resident software.  Specify "/W" on the command line to
turn this on.  This will help users with programs that "steal" the
Interrupt 9 (keyboard) vector away from JAWS.  Unfortunately this
technique is not fool-proof, it will work in some cases, some it will not.
 
UNLOADING JAWS FROM MEMORY
 
    There is a new utility called "J_UNLOAD.EXE".  When run, this
will unload JAWS from memory.  This will only work with JAWS 2.2
and will report an error if JAWS is not loaded in memory.  Naturally
you can put this command in a batch file.  To unload JAWS from the
keyboard just hold down the ALT and SHIFT keys then press F1.  Be
sure you are at the DOS prompt.
 
 
NEW MACRO FUNCTIONS
 
    There is a new macro function called Say Version.  When this
macro is executed, JAWS will speak the current version of JAWS
running, the registered owner and their serial number.  This macro is
assigned to INSERT + V, in the new JAWS.JMF file.  This will aid our
Technical Support staff in determining what version the customer is
running.
 
    There is also "Spell Word", similar to "Say Word 1" or "Say Word
2", but of course it spells the word the cursor is on.  This is handy for
spell-check macros that may want to "say" the word and spell it.
 
    Other new macros include the "Smart Screen" features.  For
details on all the macro functions please refer to the JAWS manual or
our new "Advance Macros" training tapes.  We highly recommend these
tapes for anyone wanting to tap into the unparalleled power of JAWS.
 
 
ERROR LEVELS
 
    JAWS now returns a DOS ERRORLEVEL value after it loads. 
This error level can be checked by a batch file.  A ERRORLEVEL of "0"
means that JAWS loaded without error.  An ERRORLEVEL of "1"
means that JAWS did not understand the syntax of the command line. 
An ERRORLEVEL of "2" means that JAWS was already loaded and that
you tried to load it up again.  An ERRORLEVEL of "3" means that there
is not enough memory for JAWS to load up into.  A ERRORLEVEL of
"4" means that JAWS could not create the JAWSMEM.IMG file in the
default directory.  This could be caused by insufficient disk space, a disk
error, or the disk is write protected.
 
 
SUMMARY OF COMMAND LINE PARAMETERS
 
/A  ANSI screen handler, use if double echo.
/B=XBuffer size for JAWS macros, X=1 through 8k.
/BASE=X  Base Port Address for Prose 4000 synthesizers.
/C  Color, forces JAWS to color mode instead of monochrome.
/COMX:baud, parity, data bits, stop bits
 For use with serial synthesizers, where,
 X = 1 - 4, specifies the COM port number.
 baud = 300 - 19200, must match synthesizers setting.
 parity = E, O, or N.
 data bits = 5, 6, 7, or 8.
 stop bits = 1 or 2.
 
/D=xDictionary buffer size, where x is equal to 0 through 8k.
/E  Extended keyboard, makes the extra cursor keys distinct from the
numeric pad cursor keys.
/F=XFrame monitoring timing ticks, where x is equal to 1 through 19.
/H  Hardware cursor, use instead of BIOS cursor.
/I=XInt10 time-out ticks, where x is equal to 1 through 255.  
/IRQ=X   Interrupt number on synthesizers, where x= 2 through 15. 
         (PROSE ONLY)
/L  Lock out Interrupt 8, the timer interrupt, for testing only.
/LPTX    Use LPT port x, where x is equal to 1 through 8.
/M  Monochrome screen, forces JAWS to use monochrome instead of
    color.
/N  Nesting allowed, Useful with some TSR programs.
/O  Off, defaults Autoload to Off at start up.
/Q  Quick Start up, preserves screen before JAWS is loaded.
/T  Toshiba keyboard, use when no numeric pad on keyboard.
/W  Watchdog check on, for applications that grab keyboard.
