PART 7:
INDEX
(Also contained in the disk file "71INDEX.MAN".)
 
 
 
 
 
 
SYSTEM OF PAGE NUMBERING
 
    The bottom of each page contains a footer that displays the
PART
number of the manual, the chapter number, the chapter name, and the
page number.  A typical page number would appear as "1-4.36".  The
"1"
indicates PART ONE of the manual.  The "4" indicates Chapter 4 in
PART ONE.  The "36" is the actual page number.  Pages are numbered
consecutively throughout the manual.
 
    In some cases an index entry will be followed by a reference
such
as "(File "34COMAND.MAN" p6)".  This reference indicates that the
desired information is only available in a supplemental disk file
of the
manual.  The information "34COMAND.MAN" is the file name where
the information can be found.  The "p6" indicates page six in the
file. 
These disk files are located in a subdirectory of the default JAWS
directory.  If you installed the JAWS program files in the
subdirectory
"c:\JAWS", then the disk files for the manual will be in the
subdirectory
"c:\JAWS\MANUAL".  If you installed JAWS in a different directory,
then the "MANUAL" directory will be a subdirectory of the directory
you
specified.  The disk files are ASCII text files and can be read
with any
word processing program or with a text editor.
 
 
 
 
 
101 keyboards  2-1.63
5-key (on speech pad)  2-1.45, 2-1.57
abbreviations, speaking  2-3.99
acronyms, speaking  2-3.99
activate a frame  2-5.139
activate JAWS Menu System  2-2.73
activation of JAWS Cursor  2-1.43
activation of PC Cursor  2-1.43
active cursor  2-1.43
adjusting basic synthesizer speech  1-3.19
alphabet keys  2-1.41
ALT, definition of term/usage  1-3.22, 2-1.51, 2-1.56
ALT, used with Say All  2-1.51
Americans with Disabilities Act  1-4.36
application software manuals  1-4.35
application software program  2-7.169
argument  2-8.211
ASCII characters  2-1.58
attributes on the screen  2-4.118
AUTOEXEC.BAT  3-2.234
autoload  2-7.193, 2-8.208
automatic macros  1-1.4, 2-6.148, 2-7.175
    clear  2-7.177
    delay factor  2-7.177
    set  2-7.177
background color  2-4.124
batch file  2-8.211
BAUD rate  (File "53SYNTH.MAN" p7)
Beep on Routing  2-1.54
bell, set Margin Bell  2-1.63
BIOS macros  2-7.190
BIOS writing to the screen  2-3.91, 2-6.160
bypassing JAWS keys  1-3.27, 2-1.59
cables  (File "53SYNTH.MAN" p5)
capital letters, speaking  2-3.97
case sensitive searches  2-4.117
case, speaking uppercase/capital letters  2-3.97
CHANGES.DOC update file  1-2.17
character filtering  2-3.98
college and university services to disabled students  1-4.36
color attribute selection, enhancement searches  2-4.123
color bar tracking  2-4.129, 2-6.147, 2-6.156
color searches  2-4.118
color, foreground and background  2-4.124
colors, list of screen attributes   2-4.119
column, definition of term/usage  2-1.53
columns and rows, screen dimensions  2-1.53
COM port selection  (File "34COMAND.MAN" p5)
command line parameter, definition of term/usage  2-1.64
command line parameters (switches)  (File "34COMAND.MAN"
         p4)
communication parameters  (File "53SYNTH.MAN" p7)
communication ports  (File "53SYNTH.MAN" p5)
compatibility
    computer  1-1.9
    DOS  1-1.9
    synthesizers  1-1.10, (File "53SYNTH.MAN" p4)
    video  1-1.9
computer compatibility  1-1.9
computer user groups  1-4.37
CONFIG.SYS  3-2.234, (File "53SYNTH.MAN" p5)
configuration file compatibility, JAWS version 2.3  2-3.83
configuration files  1-1.9, 2-2.79, 2-8.203
    autoload  2-8.208
    batch file loading  2-8.211
    default configurations  2-8.204, 2-8.209
    DOS shell  2-8.209
    file names  2-8.205, 2-8.210
    J_LOAD.EXE  2-8.211
    load  2-8.206
    menu  2-8.205
    path to files  2-8.206
    save  2-8.207
    signature name of programs  2-8.208
configuration manager  2-2.79, 2-8.205
conflicts between keys  1-1.5
continuous reading  1-1.8, 2-1.50
CONTROL + SHIFT  2-7.178
CONTROL + SHIFT + (UP ARROW OR ESCAPE)  2-7.180
CONTROL + SHIFT + ENTER  2-7.180
CONTROL + SPACE BAR  2-1.62
Control Key Mode  2-1.61
CONTROL, definition of term/usage  1-3.22, 2-1.51, 2-1.56
CONTROL, used with Say All  2-1.51
cursor differences
    JAWS Cursor, PC Cursor  1-1.2, 2-1.42
    review function  1-1.2
    use of JAWS Cursor  1-3.25, 2-1.43
cursor keypad  1-1.6
    cursor cross  1-1.6
cursor location  2-1.52
cursor routing  2-1.54
data bit  (File "53SYNTH.MAN" p7)
default configuration files  2-8.204
default enhancement search options  2-4.124
default JAWS screen reading keys  2-1.65
define a frame  2-5.135
delay factor, auto macros and frame monitoring  2-7.177
DELETE, delete character at PC Cursor   2-1.41
DELETE, Say Position of Active Cursor  2-1.53
demonstration JAWS program  3-2.233
device driver  (File "53SYNTH.MAN" p5)
dictionary manager  2-3.100
    adding pronunciation rules  2-3.101
    adding pronunciation rules for graphic characters 
         2-3.103
    bytes available  2-3.105
    changing pronunciation rules  2-3.104
    deleting pronunciation rules  2-3.105
    exceptions  2-3.100
    pronunciation rules  2-3.100
different, search for a different attribute  2-4.122
dimensions of screen  2-1.53
direct writing to the screen  2-3.91, 2-6.161
direction of search  2-4.116, 2-4.125
documentation conventions  3-1.213
DOS  1-4.32
DOS compatibility  1-1.9
DOS shell  2-8.209
DOWN ARROW  2-1.46, 2-2.76
drivers, software  3-2.234, (File "53SYNTH.MAN" p5)
duplicate a macro  2-7.173
echo, definition of term and types of echo  2-3.85, 2-3.89, 2-3.92,
         2-6.160
editing a macro definition  2-7.179
employment opportunity  1-4.36
END  2-1.47
enhancement searches  2-2.80, 2-4.118
    default search options  2-4.124
    different attribute  2-4.122
    direction  2-4.125
    enhance menu  2-4.121
    examples  2-4.126
    find  2-4.122
    foreground and background  2-4.125
    frame number  2-4.124
    repeat  2-4.122, 2-4.127
    selecting color attributes  2-4.123
    selecting monochrome enhancements  2-4.123
    strategies  2-4.120
    testing for attributes  2-4.128
ENTER, definition of term/usage  2-2.76
environment configuration file combatibility  2-3.83
equal educational opportunity  1-4.36
erase a macro  2-7.174
ESCAPE  2-2.78
exception,dictionary editor  2-3.100
execute  2-7.166
exit Macro Editor  2-7.179
expanded memory  1-1.9
extended ASCII characters  2-1.58
extended keyboards  2-1.63
external speech synthesizer  (File "53SYNTH.MAN" p5)
extra voice menu  2-3.106, (File "53SYNTH.MAN" p8)
F1 through F8  2-1.52
fast-forward/rewind, used with Say All  2-1.52, (File
         "34COMAND.MAN" p15)
female ports and cables  (File "53SYNTH.MAN" p6)
field, definition of term/usage  2-1.60
filter multiple characters  2-3.98
find, used with enhancement searches  2-4.122
finding screen colors and monochrome enhancements  2-4.118
finding screen locations/text/colors, general  2-4.107
finding strings of text  2-4.112
flags  2-6.162
foreground color  2-4.124
FormMate  (File "53SYNTH.MAN" p36)
frame  2-5.133
    activate  2-5.139
    delay factor  2-7.177
    frame zero  2-5.134
    leters for frame numbers  2-5.139
    menu  2-5.135
    monitoring  2-5.141, 2-7.175
    numbering strategy  2-5.137
    numbering system  2-5.134
    numbers, priority system  2-5.144
    quieting  2-5.140, 2-5.142
    referenced frame number  2-5.136
    revise, define a frame  2-5.135
    speak  2-5.138
frame manager  2-2.79, 2-5.135
function window, Macro Editor  2-7.180
gender changer  (File "53SYNTH.MAN" p7)
global voice menu  2-3.86
    pitch  2-3.87
    rate  2-3.87
    standby or sleep mode  2-3.89
    tone or voices  2-3.88
    volume  2-3.87
glossary  3-1.216
goto, in JAWS main menu  2-2.81, 2-4.107
    absolute position  2-4.108
    relative  2-4.108
graphic characters  1-1.10
graphic display mode  1-1.11, 2-2.74
help line, in JAWS Menu System  2-2.75
Help Mode  1-3.23, 2-1.44, 2-1.59
highlighted selection in JAWS Menu System  2-2.75, 2-3.85
HOME  2-1.47
Home Row mode  2-1.41, 2-7.167
hot key  2-2.74
identify a macro  2-7.174
identify characters by their phonetic and graphic names  2-1.57
identify screen colors and monochrome enhancements  2-4.120
identify window, macro editor  2-7.183
if then else  2-7.176, 2-7.186
indexing synthesizers  2-1.51
indexing, definition of term  2-1.51
INSERT + 1 (on numbers row)  2-1.59
INSERT + 3 (on numbers row)  2-1.59
INSERT + 5 (on numbers row)  2-1.60, 2-4.120
INSERT + 5 (on speech pad, pressing it twice)  2-1.45
INSERT + 5 (on speech pad)  2-1.45, 2-1.58, 2-2.77
INSERT + 6 (on numbers row)  2-1.60, 2-4.121
INSERT + 7 (on numbers row)  2-1.61
INSERT + A  2-7.193
INSERT + C  2-6.157
INSERT + D  2-6.160
INSERT + DELETE  2-1.54
INSERT + E  2-6.155
INSERT + END  2-1.48
INSERT + HOME  2-1.47
INSERT + LEFT ARROW  2-1.45, 2-2.76
INSERT + PAGE DOWN  2-1.48, 2-2.76
INSERT + PAGE UP  2-1.47
INSERT + R  2-6.150
INSERT + RIGHT ARROW  2-1.45, 2-2.76
INSERT + S  2-6.150
INSERT + UP ARROW  2-1.46, 2-2.76
INSERT, definition of term/usage  2-1.42
installation  1-2.13
    command line parameters (switches)  (File
         "34COMAND.MAN" p4)
    external (serial) synthesizers  (File "52EXTERN.MAN"
         p2)
    general information about synthesizers  (File
         "53SYNTH.MAN" p4)
    internal synthesizers  (File "51INTERN.MAN" p2)
    JAWS will not speak  3-2.235
    network systems  (File "34COMAND.MAN" p14)
    quick description  1-2.13
internal speech synthesizers  3-2.234, (File "51INTERN.MAN"
         p2), (File "53SYNTH.MAN" p5)
interrupt 9 scan code table  (File "34COMAND.MAN" p25)
interruptability
    keyboard  2-3.90
    speech pad  2-3.93
invoke JAWS Menu System  2-2.73
J_CVT23.EXE  2-3.83
J_LOAD.EXE command  2-7.193, 2-8.211
JAWS Cursor usage  1-3.25, 2-1.43
JAWS Cursor voice menu  2-3.93
JAWS demonstration program  3-2.233
JAWS learning tapes  1-4.35
JAWS manual on disk  1-2.17
JAWS Menu System  1-1.6, 2-2.73
    activate  2-2.73
    description of structure and use  2-2.74
    exiting  2-2.78
    main menu  2-2.78
    making selections  2-2.75
    screen display size  2-2.74, 2-5.143
    sub menus  2-2.75
    wrap on the selection line  2-2.76
JAWS software license agreement  1-2.14
JAWS users group  1-4.37
JAWS utilities  2-2.73
JAWS version 1 and 2.0, history  (File "01JAWS20.MAN" p1)
JAWS version 2.2, history  (File "62JAWS22.MAN" p1)
JAWS version 2.3, history  (File "63JAWS23.MAN" p1)
JAWS, newest information  1-2.17
joining cursors  2-1.54
key pass through to application  1-3.27, 2-1.59
key repeat  2-3.91
keyboard conflicts  1-1.5
keyboard echo  2-1.64, 2-3.85, 2-3.89
keyboard voice menu  2-3.89
    interruptable  2-3.90
    key repeat  2-3.91
    volume, rate, pitch, tone  2-3.90
keyboards without numeric keypads  2-1.42
keyboards, alternative designs  3-2.229, (File "53SYNTH.MAN"
         p35)
keyboards, extended/101 keys  2-1.63
keys of the speech pad  2-1.40
large screen size, rows/columns  2-5.143
learning tapes for JAWS  1-4.35
learning to use a PC  1-4.29
LEFT ARROW  2-1.44, 2-2.76
level adjustment, definition of term  2-2.73
license agreement  1-2.14
line pauses  2-3.97
list of macros  2-7.183
load configuration files  2-8.206
loading JAWS  3-2.235
location of cursor  2-1.52
lost text on the screen display  2-1.55
loudness adjustment of synthesizers  1-3.20, 2-3.87
LPT port selection  (File "34COMAND.MAN" p6)
LPT ports.  (File "53SYNTH.MAN" p6)
macro
    application software macros  2-7.169
    auto  1-1.4, 2-7.175
    BIOS macros  2-7.190
    concept and uses  1-1.4, 2-6.148, 2-7.166, 2-7.169
    delay factor  2-7.177
    duplicate  2-7.173
    erase  2-7.174
    fixing macros that don't work properly  2-7.193
    functions  2-7.195, (File "33MACRO2.MAN" p6)
    identify  2-7.174
    macro definition  2-7.167, 2-7.172
    macro key  2-7.167, 2-7.171
    macro manager  2-2.79, 2-7.169
    revise  2-7.171
    soft keys  1-1.5
    utility programs  2-7.170
Macro Editor  1-1.4, 2-7.171, 2-7.177
    abort macro editing/recording  2-7.180
    cursor movement  2-7.178, 2-7.180
    display  2-7.172
    editing a definition  2-7.179, 2-7.180
    exit  2-7.179
    function window  2-7.173, 2-7.180
    identification window  2-7.173, 2-7.183
    if then else  2-7.176, 2-7.186
    list of macros  2-7.183
    revise window  2-7.173, 2-7.178
    save a macro  2-7.180
    searches  2-7.176
    strategies for creating macros  2-7.192
macro examples
    Say Current Line  2-7.184
    Say Position of Cursor  2-7.186
    strategies for creating new macros  2-7.192
    toothbrush macro  2-7.166
    voice level adjustment  2-7.187
    WordPerfect spell check macro  2-7.188
macro functions
    detailed explanation  (File "33MACRO2.MAN" p6)
    summary  2-7.195
macro menu  2-7.171
macros that don't work  2-7.193
    cannot find color  2-7.194
    cannot find graphic character  2-7.194
main menu, JAWS  2-2.78
male ports and cables  (File "53SYNTH.MAN" p6)
manual for JAWS on disk  1-2.17
Margin Bell  2-1.63
margins of application programs  2-1.55
marking screen locations  2-4.111
menu bars  2-4.129
menu system, activation of  2-2.73
menu system, JAWS  1-1.6, 2-2.73
minus sign  2-4.110
missing text on the screen display  2-1.55
modes of cursor movement  2-1.61
monitoring a frame  2-5.141, 2-7.175
monochrome enhancement searches  2-4.118
monochrome screen enhancements, list  2-4.119
moving the cursor, different modes  2-1.61
multiple character filter  2-3.98
name of configuration files  2-8.210
names of JAWS manual disk files  1-2.18
network computer systems  (File "34COMAND.MAN" p14)
newest JAWS information  1-2.17
number lock key (num lock)  2-1.39
Number Lock mode  2-7.167
number lock, default setting  2-1.40
number row keys  2-1.59
numbering of frames, strategies  2-5.137
numbering system for frames  2-5.134
numbers of frames, system of priorities  2-5.144
numbers, speaking  2-3.94
numeric keypad  1-1.3, 2-1.39
numeric keypad, use of original key functions  2-1.41
options prompt  2-4.114, 2-4.123
    case sensitivity  2-4.117
    default  2-4.115, 2-4.124
    direction  2-4.116, 2-4.125
    examples  2-4.116, 2-4.126
    foreground and background  2-4.125
    frame number  2-4.115, 2-4.124
    testing for screen attributes  2-4.128
    verify cursor on first letter of word  2-4.117
PAGE DOWN  2-1.47
PAGE UP  2-1.47, 2-2.78
paragraph, definition for JAWS  2-1.49, 3-1.223
parallel ports  (File "53SYNTH.MAN" p5)
parameters, command line parameters (switches)  (File
         "34COMAND.MAN" p4)
parity  (File "53SYNTH.MAN" p7)
pass through a key to the application program  1-3.27, 2-1.59
path command  2-8.206
phonetic equivalents spoken for letters  3-1.215
phonetic pronunciation mode  2-1.57
pitch of synthesizer  2-3.87
place markers  2-2.81, 2-4.111
plus sign  2-4.110
pop up window  2-4.118, 2-5.133, 2-6.147
port selection  (File "34COMAND.MAN" p5), (File
         "53SYNTH.MAN" p5)
position of active cursor  2-1.53
position of inactive cursor  2-1.54
printer ports  (File "53SYNTH.MAN" p6)
priority of frame numbers  2-5.137, 2-5.144
prompt, in JAWS Menu System  2-2.75
pronunciation rules  2-3.100
pull down menu  2-4.118, 2-5.133, 2-6.147
punctuation symbols, speaking  2-3.95
quieting a frame  2-5.140, 2-5.142
rate of speech  1-3.19, 2-3.87
read contents of a frame  2-5.138
Read Line X  2-1.48, 2-1.62
reading a JAWS macro definition  2-7.178
reading continuously  1-1.8, 2-1.50
reference materials on tape and computer disk  1-4.35
referenced frame number  2-5.136
registration process for JAWS  1-2.16, 3-2.233
relative goto  2-4.108
repeat, enhancement search  2-4.122, 2-4.127
revise, frame definition   2-5.135
revise, macro definition  2-7.171, 2-7.178
rewind/fast-forward, used with Say All  2-1.52, (File
         "34COMAND.MAN" p15)
RIGHT ARROW key  2-1.44, 2-2.76
route JAWS Cursor to PC Cursor  2-1.54, 2-4.108
route PC Cursor to JAWS Cursor  2-1.54, 2-4.108
row, definition of term/usage  2-1.53
rows and columns, screen dimensions  2-1.53
save a macro  2-7.180
save configuration files  2-8.207
Say All function  1-1.8, 2-1.50
    ALT key  2-1.51
    changing speech characteristics  2-1.52
    CONTROL key  2-1.51
    rewind/fast-forward  2-1.52, (File "34COMAND.MAN"
         p15)
Say Bottom Line  2-1.48
Say Character  2-1.45, 2-2.77
Say Character (pressing it twice)  2-1.45, 2-1.57
Say Current Line  2-1.46
Say Current Sentence  2-1.49
Say Field  2-1.60
Say Field mode  2-1.60, 2-4.121
Say From Cursor  2-1.46
say help line of JAWS Menu System  2-2.76
Say Next Character  2-1.44, 2-2.76
Say Next Field  2-1.60, 2-4.121
Say Next Line  2-2.76
Say Next Paragraph  2-1.50
Say Next Sentence  2-1.49
Say Next Word  2-1.45, 2-2.76
Say Paragraph   2-1.49
Say Phonetic Name of characters  2-1.57, 3-1.215
Say Prior Character  2-1.44, 2-2.76
Say Prior Field  2-1.60, 2-4.121
Say Prior Line  2-1.45, 2-2.77
Say Prior Paragraph  2-1.49
Say Prior Sentence  2-1.49
Say Prior Word  2-1.45, 2-2.76
Say Screen Enhancement  2-1.60
say selection line of JAWS Menu System  2-2.76
say specific line  2-1.62
Say Top Line  2-1.48
Say Up to Cursor  2-1.46
Say Word  2-1.45, 2-2.76
Say Word (pressing it twice)  2-1.45, 2-1.58
scan code table  (File "34COMAND.MAN" p25)
screen attribute, definition of term  2-4.118
screen colors, list  2-4.119
screen echo  2-3.85, 2-3.92, 2-6.160
screen enhancements, identify color/monochrome enhancements 
         2-1.60, 2-4.120
screen reading keys, default  2-1.65
screen reading strategies  2-6.148
screen size  2-1.53, 2-5.143
screen voice menu  2-3.91
    echo  2-3.92
    volume, rate, pitch, tone  2-3.92
search
    application software programs  2-4.113
    enhancements  2-2.80, 2-4.118
    text strings  2-2.80, 2-4.112
searches, overview  1-1.7, 2-2.73, 2-2.80
selection character  2-2.77, 2-6.159
selection line, in JAWS Menu System  2-2.75
sentence, definition of term for JAWS  2-1.48, 3-1.224
serial ports  (File "53SYNTH.MAN" p5)
serial synthesizer  (File "52EXTERN.MAN" p2)
services for disabled students  1-4.36
set an automatic macro  2-7.177
SHIFT + 5-key (on speech pad)  2-1.49
SHIFT + CONTROL  2-7.178
SHIFT + CONTROL + (UP ARROW OR ESCAPE)  2-7.180
SHIFT + CONTROL + ENTER  2-7.180
SHIFT + LEFT ARROW  2-1.49
SHIFT + PAGE DOWN  2-1.50
SHIFT + PAGE UP  2-1.50
SHIFT + RIGHT ARROW  2-1.49
signature name of application programs  2-8.208
silence speech key, changing the key  (File "34COMAND.MAN"
         p12)
silencing a frame  2-5.140, 2-5.142
silencing speech output  1-3.21
Singles mode  2-1.61
size of screen  2-1.53, 2-5.143
sleep mode  2-3.89
smart options  2-6.157
    attribute  2-6.159
    combine  2-6.158
    data only  2-6.159
    left/right  2-6.157
    screen echo  2-6.160
    single character changes  2-6.158
    up/down  2-6.158
Smart Screen  2-6.147
    color bar  2-6.156
    manager, menu  2-6.149
    smart focus  2-6.151
    smart level  2-6.154
    smart speak  2-6.150, 2-6.162
    summary of macro keys  2-6.162
    toggle on/off  2-6.150
soft keys  1-1.5
software application program  2-7.169
software drivers  3-2.234, (File "53SYNTH.MAN" p5)
software flags  2-6.162
software manuals  1-4.35
source of speech  2-3.84
speak contents of a frame  2-5.138
speak phonetic or graphic name of characters  2-1.57
speaking extended ASCII characters  2-1.58
speech output
    general  2-3.84
    keyboard  2-3.89
    screen  2-3.91
    stopping  1-3.21
speech pad  1-1.3, 1-3.23, 2-1.39
speech pad echo  2-3.85
speech pad keys  2-1.40
speech pad voice menu  2-3.92
    interruptable  2-3.93
    volume, rate, pitch, tone  2-3.92
speech rate  1-3.19, 2-3.87
speech synthesizer adjustment  2-3.83, (File "53SYNTH.MAN"
         p4)
    initial adjustment  1-3.19
    pitch  2-3.87
    rate  1-3.19, 2-3.87
    tone  2-3.88
    voices of the DECtalk  2-3.88
    volume  1-3.20, 2-3.87
speech synthesizers
    compatibility  1-1.10, (File "53SYNTH.MAN" p4)
    external/serial  (File "52EXTERN.MAN" p2)
    indexing type  2-1.51
    internal  (File "51INTERN.MAN" p2)
    network systems  (File "34COMAND.MAN" p14)
    synthesizer will not speak  3-2.235
Spell Word  2-1.45, 2-1.58
standard text mode  1-1.11
standby mode  2-3.89
starting JAWS  1-2.15, 3-2.235
status line  2-1.48, 2-5.133, 2-5.134
stop bit  (File "53SYNTH.MAN" p7)
stopping speech output  1-3.21
strategies for developing macros  2-7.192
strategies for learning to use a PC  1-4.29
strategies for screen access  2-6.148
strategies for working with screen attributes  2-4.120, 2-6.147
string search  2-2.80
    case sensitivity  2-4.117
    direction  2-4.116
    entering the text string  2-4.113
    examples  2-4.116
    frame number  2-4.115
    verify cursor on first letter of word  2-4.117
strings of identical characters  2-3.98
sub menus  2-2.75
summary of default JAWS screen reading keys  2-1.65
summary of macro functions  2-7.195, (File "33MACRO2.MAN"
         p6)
suspending a JAWS key  1-3.27
switches (command line parameters)  2-1.64, (File
         "34COMAND.MAN" p4)
symbols, speking  2-3.95
synth1 and synth2 parameters   (File "53SYNTH.MAN" p8)
synthesizer cables  (File "53SYNTH.MAN" p5)
synthesizers  (File "53SYNTH.MAN" p4)
table of phonetic names for letters  2-1.58
testing for screen attributes  2-4.128
text searches  2-2.80, 2-4.112
title line, in JAWS Menu System  2-2.75
toggle  2-1.39, 2-3.86
tone of synthesizer  2-3.88
tracking color bars  2-4.129
typewriter keys  2-1.41
universal voice menu  2-3.94
    acronyms  2-3.99
    case (capital letters)  2-3.97
    dictionary  2-3.100
    filter  2-3.98
    line pauses  2-3.97
    numbers  2-3.94
    symbols  2-3.95
UP ARROW  2-1.45, 2-2.77
updating a JAWS version  3-2.231
uppercase letters  2-3.97
utilities, JAWS  2-2.73
variable, definition of term/usage  2-1.62
verify cursor's location on first letter of word  2-4.117
video compatibility  1-1.9, 2-2.74
voice configuration file compatibility  2-3.83
voice menu  2-2.78, 2-3.83
    extra  2-3.106, (File "53SYNTH.MAN" p8)
    general description  2-3.84
    global  2-3.86
    JAWS Cursor  2-3.93
    keyboard  2-3.89
    making selections  2-3.85
    screen  2-3.91
    speech pad  2-3.92
    universal  2-3.94
voices of DECtalk  2-3.88, 2-3.94
volume  2-3.87
window  2-5.133
WordPerfect  (File "41WP.MAN" p3)
writing to the screen  2-3.91
X, used in the JAWS Menu System  2-2.77
Z, used in JAWS Menu System  2-2.78
