' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
' DUNGEON DESIGNER 5.0 MAIN MENU         Revision 2: 15 MAR 2012 
'                                            Update: 20 NOV 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
ON ERROR GOTO ErHndlr

TYPE DESC
   TEXT AS STRING * 255
END TYPE
DIM DS AS DESC

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10), BORT
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE
d1 = ABS(d1 > 0): d2 = ABS(d2 > 0): d1$ = "(Empty)": d2$ = "(Empty)"
IF d1 = 1 THEN
  OPEN "..\DGN-1\NAME.DAT" FOR INPUT AS #1: INPUT #1, a, a, a, a, d1$: CLOSE
END IF
IF d2 = 1 THEN
  OPEN "..\DGN-2\NAME.DAT" FOR INPUT AS #1: INPUT #1, a, a, a, a, d2$: CLOSE
END IF

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27)
mc1 = 1: mc2 = 2: mc3 = 7

'                  Designer 5.0 Main Menu
'                 ------------------------
Menu:
SCREEN 0: WIDTH 80: CLS : COLOR mc1, 0: PRINT " "; STRING$(65, ""); ""
PRINT " "; SPACE$(15); : COLOR mc2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR mc1: PRINT SPACE$(14); "": PRINT " "; SPACE$(20); : COLOR mc2
PRINT " Adventure Design Menu 5.0"; : COLOR mc1: PRINT SPACE$(19); "": PRINT " ";
PRINT STRING$(65, ""); "": PRINT : COLOR 8 / (d1 + 1): PRINT "  Design #1: ";
PRINT d1$: COLOR 8 / (d2 + 1): PRINT "  Design #2: "; d2$: PRINT

c = 0: c1 = 15: a$ = INKEY$: COLOR 7
CALL EDXMenuM(c, c1, 1, 9, mc3, 0)
IF c1 = 3 THEN c = 10
IF BORT = 5 THEN BORT = 1: GOTO Menu
IF c = 1 THEN GOTO Init
IF c = 2 THEN RUN "NAMECHNG"
IF c = 3 THEN
  IF s%(4) <> 1 OR BORT = 1 THEN RUN "EDIT"
  CLS : LOCATE 8: COLOR 7
  PRINT "The Eamon Deluxe 5.0 Adventure Editor is not yet compatible with VI Mode. A new"
  PRINT "version of the editor is currently in development and will released as soon as"
  PRINT "possible. Please visit www.eamonag.org/pages/eamondx.htm for the latest updates."
  LOCATE 22: COLOR 2: GOSUB GetKey0: GOTO Menu
END IF
IF c = 4 THEN RUN "ADVTEST"
IF c = 5 THEN RUN "HINTEDIT"
IF c = 6 THEN RUN "LIST"
IF c = 7 THEN RUN "DGNMAP"
IF c = 8 THEN GOTO DsRemove
IF c = 9 THEN RUN "HANG_PSN"
OPEN "DGNDIR.DAT" FOR OUTPUT AS #1: PRINT #1, d1, d2: CLOSE
CHDIR "..": RUN "EAMONDX"

'              Start a new dungeon
'             ---------------------
Init:
IF d1 = 1 AND d2 = 1 THEN
  CLS : LOCATE 5: COLOR 2
  PRINT "Your design slots are full. You must remove a design first."
  COLOR 3: PRINT : GOSUB GetKey0: GOTO Menu
END IF
CLS : LINE INPUT "Name of adventure:"; a$: advname$ = LTRIM$(RTRIM$(a$))
PRINT : PRINT CHR$(34); advname$; CHR$(34): PRINT
PRINT "Is this correct? (Y/N): "; : GOSUB GetKey: IF k$ <> "Y" THEN GOTO Init
Init1:
CLS : PRINT "   Number of directions?": PRINT : PRINT " 1.  6 (N/S/E/W/U/D)"
PRINT " 2. 10 (N/S/E/W/U/D/NE/NW/SE/SW)": PRINT "Enter 1-2: "; : GOSUB GetKey
a = INT(VAL(k$)): IF a < 1 OR a > 2 THEN GOTO Init1
nd = 6 + 4 * ABS(a = 2)
IF d1 = 0 THEN d1 = 1: av$ = "..\DGN-1\": GOTO Init2
d2 = 1: av$ = "..\DGN-2\"

'               Init database files
'              ---------------------
Init2:
CLS : COLOR 15: PRINT "Initializing Eamon Deluxe 5.0 New Adventure Data files.........";
OPEN av$ + "NAME.DAT" FOR OUTPUT AS #1
    WRITE #1, 0, 0, 0, 0, advname$, nd, 5, 1
CLOSE #1
OPEN av$ + "ROOMS.DAT" FOR RANDOM AS #1 LEN = 101
OPEN av$ + "ROOMS.DSC" FOR RANDOM AS #2 LEN = 255
OPEN av$ + "ARTIFACT.DAT" FOR RANDOM AS #3 LEN = 51
OPEN av$ + "ARTIFACT.DSC" FOR RANDOM AS #4 LEN = 255: CLOSE
OPEN av$ + "MONSTERS.DAT" FOR RANDOM AS #1 LEN = 61
OPEN av$ + "MONSTERS.DSC" FOR RANDOM AS #2 LEN = 255
OPEN av$ + "EFFECT.DSC" FOR RANDOM AS #3 LEN = 255: CLOSE
'               Init saved games dir
'              ----------------------
OPEN av$ + "GAMEDIR.DAT" FOR OUTPUT AS #1
     PRINT #1, -1: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
CLOSE
'               Init hint files
'              -----------------
OPEN av$ + "HINTDIR.DAT" FOR OUTPUT AS #1
    a = 1: b = 8: a$ = "EAMON DELUXE 5.0 GENERAL HELP.": q$ = CHR$(34)
    PRINT #1, a: PRINT #1, a$: PRINT #1, a, b
CLOSE
OPEN av$ + "HINTS.DSC" FOR RANDOM AS #1 LEN = 255
    OPEN "NEWHINTS.DSC" FOR RANDOM AS #2 LEN = 255
    FOR x = 1 TO b: GET #2, x, DS: PUT #1, x, DS: NEXT
CLOSE
OPEN "DGNDIR.DAT" FOR OUTPUT AS #1: PRINT #1, d1, d2: CLOSE
PRINT "DONE!": LOCATE 8
'               Copy base program files
'              -------------------------
PRINT "Copying base Adventure Program files.....": COLOR 7: LOCATE 3
OPEN "DGNFILES\INTRO.BAS" FOR INPUT AS #1
OPEN av$ + "INTRO.BAS" FOR OUTPUT AS #2
DO
  LINE INPUT #1, a$
  PRINT #2, a$
LOOP UNTIL EOF(1)
CLOSE : OPEN "DGNFILES\MAINPGM.BAS" FOR INPUT AS #1
OPEN av$ + "MAINPGM.BAS" FOR OUTPUT AS #2
DO
  LINE INPUT #1, a$
  PRINT #2, a$
LOOP UNTIL EOF(1)
CLOSE
'SHELL "copy DGNFILES\*.* " + av$ + "*.*"
COLOR 15: LOCATE 8, 41: PRINT "DONE!": LOCATE 15: COLOR 7
PRINT "Hit any key to continue..."; : GOSUB GetKey: CLS : COLOR 2
PRINT "A quick review of the Eamon Deluxe Adventure programs...": PRINT
COLOR 7: a$ = SPACE$(15): PRINT a$; "  INTRO.BAS --- Adventure Intro program."
PRINT a$; "MAINPGM.BAS --- The base adventure program (your adventure)"
'PRINT a$; "INSTALL.EXE --- Install your adventure to the Eamon Deluxe"
'PRINT : COLOR 2
'PRINT "(INSTALL.EXE can be used in any directory containing an Eamon Deluxe Adventure."
'PRINT "to add that adventure to the EAMONDX directory and Installed Adventures list."
'PRINT "Once the adventure has been installed successfully it may then be safely"
'PRINT "removed from the design slot.)"
COLOR 7: PRINT : PRINT : GOSUB GetKey0: RUN

'           Murder a design in cold blood
'           -----------------------------
DsRemove:
CLS : COLOR 7: PRINT "Remove which design?": PRINT
PRINT "1: "; d1$: PRINT "2: "; d2$
PRINT "Enter 1-2: "; : GOSUB GetKey: x = INT(VAL(k$))
IF x < 1 OR x > 2 THEN GOTO Menu
IF (x = 1 AND d1 = 0) OR (x = 2 AND d2 = 0) THEN
  PRINT "No dungeon to remove.": GOSUB GetKey0: RUN
END IF
CLS : COLOR 14: PRINT "  !!!!! WARNING !!!!!": PRINT : COLOR 2
PRINT "This will destroy any data in this design slot.": PRINT
PRINT "Remove "; : IF x = 1 THEN PRINT d1$; :  ELSE PRINT d2$;
PRINT "?": PRINT : COLOR 7
PRINT "Are you sure? (Y/N):"; : GOSUB GetKey: IF k$ <> "Y" THEN GOTO Menu
a$ = "DGN-" + LTRIM$(RTRIM$(STR$(x)))
' Kill data files (you can actually hear them scream!)
CHDIR "..": CHDIR a$: KILL "*.*": CHDIR "..": CHDIR "DD"
IF x = 1 THEN d1 = 0 ELSE d2 = 0
OPEN "DGNDIR.DAT" FOR OUTPUT AS #1: PRINT #1, d1, d2: CLOSE
COLOR 2: PRINT : PRINT "Dungeon removed!": COLOR 7: PRINT
PRINT : GOSUB GetKey0: RUN

' Get a single keypress, returns with UCASE
GetKey0:
PRINT "Hit any key to continue...";
GetKey:
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = UCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: RETURN
END IF
' Standard rtn
BS = POS(0): CC = 0
DO
    CC = CC + 1
   IF CC = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC = 0
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""
PRINT k$: RETURN

'Ŀ
'                    Error handling routine                     
'
ErHndlr:
CLS : BEEP: PRINT "Run-time error"; ERR; "   ";
IF ERR = 68 THEN PRINT "(Printer unavailable)";
IF ERR = 62 THEN PRINT "(Input past end of file)";
IF ERR = 53 THEN PRINT "(File not found)";
PRINT : PRINT : PRINT "Program terminated.": RESUME ErHndlr1
ErHndlr1:
ON ERROR GOTO 0: a$ = INKEY$: PRINT : PRINT "(Hit any key)"
DO
LOOP UNTIL INKEY$ <> ""
SYSTEM

EDXMenuStrings:
DATA 10
DATA "  Start a New Adventure  "
DATA "  Rename an Adventure    "
DATA "  Edit an Adventure      "
DATA "  Test an Adventure      "
DATA "  Edit Hint Files        "
DATA "  List an Adventure      "
DATA "  Map Room Connections   "
DATA "  Remove a Design        "
DATA "  Play Hang Person       "
DATA "  Return to Main Menu    "

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
'// Compact Eamon Deluxe Selection Menu 5.0           Revision 2: 20 JUN 2012
'     User locatable, two colors, single choice row with no error checking
'
'  Passed to SUB:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'  Modified by SUB:
'   ad/v/x/k/k$ - used as generic
'  Returned by SUB:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'  Required SHARED:
'   em0 - The maximum dimension of the em$() array
'em$(x) - em$(0) holds exit keys, em$(1-x) hold user defined choices
' s%(4) - If set to =1 then use numeric menu, use else standard menu

' VI Mode ------
EDXMenuMMXII:
IF s%(4) = 1 THEN
  FOR c = be TO en
     k = k * ABS(c > 1): k$ = SPACE$(ABS((c < 100) + (c < 10)))
     k$ = k$ + LTRIM$(STR$(c - be + 1)) + ": " + LTRIM$(RTRIM$(em$(c)))
     PRINT k$: k = k + 1
     IF k >= 22 AND c < en THEN
       PRINT : PRINT "Hit any key to continue...": k$ = INKEY$
          DO
            k$ = INKEY$
          LOOP UNTIL k$ <> ""
       CLS : k = 0
     END IF
  NEXT
  PRINT : PRINT "Enter choice number (0 to exit):"; : LINE INPUT ""; k$:                                 k$ = k$ + " "
  c = INT(VAL(k$)): k = ASC(k$): GOSUB EDXMenuMB
  c1 = c + (be - 1): IF c = 0 AND INSTR(k$, "0") > 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMMXII
  en = c1: c1 = 1: EXIT SUB
END IF

' EDXMenuM ------
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, 0
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT
EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1: LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, 0: PRINT em$(c);
IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF
GOSUB EDXMenuMB: IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
'
' Make sure input is a valid ANSI code, else recode in ASCII (=SPOT)
EDXMenuMB:
IF k = 98 AND BORT = 0 THEN BORT = 2: SOUND 250, .5:
IF k = 111 AND BORT = 2 THEN BORT = 3: SOUND 350, .5:
IF k = 114 AND BORT = 3 THEN BORT = 4: SOUND 450, .5:
IF k <> 116 OR BORT <> 4 THEN RETURN:  ELSE BORT = 5: SOUND 550, .5:                                         EXIT SUB                                                                                                      'B O R T = S P O T
END SUB

