' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'            BEGINNERS ADVENTURES MULTI-INTRO PROGRAM            
'                                                                
' By Frank Black                           Revision: 26 MAR 2012 
'                                            Update: 19 JUL 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB SkullRV (sk1, sk2, sk3, sk4, sk5, sk6)
DECLARE SUB HRT ()

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: AE AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM Z AS RECORD

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), dly#, CC1#, CC2#, CC3#, s%(10), adv, adv1, adv2
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, Z: CLOSE
name$ = LTRIM$(RTRIM$(Z.CNAME$)): sex = Z.sex: q$ = CHR$(34)
adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT

'
' See if graphic mode is available
'
ON ERROR GOTO ScreenError: IF s%(4) <> 1 THEN SCREEN 7
CaveTest:
ON ERROR GOTO 0: SCREEN 0: WIDTH 80

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
DIM SHARED ANAME$, dungeons

OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF

'    Initialize drawing coordinate strings for HRT sub  (Hi-Res Text)
DIM SHARED ab$(255), a$, col, row, TextSize, TextColor1, TextColor2
RESTORE HRTstrings: FOR a = 33 TO 90: READ ab$(a): NEXT

L$ = STRING$(80, 196)
CLOSE : OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Converted to Eamon Deluxe by Frank Black"
Adventure1$ = "Beginners Adventures"
author$ = author1$: adventure$ = Adventure1$

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file. File is being restored and you are"
  PRINT "being returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5: PRINT #1, "(none)": NEXT: CLOSE
  GOSUB Title: COLOR 2: LOCATE 6
  a$ = "This is Official Eamon Deluxe Adventure #1": GOSUB Center
  LOCATE 20: COLOR 3: PRINT : PRINT : GOSUB KeyWait: GOSUB Intro: GOTO Menu
END IF

IF a = -2 THEN GOTO Menu
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Cave, AltCave, Forest, CaveII, EnhancedCave, TGround, Demo
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Header: LOCATE 8: COLOR 2
PRINT "  This adventure collection contains all of the Classic Eamon adventures"
PRINT "  which were written for beginning level characters to earn experience and"
PRINT "  wealth the 'honest' way, without cheating or using a character editor."
COLOR 3: LOCATE 22: GOSUB KeyWait
GOSUB Header: LOCATE 7: COLOR 2
PRINT "  Most of these adventures were very strict about enforcing the Beginners"
PRINT "  Only rule in their Classic format and would (literally) kick out any"
PRINT "  character that wasn't a fresh creation from the Main Hall."
PRINT
PRINT "  The Eamon Deluxe conversions, however, put no such restrictions upon the"
PRINT "  player and even strong, high level characters are free to explore and"
PRINT "  pillage any of these settings if they can handle a light scolding from the"
PRINT "  person in charge of that particular area."
COLOR 3: LOCATE 22: GOSUB KeyWait
GOSUB Header: LOCATE 6: COLOR 2
PRINT "  The Eamon Deluxe 5.0 Demo Adventure has also been included with this set."
PRINT "  Unlike the rest of the collection, the Demo Adventure has not been scaled"
PRINT "  down for beginning level characters, but rather it is recommended that at"
PRINT "  least a medium level character is used when exploring Eamon Deluxe's most"
PRINT "  famous and ever-changing little mysterious house in the forest..."
PRINT
PRINT "  The 5.0 Demo Adventure is a good introduction into how the Eamon Deluxe"
PRINT "  gaming system works and goes over almost every aspect of common game play"
PRINT "  while still mainting a consistent story and sense of adventure. It is"
PRINT "  highly recommended to new players and those who have played older versions"
PRINT "  of Eamon Deluxe before the 5.0 revisions."
COLOR 3: LOCATE 22: GOSUB KeyWait
GOSUB Header: COLOR 10: PRINT "  Note: "; : COLOR 2
PRINT "It is recommended that those who are new to Eamon Deluxe read through"
PRINT "  the Player's Manual before starting an adventure. The Player's Manual has"
PRINT "  detailed explanations of all the commands used on adventures as well as"
PRINT "  other general details about basic Eamon Deluxe gameplay. All game manuals"
PRINT "  can be read from the Eamon Deluxe Main Menu or found online at ";
COLOR 15: PRINT "EamonAG.org": COLOR 2: PRINT
PRINT "  Those who are familiar with other versions of Eamon will recognize a lot"
PRINT "  of similarities to the classic versions. However, Eamon Deluxe has many"
PRINT "  significant enhancements and features which are also detailed in the"
PRINT "  Player's Manual. For a quick reference, type HINTS once you have started"
PRINT "  playing an adventure and select hint number one, "; q$; "GENERAL HELP."; q$
PRINT : COLOR 10: PRINT SPACE$(58); "Cheers,": COLOR 10
PRINT SPACE$(56); "Frank Black": PRINT SPACE$(57); "June, 2012"
COLOR 3: LOCATE 22: GOSUB KeyWait
RETURN

Menu:
author$ = author1$: adventure$ = Adventure1$: GOSUB Title
COLOR 2 + 5 * ABS(s%(4) <> 0)
FOR a = 1 TO 4
   PRINT a$(a); : IF a < 4 THEN LOCATE CSRLIN, 40: PRINT a$(a + 4)
NEXT
PRINT : PRINT : k = 11: c1 = 4
CALL EDXMenuM(k, c1, 1, 5, 3, 0)
IF k > 5 OR c1 = 3 THEN CHDIR "..": RUN "EAMONDX"
IF k = 5 THEN GOSUB Intro: GOTO Menu
IF k = 4 THEN adv = 0: GOTO Reviews

GOSUB Pick
ON k GOTO Stories, IntroDone0, Reviews

Stories:
GOSUB Title
ON adv GOSUB Cave, AltCave, Forest, CaveII, EnhancedCave, TGround, Demo
GOTO Menu

Reviews:
IF adv > 0 THEN  ' AND adv <> 1
  COLOR 3: GOSUB Title: PRINT : COLOR 2
  PRINT "Reviews have been written for both the Eamon Deluxe version of this adventure"
  PRINT "and the classic title from the original Apple II Eamon gaming system upon which"
  PRINT "it was based. Please select the version of the adventure that you wish to read"
  PRINT "the review for.": PRINT : PRINT
  c = 12: c1 = 4
  CALL EDXMenuM(c, c1, 7, 8, 3, 0)
  IF c1 = 3 THEN GOTO Menu
  IF c = 2 THEN GOTO DustyReviews
END IF
author$ = "Reviewed by Luke Hewitt"
IF adv <> 2 THEN adventure$ = adventure$ + " Deluxe Edition"
IF adv = 0 THEN adventure$ = "Eamon Deluxe " + Adventure1$
a$ = "": IF adv < 9 THEN a$ = "0"
a1$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv)))
a$ = "": IF adv + 1 < 9 THEN a$ = "0"
a2$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv + 1)))
OPEN "EDX001RV.TXT" FOR INPUT AS #1
  DO
    LINE INPUT #1, a$
  LOOP UNTIL a$ = a1$
  COLOR 2: GOSUB Title: COLOR 3
  DO
    LINE INPUT #1, a$
    IF a$ = "<paws>" THEN
      PRINT : PRINT : COLOR 2: GOSUB KeyWait: COLOR 3
      LOCATE CSRLIN - 1: a$ = ""
    END IF
    IF a$ <> a2$ THEN PRINT a$
  LOOP UNTIL a$ = a2$
  CLOSE : GOTO Menu
DustyReviews:
GOSUB Title
ON adv GOSUB Cave1, AltCave1, Forest1, CaveII1, EnhancedCave1, TGround1, Demo1
GOTO Menu

IntroDone0:
GOSUB Title
' Skip Beginner's Forest intro (repeated in game)
IF adv <> 3 THEN
  ON adv GOSUB Cave, AltCave, Forest, CaveII, EnhancedCave, TGround, Demo
END IF
IntroDone:
a$ = "(Waking up the monsters...)"
x$ = "Whacking up the monsters (with a broom handle)..."
IF adv = 2 THEN a$ = "(Please wait while I stir things up...)"
IF adv = 7 AND INT(RND * 100) + 1 < 75 THEN a$ = x$
PRINT a$: FOR x# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$


'                      The Beginner's Cave
'                     ---------------------
Cave:
GOSUB Title: LOCATE 8: COLOR 2
PRINT "The Beginner's Cave has been set up by the Warlord as a service to all Free"
PRINT "Adventurers, giving them a chance to try their skills in a not-too-dangerous"
PRINT "setting. Let us all toast the Warlord for restocking the cave daily!"
COLOR 3: LOCATE 22: GOSUB KeyWait: COLOR 2: LOCATE 6
PRINT "Only beginner's are supposed to enter the cave (but any character can). Knight"
PRINT "Marshall William Misslefire is on duty to prevent inexperienced adventurers"
PRINT "from doing anything really foolish (like entering the cave with no weapon at"
PRINT "all!).": PRINT
PRINT "To return to the Main Hall, just leave the cave (by getting to the cave entrance"
PRINT "and moving north). Once you have done so, Sam Slicker, the local dealer for"
PRINT "treasures and booty, will pay you in gold for any items that you have collected"
PRINT "(with the price adjusted slightly depending upon your charisma)."
COLOR 3: LOCATE 22: GOSUB KeyWait
LOCATE 7: COLOR 15: PRINT "CONVERSION NOTES:": COLOR 7: PRINT
PRINT "This is the true and original Beginner's Cave and actually the first Classic"
PRINT "Eamon adventure, written by Donald Brown nearly three decades ago. In an attempt"
PRINT "to preserve the flavor of the Classic Eamon experience, very little new content"
PRINT "was added upon conversion to Eamon Deluxe conversion. Just the standard Eamon"
PRINT "Deluxe enhancements and the addition of a few embedded artifacts which were "
PRINT "already hinted at in the descriptions. Although designed as a simple outing for"
PRINT "new characters, the Beginner's Cave captures the unique experience of Eamon"
PRINT "very well and is, in many ways, one of the best adventures ever written for it."
COLOR 3: LOCATE 22: GOTO KeyWait
Cave1:
GOSUB Title: LOCATE 8: COLOR 7
PRINT "Oddly enough, no reviews presently exist for the Classic Eamon version of The"
PRINT "Beginner's Cave..."
COLOR 3: LOCATE 22: GOTO KeyWait


'                      Alternate Beginner's Cave
'                     ---------------------------
AltCave:
IF CaveTest = 0 AND s%(4) = 0 THEN
  SCREEN 7
  CALL SkullRV(15, 15, 4, 0, 14, 0): CALL SkullRV(0, -1, -1, -1, -1, -1)
  col = 1: row = 4: TextSize = 1: TextColor1 = 3: TextColor2 = -1
  a$ = "YOU ARE ABOUT TO": CALL HRT: a$ = "ADVENTURE IN THE": CALL HRT
  col = 1: row = 5: TextSize = 2: TextColor1 = 2: TextColor2 = 0
  a$ = "ALTERNATE": CALL HRT: a$ = "BEGINNER'S": CALL HRT: a$ = "  CAVE": CALL HRT
  col = 1: row = 24: TextSize = 1: TextColor1 = 7: TextColor2 = -1
  a$ = "BY RICK VOLBERDING": CALL HRT: a$ = "": CALL HRT
  a$ = "CONVERTED TO EAMON": CALL HRT: a$ = "DELUXE BY FRANK BLACK": CALL HRT
  a$ = INKEY$
  FOR x# = 1 TO dly# * 32
     IF INKEY$ <> "" THEN x# = dly# * 32
  NEXT
  SCREEN 0: WIDTH 80: CLS : COLOR 3: GOSUB Title
END IF
GOSUB Title
IF s%(4) = 1 THEN
 PRINT "[V.I. Mode note: A graphic splash screen with the adventure title and credits"
 PRINT "appears on a black background here. On the right half of the screen is a giant"
 PRINT "white skull.]"
 PRINT : PRINT : GOSUB KeyWait
END IF
GOSUB Title: LOCATE 8: COLOR 2
PRINT "There is no introduction to this adventure, you simply wander about a different"
PRINT "Beginner's Cave."
COLOR 3: LOCATE 22: GOTO KeyWait
AltCave1:
s$ = "March 1996": GOSUB Review1: LOCATE 7: COLOR 7
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min."
PRINT "Reviewer Rating: 5.0    Average Rating: 5.0/6": COLOR 2
PRINT
PRINT "Comment: This is a very adequate adventure for beginners and young Eamonauts."
PRINT "It has 46 rooms, [two] secret passages, one hidden treasure, one container,"
PRINT "one magic potion, and one maiden to rescue. I encountered no death traps. The"
PRINT "monsters were pushovers with my magic sword. There were a couple of nice"
PRINT "special effects with monsters appearing in the room. Overall, a good job, "
PRINT "considering the target audience."
COLOR 3: LOCATE 22: GOTO KeyWait


'                         Beginner's Forest
'                        -------------------
Forest:
GOSUB Title: LOCATE 7: COLOR 2
PRINT "You have no trouble finding a horse that you, well, borrow to take you on your"
PRINT "first adventure. You follow several signs which lead you to the Beginner's"
PRINT "Forest."
PRINT
PRINT "You see a green, vine covered arch with a locked wrought iron gate under the"
PRINT "arch. Worked into the design of the gate are the words, "; q$; "Beginner's Only!"; q$
PRINT : COLOR 7
PRINT "As you look at the locked gate, you see Zeus Hightower Flabbergibungander, the"
PRINT "local Forest Ranger, coming over to inspect you...."
COLOR 3: LOCATE 22: GOTO KeyWait
Forest1:
s$ = "March 1998": GOSUB Review1: LOCATE 8: COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 10-60 min.": PRINT "Reviewer Rating: 5.0": COLOR 2
PRINT
PRINT "Comment: As the above implies, this Eamon is designed for beginner characters,"
PRINT "just like the "; q$; "Beginners Cave"; q$; ". I whomped up a new character, bought myself a"
PRINT "sword and leather armor, and jumped right in."
COLOR 3: LOCATE 22: GOSUB KeyWait: LOCATE 7: COLOR 2
PRINT "It is well enough written, with a small, coherent map and good descriptions. It"
PRINT "is heavy into combat, and is pretty tough for freshly minted characters with"
PRINT "very little in the way of weapons, armor, and spells. I got killed out five or"
PRINT "six times in 20 minutes of playing, and never did see more than about 20 of the"
PRINT "32 rooms. In fact, I am going to jump up the difficulty rating to (7) because I"
PRINT "found it darned hard to survive the combat with a brand-new character."
PRINT
PRINT "One hint: don't even try to fight the spooks; you'll soon find yourself"
PRINT "hopelessly outnumbered. Run away!"
COLOR 3: LOCATE 22: GOTO KeyWait


'                      The Beginner's Cave II
'                     ------------------------
CaveII:
GOSUB Title: COLOR 2: LOCATE 7
PRINT "The Beginner's Cave has been set up by the Warlord as a service to all Free"
PRINT "Adventurers, giving them a chance to try their skills in a not-too-dangerous"
PRINT "setting. Let us all toast the Warlord for restocking the cave daily!"
COLOR 3: LOCATE 22: GOSUB KeyWait
COLOR 15: LOCATE 6: PRINT "NOTE:": COLOR 7: PRINT
PRINT "This is a Beginner's Cave that John Nelson wrote for his aborted "; q$; "Eamon II"; q$
PRINT "project on the Apple II series of computers. It was later translated into a"
PRINT "standard Version 6 Classic Eamon adventure by Tom Zuchowski. Tom's version was"
PRINT "used as the source for the conversion into Eamon Deluxe."
COLOR 3: LOCATE 22: GOTO KeyWait
CaveII1:
s$ = "June 1990": GOSUB Review1: LOCATE 6
COLOR 7: PRINT "Reviewed by Starshine": PRINT
PRINT "Playing Time: 1 hour": PRINT "Reviewer Rating: 1.0    Average Rating: 2.0/2"
PRINT : COLOR 2
PRINT "Comment: With John Nelson as author, I was expecting an improvement over the"
PRINT "original Beginner's Cave but was disappointed. The monsters in the cave"
PRINT "consisted of the usual rat, troll, and snake, but the wild boar and bull were"
PRINT "out of place in a cave. "; q$; "Treasure"; q$; " was misspelled. The action was dull with no"
PRINT "exciting Trollsfire type weapons or hidden surprises. The treasures were"
PRINT "give-aways with little hazard for the taking. The original Beginner's Cave"
PRINT "remains the better of the two for me."
COLOR 3: LOCATE 22: GOTO KeyWait


'                      Enhanced Beginner's Cave
'                     --------------------------
EnhancedCave:
GOSUB Title: LOCATE 8: COLOR 2
PRINT "The Beginner's Cave has been set up by the Warlord as a service to all Free"
PRINT "Adventurers, giving them a chance to try their skills in a not-too-dangerous"
PRINT "setting. Let us all toast the Warlord for restocking the cave daily!"
COLOR 3: LOCATE 22: GOSUB KeyWait: COLOR 2: LOCATE 6
PRINT "Only beginner's are supposed to enter the cave (but any character can). Knight"
PRINT "Marshall William Misslefire is on duty to prevent inexperienced adventurers"
PRINT "from doing anything really foolish (like entering the cave with no weapon at"
PRINT "all!).": PRINT
PRINT "To return to the Main Hall, just leave the cave (by getting to the cave entrance"
PRINT "and moving north). Once you have done so, Sam Slicker, the local dealer for"
PRINT "treasures and booty, will pay you in gold for any items that you have collected"
PRINT "(with the price adjusted slightly depending upon your charisma)."
COLOR 3: LOCATE 22: GOSUB KeyWait
LOCATE 8: COLOR 15: PRINT "Notes:": COLOR 7: PRINT
PRINT "This adventure is identical to the "; q$; "Beginner's Cave"; q$; " except that John Nelson"
PRINT "added some new rooms, monsters, etc.. There is also an extra secret passage to"
PRINT "find. Overall, about one-third of the content is new."
COLOR 3: LOCATE 22: GOTO KeyWait
EnhancedCave1:
LOCATE 5: COLOR 7
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30 minutes": PRINT "Reviewer Rating: 5.0"
PRINT : COLOR 2
PRINT "Comment: I thought long and hard before assigning this adventure its own number,"
PRINT "but one-third of the database is new and, in the end, it seemed that it would be"
PRINT "easier to track bugs and revisions if it was listed separately."
PRINT
PRINT "If you have played the original, you haven't missed much if you haven't played"
PRINT "this one as well. It is after all an adventure for beginners and is very simple."
PRINT "The rating reflects this; if it had been judged as a normal adventure it would"
PRINT "not rate quite as well as it did. I give it a (3) for difficulty."
COLOR 3: LOCATE 22: GOTO KeyWait


'             The Training Ground
'            ---------------------
TGround:
GOSUB Title: LOCATE 7: COLOR 2
PRINT "You're an inexperienced adventurer, but you know how to listen and pick up some"
PRINT "good info once in a while. When you heard that there was a place outside of"
PRINT "town that gave beginning adventurers a chance to hone their skills and pick up"
PRINT "some loot in the process, naturally you jumped at the opportunity to make the"
PRINT "most of this deal."
PRINT
PRINT "So, you hitchhiked your way out there, and readied your weapons and yourself as"
PRINT "you approached the Main entrance..."
COLOR 3: LOCATE 22: GOTO KeyWait
TGround1:
GOSUB Title: s$ = "September 1991": GOSUB Review1
COLOR 7: PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30-45 min. "
PRINT "Reviewer Rating: 5.0                             Average Rating: 6.0/2"
PRINT : COLOR 2
PRINT "Comment: The introduction text is about par for the adventure itself. There is"
PRINT "no quest of any kind and there are only 36 fairly simple rooms. This adventure"
PRINT "is for beginners who want to pump up their character's stats "; q$; "honestly"; q$; " instead"
PRINT "of using the Character Editor. There are lots of goodies everywhere you look"
PRINT "that enable the player to bulk up his character. The loot and weapons are"
PRINT "really good, too."
PRINT
PRINT "Advanced and experienced players will find this one to be a "; q$; "Monty Haul"; q$
PRINT "scenario of the "; q$; "kill and loot"; q$; " variety. But it is just the ticket for those"
PRINT "who need a stronger character but don't want to "; q$; "cheat"; q$; ". I give it a difficulty"
PRINT "rating of (2). With its low difficulty and high rewards, it is probably a good"
PRINT "candidate for young Eamonauts"
COLOR 3: LOCATE 23: GOTO KeyWait


'              Eamon Deluxe 5.0 Demo Adventure
'             ---------------------------------
Demo:
GOSUB Title: LOCATE 8: COLOR 7
PRINT "The Eamon Deluxe Demo Adventure is a mini adventure with no special programming"
PRINT "that was written to test the base adventure program during development stages."
PRINT "It also serves to demonstrate the basic game play of Eamon Deluxe and how a"
PRINT "large amount of special events can included by anybody who wishes to create"
PRINT "their own adventure simply by using the various built in features."
COLOR 3: LOCATE 22: GOSUB KeyWait: LOCATE 8: COLOR 2
PRINT "The story is: You were wandering through the woods when you heard somebody cry"
PRINT "out. You head in the direction which the sounds came from and come upon a small"
PRINT "house in the middle of the woods. Standing outside is another member of the Free"
PRINT "Adventurer's Guild who also heard the cry. Not being weak on courage, you"
PRINT "decide to explore the house..."
COLOR 3: LOCATE 22: GOTO KeyWait
Demo1:
GOSUB Title: LOCATE 10: COLOR 7
PRINT "This an Eamon Deluxe original adventure and therefore has no reviews from"
PRINT "Classic Eamon gaming systems."
COLOR 3: LOCATE 22: GOTO KeyWait


'                  Review header
'                -----------------
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter. The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe. The review is for the old Apple II version."
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it. e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait


'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN

'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$: BS = POS(0): CC# = 0
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = UCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: GOTO Title
END IF
' Standard rtn
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""

'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT L$: PRINT : RETURN

'
' Center a string on 80-column screen
'
Center:
PRINT SPC(INT((79 - LEN(a$)) / 2)); a$: RETURN

'              AD Menu Header 5.0
'             --------------------
Header:
mc1 = 1: mc2 = 15: mc3 = 7: COLOR 7: CLS
IF s%(4) = 1 THEN
  a$ = "WELCOME TO THE BEGINNERS ADVENTURES COLLECTION.": GOTO Center
END IF
COLOR mc1, 0: PRINT " "; STRING$(76, ""); ""
'PRINT " "; SPACE$(76); ""
PRINT " "; SPACE$(20); : COLOR mc2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR mc1: PRINT SPACE$(20); "": PRINT " "; SPACE$(22); : COLOR mc2
PRINT "Beginners Adventures Collection"; : COLOR mc1: PRINT SPACE$(23); ""
'PRINT " "; SPACE$(76); ""
PRINT " "; STRING$(76, ""); "": PRINT : COLOR 7: RETURN

ScreenError:
SCREEN 0: WIDTH 80: CLS : CaveTest = 1: IF s%(4) <> 1 THEN COLOR 0, 2
PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able to see the graphic intro screen for the "; q$; "Alternate Beginner's"
PRINT "Cave"; q$; ", because it requires an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME CaveTest


'
' Adventure data
'
AdventureData:
DATA 7
DATA The Beginner's Cave,Donald Brown,BEGCAVES
DATA Alternate Beginner's Cave,Rick Volberding,ALTCAVE
DATA Beginner's Forest,Margaret Anderson,FOREST
DATA Beginner's Cave II,John Nelson,CAVEII
DATA Enhanced Beginner's Cave,Donald Brown & John Nelson,BEGCAVES
DATA The Training Ground,Charles Hewgley,TGROUND
DATA Eamon Deluxe Demo Adventure,Frank Black,MAINPGM5

EDXMenuStrings:
DATA 8
DATA "  Preview Adventure Intros          "
DATA "  START PLAYING AN ADVENTURE        "
DATA "  Read Adventure Reviews            "
DATA "  Read Review for This Collection   "
DATA "  Read Notes About This Collection  "
DATA "  Return to Eamon Deluxe Menu    "
DATA "  Review of the Eamon Deluxe Version   "
DATA "  Review of the Classic Eamon Version  "

'  DRAW strings for HRT routine
HRTstrings:
DATA br1d2r1bd2l1r1bu2u2l1,"","","","","",bd2e1u1,"","","","",bd4e1u1,""
DATA bd3f1u1d1l1e1l1d1,"","","","","","","","","","","","",bd5e1u1bu2u1,""
DATA bd1r3bd2l3,"",bd4br1r1bu2e1h1l1,""
DATA bf1d3br2u2l2u1e1f1d1,d4r1e1h1e1h1l1,br2l1g1d2f1r1,d4r1e2h2l1
DATA br1d4r2bu2l2u2r2,r2l2d2r2l2d2,bd1e1r2l2g1d2f1r2u2l1,d4u2r2u2d4,r2l1d4r1l2
DATA bd2d1f1e1u3r1l3,d4u2r1e1u1d1g1f1d1,d4r2,d4u4f2e2d4,d4u4f3d1u4
DATA bd1d2f1r1e1u2h1l1g1,r1f1g1l1d2u4,bd1d2f1r2e1u2h1l2g1bf2f1
DATA d4u2r1f1d1u1h1e1h1l1,br2l1g1f1r1d1g1l1  ,r1d4u4r1,d3f1r1e1u3
DATA d3f1e1u3,d4e2f2u4,d1f2d1u1h1g1d1u1e2u1,d1f1d2u2e1u1,r3g3d1r3

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
' (Updated for VI Mode support 06 JAN 2012)
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

' VI Mode numeric menu
GetMAdvCVI:
IF s%(4) = 1 THEN
  CLS : L = 2: PRINT "Please select an adventure:"
  FOR c = 1 TO dungeons
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + dn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to Exit):";
  LINE INPUT ""; a$: c = INT(VAL(a$))
  IF c < 0 OR c > dungeons THEN CLS : GOTO GetMAdvCVI
  'IF c = 0 THEN RUN 0
  a$ = dn$(c): EXIT SUB
END IF


' Standard Menu
'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(13) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>                     <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
' (Updated with alt. numeric menu for VI Mode support 06 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:
'    s%() - Eamon DX system settings (s%(4) = 1 is VI Mode Flag)
'   em$() - An array which holds all available choices. em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'

' VI Mode numeric menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  L = 2
  FOR x = be TO en
     x$ = LTRIM$(STR$(x - be + 1)) + ": " + LTRIM$(RTRIM$(em$(x)))
     IF x < 100 THEN x$ = " " + x$: IF x < 10 THEN x$ = " " + x$
     PRINT x$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       CLS : L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to exit):";
  LINE INPUT ""; k$: c = INT(VAL(k$)): c1 = c + (be - 1)
  IF c = 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB HRT
'  This is the same SUB that is in the EDXDEMO.BAS file. See that for notes.
HRT:
IF TextSize < 1 THEN TextSize = 1
c = INT(52 / TextSize) + 1
r = INT(26 / TextSize) + 1
IF col > c THEN col = 1: row = row + 1
IF row > r THEN row = 1

DRAW "c" + STR$(TextColor1) + "s" + STR$(TextSize * 4)
IF TextColor2 > -1 THEN GOTO HRT2

FOR a = 1 TO LEN(a$)
   k = ASC(MID$(a$, a, 1))
   DRAW "bm" + STR$((col - 1) * (TextSize * 6) + mode1) + "," + STR$((row - 1) * (TextSize * 7) + mode2)
   DRAW ab$(k): col = col + 1
   IF col > c THEN : col = 1: row = row + 1: IF row > r THEN row = 1
NEXT
col = 1: row = row + 1
EXIT SUB
'
'  Inverse text gets a separate routine because
'    it is slightly slower
'
HRT2:
FOR a = 1 TO LEN(a$)
   k = ASC(MID$(a$, a, 1))
   x = (col - 1) * (TextSize * 6): y = (row - 1) * (TextSize * 7)
   LINE (x, y - 2 * TextSize)-(x + 6 * TextSize, y + 5 * TextSize), TextColor2, BF
   DRAW "c" + STR$(TextColor1)
   DRAW "bm" + STR$((col - 1) * (TextSize * 6) + mode1) + "," + STR$((row - 1) * (TextSize * 7) + mode2)
   DRAW ab$(k): col = col + 1
   IF col > c THEN col = 1: row = row + 1: IF row > r THEN row = 1
NEXT
col = 1: row = row + 1
END SUB

SUB SkullRV (sk1, sk2, sk3, sk4, sk5, sk6)
'                   SkullRV
'   (Based on a picture drawn by Rick Volberding)
'
' Microsoft BASIC conversion, colors, and enhancements
'    by Frank Black
'
' For sk2 to sk6, a value of -1 means 'don't paint'
'
' sk1 - Skull outline color   sk2 - Skull fill color
' sk3 - Eye socket color      sk4 - Nose socket color
' sk5 - Teeth color           sk6 - Background color

'                  Skull & mouth
Skull:
DRAW "c" + STR$(sk1)
DRAW "bm196,5"
DRAW "r10d1r5d1r5d1r7d1r2d1r2d1r2d1r2d1r2d1r1d1r2d1r2d1r2d1r2d1r1d1"
DRAW "r1d1r2d1r1d1r2d2r1d1r1d2r1d1r1d2r1d1r1d1r1d2r1d2r1d2r1d2r1d2r1d3r1d2r1"
DRAW "d3r1d2r1d10r1d5r1d5r1d5l1d4l1d11l1d3l1d2l1d3l1d2l1d6l1d1l1d1l1d1l1d1l1"
DRAW "d2l1d2l1d1l1d1l1d1l1d1l1d1l1d1l1d1l1d1l1d1l2d1l2d1l5u1l1u1l1u3"
DRAW "r1u2r1u1l3u3l1u2l1u2l1u2l1u2r1u1r1u1l1u1l1u1l5d1l6d1l1d1l1d1l1"
DRAW "d1l1d1l1d1l1d1l15d1l2d1l1d1l2d1l1d1l1u1l1u1l1u1l1u1l1u6l4u1l1u1l5u1"
DRAW "l2u1l1br56bd5d4l1d3l1d3l1d4l1d4l1d3l1d2l1d10l1d3l1d3l1"
DRAW "d3l1d3l1d3l1d1l5d1l5d1l1d1l2d1l2d1l1"
DRAW "d1l2d1l2d1l2d1l2d1l2d1l2d1l2d1l2 "
DRAW "d1l3d1l3d1l3d1l4d1l2d1l3d1l7u1l8u1l10u1l2u4l1u3r1u2r1u2r1u2l1"
DRAW "u2l1u1l1u8l1u1l1r1u3r2"
DRAW "d3l1r2d1r2d1r1d1r1u1r1u3l1u2l1u2l1u2r1d3r1d2r1"
DRAW "d3r1d1r1d1r3u1l1u2l1u7l5r3d1r1d4r1d2r1d2r3u1r1u8l5r4d1bd8r3d1r1u1r1u1 "
DRAW "r1u1r1u1r1u2l1u3l1u1l5r5d2bd4br2r1d1r1d1r1d1u1r1u1r1u1r1u6l5d1l2r2u1r3"
DRAW "d1r1d3r1d2r1d1r1d1u1r1u1r2u1l1r1u5l1u1l3d1br4bd6r4u1r2u1r1u4l6r6d5"
DRAW "r2d1r5u1r1u8l4d1l2d1l2br8d4r3u1r1u1r1u1r1u3l6r6d2r4d1u1r1u1r1u2r1u2r1u5l1"
DRAW "u5r1u5r1u4r1u2r1u2r3u1r2d1r1d1r1d2r2d1"
DRAW "r4u1r1u1r1u1r1u1r1u1r1u1r1u4r4u1r1u1r1"
DRAW "bd34bl36l2u3r1u4l2u1l3d1l1d7u7l3d1l3d1l5u1d1l1d2"
DRAW "l1d5u5r1u2r5d7bl6bu5l1u1l2u1l1d1l1d5u4l1u1l3"
DRAW "d1l1d1l1d5u5l1u2l1u1l1u1l2d3l1d5r1l1u5l1u2l1u1l1d1l1d1l2d6r1l1u7l1u1l2u1"
DRAW "l6d1r2d3l1d2r1d3l1u8l2d3l1d5u7l1u1l1d1l1d7r1u2d4r1u1d7u3r1u4d3r1d4r1u2d3r2"
DRAW "d1r1d1r1bu10l8u3l1u5l1d1"
DRAW "u7l1u2r1u2r1u1r1u2l1u2l1u1l1u1l1u1l1u1l1u1l1u1l1u3l1u2l1u3l1u2l1u3r1"
DRAW "u2r1u5r1u10l1u10r1u5l1u5r1u3r1u2r1u3r1u2r1u3r1u2r1 u4 r1u3r1u2r1u2r1u2"
DRAW "r1u1r1u3r1u2r1u1r1u1r1u1r1u1r1u1r2u2r1u1r1u1r1u1r1u1r2u1r2u1r2u1r2u1"
DRAW "r2u1r3u1r3u1r3u1r3u1r3u1r3u1r3u1r6u1l3r10"
'       Draw eyes & nose
DRAW "bd78bl65 r1l1u2 l1u1l1 u1r1 u1r1u1r1u1r1u1r1u1r2u1r2u1r2d1r2d1r1d1r2d1"
DRAW "r2d6l1d2l2d2l1d2l1d3l1d3r2u1r1u1r1d1r3u1d1r1d2r1d2r1d2r1d1r1d1r1d2r1"
DRAW "d2r1d1r1d6l1d1l1d1l1d1l1d1l1d1l3u1l2u1l2u1d2l1d1u1l1u1l1u3l1u3l1u6r1"
DRAW "u5r1u4l2d2l1d1l2d1l5u1l3u3r1u2r1u2r1u7br34l1u3r1u2r1u1r1u1r1u1r1u1r1"
DRAW "u1r1r2u1r10 d1r1d1r1d1r1d1r2d3r1d2r1d2r1d2r1d1r1d3l1"
DRAW "d4 r1d1l1d1l1d1l1d1l2d1l2d1l3d1l10u1l4u1l1u10l1u3l1u2"

' Paint Skull
IF sk2 > -1 THEN
  DRAW "bm196,8p" + STR$(sk2) + "," + STR$(sk1)
  DRAW "bm220,110p" + STR$(sk2) + "," + STR$(sk1)
  DRAW "bm220,130p" + STR$(sk2) + "," + STR$(sk1)
END IF
' Paint eyes
IF sk3 > -1 THEN
  DRAW "bm140,80p" + STR$(sk3) + "," + STR$(sk1)
  DRAW "bm170,80p" + STR$(sk3) + "," + STR$(sk1)
END IF
' Paint nose
IF sk4 > -1 THEN DRAW "bm148,100p" + STR$(sk4) + "," + STR$(sk1)
' Paint teeth
IF sk5 > -1 THEN
  DRAW "bm137,138p" + STR$(sk5) + "," + STR$(sk1) + "bm141,136p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm148,138p" + STR$(sk5) + "," + STR$(sk1) + "bm153,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm158,138p" + STR$(sk5) + "," + STR$(sk1) + "bm165,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm170,138p" + STR$(sk5) + "," + STR$(sk1) + "bm176,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm184,138p" + STR$(sk5) + "," + STR$(sk1) + "bm189,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm141,145p" + STR$(sk5) + "," + STR$(sk1) + "bm147,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm153,148p" + STR$(sk5) + "," + STR$(sk1) + "bm158,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm165,148p" + STR$(sk5) + "," + STR$(sk1) + "bm170,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm177,145p" + STR$(sk5) + "," + STR$(sk1) + "bm184,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm189,144p" + STR$(sk5) + "," + STR$(sk1)
END IF
' Paint background
IF sk6 > -1 THEN DRAW "bm0,0p" + STR$(sk6) + "," + STR$(sk1)

END SUB

