' THE WONDERFUL WORLD OF EAMON DELUXE
'            BY FRANK BLACK
'
'   A COMPUTERIZED FANTASY ROLE-PLAYING SYSTEM
' BASED UPON THE APPLE II VERSION BY DONALD BROWN,
'    JOHN NELSON, TOM ZUCHOWSKI, & FRANK
'
' Classic Eamon Adventures Volume 1        Update 19 DEC 2011
'
DECLARE SUB Treasure.Island.Map ()
DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), dly#, CC1#, CC2#, CC3#, adv, adv1, adv2
DIM SHARED Island1
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): sex = z.sex: q$ = CHR$(34)

adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT
a1$(3) = "by William " + q$ + "Davy" + q$ + " Davis"
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT: CLOSE
END IF

'
' Make sure graphic mode is available for Treasure Island map
'
ON ERROR GOTO ScreenError
SCREEN 7

Start:
ON ERROR GOTO 0
Island1 = ABS(Island1): SCREEN 0: WIDTH 80
'
l$ = STRING$(80, 196)
OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Converted to Eamon Deluxe by Frank Black"
adventure1$ = "Classic Eamon Adventures Volume 1"
author$ = author1$: adventure$ = adventure1$

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Kingdom, Island, Furioso, Merlin, Hogarth, Senator: GOTO IntroDone
ON adv - 6 GOSUB Tower, Gateway, Lair, Citadel, Museum, Daemon: GOTO IntroDone
ON adv - 12 GOSUB Lanst, Xim, OrcLair, Door, Bluff, LDeath, House, LifeOrb, Adept
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Title: COLOR 2
a$ = "This is official Eamon Deluxe adventure #13": GOSUB Center: COLOR 3
PRINT
PRINT "This is the first of six collections of "; q$; "Classic"; q$; " Apple II Eamon adventures."
PRINT "The order I have selected is numerical, but also includes all of an author's"
PRINT "adventures even if they aren't in sequential order."
PRINT
PRINT "Note that there are many adventures which are not included because they are"
PRINT "already collected into another Eamon Deluxe adventure set."
PRINT
PRINT "I have enhanced most of these adventures and I hope that you enjoy playing them"
PRINT "as much as I enjoyed converting them to Eamon Deluxe."
PRINT
PRINT SPC(61); "-Frank Black"
PRINT : PRINT : GOSUB KeyWait

Menu:
author$ = author1$: adventure$ = adventure1$: GOSUB Title
COLOR 2
FOR a = 1 TO 11
   PRINT a$(a);
   IF a < 11 THEN LOCATE CSRLIN, 40: PRINT a$(a + 11);
   PRINT
NEXT
PRINT : COLOR 3: k = 17: c1 = 20
CALL EDXMenuM(k, c1, 1, 4, 3, 0)
IF k < 1 OR k > 4 THEN GOTO Menu
IF k = 4 THEN CHDIR "..": RUN "EAMONDX"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Kingdom, Island, Furioso, Merlin, Hogarth, Senator, Tower, Gateway, Lair, Citadel, Museum, Daemon, Lanst, Xim, OrcLair, Door, Bluff, LDeath, House, LifeOrb, Adept
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Kingdom1, Island1, Furioso1, Merlin1, Hogarth1, Senator1, Tower1, Gateway1, Lair1, Citadel1, Museum1, Daemon1, Lanst1, Xim1, OrcLair1, Door1, Bluff1, LDeath1, House1, LifeOrb1, Adept1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Kingdom, Island, Furioso, Merlin, Hogarth, Senator, Tower, Gateway, Lair, Citadel, Museum, Daemon, Lanst, Xim, OrcLair, Door, Bluff, LDeath, House, LifeOrb, Adept
IntroDone:
PRINT "(Waking up the monsters...)"
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'               -------------------
'                The Magic Kingdom
'               -------------------
' The original scale & plot of this adventure was expanded by Frank Black
Kingdom:
GOSUB Title
PRINT "Recently, a local evil sorcerer was spying on you through his crystal ball.  He"
PRINT "overheard you talking about him and, having a short temper like most evil"
PRINT "sorcerers, he instantly banished you to the Magic Kingdom, thinking you would"
PRINT "never return."
PRINT : PRINT : GOTO KeyWait
'  The Magic Kingdom review
Kingdom1:
PRINT q$; a$(adv); q$; " was reviewed in the June 1994 issue of the EAG"
PRINT "newsletter.  However, the review dealt only with problems and features of the"
PRINT "Apple II version so it wasn't included here."
PRINT : PRINT : GOTO KeyWait
'           ------------------------------
'            The Caves of Treasure Island
'           ------------------------------
' IBM PC graphics & sounds programmed by Frankus Kunzus,
'  based on the Apple versions
'
Island:
PRINT "Greetings, "; name$; "!"
PRINT
PRINT "The Free Adventurer's Guild has elected you to rescue a captured adventurer."
PRINT "Recently, somebody found a note in a bottle asking for assistance.  The"
PRINT "author, Genzenbraun the Sailor, is a fellow member of the Guild."
PRINT
PRINT "He explained that he had been taken captive by pirates on Treasure Island."
PRINT "Unfortunatly the exact location of the unlucky adventurer was destroyed by"
PRINT "sea water.  However, in the bottle was the following map..."
PRINT : PRINT : GOSUB KeyWait
'                        SHOW MAP OF ISLAND
IF Island = 0 THEN CALL Treasure.Island.Map: GOSUB Title
IF Island = 1 THEN
  CLS : COLOR 14: PRINT SPC(27); "TREASURE ISLAND": PRINT : COLOR 2
  PRINT SPC(10); "L = Landing Point                 xx = Jungle"
  PRINT SPC(10); "P = Pickup point                  OO = Lake": COLOR 6
  PRINT SPC(17); "_________"; SPC(18); : COLOR 2: PRINT ".. = Beach": COLOR 6
  PRINT SPC(16); "/xxxxxxxxx\"
  PRINT SPC(14); " / xxxxxxxxxx\     _____"
  PRINT SPC(13); " /...xxxxxxxxxx\___/.....\____________"
  PRINT SPC(13); " \...xxxxxxxOOOOOOx............xxxxxxx\"
  COLOR 2: PRINT SPC(11); "-L- "; : COLOR 6
  PRINT "|..xxxxx OOOOOOOOxxxxxxxxxxxxxxxx!!x \"
  PRINT SPC(13); " /...xxxxxx OOOOOO..............xx!!!!xx|"
  PRINT SPC(13); " \...xxxx___ xxxxxxx.......... xxxx!! x /"
  PRINT SPC(14); " \_____/   \________/-----\_________x/"
  COLOR 2: PRINT SPC(12); "Whaler's Cove           -P-"
  a$ = "VOLCANO": LOCATE 8
  FOR x = 1 TO 7
     LOCATE CSRLIN, 56: PRINT MID$(a$, x, 1)
  NEXT
  COLOR 3: PRINT : PRINT : GOSUB KeyWait
END IF
PRINT "A word of caution:  Genzenbraun warns of hidden caverns with one way passages "
PRINT "and tunnels under the surface of the island.  Also the waters around it are"
PRINT "infested with man-eating sharks."
PRINT
PRINT "A ship will drop you off on the west beach of the island, but it has other"
PRINT "duties and can't wait for you.  Another is scheduled to land on the south"
PRINT "beach soon after you are dropped off."
PRINT
PRINT SPC(28); "**** Good luck! ****"
PRINT : PRINT : GOTO KeyWait
'
'  Caves of Treasure Island review
'
Island1:
s$ = "June 1995": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Special features: Hi-res map in intro, musical instrument sounds"
PRINT "Playing Time: 30-90 min."
PRINT "Reviewer Rating: 5.0       Average Rating: 4.5/6"
PRINT
PRINT "Comment: The intro has a fairly nice hi-res map, too, that is hardly essential"
PRINT "to the play, but is a nice touch just the same."
PRINT
PRINT "This Eamon has a lot of nice touches.  There is some stuff with some magical"
PRINT "musical instruments, and when you play them, you hear "; q$; "music"; q$; " through the"
PRINT "speaker.  There are also some interesting specials with some other commands."
PRINT "There are quite a number of death traps, too.  Even so, the difficulty isn't"
PRINT "much worse than a (6)."
PRINT : PRINT : GOTO KeyWait
'                        ---------
'                         Furioso
'                        ---------
'
Furioso:
a$ = "lad": IF sex = 1 THEN a$ = "lass"
PRINT name$; ", you've made a big mistake."
PRINT
PRINT "When you recently accepted a mission to find the contact of a band of"
PRINT "smugglers in a strange city, you did not think you would end up this bad off."
PRINT
PRINT "As you strolled along the docks last night trying to pick up information on"
PRINT "the smugglers, you stopped off at a local tavern and made the mistake of"
PRINT "ordering a drink."
PRINT
PRINT "It's not that the drink tasted bad, or that it made you sick.  It's that the"
PRINT "drink was drugged!  Your last memory was of a smiling, fat-jowled barkeep"
PRINT "with deep red hair."
PRINT
PRINT q$; "Drink up, me fine "; a$; "!"; q$; " he said as he slapped you on the back.  The world "
PRINT "started to weave and he then "; q$; "helped"; q$; " you into the back room."
PRINT : PRINT : GOTO KeyWait
Furioso1:
PRINT "Special Features:  10 Directions"
PRINT "Average Rating:  5.3/3"
PRINT
PRINT q$; "Furioso"; q$; " was reviewed in the August 1984 issue of the NEUC Adventurer's log,"
PRINT "but the review was really just a brief summary and contained nothing noteworthy."
PRINT SPC(56); "-Frank"
PRINT : PRINT : GOTO KeyWait
'                     -----------------
'                      Merlin's Castle
'                     -----------------
Merlin:
a$ = "As you leave the Main Hall a great idea comes into your head."
a# = dly# / 8: GOSUB SlowPrint: PRINT
FOR x# = 1 TO dly# * 4: NEXT
a$ = q$ + "Why not go to Elven Wonderland?!" + q$
GOSUB SlowPrint: PRINT
FOR x# = 1 TO dly# * 4: NEXT
a$ = q$ + "Adventures don't have to be dangerous!" + q$
GOSUB SlowPrint: PRINT
FOR x# = 1 TO dly# * 4: NEXT
a$ = "Over the trees of the dark forest you see the gleam of Elven Wonderland,"
GOSUB SlowPrint
a$ = "but as you pass under them there is a noise from above.  You look up just"
GOSUB SlowPrint
a$ = "in time to glimpse three elves descending upon you!"
GOSUB SlowPrint
PRINT : PRINT : GOSUB KeyWait
FOR a = 1 TO 10
   FOR x = 1 TO 15
      COLOR 0, x
      FOR xa = 1 TO 13: PRINT "x+x+x+"; : NEXT: COLOR 0, 0: PRINT
   NEXT
   COLOR 3, 0
NEXT
FOR x# = 1 TO dly# * 4: NEXT
GOSUB Title
PRINT "When you regain consciousness you realize that your surroundings have"
PRINT "changed drastically.  You are not in Elven Wonderland or the dark forest,"
PRINT "but in Merlin's castle!!"
PRINT : PRINT : GOTO KeyWait
Merlin1:
s$ = "September 1990": GOSUB Review1
PRINT "Reviewed by Henry Haskell"
PRINT
PRINT "Playing time: 60-90 min."
PRINT "Reviewer Rating: 5.5                 Average Rating: 4.8"
PRINT
PRINT "Comment: This adventure uses the classic formula: kill everything but your"
PRINT "friends, and grab everything but your enemies.  Monsters are illogically (though"
PRINT "humorously) scattered throughout Merlin's Castle.  When you finally escape after"
PRINT "having killed Merlin (with the aid of your map--this place you will definitely"
PRINT "need to map), be sure to kill those pesky Elves, just as you would any other"
PRINT "enemy."
PRINT
PRINT "I would not recommend this adventure to those who are fond of puzzles, who have"
PRINT "short attention spans, or who think combat is just a boring display of chance."
PRINT "However, if you like reading cadaver descriptions and piling up lists of"
PRINT "friends, this one's for you.  I give it a difficulty rating of 7.5."
PRINT : PRINT : GOTO KeyWait
'                   ------------------
'                     Hogarth Castle
'                   ------------------
'
Hogarth:
a$ = "Hogarth Castle": GOSUB Center: PRINT
a$ = "An Eamon adventure": GOSUB Center: PRINT
a$ = "by K. R. Nestle": GOSUB Center: PRINT ': flash
a$ = "Feb. 1981": GOSUB Center
PRINT : PRINT : GOSUB KeyWait
a$ = name$ + ", my dear friend, thank you for coming.": GOSUB Lp0
PRINT
PRINT "I have summoned you here to beg for your help in rescuing my daughter, Rowina,"
PRINT "who has been kidnaped and is being held for ransom by the evil Prince Hogarth."
PRINT
PRINT "I would gladly pay the ransom that he asks (ten chests of gold), if only I had"
PRINT "it.  However, since I do not have that much gold, I must turn to you for"
PRINT "help."
PRINT
PRINT "Since what I ask of you is so very dangerous, I will pay you 1,000 gold pieces"
PRINT "for the safe return of my fair Rowina.  This of course, in addition to whatever"
PRINT "treasures you can carry away from Castle Hogarth."
PRINT : PRINT : GOSUB KeyWait
PRINT "Now, my friend, the choice is yours, will you attempt to rescue fair Rowina"
PRINT "from the castle of evil Prince Hogarth?  ...  Good, I knew you would!"
PRINT
PRINT "Remember the greeting, "; q$; "HOWDY"; q$; ".  It is a code word that will identify you as my"
PRINT "emmisary in Hogarth Town.  Count Orloff is the one person inside the castle"
PRINT "that you can trust.  When you get into the castle, seek him out.  He will help"
PRINT "you."
PRINT
PRINT "God speed and good luck!"
PRINT : PRINT : GOTO KeyWait
Hogarth1:
s$ = "March 1993": GOSUB Review1
PRINT "Reviewed by Steve Bernbaum"
PRINT
PRINT "Extra Commands: KISS"
PRINT "Special Features: Advice and artifacts offered by monsters"
PRINT "Playing Time:  15 minutes to 2 hours"
PRINT "Reviewer Rating: 5                Average Rating: 4.5/2"
PRINT
PRINT "Comment:  Pay close attention to the advice that the king gives you.  If you"
PRINT "follow this advice, both as to what is said and what is not said but logically"
PRINT "follows, you will get lots of help and aid from the villagers.  If you ignore"
PRINT "the unsaid implications, all hands will be turned against you.  HOWDY is the"
PRINT "code word the king gives you.  SAY HOWDY to everyone, no matter how unlikely"
PRINT "they look to provide help, or you will not succeed in freeing Rowena.  Even if"
PRINT "they are unfriendly, they will give you the advice and artifacts they have for"
PRINT "you before attacking."
PRINT : PRINT : GOSUB KeyWait
PRINT "If you explore the town thoroughly before entering the castle, read between the"
PRINT "lines in the advice given by the king and the villagers and use your head to"
PRINT "think through your mission, you can get into the castle, find Rowena, get some"
PRINT "backup warriors, free Rowena and get out pretty quick and easily.  It took me"
PRINT "about fifteen minutes to do so.  Then I went back to the adventure with another"
PRINT "character and explored the rest of the castle.  If you don't figure out the easy"
PRINT "way, make a wrong turn once you are in the castle or just decide to check the"
PRINT "whole place out, you can take about two hours to finish this one."
PRINT
PRINT "There are a few fairly nasty monsters about, as well as lots of loot.  So, you"
PRINT "can aim for accomplishing the mission quickly or have a hack and slash adventure"
PRINT "where you can get filthy rich.  Overall the monsters are of average hardiness."
PRINT "Some are tough.  Some are pushovers. Most are in between.  None are super tough."
PRINT "However, if you don't do the right thing around a couple of them, you're dead,"
PRINT : PRINT : GOSUB KeyWait
PRINT "no matter how tough the adventurer.  If you think about the things helpful"
PRINT "villagers give you and follow the king's advice, you won't have this problem."
PRINT "Otherwise.....  Except for these spots, there was no situation that my"
PRINT "adventurers could not handle.  However, I might add both were well experienced"
PRINT "and carried heavy duty weapons but I think an average character with average"
PRINT "weapons would do fine."
PRINT
PRINT "Overall, I'd give it a 5 for difficulty.  If you make the easy rescue, you will"
PRINT "find it only a 3 or 4 for difficulty."
PRINT : PRINT : GOTO KeyWait
'
'           The Senator's Chambers
'          ------------------------
Senator:
PRINT "The Senator has been in politics for a long time, and has thereby amassed a"
PRINT "small fortune.  His chambers are quite well guarded, though he does not really"
PRINT "believe anyone would ever invade his stronghold."
PRINT
PRINT "Rumour has it that the senator has kidnapped a number of his political rivals"
PRINT "(of which there were once many; now there are few).  It is now thought that the"
PRINT "person most likely to still be in the Senator's foul clutches is the good Sir"
PRINT "Charles of Aknor, former counselor to the King."
PRINT
PRINT "You stand before the Senator's house.  It is a lonely edifice far from other"
PRINT "buildings or people.  It is almost midnight, and the house is still, though a"
PRINT "few lights still burn.  It is time to begin.  Good luck!"
PRINT : PRINT : GOTO KeyWait
Senator1:
s$ = "September 1995": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 20-30 min."
PRINT "Reviewer Rating: 5.0             Average Rating: 4.9/6"
PRINT
PRINT "Comment: This is a short and simple foray.  The map is that of a large house."
PRINT "There is very little in the way of special stuff to see or do.  There are about"
PRINT "15 guards named "; q$; "GUARD"; q$; "."
PRINT
PRINT "Still, I found it to be a solidly-crafted member of the "; q$; "hack'n'slash"; q$; " genre and"
PRINT "a pleasant play.  I give it a (3) for difficulty."
PRINT : PRINT : GOTO KeyWait
'
'            The Tower of London
'           -----------------------
Tower:
CLS
COLOR 15: a$ = SPACE$(20): FOR x = 1 TO 20: a$ = a$ + "* ": NEXT: PRINT a$
FOR x = 2 TO 20
   LOCATE x, 21: PRINT "*"; : LOCATE x, 59: PRINT "*"
NEXT
PRINT a$: LOCATE 3, 31: PRINT "Her Majesty's Palace";
LOCATE 4, 35: PRINT "and Fortress"; : LOCATE 5, 39: PRINT "of";
LOCATE 7, 32: COLOR 0, 7: PRINT " T H E  T O W E R ";
LOCATE 9, 32:  PRINT " O F  L O N D O N "; : COLOR 15, 0
LOCATE 12, 33: PRINT "Is the scene for";
LOCATE 13, 28: PRINT "-> Your next adventure <-";
LOCATE 17, 36: PRINT "Written by";
LOCATE 18, 31: PRINT "Fred and Sandy Smith";
FOR x# = 1 TO dly# * 10: NEXT
LOCATE 22, 1: COLOR 3: GOSUB KeyWait
PRINT "     Past and present often meet in the old historic streets of London."
PRINT "However, people still stare at you strangely.  You clank as you walk and the"
PRINT "weapons you carry are centuries out of date!"
PRINT
PRINT "     Because you've heard rumours of an impending attempt to steal the Crown"
PRINT "Jewels from the Tower of London, you decide to go there..."
PRINT
PRINT "     To prevent the theft?"
PRINT "            or"
PRINT "     To steal them for yourself!?!"
PRINT : PRINT : GOSUB KeyWait
PRINT "Note:  If I had already played this "; q$; "epic"; q$; " before I arranged the Eamon Deluxe"
PRINT "adventure lists, I may have been tempted to add it to "; q$; "Worst of the Classics"; q$; "."
PRINT "While all the descriptions are very well written, there is next to nothing to"
PRINT "do and it gets VERY boring.  -Frank Black"
PRINT : PRINT : GOTO KeyWait
Tower1:
s$ = "December 1995": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 4.0                Average Rating: 5.5/3"
PRINT
PRINT "Comment:  This is decidedly what you would call an "; q$; "educational"; q$; " Eamon.  It is a"
PRINT "tour of the Tower of London.  And I do mean "; q$; "tour"; q$; ".  I had the strong feeling"
PRINT "that it closely paralleled an actual trip that the Smiths had taken."
PRINT
PRINT "It's well written, with lots of detail.  I found it easy to visualize the things"
PRINT "they described.  So why the poor rating?  First, it is loaded with other"
PRINT "tourists and ghosts who decide to tag along with you.  By the time you've"
PRINT "explored 50 rooms, you literally have a screen full of companions.  "
PRINT : PRINT : GOSUB KeyWait
PRINT "Second, it is aimless.  There was no plot to steal jewels that I saw anywhere."
PRINT "Nobody cared who I attacked or what I took."
PRINT
PRINT "Still, it was a pretty good play, and I must point out that the other people who"
PRINT "rated it gave it a (6) or better.  I just wasn't very entertained.  I give it"
PRINT "(3) for difficulty."
PRINT : PRINT : GOTO KeyWait
'
'                 Death's Gateway
'                -----------------
Gateway:
GOSUB Title
PRINT "During the night of the last new moon, Locus the blacksmith disappeared."
PRINT "Red-Eye, the town drunk, says that he saw Locus lifted into the sky!  Of course,"
PRINT "hearty laughter greeted this crazy talk."
PRINT
PRINT "You searched the blacksmiths shop and uncovered a map with a cryptic note:"
PRINT q$; "Bring the gates here so that my pretty will be protected!"; q$
PRINT
PRINT "Following the directions shown on the map, you find the burnt ruins of a castle"
PRINT "keep.  Searching the ruins you find the smoldering body of poor Locus.  Nearby"
PRINT "you find a spiral staircase descending into the bowels of the earth."
PRINT : PRINT : GOSUB KeyWait
PRINT "As you stand there, wondering if going down is a very good idea, you see Yohab,"
PRINT "an adventurer you know from the Main Hall, scramble from the ruins!  As he"
PRINT "hurries away, you can't fail to notice that he has been stripped of all his"
PRINT "possessions!  How strange, only yesterday you saw him well armed, with a fine"
PRINT "suit of armor and an overflowing pouch of gold..."
PRINT : PRINT : GOTO KeyWait
Gateway1:
s$ = "March 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours "
PRINT "Reviewer Rating: 7.0    Average Rating: 6.5/2"
PRINT
PRINT "Comment: This is in many ways a mundane early version adventure.  On the other"
PRINT "hand, there are a lot of interesting effects and puzzles that are often pretty"
PRINT "funny.  There are two or three no-warning 'Gotcha!' death traps, so it would be"
PRINT "a good idea for you to save the game fairly often."
PRINT
PRINT "The basic 'quest' of this adventure is simply to escape, as you will find"
PRINT "yourself trapped once you enter the dungeon.  The theme of the adventure is to"
PRINT "win your way past a number of gates, each of which requires its own solution"
PRINT "(only one gate requires a key)."
PRINT
PRINT "This is a puzzler's adventure.  While there is quite a bit of combat, the"
PRINT "opponents aren't that tough and can be handled easily enough.  I give it a"
PRINT "difficulty rating of (6)."
PRINT : PRINT : GOTO KeyWait
'
'                 The Lair of Mutants
'                ---------------------
Lair:
GOSUB Title: COLOR 2: PRINT "Note:": COLOR 3: PRINT
PRINT "Although it is never mentioned, I believe all of the characters in this"
PRINT "adventure are from the DC Comics series, "; q$; "The New Gods"; q$; ", which was created,"
PRINT "written, and drawn by comics legend Jack "; q$; "King"; q$; " Kirby."
PRINT : PRINT SPC(60); "-Frank"
PRINT : PRINT : GOSUB KeyWait
PRINT "As you scan the lists of available quests at the Main Hall you are approached by"
PRINT "what appears to be a wizard.  "; q$; "You seem to be a brave and doughty warrior,"; q$; " he"
PRINT "says.  "; q$; "Could I enlist your help?  It is for the most dangerous mission any"
PRINT "adventurer has ever embarked upon.  Indeed, many have died in the attempt!  It"
PRINT "is an emergency and help is needed quickly!"; q$
PRINT
PRINT "Intrigued, you bid him continue."
PRINT
PRINT q$; "We are in deadly peril from the mutant masters,"; q$; " he says.  "; q$; "Slig and his"
PRINT "vicious brothers --Jaffar, Trok, Gole, Shaligo and Pyron-- supply mutant"
PRINT "warriors to the highest bidder.  They  have set up a complex here on Eamon."
PRINT "They strip the area of all life.  Those humans they don't kill outright they use"
PRINT "in their fiendish processes."; q$; "  The wizard sighs deeply."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "They have just delivered several thousand mutants to a Gorm warlord and are"
PRINT "busy mutating thousands more.  Normally harmless and common animals become"
PRINT "deadly killers.  Most are mindlessly obedient soldiers, too.  Some cannot be"
PRINT "bent to Slig's will and are of course killed."; q$
PRINT
PRINT q$; "Right now,"; q$; " the wizard says, "; q$; "they will be almost alone in their complex while"
PRINT "they mutate more soldiers.  If you leave today, you should be able to enter and"
PRINT "destroy the place before the soldiers are fully grown.  Once that happens, you"
PRINT "will never breach their defenses and they will overrun the planet, I fear."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "There is no one here who can help you as yet,"; q$; " he continues.  "; q$; "All of these"
PRINT "people here are too inexperienced.  Slig would kill them easily, and they would"
PRINT "probably get you killed too.  A number of veteran warriors have gone into that"
PRINT "lair...  None have returned.  If you don't have a large hardiness and"
PRINT "considerable experience, you too, will die.  I have no desire to send a whelp"
PRINT "fresh from the Beginners Cave to his death.  I will find someone else."; q$
PRINT : PRINT "Can you take this quest? (Y/N):";
Lair0:
f = 1: GOSUB KeyWait1: IF k$ <> "y" AND k$ <> "n" THEN GOTO Lair0
GOSUB Title

IF k$ = "n" THEN
  PRINT "The wizard says, "; q$; "I do not blame you."; q$; " and walks off to speak with another"
  PRINT "warrior.  You return to looking for a safer adventure."
  PRINT : PRINT : GOSUB KeyWait: RUN
END IF

PRINT q$; "Good!"; q$; " the wizard says.  He gives you an amulet and says, "; q$; "This will bring such"
PRINT "aid as I can find here when you first use it.  Hopefully some of the Guild's"
PRINT "champions will have returned by then.  The second time that you use it, it will"
PRINT "strengthen you.  To invoke its power, say the word 'HOSHIANU'."; q$
PRINT
PRINT "The wizard motions to a young lad and says, "; q$; "Ian here knows the way and will"
PRINT "guide you to the lair.  Time is short--  You must leave now.  Do not let Slig or"
PRINT "any of his five brothers survive your visit.  Remember the amulet in your time"
PRINT "of need!  Good luck!"; q$
PRINT : PRINT : GOSUB KeyWait
PRINT "It is a journey of several days over confusing terrain.  But early one day Ian"
PRINT "stops and points.  "; q$; "There,"; q$; " he says simply."
PRINT
PRINT "And so the adventure begins..."
PRINT : PRINT : GOTO KeyWait
'
'                 The Lair of Mutants review
'                ----------------------------
Lair1:
s$ = "September 1990": GOSUB Review1
PRINT "Reviewed by Henry Haskell"
PRINT
PRINT "Extra Commands: WORSHIP"
PRINT "Special Features: Magical Amulet"
PRINT "Playing Time: 60-90 min."
PRINT "Reviewer Rating: 7.0"
PRINT
PRINT "Comment: This adventure is quite long and tough, with few friends and much"
PRINT "combat.  Only a highly advanced warrior will live through it; Sam [a character"
PRINT "from the Eamon Deluxe Test Bench] will work fine.  I give it a (9) for"
PRINT "difficulty."
PRINT : PRINT : GOSUB KeyWait
PRINT "Although the combat is grueling, it is gratifying to see the mutant brothers'"
PRINT "empire collapse slowly as the result of your actions.  The mutant brothers are"
PRINT "skillfully painted in a hideously evil light; overall, "; q$; "The Lair of Mutants"; q$
PRINT "gives the appearance of a high-quality adventure, while still supplying bouts of"
PRINT "tough, exciting combat."
PRINT
PRINT "I would recommend this to a warmonger with a free hour or two."
PRINT : PRINT : GOTO KeyWait
'
'                 The Citadel of Blood
'                ----------------------
Citadel:
GOSUB Title
PRINT q$; "The place is cursed,"; q$; " said Olthen Bedwier about the Citadel of Blood.  "; q$; "I know"
PRINT "of too many adventurers who set off for there and never came back."; q$; "  He drained"
PRINT "his mug and changed the subject.  You found yourself most curious about this"
PRINT "strange place as you sat in the Main Hall with your comrades.  You wanted to"
PRINT "find out more..."
PRINT
PRINT "The Citadel, you discovered, was a huge castle that stood off quite a ways from"
PRINT "town surrounded by forest.  It was not known who built it or how it got there"
PRINT "but everyone just accepted the fact that it was there."
PRINT
PRINT "You heard confusing rumors and stories about it --tales of giant creatures and"
PRINT "armored beings that patrolled the castle and of fabulous wealth-- but you were"
PRINT "unsure how much was true."
PRINT : PRINT : GOSUB KeyWait
PRINT "You were especially interested to learn about the "; q$; "Serpent's Eyes"; q$; " (rubies said"
PRINT "to be very valuable), a solid platinum sundial, and the lost stone of seeking..."
PRINT "You also have heard tales of the great sword wielded long ago by the king who"
PRINT "dwelt in the Citadel.  All of this is rumored to be in the Citadel."
PRINT
PRINT "You have also heard tales of death, but they do not deter you.  Indeed, you soon"
PRINT "realize that you may not be the only one planning to visit the Citadel..."
PRINT
PRINT "Today you find yourself in the forest just north of the castle.  You see that"
PRINT "the drawbridge is down and the gate is open.  You realize that you can probably"
PRINT "come and go as you please, just as the tales you heard said...  All you have to"
PRINT "do is live long enough to get back to the gate and out of the Citadel of Blood!"
PRINT : PRINT : GOSUB KeyWait
PRINT "So you now gather up your courage and decide to find out just how much of the"
PRINT "stories you heard were true...  Especially the tales about the wealth beyond"
PRINT "belief!"
PRINT : PRINT : GOTO KeyWait
'
'                 The Citadel of Blood review
'                -----------------------------
Citadel1:
s$ = "March 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 5.0    Average Rating: 6.0/4"
PRINT
PRINT "Comment:  Here we have a basic "; q$; "Kill'n'Loot"; q$; " scenario with no quest and really"
PRINT "no puzzles.  You can make your own quest by seeking out the items named in the"
PRINT "introduction.  It would be classed as a Fantasy Eamon but for a gaggle of Sentry"
PRINT "Robots that were apparently lifted from Epyx's "; q$; "Rescue at Rigel"; q$; " game."
PRINT
PRINT "This is a nicely done example of an early Eamon.  The descriptions are"
PRINT "competently done, and the play has many special events that help keep the"
PRINT "interest up."
PRINT : PRINT : GOSUB KeyWait
PRINT "Among those specials are some apparently random trap doors that complicate"
PRINT "mapping by dumping you out of where you were exploring into pits in the dungeon,"
PRINT "but not unfairly nor dangerously.  But the added mapping complication, plus some"
PRINT "pretty tough bad guys, gives this Eamon a (7) for difficulty."
PRINT : PRINT : GOTO KeyWait
'
'             Museum of Unnatural History
'            -----------------------------
Museum:
GOSUB Title
PRINT "A short, stooped man walks up to your table and introduces himself as Professor"
PRINT "Thomias X. Larkspur - a physicist."
PRINT
PRINT q$; "I was working on an interdimensional translocator at the university when my"
PRINT "plans were stolen one night a few months ago.  This morning I read in the paper"
PRINT "that the palace police were baffled by the disappearance of the Eamon Museum of"
PRINT "Natural History on 1st Street and Main Hall Avenue."
PRINT
PRINT q$; "My assistant, Yrn Zandro, a Loathian from the Eamon West Archipelago, is also"
PRINT "gone.  I believe that he stole my plans, built a translocator, and warped the"
PRINT "museum out of this dimension for evil purposes."
PRINT
PRINT q$; "I have finally finished my machine and located the dimension containing the"
PRINT "museum.  Unfortunately my translocator will only transport one person to the"
PRINT "'other side.'"
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "It is impossible to determine what effect the translocation had on the museum"
PRINT "artifacts since other dimensions probably have different basic laws."
PRINT
PRINT q$; "I have talked to the museum Board of Directors and they said they will pay"
PRINT "5,000 gold pieces for the return of the museum and also a reward for each"
PRINT "artifact brought back."
PRINT
PRINT q$; "Um, one more thing.  You would be the third adventurer I've translocated today "
PRINT "- the others never returned!"
PRINT
PRINT q$; "Do you want to go?"; q$; "  (Y/N)"; : GOSUB KeyWait1
IF LCASE$(k$) = "n" THEN
  PRINT "The professor shakes his head in disappointment, pushes back his chair, and"
  PRINT "walks away.  You hear him ask other adventurers if they will translocate."
  PRINT : PRINT : GOSUB KeyWait: RUN
END IF
PRINT
PRINT "You quickly go to the university and enter the Professor's device.  He throws a"
PRINT "huge knife switch, and banks of lights and dials come to life.  He says, "; q$; "Here"
PRINT "goes!"; q$; " and presses a button."
PRINT
PRINT "You are assaulted by intense flashes of light and a deep thrum!  As from a"
PRINT "distance you hear the professor say, "; q$; "The main levels of the Museum are in the"
PRINT "shape of an 'H'!  Good luck! ... Well, I'd better find another adventurer"
PRINT "now..."; q$
PRINT : PRINT : GOTO KeyWait
'
'             Museum of Unnatural History review
'            ------------------------------------
Museum1:
s$ = "March 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1 hour "
PRINT "Reviewer Rating: 5.0    Average Rating: 6.0"
PRINT
PRINT "Comment: The map of this adventure is well-organized and well thought out."
PRINT "Basically, the objective is explore a museum until you find and destroy Zandro's"
PRINT "translocator.  Where the adventure falls down is that text descriptions of the"
PRINT "insides of museums are not necessarily all that fascinating to read.  However,"
PRINT "the monsters were generally interesting enough."
PRINT
PRINT "This is basically a hack'n'slash offering with a couple of puzzles thrown in."
PRINT "One of them is extremely obscure, so I will give a hint here: you will need a"
PRINT "bomb, and you ignite the bomb by saying a certain word that has to do with fire."
PRINT "Knowing this much, the clues that you discover should carry you through."
PRINT : PRINT : GOSUB KeyWait
PRINT "If not for this one puzzle it would have a difficulty rating of (4), but I give"
PRINT "the adventure an overall difficulty rating of (7)."
PRINT : PRINT : GOTO KeyWait
'
'                 Daemon's Playground
'                ---------------------
Daemon:
GOSUB Title
PRINT "You are on your way home after a strenuous day at the Main Gall (guzzling beer)."
PRINT "You pass by a park and see some children playing in a sand pile.  You step"
PRINT "closer and see that tiny buildings are connected by roads of dried mud and"
PRINT "sticks serve as vegetation.  A river is formed by a child pouring water from a"
PRINT "bucket onto the higher part of the pile."
PRINT
PRINT "Just then a huge daemon materializes and trains a strange rod on the frightened"
PRINT "children.  You gallantly fling your body in front of the rod and a bright red"
PRINT "light engulfs you!"
PRINT
PRINT "Your last sight is of the children escaping and the daemon grinning evilly!"
PRINT : PRINT : GOTO KeyWait
'
'                 Daemon's Playground review
'                ----------------------------
Daemon1:
s$ = "March 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min."
PRINT "Reviewer Rating: 4.0    Average Rating: 4.7/3"
PRINT
PRINT "Comment: This is a fairly simple hack'n'slash' foray.  You just wander around,"
PRINT "killing everyone you meet and gather up four unhidden keys needed to pass four"
PRINT "gates to escape."
PRINT
PRINT "I expected to be placed in the children's play village, but the place seemed"
PRINT "normal (by Eamon standards), with full-size monsters."
PRINT
PRINT "This is a quick, easy play, suitable for young Eamonauts.  All of the monsters"
PRINT "were easily beaten in two rounds of combat with my magic weapons, so if you"
PRINT "enjoy combat, you'll want to use weapons from Marcos for the outing."
PRINT : PRINT : GOTO KeyWait
'
'                   Caverns of Lanst
'                  ------------------
Lanst:
GOSUB Title
PRINT "The noted archaeologist, Dr. Andrew Whitehead, walks up to your table in the"
PRINT "Main Hall and asks if he could talk to you.  Being between adventures and a"
PRINT "little bored, you nod and invite him to sit down."
PRINT
PRINT "He says, "; q$; "You have been well recommended as an experienced adventurer and I"
PRINT "would like to hire you as a guide.  I plan to explore the Caverns of Lanst in"
PRINT "search of artifacts of the fabled Lanstians.  My research indicates that the"
PRINT "Caverns were inhabited many centuries ago by a civilization of great"
PRINT "capabilities!"
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "I've prepared a standard contract"; q$; ", he says as he passes over a legal-looking"
PRINT "paper.  You look it over and it says:"
PRINT
PRINT "     1.  I will guide Dr. Whitehead through the Caverns of Lanst."
PRINT "     2.  I will give all artifacts of indicated archeological value to "
PRINT "         Doctor whitehead."
PRINT "     3.  All non-archeological artifacts are mine to keep or sell."
PRINT "     4.  Dr. Whitehead's suggestions will be considered in all decisions."
PRINT "     5.  I will receive 5,000 gold pieces when the party returns to the Main "
PRINT "         Hall."
PRINT
PRINT "Do you sign? (Y/N) "; : GOSUB KeyWait1
IF LCASE$(k$) = "n" THEN
  PRINT "Dr. Whitehead shakes his head in disappointment, pushes back his chair, and"
  PRINT "walks away.  You hear him ask other adventurers if they will guide him."
  PRINT : PRINT : GOSUB KeyWait: RUN
END IF

PRINT "Dr. Whitehead takes the contract, looks it over, smiles, and shakes your hand."
PRINT "He says, "; q$; "Give me a few minutes to get my stuff together and I'll meet you by"
PRINT "the door!"; q$; " as he hurries away."
PRINT
PRINT "You down several drinks (the fine print said no hooch on the expedition) and"
PRINT "amble out to the gate where the Doctor is waiting impatiently.  You pick up some"
PRINT "of the supplies and head off down the road."
PRINT
PRINT "After many days of following old maps and weary searching you find the Caverns"
PRINT "of Lanst!"
PRINT : PRINT : GOTO KeyWait
'
'                   Caverns of Lanst review
'                  -------------------------
Lanst1:
s$ = "March 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Special Features: 10-directions"
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 6.0"
PRINT
PRINT "Comment: This is a very large adventure for its time, with 93 rooms and an"
PRINT "adequate number of artifacts.  The ten-direction map is quite complex, but holds"
PRINT "no nasty surprises.  I came across a few traps that triggered a "; q$; "narrow escape"; q$
PRINT "special effect rather than actual death, which was a nice touch.  There are"
PRINT "several possible endings, depending on how well you fulfill your contract"
PRINT "obligations."
PRINT : PRINT : GOSUB KeyWait
PRINT "The scenario takes place in an ancient, abandoned location which doesn't have"
PRINT "much to offer in the way of opponents for combat.  Rick compensates for this by"
PRINT "sprinkling looters throughout the complex.  They felt somewhat contrived and in"
PRINT "my opinion added very little to the adventure, but there would have been no"
PRINT "combat at all without them."
PRINT
PRINT "While the adventure was well written, it lacked a plot or any puzzles to solve."
PRINT "The "; q$; "quest"; q$; " consisted of wandering about, picking up artifacts and fighting off"
PRINT "looters.  If there had been more content or variety, it could easily have"
PRINT "garnered a higher rating.  With no puzzles nor difficult encounters but with a"
PRINT "challenging map, it gets a (5) for difficulty."
PRINT : PRINT : GOTO KeyWait
'
'                    Priests of Xim!
'                   -----------------
Xim:
GOSUB Title
LOCATE 7: COLOR 14
PRINT "                    Welcome to the Priests of Xim!"
PRINT : COLOR 3
PRINT "As you travel through the tomb, you will encounter many powerful enemies."
PRINT "However, the rewards will far outweigh the costs."
PRINT : PRINT : GOTO KeyWait
'
'                    Priests of Xim!
'                   -----------------
Xim1:
s$ = "March 1994": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Extra Commands: PRAY, BUY"
PRINT "Playing Time: 1-2 hours "
PRINT "Reviewer Rating: 4.0    Average Rating: 5.7/3"
PRINT
PRINT "Comment: This is straight kill'n'loot with a handful of locked doors to open."
PRINT "Contrary to the intro, the bad guys are medium-to-lightweight and sometimes"
PRINT "decide to ignore you after first presenting a very hostile description."
PRINT
PRINT "The "; q$; "homage"; q$; " that you must pay to enter is 70% of all your gold.  I managed to"
PRINT "scrounge together less than 4,000 GP of loot, or about 32,000 GP short of what I"
PRINT "was charged to enter the tomb."
PRINT : PRINT : GOSUB KeyWait
PRINT "I found this to be a mediocre offering largely because the authors threw"
PRINT "whatever popped into their heads into the dungeon map, which makes very little"
PRINT "sense and has lots of incongruities. It is painfully obvious that they were"
PRINT "running out of ideas and patience in the last quarter of the dungeon, which is"
PRINT "decidedly poorer in quality than the first half, which is pretty darned good."
PRINT
PRINT "If the entire dungeon was up to the standards of the beginning, this would be a"
PRINT "real keeper.  But instead it winds down to what I felt was a disappointing"
PRINT "ending.  Still, you should note that the average rating is quite a bit higher"
PRINT "than mine, indicating that several people enjoyed it more than I did."
PRINT : PRINT : GOTO KeyWait
'
'                Escape from the Orc Lair
'               --------------------------
OrcLair:
GOSUB Title
PRINT "Boy do you feel good as you go looking for a new adventure!  Striding down a"
PRINT "nearby dark alley, you feel so energetic that you almost don't feel it when you"
PRINT "are clubbed in the head by a group of orcs."
PRINT
PRINT "You wake up very groggy sometime later and you hear part of one of their"
PRINT "conversations."
PRINT
PRINT "Voice #1:  "; q$; "It won't be long before we have enough captives!"; q$
PRINT
PRINT "Voice #2:  "; q$; "I just hope we make enough ransom money, or I will have your"
PRINT "            head, Grishnakh!"; q$
PRINT
PRINT "Unfortunately, you lapse into unconsciousness again, but you realize without"
PRINT "much difficulty that it is your duty to escape and warn the Guild, before it"
PRINT "meets certain ruin!"
PRINT : PRINT : GOTO KeyWait
'
'                Escape from the Orc Lair review
'               ---------------------------------
OrcLair1:
s$ = "June 1994": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 20-30 min. "
PRINT "Reviewer Rating: 4.0    Average Rating: 3.8/4"
PRINT
PRINT "Comment: This adventure is a Hack'n'Slasher's delight.  There are 3 potential"
PRINT "allies and 60 bad guys.  There are only a half-dozen artifacts that aren't"
PRINT "monster weapons!"
PRINT
PRINT "This is a smallish, 48-room dungeon.  There are no puzzles nor complex actions"
PRINT "to complete.  Simply hack your way through the bad guys and exit the dungeon."
PRINT
PRINT "The bad guys aren't all that tough, and this is a walk-through for anyone with"
PRINT "decent stats and weapons.  I give it a difficulty of (3); probably a good choice"
PRINT "for the Young Eamonaut."
PRINT : PRINT : GOTO KeyWait
'
'              Behind the Sealed Door
'             ------------------------
Door:
GOSUB Title
PRINT "Hearing legends about a huge city, filled with strange, powerful weapons and"
PRINT "priceless treasures, you make your way to a little used path going east."
PRINT
PRINT "From what you've heard, many adventurers have sought out this city only to never"
PRINT "be seen again, some have even said (in the Main Hall) that each adventurer might"
PRINT "have been the victim of foul play ... though from whom no one is quite sure."
PRINT
PRINT "On the dawn of the second day you see a familiar face come galloping up on his"
PRINT "horse.  It is the Night Marshal (in the day time hours?)."
PRINT
PRINT q$; "Ho,"; q$; " he calls, "; q$; "I am to lead you to the place of the legend!"; q$; " and with that he"
PRINT "walks off to a large jungle area you had seen some distance away.  No sooner"
PRINT "does he enter the jungle than do you lose sight of him."
PRINT : PRINT : GOSUB KeyWait
PRINT "It is about this time that you notice that the plants smell funny.  As soon as"
PRINT "you realize this your senses reel.  Just then you see the Night Marshall appear"
PRINT "out from behind a bush with an evil smile on his face.  Slowly he begins to move"
PRINT "towards you, forcing you backwards.  Then as you pass a huge bush you find"
PRINT "that you are in a strange land, next to a shimmering portal..."
PRINT : PRINT : GOTO KeyWait
'
'              Behind the Sealed Door review
'             -------------------------------
Door1:
s$ = "March 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours"
PRINT "Reviewer Rating: 4.0    Average Rating: 4.7/3"
PRINT
PRINT "Comment: Like Tim's other Eamons, this one has a strong theme that evokes"
PRINT "interesting images in your mind's eye. The gimmick here is a series of "; q$; "crystal"
PRINT "barriers"; q$; " and mirrors that can mess up your map if you're not careful.  There is"
PRINT "a gizmo that can break the barriers, but until you find it, many paths will be"
PRINT "closed in front or behind you. Once you begin passing the barriers, it can get"
PRINT "confusing in this 90-plus-room dungeon."
PRINT : PRINT : GOSUB KeyWait
PRINT "All in all, there wasn't a lot of content beyond the barriers.  All of the"
PRINT "monsters except one were one-hit pushovers for my magic sword.  That one was so"
PRINT "strong that I elected to FLEE until I lost him.  There are quite a number of"
PRINT "spelling errors; if that tends to bother you a lot, you might want to pass this"
PRINT "one by.  [Fixed in the Eamon DX version. -FK]"
PRINT
PRINT "But for tricky mapping and the tough guy, this was a walk-through, and gets (3)"
PRINT "for difficulty.  However, even though it's easy, the map may make this a poor"
PRINT "choice for young Eamonauts."
PRINT : PRINT : GOTO KeyWait
'
'             The Caves of Eamon Bluff
'            --------------------------
Bluff:
GOSUB Title
PRINT "As you leave the Main Hall a white horse comes to you and seems to nod in your"
PRINT "direction.  As you draw close to it you hear it say, "; q$; "My master desires your"
PRINT "services, come with me."; q$; "  It then and beckons for you to climb up on it."
PRINT
PRINT "The horse takes you for some distance to the south before stopping at a group of"
PRINT "bushes, just in front of a large cave.  As you get down from the horse and wait"
PRINT "for a few minutes."
PRINT
PRINT "As you stand there, you see the Knight Marshal come out from behind one bush."
PRINT "You can see from his clothing that he's been in some sort of fight."
PRINT : PRINT : GOSUB KeyWait
PRINT "He looks you up and down and then says, "; q$; "Great evil has infested one of Eamon's"
PRINT "best caverns.  I was too late in getting people to help destroy the evil, but I"
PRINT "see"; q$; " --(and he looks at you)-- "; q$; "that at least one person might be able to help"
PRINT "me.  I will even come along if you agree to help."; q$
Bluff0:
PRINT : PRINT
PRINT "Do you go along or go back to the Main Hall.  (G)o or (L)eave?  (G/L):";
GOSUB KeyWait1: IF k$ <> "g" AND k$ <> "l" THEN GOTO Bluff0

IF k$ = "l" THEN
  PRINT "Seeing that you haven't agreed, he seems to groan and then begins to wave his"
  PRINT "arms in the air.  After awhile the white horse reappears and you watch as it"
  PRINT "bends down to you, allowing you to mount and leave."
  PRINT : PRINT : GOSUB KeyWait: RUN
END IF

PRINT "Seeing that you have agreed the Marshal goes back to his bush, gets his gear,"
PRINT "and stands ready..."
PRINT : PRINT : GOTO KeyWait
'
'           The Caves of Eamon Bluff review
'          ---------------------------------
Bluff1:
PRINT "Average Rating: 6.8/3": PRINT
PRINT "The Caves of Eamon Bluff was reviewed in the May 1985 issue of the NEUC"
PRINT "newsletter but it was a strange and non-standard review which said little to"
PRINT "nothing about the adventure.  Therefore I didn't include the review."
PRINT : PRINT SPC(70); "-Frank"
PRINT : PRINT : GOTO KeyWait
'
'                 The Land of Death
'                -------------------
LDeath:
GOSUB Title
PRINT "You are led by the Knight Marshal to a long path stretching far off into the"
PRINT "east.  In the distance you see a huge obelisk which the Knight Marshall says is"
PRINT "the "; q$; "Pillar of Time"; q$; "."
PRINT
PRINT q$; "Many people,"; q$; " he says, "; q$; "have come this route never to return.  Good luck."; q$; " as"
PRINT "he slowly turns and leaves."
PRINT
PRINT "Walking towards the east, you soon find yourself before a huge fifty-meter"
PRINT "obelisk.  As you draw close to it you see an inscription."
PRINT : PRINT : GOSUB KeyWait: PRINT : PRINT : COLOR 14

a$ = "HAIL": GOSUB Center: a$ = "ALL THOSE": GOSUB Center: a$ = "WHO COME THIS WAY!"
GOSUB Center: a$ = "WOE BE TO THOSE WHO SPEAK": GOSUB Center
a$ = "THE ANCIENT WORDS": GOSUB Center
a$ = "AND DESECRATE THIS MOST HONORED SHRINE": GOSUB Center
a$ = "LO THE PROPHET OF": GOSUB Center
a$ = "TIME, JOHN COOPER, HAS SPOKEN!!": GOSUB Center
COLOR 3: PRINT : PRINT : GOSUB KeyWait: PRINT : PRINT : PRINT

PRINT "Casually you turn to leave even as you hear a voice say, "; : COLOR 14
PRINT q$; "Cooper's revenge is"
PRINT "upon you, foolish mortal!"; q$: COLOR 3
PRINT : PRINT : GOSUB KeyWait

PRINT "After you hear this you feel vertigo and a sudden blast of air which seems to"
PRINT "grab hold of you.  You try to resist but it proves futile as you are pulled"
PRINT "towards the pillar!"
PRINT
PRINT "All at once you feel very strange and are immediately thrust forward into the"
PRINT "pillar.  For an instant you think all is lost, but as you open your eyes you"
PRINT "find yourself alive but falling through an endless void..."
'cool effects
PRINT : PRINT : GOTO KeyWait
'
'                 The Land of Death review
'                --------------------------
LDeath1:
s$ = "March 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours "
PRINT "Reviewer Rating: 6.0"
PRINT
PRINT "Comment:  Basically, you find yourself in a rather odd city with overhead"
PRINT "railroads, magical mists, and lots of cryptically inscribed obelisks.  The basic"
PRINT "thrust of this adventure is to explore the city and find a way back to the Main"
PRINT "Hall."
PRINT
PRINT "The city is loaded with fascinating objects and clues and seems to promise a lot"
PRINT "of interesting puzzles and special effects.  Every few rooms you run across yet"
PRINT "another inscribed obelisk with passages like this one: "; q$; "THAT WHICH IS SEALED IN"
PRINT "CRYSTAL CONTAINS THE POWER TO RELEASE THE FROZEN."; q$; "  Unfortunately, nearly all of"
PRINT "it is fluff-- "; q$; "color"; q$; " and "; q$; "atmosphere"; q$; " pieces that actually have nothing to do"
PRINT : PRINT : GOSUB KeyWait
PRINT "with solving the adventure.  At least, if more puzzles existed, I couldn't find"
PRINT "them and didn't need them for anything.  There is no indication of success or"
PRINT "failure at the end of the game, so I conclude that the only true objective is"
PRINT "escape."
PRINT
PRINT "Even so, the atmosphere is well done and interesting to read.  It fails on two"
PRINT "counts:  First, it has dozens and dozens of stupid spelling errors.  [Note: This"
PRINT "was fixed in the Eamon Deluxe conversion. -Frank]  second, and in my opinion "
PRINT "much more damaging failing is that it has about a half-dozen death traps."
PRINT
PRINT "I give it a difficulty rating of (6).  While there is very little that is"
PRINT "actually challenging, the map is pretty complex and the death traps do offer"
PRINT "minimal warning once you have fallen into one and know what they are.  I feel"
PRINT "that it is worth playing for the interesting descriptions and map, but there is"
PRINT "little combat and only one puzzle."
PRINT : PRINT : GOTO KeyWait
'
'                   House on Eamon Ridge
'                  ----------------------
House:
GOSUB Title: GOSUB House1
PRINT "Hearing tales of great adventure in a place called Eamon Bluff, you set off to"
PRINT "find this ancient place"
PRINT
PRINT "For two days you travel, then as you are about to arrive, you encounter a fog"
PRINT "bank in the place where you think Eamon Bluff is."
PRINT
PRINT "You come upon two paths thick in fog.  One leads through an old cemetery and"
PRINT "past a well with the sound of distant waves crashing on a shore nearby.  The"
PRINT "other path goes deeper into the fog and a deathly silence overtakes you some"
PRINT "distance from the fork before you go back (as you had done on the other path.)"
PRINT
Ridge0:
COLOR 2: PRINT "Do you want to:": PRINT
PRINT "Go B)ack the way you came, T)hrough the cemetery or I)nto the fog?";
COLOR 3: GOSUB KeyWait1
IF k$ <> "b" AND k$ <> "t" AND k$ <> "i" THEN GOTO Ridge0
OPEN "HOUSE.DAT" FOR OUTPUT AS #1
'
IF k$ = "b" THEN
  PRINT #1, 1: CLOSE
  PRINT "As you turn to leave you hear someone say, "; q$; "Aye Matey!  And here be another"
  PRINT "one."; q$; " and someone hits you from behind."
  PRINT
  PRINT "You wake up in a cell, stripped of everything you were carrying.  From the way"
  PRINT "the bed rocks, you must be in some type of ship.  You can see your jailer,"
  PRINT "however the door is open and he look's asleep!"
  PRINT : PRINT : GOTO KeyWait
END IF
IF k$ = "t" THEN
  PRINT #1, 2: CLOSE
  PRINT "You head into the fog and feel the grip of strong magic.  There is a hideous"
  PRINT "laugh and then you open your eyes, as if you had been sleeping, and ... you find"
  PRINT "yourself before a huge structure which looms in front of you.  Then someone"
  PRINT "pushes you from behind and everything goes black..."
  PRINT : PRINT : GOTO KeyWait
END IF
IF k$ = "i" THEN
  PRINT #1, 3: CLOSE
  PRINT "You go into the fog and feel the grip of arcane evil magic.  It touches you for"
  PRINT "an instant and then you find yourself in a strange place..."
  PRINT : PRINT : GOTO KeyWait
END IF
'
'                   House on Eamon Ridge Review
'                  -----------------------------
House1:
COLOR 2: PRINT "Notes:": COLOR 3
PRINT
PRINT q$; "House on Eamon Ridge"; q$; " was reviewed in the December, 1996 issue of the EAG"
PRINT "newsletter.  However, Tim Berge never finished this adventure and the review"
PRINT "noted that, as well as many problems dealing with the unfinished version.  For"
PRINT "that reason I'm not including the review here."
PRINT
PRINT "I have finished this adventure to the best of what I gathered Tim was intending."
PRINT "I also straightened up the map, cleaned up the descriptions, patched plot"
PRINT "errors, reset monster and artifact values, and I added a few minor touches of my"
PRINT "own in the process.  Not a lot, mind you, this is still mainly Tim's adventure."
PRINT "However, I did so much work getting it up and running that I felt I deserved"
PRINT "deserved co-author credit."
PRINT : PRINT : GOSUB KeyWait
PRINT "It is a pretty good adventure for the time period in which it was written and I"
PRINT "hope you enjoy it."
PRINT
PRINT SPC(61); "-Frank Black"
PRINT
PRINT "One hint:  When you start the adventure, you should choose the first option, to"
PRINT q$; "Go B)ack the way you came"; q$; " for a more interesting adventure."
PRINT : PRINT : GOTO KeyWait
'
'              The Life-Orb of Mevtrelek
'             ---------------------------
LifeOrb:
GOSUB Title
COLOR 2: PRINT "Adventure difficulty: "; : COLOR 14: PRINT "Intermediate": COLOR 3
PRINT : PRINT
PRINT "You are anticipating a few mugs of ale and a soft bed after returning from a"
PRINT "difficult adventure.  You sit down at your usual table and then become aware of"
PRINT "the strange absence of conversation."
PRINT
PRINT "Most of the patrons, though seemingly immersed in their cups, are staring at"
PRINT "you.  The rest are looking at a small, wizened man half-hidden in a dim corner."
PRINT
PRINT "The dark robe and high collar indicate that the man is a sorcerer and the single"
PRINT "spiral worked in silver thread is the badge of apprenticeship."
PRINT : PRINT : GOSUB KeyWait
PRINT "Eyes quickly turn away as the muffled figure approaches you and silently sits"
PRINT "down.  A hand, dark with age, rises and slowly pushes the cowl back.  The"
PRINT "wrinkled, bald head contains a pair of cold, black eyes and a near-lipless"
PRINT "mouth."
PRINT
PRINT q$; "I am Kulath, apprentice to the Magician Mevtrelek A'Haet.  He has sent me here"
PRINT "to engage the services of an experienced adventurer.  I have had little success"
PRINT "with those you see here.  They all say you would be the most appropriate"
PRINT "choice."; q$
PRINT
PRINT "Though you silently curse the generous recommendations of the others, the name"
PRINT "of one of Eamon's most powerful mages excites your curiosity, and, of course,"
PRINT "your well-known avarice.  You nod at the wizard to continue."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "Recently, strange disturbances in the usual order of things have occurred.  The"
PRINT "most timid of animals attack those who come near.  Fields are ravaged at night"
PRINT "and dogs howl during the day.  Lightning appears in cloudless skies and thunder"
PRINT "is heard beneath the ground."
PRINT
PRINT q$; "Mevtrelek was attempting to determine the cause of this chaos when his Life-Orb"
PRINT "disappeared in a flash of red light.  He was able to trace its location before"
PRINT "becoming too weak to continue."
PRINT
PRINT q$; "Now bed-ridden, he is losing strength day-by-day and will surely fail soon"
PRINT "unless the Orb is returned.  My presence is needed here to care for Mevtrelek,"
PRINT "else I would go."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "We are prepared to pay the successful adventurer 5000 gold pieces upon his"
PRINT "return!"
LifeOrb0:
PRINT
PRINT q$; "There is great danger and little time.  Will you go?"; q$; "  (Y/N):";
GOSUB KeyWait1: IF k$ <> "y" AND k$ <> "n" THEN GOTO LifeOrb0

IF k$ = "n" THEN
  PRINT "Kulath walks away.  Later you hear that the Orb was recovered by another"
  PRINT "adventurer.  Meanwhile an economic panic resulted in the loss of all of your"
  PRINT "gold!"
  PRINT : PRINT : GOSUB KeyWait: RUN
END IF

PRINT q$; "A wise choice, "; name$; "!"; q$
PRINT
PRINT "Kulath leads you to his nearby rooms and carefully locks the door.  He chants a"
PRINT "short incantation and the air becomes hazy."
PRINT
PRINT q$; "Just a de-scrying spell to confuse the sight of any enemies.  Now, take this"
PRINT "amulet and wear it.  Then quickly memorize the spells in this book."; q$
PRINT
PRINT "He hands you a small, thin book which contains but two spells: STEALTH and SEEK."
PRINT "You have no trouble learning them but there is also no explanation of their"
PRINT "effects."
PRINT
PRINT "You lay the book down and turn to Kulath to ask him about the spells when he"
PRINT "shouts, "; q$; "Now!"; q$; ", and his room disappears.  A moment of disorientation and you"
PRINT "reappear in the midst of a dark forest..."
PRINT : PRINT : GOTO KeyWait
'
'              The Life-Orb of Mevtrelek review
'             ----------------------------------
LifeOrb1:
s$ = "June 1986": GOSUB Review1
PRINT "Reviewed by Bob Davis"
PRINT
PRINT "Extra Commands:  STEALTH, SEEK"
PRINT "Average Rating:  6.0/3"
PRINT
PRINT "Comment:  This adventure has good room descriptions, interesting situations and"
PRINT "kept me enthralled with the story.  I was always asking myself how each item or"
PRINT "new event fit into the plot and what I could deduce from the extra knowledge.  I"
PRINT "liked the special effects, but unfortunately cannot even hint at them lest I"
PRINT "spoil the fun/surprise/etc."
PRINT
PRINT "The good points outweigh the bad points and I recommend this adventure to all,"
PRINT "experienced and inexperienced alike.  I believe with a cautious effort, a"
PRINT "beginning character can complete this mission."
PRINT : PRINT : GOTO KeyWait
'
'                 The Halls of the Adept
'                ------------------------
Adept:
GOSUB Title
PRINT "Whilst partaking of the offerings of the Main Hall, you find several of the"
PRINT "King's Guard surrounding you."
PRINT : n$ = "Brave " + name$: IF sex = 1 THEN n$ = "Fair " + name$
a$ = "The Captain of the Guard says, " + q$ + n$ + " the King has need of your "
a$ = a$ + "services.  Come with us if you desire great adventure for a great "
a$ = a$ + "reward.  If not, we will seek another." + q$
GOSUB Lp0: PRINT : PRINT "Of course, you agree."
PRINT : PRINT : GOSUB Adept01
FOR y = 1 TO 80
   FOR x = 1 TO 24
      LOCATE x, y: PRINT " ";
   NEXT
   FOR x# = 1 TO dly# / 10: NEXT
NEXT

GOSUB Title
n$ = "Brave": IF sex = 1 THEN n$ = "Fair"
a$ = "The Captain and guards have escorted you to the King's hall.  Two guards in "
a$ = a$ + "red crystal armor bar your way, yet you hear a growl from inside the "
a$ = a$ + "chamber, saying:  " + q$ + "Fools, let this " + n$ + " warrior enter!" + q$
GOSUB Lp0: PRINT
PRINT "The guards allow you to enter, the King taking note of you as you walk in."
PRINT
PRINT "The king informs you, "; q$; "The beautiful Princess Aeriel has been kidnapped by an"
PRINT "evil Adept."
PRINT
PRINT q$; "This seems bad enough, but it is worse, because a war may break out if she is"
PRINT "not returned in time to marry the barbarous King of the Northern Reaches."
PRINT
PRINT q$; "It is said this King has the aid of demon magic, and Eamon would be destroyed"
PRINT "if you fail."; q$
PRINT : PRINT : GOSUB Adept01
FOR y = 80 TO 1 STEP -1
   FOR x = 1 TO 24
      LOCATE x, y: PRINT " ";
   NEXT
   FOR x# = 1 TO dly# / 10: NEXT
NEXT

GOSUB Title
PRINT "The king offers you a reward of 7500 gold pieces for Aeriel's Return, and"
PRINT "another 2500 for the Adept's body.  And, of course, you may keep whatever you,"
PRINT "well, "; q$; "acquire"; q$; " while questing."
PRINT
PRINT "He gives you provisions and a horse, but cannot send another man with you at"
PRINT "this time, as they are preparing for war, in case the worst comes to pass."
PRINT
PRINT "He sends you on your way and says, "; q$; "May the Gods of Eamon be with you!"; q$
PRINT : PRINT : GOSUB Adept01
l = 0
FOR y = 41 TO 1 STEP -1
   l = l + 2
   FOR x = 1 TO 24
      LOCATE x, y: PRINT SPC(l);
   NEXT
   FOR x# = 1 TO dly# / 10: NEXT
NEXT
GOTO Title
'
'             The Halls of the Adept Review
'            -------------------------------
Adept1:
s$ = "March 1993": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Extra Commands: SIT, STAND"
PRINT "Special Features: 10-directions, secret door screen effects"
PRINT "Playing Time: 30-60 min."
PRINT "Reviewer Rating: 7.0"
PRINT
PRINT "Comment:  After a lapse of 150 adventures, Tim Berge rises from the dead with a"
PRINT "quite competent offering.  It is simply jammed with nonstop specials and"
PRINT "effects.  This adventure has all the right elements: a clear quest, interesting"
PRINT "companions and foes, magical devices, and some minor puzzling."
PRINT : PRINT : GOSUB KeyWait
PRINT "The POWER spell is loaded with special stuff that you won't want to miss."
PRINT "There's a (literally) fire-breathing companion that makes combat rather more"
PRINT "interesting.  There is a special screen gimmick for secret doors that I really"
PRINT "enjoyed.  There are a number of random traps, but most are not fatal."
PRINT
PRINT "I guess I give it a (6) for difficulty.  This one is worth a play for all the"
PRINT "specials; they are pretty neat."
PRINT : PRINT : GOTO KeyWait

'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version."
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN

'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$
BS = POS(0): CC# = 0
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""
k$ = LCASE$(k$): IF f = 1 THEN f = 0: RETURN
'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN

'
' Center a string on 80-column screen
'
Center:
PRINT SPC((79 - LEN(a$)) / 2); a$: RETURN

'------------------------------
' Print a$ without wrap-around
'------------------------------
Lp0:
xm = 0: a$ = LTRIM$(a$)
IF LEN(a$) <= 79 THEN PRINT a$:  RETURN
FOR k = 79 TO 1 STEP -1
   IF MID$(a$, k, 1) = " " THEN
     PRINT LEFT$(a$, k - 1): a$ = RIGHT$(a$, LEN(a$) - k): k = 1: xm = 1
   END IF
NEXT: IF xm = 1 THEN GOTO Lp0
'        --------------------------------
'         Emulate Apple II SPEED command
'        --------------------------------
SlowPrint:
FOR x = 1 TO LEN(a$)
   PRINT MID$(a$, x, 1);
   FOR x1# = 1 TO a#: NEXT
NEXT
PRINT : RETURN
'
'    Halls of the Adept promt
'
Adept01:
PRINT SPC(30); "(Hit any key)"
k$ = INKEY$
DO
   k$ = INKEY$
LOOP UNTIL k$ <> ""
RETURN

'--------------------------------------------
' Can't initialize graphics screen
'--------------------------------------------
ScreenError:
SCREEN 0: WIDTH 80: CLS : Island = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the graphic map of "; q$; "Treasure Island"; q$; ", because it"
PRINT "requires an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME Start


'
' Adventure data
'
AdventureData:
DATA 21
DATA The Magic Kingdom,"David Cook & Frank Black",KINGDOM
DATA Caves of Treasure Island,Geoffrey Genz & Paul Braun,T-ISLAND
DATA Furioso,William Davis,FURIOSO
DATA Merlin's Castle,Randall Hersom,MERLIN
DATA Hogarth Castle,Ken Nestle,HOGARTH
DATA The Senator's Chambers,James Plamondon,SENATOR
DATA The Tower of London,Fred & Sandy Smith,TOWER
DATA Death's Gateway,Bob Linden,GATEWAY
DATA The Lair of Mutants,Evan Hodson,LAIR
DATA The Citadel of Blood,Evan Hodson,CITADEL
DATA Museum of Unnatural History,Rick Volberding,MUSEUM
DATA Daemon's Playground,Rick Volberding,DAEMON
DATA Caverns of Lanst,Rick Volberding,LANST
DATA Priests of Xim!,Marty & Ed Bauman,XIM
DATA Escape from the Orc Lair,Jay Hinkelman,ORCLAIR
DATA Behind the Sealed Door,Tim Berge,DOOR
DATA The Caves of Eamon Bluff,Tim Berge,BLUFF
DATA The Land of Death,Tim Berge,LDEATH
DATA House on Eamon Ridge,"Tim Berge & Frank Black",HOUSE
DATA The Life-Orb of Mevtrelek,Rick Volberding,LIFEORB
DATA The Halls of the Adept,"Tim Berge and Johnathan Thomas Cottingham",ADEPT

EDXMenuStrings:
DATA 4
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Quit "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
IF k = 4 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>                     <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB Treasure.Island.Map
SCREEN 7
'COLOR 1: LINE (0, 180)-(320, 180): PAINT (0, 0)
COLOR 14: LOCATE CSRLIN, 12: PRINT "TREASURE ISLAND": PRINT
COLOR 7: PRINT "L=Landing point"; : LOCATE CSRLIN, 31: PRINT "=Jungle"
PRINT "P=Pick up point"
LOCATE CSRLIN, 31: PRINT "=Lake": PRINT
LOCATE CSRLIN, 31: PRINT "=Beach"
CIRCLE (225, 20), 11, 6, , , .5: PAINT (225, 20), 2, 6
CIRCLE (225, 35), 11, 6, , , .5: PAINT (226, 36), 1, 6
CIRCLE (225, 50), 11, 6, , , .5: PAINT (225, 50), 14, 6
'
COLOR 15: LOCATE 10: a$ = "Volcano"
FOR x = 1 TO 7: LOCATE CSRLIN, 38: PRINT MID$(a$, x, 1): NEXT
LOCATE 11, 2: PRINT "L"
LOCATE 21, 4: PRINT "Whaler's Cove"; : LOCATE CSRLIN, 27: PRINT "P"
DRAW "B M292,85 C15 G8 R1 E8 G8 L1 U5 D5 R6"  '
DRAW "B M104,157 C15 H8 L1 F8 H8 D5 U5 R6 L6" ' Arrows
'
'Draw island
'
COLOR 6
LINE (20, 70)-(20, 100): LINE (29, 55)-(20, 70): LINE (65, 43)-(29, 55)
LINE (65, 43)-(105, 43): LINE (105, 43)-(113, 48): LINE (113, 48)-(125, 70)
LINE (125, 70)-(125, 75): LINE (124, 75)-(160, 70): LINE (160, 70)-(165, 70)
LINE (165, 70)-(185, 75): LINE (185, 75)-(265, 80): LINE (265, 80)-(270, 85)
LINE (270, 85)-(277, 90)
DRAW "D5 F5 D5 F5 D20 G2 D2 G2 D2 G4 L10"
FOR x = 1 TO 5: DRAW "D1 L7": NEXT
FOR x = 1 TO 9: DRAW "D1 L10": NEXT
DRAW "L30 H2 U2 H2 U4 E4 U2 E4"
DRAW "H4 L20 G4 L2 G2 L2 G2 D4 G6 D2 G2 L10 G2 L10"
DRAW "H2 L4 H2 L8 H4 L4 H2 U2 H4 U2 H2 U35"
PAINT (21, 71), 2, 6
'
'     Volcano & Lake
'
CIRCLE (250, 110), 20, 0, , , .9: PAINT (251, 111), 6, 0
CIRCLE (250, 110), 8, 0, , , .9: PAINT (251, 111), 4, 0
CIRCLE (98, 85), 27, 0, , , .3: PAINT (99, 86), 1, 0
'
'  Beaches
'
DRAW "B M20,71 C0 F20 D27 G18 L2"
PAINT (25, 80), 14, 0
DRAW "B M148,72 C0 F5 R1 F5 R1 F8 R1 F4 R25 U1 E4 U1 E4 U1 E6"
PAINT (160, 75), 14, 0
DRAW "B M165,154 C0 E10 R1 E2 R1 E2 R1 E1 R30 F2 R1 F2 R1 F2 R1 F2 R1 F2"
PAINT (170, 150), 14, 0
COLOR 3: LOCATE 24: PRINT "(Hit any key)";
k$ = INKEY$
DO
   k$ = INKEY$
LOOP UNTIL k$ <> ""
SCREEN 0: WIDTH 80:  CLS : COLOR 3

END SUB

