' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank                         
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank              
'                                                                
'                 MULTI-ADVENTURE INTRO PROGRAM                  
'                                                                
' Classic Eamon Adventures Volume 2          Update: 19 DEC 2011 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB YGolonac.PicLoader ()

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

'  Tomb of Y'Golonac picture variables
DIM SHARED pic%(1 TO 3460)
TYPE pictype
   s AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), dly#, CC1#, CC2#, CC3#, adv, adv1, adv2
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): sex = z.sex: q$ = CHR$(34): gold = z.gold

adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF
CLOSE #1

l$ = STRING$(80, 196)
OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Converted to Eamon Deluxe by Frank Black"
Adventure1$ = "Classic Eamon Adventures Volume 2"
author$ = author1$: adventure$ = Adventure1$

'
' Make sure graphic mode is available for Tomb of Y'Golonac intro
'
ON ERROR GOTO ScreenError
SCREEN 7

Start:
ON ERROR GOTO 0
SCREEN 0: WIDTH 80

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX.BAS"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Devil, Carroll, Crystmtn, Master, LostAdvt, Manxfoe, Sewers, Harpy, CavDoom, ModProb, School, Xenon, CCaves, Smiths, YGolonac, Mansi, Twin, Riveneta, TimePort, LinWang, DoomClock
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Title
COLOR 2: a$ = "This is official Eamon Deluxe adventure #14": GOSUB Center
COLOR 3: PRINT : PRINT
PRINT "This is the second of six collections of "; q$; "Classic"; q$; " Apple II Eamon adventures."
PRINT "The order I have selected is numerical, but also includes all of an author's"
PRINT "adventures even if they aren't in sequential order."
PRINT
PRINT "Note that there are many adventures which are not included because they are"
PRINT "already collected into another Eamon Deluxe adventure set."
PRINT
PRINT "I have enhanced most of these adventures and I hope that you enjoy playing them"
PRINT "as much as I enjoyed converting them to Eamon Deluxe."
PRINT
PRINT SPC(61); "-Frank Black"
PRINT : PRINT : GOSUB KeyWait

Menu:
author$ = author1$: adventure$ = Adventure1$: GOSUB Title
COLOR 2
FOR a = 1 TO 11
   PRINT a$(a); : IF a < 11 THEN LOCATE CSRLIN, 40: PRINT a$(a + 11);
   PRINT
NEXT
PRINT : COLOR 3: k = 17: c1 = 4
CALL EDXMenuM(k, c1, 1, 4, 3, 0)
IF k < 1 OR k > 4 THEN GOTO Menu
IF k = 4 THEN CHDIR "..": RUN "EAMONDX.BAS"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Devil, Carroll, Crystmtn, Master, LostAdvt, Manxfoe, Sewers, Harpy, CavDoom, ModProb, School, Xenon, CCaves, Smiths, YGolonac, Mansi, Twin, Riveneta, TimePort, LinWang, DoomClock
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Devil1, Carroll1, Crystmtn1, Master1, LostAdvt1, Manxfoe1, Sewers1, Harpy1, CavDoom1, ModProb1, School1, Xenon1, CCaves1, Smiths1, YGolonac1, Mansi1, Twin1, Riveneta1, TimePort1, LinWang1, DoomClock1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Devil, Carroll, Crystmtn, Master, LostAdvt, Manxfoe, Sewers, Harpy, CavDoom, ModProb, School, Xenon, CCaves, Smiths, YGolonac, Mansi, Twin, Riveneta, TimePort, LinWang, DoomClock
IntroDone:
a$ = "(Waking up the monsters...)"
IF adv = 7 THEN a$ = "(Waking up the rats...)"
IF adv = 19 THEN a$ = "(Warming up the machinery...)"
PRINT a$
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'
'   The Devil's Dungeon
'
Devil:
dev2 = 0: adr$ = "sir": IF sex = 1 THEN adr$ = "ma'am"
PRINT "As you leave the Main Hall, a disgusting looking dwarf runs up behind you and"
PRINT "tugs at your armor.  "; q$; "If you'll follow me, "; adr$; ","; q$; " he says, "; q$; "I'll take you to a"
PRINT "little-known dungeon filled with some of the most unusual riches imaginable!"
PRINT
PRINT "You are inclined not to trust the repulsive little fellow, but your greed wins"
PRINT "out over your common sense, and you follow him to a secluded spot in the woods."
PRINT "The diminutive man brushes away some grass and twigs to reveal a small wooden"
PRINT "door in the ground."
PRINT
PRINT "The dwarf now turns and asks you, "; q$; "How about a little monetary reward for my"
PRINT "efforts?"; q$
PRINT
Devil2:
PRINT "Will you pay him (Y/N)?"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "n" THEN GOTO Devil2

IF k$ = "y" THEN
Devil3:
  LINE INPUT "How much will you pay him? "; a$: PRINT : dev2 = INT(VAL(a$))
  IF dev2 < 1 THEN GOTO Devil3
  IF dev2 > gold THEN
    PRINT "You don't have that much gold with you!": GOTO Devil3
  END IF
  IF dev2 < 25 THEN GOTO Devil4
  dev1 = -999
  IF dev2 < 50 THEN
    PRINT "The dwarf looks disgustedly at the small payment in his hand, sniffs once, and"
    PRINT "turns and walks away.": GOTO Devil8
  END IF
  PRINT "The little man's face lights up...  He leans over to whisper to you as you climb"
  PRINT "into the hole, "; q$; "Thank you, "; adr$; ", and keep a sharp eye out for secret doors in"
  PRINT "this adventure!"; q$: GOTO Devil8
END IF

Devil4:
PRINT "Angry and hurt, the dwarf violently pushes you into the hole and slams the door"
PRINT "shut above you!"
dev1 = -1
Devil8:
OPEN "DEVILDUN.DAT" FOR OUTPUT AS #1: PRINT #1, dev1, dev2: CLOSE #1
PRINT : PRINT : GOTO KeyWait
'
'
Devil1:
PRINT "Extra Command:  KISS"
PRINT "Playing Time:  1 Hour"
PRINT "Average Rating:  6.0/3"
PRINT
PRINT "("; q$; "The Devil's Dungeon"; q$; " was reviewed in the May, 1985 issue of the NEUC"
PRINT "Adventurer's Log but it was rather outdated and didn't really say much so it"
PRINT "wasn't included here.)"
PRINT : PRINT : GOTO KeyWait

'   Feast of Carroll
Carroll:
PRINT "You and your friends, Otho the Dragon Slayer, and Morlok the Wizard, spent last"
PRINT "night together in the Main Hall celebrating the Feast of Carroll, the one day"
PRINT "each year when all of Eamon's moons are full."
PRINT
PRINT "You must have enjoyed yourself a little more than you intended, because now you"
PRINT "don't know where you are, and you can't remember how you got here.  All that you"
PRINT "know, for sure, is that you are in a very mysterious place..."
PRINT : PRINT : GOTO KeyWait
Carroll1:
s$ = "June 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Extra Commands: ROTATE, KNIGHT"
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 6.0    Average Rating: 5.7/3"
PRINT
PRINT "Comment:  This is a fairly interesting and not too difficult foray into the"
PRINT "worlds of Lewis Carroll and fairy tales in general.  The bad guys are few and"
PRINT "pretty easy.  There are a couple of minor puzzles."
PRINT
PRINT "The little gimmicks are clever and funny, and overall I did enjoy the play."
PRINT "Read everything you can, and try your POWER spell when all else fails (and NOT"
PRINT "before!), and you shouldn't have any real trouble.  One item: the way the"
PRINT q$; "Excalibur"; q$; " code is written, there is only a one in four chance that you will be"
PRINT : PRINT : GOSUB KeyWait
PRINT "able to get the sword, and you only get three chances at it.  If you don't get"
PRINT "the sword, the KNIGHT command is inoperative.  But don't worry if you don't get"
PRINT "the sword; it's not a very big deal."
PRINT
PRINT "While I give this one a (4) for difficulty, the puzzles are subtle enough that"
PRINT "they may be over the heads of very young Eamonauts."
PRINT : PRINT : GOTO KeyWait

'             Crystal Mountain
Crystmtn:
PRINT "Once again you find yourself in the Main Hall reading this month's issue of"
PRINT "Adventure Monthly, when you come across an article about the legendary Crystal"
PRINT "Kingdom.  It gives the standard info-- Location, probability of truth (73%), and"
PRINT "legendary treasures:"
PRINT
PRINT "    1)  Black pearl necklace of the Royal Family"
PRINT "    2)  The Great Diamond (a priceless gem!)"
PRINT "    3)  The Crystal Sword (legend says it will make the holder invincible!)"
PRINT
PRINT "Since you are brave, daring, and broke, you decide to search out Crystal"
PRINT "Mountain, seat of power for the Crystal Kingdom."
PRINT : PRINT : GOSUB KeyWait
PRINT "After much searching you find an entrance.  Just as you enter you trip on a wire"
PRINT "and there is a low rumble.  A cave-in!  A large rock hits you on the head and"
PRINT "you black out!"
PRINT : PRINT : GOTO KeyWait
Crystmtn1:
s$ = "June 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours"
PRINT "Reviewer Rating: 5.0"
PRINT
PRINT "Comment:  This is a largish 85-room dungeon with several small mazes, a couple"
PRINT "of death traps, and several minor puzzles. "
PRINT
PRINT "I enjoyed the mazes; they are the really bad sort with identical descriptions"
PRINT "and names and totally mixed-up room connections, but they are only a few rooms"
PRINT "each and not too difficult to solve with persistence.  There is a good bit of"
PRINT "special stuff involving such items as levers, keys, doors, cells, and buttons."
PRINT
PRINT "There is no Quest other than simple escape, but I suggest that you make your own"
PRINT "by recovering the items listed in the introduction."
PRINT : PRINT : GOSUB KeyWait
PRINT "The mazes, a death trap, and a very strong dragon run the difficulty up to about"
PRINT "(7). Here are some hints:  Don't forget your POWER spell; the Crystal Sword is"
PRINT "an exceptional magical weapon, but it DOES NOT make you invincible!"
PRINT : PRINT : GOTO KeyWait

'                 The Master's Dungeon
Master:
PRINT "Once upon a time on a warm sunny day, a tired but satisfied adventurer was"
PRINT "taking a restful sojourn in the Spartu Mountains.  It was once a wild and wooly"
PRINT "land, but since the rise of the Spartu Empire, the ancient tribes and cults"
PRINT "vanished along with their warlike manner.  You are that tired adventurer taking"
PRINT "a breather from your mercenary service to the Empire.  "
PRINT
PRINT "You are amazed and astounded at the peaceful scenery because of the savage"
PRINT "desperation you faced in your last adventure.  To your left, you see a rather"
PRINT "steep but rugged enough to climb slope.  In a burst of compulsive energy, you"
PRINT "scramble up the 200 foot slope quickly."
PRINT
PRINT "You are now at the top of the slope, standing in knee-high prairie grass."
PRINT "Looking down, you realize that you had been hiking in the bed of a deep canyon."
PRINT "All around you see mountains larger than you have ever seen before.  You feel"
PRINT "totally cut off from the world you once knew.  It is great to feel that for"
PRINT "once, no one can see you and you can't see anyone."
PRINT : PRINT : GOSUB KeyWait
PRINT "You now have finally caught your breath enough to walk.  You still feel a little"
PRINT "dizzy from exertion at a high altitude, but it is tolerable.  After walking"
PRINT "approximately thirty yards from the edge of the cliff, the grass gives way to"
PRINT "hard, rocky ground that begins the slope of an unusually massive mountain.  You"
PRINT "also notice a dark hole in front of you that leads straight down into"
PRINT "nothingness."
PRINT
PRINT "You notice that the source of this hole must have been a cave-in of some giant"
PRINT "underground cavern.  As you move toward the edge of the hole for a closer look"
PRINT "inside, the ground under your feet suddenly gives way and you fall into the"
PRINT "cavern along with a giant landslide of rocks and hard clay."
PRINT : PRINT : GOSUB KeyWait
PRINT "You make a feeble attempt to scramble but it is to no avail.  You feel yourself"
PRINT "in an endless and timeless fall.  You start to feel yourself floating through"
PRINT "the air even though you are accelerating to a faster and faster speed.  You see"
PRINT "your entire life relived in front of your eyes at the same speed it occurred."
PRINT "You know you will be killed from the impact when you finally hit the bottom of"
PRINT "this pit.  You close your eyes and wait for impact..."
PRINT : PRINT : GOTO KeyWait
Master1:
s$ = "January 1985": GOSUB Review1
PRINT "Reviewed by John Nelson": PRINT
PRINT "Extra Command:  THROW"
PRINT "Special Features:  Wandering monsters"
PRINT "Average Rating:  6.5/4"
PRINT
PRINT "Comment:  The room descriptions were fairly good although there were some"
PRINT "ambiguities and I found myself trying to do impossible things to interact with"
PRINT "my surroundings.  The descriptions of the monsters were not bad, although none"
PRINT "were dramatic and many were so similar that they must have been related."
PRINT
PRINT "The worse thing about this adventure is that action-wise it was somewhat boring."
PRINT "There were very few monsters, and lots of empty rooms."
PRINT : PRINT : GOTO KeyWait

'                    The Lost Adventure
LostAdvt:
PRINT "Note:  The intro to this adventure was originally a sort of mini-adventure with"
PRINT "three artifacts and a couple of rooms.  Because you had no choice but to follow"
PRINT "the author's intended path anyway I just converted it to standard intro text."
PRINT "This is why it may seem to read a little funny at times."
PRINT SPC(65); "-Frank"
PRINT : PRINT : GOSUB KeyWait
PRINT "You are standing on a sidewalk.  To the east you see a greenish colored stone"
PRINT "building that looks like some form of church.  It has a tall spire as usual and"
PRINT "over the door there is a huge cross with the figure of an emaciated toad tacked"
PRINT "to the crossbars.  A sign above the door says, "; q$; "The Temple"; q$; ".  You see a shiny"
PRINT "gold coin.  The face on the coin appears to be that of some important person, of"
PRINT "whom you recognize as being Willy Zyzyx.  You pick it up.  You move east and"
PRINT "gain entry to the building."
PRINT
'You gag as you try to drink the coin.  It hits the floor with a CLANG when
'you spit it out.
'Your teeth crack and chip as you try to eat the gold coin.  You had better
'try eating something a little softer.
PRINT "You are then standing at the back of a large temple.  The room is lit by candles"
PRINT "and small, dark stained glass windows in the ceiling.  The air is smoky and"
PRINT "smells of incense.  You hear the sound of organ music playing softly in the"
PRINT "distance.  To the east is an aisle leading between two columns of pews toward an"
PRINT "alter."
PRINT : PRINT : GOSUB KeyWait
PRINT "You move to an aisle between two columns of pews.  To your south you notice an"
PRINT "empty seat among the large number of worshipers.  The way to the east is barred"
PRINT "but the way to the exit isn't."
PRINT
PRINT "You are sitting in a church pew.  All around you notice people in some form of"
PRINT "trance staring straight ahead.  At the front of the temple you see the alter"
PRINT "much more clearly than you could before.  It is a rough hewn wooden bench."
PRINT "There are sets of burning candles on both ends of the bench.  All around the"
PRINT "alter are incense burners spewing large quantities of smoke.  On the bench are"
PRINT "two large mallets.  You also notice a large statue of a cross over the alter"
PRINT "with a figure of an emaciated toad tacked to the cross bars."
PRINT
PRINT "A burly usher wearing a black suit hands you an offering tray that is full of"
PRINT "money.  You drop the coin that you found into it and the usher smiles and passes"
PRINT "the tray to the next person.  The organ music becomes much louder and you notice"
PRINT "monstrous speakers placed in strategic locations around the room."
PRINT : PRINT : GOSUB KeyWait
PRINT "As your eyes become more adjusted to the darkened room, you notice paintings of"
PRINT "butterflies, mushrooms, eggs, and rabbits in bright florescent colors on the"
PRINT "side walls of the room."
PRINT
PRINT "Suddenly, a figure in a long red cowl with intricate designs walks out and"
PRINT "kneels in front of the alter.  After muttering unintelligible words, he stands"
PRINT "and raises his arms upward."
PRINT
PRINT "You notice many ushers with communion trays passing the trays up and down the"
PRINT "lines of people in the pews.  A small weasely man with long stringy hair hands"
PRINT "you a half-full tray of sugar cubes.  You take one and examine it."
PRINT : PRINT : GOSUB KeyWait
PRINT "You see an averaged sized white sugar cube.  As you examine it, a few loose"
PRINT "grains of sugar come off in your hand.  The weasely man tells you to eat it"
PRINT "because you're supposed to.  The sugar tastes very sweet as you chew it up and"
PRINT "swallow.  The weasely man smiles and passes the tray to the next person in the"
PRINT "aisle."
PRINT
'You choke trying to drink a sugar cube.  It falls to the floor after you
'spit it out.
PRINT "A huge man with a leather jacket and a beard hands you a tray full of shot"
PRINT "glasses.  Some of the glasses contain a dark brown liquid.  You take one and you"
PRINT "see it is a one-ounce shot glass full of a brown liquid that smells like strong"
PRINT "whiskey.  The man wearing the leather jacket tells you to drink it to wash down"
PRINT "the sugar cube."
PRINT
PRINT "You feel the whiskey burn as it flows down your throat into your stomach.  The"
PRINT "bearded man takes your empty glass and passes the tray to the next person."
PRINT : PRINT : GOSUB KeyWait
PRINT "You wait for a while as the rest of the people eat and drink.  Then the music"
PRINT "becomes much louder.  You recognize it as being the song, "; q$; "Inda-gadda-da-vida"; q$; "."
PRINT "The Cardinal of Cody raises his hands once again."
PRINT
PRINT "You notice yourself feeling different.  The room seems to be taking on a purple"
PRINT "glow.  The cardinal holds his hammers high and says, "; q$; "Accept my sacrifices, the"
PRINT "god whose name starts with the letter 'T'!!!"; q$; "  You no longer can tell the"
PRINT "difference between dreams and reality as the priest begins smashing toads and"
PRINT "the music erupts into a drum solo.  Flashing colors and ripples fill the air as"
PRINT "your mind leaves the world you are familiar with."
PRINT : PRINT : GOSUB KeyWait
CLS : LOCATE 7
a$ = "You feel very strange as you notice that you can no longer see the room that you"
GOSUB TripPrint
a$ = "were last in.  You feel as if you are growing very small.  You notice outdoor"
GOSUB TripPrint
a$ = "scenery slowly come into focus.  You begin to squint as you find yourself"
GOSUB TripPrint
a$ = "outside on a hot sunny day.  You suddenly realize you are less than an inch"
GOSUB TripPrint
a$ = "tall.  The only way out of this situation is to find the way to become large"
GOSUB TripPrint
a$ = "again...": GOSUB TripPrint
PRINT : PRINT : GOTO KeyWait
LostAdvt1:
s$ = "March 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Extra Command: SMOKE"
PRINT "Playing Time: 1-1.5 hours"
PRINT "Reviewer Rating: 6.0"
PRINT
PRINT "Comment:  This adventure does a pretty good job of portraying the experience of"
PRINT "being so very small.  You start out in a "; q$; "forest"; q$; " of lawn grass, and fight your"
PRINT "way past an assortment of insects.  There is an interesting side-trip into an"
PRINT "anthill.  Though most of your opponents are small like you, you will have to"
PRINT "find a way past a cat which thinks that you are dinner."
PRINT : PRINT : GOSUB KeyWait
PRINT "All in all, I enjoyed the play.  It mapped well and was very consistent.  It had"
PRINT "two or three nicely done puzzles.  It would have rated better but for two"
PRINT "things: first, drug use is an integral part of the adventure both going in and"
PRINT "during play, and the solution consists of trying drugs until you find one that"
PRINT "makes you big again.  Secondly, there is a large number of death traps.  While"
PRINT "there certainly are warning clues for all these traps, there are so many that"
PRINT "stumbling into one or two is virtually unavoidable.  The cat, for instance, is"
PRINT "instant death if you don't do the right thing on the very first move."
PRINT
PRINT "The combination of puzzle difficulty and death traps gives this adventure a (7)"
PRINT "rating for difficulty.  Puzzle fanciers will probably enjoy it more than"
PRINT "Hack'n'Slashers, but there is plenty of combat to go around."
PRINT : PRINT : GOTO KeyWait

'                       The Manxome Foe
Manxfoe:
PRINT "As you step out of the Main Hall, a hansom cab pulls up.  The driver offers you"
PRINT "a ride to your destination.  Soon after you are seated in the cab, you fall"
PRINT "into a deep slumber.  You awaken in a strange room, alone."
PRINT : PRINT : GOTO KeyWait
Manxfoe1:
s$ = "June 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 20-30 min."
PRINT "Reviewer Rating: 4.0    Average Rating: 5.5/2"
PRINT
PRINT "Comment: This is a somewhat strange Eamon.  While I haven't read the poem"
PRINT "personally, it appears to be based on "; q$; "Jabberwocky"; q$; ".  It has a lot of odd"
PRINT "creatures.  The map itself is rather mundane, although the room connections are"
PRINT "often pretty mixed up and one-way.  About half of the map is simple"
PRINT "in-one-side-and-out-the other rooms, and the rest almost constitutes an"
PRINT "intermittent maze."
PRINT
PRINT "Your "; q$; "quest"; q$; " is to find an exit.  I would guess that you probably won't see more"
PRINT "than about 30 of the 50 rooms on a given playthrough.  With a difficulty rating"
PRINT "of (4), it is actually an easy play, although it may not be suitable for young"
PRINT "Eamonauts because of the room connections."
PRINT : PRINT : GOTO KeyWait

'                  The Sewers of Chicago
Sewers:
GOSUB Title
PRINT "The Department of Streets and Sanitation has determined that the rat population"
PRINT "in the City of Chicago has grown so large that there is danger of the entire"
PRINT "human population deserting the otherwise fine city.  They have put a bounty of"
PRINT "20 gold pieces for every dead rat brought to the bounty center.  You have"
PRINT "decided to take on this challenge!"
PRINT : PRINT : GOTO KeyWait
Sewers1:
PRINT q$; "The Sewers of Chicago"; q$; " was reviewed in the March 1989 issue of the EAG"
PRINT "newsletter, but the review was unnecessarily harsh and dealt only with the"
PRINT "problems of the original version.  I have enhanced the Eamon Deluxe version"
PRINT "considerably and added some things of my own, making the review obsolete anyway."
PRINT SPC(58); "-Frank"
PRINT : PRINT : GOTO KeyWait

'                     The Harpy Cloud
Harpy:
GOSUB Title
PRINT "As you leave the Main Hall a dark dwarf sidles up to you.  He holds out a"
PRINT "sparkling flask and says, "; q$; "Would you like to visit a kingdom in the clouds?"; q$
PRINT
PRINT "Before you can answer he says, "; q$; "Good!  I thought you would!  Drink this Potion"
PRINT "of Lightness."; q$
PRINT : PRINT : GOSUB KeyWait
LOCATE 10: a# = dly# / 5
a$ = "As you drink the potion you feel yourself getting lighter..."
GOSUB SlowPrint: PRINT : a$ = "...and lighter...": LOCATE CSRLIN, 52
a# = dly# / 2: GOSUB SlowPrint: PRINT : a$ = "...and lighter..."
LOCATE CSRLIN, 61: a# = dly#: GOSUB SlowPrint
PRINT : PRINT : GOTO KeyWait
Harpy1:
s$ = "June 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 10-60 min."
PRINT "Reviewer Rating: 4.0    Average Rating: 4.0/3"
PRINT
PRINT "Comment: This begins as a standard "; q$; "Kill'n'Loot"; q$; " scenario, but after a while I"
PRINT "found myself more interested in finding an exit than anything else.  The map is"
PRINT "rather messy with lots of very similar room names, though you can't call it a"
PRINT "maze, because the room descriptions are quite different.  However, the room"
PRINT "names don't even remotely resemble the descriptions, which makes mapping a"
PRINT "difficult chore."
PRINT : PRINT : GOSUB KeyWait
PRINT "Much of the stuff was interesting and clever, but mapping got to be a real"
PRINT "grind, greatly lowering my overall enjoyment.  You are not notified or warned"
PRINT "of the exit either, which means that the game is over once you stumble through"
PRINT "it, which can happen in 8 or 9 moves if you make all the right choices. There"
PRINT "are no puzzles, and the bad guys aren't too bad, but the map bumps the"
PRINT "difficulty up to a (6)."
PRINT : PRINT : GOTO KeyWait

'                   The Caverns of Doom
CavDoom:
GOSUB Title
PRINT "You have been chosen to journey into the Caverns of Doom to recover the stolen"
PRINT "machinery desperately needed by the Apple Computer Corporation for their new"
PRINT "computer, the Apple //e."
PRINT
PRINT "The town will reward you for each piece of machinery returned.  In addition,"
PRINT "Hokas Tokas says that he will reward you himself."
PRINT
PRINT "The Knight Marshal accompanies you to the cavern entrance.  As he leaves a"
PRINT "phantasmal scroll appears.  It reads:"
PRINT
PRINT SPC(33); "Good luck,": PRINT SPC(31); "and god speed!"
PRINT SPC(29); "(You'll need it!!)"
PRINT : PRINT : GOSUB KeyWait
PRINT "As you descend the stairs, two stainless steel doors close behind you.  "
PRINT "Your quest has now begun..."
PRINT : PRINT : GOTO KeyWait
CavDoom1:
s$ = "September 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours"
PRINT "Reviewer Rating: 3.0    Average Rating: 3.0/2"
PRINT
PRINT "Comment: This Eamon starts with much promise, but it is not well turned out and"
PRINT "shows a severe lack of final polishing.  There are tons of text errors of just"
PRINT "about every kind.  The room exits are usually well enough marked on this"
PRINT "100-room map, but there are several significant room connection errors.  [Note:"
PRINT "Both of these problems have been fixed in the Eamon Deluxe Version.]"
PRINT
PRINT "There is no theme to the adventure.  You'll see Egyptian pharaohs, mad"
PRINT "scientists, dinosaurs, demons, Superman, evil priests, and more.  That probably"
PRINT "lowered my rating as much as anything.  There are also several death traps."
PRINT : PRINT : GOSUB KeyWait
PRINT "This is not an easy Eamon.  Between the mapping problems and some tough bad"
PRINT "guys, a difficulty rating of (8) is none too high."
PRINT
PRINT "Hint: when carrying the sword TELON, you will be randomly teleported every 15-20"
PRINT "moves."
PRINT : PRINT : GOTO KeyWait

'                Modern Problems
ModProb:
a$ = "Welcome to Modern Problems!": GOSUB Center: PRINT
PRINT "You have been transported to Seattle, Washington circa 1983.  There are only two"
PRINT "ways to leave "; q$; "Modern Problems"; q$; ".  The first is to return to the bus depot and"
PRINT "buy your ticket back to the Main Hall.  The second is to win the game, of"
PRINT "course.  Even though the bus ticket may be costly, money-wise, trying to win the"
PRINT "game may be even more costly, life-wise."
PRINT : PRINT : GOSUB KeyWait
PRINT "To win this game will require all of your imagination and previous experience."
PRINT "You need to collect the following articles:"
PRINT
PRINT SPC(25); "1) An apartment"
PRINT SPC(25); "2) A job"
PRINT SPC(25); "3) A car"
PRINT
PRINT "The only weapons/armor you will start this adventure with is a .357 magnum and"
PRINT "a bulletproof vest."
PRINT : PRINT : GOTO KeyWait
'
ModProb1:
s$ = "March 1989": GOSUB Review1
PRINT "Reviewed by Nathan Segerlind"
PRINT
PRINT "Extra Command: TALK": PRINT "Playing Time: 1-3 hours"
PRINT "Rating: 6.5                 Average rating: 6.2/2"
PRINT
PRINT "Comment:  This adventure is refreshing in that its quest is not related to"
PRINT "violence or fighting.  Don't take me wrong- there is a good deal of fighting,"
PRINT "but it's not too significant."
PRINT
PRINT "The worst feature about this adventure is that it can get rather unrealistic,"
PRINT "allowing you into all kinds of places that nobody would let you go in real life."
PRINT "For example, you can walk right into a mental hospital and get killed."
PRINT : PRINT : GOSUB KeyWait
PRINT "A nice feature is that in order to make a transaction, you must say something "
PRINT "(using the new TALK command) to the clerks, or else they will ignore you.  (But"
PRINT "that's unrealistic, too- they always ignore you in real life!)"
PRINT
PRINT "This adventure is rather fun, but has the simple style that you expect of an"
PRINT "earlier Eamon."
PRINT : PRINT : GOTO KeyWait

'                 The School of Death
School:
PRINT "As you were exiting the Main Hall, you bumped into none other than the Baron of"
PRINT "Lucidia, Sir Luketzar.  He said that he has heard a lot about you, and was"
PRINT "coming over to see you about doing him a small favor.  Not being a coward, you"
PRINT "bid him to continue, and he tells you the following:"
PRINT
PRINT q$; "Last evening, during one of my best parties, a small band of thieves managed to"
PRINT "break into the castle storages, and steal some of my family treasures.  The"
PRINT "palace guards captured and killed all but one of the culprits.  Only their"
PRINT "leader, Karal, managed to escape.  Among the things still missing are the Golden"
PRINT "Cup of Negavia, a painting of my forefather Kahn, FireKing-Sword of Conquerors,"
PRINT "and the magical crystal-Krystar."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "You must slay Karal and bring back all the treasures!  You will be paid well,"
PRINT "and you may keep FireKing, if all other treasures are unharmed.  It is said that"
PRINT "Karal is hiding in ancient ruins on a different plane of existence.  A place"
PRINT "called Tech High School, whatever that is.  One of my best men, Sir Orabon, will"
PRINT "meet you at the entrance."; q$
PRINT
PRINT "Zorphurck, the Baron's wizard, then steps up and chants, making signs in the air"
PRINT "with his hands.  You soon feel a nauseating pull at your stomach, and find"
PRINT "yourself at the entrance to Tech High School..."
PRINT : PRINT : GOTO KeyWait
School1:
s$ = "March 1989": GOSUB Review1
PRINT "Reviewed by Nathan Segerlind"
PRINT
PRINT "Playing Time: 2-4 hours"
PRINT "Reviewer's Rating 5          Average Rating: 5.5/2"
PRINT
PRINT "Comment:  This adventure is probably one of the best you will find that has"
PRINT "almost no modification to the MAIN PGM.  The only modification that I found was"
PRINT "a sequence that required you to have the 5 treasures to exit.  [Note: The POWER"
PRINT "spell was also modified, but that's it.]"
PRINT
PRINT "The text is well written and entertaining, often humorous.  I myself found it"
PRINT "entertaining because of its resemblance to the school I attended."
PRINT : PRINT : GOSUB KeyWait
PRINT "It is mainly a Hack'n'Slash joke-fest, with almost no puzzle solving.  I don't"
PRINT "really mind this, but fans of puzzle-rich Eamons will be disappointed."
PRINT
PRINT "Recommended to young Eamonauts and Hack'n'Slashers."
PRINT : PRINT : GOTO KeyWait

'                  Dungeons of Xenon
Xenon:
PRINT "Notes:  The bad guy in this adventure was called "; q$; "Xenor"; q$; " and "; q$; "Xenon"; q$; " in various"
PRINT "different descriptions.  Since the official name of the adventure was "; q$; "Dungeons"
PRINT "of Xenon"; q$; ", I changed all of the Xenor references to Xenon.  I also cleaned up"
PRINT "the text considerably and added the individual traits to Xenon's guards, which"
PRINT "were originally cardboard cutouts of each other."
PRINT SPC(60); "-Frank": PRINT : PRINT : GOSUB KeyWait
PRINT "As you walk out of the Main Hall you see a beggar.  He comes up to you and says,"
PRINT q$; "An evil man named Xenon is building up an army and is planning to try and take"
PRINT "over the Eamon Main Hall.  I was once a prisoner in his concentration camp.  I"
PRINT "escaped and came to the Main Hall to warn a brave and loyal Free Adventurer like"
PRINT "you.  You must stop this evil man.  The way to find him is that you must venture"
PRINT "into "; : COLOR 0, 2: PRINT " THE DUNGEONS OF XENON! "; : COLOR 3, 0: PRINT
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "The dungeon leads to his hide-out.  You go past the dungeon and through the"
PRINT "forest-woods of Eldarr.  Along the way you will meet five friends.  Their names"
PRINT "be Sir Angadon the knight, Lady Amrat the barbarian, Prince Castillon the"
PRINT "son-of-a-err, the son of the King I mean, Destroyer the ogre, and Don the"
PRINT "overweight Dwarf.  Now remember, you must kill Xenon.  Also remember that he has"
PRINT "a whole army.  The Main Hall is at stake and we're all depending on you.  Good"
PRINT "luck and Hermes' speed on you quest!"; q$
PRINT
PRINT "The beggar leaves and you realize that this will be one of the toughest quests"
PRINT "of your lifetime."
PRINT : PRINT : GOTO KeyWait
Xenon1:
s$ = "September 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 5.0"
PRINT
PRINT "Comment: Well, I saw no army, so you don't have to worry about fighting one."
PRINT "And I have a sneaking suspicion that this is supposed to be named "; q$; "Dungeons of"
PRINT "Xenor"; q$; ", but there you are."
PRINT
PRINT "This Eamon will be of interest primarily to the young Hack'n'Slash crowd.  It"
PRINT "has one death trap, a couple of unimportant signs to be read, no artifacts"
PRINT "other than weapons and treasure, and lots of bad guys.  This feels mostly "
PRINT "like a largish Beginners Cave, with a bit of humor and a mixed bag of monsters."
PRINT : PRINT : GOSUB KeyWait
PRINT "The map is not bad at all, nicely laid out and written, though the room"
PRINT "descriptions were often very simple.  There appears to be a couple of bad room"
PRINT "connections near the end, but it felt intentional to me, to fake a simple maze."
PRINT "[Note: Tom was imagining this, all the room connection were accurate, except one"
PRINT "which was most likely a mistake and was fixed in the Eamon Deluxe version.]"
PRINT
PRINT "It gets a (3) for difficulty.  This is definitely a good pick for the Young"
PRINT "Eamonaut."
PRINT : PRINT : GOTO KeyWait

'                    Chaosium Caves
CCaves:
PRINT "After walking out of the Main Hall you see Hokas Tokas, the wizard.  He says to"
PRINT "you, "; q$; "I have just heard word of a new tyrant named Astrallion.  He has the"
PRINT "ancient Medallion of the Mind.  It was stolen from the Main Hall's treasure"
PRINT "room.  It has the power of controlling other people's minds.  I found the"
PRINT "tyrant's hide-out.  It is in the "; : COLOR 0, 2
PRINT " CHAOSIUM CAVES! "; : COLOR 3, 0: PRINT
PRINT
PRINT q$; "You must venture into the caves and kill the tyrant.  Once you are in the"
PRINT "caves, you will not be able to leave until you get the medallion."; q$
PRINT
PRINT "He makes a gesture with his hand and you find yourself in the caves!"
PRINT : PRINT : GOTO KeyWait
CCaves1:
s$ = "December 1989": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "MAIN PGM version: 4"
PRINT "Playing Time: 30 minutes"
PRINT "Reviewer Rating: 3.0"
PRINT
PRINT "Comment: Although you are given a quest, the background is rather bare.  And so"
PRINT "goes the adventure.  There are no puzzles nor hidden stuff.  The descriptions"
PRINT "are typically no more than a variation on the name (eg: YOU ARE IN A N/S HALL)."
PRINT "Four-fifths of the monsters are bats and skeletons (BAT4, BAT7, SKELETON11,"
PRINT "etc.).  Punctuation is very erratic.  [Note: Punctuation was fixed in the Eamon"
PRINT "Deluxe version. -Frank]"
PRINT : PRINT : GOSUB KeyWait
PRINT "It has two things going for it: there is a quest, and the room exits are clearly"
PRINT "stated in both the room descriptions and in the names.  It is a VERY simple"
PRINT "adventure, and may be well-suited for young Eamonauts.  I give it a (2) for"
PRINT "difficulty."
PRINT : PRINT : GOTO KeyWait

'                The Smith's Stronghold
Smiths:
PRINT "The wizard, Frobos, has commissioned you to secure a dragon tooth from the lair"
PRINT "of the white dragon beneath the Smith's Stronghold.  He has provided you with a"
PRINT "map and following that map, you have arrived at the entrance to a narrow and"
PRINT "dark ravine.........."
PRINT : PRINT : GOTO KeyWait
Smiths1:
s$ = "September 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 6.0"
PRINT
PRINT "Comment: Here we have a pretty straightforward Hack'n'Slash Eamon, with a large"
PRINT "map and well-written room descriptions.  The play is to check out a smithy and"
PRINT "the passages hidden below it.  There are two secret passages and one "; q$; "Gotcha!"; q$
PRINT "no-warning death trap.  The monsters and weapons are somewhat boring, with names"
PRINT "like Dwarf10 and Viper7."
PRINT
PRINT "No mental heavy lifting at all.  Just check out all the passages and kill all"
PRINT "the bad guys.  I half-expected to get slammed by the dragon once I got the"
PRINT "tooth, but all I saw was one quick glimpse of him and then he was gone."
PRINT "Difficulty rings in at (5)."
PRINT : PRINT : GOTO KeyWait

'                  The Tomb of Y'Golonac
YGolonac:
IF ScreenErr = 0 THEN
  PRINT "Do you want to see the original hi-res intro story? (Y/N):";
  GOSUB KeyWait1: IF k$ = "y" THEN CALL YGolonac.PicLoader: GOTO Title
END IF
COLOR 0, 2: PRINT "    WARNING!    "; : COLOR 3, 0: PRINT : PRINT
PRINT "The Tomb of Y'Golonac is an extremely dangerous and high-level dungeon.  If "
PRINT "you are not using an experienced Eamon character with at least one magical"
PRINT "weapon, return to the Main Hall at once!"
PRINT : PRINT : GOSUB KeyWait
PRINT "The dreaded Cthulhu Cycle has existed since the dawn of time.  The ancient myths"
PRINT "of Elder Beings from beyond space and time have, in other worlds, too often"
PRINT "proven true."
PRINT
PRINT "In the Main Hall, you heard a rumor of a segment of the Cthulhu Cult, "; q$; "The"
PRINT "Minions of Y'Golonac"; q$; ".  Apparently, another adventurer had attempted to destroy"
PRINT "this evil cult, but never returned."
PRINT
PRINT "Your interest in solving this mystery grew as you heard of a reasonable reward"
PRINT "for the safe return of this adventurer, and rumors of great wealth hidden at the"
PRINT "heart of the cult, a structure that exists right here on the Planet Eamon, the"
PRINT "Tomb of Y'Golonac!  This horrid structure filled with hideous monsters remaining"
PRINT "from some bygone era, must be looted and the god destroyed before the time you"
PRINT "had read of in a rotting, worm-eaten tome..."
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "Beyond a gulf in the subterranean night a passage leads to a wall of massive"
PRINT "brick, and beyond the wall rises Y'Golonac to be served by the tattered eyeless"
PRINT "figures of the dark."
PRINT
PRINT q$; "So may Y'Golonac return to walk among men and await the time when Eamon is"
PRINT "cleared off and Cthulhu rises from his tomb among the weeds, Glaaki thrusts open"
PRINT "the crystal trapdoor, Shub-Niggurath strides forth to smash the moon-lens..."; q$
PRINT
PRINT "So that night you set off to find the tomb.  After heading northwards from the"
PRINT "Main Hall for many miles, over a small, forgotten path winding through the huge"
PRINT "Voormithadreth Mountains, you came across the entrance to the tomb!"
PRINT : PRINT : GOTO KeyWait
YGolonac1:
s$ = "September 1988": GOSUB Review1
PRINT "Reviewed by Pat Hurst"
PRINT
PRINT "Special Features: Intro in ornate hi-res typeface"
PRINT "Playing Time: 1 hour"
PRINT "Average Rating: 6.0/2"
PRINT
PRINT "Comment: This adventure was dedicated to H.P. Lovecraft who originated the"
PRINT "literary tradition which has come to be known as the Cthulhu Mythos.  If you are"
PRINT "familiar with these stories by Lovecraft, et al., you will appreciate this"
PRINT "adventure more.  If you have played the Call of Cthulhu game ((C) by Chaosium,"
PRINT "Inc.) you will have a good idea of what to expect from this adventure - you will"
PRINT "probably die. If you are a wimp, the monsters will kill you.  If you're really"
PRINT "tough, and you don't fumble your heavy-duty weapon (killing yourself,) then you"
PRINT "may survive.  But if you are thorough in your explorations, then you will die in"
PRINT "one of the traps.  The best way to deal with this is to heed any warning that"
PRINT "the author provides during play.  This limits your exploration but gives you the"
PRINT "best chance of surviving."
PRINT : GOSUB KeyWait
PRINT "I would normally complain about the 'gotcha' traps but these are true to the"
PRINT "genre.  In the Cthulhu Mythos, the humans who confronted the Elder Gods"
PRINT "typically died, usually horribly.  That's why if you are a shade Cthulhoid"
PRINT "yourself, you may appreciate the numerous opportunities to croak.  The"
PRINT "descriptions are sufficiently gruesome to raise the adventure's rating.  I would"
PRINT "recommend it to any Cthulhu nuts, but there are better adventures for normal"
PRINT "Eamon players.  If you have played all of the better ones and are still after a"
PRINT "challenge, then you might consider this one.  Difficulty of (9)."
PRINT : PRINT : GOTO KeyWait

'              Escape from Mansi Island
Mansi:
COLOR 0, 2: PRINT SPC(21); "There is trouble in the town of Yomber!"; SPC(20);
COLOR 3, 0: PRINT : PRINT
PRINT "When you were coming home from the Main Hall one day, you heard the town crier"
PRINT "of Yomber say something of adventure and treasure.  Having a great interest for"
PRINT "both of these things, you came a little closer."
PRINT
PRINT "You find out that the Queen's dog, Fifi, has been dognapped and there is a"
PRINT "reward for the person who finds her."
PRINT
PRINT "Fifi has been stolen by a group of vicious goblins known only as the "; q$; "Rogues of"
PRINT "R.T."; q$; ".  This group has always caused problems for Yomber, and it would be"
PRINT "appreciated if this R.T. was either slain or stopped.  Yomber will never be safe"
PRINT "until this evil menace is killed."
PRINT : PRINT : GOSUB KeyWait
PRINT "Because so many have tried this mission and failed (you might find a few) you"
PRINT "will be issued a special ring.  This extraordinary ring has many powers, the"
PRINT "most powerful being on your death, you will be teleported to Yomber Castle,"
PRINT "alive.  If you lose the ring and die then it won't be able to help you!"
PRINT
PRINT "You will have approximately three hours to complete the mission.  If you are not"
PRINT "back within that time the ring will teleport you to Yomber castle.  The reason"
PRINT "for this is: Many more goblins are out at night and you would more than likely"
PRINT "be killed before you could say, "; q$; "Yomber"; q$; "."
PRINT : PRINT : GOTO KeyWait
Mansi1:
s$ = "September 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Special Features: "; q$; "Tournament"; q$; " game: timed play"
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 5.0"
PRINT
PRINT "Comment:  This adventure is very similar to "; q$; "The Castle of Count Fuey"; q$; " (from The"
PRINT "Donald Brown Adventures) in that you have a limited number of moves and are"
PRINT "scored at the end.  It plays well enough, and is not especially complex or"
PRINT "difficult to complete.  I was able to rescue Fifi in my first attempt, though"
PRINT "time was getting short."
PRINT : PRINT : GOSUB KeyWait
PRINT "I got somewhat bored while exploring a large forest and while floundering about"
PRINT "on the ocean in a boat.  I have no doubt that these mapping aspects were"
PRINT "included so as to run up the game clock as the player frantically explored them."
PRINT
PRINT "In the end you are scored on loot taken, goblins killed, Fifi rescued, and"
PRINT "whether or not R.T. was killed.  I peg the difficulty at (5)."
PRINT
PRINT "Two hints:  Remember your spells, and don't put to sea without provisions."
PRINT : PRINT : GOTO KeyWait

'                 The Twin Castles
Twin:
PRINT "King Escher calls you before his throne and asks you to take on an assignment of"
PRINT "incredible importance.  It seems that the magic orb, Ballweena, has been stolen"
PRINT "by Vathek, the King of a neighboring realm.  This magic orb supplies the psychic"
PRINT "power that keeps the whole kingdom going.  And it can be recognized by its blue"
PRINT "glow."
PRINT
PRINT "It is your job to find the orb and return it to the king."
PRINT
PRINT "Escher says he will have his favorite psychic waiting outside the castle walls"
PRINT "to accompany you and wishes you the best of luck."
PRINT : PRINT : GOTO KeyWait
Twin1:
s$ = "September 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Special Features: Companion offers hints"
PRINT "Playing Time: 30-90 min."
PRINT "Reviewer Rating: 6.0           Average Rating: 6.3/3"
PRINT
PRINT "Comment: This was Jim's first Eamon, and it is a very creditable job.  The"
PRINT "largish map is a bit simple, but clear.  He's done some nice coding of special"
PRINT "events.  He did a very nice job with his method of printing a single description"
PRINT "for a band of several dogs in this time before the advent of the"
PRINT "multiple-monster."
PRINT : PRINT : GOSUB KeyWait
PRINT "One item I really liked was the comments that the psychic guide made as I"
PRINT "progressed.  You'll want to pay close attention to his advice."
PRINT
PRINT "While nicely written, this Eamon doesn't have a lot of depth, which lowered my"
PRINT "rating slightly and gives it a difficulty rating of (4)."
PRINT : PRINT : GOTO KeyWait

'                   Castle of Riveneta
Riveneta:
PRINT "As you prepare for your next journey, a small young man comes up from around a"
PRINT "building.  He tells you of a castle to the north of town which was abandoned by"
PRINT "the royal government when the Queen Riveneta mysteriously died in her bedroom."
PRINT
PRINT "When he finishes his story of the castle he quickly crams a map into your hand"
PRINT "and says, "; q$; "Use this here piece of paper to find yer way to the castle yonder to"
PRINT "the north."; q$
PRINT
PRINT "Before you can say a word he dashes off to wherever he came from.  You study the"
PRINT "map for a while and then decide to adventure in the castle."
PRINT : PRINT : GOTO KeyWait
Riveneta1:
s$ = "June 1990": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-1.5 hours"
PRINT "Reviewer Rating: 5.0"
PRINT
PRINT "Comment: This was a fairly average adventure, being neither outstanding nor a"
PRINT "stinker.  It is strictly a 'kill and loot' scenario, and the only puzzles are"
PRINT "secret passages and an unusual 'elevator' gimmick.  I detected a hint of a quest"
PRINT "for vengeance against the queen's murderer but it wasn't followed through with."
PRINT "It has 80 rooms and the map had lots of diversity with no problems, although"
PRINT "there was never a real castle with such a weird layout.  I found a minor fault"
PRINT "in that many of the monsters are wild animals that have no business in an"
PRINT "abandoned castle.  The most notable such encounter was with an angry giraffe in"
PRINT "an underground tunnel!  Last, there were valuables laying about to be looted in"
PRINT "dumb places; for example, a "; q$; "priceless"; q$; " Ming vase in a cistern room."
PRINT : PRINT : GOSUB KeyWait
PRINT "But it was otherwise well built and error free.  Hack-&-Slashers should note"
PRINT "that it is geared for weapons from Marcos' weapon shop and is a pushover with"
PRINT "magic-class weapons.  But with a mundane weapon in the 1D8 class, this adventure"
PRINT "would be an interesting challenge."
PRINT : PRINT : GOTO KeyWait

'                     The Time Portal
TimePort:
PRINT q$; "Well as I live and breath, if it isn't my old pal!  I've heard from a few of"
PRINT "the boys that you're looking for something to do to 'pass the time'."
PRINT
PRINT q$; "Well I've got something you just might be interested in, old buddy!  I've heard"
PRINT "that the boys down at the Science Institute have made a fantastic discovery."
PRINT "They've come up with a wonderful new time machine!  This machine is supposed to"
PRINT "be able to take you to places you never dreamed were possible."
PRINT
PRINT q$; "Well, old buddy, what do you think?  Would you like to travel through time in"
PRINT "this new machine?"
'  Original answer if player decided to JUST SAY NO!
'Aw, what a shame.  You're missing out on a very interesting trip.  But
'perhaps you might reconsider after a short rest in the Main Hall.
PRINT : PRINT : GOSUB KeyWait
PRINT q$; "Good!  I knew you would!  Well then just stay on this road for a little while"
PRINT "and you'll come to a big building.  What you want is inside.  Just remember to"
PRINT "look for the doors with lights!"
PRINT
PRINT q$; "Good luck and good traveling!"; q$
PRINT : PRINT : GOTO KeyWait
TimePort1:
s$ = "December 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 1-2 hours"
PRINT "Reviewer Rating: 5.0    Average Rating: 5.0/2"
PRINT
PRINT "Comment:  This Eamon is actually a conglomeration of three small Eamon dungeons"
PRINT "linked together through the "; q$; "time portals"; q$; ".  The three themes are movie"
PRINT "monsters, movie cavemen, and Star Trek."
PRINT
PRINT "Each of them was smallish, of course, with very similar-feeling, unimaginative"
PRINT "maps.  There were a few specials that upped the rating somewhat, though."
PRINT
PRINT "I guess it gets a (5) for difficulty, too.  Be sure to read the descriptions"
PRINT "carefully, as two places have death traps that are described before you get"
PRINT "nailed by them."
PRINT : PRINT : GOTO KeyWait

'               Super Fortress of Lin Wang
LinWang:
PRINT "As you walk out of the Main Hall you see an orb.  As you touch it, the world"
PRINT "shifts around you and you find yourself in medieval Japan.  You soon discover"
PRINT "that a tyrant, Lin Wang, recently seized power here by force and built a huge"
PRINT "fortress so that no one could harm him.  You must avoid his karate experts"
PRINT "(ranging from white to black belt), his Samurai and ninja, his Guards, Captains,"
PRINT "and Generals.  Most of all, you must avoid his Oriental and Komodo dragons."
PRINT "Finally you must stop Lin Wang (by whatever means necessary) and escape his"
PRINT "fortress!  Good luck!"
PRINT : PRINT : GOTO KeyWait
LinWang1:
s$ = "December 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min."
PRINT "Reviewer Rating: 3.0        Average Rating: 3.9/4"
PRINT
PRINT "Comment:  This is straight Hack'n'slash fare.  No puzzles, no secret passages,"
PRINT "just lots and lots of combat."
PRINT
PRINT "I confess that I was put off from the beginning by Sam's use of a Chinese name"
PRINT "for a Japanese bad guy.  It's an OK Eamon, but not a great one.  Once you've"
PRINT "killed one Ninja, you killed them all, so to speak.  Sam added some bits to his"
PRINT "narrative, such as gratuitously calling me a coward in the middle of an empty"
PRINT "passage, that didn't set well with me, either."
PRINT
PRINT "There is a lot of combat here, so you may want to bring along a good set of"
PRINT "magic weapons.  Given a good magic sword, I peg the difficulty at (6)."
PRINT : PRINT : GOTO KeyWait

'                   The Doomsday Clock
DoomClock:
PRINT "You have been assigned to the US Embassy in Moscow, officially as an Air Force"
PRINT "attache.  Actually, however, you are a highly-trained member of a covert branch"
PRINT "of the CIA known as SOG, or "; q$; "Special Operations Group"; q$; ".  SOG was famous during"
PRINT "the Vietnam war for its covert operations behind the lines in North Vietnam,"
PRINT "including assassinations."
PRINT
PRINT "One night you are called to duty by your Section Chief, who looks like he is"
PRINT "about to have apoplexy.  He informs you that our agents have discovered an"
PRINT "unbelievable but terrible plot -- the Libyans have succeeded in putting an"
PRINT "atomic bomb somewhere in the Kremlin and the thing is set to go off in a few"
PRINT "hours!  If the bomb explodes, the Soviets will think the Americans did it and"
PRINT "launch their missiles, starting World War III!  It is your task to go into the"
PRINT "Kremlin and find the bomb and dismantle it."
PRINT : PRINT : GOSUB KeyWait
PRINT "Before you go, you stop off at the SOG supply room to get some appropriate"
PRINT "equipment...  You walk into the SOG supply room, and are greeted by Bull Durham,"
PRINT "a veteran of the Peanut Farmer's Abortive Iranian Hostage Rescue Attempt.  He"
PRINT "has a crew cut and is chewing a cigar."
PRINT
PRINT "Durham helps you with your gear and loads you into an old Plymouth and starts"
PRINT "driving toward the Kremlin.  As he drives along, he says, "; q$; "I sure hope you find"
PRINT "that sucker.  You know, they've got those things so miniaturized now that you"
PRINT "can hide one in a baby buggy."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT "Durham stops the car on a dark, deserted street.  He gets out and says, "; q$; "I"
PRINT "really hate to see you go in there alone.  Hell, this is strictly illegal, but"
PRINT "what if I went along with you?  Terrific!"; q$
PRINT
' Original answer if player refused B.D.'s company
'Durham says, "Okay, pal, I understand.  Catch you later at the Embassy."
PRINT "Your adrenalin starts pumping!  This is the one you have been waiting for -- the"
PRINT "assignment that will let you use all your training and skill, and save the world"
PRINT "besides!"
PRINT : PRINT : GOTO KeyWait
DoomClock1:
s$ = "June 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Special Features: Time limit, randomly placed bomb and monsters"
PRINT "Playing Time: 1-2 hours"
PRINT "Average Rating: 6.0/1"
PRINT
PRINT "Comment: This adventure does a nice job of conveying the tension of the"
PRINT "situation.  Every move that you make takes one minute, and the bomb goes off"
PRINT "after two hours!  Each round prints an inverse bar with the remaining minutes on"
PRINT "it.  It can really get on your nerves, which is a nice approximation of how you"
PRINT "would feel if the situation was real."
PRINT : PRINT : GOSUB KeyWait
PRINT "The maps and descriptions of the Kremlin grounds give a pretty good feel for how"
PRINT "it is laid out and what it must be like.  Descriptions and room names give"
PRINT "available exits, a very important feature in Eamons with a time limit.  Good use"
PRINT "was made of artifact types, with notes, containers, and other features in ready"
PRINT "abundance.  Jim supplies you with a full arsenal of modern weapons and special"
PRINT "equipment for the task at hand.  All in all, a well-turned-out adventure."
PRINT : PRINT : GOSUB KeyWait
PRINT "Ok, if it's so good, how come I didn't give it a higher rating?  Well,"
PRINT "essentially you have to fight and kill everyone that you meet.  While this is"
PRINT "not unusual in Eamon adventuring, I was left wondering what the Soviets would"
PRINT "make of a truckload of dead guards and KGB officers, bomb or no bomb.  Some"
PRINT "special programming for special monster relations would have been a huge plus in"
PRINT "this scenario.  Secondly, the time limit is too short to find the bomb unless"
PRINT "you happen to luck into it.  While I don't have a problem with a short time"
PRINT "limit, it offends me that there is no way (that I could discover) to figure out"
PRINT "where to look.  The Kremlin is a big place!  Lastly, I personally favor Sword &"
PRINT "Sorcery stuff and don't get real excited about contemporary settings, as a rule."
PRINT : PRINT : GOSUB KeyWait
PRINT "Eamonauts who enjoy adventures that offer some real texture to their scenarios"
PRINT "may favor this one. Hack&Slashers won't find much here to kill and maim.  The"
PRINT "puzzles are all within the normal bounds of what can be done with embedded"
PRINT "artifacts.  Because of the time limit, you may have to play it more than once"
PRINT "before you finally cover all the bases and manage to find and disarm the bomb."
PRINT "I give it a difficulty rating of (9) because of the game's complexity in"
PRINT "relation to the time limit."
PRINT
PRINT "This is a pretty unique adventure and well worth a play; there's nothing else"
PRINT "like it in Eamon."
PRINT : PRINT : GOTO KeyWait

'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version.": PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN
'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$
BS = POS(0): CC# = 0
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""
k$ = LCASE$(k$)
'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN
'
' Center a string on 80-column screen
'
Center:
PRINT SPC(INT((80 - LEN(a$)) / 2)); a$: RETURN
'
'         Emulate Apple II SPEED command
'
SlowPrint:
FOR x = 1 TO LEN(a$)
   PRINT MID$(a$, x, 1);
   FOR x1# = 1 TO a#: NEXT
NEXT
PRINT : RETURN
'
'  Psychedelic string print routine for The Lost Adventure
'
TripPrint:
c1 = 0: RANDOMIZE TIMER
FOR a = 1 TO LEN(a$)
TripPrint1:
   c = INT(RND * 15) + 1: IF c = c1 THEN GOTO TripPrint1
   c1 = c: COLOR c: PRINT MID$(a$, a, 1);
   FOR x# = 1 TO dly# / 6: NEXT
NEXT
COLOR 3: PRINT : PRINT : RETURN
'
' Can't initialize graphics screen
'
ScreenError:
SCREEN 0: WIDTH 80: CLS : ScreenErr = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the graphic intro of "; q$; "The Tomb of Y'Golonac"; q$; ", because it"
PRINT "requires an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME Start
'
' Adventure data
'
AdventureData:
DATA 21
DATA The Devil's Dungeon,Jeannette Merrill,DEVILDUN.BAS
DATA Feast of Carroll,Daniel and Jon Lilienkamp,CARROLL.BAS
DATA Crystal Mountain,Ken Hoffman,CRYSTMTN.BAS
DATA The Master's Dungeon,Jeff Allen,MASTER.BAS
DATA The Lost Adventure,Jeff Allen,LOSTADVT.BAS
DATA The Manxome Foe,Ray Olszewski,MANXFOE.BAS
DATA The Sewers of Chicago,Jeff Allen,SEWERS.BAS
DATA The Harpy Cloud,Allan Porter,HARPY.BAS
DATA The Caverns of Doom,Matthew Mullin,CAVDOOM.BAS
DATA Modern Problems,"Bonnie Anderson, Tony Barban, & Jay Thompson",MODERNPB.BAS
DATA The School of Death,Kurt Townsend,SCHOOL.BAS
DATA Dungeons of Xenon,Sam Bhayani,XENON.BAS
DATA Chaosium Caves,Sam Bhayani,CHAOSCAV.BAS
DATA The Smith's Stronghold,Allan Porter,SMITHS.BAS
DATA The Tomb of Y'Golonac,Robert Romanchuk,YGOLONAC.BAS
DATA Escape from Mansi Island,Scott Starkey,MANSI.BAS
DATA The Twin Castles,Jim Tankard,TWIN.BAS
DATA Castle of Riveneta,Robert Karsten,RIVENETA.BAS
DATA The Time Portal,Ed Kuypers,TIMEPORT.BAS
DATA Super Fortress of Lin Wang,Sam Bhayani,LINWANG.BAS
DATA The Doomsday Clock,Jim Tankard,DOOMCLOK.BAS

EDXMenuStrings:
DATA 4
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Quit "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
IF k = 4 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB YGolonac.PicLoader
'
'    The Tomb of Y'Golonac picture loader and uncompressor
'   ----------------------===------------------------------
'
SCREEN 7: CLS
pic = 0: GOSUB PicLoader: GOSUB YgolGetKey: CLS
pic = 4: GOSUB PicLoader: GOSUB YgolGetKey: CLS
pic = 8: GOSUB PicLoader: GOSUB YgolGetKey: CLS

'  Resume text mode and exit
SCREEN 0: WIDTH 80: CLS : COLOR 3
EXIT SUB

'   Wait for keypress
YgolGetKey:
a$ = INKEY$
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
RETURN

'  Load & uncompress pictures
PicLoader:
OPEN "YGOLONAC.PIC" FOR RANDOM AS #1 LEN = 6920
    GET #1, 1 + pic, picrec
    a$ = picrec.s
    p = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(p) = CVI(MID$(a$, a, 2))
       p = p + 1
    NEXT
    PUT (0, 0), pic%, PSET: a$ = ""
    GET #1, 2 + pic, picrec
    a$ = picrec.s
    p = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(p) = CVI(MID$(a$, a, 2))
       p = p + 1
    NEXT
    PUT (140, 0), pic%, PSET: a$ = ""
    GET #1, 3 + pic, picrec
    a$ = picrec.s
    p = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(p) = CVI(MID$(a$, a, 2))
       p = p + 1
    NEXT
    PUT (0, 96), pic%, PSET: a$ = ""
    GET #1, 4 + pic, picrec
    a$ = picrec.s
    p = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(p) = CVI(MID$(a$, a, 2))
       p = p + 1
    NEXT
    PUT (140, 96), pic%, PSET: a$ = ""
CLOSE : RETURN
END SUB

