' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank                         
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank              
'                                                                
'                 MULTI-ADVENTURE INTRO PROGRAM                  
'                                                                
' Classic Eamon Adventures Volume 3         Update: 19 DEC 2011  
' Converted to Eamon Deluxe by Frank Black                       
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB PicLoader (f$)

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM z AS RECORD

'  Intro picture variables
DIM SHARED pic%(1 TO 3460)
TYPE pictype
   s AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), dly#, CC1#, CC2#, CC3#, adv, adv1, adv2
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, z: CLOSE
name$ = LTRIM$(RTRIM$(z.CNAME$)): sex = z.sex: q$ = CHR$(34)

adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT
END IF
CLOSE

l$ = STRING$(80, 196)
OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Converted to Eamon Deluxe by Frank Black"
Adventure1$ = "Classic Eamon Adventures Volume 3"
author$ = author1$: adventure$ = Adventure1$

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Mantru, FCircus, BFeud, MazeQ
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
'  (Make sure graphic mode is available for intro pics)
ON ERROR GOTO ScreenError
SCREEN 7
Start:
ON ERROR GOTO 0
SCREEN 0: WIDTH 80: COLOR 3: GOSUB Title
a$ = "This is official Eamon Deluxe adventure #15": GOSUB Center: PRINT
GOSUB Title
COLOR 2: a$ = "This is official Eamon Deluxe adventure #15": GOSUB Center
COLOR 3: PRINT : PRINT
PRINT "This is the third of six collections of "; q$; "Classic"; q$; " Apple II Eamon adventures."
PRINT "The order I have selected is numerical, but also includes all of an author's"
PRINT "adventures even if they aren't in sequential order."
PRINT
PRINT "Note that there are many adventures which are not included because they are"
PRINT "already collected into another Eamon Deluxe adventure set."
PRINT
PRINT "I have enhanced most of these adventures and I hope that you enjoy playing them"
PRINT "as much as I enjoyed converting them to Eamon Deluxe."
PRINT
PRINT SPC(61); "-Frank Black"
PRINT : PRINT : GOSUB KeyWait

Menu:
author$ = author1$: adventure$ = Adventure1$: GOSUB Title
COLOR 2
FOR a = 1 TO adv2 STEP 2
   COLOR 2: IF a < 4 THEN COLOR 14
   PRINT a$(a);
   IF a + 1 <= adv2 THEN LOCATE CSRLIN, 40: PRINT a$(a + 1);
   PRINT
NEXT
PRINT : COLOR 3: k = 16: c1 = 4
CALL EDXMenuM(k, c1, 1, 4, 3, 0)
IF k < 1 OR k > 4 THEN GOTO Menu
IF k = 4 THEN CHDIR "..": RUN "EAMONDX"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Mantru, FCircus, BFeud, MazeQ
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Mantru1, FCircus1, BFeud1, MazeQ1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Mantru, FCircus, BFeud, MazeQ
IntroDone:
PRINT "(Waking up the monsters...)"
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'                              Castle Mantru
'                              -------------
Mantru:
IF ScreenErr = 0 THEN CALL PicLoader("MANTRU.PIC")
GOSUB Title
PRINT "As you leave the Main Hall, King Stevron, the King of nearby Century Castle,"
PRINT "calls to you.  He tells you that he has heard that you are a great adventurer"
PRINT "with much experience.  Therefore, he said, you were the only one for his task."
PRINT
PRINT q$; "I wish for you to go to Castle Mantru.  There the evil wizard called Crimson"
PRINT "has hidden the magical Amulet of Wisdom which he stole from me one week ago.  I"
PRINT "have waited this long because I could not find anyone to do this task for me."
PRINT
PRINT q$; "If Crimson has the amulet in his hands for too long he will be able to use its"
PRINT "powers to control the world!  But beware, it is rumored that Crimson has many"
PRINT "deadly monsters and traps set up in Castle Mantru to stop anyone that tries to"
PRINT "retrieve the Amulet of Wisdom."; q$
PRINT
PRINT "King Stevron then says he will reward you well if the amulet is brought back and"
PRINT "is not damaged.  King Stevron also says the evil wizard, Crimson, has some"
PRINT "special weapons that are yours to keep if you find them.  You will probably have"
PRINT "to kill Crimson to get out safely."
PRINT : PRINT : GOSUB KeyWait
PRINT "King Stevron then calls to his wizard who is standing behind him.  The wizard"
PRINT "casts a spell and you suddenly feel yourself flying through the air.  There is a"
PRINT "loud clap and a puff of smoke and you find yourself at the entrance to Castle"
PRINT "Mantru!"
PRINT : PRINT : GOTO KeyWait
Mantru1:
s$ = "June 1991": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Special Features: HiRes screen at startup "
PRINT "Playing Time: 1 hour"
PRINT "Reviewer Rating: 6.0"
PRINT
PRINT "Comment: This adventure isn't terribly sophisticated.  It plays much like an"
PRINT "earlier version of Eamon, with no hidden artifacts or locked doors to contend"
PRINT "with.  The descriptions and monsters are on this same level: short and simple"
PRINT "but not exactly lyrical in their content.  The 76-room map is laid out well"
PRINT "enough. [EDX NOTE: A LOT of cleaning up was done on the text in this adventure!]"
PRINT
PRINT "So while there is little of special note to make this adventure stand out, it is"
PRINT "a competently done Sword & Sorcery dungeon and well worth a play.  The Hi-Res"
PRINT "screen at the beginning of the intro is a nicely done line drawing of the Castle"
PRINT "that was a very nice touch.  As puzzles are nonexistent and the monsters are"
PRINT "suitable for mundane weapons, I give this adventure a (3) for difficulty.  All"
PRINT "in all, a superior beginner-level Eamon adventure."
PRINT : GOTO KeyWait

'                          Flying Circus
'                          -------------
FCircus:
PRINT "Good day!  We apologize most sincerely to those of you who have bought this"
PRINT "program, under the impression it was connected in any way with the humorous"
PRINT "television series, "; q$; "Monty Python's Flying Circus"; q$; ".  It is really an adventure"
PRINT "based on World War I air heroes as compiled by Oscar Tritt."
PRINT : PRINT : GOSUB KeyWait
PRINT "Good day!  We apologize for the previous apology.  That apology was unnecessary"
PRINT "and appeared on this disk owing to an administrative error."
PRINT
PRINT "This program is not as stated in the previous apology, but does contain material"
PRINT "from the humorous television series, "; q$; "Monty Python's Flying Circus"; q$; "."
PRINT : PRINT : GOTO KeyWait
FCircus1:
s$ = "June 1993": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time:  1 hour"
PRINT "Reviewer Rating:  7.0"
PRINT
PRINT "Comment:  This adventure is largely a collection of bits and pieces from "; q$; "Monty"
PRINT "Python"; q$; " skits.  If you are a fan of the show and can put the proper voices and"
PRINT "emphases to the bits, you will likely enjoy it quite a lot.  If you don't know"
PRINT "Monty Python, it won't be nearly as good.  Much of the adventure doesn't even"
PRINT "try to be overtly funny, but makes references that Python fans will enjoy"
PRINT "spotting."
PRINT
PRINT "Bring some big guns; the bad guys are fairly tough.  On the other hand, you will"
PRINT "pick up quite a few companions in your wanderings.  I never once had to use the"
PRINT "heal spell on myself, but some enemies took quite a lot of beating with my best"
PRINT "sword before they fell."
PRINT : PRINT : GOSUB KeyWait
PRINT "There is some puzzling in the form of imaginatively-hidden keys and magic"
PRINT "doorways that require the answer to a riddle before you can pass.  Be sure to"
PRINT "read descriptions closely and to examine likely-looking stuff mentioned in those"
PRINT "descriptions; that's where the answers to the riddles will be found.  Here's a"
PRINT "puzzle hint for you: what word rhymes with "; q$; "ding"; q$; " and "; q$; "dong"; q$; "?  Don't worry if"
PRINT "this makes no sense now; it will be meaningful when the time comes."
PRINT
PRINT "I give this a (7) for difficulty, because you have to be on your toes to catch"
PRINT "all of the puzzle clues.  Apart from that, it's a pretty easy play."
PRINT : PRINT : GOTO KeyWait

'                                Blood Feud
'                                ----------
BFeud:
PRINT "While sitting at the bar at the local pub, You are approached by a gnome "
PRINT "wearing a blue wool hat, glasses and smoking a cigarette."
PRINT
PRINT "He says, "; q$; "Ah, here you are!  So you're the brave warrior who has volunteered "
PRINT "for this hazardous job?  I've been told to fill you in on Blood Feud Castle "
PRINT "and the rivalry between the Pozzis and Spanners."; q$
PRINT : PRINT : GOSUB KeyWait
PRINT "Three (3) hours later he concludes his history of Blood Feud, the Pozzis and "
PRINT "the Spanners.  He then gets to his point:"
PRINT
PRINT "The evil Pseudo-Guru has stolen the Rod of Stupidity from the Royal "
PRINT "Depository and he has taken up residence at Blood Feud Castle.  Should you "
PRINT "succeed in recovering the rod, you will be given the title of Knight of the "
PRINT "Realm, and all will call you "; q$;
IF sex = 0 THEN PRINT "Sir";  ELSE PRINT "Madam";
PRINT q$; ".": PRINT
PRINT "You may keep all the possessions you find, and that includes an amulet that "
PRINT "has the power of increasing all your attributes!  The gnome then says, "; q$; "Good "
PRINT "luck!"; q$; " and disappears into a cloud of smoke."
PRINT : PRINT : GOTO KeyWait
BFeud1:
s$ = "December 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time:  1-2 hours"
PRINT "Reviewer Rating:  5.0"
PRINT
PRINT "Comment:  I have no idea what all that is about in regards to a feud.  You see"
PRINT "no one other than the Guru's guards and some oddball allies and monsters.  There"
PRINT "are a bunch of sporting artifacts lying about plus some other stuff which makes"
PRINT "me think that it all might have something to do with wherever Rick was going to"
PRINT "school at the time he wrote this thing."
PRINT
PRINT "It has 95 rooms and takes a while to explore.  It's an OK Eamon but nothing"
PRINT "special.  Some of the bad guys are really tough, so be sure to pack your magical"
PRINT "weapons.  Between the tough guys and a couple of death traps, it gets a (7) for"
PRINT "difficulty."
PRINT : PRINT : GOTO KeyWait

'                       The Maze of Quasequeton
'                       -----------------------
MazeQ:
PRINT "You heard that a group of fighters have gathered in ";
COLOR 2: PRINT "The Maze of Quasequeton.": COLOR 3
PRINT "You know that they are lead by a man called The Master.  You must find him and"
PRINT "kill him.  Good luck!"
PRINT : PRINT : GOTO KeyWait
MazeQ1:
s$ = "March 1994": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min. "
PRINT "Reviewer Rating: 4.0                            Average Rating: 3.2/4"
PRINT
PRINT "Comment:  I think that the intro story sums up the content of this adventure"
PRINT "nicely.  The dungeon map consists of a mere 18 rooms.  No special effects.  No"
PRINT "secret passages.  No companions."
PRINT
PRINT "This is classic "; q$; "hack'n'slash"; q$; " fare: kill everyone you meet and grab anything"
PRINT "that isn't nailed down.  The poll ratings on this one range from (1) from a"
PRINT "puzzle fan to (5) from a hack'n'slasher.  It's very short and simple, but it's"
PRINT "cleanly written."
PRINT
PRINT "It's very easy to complete.  Being very simple and short, it may be a good"
PRINT "choice for young Eamonauts."
PRINT : PRINT : GOTO KeyWait

'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version."
Review1a:
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
COLOR 3: PRINT : PRINT : GOTO KeyWait
'                *********************
'                  NEUC Review header
'                *********************
Review2:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the "; : COLOR 7
PRINT "National Eamon User's Club": COLOR 3
PRINT "newsletter which preceded the Eamon Adventurer's Guild.  The ratings are from"
PRINT "the EAG.  The NEUC supported the Apple II version of Eamon and not Eamon Deluxe."
PRINT "The review is for the old Apple II version.": GOTO Review1a

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN

'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$
BS = POS(0): CC# = 0
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""

'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN

'
' Center a string on 80-column screen
'
Center:
PRINT SPC((80 - LEN(a$)) / 2); a$: RETURN

'
' Can't initialize graphics screen
'
ScreenError:
SCREEN 0: WIDTH 80: CLS : ScreenErr = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the graphic intro of "; q$; "Castle Mantru"; q$; ", because it"
PRINT "requires an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME Start

'
' Adventure data
'
AdventureData:
DATA 20
DATA Castle Mantru,Steve Costanzo,MANTRU
DATA Flying Circus,Rick Krebs,FCIRCUS
DATA Blood Feud,Rick Krebs,BFEUD
DATA The Maze of Quasequeton,Brian Kondalski,MAINPGM1
DATA The House of Secrets,George Gunn,MAINPGM1
DATA Slave Pits of Kzorland,Rick Hersam,MAINPGM1
DATA Fire Island,Greg Gioia,MAINPGM1
DATA A Vacation in Europe,Dave Smith,MAINPGM1
DATA Hills of History,Dave Smith,MAINPGM1
DATA Wizard of the Spheres,Marc Elkin,MAINPGM1
DATA Nucleus of the Ruby,Keith Somers,MAINPGM1
DATA The Final Frontier,Roger Slemon,MAINPGM1
DATA Pyramid of the Ancients,"J. & R. Pirone",MAINPGM1
DATA The Ruins of Ivory Castle,Mike Greifenkamp,MAINPGM1
DATA Starfire,Ed Phillips,MAINPGM1
DATA The Infested Forest,"M. & P. Hamaoka",MAINPGM1
DATA Gartin Manor,Greg Gioia,MAINPGM1
DATA Expedition to the Darkwoods,Greg Gioia,MAINPGM1
DATA Treasure Island,Margaret Anderson,MAINPGM1
DATA The Pirate's Cave,Margaret Anderson,MAINPGM1
         
EDXMenuStrings:
DATA 4
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Quit "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB PicLoader (f$)
'  Load, uncompress and display picture
SCREEN 7
OPEN f$ FOR RANDOM AS #1 LEN = 6920
    GET #1, 1, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 0), pic%, PSET: a$ = ""
    GET #1, 2, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 0), pic%, PSET: a$ = ""
    GET #1, 3, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 96), pic%, PSET: a$ = ""
    GET #1, 4, picrec
    a$ = picrec.s
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 96), pic%, PSET
CLOSE

' Delay
a$ = INKEY$
FOR paws# = 1 TO dly# * 10
   a$ = INKEY$
   IF a$ <> "" THEN paws# = dly# * 10
NEXT

'  Resume text mode and exit
SCREEN 0: WIDTH 80: CLS : COLOR 3
END SUB

