' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                MULTI-ADVENTURE INTRO PROGRAM 5.0               
'         DUMMY (SPACE HOLDER) ADVENTURE INTRO PROGRAM           
'                                                                
' Dummy McDumdum by Frank Black            Revision: 09 JUN 2012 
'                                            Update: 09 JUN 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB Pic.Loader (a$)

DIM SHARED Adventure$, author$, q$, sex
ON ERROR GOTO ErrHandler

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM SHARED Z AS RECORD

'    Variables to load & hold picture data
DIM SHARED Pic%(1 TO 3460)
TYPE pictype
   ps AS STRING * 6920
END TYPE
DIM SHARED picrec AS pictype

' Load system settings
DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), adv, adv1, adv2, ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
    INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
    IF dungeons > 1 THEN
      DIM SHARED dn$(dungeons), dn%(dungeons, 9)
      FOR a = 1 TO dungeons
         LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
      NEXT
    END IF
CLOSE

' Load multi-adventure names
'----------------------------
adv2 = a
FOR a = 1 TO adv2: READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a): NEXT

' Init choices for EDXMenuM
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27) '(Enter, Space, Escape)
'  Load useful character data
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, Z: CLOSE
name$ = LTRIM$(RTRIM$(Z.CNAME$)): sex = Z.sex: q$ = CHR$(34)
author1$ = "Converted to Eamon Deluxe by Frank Black": author$ = author1$
Adventure1$ = "Classic Eamon Adventures Volume 5": Adventure$ = Adventure1$


' See if graphic mode is available
'----------------------------------
ON ERROR GOTO ScreenError: IF s%(4) <> 1 THEN SCREEN 7
SkreenTest:
ON ERROR GOTO 0: SCREEN 0: WIDTH 80: CLS : GOSUB Title

OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
IF ASC(MID$(name$, 1)) = 0 THEN
  COLOR 15: PRINT "WARNING! This adventure has a corrupt file. Repairing the ";
  PRINT "file and returning to": PRINT "Main System Menu...": GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1:  PRINT #1, -1
      FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF
IF a = -1 THEN
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
      a = -2: PRINT #1, a: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE
  COLOR 2: LOCATE 6: a$ = "This is Official Eamon Deluxe Adventure #17"
  GOSUB Center: LOCATE 20: GOSUB KeyWait: GOSUB Intro: GOTO Menu
END IF
IF a = -2 THEN GOTO Menu
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)

' !!! TEMP CODE
author$ = "by Frank Black"
Adventure$ = "Classic Eamon Adventures Volume 5 Construction Zone"

PRINT "Welcome back to "; Adventure$; "!": PRINT
PRINT "Do you want to read the intro story again? (Y/N):"; : GOSUB KeyWait3
IF k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Adventure0, Game1, Game2, Game3, Game4, Game5, Game6, Game7
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Header: LOCATE 8: COLOR 2
PRINT "  NONE of the adventures in this collection have actually been converted to"
PRINT "  Eamon Deluxe yet. This non-adventure is here only as a placeholder until"
PRINT "  these adventures are converted."
LOCATE 20: GOSUB KeyWait
GOSUB Header: LOCATE 8: COLOR 2
PRINT "  Visit "; : COLOR 15: PRINT "www.EamonAG.org/pages/eamondx.htm"; : COLOR 2
PRINT " for the latest Eamon Deluxe updates.": PRINT : PRINT : PRINT
PRINT "  For information regarding the conversion status of these adventures or any"
PRINT "  other questions, comments, etc., please email:"; : COLOR 15
PRINT " eamondeluxe@gmail.com"
LOCATE 20: GOSUB KeyWait
GOSUB Header: COLOR 2: LOCATE 9
PRINT "  For your amusement (and to keep the programs from crashing) a fully playable"
PRINT "  mini "; q$; "adventure"; q$; " has been included.": COLOR 3
LOCATE 20: GOSUB KeyWait
GOSUB Header: LOCATE 6: COLOR 2
PRINT "  This is the fifth of six collections of "; q$; "Classic"; q$; " Eamon adventures from"
PRINT "  the Apple II Eamon library."
PRINT
PRINT "  The selected order for these adventure sets is numerical by the official"
PRINT "  Classic Eamon adventure number, but each set also includes all of an "
PRINT "  author's adventures even if they aren't in sequential order."
PRINT
PRINT "  It should be noted that there are many Classic Eamon adventures which are"
PRINT "  not included in these volumes because they have been collected into another"
PRINT "  Eamon Deluxe adventure set. Select View Manuals from the Eamon Deluxe Main"
PRINT "  Menu and review the current Eamon Deluxe adventure list for more details."
LOCATE 20: GOSUB KeyWait
GOSUB Header: LOCATE 8: COLOR 2
PRINT "  Many of these adventures have been enhanced from their original Classic"
PRINT "  Eamon versions and I hope that you enjoy playing them as much as I enjoyed"
PRINT "  converting them to Eamon Deluxe."
PRINT : PRINT : COLOR 10: PRINT SPC(64); "Cheers,"
PRINT SPC(61); "-Frank Black"
LOCATE 20: GOSUB KeyWait

Menu:
author$ = "[Warning! Hard Hat Area: Adventures under construction!]"
Adventure$ = Adventure1$: GOSUB Title: COLOR 8
FOR a = 1 TO 10: PRINT a$(a); : LOCATE CSRLIN, 40: PRINT a$(a + 10): NEXT
COLOR 7: PRINT
k = 16: c1 = 4
CALL EDXMenuM(k, c1, 1, 5, 3, 0)
author$ = "by Frank Black": Adventure$ = "The Waiting Room!"
IF k > 5 OR c1 = 3 THEN CHDIR "..": RUN "EAMONDX"
IF k = 5 THEN GOSUB Intro: GOTO Menu
IF k = 4 THEN adv = 0: GOTO Reviews

GOSUB Pick
ON k GOTO Stories, IntroDone0, Reviews

Stories:
author$ = "by Frank Black"
Adventure$ = "Classic Eamon Adventures Volume 5 Construction Zone"
author$ = "by Frank Black": Adventure$ = "The Waiting Room!"
GOSUB Title
ON adv GOSUB Adventure0, Game1, Game2, Game3, Game4, Game5, Game6, Game7
GOTO Menu

Reviews:
author$ = "by Frank Black": Adventure$ = "The Waiting Room!"
IF adv > 0 THEN  ' AND adv <> 1
  COLOR 3: GOSUB Title1: PRINT : COLOR 2
  PRINT "Reviews have been written for both the Eamon Deluxe version of this adventure"
  PRINT "and the classic title from the original Apple II Eamon gaming system upon which"
  PRINT "it was based. Please select the version of the adventure that you wish to read"
  PRINT "the review for.": PRINT : PRINT
  c = 12: c1 = 4
  CALL EDXMenuM(c, c1, 7, 8, 3, 0)
  IF c1 = 3 THEN GOTO Menu
  IF c = 2 THEN GOTO DustyReviews
END IF
author$ = "Reviewed by Luke Hewitt"
'IF adv <> 2 THEN adventure$ = adventure$ + " Deluxe Edition"
Adventure$ = Adventure$ + " Deluxe Edition"
IF adv = 0 THEN Adventure$ = Adventure1$: Adventure$ = "The Waiting Room!"
a$ = "": IF adv < 9 THEN a$ = "0"
a1$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv)))
a$ = "": IF adv + 1 < 9 THEN a$ = "0"
a2$ = "ADVENTURE #" + a$ + LTRIM$(RTRIM$(STR$(adv + 1)))
OPEN "EDX017RV.TXT" FOR INPUT AS #1
  DO
    LINE INPUT #1, a$
  LOOP UNTIL a$ = a1$
  COLOR 2: GOSUB Title1: COLOR 3
  DO
    LINE INPUT #1, a$
    IF a$ = "<paws>" THEN
      PRINT : COLOR 2: GOSUB KeyWait2: COLOR 2: GOSUB Title1: COLOR 3
      LOCATE CSRLIN - 1: a$ = ""
    END IF
    IF a$ <> a2$ THEN PRINT a$
  LOOP UNTIL a$ = a2$
  CLOSE : GOTO Menu
DustyReviews:
GOSUB Title
author$ = "by Frank Black": Adventure$ = "The Waiting Room!"
ON adv GOSUB Adventure1, Game1, Game2, Game3, Game4, Game5, Game6, Game7
GOTO Menu

IntroDone0:
author$ = "by Frank Black"
Adventure$ = "Classic Eamon Adventures Volume 5 Construction Zone"
author$ = "by Frank Black": Adventure$ = "The Waiting Room!"
GOSUB Title
ON adv GOSUB Adventure0, Game1, Game2, Game3, Game4, Game5, Game6, Game7
IntroDone:
a$ = "(Waking up the monsters...)"
PRINT a$: FOR x# = 1 TO dly# * 2: NEXT
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

Game1:
GOTO KeyWait
Game2:
GOTO KeyWait
Game3:
GOTO KeyWait
Game4:
GOTO KeyWait
Game5:
GOTO KeyWait
Game6:
GOTO KeyWait
Game7:
GOTO KeyWait
'                          The Waiting Room!
'                         -------------------
Adventure0:
GOSUB Title: COLOR 2
PRINT "You are sitting half-asleep at the bar in the Main Hall one day when you"
PRINT "overhear a group of rough old adventurers talking earnestly to a giant, brutish"
PRINT "young adventurer. They are telling him about a mystic doorway hidden within the"
PRINT "remains of the old Main Hall."
PRINT
PRINT "This doorway, they proclaim in grave whispers, leads to a magical intersection"
PRINT "of pathways; these pathways in turn lead to many, many different adventures,"
PRINT "each one being unique and full of gold, fantastic treasures and opportunities"
PRINT "ripe for the taking...for those who dare!"
PRINT
PRINT "You continue to eavesdrop as one of the older adventurers argues with the"
PRINT "anxious young man over the value of such information. They finally come to an"
PRINT "agreement and a pouch of gold changes hands. Straining your ears, you manage to"
PRINT "overhear as one of the seasoned and scarred adventurers describes to his eager"
PRINT "audience how to locate and conjure this fantastic door."
GOSUB KeyWait: COLOR 2
PRINT "You laugh to yourself, remembering being conned out of your gold a few times by"
PRINT "mysterious strangers selling fake maps and false information when you were a"
PRINT "fresh-out-of-the-Beginner's-Cave novice adventurer. And that, you figure, is"
PRINT "most likely what you've just witnessed."
GOSUB KeyWait: COLOR 2: LOCATE 10
PRINT "But then again...": LOCATE 20
GOSUB KeyWait: COLOR 2
PRINT "It's been pretty boring lately, and you have that new enchanted elven sword"
PRINT "that you've been itching to try out."
PRINT
PRINT "You quickly finish your drink and head to your room. Once properly prepared,"
PRINT "you sneak past your friends at the bar and slip out a little-used side door in"
PRINT "the kitchen of the Main Hall. You head down the worn road towards the Beginner's"
PRINT "Cave, then cut westward into the Haunted Apple Grove. After engaging in a few"
PRINT "minor skirmishes along the way, you come to the dark and imposing remains of the"
PRINT "old Main Hall."
PRINT
PRINT "Still doubtful, you continue to follow the directions you overheard and soon"
PRINT "come to a musty old storage room. You pry a heavy bookcase from the back wall,"
PRINT "take a deep breath, and mutter a short enchantment..."
GOSUB KeyWait: COLOR 2
PRINT "Tinges of surprise and excitement wash over you as a glowing golden doorway"
PRINT "appears on the wall. You cautiously open it and step into a long dark tunnel."
PRINT
PRINT "After several minutes of walking, you come to a small plain door. Making one"
PRINT "last adjustment to your armor and weapons, you open the door and step inside..."
GOTO KeyWait

Adventure1:
s$ = "December 2069": GOSUB Review1
LOCATE 7: COLOR 2: PRINT "Review for this adventure:"
PRINT : COLOR 15: PRINT "It was great!"
LOCATE 20: GOTO KeyWait


'                  Review header
'                 ---------------
Review1:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter. The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe. The review is for the old Apple II version."
Review1a:
PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it. e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people."
PRINT : COLOR 2
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
GOTO KeyWait

'                *********************
'                  NEUC Review header
'                *********************
Review2:
GOSUB Title: a$ = "The Eamon Adventurer's Guild": COLOR 14: GOSUB Center
COLOR 2: a$ = "www.EamonAG.org": GOSUB Center: COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the "; : COLOR 7
PRINT "National Eamon User's Club": COLOR 3
PRINT "newsletter which preceded the Eamon Adventurer's Guild. The ratings are from"
PRINT "the EAG. The NEUC supported the Apple II version of Eamon and not Eamon Deluxe."
PRINT "The review is for the old Apple II version.": GOTO Review1a


'                  Select adventure
'                 ------------------
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
Adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv): RETURN


KeyWait:
COLOR 3
KeyWait1:
PRINT : PRINT
KeyWait2:
PRINT "Press any key to continue...";
KeyWait3:
k$ = INKEY$: BS = POS(0): CC# = 0
DO
   IF s%(4) <> 1 THEN
     CC# = CC# + 1
     IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, BS
     IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
     IF CC# = CC3# THEN : PRINT "\": LOCATE CSRLIN - 1, BS: CC# = 0
   END IF
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

Title:
COLOR 3
Title1:
CLS : a$ = Adventure$: GOSUB Center: a$ = author$:
GOSUB Center: PRINT STRING$(80, 196): PRINT : RETURN

Center:
PRINT SPC(INT((80 - LEN(a$)) / 2)); a$: RETURN

'              AD Menu Header 5.0
'             --------------------
Header:
mc1 = 1: mc2 = 15: mc3 = 7: COLOR 7: CLS
IF s%(4) = 1 THEN RETURN
COLOR mc1, 0: PRINT " "; STRING$(76, ""); ""
'PRINT " "; SPACE$(76); ""
PRINT " "; SPACE$(20); : COLOR mc2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR mc1: PRINT SPACE$(20); "": PRINT " "; SPACE$(21); : COLOR mc2
PRINT "Classic Eamon Adventures Volume 5"; : COLOR mc1: PRINT SPACE$(22); ""
'PRINT " "; SPACE$(76); ""
PRINT " "; STRING$(76, ""); "": PRINT : COLOR 7: RETURN

'                       -----------
'                        Error Pit
'                       -----------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; STR$(ERR); ")": PRINT
k$ = "try and continue": IF ERR > 51 THEN k$ = "exit to Main Menu"
PRINT SPACE$(20); "Hit any key to "; k$; "...": k$ = INKEY$: k$ = ""
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : L = 0: COLOR 7: RESUME NEXT

ScreenError:
SCREEN 0: WIDTH 80: CLS : SkreenTest = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the graphic intro screen for "; q$; "[GAME NAME]"; q$; ","
PRINT "because compatible graphics hardware is not available."
GOSUB KeyWait: RESUME SkreenTest

AdventureData:
DATA 20
DATA Eamon Renegade Club,Phil Schulz,MAINPGM
DATA Assault on Helstar,Phil Schulz,MAINPGM
DATA Apocalypse 2021,Hoyle Purvis,MAINPGM
DATA Return of Ngurct,Hoyle Purvis,MAINPGM
DATA Lair of the Marauders,Hoyle Purvis,MAINPGM
DATA Haunted Keep,Hoyle Purvis,MAINPGM
DATA Demongate,Hoyle Purvis,MAINPGM
DATA Deathstalker's Castle,Phil Schulz,MAINPGM
DATA Eye of Agamon,Hoyle Purvis,MAINPGM
DATA Return to Pendrama,Hoyle Purvis,MAINPGM
DATA The City of Sorcerers,Roger Osgood,MAINPGM
DATA Catacombs of Terror,Phil Schulz,MAINPGM
DATA Time-Shift,Corey Sena,MAINPGM
DATA Prisoner of Darkness,Phil Schulz,MAINPGM
DATA Shipwreck Island,Ron Ledbetter,MAINPGM
DATA Firestorm,Phil Schulz,MAINPGM
DATA Well of the Great Ones,Mike Ellis,MAINPGM
DATA Keep of Skull Gorge,Don Kellogg,MAINPGM
DATA Jewel of Yara,Hoyle Purvis,MAINPGM
DATA Domain of Zenoqq,Robert Claney,MAINPGM

EDXMenuStrings:
DATA 8
DATA "  Preview Adventure Intros          "
DATA "  START PLAYING AN ADVENTURE        "
DATA "  Read Adventure Reviews            "
DATA "  Read Review for This Collection   "
DATA "  Read Notes About This Collection  "
DATA "  Return to Eamon Deluxe Menu    "
DATA "  Review of the Eamon Deluxe Version   "
DATA "  Review of the Classic Eamon Version  "

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
' (Updated for VI Mode support 06 JAN 2012)
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

' VI Mode numeric menu
GetMAdvCVI:
IF s%(4) = 1 THEN
  CLS : L = 2: PRINT "Please select an adventure:"
  FOR c = 1 TO dungeons
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + dn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to Exit):";
  LINE INPUT ""; a$: c = INT(VAL(a$))
  IF c < 0 OR c > dungeons THEN CLS : GOTO GetMAdvCVI
  'IF c = 0 THEN RUN 0
  a$ = dn$(c): EXIT SUB
END IF


' Standard Menu
'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(13) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>                     <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
' (Updated with alt. numeric menu for VI Mode support 06 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:
'    s%() - Eamon DX system settings (s%(4) = 1 is VI Mode Flag)
'   em$() - An array which holds all available choices. em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'

' VI Mode numeric menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  L = 2
  FOR x = be TO en
     x$ = LTRIM$(STR$(x - be + 1)) + ": " + LTRIM$(RTRIM$(em$(x)))
     IF x < 100 THEN x$ = " " + x$: IF x < 10 THEN x$ = " " + x$
     PRINT x$: L = L + 1
     IF L = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       CLS : L = 0
     END IF
  NEXT
  PRINT : PRINT "Enter the number of your choice (0 to exit):";
  LINE INPUT ""; k$: c = INT(VAL(k$)): c1 = c + (be - 1)
  IF c = 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB Pic.Loader (a$)
'    Intro picture loader and uncompressor
'    (Call Sub with a$ = file name of pic)
'   ---------------------------------------
' Exit if in VI Mode
IF s%(4) = 1 THEN CLS : COLOR 7: EXIT SUB
SCREEN 7
OPEN a$ + ".PIC" FOR RANDOM AS #1 LEN = 6920
    GET #1, 1, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 0), Pic%, PSET: a$ = ""
    GET #1, 2, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 0), Pic%, PSET: a$ = ""
    GET #1, 3, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (0, 96), Pic%, PSET: a$ = ""
    GET #1, 4, picrec
    a$ = picrec.ps
    pz = 1
    FOR a = 1 TO 3460 * 2 STEP 2
       Pic%(pz) = CVI(MID$(a$, a, 2))
       pz = pz + 1
    NEXT
    PUT (140, 96), Pic%, PSET
CLOSE

'  Pause, resume text mode and exit
'
FOR x# = 1 TO dly# * 10: NEXT
LOCATE 24, 5: PRINT "(Hit any key to continue)"; : a$ = INKEY$
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
SCREEN 0: WIDTH 80: CLS : COLOR 3

END SUB

