' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                    ADVENTURE INTRO PROGRAM                     
'                                                                
' Mission for the Eamon Republic: Journey Across The Muerte Sea  
'      by John MacArthur                             19 JUL 2004 
'   Debugged by Frank Black                Released: 05 JAN 2005 
'                                            Update: 27 JAN 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
adventure$ = "Journey Across The Muerte Sea"
author$ = "John MacArthur": q$ = CHR$(34)

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: A1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: SEX AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM Z AS RECORD

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, Z: CLOSE
name$ = LTRIM$(RTRIM$(Z.CNAME$)): SEX = Z.SEX

FOR a = 1 TO 80: L$ = L$ + CHR$(196): NEXT
OPEN "GAMEDIR.DAT" FOR INPUT AS #1
INPUT #1, a
CLOSE

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu."
  PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF
IF a = -2 THEN GOTO Intro
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone

Intro:
COLOR 2: a$ = "This is official Eamon Deluxe adventure #20": GOSUB Center
COLOR 3: LOCATE 20: GOSUB KeyWait
PRINT "Notes:": PRINT
PRINT "I received this adventure in the summer of 2004.  After exchanging some emails"
PRINT "with the author about a few bugs that needed to be worked out, I lost contact"
PRINT "with him."
PRINT
PRINT "I finally decided to go ahead and debug it myself.  I made no major changes to"
PRINT "the story, puzzles, or general gameplay.  However I did re-write a lot of the"
PRINT "program code, edited some mistakes on the map, tied up some loose ends, added"
PRINT "some HINTs, did a spelling check on all the text, adjusted the stats on some"
PRINT "monsters, and added the ending text.  All in all I spent several days getting"
PRINT "this ready for release."
PRINT : PRINT : GOSUB KeyWait
PRINT "I feel I must note that the author had put a lot of time and work into a new"
PRINT "routine to handle doors.  While it was well done, it had some bugs and wasn't"
PRINT "really crucial to gameplay.  Because of the bugs, and because I lost contact"
PRINT "with him, I removed it completely and used the standard Eamon Deluxe door"
PRINT "handling routines and artifacts."
PRINT
PRINT "I am, of course, keeping a copy of the original version in the Eamon Deluxe "
PRINT "archives; if anybody wishes to see it, let me know."
PRINT
PRINT SPC(57); "- Frank Black": PRINT SPC(55); "February 11, 2005"
PRINT : PRINT : PRINT : PRINT
PRINT "Please send questions, comments, etc. to: "; : COLOR 2
PRINT "eamondeluxe@gmail.com": COLOR 3
PRINT "Download new Eamon Deluxe adventures and updates from: "; : COLOR 2
PRINT "www.EamonAG.org": COLOR 3
PRINT : GOSUB KeyWait
PRINT "Do you wish to view the author's notes? (Y/N) "; : GOSUB KeyWait1
IF UCASE$(k$) = "Y" THEN GOSUB Authors.Notes

a$ = "IN THE BEGINNING": GOSUB SubTitle
PRINT "In the beginning, the four gods created your world.  There was the god of fire,"
PRINT "the god of water, the god of air, and the god of earth.  Each created the world"
PRINT "with their element.  It was supposed to create peace between the otherwise"
PRINT "competitive gods.  However, discord between them was only increased!"
PRINT
PRINT "The gods each believed that their element was the best element.  They quickly"
PRINT "battled each other in the Muerte Sea separating the continents.  Eventually,"
PRINT "this ocean was barred from the rest of the world.  Nobody, man or beast, dared"
PRINT "cross the sea, especially the southern part!"
PRINT
PRINT "The three continents were named thus:": PRINT
COLOR 12: PRINT "Republica", ; : COLOR 2: PRINT "Grancasa", ; : COLOR 5
PRINT "Malcarcel": COLOR 3
PRINT
PRINT "Grancasa was the home of your people for thousands of years.  Eventually, it"
PRINT "split into three empires: ";
COLOR 12: PRINT "The RU Empire, "; : COLOR 5: PRINT "The Orntec Empire, ";
COLOR 2: PRINT "The Yrma Empire"; : COLOR 3: PRINT "."
PRINT : GOSUB KeyWait
COLOR 12: PRINT "The RU Empire": PRINT "=== == ======": COLOR 3: PRINT
PRINT "RU is an abbreviation for something in the ancient language, but its meaning had"
PRINT "been lost over the centuries.  It generally had the happiest people.  The"
PRINT "natural resources were plenty, the quality of life was good, and the economy was"
PRINT "excellent."
PRINT
PRINT "However, there were problems.  Number one was that most of the northern third"
PRINT "had unlivable weather conditions.  There were mountains at least 10 miles up,"
PRINT "and temperatures could easily reach -45 degrees Celsius.  There were resources"
PRINT "there, but nobody could go there to mine them."
PRINT
PRINT "Secondly, much of their economy depended on trade.  As the Yrma Empire sought to"
PRINT "lower its relationships with the other empires, its economy started the"
PRINT "inevitable collapse.  The fact that the Yrma Empire was secretly increasing ties"
PRINT "with the Orntec Empire didn't help things much."
PRINT : GOSUB KeyWait
COLOR 12: PRINT "The RU Empire (continued)": PRINT "=== == ======": COLOR 3: PRINT
PRINT "Thirdly, the governments of each of the Empires signed a treaty that split the"
PRINT "empires up into different ethnic groups.  This was supposed to end genocide and"
PRINT "other crimes against humanity that were supposedly going on in all three"
PRINT "empires.  However, this split the majority of the population from the natural"
PRINT "resources.  The RU Empire was split into Rusa, Furioso, Vaal, and Frioland.  The"
PRINT "countries of Furioso and Rusa longed for the olden days, and Vaal and Frioland"
PRINT "liked how it was now."
PRINT
PRINT "This caused the economy of Rusa to collapse.  In 2163, a person in the RU wrote"
PRINT "a book called "; q$; "New Socialism"; q$; " that suggested that the government become more"
PRINT "involved in the economy and destroy free enterprise.  Instead, everybody would"
PRINT "get an equal amount of money, food, water, liquor, etc.  Less than ten years"
PRINT "later, in 2171, Malther (whose first name is unknown) overthrew the government,"
PRINT "thinking that he could make everybody happy by implementing many of the ideas!"
PRINT : GOSUB KeyWait
COLOR 5: PRINT "The Orntec Empire": PRINT "=== ====== ======": COLOR 3: PRINT
PRINT "Orntec means central in the ancient language.  It is the center of commerce, and"
PRINT "rightfully so, because its small size is deceiving!  It has the most natural"
PRINT "resources of any of the empires.  This seems very good; however, this empire has"
PRINT "extreme problems with crime!  Its police force is small, the burglars settle"
PRINT "here because it is the most best off, and the government hasn't done much to"
PRINT "stop it.  However, from extreme pressure with the people, they made an agreement"
PRINT "with the Yrma Empire which would ship all the criminals over to their empire."
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT "The Yrma Empire": PRINT "=== ==== ======": COLOR 3: PRINT
PRINT "The Yrma empire is a militaristic empire.  Its military is at least triple the"
PRINT "size of Orntec's and RU's combined!  It is the sole owner of the Malcarcel"
PRINT "continent, which it uses as a prison colony.  It is guarded extremely well, is"
PRINT "very large, and allows criminals to start their lives over again.  This was a"
PRINT "large concern of the people ("; q$; "What if they got away?"; q$; ")!"
PRINT : PRINT : GOSUB KeyWait
PRINT "The Yrma and Orntec Empires made a deal to trade only with each other.  However,"
PRINT "this got sharp criticism from the RU Empire when they found out in 2160.  This"
PRINT "almost caused a war to break out.  However, some quick thinking by the UI"
PRINT "(United Islands, I'll get to them in a minute) and the Free Republic could"
PRINT "have saved the world (for about ten years), before the inevitable happened."
PRINT
PRINT "All three world leaders signed the "; q$; "Treaty of Alliance"; q$; " that would stop all"
PRINT "future wars (supposedly).  It called for the splitting of the empires into"
PRINT "separate countries.  This ended making all but two nations unhappy:  Rusa and"
PRINT "Furioso from the RU Empire!"
PRINT
PRINT "Not that there wasn't some people who liked it.  The Puent people were finally"
PRINT "united after many years of separation under two empires.  The Nocambio island,"
PRINT "part of the Orntec Empire, finally got to close ties with other nations.  But"
PRINT "the RU Empire wanted to stay together, except for Vaal and Frioland, which had"
PRINT "exclusive access to most of the RU Empire's resources!": PRINT
GOSUB KeyWait
a$ = "WAR BREAKS OUT": GOSUB SubTitle
PRINT "Things did not look good.  When Malther rose to power in Rusa, he renamed it the"
PRINT "Rojo Empire, made the country a total communist dictatorship, and set out to"
PRINT "create a large-scale army, that even the Yrma empire wasn't ready to fight!"
PRINT
PRINT "Malther ignored the tiny fact that the Treaty of Alliance forbid an army above"
PRINT "10,000 men.  This raised sharp criticism from other nations.  He sent the army"
PRINT "to the border of Furioso, another violation.  But the other nations were"
PRINT "enjoying peace, and didn't want to be the ones to declare war first."
PRINT
PRINT "They weren't.  After Furioso and Rojo united in 2175 (a third violation), the"
PRINT "two empires marched into Vaal, which had declared itself neutral!  This sparked"
PRINT "a WORLD WAR!!  Even the Free Republic joined the war.  However, in late 2176,"
PRINT "the country of Vaal fell to the communists.  However, the Rojo Empire knew that"
PRINT "marching troops through was too expensive.  They came up with a terrible,"
PRINT "horrifying plan to take over nations."
PRINT : GOSUB KeyWait
PRINT "In the country of Frioland, the president was at a theatre watching a play,"
PRINT "when . . . . ."
PRINT
IF s%(4) <> 1 THEN
  COLOR 15, 12: PRINT " B    O    O   M  ! ! !  ": COLOR 3, 0
END IF
IF s%(4) = 1 THEN PRINT "BOOM!"
PRINT
PRINT "There was an explosion.  The communist forces were above, dropping bombs"
PRINT "everywhere.  They sent ground troops too, that killed anyone who got in their"
PRINT "way.  This was a "; : COLOR 15, 12: PRINT "BLITZKREIG!!": COLOR 3, 0
PRINT
PRINT "It took only two weeks for the communists to seize control of the government!"
PRINT "The other world powers, realizing that the worst was coming, had a meeting with"
PRINT "the king of the Rojo Empire.  They drew up another treaty saying that the Rojo"
PRINT "Empire could keep all of its existing countries, but no new invasions of other"
PRINT "countries.  The king signed it.  The president of the UI went home waving the"
PRINT "treaty in the air and rejoicing that he had signed it!"
PRINT : COLOR 12: PRINT "Except for one thing:": COLOR 3: PRINT : GOSUB KeyWait
COLOR 15, 12: PRINT " MATHER'S WORD COULD NOT BE TRUSTED! ": COLOR 3, 0: PRINT
PRINT "Less than two months after the treaty was signed, Malther attack Orntec!  The"
PRINT "country fell in three weeks.  The Nocambio nation promised to support Orntec,"
PRINT "but never did."
PRINT
PRINT "Many countries fell to the Rojo Empire, including Puente, Yrma, and the"
PRINT "Central Territory but the worst thing they did was:"
PRINT : PRINT : GOSUB KeyWait
COLOR 15, 12
FOR i = 1 TO 10
   PRINT "                                    "; : LOCATE , 1
   FOR j# = 1 TO dly# / 1.5: NEXT
   PRINT " B      O        O        M   ! ! ! "; : LOCATE , 1
   FOR j# = 1 TO dly# / 1.5: NEXT
NEXT
COLOR 3, 0: PRINT : PRINT : PRINT
PRINT "They dropped two atomic bombs on the continent of Malcarcel, flattening it!"
PRINT "There was nowhere to put criminals anymore.  Malther claimed that an individual"
PRINT "had done it, but at that point, nobody trusted Malther!"
PRINT : PRINT : GOSUB KeyWait
a$ = "THE RESISTANCE": GOSUB SubTitle
PRINT "The United Islands of Sur (or just the UI) was a small country that never was"
PRINT "part of an empire.  It was the country that felt it was necessary to split up"
PRINT "the empires to preserve the peace (to some degree).  Although the plan worked in"
PRINT "the beginning, they received sharp criticism for not realizing what Malther was"
PRINT "capable of."
PRINT
PRINT "The Free Republic was a nation that shared the continent of Republica with a"
PRINT "country called Oeste.  It, along with Oeste, supported the countries that were"
PRINT "being taken over and tried to stop the Rojo Empire.  It didn't work.  Twenty"
PRINT "years after the conquest of Vaal, the Empire was unstoppable."
PRINT : GOSUB KeyWait
a$ = "THE EAMON ADVENTURER'S GUILD": GOSUB SubTitle
PRINT "You went into the bar one afternoon after an adventure that nearly killed you."
PRINT "You realized that the 5 1/2 % sign was up, signalling that you were supposed to"
PRINT "report to EAG headquarters immediately.  You went into the kitchen, entered the"
PRINT "walk-in freezer, and turned the temperature dial to -12 1/2 degrees.  The wall"
PRINT "slowly opened, revealing EAG headquarters."
PRINT
PRINT q$; "You're late!"; q$; " snapped General Zuchowksi."
PRINT
PRINT "Everybody looks at you.  You realize that you'd better behave or you'll be"
PRINT "beheaded."
PRINT
PRINT q$; "Well, now that we're all here . . . ."; q$; " said the general, looking at you."
PRINT
PRINT q$; "As you know, the Rojo Empire has been conquering, attacking, and destroying our"
PRINT "allies.  Right now, we stand no chance of winning this war as we ourselves have"
PRINT "lost thousands of troops."
PRINT : GOSUB KeyWait
PRINT q$; "However, we aren't going to stop trying.  There is one thing that might turn"
PRINT "Nocambio against them.  I am talking about the control potion."
PRINT
PRINT "We have one person who is familiar with the legend..."; q$; "  He turns to face you."
PRINT q$; "You may take three people with you to locate it."; q$
PRINT
PRINT q$; "How am I supposed to find something that I'm not even sure exists?"; q$
PRINT
PRINT q$; "Oh, it exists all right.  Somebody tried to slip it into the president's drink!"
PRINT "Is that enough evidence?"; q$
PRINT
PRINT q$; "@*!&$!  All right, may I see the files for Brian Gendreau, David Lechner, and"
PRINT "Russell Lewis?"; q$
PRINT : PRINT : GOSUB KeyWait
'
COLOR 7: PRINT "Brian Gendreau        HD: 25    AG: 20    CH: 17"
PRINT : PRINT "Spells: Power": PRINT : PRINT "Equipment:"
PRINT "Sangre.................Sword.........4D8": PRINT
PRINT "Plate Armour + Shield": PRINT : PRINT "Comments:": PRINT "========="
PRINT
PRINT "Very powerful.  He inherited the sword, "; q$; "Sangre"; q$; " which is the only sword"
PRINT "to every slay a sea dragon.  However, his brains haven't kept up."
COLOR 3: PRINT : PRINT : GOSUB KeyWait
'
COLOR 7: PRINT "David Lechner        HD: 21    AG: 23    CH: 19"
PRINT : PRINT "Spells: Power   Heal   Speed": PRINT : PRINT "Equipment:"
PRINT "Battle Axe.............Axe...........2D10": PRINT
PRINT "Chain Armour + Shield": PRINT : PRINT "Comments:": PRINT "========="
PRINT
PRINT "Only several years out of adventuring school.  He has not gone on many"
PRINT "adventures but has proved himself worthy of any task the EAG requires."
COLOR 3: PRINT : PRINT : GOSUB KeyWait
'
COLOR 7: PRINT "Russell Lewis        HD: 21    AG: 25    CH: 12"
PRINT : PRINT "Spells: Blast  Heal": PRINT : PRINT "Equipment:"
PRINT "Machine gun............Bow/missle...8D3": PRINT
PRINT "Leather Armour + Shield": PRINT : PRINT "Comments:": PRINT "========="
PRINT
PRINT "Quit adventuring school early to go on adventures.  He's proven himself worthy"
PRINT "but is not very good at following order and loves fooling around.  However, his"
PRINT "skills remain unmatched except by a few."
COLOR 3: PRINT : PRINT : GOSUB KeyWait
'
PRINT "You set out to the Muerte Sea, where there are three islands, according to"
PRINT "legend.  Nobody has successfully crossed this sea.  However, on each island is"
PRINT "an artifact from the god that inherited it.  On one island is a jar of pure"
PRINT "water, on another is a jar of pure air, and on the last island is a torch"
PRINT "lighted with pure fire."
PRINT
PRINT "The legend says that if the water is lit with the fire in the presence of the"
PRINT "air, a potion will be created, personalized for the person who called it forth."
PRINT "They can give the potion to anybody to control them.  One catch:  you must be"
PRINT "strong enough to control the person, otherwise you and the person will die."
PRINT : PRINT : GOSUB KeyWait
LOCATE 5: PRINT "So off you went.  However, suddenly:": PRINT
FOR j# = 1 TO dly# * 3: NEXT
COLOR 15, 12: PRINT " B    O    O   M  ! ! !  "; : LOCATE , 1: COLOR 3, 0
PRINT : PRINT
PRINT "The next thing you see is two of your companions, dead!  They are Lechner and"
PRINT "Russell Lewis.  And nobody was supposed to know about your mission . . . . . ."
PRINT : PRINT : GOSUB KeyWait

IntroDone:
PRINT "(Waking up the monsters...)":FOR x# = 1 TO dly# * 2: NEXT
RUN "MUERTE"


'----------------------------------------------------------------------------
' Wait for keypress
'
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$: BS = POS(0): CC# = 0
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = UCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: GOTO Title
END IF
' Standard rtn
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, BS
   IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
   IF CC# = CC3# THEN
     PRINT "\": LOCATE CSRLIN - 1, BS: CC# = 0
   END IF
   k$ = INKEY$
LOOP UNTIL k$ <> ""

'----------------------------------------------------------------------------
' Clear screen and print adventure name and author
'
Title:
CLS
a$ = adventure$: GOSUB Center: a$ = "by " + author$: GOSUB Center
PRINT L$: PRINT : RETURN

'----------------------------------------------------------------------------
' Center a string on 80-column screen
'
Center:
PRINT SPC(INT((80 - LEN(a$)) / 2)); a$
RETURN

'----------------------------------------------------------------------------
' Center string in between colored walls
'
SubTitle:
CLS : COLOR 0, 3: FOR i = 1 TO 10: PRINT STRING$(80, " "): NEXT
COLOR 12, 0: GOSUB Center: COLOR 0, 3
FOR i = 1 TO 10: PRINT STRING$(80, " "): NEXT
COLOR 3, 0: SLEEP 2: a$ = INKEY$: GOTO Title

'----------------------------------------------------------------------------
' Author's notes
'
Authors.Notes:
GOSUB Title
PRINT "This is the first Eamon Deluxe-specific adventure, not counting the Demo"
PRINT "Adventure.  I have made many modifications to the base program.  The only ones"
PRINT "that you'll need to be concerned about are:"
PRINT
PRINT "1.) New command:  WAIT.  This command is a good command to use when you want to"
PRINT "wait for something to happen.  Otherwise, it just wastes moves."
PRINT
PRINT "2.) New command:  ORDER.  Use the following syntax."
PRINT
PRINT "Your command-> ORDER <MONSTER>"
PRINT
PRINT "To use what? <ARTIFACT>"
PRINT
PRINT "3.) New command:  KISS.  Use the following syntax."
PRINT
PRINT "Your command-> KISS <MONSTER>"
PRINT : PRINT : GOSUB KeyWait
PRINT "Here are some Eamon Deluxe tips:"
PRINT
PRINT "1.) You must REMOVE items from containers to interact with them."
PRINT
PRINT "2.) USE is a generic command.  It is a consolidation of a bunch of commands that"
PRINT "I would have separated if I had had time to debug a half dozen routines."
PRINT
PRINT "3.) If you die, a screen will pop up allowing you to restart the game."
PRINT
PRINT "4.) LOOK finds NOTHING extra.  However, EXAMINE find loads of stuff:  Nearly"
PRINT "half of the artifacts are embedded or otherwise hidden.  Some are multiply"
PRINT "embedded."
PRINT : PRINT : GOSUB KeyWait
LOCATE 5
PRINT "Finally, this is my first Eamon adventure.  If you have any comments, questions,"
PRINT "whatever, feel free to contact me at: "; : COLOR 2
PRINT "[Invalid contact info removed 12/18/2011]": COLOR 3
'PRINT "j.b.macarthur@worldnet.att.net": COLOR 3
PRINT
PRINT "And now, Journey Across the Muerte Sea . . . . "
PRINT : PRINT : GOSUB KeyWait
RETURN

