' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                BASE ADVENTURE INTRO PROGRAM 5.0                
'                                                                
'  A Runcible Cargo                        Revision: 04 JUN 2012 
'  by Thomas Ferguson                        Update: 04 JUN 2012 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DIM SHARED adventure$, author$, q$, sex
ON ERROR GOTO ErrHandler

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: A1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: ae AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM SHARED Z AS RECORD

adventure$ = "A Runcible Cargo": author$ = "by " + "Thomas Ferguson"
' Load system settings
DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE
' Init choices for EDXMenuM
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27) '(Enter, Space, Escape)
'  Load useful character data
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, Z: CLOSE
name$ = LTRIM$(RTRIM$(Z.CNAME$)): sex = Z.sex: q$ = CHR$(34)

SCREEN 0: WIDTH 80: CLS : GOSUB Title

OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
IF ASC(MID$(name$, 1)) = 0 THEN
  COLOR 15: PRINT "WARNING! This adventure has a corrupt file. Repairing the ";
  PRINT "file and returning to": PRINT "Main System Menu...": GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1:  PRINT #1, -1
      FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF
IF a = -1 THEN
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
      a = -2: PRINT #1, a: FOR m = 1 TO 5: PRINT #1, "(none)": NEXT
  CLOSE
END IF
IF a = -2 THEN GOTO Intro0
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to read the intro story again? (Y/N):"; : GOSUB KeyWait3
IF k$ <> "Y" THEN GOTO IntroDone

Intro0:
GOSUB Title: a$ = "This is Official Eamon Deluxe Adventure #22"
LOCATE 7: COLOR 2: GOSUB Center: LOCATE 20: GOSUB KeyWait
Intro:
c = 10: c1 = 23: CALL EDXMenuM(c, c1, 1, 2, 7, 0): GOSUB Title
IF c1 = 3 THEN CHDIR "..": RUN "EAMONDX"
IF c = 2 THEN GOSUB AdventureReview: GOTO Intro
LOCATE 7: COLOR 2
PRINT "Admittedly, you don't know how you got here, but a relaxing, if uncanny, sunset"
PRINT "greets your gaze."
PRINT
PRINT "But you have unexpected company, in the form of an incredibly large rabbit.": PRINT
PRINT "Being a seasoned Eamonaut, a rabbit of this stature should seem pedestrian. You,"
PRINT "after all, have battled wizards with rocket launchers and engaged in space"
PRINT "opera with broadswords..."
PRINT
PRINT "...so why does this rabbit unnerve you so?": LOCATE 20
GOSUB KeyWait

IntroDone:
LOCATE 7: PRINT "(Waking up the monsters...)": FOR x# = 1 TO dly# * 3: NEXT
RUN "RUNCIBLE"

'           ---> Insert adventure review(s) here <---
AdventureReview:
x$ = author$: author$ = "Reviewed by Frank Black": GOSUB Title0
COLOR 15: PRINT "Eamon Deluxe version: 5.0"
PRINT "Playing time: 6-8 hours!"
PRINT "Reviewer rating: 9.5 out of 10           Average rating: 9.5/1"
PRINT : COLOR 7
PRINT "Comment: Above is the ENTIRE intro text, which, when paired with the author"
PRINT "warning me ahead of time that he had little programming experience and had never"
PRINT "written an Eamon before, led me to believe I was in for a mildly entertaining,"
PRINT "Alice in Wonderland type hack'n'slash fest. But looks can be deceiving and A"
PRINT "Runcible (look it up) Cargo is a good example of that. Weighing in at 102 rooms,"
PRINT "141 artifacts, 39 monsters and *162* effects, this nearly 17,000 word Eamon"
PRINT "Deluxe original is best described as an interactive novel with a real sense of"
PRINT "urgent adventure and rich with the flavor of Classic Eamon Lore. Indeed there"
PRINT "are so many references to the Main Hall regulars and various classic adventures"
PRINT "across the board that I was left dazed in a fantastic sort of way."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "I initially sat down with my girlfriend at 1 a.m. one night, expecting to play"
PRINT "through this adventure in an hour or less, make a few notes about bugs and typos"
PRINT "and whip out a quick review. Three hours later I looked over to see her"
PRINT "literally shudder while reading a description of a creepy figure outside a hotel"
PRINT "window and felt a slight chill wash over myself as well. It had somehow become"
PRINT "4 a.m. and neither of us had noticed, being completely entranced in Mr."
PRINT "Ferguson's well crafted little world. I had to force myself to save the game and"
PRINT "go to sleep, doing a quick 'seen flag' count told me that, after three hours of"
PRINT "game play, we had only been to less than half of the rooms in this adventure."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "It took several days for me to set aside enough time to continue the adventure"
PRINT "properly. I was playing it alone this time, picking up right where we had left"
PRINT "off and it still took me another three hours to complete it. Six hours total"
PRINT "game play and I know Eamon Deluxe inside and out! Plus I was cheating slightly"
PRINT "by already having a map and adding some code to list all the embedded artifacts"
PRINT "in each room so I didn't have to waste time examining every item in the rich and"
PRINT "verbose room descriptions. In fact there are very few descriptions in the entire"
PRINT "adventure that are under 200 characters long or that are repetitious of each"
PRINT "other. Indeed even the average empty N/S corridor-type rooms are treated to"
PRINT "their own rich and very individual descriptions."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "I can't praise the author's excellent writing style enough. As I mentioned, I"
PRINT "felt completely drawn into his creation. He has a definite mastery over words"
PRINT "and you can feel how much fun he is having with them as he builds his"
PRINT "interesting images around you. Verbose to the point of almost being ridiculous"
PRINT "at times, clever puns and inside Eamon references everywhere, and somehow"
PRINT "managing to be light-hearted and often funny while still portraying a strong"
PRINT "sense of mood and urgency. I have played over 200 Eamon adventures, some of them"
PRINT "having been very good, and still I have never been as entertained or taken as"
PRINT "many notes as I did wile playing A Runcible Cargo."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "While the initial rooms have sort of a dreamy (for a good reason) feel to them,"
PRINT "and match up well with the simple intro text, you soon move into another area"
PRINT "and the action starts immediately. I had to laugh at myself as I noticed I was"
PRINT "gripping my chair and my heart was racing at one point, something that doesn't"
PRINT "normally happen to me from any form of media. As you progress through the"
PRINT "adventure the mood shifts perfectly to match the various settings and it is"
PRINT "obvious that the author took great care to even the smallest details which make"
PRINT "it much more realistic than the average Eamon. As I mentioned, there is an area"
PRINT "of intense action near the start. Things slow down a bit afterwards and you are"
PRINT "left to wander the large map at your leisure, however the sense of urgency never"
PRINT "really goes away and the author takes great care to let you have your freedom"
PRINT "but never really lets you stray too far from his preferred path."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "In fact you can mostly ignore the usual hints, heal spell and frequent saving"
PRINT "that accompanies most complex adventures. The author is very fair to the player"
PRINT "and seems more interested in entertaining you than killing you off, which is"
PRINT "refreshing in an Eamon adventure. He also offers multiple ways for you to finish"
PRINT "the game with varying consequences which further adds to the realism and leaves"
PRINT "the player well satisfied as they exit the adventure."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "The various well done moods in a myriad of interesting settings and all the"
PRINT "references to Eamon Lore that are thrown in make it a real treat to play for"
PRINT "both experienced Eamon gamers and those new to the system. If you know your"
PRINT "Eamon history and have played most of the adventures, you will be amazed at the"
PRINT "amount of "; q$; "throwbacks"; q$; " that the author has made. The most obvious of all"
PRINT "possibly being a wagon you come across near the start which contains a ray gun"
PRINT "and a sword; this is no accident or random artifact placement but rather a well"
PRINT "done symbol of the diversity and strangeness of Eamon. The adventure itself"
PRINT "could be described as one big tribute to/celebration of Eamon. He even went as"
PRINT "far as to incorporate one of the worst Eamons ever made, The Eamon Railroad,"
PRINT "which is placed perfectly amidst this masterpiece of interactive fiction and I"
PRINT "enjoyed quite a bit."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "From the dreamy light hearted starting point, to the absolute chaos that"
PRINT "follows, to the distinct feeling of abandonment and entropy in the Eamon Rail"
PRINT "yard (which is perfect for an adventure nobody has wanted to play for over 20"
PRINT "years), to the spine tingling creepiness in the town of Dodge, to the local inn"
PRINT "which made me laugh out loud to myself as I explored and discovered that a bunch"
PRINT "of jerks had ransacked it, locked the owner in his own appliance and invaded his"
PRINT "quarters for a sleazy poker game. I particularly enjoyed the dispatching of"
PRINT "those jerks and then laughed again for letting myself get so involved in the"
PRINT "story."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "Nearly every area of Eamon is touched upon, including the obligatory sailing"
PRINT "where you just walk between watery rooms in a perhaps imaginary boat, to the"
PRINT "Eamon sewers...Even the rarely spoken of House of Ill Repute gets a quick and"
PRINT "hilarious visit. In short, this is an adventure which the author took care to"
PRINT "craft slowly, trying to cover every detail along the way and all of his hard"
PRINT "work shows."
PRINT
PRINT "A Runcible Cargo has all of the traits of a great adventure. A steady pace;rich"
PRINT "and realistic, yet fun, descriptions; a clear quest; lots of specials and action"
PRINT "to keep the interest up; plenty of laughs and often amusing companions who seem"
PRINT "to display real personality traits. The adventure seems to never be afraid to"
PRINT "break the 4th wall, but yet remained, in many ways, the most realistic Eamon"
PRINT "adventure I have played to date. Halfway through the game I was sure I was going"
PRINT "to give it a perfect 10 rating, something I don't believe any adventure has ever"
PRINT "gotten in the history of Eamon. "
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "Why did I lower the rating to 9.5 then? Well there were a few things, mostly"
PRINT "towards the end, that didn't sit well with me personally."
PRINT
PRINT "First off, most of the monsters are cardboard cutout "; q$; "bandits"; q$; ". While this goes"
PRINT "with the clear storyline and quest, it also gets rather tedious. At first I was"
PRINT "impressed with the author's ability to write rich entertaining descriptions for"
PRINT "each one of these cutouts, but by the end I was less amused and somewhat bored"
PRINT "with each new way to verbosely say "; q$; "You see a bandit."; q$; " I found myself just"
PRINT "skimming the bandit descriptions and blankly looking around my house as I"
PRINT "repeatedly tapped the Enter key until they were dead and I could move on with my"
PRINT "explorations."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "The order in which I chose to pursue the map most likely worked against my"
PRINT "rating as well because apparently I came across the most boring and somewhat"
PRINT "unfinished feeling section of the game at the end of my explorations which left"
PRINT "me with a anti-climactic feeling lingering after all of the interesting places I"
PRINT "had visited previously. I found myself in a nearly empty college campus with a"
PRINT "bunch of doors that were practically left wide open (I am guessing the author"
PRINT "had some programming problems and gave up on trying to get them to work right at"
PRINT "some point)."
PRINT
PRINT "On that subject, there were way too many doors in this adventure in general,"
PRINT "especially given the fact that few of them seemed to actually work right. Locked"
PRINT "door puzzles can get old fast if not done right and that, combined with the"
PRINT "cardboard cutout bad guys, brought the excellent material in the rest of the"
PRINT "game down with it a little."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "Once I acquired the Runcible Cargo there were some good special effects which"
PRINT "brought the tension and interest back up again. I expected more of these effects"
PRINT "as I journeyed on with it, but nothing else happened which was another small let"
PRINT "down. The end of the game routines also seemed a bit rushed to me and not nearly"
PRINT "as smoothly done as the beginning. Keep in mind that these are all just my"
PRINT "personal opinions and others may rate this adventure higher or lower than I did"
PRINT "as well."
GOSUB KeyWait0: GOSUB Title0: COLOR 7
PRINT "With the few gripes I just listed cast aside, A Runcible Cargo is nothing short"
PRINT "of a complete masterpiece of interactive fiction and definitely one of the top"
PRINT "five best Eamons ever written. It's well crafted, well written, detailed and"
PRINT "also a perfect example of the powerful capabilities Eamon Deluxe has over"
PRINT "Classic Eamon systems in the hands of the right author. An excellent yet somehow"
PRINT "precisely humble entry for a first time author and I hope Mr. Ferguson sticks"
PRINT "around for a long time and decides to write more adventures in the future."
PRINT
PRINT "Overall, I give it a difficulty rating of around 5 and part of that reflects the"
PRINT "amount of time one needs to set aside just to play through and see everything"
PRINT "rather than dangers of character death. I highly recommend this adventure to"
PRINT "everyone. It is certainly Eamon flavored interactive fiction at it's best."
GOSUB KeyWait: author$ = x$: GOTO Title

'                     ----------------------
'                       USEFUL SUBROUTINES
'                     ----------------------
KeyWait0: COLOR 2: GOTO KeyWait1
KeyWait:
COLOR 3
KeyWait1:
PRINT : PRINT
KeyWait2:
PRINT "Press any key to continue...";
KeyWait3:
k$ = INKEY$: BS = POS(0): CC# = 0
DO
   IF s%(4) <> 1 THEN
     CC# = CC# + 1
     IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, BS
     IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
     IF CC# = CC3# THEN : PRINT "\": LOCATE CSRLIN - 1, BS: CC# = 0
   END IF
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""

Title:
COLOR 3
Title1:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT STRING$(80, 196): PRINT : RETURN
Title0: COLOR 2: GOTO Title1

Center:
PRINT SPC(INT((80 - LEN(a$)) / 2)); a$: RETURN

'                       -----------
'                        Error Pit
'                       -----------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; STR$(ERR); ")": PRINT
k$ = "try and continue": IF ERR > 51 THEN k$ = "exit to Main Menu"
PRINT SPACE$(20); "Hit any key to "; k$; "...": k$ = INKEY$: k$ = ""
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : l = 0: COLOR 7: RESUME NEXT

'(DATA Format: Total number of choices followed by names of each)
EDXMenuStrings:
DATA 10
DATA "  START PLAYING THIS ADVENTURE    "
DATA "  Read a Review of this Adventure "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "
DATA " Inserts your menu choices here "

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
' (Updated with VI Mode alternate numeric menu: 09 JAN 2012)
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'   s%() - Eamon Deluxe system settings. s%(4) = 1 is flag for VI Mode
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1

' VI Mode Numeric Menu
EDXMenuMCVI:
IF s%(4) = 1 THEN
  CLS : l = 0
  FOR x = be TO en
     PRINT x; ": "; em$(x): l = l + 1
     IF l = 22 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; k$
  c = INT(VAL(k$)):  c1 = c + (be - 1)
  IF c = 0 THEN c = en + 1: c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMCVI
  en = c1: c1 = 1: EXIT SUB
END IF

' Standard Menu
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

