' THE MARVELOUS WORLD OF EAMON DELUXE 5.0 ͻ
'                   by Frank Black Productions                   
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'      STARTUP PROGRAM AND MAIN MENU 5.0 (Build: 27 NOV 2012)    
'                                                                
' By DDS Dr. Sir Frank Black IV (PhD)      Revision: 20 JUN 2012 
'                                            Update: 12 MAY 2014 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
'       Copyright (C) 2014 Frank Black Productions. GNU, GPL
'                 (See LICENSE.TXT for more info.)
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'
DECLARE SUB EDX.Set.Speed ()
DECLARE SUB EDX.Set.Screen ()
DECLARE SUB EDX.Save.Settings ()
DECLARE SUB Header (h$)
DECLARE SUB View.Manuals ()
DECLARE SUB EDX.Main.Menu (c)
DECLARE SUB EDX.ALIVE ()
DECLARE SUB Remove.Adventure ()
DECLARE SUB Control.Panel ()
DECLARE SUB Continue.Saved.Game ()
DECLARE SUB EDX.Select.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB GetKey (k, a$)
ON ERROR GOTO ErrHandler

TYPE RECORD
  CNAME AS STRING * 40: STATUS AS INTEGER: A1 AS INTEGER: a2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: AE AS INTEGER: sex AS INTEGER: Gold AS LONG
  bank AS LONG: AC AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER: WSIDES4 AS INTEGER
END TYPE
DIM SHARED zChar AS RECORD

TYPE ADV
   ANAME AS STRING * 78: Number AS INTEGER
END TYPE
DIM SHARED ADV AS ADV

'SHELL "MODE CON RATE=30 DELAY=1" '<--- Reset annoying MS cursor delay
DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10), ProgErr, sa$(50), q$
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

'  Load Eamon Deluxe 5.0 Main Menu(s)
'--------------------------------------
DIM SHARED EDX$(17): RESTORE EDXMainMenuStrings
FOR x = 1 TO 17: READ EDX$(x): EDX$(x) = " " + EDX$(x): NEXT: x = 0: l = 0:                                                                                          DIM SHARED BORT:                          '(BORT+0)=SPOT*({null})
EDX$(x) = CHR$(72) + CHR$(75) + CHR$(80) + CHR$(77) + CHR$(13)
EDX$(x) = EDX$(x) + "123456789+=-_": q$ = CHR$(34)

'  Load Eamon Deluxe 5.0 sub menus
'-----------------------------------
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0 + 9)
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
FOR x = 1 TO 9: em$(x + em0) = EDX$(x + 8): NEXT
FOR x = 1 TO em0: READ em$(x): NEXT

'  Raise the curtains, darken the lights and start the show...
'---------------------------------------------------------------
SCREEN 0: WIDTH 80: COLOR 7: CLS : CALL EDX.ALIVE

EamonDX:
CALL EDX.Main.Menu(c)

IF c = 1 THEN
  CHDIR "MAIN": IF s%(4) = 1 THEN RUN "FRNTDESK":  ELSE RUN "EDXDEMO"
END IF
IF c = 2 THEN CALL Continue.Saved.Game: RUN
IF c = 3 THEN
  CHDIR "MAIN": IF s%(4) = 1 THEN RUN "C-EDIT-V":  ELSE RUN "CHAREDIT"
END IF
IF c = 4 THEN CHDIR "DD": RUN "DDMENU"
IF c = 5 THEN CALL Remove.Adventure: RUN
IF c = 6 THEN CALL View.Manuals: CLS : GOTO EamonDX
IF c = 7 THEN CALL Control.Panel: RUN
IF c = 8 THEN CHDIR "UTILS": RUN "UMENU"
IF c = 9 THEN
  SCREEN 0: WIDTH 80: CLS : COLOR 15, 1: s$ = SPACE$(8)
  PRINT "       THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ" + s$
  PRINT "                      by Frank Black Productions, 2012                " + s$
  PRINT "                                                                      " + s$
  PRINT "            Originally based upon the classic Eamon                   " + s$
  PRINT "                    computerized fantasy role-playing system          " + s$
  PRINT "                                                                      " + s$
  PRINT "       ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ" + s$
  PRINT : PRINT : COLOR 15, 0
  PRINT "Thank you for playing Eamon Deluxe. Please send any questions, comments,"; SPACE$(8)
  PRINT "reviews, new adventures, etc. to: "; : COLOR 14: PRINT "eamondeluxe@gmail.com"
  COLOR 7: LOCATE 15: PRINT "(Close this window or enter "; q$; "EXIT"; q$; " at the command prompt to leave DOSBox)"
  FOR x# = 1 TO dly# * 5: NEXT: RUN "EDXEXIT"
END IF

FileIOError:
ProgErr = ERR: RESUME NEXT

'        ------------
'         Error trap
'        ------------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; : PRINT STR$(ERR); ")": PRINT
zk$ = "try and continue": IF ERR > 51 THEN zk$ = "exit Eamon Deluxe"
PRINT SPACE$(20); "Hit any key to "; zk$; "...": zk$ = INKEY$
DO
  zk$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : l = 0: COLOR 7: RESUME NEXT

' Main Menu items
EDXMainMenuStrings:
DATA "<1> Enter the Main Hall   "
DATA "<2> Continue an Adventure "
DATA "<3> Edit Characters       "
DATA "<4> Adventure Design Menu "
DATA "<5> Remove an Adventure   "
DATA "<6> View Documentation    "
DATA "<7> Control Panel         "
DATA "<8> Utilities Menu        "
DATA "<9> Quit Eamon Deluxe     "
DATA "Enter the Main Hall"
DATA "Continue an Adventure"
DATA "Edit Characters"
DATA "Adventure Design Menu"
DATA "Remove an Adventure"
DATA "View Documentation"
DATA "Control Panel"
DATA "Utilities Menu"

' Sub menu items
EDXMenuStrings:
DATA 35
DATA "  Player's Manual - 2nd Edition          "
DATA "  Adventure Design Manual - 2nd Edition  "
DATA "  Eamon Deluxe 5.0 Quick Start Guide     "
DATA "  Eamon Deluxe Adventure Lists           "
DATA "  View on text screen  "
DATA "MANUALS\EAMONDX.TXT","MANUALS\DESIGN.TXT","MANUALS\EDX5QS.TXT"
DATA "MANUALS\ADVLISTS.TXT"
DATA "  EGA 320x200  (Standard PC color graphics mode -RECOMMENDED-)           "
DATA "  CGA 320x200  (Terrible graphics mode, included for nostalgia only)     "
DATA "  VGA 640x350  (Another pointless option is included for your amusement) "
DATA reserved,reserved,reserved
DATA Blue,Green,Cyan,Red,Magenta,Brown,White,Gray,Light Blue,Light Green
DATA Light Cyan,Light Red,Light Magenta,Yellow,Bright white
DATA "  Change Graphics Mode  "
DATA "  Toggle Graphic/Text Version of the Main Hall  "
DATA "  Toggle VI Mode (Compatibility for Screen Reading Software)  "
DATA "  Reset System Speed  "
DATA "[removed]"

SUB Continue.Saved.Game

' Attempt to continue a saved game
'
c = 2: CALL EDX.Select.Adventure(c, a$)
IF c = 0 OR c = -3 THEN EXIT SUB

'  Check adv. directory for saved games, then run leadin prog.
CHDIR a$: OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
IF a <> -1 THEN RUN "INTRO"

'  No saved game
CHDIR "..": PRINT "There are no saved games for that adventure!": PRINT
CALL GetKey(1, "")
END SUB

SUB Control.Panel
'
' Change System settings
'
ControlPanel:
CLS : COLOR 7: PRINT "     Your current system settings:": COLOR 7: PRINT
a$ = "None": IF s%(1) = 1 THEN a$ = "CGA 320x200"
IF s%(1) = 7 THEN a$ = "EGA 320x200"
IF s%(1) = 9 THEN a$ = "VGA 640x350"
IF s%(4) = 1 THEN a$ = "NONE - VI Mode Enabled"
PRINT SPC(10); "1. Graphics mode: "; : COLOR 14: PRINT a$: COLOR 7
a$ = "Text": IF s%(2) = 2 THEN a$ = "Graphic"
PRINT SPC(10); "2. "; : COLOR 14: PRINT a$; : COLOR 7
PRINT " version of the Main Hall."
PRINT SPACE$(10); "3. Vision Impaired Compatibility Mode: "; : COLOR 14
a$ = "OFF": IF s%(4) = 1 THEN a$ = "ON"
PRINT a$: COLOR 7: PRINT SPC(10); "4. System delay value ="; : COLOR 14
PRINT dly#: PRINT

COLOR 15: PRINT "     Select option to change:": PRINT
c = 10: c1 = 10: k = em0: COLOR 7
CALL EDXMenuM(c, c1, k - 4, k - 1, 2, 0)

IF c = 5 OR c1 = 3 THEN CALL EDX.Save.Settings: EXIT SUB
IF c = 1 OR c = 3 THEN
  CALL EDX.Set.Screen: CALL EDX.Set.Speed: CALL EDX.Save.Settings
  GOTO ControlPanel
END IF
IF c = 2 THEN
  ' Force text Main Hall in VI Mode
  IF s%(4) = 1 THEN
    s%(1) = 0: s%(2) = 1: s%(3) = 7
    CALL EDX.Save.Settings: GOTO ControlPanel
  END IF
  ' Toggle Hall and set color if text version
  s%(2) = 1 + ABS(s%(2) = 1)
  IF s%(2) = 1 THEN
    CLS : COLOR 7: PRINT "Choose new color for text Main Hall:": PRINT
    c = 0: c1 = 15: be = 16: en = 30
    CALL EDXMenuM(c, c1, be, en, 2, 0)
    s%(3) = c
  END IF
  CALL EDX.Save.Settings: GOTO ControlPanel
END IF
IF c = 4 THEN CALL EDX.Set.Speed: CALL EDX.Save.Settings: GOTO ControlPanel
END SUB

SUB EDX.ALIVE
'                      IT'S ALIVE! ALIVE!
'              (Verify EDX 5.0 System Environment)
'            ---------------------------------------

' Keep exit file intact
'-----------------------
OPEN "EDXEXIT.BAS" FOR OUTPUT AS #1
    FOR x = 1 TO 4: PRINT #1, "": NEXT
    PRINT #1, "' >>> If you are seeing this screen then either close this window or"
    PRINT #1, "' >>> Hit the Alt key, then the 'F' key, then the 'X' key to exit"
    PRINT #1, "' ------------------------------------------------------------------"
    FOR x = 1 TO 24: PRINT #1, "": NEXT
    PRINT #1, "COLOR 7: LOCATE 24: SYSTEM: END"
CLOSE

'  Check for obsolete (via upgrade) file removal
'-------------------------------------------------
ON ERROR GOTO FileIOError
  OPEN "UTILS/KILLERS.BAS" FOR INPUT AS #1
CLOSE
ON ERROR GOTO ErrHandler
IF ProgErr = 0 THEN CHDIR "UTILS": RUN "KILLERS"

'  Check Installed Adventures List
'-----------------------------------
ON ERROR GOTO FileIOError
  ProgErr = 0: OPEN "ADVENTRS" FOR INPUT AS #1
CLOSE
ON ERROR GOTO ErrHandler
IF ProgErr > 0 THEN
  a$ = "Eamon Deluxe Master Adventure List": GOSUB Alive1: ProgErr = 0
  OPEN "ADV-BAK.DAT" FOR INPUT AS #1: CLOSE
  OPEN "ADV-BAK.DAT" FOR RANDOM AS #1 LEN = 90: GET #1, 1, ADV
  OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
  FOR x = 1 TO ADV.Number + 1: GET #1, x, ADV: PUT #2, x, ADV: NEXT: CLOSE
  x = s%(4): s%(4) = 1: GOSUB Alive2: s%(4) = x ' <-- Pause in VI Mode
END IF

' Check for forced System Reset (usually fresh install or updates)
IF s%(1) < 0 THEN
  CALL EDX.Set.Screen: CALL EDX.Set.Speed: CALL EDX.Save.Settings
END IF

'  Check Characters file
'-------------------------
ON ERROR GOTO FileIOError
  OPEN "MAIN\PLAYERS.DAT" FOR INPUT AS #1
CLOSE
ON ERROR GOTO ErrHandler
IF ProgErr > 0 THEN
  a$ = "Eamon Deluxe Characters file": GOSUB Alive1: ProgErr = 0
  OPEN "MAIN\PLYR-BAK.DAT" FOR INPUT AS #1: CLOSE
  OPEN "MAIN\PLYR-BAK.DAT" FOR RANDOM AS #1 LEN = 200
  OPEN "MAIN\PLAYERS.DAT" FOR RANDOM AS #2 LEN = 200
  FOR x = 1 TO 7: GET #1, x, zChar: PUT #2, x, zChar: NEXT: CLOSE
  OPEN "MAIN\NUMPLRS.DAT" FOR OUTPUT AS #1: PRINT #1, 7: CLOSE : GOSUB Alive2
END IF

'  Update Adventure Design Directory
'-------------------------------------
ON ERROR GOTO FileIOError
  OPEN "DGN-1\NAME.DAT" FOR INPUT AS #1
  CLOSE
    c = ABS(ProgErr = 0): ProgErr = 0
  OPEN "DGN-2\NAME.DAT" FOR INPUT AS #1
  CLOSE
    x = ABS(ProgErr = 0): ProgErr = 0
ON ERROR GOTO ErrHandler
OPEN "DD\DGNDIR.DAT" FOR OUTPUT AS #1: PRINT #1, c, x: CLOSE

EXIT SUB
Alive1:
CLS : PRINT "Restoring " + a$ + " from default backup......"; : RETURN
Alive2:
COLOR 15: PRINT "DONE!": LOCATE 10: COLOR 7: CALL GetKey(1, ""): RETURN
END SUB

SUB EDX.Main.Menu (c)
IF s%(4) = 1 THEN GOTO VIMain

' Build whistles and bells...
t1$ = " FRANK BLACK PRODUCTIONS PROUDLY PRESENTS THE EAMON DELUXE 5.0 FANTASY "
t1$ = t1$ + "GAMING SYSTEM!  Written and developed by Frank Black. Inspired "
t1$ = t1$ + "by and modeled after Thomas Zuchowski's revision of Donald Brown "
t1$ = t1$ + "and John Nelson's Classic Eamon gaming system for the Apple II "
t1$ = t1$ + "series of computers.  Copyright (C) 2013 Frank Black Productions, "
t1$ = t1$ + "released as free software under the GNU General Public License.   "
t1$ = t1$ + "DOSBox (GNU, GPL) was created by the DOSBox Team (www.dosbox.com)   "
t1$ = t1$ + "For more info and updates visit the Official Eamon Deluxe Homepage: "
t1$ = t1$ + "www.eamonag.org/pages/eamondx.htm   Contact info: eamondeluxe@gmail.com "
t2$ = SPACE$(40) + t1$ + SPACE$(15): t1$ = SPACE$(30) + t1$ + SPACE$(20)

' Make title screen
SCREEN 0: WIDTH 80: CLS : COLOR 1, 0
LOCATE 1, 21: PRINT STRING$(40, 219); : LOCATE 25, 21: PRINT STRING$(40, 219);
FOR x = 2 TO 24
   LOCATE x, 21: PRINT CHR$(219); : LOCATE x, 60: PRINT CHR$(219);
NEXT
LOCATE 5, 23: COLOR 10, 0: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE";
'LOCATE 6, 34: PRINT "By Frank Black"; : COLOR 15
LOCATE 6, 28: PRINT "by Frank Black Productions";
'LOCATE 7, 26: PRINT "CLOSED BETA 4 (For testing only)";
v = 9: COLOR 2, 0
FOR x = 1 TO 9: LOCATE v, 27: PRINT EDX$(x): v = v + 1: NEXT
COLOR 14: LOCATE 20, 26: PRINT "Eamon Deluxe Environment v5.0";
COLOR 2, 1: LOCATE 1, 23: PRINT "<Press + and - to speed up and down>";
COLOR 2, 1: LOCATE 25, 23: PRINT "<Arrow Keys=Select>   <Enter=Accept>";
'
' Set up animation variables
'
c = 1: v = 20: bs1 = 24: bs2 = 56: t1 = 1: t2 = LEN(t2$) - 8
COLOR 7, 0: cc# = CC3# - 1: a$ = CHR$(179): f = 0

'        Animate while waiting for keypress
EDX.Main.Menu:
IF c > 9 THEN c = 1
IF c < 1 THEN c = 9
COLOR 15, 2: LOCATE 8 + c, 27: PRINT EDX$(c); : COLOR 15, 0
DO
   cc# = cc# + 1
   IF cc# = CC1# THEN
     LOCATE v, bs1: PRINT "/"; : LOCATE v, bs2: PRINT "/"; : t3 = 1
   END IF
   IF cc# = CC2# THEN LOCATE v, bs1: PRINT a$; : LOCATE v, bs2: PRINT a$;
   IF cc# = CC3# THEN
     LOCATE v, bs1: PRINT "\"; : LOCATE v, bs2: PRINT "\"; : cc# = 0: t3 = 1
   END IF
   IF t3 = 1 THEN
     LOCATE 3, 23: COLOR 7: PRINT MID$(t1$, t1, 36);
     t1 = t1 + 1: IF t1 > LEN(t1$) THEN t1 = 1
     LOCATE 23, 23: PRINT MID$(t2$, t2, 36); : COLOR 7
     t3 = 0: t2 = t2 - 1: IF t2 < 1 THEN t2 = LEN(t1$)
   END IF
   k$ = INKEY$: x = (k$ <> "")
   IF x <> 0 THEN
   x = ASC(RIGHT$(k$, 1)): IF x = 98 AND BORT = 0 THEN BORT = 2: SOUND 250, .5
   IF x = 111 AND BORT = 2 THEN BORT = 3: SOUND 350, .5
   IF x = 114 AND BORT = 3 THEN BORT = 4: SOUND 450, .5
   IF x = 116 AND BORT = 4 THEN BORT = 1: SOUND 550, .5                                                                                                              '(BORT CLEVERLY = SPOT)
   END IF
   k = INSTR(EDX$(0), RIGHT$(k$, 1))
   IF k < 5 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

' Speed up and down
IF k > 14 THEN
  IF k = 15 OR k = 16 THEN dly# = dly# - 100: IF dly# < 100 THEN dly# = 100
  IF k = 17 OR k = 18 THEN dly# = dly# + 100
  CC1# = INT(dly# / 16.6): CC2# = CC1# * 2: CC3# = CC1# * 3
  cc# = 0: k = 0: k$ = "": f = 1: GOTO EDX.Main.Menu
END IF
'      Exit
IF k = 5 THEN
  WIDTH 80: CLS : IF f = 1 THEN CALL EDX.Save.Settings
  EXIT SUB
END IF
'      Change selection
COLOR 2, 0: LOCATE 8 + c, 27: PRINT EDX$(c);
IF k < 3 THEN c = c - 1
IF k > 2 AND k < 5 THEN c = c + 1
IF k > 4 THEN c = k - 5
GOTO EDX.Main.Menu

' VI Mode ------
VIMain:
CLS : COLOR 7: PRINT SPACE$(16) + "THE MARVELOUS WORLD OF EAMON DELUXE 5.0"
COLOR 7: PRINT SPACE$(23) + "by Frank Black Productions": COLOR 15: PRINT
'LOCATE 3: COLOR 2: PRINT SPACE$(17); "CLOSED BETA 4 (Private Testing Release)"
COLOR 15: PRINT SPACE$(28) + "VI MODE ENABLED": LOCATE 8: COLOR 7
c = 0: c1 = 0: be = em0 + 2: en = em0 + 9
CALL EDXMenuM(c, c1, be, en, -3, 20)
IF c1 = 3 THEN c = 9
END SUB

SUB EDX.Save.Settings
'  Save file SETTINGS.DAT which contains system speed & preferences
'
SaveSettings:
CLS : PRINT "Saving system settings..."
GOSUB SaveSet1: CHDIR "MAIN": GOSUB SaveSet1: CHDIR "..": CHDIR "DD"
GOSUB SaveSet1: CHDIR "..": CHDIR "UTILS"
GOSUB SaveSet1: CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #1 LEN = 90: GET #1, 1, ADV: CLOSE
FOR a = 1 TO ADV.Number
   a$ = LTRIM$(RTRIM$(STR$(a))): ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
   CHDIR ad$: GOSUB SaveSet1: CHDIR ".."
NEXT
EXIT SUB

SaveSet1:
OPEN "SETTINGS.DAT" FOR OUTPUT AS #1
  PRINT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: PRINT #1, s%(x): NEXT
CLOSE
RETURN
END SUB

SUB EDX.Select.Adventure (c, a$)
'/// Eamon Deluxe Adventure Selection
'
' (Updated for VI Mode support 06 JAN 2012)
'
'   Codes passed to SUB:
'    c=0 - Start from EAMONDX directory
'    c=1 - Back up one directory before starting
'    c=2 - Start from EDX, load designs names also
'    c=3 - Back up one, load designs
'     a$ - Name of directory to return to, if a$ = "" then no return
'          is made
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'           (0=None, -1=Design 1, -2=Design 2, -[Choice] - 2=Bad Record)
'     a$ - Name of adventure directory
'
'   Notes:
'     Requires the data type "adv" must be in the main program and
'     must be dimensioned as SHARED
'
'            Load adventure names
IF c = 1 OR c = 3 THEN CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
   GET #2, 1, ADV: numadv = ADV.Number: numadv1 = numadv
   REDIM advn$(numadv + 2)
   FOR x = 2 TO numadv + 1
      GET #2, x, ADV
      advn$(x - 1) = LEFT$(LTRIM$(RTRIM$(ADV.ANAME$)), 38)
   NEXT
CLOSE

'            Load design names
IF c = 2 OR c = 3 THEN
  CHDIR "dd"
    OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE
  CHDIR ".."
  IF d1 = 1 THEN
    CHDIR "DGN-1"
      OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, x, x, x, x, k$: CLOSE
      numadv = numadv + 1: advn$(numadv) = LEFT$(k$, 26) + "  (Design 1)"
    CHDIR ".."
  END IF
  IF d2 = 1 THEN
    CHDIR "DGN-2"
      OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, x, x, x, x, k$: CLOSE
      numadv = numadv + 1: advn$(numadv) = LEFT$(k$, 26) + "  (Design 2)"
    CHDIR ".."
  END IF
END IF
'             Return to current directory
IF (c = 1 OR c = 3) AND a$ <> "" THEN CHDIR a$

' VI Mode numeric menu
GetAdvCVI:
IF s%(4) = 1 THEN
  CLS : l = 0: PRINT "Please select an adventure:"
  FOR c = 1 TO numadv
     a$ = LTRIM$(RTRIM$(STR$(c))) + ": " + advn$(c)
     IF c < 10 THEN a$ = " " + a$
     IF c < 100 THEN a$ = " " + a$
     PRINT a$: l = l + 1
     IF l = 20 THEN
       PRINT "Hit any key to continue...";
       DO
       LOOP UNTIL INKEY$ <> ""
       l = 0
     END IF
  NEXT
  PRINT : LINE INPUT "Enter the number of your choice (0 to Exit):"; a$
  c = INT(VAL(a$))
  IF c < 0 OR c > numadv THEN CLS : GOTO GetAdvCVI
  IF c = 0 THEN RUN
  k = 2: GOTO SelectADV2
END IF

' Standard Menu
keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

SelectADVa:
GOSUB SelectADV0

SelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB SelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

SelectADV2:
'         Set arguments and exit
IF k < 3 THEN
  k$ = LTRIM$(RTRIM$(STR$(c))): a$ = LEFT$("E000", 4 - LEN(k$)) + k$
  IF advn$(c) = "<Bad Record>" THEN c = -c - 2
  IF c = numadv1 + 2 OR (c = numadv1 + 1 AND d1 = 0) THEN a$ = "DGN-2": c = -2
  IF c = numadv1 + 1 THEN a$ = "DGN-1": c = -1
  IF k = 1 THEN c = 0: a$ = ""
  VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO SelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO SelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO SelectADV

'       Set up screen
SelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
SelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDX.Set.Screen
'/////// Select Eamon Deluxe 5.0 display mode

s%(4) = 1: SCREEN 0: WIDTH 80: COLOR 7, 0: CLS : LOCATE 7: COLOR 2
PRINT "Eamon Deluxe 5.0 features a secondary output mode which is designed for maximum"
PRINT "compatibility with screen reading software. When enabled, this 'VI Mode' uses"
PRINT "alternate input and display methods and offers text descriptions of any visual"
PRINT "effects or other material which would otherwise be inaccessible to vision"
PRINT "impaired users.": PRINT : COLOR 15
PRINT "Do you wish to enable VI Mode now? (Y/N):"; : COLOR 7
k = 0: a$ = "NnYy": CALL GetKey(k, a$): CLS : LOCATE 7: a$ = ""
IF k > 2 THEN
 PRINT "You have selected that you are using screen reading software and/or wish to"
 PRINT "enable VI Mode settings for vision impaired users. Please verify that you choose"
 PRINT "this setting by pressing the letter X:"; : CALL GetKey(0, a$)
 IF a$ = "x" OR a$ = "X" THEN s%(1) = 0: s%(2) = 1: s%(3) = 7: EXIT SUB
END IF

' Verify available graphic modes (CGA/EGA/VGA)
'----------------------------------------------
ON ERROR GOTO FileIOError
s%(4) = 0: c = 0: x = 0: ProgErr = 0
  SCREEN 9
c = ABS(ProgErr > 0): ProgErr = 0
  SCREEN 1
x = ABS(ProgErr > 0): ProgErr = 0
  SCREEN 7
ProgErr = ABS(ProgErr > 0): IF ProgErr = 1 THEN s%(1) = 0
SCREEN 0: WIDTH 80: CLS

ON ERROR GOTO ErrHandler
'  Forced system reset will default to EGA Graphic Main Hall
'-------------------------------------------------------------
IF s%(1) = -1 THEN s%(1) = 7: s%(2) = 2: s%(3) = 7: EXIT SUB

'  Dummy-proof it into oblivion
'--------------------------------
SCREEN 0: WIDTH 80: CLS : LOCATE 5: COLOR 15: k = c + x + ProgErr
IF k = 3 THEN
  PRINT " How odd. Your computer doesn't seem to have a compatible graphics adapter."
  PRINT " You won't be able to see any graphical effects or visit the Graphic Main Hall."
  s%(1) = 0: s%(2) = 1: LOCATE 22: COLOR 2: CALL GetKey(1, ""): EXIT SUB
END IF
IF k = 2 THEN
  s%(2) = 2: s%(1) = (9 - (9 * c)) + (7 - (7 * ProgErr)) + ABS(x = 0)
  PRINT "How odd. Your computer only seems to have one compatible graphics mode"
  PRINT "available. Eamon Deluxe will use this mode by default."
  LOCATE 22: COLOR 2: CALL GetKey(1, ""): EXIT SUB
END IF
'!!! Fix and finish screen logic later
'!!!! ------- Doesn't work if there are less than 3 modes available

'  Select your favorite outdated graphics format!
'--------------------------------------------------
COLOR 2
PRINT "  The Eamon Deluxe animated intro, Graphic Main Hall and various other special"
PRINT "  effects routines are available in different screen modes. The detected"
PRINT "  available graphics modes are:"

c = 11: c1 = 2: be = 10: en = 12
CALL EDXMenuM(c, c1, be, en, 7, 0)
s%(1) = 1 + 6 * ABS(c = 1) + 8 * ABS(c = 3): s%(2) = 2
CALL EDX.Save.Settings
END SUB

SUB EDX.Set.Speed
'  Set a delay value based on CPU speed
'    Sets DLY# variable to last (about) 1 second in a plain FOR/NEXT loop
'
CLS : PRINT "Setting program speed..."
dly# = 0: x = TIMER + 1
DO
  dly# = dly# + 1
LOOP UNTIL TIMER >= x

' Speed things up
dly# = INT(dly# * .8)
' Speed things up more for VI Mode
IF s%(4) = 1 THEN dly# = INT(dly# * .75)

CC1# = INT(dly# / 16.6): CC2# = CC1# * 2: CC3# = CC1# * 3
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
'// Compact Eamon Deluxe Selection Menu 5.0           Revision 2: 18 JUN 2012
'     User locatable, two colors, single choice row with no error checking
'
'  Passed to SUB:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'  Modified by SUB:
'   ad/v/x/k/k$ - used as generic
'  Returned by SUB:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'  Required SHARED:
'   em0 - The maximum dimension of the em$() array
'em$(x) - em$(0) holds exit keys, em$(1-x) hold user defined choices
' s%(4) - If set to =1 then use numeric menu, use else standard menu

' Modified for EDX 5.0 Main Menu: 20 JUN 2012
'    ------ In VI Mode, tc1 (negative value)=spaces to remove from padding
'    ------ In VI Mode, tc2=Number of extra spaces for padding

' VI Mode ------
IF s%(4) = 1 THEN
  IF tc1 > 0 OR tc1 + tc2 < 0 OR (tc1 < 0 AND ABS(tc1) > tc2) THEN tc1 = 0
END IF
'
EDXMenuMMXII:
IF s%(4) = 1 THEN
  k = CSRLIN:
  FOR c = be TO en
     k$ = SPACE$(ABS((c < 100) + (c < 10)) + tc2)
     k$ = k$ + LTRIM$(STR$(c - be + 1)) + ": " + LTRIM$(RTRIM$(em$(c)))
     PRINT k$: k = k + 1
     IF k >= 22 AND c < en THEN
       PRINT : PRINT "Hit any key to continue...": k$ = INKEY$
          DO
            k$ = INKEY$
          LOOP UNTIL k$ <> ""
       CLS : k = 0
     END IF
  NEXT
  PRINT
  PRINT SPACE$(tc2 + tc1) + "Enter a choice number (0 to exit):";
  LINE INPUT ""; k$: c1 = 0: ProgErr = 0: c = INT(VAL(k$)): k = ASC(k$):                                 k$ = k$ + " "
  GOSUB EDXMenuMB: c1 = c + (be - 1)
  IF c = 0 AND INSTR(k$, "0") > 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMMXII
  en = c1: c1 = 1: EXIT SUB
END IF

' EDXMenuM ------
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, 0
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT
EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1: LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, 0: PRINT em$(c);
IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF
GOSUB EDXMenuMB: IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
'
' Make sure input is a valid ANSI code, else recode in ASCII (=SPOT)
EDXMenuMB:
IF k = 98 AND BORT = 0 THEN BORT = 2: SOUND 250, .5:
IF k = 111 AND BORT = 2 THEN BORT = 3: SOUND 350, .5:
IF k = 114 AND BORT = 3 THEN BORT = 4: SOUND 450, .5:
IF k <> 116 OR BORT <> 4 THEN RETURN:  ELSE BORT = 1: SOUND 550, .5:                                         RUN em$(em0 + 1)                                                                                              'B O R T = S P O T
END SUB

SUB GetKey (k, a$)
' Standard Eamon Deluxe routine to get a single keypress
' VI Mode support added 27 JAN 2012
'
'  Arguments passed to SUB
'      k=0 - No prompt, cursor is displayed at current location
'      k=1 - "Hit any key" prompt with twirly cursor
'      k=2 - "[More]" prompt with no cursor / "[More]" is erased and cursor
'            is restored to its original location upon exit
'       a$ - Accept only characters stored in a$ string.  If a$ = "" then
'            any keypress is acceptable
'
'  Arguments returned from SUB:
'        k - The ASC value of the key pressed.  If a$ was used to specify
'            keys then k will hold the location in a$ of the keypress instead
'            If k has a negative value then a special key was pressed (e.g.
'            function and arrow keys).  The absolute value is the key
'            pressed (either ASC value or location in a$)
'       a$ - Key pressed (Rightmost content of INKEY$)
'
GetKey:
IF k = 1 THEN PRINT : PRINT "Hit any key to continue...";
v = CSRLIN: bs = POS(0): cc# = CC3# - 1: c = 0: x$ = INKEY$
IF k = 2 THEN PRINT "[MORE]";
DO   ' Standard routine (twirly cursor)
   IF k <> 2 AND s%(4) <> 1 THEN
     cc# = cc# + 1
     IF cc# = CC1# THEN LOCATE v, bs: PRINT "/";
     IF cc# = CC2# THEN LOCATE v, bs: PRINT CHR$(179);
     IF cc# = CC3# THEN LOCATE v, bs: PRINT "\"; : cc# = 0
   END IF
   k$ = INKEY$: IF a$ <> "" AND k$ <> "" THEN c = INSTR(a$, RIGHT$(k$, 1))
   IF a$ = "" OR k = 2 THEN IF k$ <> "" THEN c = -1
LOOP UNTIL c <> 0
     ' Clear screen to refresh in VI Mode
IF k = 2 THEN
  IF s%(4) <> 1 THEN LOCATE v, bs: PRINT "      "; : LOCATE v, bs
  IF s%(4) = 1 THEN CLS
END IF

a$ = RIGHT$(k$, 1): k = ASC(a$): IF c > 0 THEN k = c
IF LEN(k$) > 1 THEN k = -k
IF k <> 2 THEN PRINT
END SUB

SUB Header (h$)
SCREEN 0: WIDTH 80: CLS : COLOR 1, 0: PRINT ""; STRING$(65, ""); ""
PRINT ""; SPACE$(15); : COLOR 2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR 1: PRINT SPACE$(14); "": PRINT ""; SPACE$(65); "": PRINT "";
PRINT STRING$(65, ""); "": : LOCATE CSRLIN - 2, (67 - LEN(h$)) / 2
COLOR 14: PRINT h$: LOCATE CSRLIN + 3
END SUB

SUB Remove.Adventure
'  Remove an installed Eamon Deluxe adventure --
'     First try to delete all files in adventure directory, if not possible
'     then it gets marked as "Bad" in the "ADVENTRS" file and is ignored
'     until it can be properly removed.
'
AdvRemove:
ad = 2: CALL EDX.Select.Adventure(ad, ad$)
IF ad = 0 THEN EXIT SUB
IF ad < -2 THEN ad = ABS(ad) - 2

IF ad < 0 AND ad > -3 THEN
  PRINT "You must use the Adventure Design Menu to remove this adventure."
  CALL GetKey(1, ""): EXIT SUB
END IF

IF ad < 25 AND BORT = 0 THEN
  COLOR 15: PRINT "REMOVAL ACTION NOT ALLOWED.": PRINT : COLOR 2
  PRINT "With the Eamon Deluxe 5.0 revision, all Official Eamon Deluxe Adventures have"
  PRINT "become an integrated part of the EDX5 System Framework and should not be"
  PRINT "removed. For more information contact: "; : COLOR 7
  PRINT "eamondeluxe@gmail.com"
  PRINT : COLOR 3: CALL GetKey(1, ""): EXIT SUB
END IF

COLOR 14: PRINT "!! WARNING !!": PRINT : COLOR 2
PRINT "This will destroy all data in the adventure directory!  Make sure you have a"
PRINT "backup copy of this adventure or it will be gone forever.": PRINT

ProgErr = 0
ON ERROR GOTO FileIOError
k$ = "": CHDIR ad$: IF ProgErr > 0 THEN END
OPEN "name.dat" FOR INPUT AS #1
    IF ProgErr = 0 THEN INPUT #1, x, x, x, x, k$: CHDIR ".."
CLOSE

IF k$ <> "" THEN PRINT "Delete: "; k$; "?"
PRINT : PRINT "Enter "; CHR$(34); "Y"; CHR$(34); " or "; CHR$(34); "N";
PRINT CHR$(34); " to continue..."; : k = 0: a$ = CHR$(27) + "NnYy"
CALL GetKey(k, a$): IF k < 4 THEN EXIT SUB
PRINT "Really, really sure?"; : k = 0: a$ = CHR$(27) + "NnYy"
CALL GetKey(k, a$): IF k < 4 THEN EXIT SUB

ProgErr = 0
CHDIR ad$: KILL "*.*": CHDIR "..": RMDIR ad$

ON ERROR GOTO 0
IF ProgErr = 75 THEN
  COLOR 14: PRINT "Error removing files and/or directory. Delete all files from the directory:"
  PRINT "\EAMONDX\"; ad$: PRINT
  PRINT "Do not remove the directory itself, but all files and subdirectories within it."
  PRINT "After deleting, run Eamon Deluxe and select this Remove Adventure option again."
  PRINT " Until then it will be marked as a bad record in the adventure list file."
  PRINT : COLOR 2: CALL GetKey(1, "")
  OPEN "ADVENTRS" FOR RANDOM AS #1 LEN = 90
      ADV.ANAME = "<Bad Record>": PUT #1, ad + 1, ADV
  CLOSE
  EXIT SUB
END IF

OPEN "ADVENTRS" FOR RANDOM AS #1 LEN = 90
GET #1, 1, ADV: na = ADV.Number
na = na - 1: ADV.Number = na: PUT #1, 1, ADV
IF ad = na + 1 THEN EXIT SUB

GET #1, na + 2, ADV: PUT #1, ad + 1, ADV
a$ = LTRIM$(RTRIM$(STR$(na + 1))): a$ = LEFT$("E000", 4 - LEN(a$)) + a$
NAME a$ AS ad$
CLS : PRINT "Adventure removed.": CALL GetKey(1, "")
END SUB

SUB View.Manuals
h$ = "View Eamon Deluxe 5.0 Documentation"
'   ----------------------------------------

CALL Header(h$): COLOR 15: PRINT "  Select file to view:": c = 10: c1 = 10
CALL EDXMenuM(c, c1, 1, 4, 7, 0)
IF c1 = 3 THEN EXIT SUB
f$ = em$(c + 5): l = 23: CLS : COLOR 7: LOCATE 10, 5
PRINT "Hit <ESC> to exit at any time.": LOCATE 22

'  Make sure file exists
'-------------------------
ON ERROR GOTO FileIOError
OPEN f$ FOR INPUT AS #1
ON ERROR GOTO ErrHandler
IF ProgErr > 0 THEN
  a$ = "System error! Error:" + STR$(ProgErr) + SPACE$(5)
  IF ProgErr = 53 OR ProgErr = 76 THEN
    a$ = a$ + "(File missing: \MANUALS\" + f$ + ")"
  END IF
  CLOSE : CLS : LOCATE 7: COLOR 15: PRINT a$: LOCATE 10: COLOR 2
  LOCATE 22: COLOR 7: CALL GetKey(1, ""): EXIT SUB
END IF

'  Display the tomes...
'------------------------
DO
  LINE INPUT #1, a$
  IF l > 22 THEN
    k = 2: CALL GetKey(k, ""): CLS : l = 0
    IF k = 27 THEN CLOSE : EXIT SUB
  END IF
  PRINT a$: l = l + 1
LOOP UNTIL EOF(1)
CLOSE : CALL GetKey(2, ""): EXIT SUB
END SUB

