' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                   by Frank Black Productions                   
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'               EAMON DELUXE CHARACTER EDITOR 1.0                
'                   Written January 1997 (Wow!)                  
'                                                                
' Archived and replaced with full screen editor - July 1999      
' Restored and revised for use in VI Mode - January 2012         
'                                                                
'                                           Update: 12 JUL 2012  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

TYPE RECORD
CNAME AS STRING * 40: STATUS AS INTEGER: A1 AS INTEGER: A2 AS INTEGER
A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
WA4 AS INTEGER: WA5 AS INTEGER: AE AS INTEGER: sex AS INTEGER: Gold AS LONG
bank AS LONG: AC AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER: WSIDES4 AS INTEGER
END TYPE
DIM c AS RECORD

DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10)
OPEN "SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

OPEN "NUMPLRS.DAT" FOR INPUT AS #1:  INPUT #1, numchars: CLOSE : m = 50
DIM na$(m), stat(m), hd(m), AG(m), ch(m), sp%(m, 4), WA%(m, 5), AE(m), sex(m)
DIM Gold(m), bank(m), AC(m), wn$(m, 4), wo%(m, 4), wt%(m, 4), wd%(m, 4)
DIM ws%(m, 4), wp$(5), stat$(3)
stat$(1) = "Ok": stat$(2) = "Dead": stat$(3) = "Adventuring"
GOSUB Init: m = 0

'------------------------------
' Main menu
'
Menu:
CLS : COLOR 15: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(11); "Eamon Deluxe Character Editor 1.0 [VI Mode Alternate]";
PRINT SPACE$(10); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
COLOR 7: PRINT : PRINT "Character: "; : COLOR 14
IF m = 0 THEN PRINT "None"
IF m > 0 THEN PRINT n$(m)
COLOR 7: PRINT
PRINT "  Select action:": PRINT
PRINT " 1. Select a character"
PRINT " 2. Edit character"
PRINT " 3. Character file maintenance"
PRINT " 4. Create a new character"
PRINT " 5. Update character file and quit"
x = 5: GOSUB GetNo: pk = 0
ON k GOTO Pick, Edit, File, Create, Quit
'
' Choose a character to edit
'
Pick:
CLS : PRINT "Select a character:": PRINT : L = 0
FOR r = 1 TO numchars STEP 2
   PRINT r; ": "; n$(r);
   IF r + 1 <= numchars THEN
     LOCATE CSRLIN, 40: PRINT r + 1; ": "; n$(r + 1);
   END IF
   PRINT : L = L + 1
   IF L = 18 THEN GOSUB Lp6
NEXT
PRINT : PRINT "Enter 1-"; LTRIM$(STR$(numchars));
LINE INPUT ": "; a$: m = INT(VAL(a$))
IF m < 1 OR m > numchars THEN GOTO Pick

IF stat(m) = 3 THEN
  CLS : LOCATE 10: COLOR 14
  PRINT : PRINT "This character is on an adventure right now and can't be modified."
  PRINT : COLOR 2: PRINT "If you wish, you can remove the character from the adventure (you will lose any"
  PRINT "saved games and have to start the adventure over).": PRINT : COLOR 3
  PRINT "Do you want to do this? (Y/N):"; : GOSUB GetKey: PRINT
  IF k$ = "Y" THEN
  '      Snatch
    ON ERROR GOTO SearchError
    CLS : COLOR 7: PRINT "Searching for character...": PRINT
    f = 0: x = 0: p1$ = ""
   DO
     CLOSE #3: x = x + 1: x$ = LTRIM$(RTRIM$(STR$(x)))
     IF LEN(x$) < 3 THEN x$ = "0" + x$: IF LEN(x$) < 3 THEN x$ = "0" + x$
     x$ = "..\e" + x$
     OPEN x$ + "\NEW-MEAT" FOR INPUT AS #3
     CLOSE #3
     IF ProgErr = 0 THEN
       OPEN x$ + "\NEW-MEAT" FOR RANDOM AS #3 LEN = 200: GET #3, 1, c: CLOSE #3
       IF LTRIM$(RTRIM$(LCASE$(c.CNAME))) = LTRIM$(RTRIM$(LCASE$(n$(m)))) THEN
         p1$ = x$: f = 1
       END IF
     END IF
     IF ProgErr > 0 AND ProgErr <> 53 THEN f = 2
     ProgErr = 0
   LOOP UNTIL f > 0 'OR p1$ <> ""
   ON ERROR GOTO 0
   CLOSE #3: ProgErr = 0: x$ = p1$
   IF p1$ = "" THEN
      COLOR 15: PRINT "Error! Couldn't find character, restoring anyway.": PRINT
   END IF
   IF p1$ <> "" THEN
     OPEN x$ + "\GAMEDIR.DAT" FOR OUTPUT AS #3: PRINT #3, -1
     FOR x = 1 TO 5: PRINT #3, "(none)": NEXT: CLOSE #3
     FOR x = 1 TO 5
        a$ = "\GAME" + LTRIM$(RTRIM$(STR$(x))) + ".SAV"
        OPEN x$ + a$ FOR OUTPUT AS #3: PRINT #3, 1: CLOSE #3: KILL x$ + a$
     NEXT
     KILL x$ + "\NEW-MEAT"
   END IF
   PRINT : PRINT "Character has been returned. The Character Editor must now save and exit."
   PRINT "Run the Character Editor again and select character to modify."
   stat(m) = 1: GOSUB Lp6: GOTO Quit
  END IF
  GOSUB Lp6: m = 0: GOTO Menu
END IF

IF pk = 1 THEN GOTO Edit
GOTO Menu
'-----------------------------------
' Modify a character
'
Edit:
IF m = 0 THEN pk = 1: GOTO Pick
CLS : PRINT "Editing: "; : COLOR 14: PRINT n$(m): COLOR 7: PRINT
IF stat(m) = 2 THEN
  PRINT "This character is dead.  Resurrect? (Y/N): ";
  GOSUB GetKey: IF k$ <> "Y" THEN m = 0: GOTO Menu
END IF
CLS : IF stat(m) = 2 THEN stat(m) = 1
PRINT "Change what data?:": PRINT
PRINT " 1. Name                      7. Armor"
PRINT " 2. Hardiness                 8. Sex"
PRINT " 3. Agility                   9. Gold"
PRINT " 4. Charisma                 10. Armor Expertise"
PRINT " 5. Spell Abilities          11. Weapons "
PRINT " 6. Weapon abilities"
PRINT LEFT$(ln$, 52)
PRINT "12. View Character           13. Return to Main Menu"
PRINT : LINE INPUT "   Enter 1-13: "; a$: k = INT(VAL(a$))
IF k < 1 OR k > 13 THEN GOTO Edit
CLS
ON k GOTO E1, E2, E3, E4, E5, E6, E7, E8, E9, E10, E11, E12, Menu


E1:
PRINT "Enter new name for "; : COLOR 14: PRINT n$(m): COLOR 7: PRINT
PRINT "New name:"; : LINE INPUT ""; a$: PRINT
IF a$ = "" THEN GOTO E1
GOSUB Check: pk = 0
FOR r = 1 TO numchars
   IF r <> m AND LCASE$(n$(r)) = LCASE$(a$) THEN pk = 1
NEXT
IF pk = 1 THEN
  PRINT : PRINT "That name is already being used.": GOSUB Lp6: GOTO Edit
END IF
n$(m) = a$: GOTO Edit

E2:
PRINT "Old Hardiness:"; hd(m): PRINT
LINE INPUT "New Hardiness: "; a$: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > 300 THEN
  PRINT "Invalid!  Hardiness is 1-300.": PRINT : GOTO E2
END IF
hd(m) = a: GOTO Edit

E3:
PRINT "Old Agility:"; AG(m): PRINT
LINE INPUT "New Agility: "; a$: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > 300 THEN
  PRINT "Invalid!  Agility is 1-300.": PRINT : GOTO E3
END IF
AG(m) = a: GOTO Edit

E4:
PRINT "Old Charisma:"; ch(m): PRINT
LINE INPUT "New Charisma: "; a$: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > 200 THEN
  PRINT "Invalid!  Charisma is 1-200.": PRINT : GOTO E4
END IF
ch(m) = a: GOTO Edit

'--------------------------------
E5:
CLS
PRINT "  Select Spell:": PRINT
PRINT " 1. Blast:"; RTRIM$(STR$(sp%(m, 1))); "%"
PRINT " 2. Heal :"; RTRIM$(STR$(sp%(m, 2))); "%"
PRINT " 3. Speed:"; RTRIM$(STR$(sp%(m, 3))); "%"
PRINT " 4. Power:"; RTRIM$(STR$(sp%(m, 4))); "%"
PRINT LEFT$(ln$, 19)
PRINT " 5. Return to menu"
x = 5: GOSUB GetNo: CLS
IF k = 5 THEN GOTO Edit

Spell:
PRINT "Old "; s$(k); " rating:"; sp%(m, k): PRINT
LINE INPUT "Enter new rating:"; a$: a = INT(VAL(a$)): PRINT
IF a < 0 OR a > 500 THEN
  PRINT "Invalid!  Max spell ability is 500%": PRINT : GOTO Spell
END IF
sp%(m, k) = a: GOTO E5

'-------------------------------
E6:
CLS
PRINT "  Select Weapon Ability:": PRINT
PRINT " 1. Axe  :"; RTRIM$(STR$(WA%(m, 1))); "%"
PRINT " 2. Bow  :"; RTRIM$(STR$(WA%(m, 2))); "%"
PRINT " 3. Club :"; RTRIM$(STR$(WA%(m, 3))); "%"
PRINT " 4. Spear:"; RTRIM$(STR$(WA%(m, 4))); "%"
PRINT " 5. Sword:"; RTRIM$(STR$(WA%(m, 5))); "%"
PRINT LEFT$(ln$, 20)
PRINT " 6. Return to menu"
x = 6: GOSUB GetNo: CLS
IF k = 6 THEN GOTO Edit

Weapon:
PRINT "Old "; wp$(k); " Expertise:"; WA%(m, k): PRINT
LINE INPUT "Enter new rating:"; a$: a = INT(VAL(a$)): PRINT
IF a < -50 OR a > 200 THEN
  PRINT "Invalid!  Max weapon ability is -50 to 200": PRINT : GOTO Weapon
END IF
WA%(m, k) = a: GOTO E6
'-------------------------------
E7:
PRINT "  Enter Armor Class": PRINT
PRINT " 1. Shield only"
PRINT " 2. Leather Armor"
PRINT " 3. Leather Armor & Shield"
PRINT " 4. Chain Mail"
PRINT " 5. Chain Mail & Shield"
PRINT " 6. Plate Armor"
PRINT " 7. Plate Armor & Shield": PRINT
PRINT "Currently:"; AC(m);
IF AC(m) = 0 THEN PRINT "(Clothes)";
IF AC(m) > 7 THEN
  PRINT "(Magic";
  IF AC(m) / 2 <> INT(AC(m) / 2) THEN PRINT " & Shield";
  PRINT ")";
END IF
PRINT : PRINT : LINE INPUT "New value? "; a$: k = INT(VAL(a$))
IF k < 0 OR k > 15 THEN
  PRINT : PRINT "Invalid!  Highest armor rating is 15.": PRINT : GOTO E7
END IF
AC(m) = k: GOTO Edit

'--------------------------
E8:
IF sex(m) < 0 OR sex(m) > 1 THEN sex(m) = 0
PRINT "  Enter new sex": PRINT
PRINT " 1. Male"
PRINT " 2. Female": PRINT
PRINT "Currently: "; sex$(sex(m)): PRINT
x = 2: GOSUB GetNo
sex(m) = k - 1: GOTO Edit

'---------------------------
E9:
CLS
PRINT "  Select what to change:": PRINT
PRINT " 1. Gold in hand", Gold(m)
PRINT " 2. Gold in bank", bank(m)
PRINT LEFT$(ln$, 26)
PRINT " 3. Return to menu"
x = 3: GOSUB GetNo: IF k = 3 THEN GOTO Edit
ON k GOSUB GoldHand, GoldBank
GOTO E9

GoldHand:
s$ = "hand": GOSUB Gold: Gold(m) = a: RETURN

GoldBank:
s$ = "bank": GOSUB Gold: bank(m) = a: RETURN

Gold:
PRINT "New amount in "; s$; : LINE INPUT "?:"; a$: a = INT(VAL(a$))
IF a < 0 OR a > 50000 THEN
  PRINT "Isn't that a bit odd?  Try an amount between 1-50,000."
  PRINT : GOTO Gold
END IF
RETURN

'-----------------------------
E10:
PRINT "Armor Expertise:"; RTRIM$(STR$(AE(m))); "%": PRINT
LINE INPUT "New rating: "; a$: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > 65 THEN
  PRINT "Invalid!  Armor Expertise is 1-65.": PRINT : GOTO E10
END IF
AE(m) = a: GOTO Edit
'--------------------------------
E11:
CLS : PRINT "Select weapon to change:": PRINT
PRINT "Weapon Names:                Odds:            Damage:      Weapon Type:"
PRINT LEFT$(ln$, 71)
FOR W = 1 TO 4
   IF wn$(m, W) = "" THEN wn$(m, W) = "NONE"
   IF wt%(m, W) < 0 OR wt%(m, W) > 5 THEN wt%(m, W) = 5
   a$ = LTRIM$(RTRIM$(STR$(W))) + ". " + LEFT$(wn$(m, W), 27)
   PRINT a$; SPC(31 - LEN(a$));
   a$ = LTRIM$(RTRIM$(STR$(wo%(m, W)))) + "%"
   PRINT a$; SPC(18 - LEN(a$));
   a$ = LTRIM$(RTRIM$(STR$(wd%(m, W)))) + "D" + LTRIM$(RTRIM$(STR$(ws%(m, W))))
   PRINT a$; SPC(14 - LEN(a$)); wp$(wt%(m, W))
NEXT
PRINT LEFT$(ln$, 71)
PRINT "5. Return to menu"
x = 5: GOSUB GetNo: W = k: IF k = 5 THEN GOTO Edit

Wep:
CLS
PRINT "  Select field to change:": PRINT
PRINT " 1. Name...................."; wn$(m, W)
PRINT " 2. Odds...................."; LTRIM$(RTRIM$(STR$(wo%(m, W)))); "%"
PRINT " 3. Type...................."; wp$(wt%(m, W))
PRINT " 4. Dice & Sides............";
PRINT LTRIM$(RTRIM$(STR$(wd%(m, W)))); "D"; LTRIM$(STR$(ws%(m, W)))
PRINT "---------------------------------"
PRINT " 5. Return to menu"
x = 5: GOSUB GetNo: PRINT
ON k GOTO Wep1, Wep2, Wep3, Wep4, E11

Wep1:
LINE INPUT "Enter new name:"; a$: GOSUB Check
wn$(m, W) = LEFT$(a$, 20): GOTO Wep

Wep2:
LINE INPUT "Enter new odds:"; a$: a = INT(VAL(a$)): PRINT
IF a < -100 OR a > 200 THEN
  PRINT "Invalid!  Odds range from -100 to 200.": PRINT : GOTO Wep2
END IF
wo%(m, W) = a: GOTO Wep

Wep3:
PRINT "Enter new type:": PRINT
PRINT " 1. Axe        4. Spear"
PRINT " 2. Bow        5. Sword"
PRINT " 3. Club"
PRINT LEFT$(ln$, 24)
x = 5: GOSUB GetNo: wt%(m, W) = k: GOTO Wep

Wep4:
PRINT "(Minimum 1D1, Max 50D50)": PRINT
LINE INPUT "Enter # of dice:"; a$: a = INT(VAL(a$)): PRINT
IF a > 50 THEN a = 50
IF a < 1 THEN a = 1
wd%(m, W) = a
LINE INPUT "Enter # of sides to dice:"; a$: a = INT(VAL(a$)): PRINT
IF a > 50 THEN a = 50
IF a < 1 THEN a = 1
ws%(m, W) = a: GOTO Wep

'-----------------------
E12:
GOSUB ViewChar: GOTO Edit
'
' View player data
'
ViewChar:
FOR a = 1 TO 4
   sp$(a) = LTRIM$(STR$(sp%(m, a))) + "%"
   IF sp%(m, a) < 1 THEN sp$(a) = "None"
NEXT
a = INT(AC(m) / 2): sh = ABS((a < AC(m) / 2))
a = ABS((a < 5)) * a + ABS((a > 4)) * 4
ar$ = ar$(a): IF sh > 0 THEN ar$ = ar$ + " & Shield"

CLS
PRINT "Name: "; n$(m); : LOCATE CSRLIN, 44: PRINT "Sex: "; sex$(sex(m));
LOCATE CSRLIN, 57: PRINT "Status: "; stat$(stat(m)): PRINT
PRINT "Hardiness: "; hd(m): LOCATE 3, 20: PRINT "Agility: "; AG(m)
LOCATE 3, 37: PRINT "Charisma: "; ch(m); "   (Charm Mon:";
a = (ch(m) - 10) * 2
a$ = LTRIM$(STR$(a)) + "%)"
PRINT MID$("+", ABS((a < 1)) * 1 + 1, 1); a$: PRINT

PRINT "Weapon Abilities:"; : LOCATE 5, 41: PRINT "Spell Abilities:"
PRINT "1. Axe:  "; WA%(m, 1); : LOCATE 6, 42: PRINT "Blast..."; sp$(1)
PRINT "2. Bow:  "; WA%(m, 2); : LOCATE 7, 42: PRINT "Heal...."; sp$(2)
PRINT "3. Mace: "; WA%(m, 3); : LOCATE 8, 42: PRINT "Speed..."; sp$(3)
PRINT "4. Spear:"; WA%(m, 4); : LOCATE 9, 42: PRINT "Power..."; sp$(4)
PRINT "5. Sword:"; WA%(m, 5); : LOCATE 10, 24: PRINT "Gold:"; Gold(m)
LOCATE 10, 56: PRINT "In bank:"; bank(m): PRINT

a$ = RTRIM$(STR$(AE(m))) + "%"
PRINT "Armour:  "; ar$: LOCATE 12, 34: PRINT "Armour Expertise: "; a$
PRINT :  a = hd(m) * 10: a$ = LTRIM$(RTRIM$(STR$(a)))
PRINT "Weight Carryable: "; a$; " Gronds  (";
a$ = LTRIM$(RTRIM$(STR$(a * 10)))
PRINT a$; " Dos)": PRINT

PRINT "Weapon Names:             Complexity:         Damage:     Weapon Type:"
PRINT LEFT$(ln$, 75)
FOR W = 1 TO 4
   IF wn$(m, W) = "" THEN wn$(m, W) = "NONE"
   IF wn$(m, W) = "NONE" THEN GOTO WLoop
   IF LEN(wn$(m, W)) > 20 THEN wn$(m, W) = LEFT$(wn$(m, W), 20)
   PRINT wn$(m, W); SPC(31 - LEN(wn$(m, W)));
   a$ = LTRIM$(RTRIM$(STR$(wo%(m, W)))) + "%"
   PRINT a$; SPC(18 - LEN(a$));
   a$ = LTRIM$(RTRIM$(STR$(wd%(m, W)))) + "D" + LTRIM$(RTRIM$(STR$(ws%(m, W))))
   PRINT a$; SPC(12 - LEN(a$));
   'EA = 0: IF AE(m) < AC(m) * AC(m) THEN EA = AE(m) - AC(m) * AC(m)
   'a = INT(50 + (AG(m) - AC(m)) * 2 + WA%(m, WT%(m, W)) / 4 + EA + wo%(m, W) / 2)
   'PRINT LTRIM$(RTRIM$(STR$(a))); "%"
   PRINT wp$(wt%(m, W))
WLoop:
NEXT: GOTO Lp6

'-----------------------------------
' File utilities
'
File:
CLS
PRINT "  Select action:": PRINT
PRINT " 1. List file (display characters)"
PRINT " 2. Short list (Display names only)"
PRINT " 3. List/delete characters"
PRINT " 4. Initialize file"
PRINT " 5. Return to main menu"
x = 5: GOSUB GetNo: CLS
ON k GOTO FileList, ShortList, Delete, InitFile, Menu

'--------------------------
' Display all characters
'
FileList:
mm = m
FOR m = 1 TO numchars: GOSUB ViewChar: NEXT
m = mm: GOTO File

'--------------------------
' Display all names
'
ShortList:
FOR r = 1 TO numchars STEP 2
   PRINT r; ": "; n$(r);
   IF r + 1 <= numchars THEN LOCATE CSRLIN, 40: PRINT r + 1; ": "; n$(r + 1);
   PRINT : L = L + 1: IF L = 18 THEN GOSUB Lp6
NEXT
GOSUB Lp6: GOTO File

'--------------------------
' File utilities
'
Delete:
pk = 0: m = 0: CLS
FOR r = 1 TO numchars
   PRINT r; ": "; n$(r)
   PRINT "Delete (Y/N):"; : GOSUB GetKey
   IF k$ = "Y" THEN GOSUB Delete2
   IF pk = 1 THEN r = 9999
NEXT
IF numchars < 1 THEN GOTO Create
IF pk = 1 THEN GOTO Delete
GOTO File

Delete2:
IF stat(r) = 3 THEN
  PRINT "Can't delete, character is on an adventure right now.": GOTO Lp6
END IF
a = numchars
IF r < a THEN
  n$(r) = n$(a): hd(r) = hd(a): AG(r) = AG(a): ch(r) = ch(a)
  AE(r) = AE(a): sex(r) = sex(a): stat(r) = stat(a): Gold(r) = Gold(a)
  bank(r) = bank(a): AC(r) = AC(a): WA%(r, 5) = WA%(a, 5)
  FOR k = 1 TO 4
     sp%(r, k) = sp%(a, k): WA%(r, k) = WA%(a, k): wn$(r, k) = wn$(a, k)
     wo%(r, k) = wo%(a, k): wt%(r, k) = wt%(a, k): wd%(r, k) = wd%(a, k)
     ws%(r, k) = ws%(a, k)
  NEXT
END IF
numchars = numchars - 1: pk = 1
RETURN

'-----------------------------
' Wipe out file, start over
'
InitFile:
pk = 0
FOR r = 1 TO numchars
   IF stat(r) = 3 THEN pk = 1
NEXT
IF pk = 1 THEN
  PRINT "You can't do this at this time -- Character(s) on adventure."
  GOSUB Lp6: GOTO File
END IF
PRINT : PRINT : COLOR 14: PRINT "     !!!!!  WARNING !!!!!": COLOR 7: PRINT
PRINT "You are about to delete every character in your file!": PRINT
PRINT "Are you sure you want to do this? (Y/N):"; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO File
PRINT "Are you really, really sure? (Y/N):"; : GOSUB GetKey
IF k$ <> "Y" THEN GOTO File
numchars = 0
CLOSE
KILL "PLAYERS.DAT"
KILL "NUMPLRS.DAT"
OPEN "NUMPLRS.DAT" FOR OUTPUT AS #1:  PRINT #1, numchars
CLOSE
OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
PRINT : PRINT "Your roster is empty.  You must now create a new character."
GOSUB Lp6: GOTO Create

'----------------------------
' Generate a new character
'
Create:
CLS : numchars = numchars + 1: m = numchars
Create0:
PRINT "Enter a character name:"; : LINE INPUT ""; a$: PRINT
IF a$ = "" THEN GOTO Create0
'
GOSUB Check: n$(m) = a$: k = 0
FOR a = 1 TO numchars - 1
   IF LCASE$(n$(a)) = LCASE$(n$(m)) THEN k = 1
NEXT
IF k = 1 THEN
  PRINT "You already have a character with that name. ";
  GOSUB GetKey: GOTO Create0
END IF
PRINT "  Enter sex": PRINT
PRINT " 1. Male"
PRINT " 2. Female"
x = 2: GOSUB GetNo: sex(m) = k - 1

Create1:
CLS : PRINT "Creating:"; n$(m): PRINT
GOSUB Roll: hd(m) = a: GOSUB Roll: AG(m) = a: GOSUB Roll: ch(m) = a
PRINT "Hardiness:"; hd(m): PRINT "Agility  :"; AG(m)
PRINT "Charisma :"; ch(m): PRINT
PRINT " Roll Stats again? (Y/N):"; : GOSUB GetKey
IF k$ = "Y" THEN GOTO Create1
FOR r = 1 TO 4
   sp%(m, r) = 0: wn$(m, r) = "NONE": wo%(m, r) = 0: wt%(m, r) = 0
   wd%(m, r) = 0: ws%(m, r) = 0
NEXT
WA%(m, 1) = 5: WA%(m, 2) = -10: WA%(m, 3) = 20: WA%(m, 4) = 10: WA%(m, 5) = 0
AE(m) = 0: stat(m) = 1: Gold(m) = 200: bank(m) = 0: AC(m) = 0
GOTO Menu

'---------------------------
' Exit Character Edit
'
Quit:
FOR r = 1 TO numchars
   c.CNAME = n$(r): c.STATUS = stat(r): c.A1 = hd(r): c.A2 = AG(r)
   c.A3 = ch(r): c.AE = AE(r):   c.sex = sex(r)
   c.SP1 = sp%(r, 1): c.SP2 = sp%(r, 2): c.SP3 = sp%(r, 3): c.SP4 = sp%(r, 4)
   c.WA1 = WA%(r, 1): c.WA2 = WA%(r, 2): c.WA3 = WA%(r, 3)
   c.WA4 = WA%(r, 4): c.WA5 = WA%(r, 5)
   c.Gold = Gold(r): c.bank = bank(r): c.AC = AC(r)
   c.WN1 = wn$(r, 1): c.WN2 = wn$(r, 2): c.WN3 = wn$(r, 3): c.WN4 = wn$(r, 4)
   c.WCOMPLX1 = wo%(r, 1): c.WCOMPLX2 = wo%(r, 2): c.WCOMPLX3 = wo%(r, 3)
   c.WCOMPLX4 = wo%(r, 4): c.WTYPE1 = wt%(r, 1): c.WTYPE2 = wt%(r, 2)
   c.WTYPE3 = wt%(r, 3): c.WTYPE4 = wt%(r, 4): c.WDICE1 = wd%(r, 1)
   c.WDICE2 = wd%(r, 2): c.WDICE3 = wd%(r, 3): c.WDICE4 = wd%(r, 4)
   c.WSIDES1 = ws%(r, 1): c.WSIDES2 = ws%(r, 2): c.WSIDES3 = ws%(r, 3)
   c.WSIDES4 = ws%(r, 4)
   PUT #1, r, c
NEXT
OPEN "NUMPLRS.DAT" FOR OUTPUT AS #2: WRITE #2, numchars, 1: CLOSE
CHDIR "..": RUN "EAMONDX"

'----------------------------------------------------------------------------
' Subroutines
'
Lp6:
PRINT : PRINT "(Hit any key to continue)";
DO
LOOP UNTIL INKEY$ <> ""
PRINT : CLS : L = 0: RETURN
'
' Get a keypress from 1 to x
'
GetNo:
PRINT : PRINT "   Enter 1-"; LTRIM$(STR$(x)); ": ";
' VI Mode routines added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    a = RND: k = VAL(INKEY$)
  LOOP UNTIL k > 0 AND k < x + 1
  PRINT LTRIM$(STR$(k)): RETURN
END IF
' Standard rtn
BS = POS(0)
DO
   a = RND: CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k = VAL(INKEY$)
LOOP UNTIL k > 0 AND k < x + 1
PRINT LTRIM$(STR$(k)): RETURN
'
' Get a keypress
'
GetKey:
' VI Mode
IF s%(4) = 1 THEN
  DO
    a = RND: k$ = INKEY$
  LOOP UNTIL k$ <> ""
  k$ = UCASE$(k$): PRINT k$: RETURN
END IF
' Standard
BS = POS(0)
DO
   a = RND ' Randomize RND seed
   CC# = CC# + 1 ' CC# = Cursor Counter
   IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, BS
   IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, BS
   IF CC# = CC3# THEN PRINT "\": LOCATE CSRLIN - 1, BS: CC# = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""
k$ = UCASE$(k$): PRINT k$: RETURN
'
' Remove commas, colins, and quotes from a$
'
Check:
a$ = LTRIM$(RTRIM$(LEFT$(a$, 40)))
IF LEN(a$) < 1 THEN GOTO E1
FOR a = 1 TO LEN(a$)
 k = ASC(MID$(a$, a, 1))
 IF k = 44 OR k = 58 OR k = 34 THEN
   a$ = LEFT$(a$, a - 1) + MID$(a$, a + 1)
   GOTO Check
 END IF
NEXT: RETURN
'
' Roll 3D8
'
Roll:
a = 0
FOR r = 1 TO 3: a = a + INT(RND * 8) + 1: NEXT
IF a < 10 THEN a = 10
RETURN

SearchError:
ProgErr = ERR: RESUME NEXT


'---------------------------------
' Initialize data
'
Init:
OPEN "PLAYERS.DAT" FOR RANDOM AS #1 LEN = 200
FOR r = 1 TO numchars
   GET #1, r, c
   n$(r) = RTRIM$(c.CNAME): stat(r) = c.STATUS: hd(r) = c.A1: AG(r) = c.A2
   ch(r) = c.A3: sp%(r, 1) = c.SP1: sp%(r, 2) = c.SP2: sp%(r, 3) = c.SP3
   sp%(r, 4) = c.SP4: WA%(r, 1) = c.WA1: WA%(r, 2) = c.WA2: WA%(r, 3) = c.WA3
   WA%(r, 4) = c.WA4: WA%(r, 5) = c.WA5: AE(r) = c.AE: sex(r) = c.sex
   Gold(r) = c.Gold: bank(r) = c.bank: AC(r) = c.AC: wn$(r, 1) = RTRIM$(c.WN1)
   wn$(r, 2) = RTRIM$(c.WN2): wn$(r, 3) = RTRIM$(c.WN3)
   wn$(r, 4) = RTRIM$(c.WN4): wo%(r, 1) = c.WCOMPLX1: wo%(r, 2) = c.WCOMPLX2
   wo%(r, 3) = c.WCOMPLX3: wo%(r, 4) = c.WCOMPLX4: wt%(r, 1) = c.WTYPE1
   wt%(r, 2) = c.WTYPE2: wt%(r, 3) = c.WTYPE3: wt%(r, 4) = c.WTYPE4
   wd%(r, 1) = c.WDICE1: wd%(r, 2) = c.WDICE2: wd%(r, 3) = c.WDICE3
   wd%(r, 4) = c.WDICE4: ws%(r, 1) = c.WSIDES1: ws%(r, 2) = c.WSIDES2
   ws%(r, 3) = c.WSIDES3: ws%(r, 4) = c.WSIDES4
NEXT
sex$(0) = "Male": sex$(1) = "Female"
FOR x = 1 TO 5: READ wp$(x): NEXT
FOR x = 0 TO 4: READ ar$(x): NEXT
FOR x = 1 TO 4: READ s$(x): NEXT
FOR x = 1 TO 79: ln$ = ln$ + "-": NEXT
RETURN
DATA Axe,Bow,Club,Spear,Sword
DATA Clothes,Leather,Chain Mail,Plate Mail,Magic/Exotic
DATA blast,heal,speed,power

