' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
'                                                                
' LOWER CASE TEXT FILE SHIFTER                                   
'                                                                
'                                           Update: 13 OCT 2000  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
'
' This program will shift all letters in a plain text file
'  into lower case.  It was designed for converting Apple II caps-only
'  Eamon databases to Eamon Deluxe
'

'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

TYPE ADV
   ANAME AS STRING * 78
   NUMBER AS INTEGER
END TYPE
DIM ADV AS ADV

'---------------------------------------------------------------------------
' Load design names
'
CHDIR "..": CHDIR "DD"
OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE
IF d1 = 1 THEN
  CHDIR "..": CHDIR "DGN-1"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d1$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
IF d2 = 1 THEN
  CHDIR "..": CHDIR "DGN-2"
  OPEN "NAME.DAT" FOR INPUT AS #1
  INPUT #1, a, a, a, a, d2$
  CLOSE
  CHDIR "..": CHDIR "DD"
END IF
'---------------------------------------------------------------------------
' Load adventure names
'
CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
GET #2, 1, ADV
numadv = ADV.NUMBER: numadv1 = numadv
DIM an$(numadv + 2), anum(numadv + 2)

FOR a = 2 TO numadv + 1
   GET #2, a, ADV
   an$(a - 1) = LTRIM$(RTRIM$(ADV.ANAME$))
NEXT
CLOSE : CHDIR "DD"
IF d1 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d1$ + "  (Design 1)"
END IF
IF d2 = 1 THEN
  numadv = numadv + 1: an$(numadv) = d2$ + "  (Design 2)"
END IF
'---------------------------------------------------------------------------
' Change to proper directory
'
Start:
CLS : L = 0
PRINT "Select adventure with TXT file to shift."
FOR a = 1 TO numadv
   a$ = LTRIM$(RTRIM$(STR$(a))) + ": " + an$(a)
   PRINT a$
   L = L + 1
   IF L = 20 THEN
      PRINT "Hit any key to continue...";
      DO
      LOOP UNTIL INKEY$ <> ""
      L = 0
   END IF
NEXT
PRINT
LINE INPUT "Enter the number of your choice:"; a$
a = INT(VAL(a$))
IF a < 1 OR a > numadv THEN GOTO Start
a$ = LTRIM$(RTRIM$(STR$(a)))
ad$ = LEFT$("E000", 4 - LEN(a$)) + a$
IF a = numadv1 + 1 THEN ad$ = "DGN-1"
IF a = numadv1 + 2 OR (a = numadv1 + 1 AND d1 = 0) THEN ad$ = "DGN-2"
CHDIR "..": CHDIR ad$

CLS
INPUT "File name"; f$: f$ = UCASE$(f$)
IF INSTR(f$, ".") = 0 THEN f$ = f$ + ".TXT"
INPUT "New name"; f2$: f2$ = UCASE$(f2$)
IF INSTR(f2$, ".") = 0 THEN f2$ = f2$ + ".TXT"
CLS : PRINT "Reading text from "; f$; " / writing shifted text to "; f2$; "...";
OPEN f$ FOR INPUT AS #1
OPEN f2$ FOR OUTPUT AS #2

ON ERROR GOTO FileDone
Rtn:
LINE INPUT #1, a$
a$ = LCASE$(a$)
PRINT #2, a$
GOTO Rtn

FileDone:
IF ERR <> 62 THEN BEEP: PRINT "Error #"; ERR: END
CLOSE : PRINT "Done!"
RESUME FileDone1

FileDone1:
ON ERROR GOTO 0
PRINT : PRINT "[Hit any key to continue...]": k$ = INKEY$
DO
LOOP UNTIL INKEY$ <> ""
CHDIR "..": CHDIR "UTILS"
RUN "UMENU"
END

