' THE MARVELOUS WORLD OF EAMON DELUXE v5.0 ͻ
'                  by Frank Black Productions                    
'                                                                
'      Originally based upon the classic Eamon                   
'              computerized fantasy role-playing system          
'                                                                
' EAMON DELUXE 5.0 UTILITIES MENU          Revision: 08 JAN 2013 
'                                            Update: 08 JAN 2013 
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

'
' Copyright (C) 2013 Frank Black Productions
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'

DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
CHDIR "..\UTILS"
ON ERROR GOTO ErrHandler


DIM SHARED dly#, CC1#, CC2#, CC3#, s%(10), BORT
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1
    INPUT #1, dly#, CC1#, CC2#, CC3#: FOR x = 1 TO 10: INPUT #1, s%(x): NEXT
CLOSE

DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT: em$(0) = CHR$(13) + CHR$(32) + CHR$(27)
mc1 = 1: mc2 = 2: mc3 = 7

'                  General Utilites 5.0 Main Menu
'                 --------------------------------
Menu:
SCREEN 0: WIDTH 80: CLS : COLOR mc1, 0: PRINT " "; STRING$(65, ""); ""
PRINT " "; SPACE$(15); : COLOR mc2: PRINT "THE MARVELOUS WORLD OF EAMON DELUXE ";
COLOR mc1: PRINT SPACE$(14); "": PRINT " "; SPACE$(18); : COLOR mc2
PRINT " Developer Utilities Menu 5.0"; : COLOR mc1: PRINT SPACE$(18); "": PRINT " ";
PRINT STRING$(65, ""); "": PRINT : PRINT

c = 0: c1 = 3: a$ = INKEY$: COLOR 7
CALL EDXMenuM(c, c1, 1, 10, mc3, 0)
IF c1 = 3 THEN CHDIR "..": RUN "EAMONDX"
IF BORT = 5 THEN BORT = 1: GOTO Menu

IF c = 1 THEN RUN "RESET"
IF c = 2 THEN RUN "SHIFT"
IF c = 3 THEN RUN "TXTMV"
IF c = 4 THEN RUN "MAKE-EDX"
IF c = 5 THEN RUN "MAKE-SRC"
IF c = 6 THEN RUN "HINTMAKE"
IF c = 7 THEN RUN "MAKESHPS"
IF c = 8 THEN RUN "EDX2-MKS"
IF c = 9 THEN RUN "TOOLS"
IF c = 10 THEN RUN "GRINDER"

' Get a single keypress, returns with UCASE
GetKey0:
PRINT "Hit any key to continue...";
GetKey:
' VI Mode support added 27 JAN 2012
IF s%(4) = 1 THEN
  DO
    k$ = UCASE$(INKEY$)
  LOOP UNTIL k$ <> ""
  PRINT k$: RETURN
END IF
' Standard rtn
BS = POS(0): CC = 0
DO
    CC = CC + 1
   IF CC = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC = 0
   k$ = UCASE$(INKEY$)
LOOP UNTIL k$ <> ""
PRINT k$: RETURN

'        ------------
'         Error trap
'        ------------
ErrHandler:
COLOR 15: PRINT : PRINT SPACE$(15);
PRINT "UH-OH, A PROGRAM ERROR JUST POPPED UP! (CODE"; : PRINT STR$(ERR); ")": PRINT
zk$ = "try and continue": IF ERR > 51 THEN zk$ = "exit Eamon Deluxe"
PRINT SPACE$(20); "Hit any key to "; zk$; "...": zk$ = INKEY$
DO
  zk$ = INKEY$
LOOP UNTIL k$ <> ""
PRINT : IF ERR > 51 THEN CHDIR "..": RUN "EAMONDX"
PRINT "ATTEMPTING TO CONTINUE...": PRINT : l = 0: COLOR 7: RESUME NEXT

EDXMenuStrings:
DATA 11
DATA " Reset Eamon Deluxe System Default Settings                    "
DATA " Convert a File to All Lower Case Text                         "
DATA " Move All Text From an Eamon Deluxe Adventure To/From TXT File "
DATA " Import Adventure Source Code File to Eamon Deluxe Database    "
DATA " Export Eamon Deluxe Database to Adventure Source Code File    "
DATA " Add Hints to an Adventure From a Text File                    "
DATA " View/Store Graphic Main Hall Tile Sets                        "
DATA " View/Store Lost Island of Apple Shapes                        "
DATA " Create/Separate/Rename a Multi-Adventure                      "
DATA " Convert Vanilla Eamon Data Extraction to EDX Source Code File "
DATA "[extra]  Backup/Restore Characters File                       "

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
'// Compact Eamon Deluxe Selection Menu 5.0           Revision 2: 20 JUN 2012
'     User locatable, two colors, single choice row with no error checking
'
'  Passed to SUB:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'  Modified by SUB:
'   ad/v/x/k/k$ - used as generic
'  Returned by SUB:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'  Required SHARED:
'   em0 - The maximum dimension of the em$() array
'em$(x) - em$(0) holds exit keys, em$(1-x) hold user defined choices
' s%(4) - If set to =1 then use numeric menu, use else standard menu

' VI Mode ------
EDXMenuMMXII:
IF s%(4) = 1 THEN
  FOR c = be TO en
     k = k * ABS(c > 1): k$ = SPACE$(ABS((c < 100) + (c < 10)))
     k$ = k$ + LTRIM$(STR$(c - be + 1)) + ": " + LTRIM$(RTRIM$(em$(c)))
     PRINT k$: k = k + 1
     IF k >= 22 AND c < en THEN
       PRINT : PRINT "Hit any key to continue...": k$ = INKEY$
          DO
            k$ = INKEY$
          LOOP UNTIL k$ <> ""
       CLS : k = 0
     END IF
  NEXT
  PRINT : PRINT "Enter choice number (0 to exit):"; : LINE INPUT ""; k$:                                 k$ = k$ + " "
  c = INT(VAL(k$)): k = ASC(k$): GOSUB EDXMenuMB
  c1 = c + (be - 1): IF c = 0 AND INSTR(k$, "0") > 0 THEN c1 = 3: EXIT SUB
  IF c1 < be OR c1 > en THEN CLS : GOTO EDXMenuMMXII
  en = c1: c1 = 1: EXIT SUB
END IF

' EDXMenuM ------
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, 0
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT
EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1: LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, 0: PRINT em$(c);
IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF
GOSUB EDXMenuMB: IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
'
' Make sure input is a valid ANSI code, else recode in ASCII (=SPOT)
EDXMenuMB:
IF k = 98 AND BORT = 0 THEN BORT = 2: SOUND 250, .5:
IF k = 111 AND BORT = 2 THEN BORT = 3: SOUND 350, .5:
IF k = 114 AND BORT = 3 THEN BORT = 4: SOUND 450, .5:
IF k <> 116 OR BORT <> 4 THEN RETURN:  ELSE BORT = 5: SOUND 550, .5:                                         EXIT SUB                                                                                                      'B O R T = S P O T
END SUB

